#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 1295
#define SYMBOL_COUNT 224
#define ALIAS_COUNT 3
#define TOKEN_COUNT 106
#define EXTERNAL_TOKEN_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 3

enum {
  anon_sym_tensor = 1,
  anon_sym_format = 2,
  anon_sym_LPAREN = 3,
  anon_sym_LBRACE = 4,
  anon_sym_RBRACE = 5,
  anon_sym_RPAREN = 6,
  anon_sym_SEMI = 7,
  anon_sym_COMMA = 8,
  anon_sym_indexvars = 9,
  anon_sym_dense = 10,
  anon_sym_sparse = 11,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH = 12,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH = 13,
  anon_sym_LF = 14,
  anon_sym_LPAREN2 = 15,
  anon_sym_DOT_DOT_DOT = 16,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH = 17,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH = 18,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH = 19,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH = 20,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH = 21,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH = 22,
  sym_preproc_directive = 23,
  sym_preproc_arg = 24,
  anon_sym_typedef = 25,
  anon_sym_extern = 26,
  anon_sym_STAR = 27,
  anon_sym_LBRACK = 28,
  anon_sym_RBRACK = 29,
  anon_sym_EQ = 30,
  anon_sym_static = 31,
  anon_sym_auto = 32,
  anon_sym_register = 33,
  anon_sym_inline = 34,
  anon_sym_const = 35,
  anon_sym_restrict = 36,
  anon_sym_volatile = 37,
  anon_sym__Atomic = 38,
  anon_sym_unsigned = 39,
  anon_sym_long = 40,
  anon_sym_short = 41,
  sym_primitive_type = 42,
  anon_sym_enum = 43,
  anon_sym_struct = 44,
  anon_sym_union = 45,
  anon_sym_COLON = 46,
  anon_sym_if = 47,
  anon_sym_else = 48,
  anon_sym_switch = 49,
  anon_sym_case = 50,
  anon_sym_default = 51,
  anon_sym_while = 52,
  anon_sym_do = 53,
  anon_sym_for = 54,
  anon_sym_return = 55,
  anon_sym_break = 56,
  anon_sym_continue = 57,
  anon_sym_goto = 58,
  anon_sym_QMARK = 59,
  anon_sym_STAR_EQ = 60,
  anon_sym_SLASH_EQ = 61,
  anon_sym_PERCENT_EQ = 62,
  anon_sym_PLUS_EQ = 63,
  anon_sym_DASH_EQ = 64,
  anon_sym_LT_LT_EQ = 65,
  anon_sym_GT_GT_EQ = 66,
  anon_sym_AMP_EQ = 67,
  anon_sym_CARET_EQ = 68,
  anon_sym_PIPE_EQ = 69,
  anon_sym_AMP = 70,
  anon_sym_PIPE_PIPE = 71,
  anon_sym_AMP_AMP = 72,
  anon_sym_BANG = 73,
  anon_sym_PIPE = 74,
  anon_sym_CARET = 75,
  anon_sym_TILDE = 76,
  anon_sym_EQ_EQ = 77,
  anon_sym_BANG_EQ = 78,
  anon_sym_LT = 79,
  anon_sym_GT = 80,
  anon_sym_LT_EQ = 81,
  anon_sym_GT_EQ = 82,
  anon_sym_LT_LT = 83,
  anon_sym_GT_GT = 84,
  anon_sym_PLUS = 85,
  anon_sym_DASH = 86,
  anon_sym_SLASH = 87,
  anon_sym_PERCENT = 88,
  anon_sym_DASH_DASH = 89,
  anon_sym_PLUS_PLUS = 90,
  anon_sym_sizeof = 91,
  anon_sym_DOT = 92,
  anon_sym_DASH_GT = 93,
  sym_number_literal = 94,
  anon_sym_SQUOTE = 95,
  aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH = 96,
  anon_sym_DQUOTE = 97,
  aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH = 98,
  sym_escape_sequence = 99,
  sym_system_lib_string = 100,
  sym_true = 101,
  sym_false = 102,
  sym_null = 103,
  sym_identifier = 104,
  sym_comment = 105,
  sym_translation_unit = 106,
  sym_ta_top_level = 107,
  sym_ta_name_list = 108,
  sym_ta_integer_list = 109,
  sym_ta_specifier_list = 110,
  sym_ta_specifier_list_specifier = 111,
  sym_preproc_include = 112,
  sym_preproc_def = 113,
  sym_preproc_function_def = 114,
  sym_preproc_params = 115,
  sym_preproc_call = 116,
  sym_preproc_if = 117,
  sym_preproc_ifdef = 118,
  sym_preproc_else = 119,
  sym_preproc_elif = 120,
  sym_preproc_if_in_compound_statement = 121,
  sym_preproc_ifdef_in_compound_statement = 122,
  sym_preproc_else_in_compound_statement = 123,
  sym_preproc_elif_in_compound_statement = 124,
  sym_preproc_if_in_field_declaration_list = 125,
  sym_preproc_ifdef_in_field_declaration_list = 126,
  sym_preproc_else_in_field_declaration_list = 127,
  sym_preproc_elif_in_field_declaration_list = 128,
  sym_function_definition = 129,
  sym_declaration = 130,
  sym_type_definition = 131,
  sym__declaration_specifiers = 132,
  sym_linkage_specification = 133,
  sym_declaration_list = 134,
  sym__declarator = 135,
  sym__field_declarator = 136,
  sym__type_declarator = 137,
  sym__abstract_declarator = 138,
  sym_pointer_declarator = 139,
  sym_pointer_field_declarator = 140,
  sym_pointer_type_declarator = 141,
  sym_abstract_pointer_declarator = 142,
  sym_function_declarator = 143,
  sym_function_field_declarator = 144,
  sym_function_type_declarator = 145,
  sym_abstract_function_declarator = 146,
  sym_array_declarator = 147,
  sym_array_field_declarator = 148,
  sym_array_type_declarator = 149,
  sym_abstract_array_declarator = 150,
  sym_init_declarator = 151,
  sym_compound_statement = 152,
  sym_storage_class_specifier = 153,
  sym_type_qualifier = 154,
  sym__type_specifier = 155,
  sym_sized_type_specifier = 156,
  sym_enum_specifier = 157,
  sym_enumerator_list = 158,
  sym_struct_specifier = 159,
  sym_union_specifier = 160,
  sym_field_declaration_list = 161,
  sym__field_declaration_list_item = 162,
  sym_field_declaration = 163,
  sym_enumerator = 164,
  sym_parameter_list = 165,
  sym_parameter_declaration = 166,
  sym_labeled_statement = 167,
  sym_expression_statement = 168,
  sym_if_statement = 169,
  sym_switch_statement = 170,
  sym_case_statement = 171,
  sym_while_statement = 172,
  sym_do_statement = 173,
  sym_for_statement = 174,
  sym_return_statement = 175,
  sym_break_statement = 176,
  sym_continue_statement = 177,
  sym_goto_statement = 178,
  sym__expression = 179,
  sym_comma_expression = 180,
  sym_conditional_expression = 181,
  sym_assignment_expression = 182,
  sym_pointer_expression = 183,
  sym_logical_expression = 184,
  sym_bitwise_expression = 185,
  sym_equality_expression = 186,
  sym_relational_expression = 187,
  sym_shift_expression = 188,
  sym_math_expression = 189,
  sym_cast_expression = 190,
  sym_type_descriptor = 191,
  sym_sizeof_expression = 192,
  sym_subscript_expression = 193,
  sym_call_expression = 194,
  sym_argument_list = 195,
  sym_field_expression = 196,
  sym_compound_literal_expression = 197,
  sym_parenthesized_expression = 198,
  sym_initializer_list = 199,
  sym_initializer_pair = 200,
  sym_subscript_designator = 201,
  sym_field_designator = 202,
  sym_char_literal = 203,
  sym_concatenated_string = 204,
  sym_string_literal = 205,
  sym__empty_declaration = 206,
  sym_macro_type_specifier = 207,
  aux_sym_translation_unit_repeat1 = 208,
  aux_sym_preproc_params_repeat1 = 209,
  aux_sym_preproc_if_in_compound_statement_repeat1 = 210,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 211,
  aux_sym_declaration_repeat1 = 212,
  aux_sym_type_definition_repeat1 = 213,
  aux_sym__declaration_specifiers_repeat1 = 214,
  aux_sym_sized_type_specifier_repeat1 = 215,
  aux_sym_enumerator_list_repeat1 = 216,
  aux_sym_field_declaration_repeat1 = 217,
  aux_sym_parameter_list_repeat1 = 218,
  aux_sym_for_statement_repeat1 = 219,
  aux_sym_initializer_list_repeat1 = 220,
  aux_sym_initializer_pair_repeat1 = 221,
  aux_sym_concatenated_string_repeat1 = 222,
  aux_sym_string_literal_repeat1 = 223,
  alias_sym_field_identifier = 224,
  alias_sym_statement_identifier = 225,
  alias_sym_type_identifier = 226,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "END",
  [anon_sym_tensor] = "tensor",
  [anon_sym_format] = "format",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI] = ";",
  [anon_sym_COMMA] = ",",
  [anon_sym_indexvars] = "indexvars",
  [anon_sym_dense] = "dense",
  [anon_sym_sparse] = "sparse",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = "#include",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = "#define",
  [anon_sym_LF] = "\n",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = "#if",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = "#endif",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = "#ifdef",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = "#ifndef",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = "#else",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = "#elif",
  [sym_preproc_directive] = "preproc_directive",
  [sym_preproc_arg] = "preproc_arg",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym_STAR] = "*",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_auto] = "auto",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym_const] = "const",
  [anon_sym_restrict] = "restrict",
  [anon_sym_volatile] = "volatile",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_QMARK] = "?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_BANG] = "!",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_TILDE] = "~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH] = "/[^\\n']/",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = "/[^\\\\\"\\n]/",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_identifier] = "identifier",
  [sym_comment] = "comment",
  [sym_translation_unit] = "translation_unit",
  [sym_ta_top_level] = "ta_top_level",
  [sym_ta_name_list] = "ta_name_list",
  [sym_ta_integer_list] = "ta_integer_list",
  [sym_ta_specifier_list] = "ta_specifier_list",
  [sym_ta_specifier_list_specifier] = "ta_specifier_list_specifier",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_if_in_compound_statement] = "preproc_if",
  [sym_preproc_ifdef_in_compound_statement] = "preproc_ifdef",
  [sym_preproc_else_in_compound_statement] = "preproc_else",
  [sym_preproc_elif_in_compound_statement] = "preproc_elif",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym__expression] = "_expression",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_logical_expression] = "logical_expression",
  [sym_bitwise_expression] = "bitwise_expression",
  [sym_equality_expression] = "equality_expression",
  [sym_relational_expression] = "relational_expression",
  [sym_shift_expression] = "shift_expression",
  [sym_math_expression] = "math_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_in_compound_statement_repeat1] = "preproc_if_in_compound_statement_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_tensor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_format] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_indexvars] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dense] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sparse] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_auto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_ta_top_level] = {
    .visible = true,
    .named = true,
  },
  [sym_ta_name_list] = {
    .visible = true,
    .named = true,
  },
  [sym_ta_integer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_ta_specifier_list] = {
    .visible = true,
    .named = true,
  },
  [sym_ta_specifier_list_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_equality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_shift_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_math_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_compound_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [2] = {
    [1] = alias_sym_type_identifier,
  },
  [3] = {
    [0] = alias_sym_field_identifier,
  },
  [4] = {
    [1] = alias_sym_statement_identifier,
  },
  [5] = {
    [0] = alias_sym_statement_identifier,
  },
  [6] = {
    [2] = alias_sym_field_identifier,
  },
  [7] = {
    [1] = alias_sym_field_identifier,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(44);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(56);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '<')
        ADVANCE(76);
      if (lookahead == '=')
        ADVANCE(80);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(88);
      if (lookahead == ']')
        ADVANCE(103);
      if (lookahead == '^')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '|')
        ADVANCE(107);
      if (lookahead == '}')
        ADVANCE(110);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 5:
      if (lookahead == 'd')
        ADVANCE(6);
      if (lookahead == 'e')
        ADVANCE(13);
      if (lookahead == 'i')
        ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(5);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(7);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(8);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n')
        ADVANCE(10);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l')
        ADVANCE(14);
      if (lookahead == 'n')
        ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(15);
      if (lookahead == 's')
        ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(18);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(24);
      if (lookahead == 'n')
        ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH);
      if (lookahead == 'd')
        ADVANCE(25);
      if (lookahead == 'n')
        ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c')
        ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l')
        ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(41);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(49);
      if (lookahead == '=')
        ADVANCE(50);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(53);
      if (lookahead == '=')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(55);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == '.')
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(60);
      if (lookahead == '/')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(64);
      END_STATE();
    case 60:
      if (lookahead == '*')
        ADVANCE(61);
      if (lookahead != 0)
        ADVANCE(60);
      END_STATE();
    case 61:
      if (lookahead == '*')
        ADVANCE(61);
      if (lookahead == '/')
        ADVANCE(62);
      if (lookahead != 0)
        ADVANCE(60);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.')
        ADVANCE(66);
      if (lookahead == 'L')
        ADVANCE(68);
      if (lookahead == 'U')
        ADVANCE(68);
      if (lookahead == 'b')
        ADVANCE(69);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      if (lookahead == 'x')
        ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(67);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(68);
      if (lookahead == 'U')
        ADVANCE(68);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(68);
      if (lookahead == 'U')
        ADVANCE(68);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      END_STATE();
    case 69:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(68);
      if (lookahead == 'U')
        ADVANCE(68);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(70);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f'))
        ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(72);
      if (lookahead == 'U')
        ADVANCE(72);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f'))
        ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.')
        ADVANCE(66);
      if (lookahead == 'L')
        ADVANCE(68);
      if (lookahead == 'U')
        ADVANCE(68);
      if (lookahead == 'l')
        ADVANCE(68);
      if (lookahead == 'u')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(77);
      if (lookahead == '=')
        ADVANCE(79);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(83);
      if (lookahead == '>')
        ADVANCE(84);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 88:
      if (lookahead == 'U')
        ADVANCE(89);
      if (lookahead == 'u')
        ADVANCE(93);
      if (lookahead == 'x')
        ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(101);
      if (lookahead != 0)
        ADVANCE(97);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(90);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(91);
      END_STATE();
    case 91:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(92);
      END_STATE();
    case 92:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(93);
      END_STATE();
    case 93:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(94);
      END_STATE();
    case 94:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(95);
      END_STATE();
    case 95:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(96);
      END_STATE();
    case 96:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(97);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 98:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(99);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(100);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(102);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(97);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(105);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(108);
      if (lookahead == '|')
        ADVANCE(109);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 112:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(56);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '<')
        ADVANCE(76);
      if (lookahead == '=')
        ADVANCE(80);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == ']')
        ADVANCE(103);
      if (lookahead == '^')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '|')
        ADVANCE(107);
      if (lookahead == '}')
        ADVANCE(110);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 115:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(116);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(115);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 116:
      if (lookahead == 'd')
        ADVANCE(6);
      if (lookahead == 'i')
        ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(116);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 117:
      if (lookahead == '*')
        ADVANCE(60);
      if (lookahead == '/')
        ADVANCE(63);
      END_STATE();
    case 118:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '<')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(118);
      END_STATE();
    case 119:
      if (lookahead == '>')
        ADVANCE(120);
      if (lookahead == '\\')
        ADVANCE(121);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 121:
      if (lookahead == '>')
        ADVANCE(122);
      if (lookahead == '\\')
        ADVANCE(121);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(119);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>')
        ADVANCE(120);
      if (lookahead == '\\')
        ADVANCE(121);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(119);
      END_STATE();
    case 123:
      if (lookahead == '\n')
        SKIP(123);
      if (lookahead == '/')
        ADVANCE(124);
      if (lookahead == '\\')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(131);
      if (lookahead != 0)
        ADVANCE(130);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '/')
        ADVANCE(128);
      if (lookahead == '\\')
        ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(130);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(60);
      if (lookahead == '*')
        ADVANCE(126);
      if (lookahead == '\\')
        ADVANCE(127);
      if (lookahead != 0)
        ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(60);
      if (lookahead == '*')
        ADVANCE(126);
      if (lookahead == '/')
        ADVANCE(62);
      if (lookahead == '\\')
        ADVANCE(127);
      if (lookahead != 0)
        ADVANCE(125);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(125);
      if (lookahead == '*')
        ADVANCE(126);
      if (lookahead == '\\')
        ADVANCE(127);
      if (lookahead != 0)
        ADVANCE(125);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\')
        ADVANCE(128);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(128);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(130);
      if (lookahead == '\\')
        ADVANCE(129);
      if (lookahead != 0)
        ADVANCE(130);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\\')
        ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/')
        ADVANCE(124);
      if (lookahead == '\\')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(131);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(130);
      END_STATE();
    case 132:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '/')
        ADVANCE(124);
      if (lookahead == '\\')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(134);
      if (lookahead != 0)
        ADVANCE(130);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/')
        ADVANCE(124);
      if (lookahead == '\\')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(134);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(130);
      END_STATE();
    case 135:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(137);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(138);
      if (lookahead == '+')
        ADVANCE(139);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(140);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '=')
        ADVANCE(142);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == ']')
        ADVANCE(103);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(135);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(49);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(53);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 143:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(143);
      END_STATE();
    case 144:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(137);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == '*')
        ADVANCE(138);
      if (lookahead == '+')
        ADVANCE(139);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(140);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '=')
        ADVANCE(142);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '}')
        ADVANCE(110);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 145:
      if (lookahead == '\n')
        SKIP(146);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(147);
      if (lookahead == '\\')
        ADVANCE(88);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(147);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 146:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH);
      END_STATE();
    case 148:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(116);
      if (lookahead == '&')
        ADVANCE(137);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == '*')
        ADVANCE(138);
      if (lookahead == '+')
        ADVANCE(139);
      if (lookahead == '-')
        ADVANCE(140);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '}')
        ADVANCE(110);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(148);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 149:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '(')
        ADVANCE(44);
      if (lookahead == '/')
        ADVANCE(124);
      if (lookahead == '\\')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(134);
      if (lookahead != 0)
        ADVANCE(130);
      END_STATE();
    case 150:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(137);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == '*')
        ADVANCE(138);
      if (lookahead == '+')
        ADVANCE(139);
      if (lookahead == '-')
        ADVANCE(140);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(150);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 151:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(151);
      END_STATE();
    case 152:
      if (lookahead == '#')
        ADVANCE(153);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(152);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 153:
      if (lookahead == 'i')
        ADVANCE(154);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(153);
      END_STATE();
    case 154:
      if (lookahead == 'f')
        ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH);
      if (lookahead == 'd')
        ADVANCE(156);
      if (lookahead == 'n')
        ADVANCE(159);
      END_STATE();
    case 156:
      if (lookahead == 'e')
        ADVANCE(157);
      END_STATE();
    case 157:
      if (lookahead == 'f')
        ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH);
      END_STATE();
    case 159:
      if (lookahead == 'd')
        ADVANCE(160);
      END_STATE();
    case 160:
      if (lookahead == 'e')
        ADVANCE(161);
      END_STATE();
    case 161:
      if (lookahead == 'f')
        ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH);
      END_STATE();
    case 163:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(116);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(163);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 164:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(165);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(116);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '<')
        ADVANCE(76);
      if (lookahead == '=')
        ADVANCE(80);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == ']')
        ADVANCE(103);
      if (lookahead == '^')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '|')
        ADVANCE(107);
      if (lookahead == '}')
        ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(164);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 165:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 166:
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(138);
      if (lookahead == '.')
        ADVANCE(167);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(166);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 167:
      if (lookahead == '.')
        ADVANCE(57);
      END_STATE();
    case 168:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(169);
      if (lookahead == '&')
        ADVANCE(137);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == '*')
        ADVANCE(138);
      if (lookahead == '+')
        ADVANCE(139);
      if (lookahead == '-')
        ADVANCE(140);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(168);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 169:
      if (lookahead == 'd')
        ADVANCE(6);
      if (lookahead == 'e')
        ADVANCE(170);
      if (lookahead == 'i')
        ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(169);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n')
        ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 171:
      if (lookahead == '#')
        ADVANCE(172);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(171);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 172:
      if (lookahead == 'e')
        ADVANCE(173);
      if (lookahead == 'i')
        ADVANCE(154);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(172);
      END_STATE();
    case 173:
      if (lookahead == 'l')
        ADVANCE(174);
      if (lookahead == 'n')
        ADVANCE(179);
      END_STATE();
    case 174:
      if (lookahead == 'i')
        ADVANCE(175);
      if (lookahead == 's')
        ADVANCE(177);
      END_STATE();
    case 175:
      if (lookahead == 'f')
        ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH);
      END_STATE();
    case 177:
      if (lookahead == 'e')
        ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH);
      END_STATE();
    case 179:
      if (lookahead == 'd')
        ADVANCE(180);
      END_STATE();
    case 180:
      if (lookahead == 'i')
        ADVANCE(181);
      END_STATE();
    case 181:
      if (lookahead == 'f')
        ADVANCE(182);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH);
      END_STATE();
    case 183:
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '=')
        ADVANCE(142);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(183);
      END_STATE();
    case 184:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '<')
        ADVANCE(76);
      if (lookahead == '=')
        ADVANCE(80);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '^')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '|')
        ADVANCE(107);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 185:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(137);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == '*')
        ADVANCE(138);
      if (lookahead == '+')
        ADVANCE(139);
      if (lookahead == '-')
        ADVANCE(140);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == ']')
        ADVANCE(103);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(185);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 186:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == '<')
        ADVANCE(76);
      if (lookahead == '=')
        ADVANCE(80);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '^')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '|')
        ADVANCE(107);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 187:
      if (lookahead == '#')
        ADVANCE(172);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(187);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 188:
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '=')
        ADVANCE(142);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(188);
      END_STATE();
    case 189:
      if (lookahead == '\n')
        SKIP(190);
      if (lookahead == '/')
        ADVANCE(191);
      if (lookahead == '\\')
        ADVANCE(192);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(193);
      if (lookahead != 0 &&
          lookahead != '\'')
        ADVANCE(193);
      END_STATE();
    case 190:
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH);
      if (lookahead == '*')
        ADVANCE(60);
      if (lookahead == '/')
        ADVANCE(63);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH);
      if (lookahead == 'U')
        ADVANCE(89);
      if (lookahead == 'u')
        ADVANCE(93);
      if (lookahead == 'x')
        ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(101);
      if (lookahead != 0)
        ADVANCE(97);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH);
      END_STATE();
    case 194:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == '<')
        ADVANCE(76);
      if (lookahead == '=')
        ADVANCE(80);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == ']')
        ADVANCE(103);
      if (lookahead == '^')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '|')
        ADVANCE(107);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 195:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == '<')
        ADVANCE(76);
      if (lookahead == '=')
        ADVANCE(80);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '^')
        ADVANCE(104);
      if (lookahead == '{')
        ADVANCE(106);
      if (lookahead == '|')
        ADVANCE(107);
      if (lookahead == '}')
        ADVANCE(110);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(195);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 196:
      if (lookahead == '!')
        ADVANCE(165);
      if (lookahead == '%')
        ADVANCE(38);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(46);
      if (lookahead == '+')
        ADVANCE(48);
      if (lookahead == ',')
        ADVANCE(51);
      if (lookahead == '-')
        ADVANCE(52);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(59);
      if (lookahead == ':')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(75);
      if (lookahead == '<')
        ADVANCE(76);
      if (lookahead == '=')
        ADVANCE(80);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == ']')
        ADVANCE(103);
      if (lookahead == '^')
        ADVANCE(104);
      if (lookahead == '|')
        ADVANCE(107);
      if (lookahead == '}')
        ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(196);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    case 197:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(137);
      if (lookahead == '\'')
        ADVANCE(43);
      if (lookahead == '(')
        ADVANCE(113);
      if (lookahead == ')')
        ADVANCE(45);
      if (lookahead == '*')
        ADVANCE(138);
      if (lookahead == '+')
        ADVANCE(139);
      if (lookahead == '-')
        ADVANCE(140);
      if (lookahead == '/')
        ADVANCE(117);
      if (lookahead == '0')
        ADVANCE(65);
      if (lookahead == '~')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(114);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'F')
        ADVANCE(1);
      if (lookahead == 'N')
        ADVANCE(6);
      if (lookahead == 'T')
        ADVANCE(10);
      if (lookahead == '_')
        ADVANCE(14);
      if (lookahead == 'a')
        ADVANCE(21);
      if (lookahead == 'b')
        ADVANCE(25);
      if (lookahead == 'c')
        ADVANCE(33);
      if (lookahead == 'd')
        ADVANCE(56);
      if (lookahead == 'e')
        ADVANCE(70);
      if (lookahead == 'f')
        ADVANCE(82);
      if (lookahead == 'g')
        ADVANCE(93);
      if (lookahead == 'i')
        ADVANCE(97);
      if (lookahead == 'l')
        ADVANCE(111);
      if (lookahead == 'r')
        ADVANCE(115);
      if (lookahead == 's')
        ADVANCE(133);
      if (lookahead == 't')
        ADVANCE(165);
      if (lookahead == 'u')
        ADVANCE(179);
      if (lookahead == 'v')
        ADVANCE(193);
      if (lookahead == 'w')
        ADVANCE(202);
      END_STATE();
    case 1:
      if (lookahead == 'A')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 'L')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'S')
        ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == 'E')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 6:
      if (lookahead == 'U')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'L')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'L')
        ADVANCE(9);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 10:
      if (lookahead == 'R')
        ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == 'U')
        ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == 'E')
        ADVANCE(13);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 14:
      if (lookahead == 'A')
        ADVANCE(15);
      END_STATE();
    case 15:
      if (lookahead == 't')
        ADVANCE(16);
      END_STATE();
    case 16:
      if (lookahead == 'o')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 'm')
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == 'i')
        ADVANCE(19);
      END_STATE();
    case 19:
      if (lookahead == 'c')
        ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 21:
      if (lookahead == 'u')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 't')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'o')
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_auto);
      END_STATE();
    case 25:
      if (lookahead == 'o')
        ADVANCE(26);
      if (lookahead == 'r')
        ADVANCE(29);
      END_STATE();
    case 26:
      if (lookahead == 'o')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 'l')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_primitive_type);
      END_STATE();
    case 29:
      if (lookahead == 'e')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 'a')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'k')
        ADVANCE(32);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 33:
      if (lookahead == 'a')
        ADVANCE(34);
      if (lookahead == 'h')
        ADVANCE(37);
      if (lookahead == 'o')
        ADVANCE(47);
      END_STATE();
    case 34:
      if (lookahead == 's')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'e')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 37:
      if (lookahead == 'a')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'r')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1')
        ADVANCE(40);
      if (lookahead == '3')
        ADVANCE(43);
      if (lookahead == '6')
        ADVANCE(44);
      if (lookahead == '8')
        ADVANCE(41);
      if (lookahead == 'p')
        ADVANCE(45);
      END_STATE();
    case 40:
      if (lookahead == '6')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == '_')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 't')
        ADVANCE(28);
      END_STATE();
    case 43:
      if (lookahead == '2')
        ADVANCE(41);
      END_STATE();
    case 44:
      if (lookahead == '4')
        ADVANCE(41);
      END_STATE();
    case 45:
      if (lookahead == 't')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 'r')
        ADVANCE(41);
      END_STATE();
    case 47:
      if (lookahead == 'n')
        ADVANCE(48);
      END_STATE();
    case 48:
      if (lookahead == 's')
        ADVANCE(49);
      if (lookahead == 't')
        ADVANCE(51);
      END_STATE();
    case 49:
      if (lookahead == 't')
        ADVANCE(50);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 51:
      if (lookahead == 'i')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 'n')
        ADVANCE(53);
      END_STATE();
    case 53:
      if (lookahead == 'u')
        ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == 'e')
        ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 56:
      if (lookahead == 'e')
        ADVANCE(57);
      if (lookahead == 'o')
        ADVANCE(66);
      END_STATE();
    case 57:
      if (lookahead == 'f')
        ADVANCE(58);
      if (lookahead == 'n')
        ADVANCE(63);
      END_STATE();
    case 58:
      if (lookahead == 'a')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'u')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 'l')
        ADVANCE(61);
      END_STATE();
    case 61:
      if (lookahead == 't')
        ADVANCE(62);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 63:
      if (lookahead == 's')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'e')
        ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_dense);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'b')
        ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == 'l')
        ADVANCE(69);
      END_STATE();
    case 69:
      if (lookahead == 'e')
        ADVANCE(28);
      END_STATE();
    case 70:
      if (lookahead == 'l')
        ADVANCE(71);
      if (lookahead == 'n')
        ADVANCE(74);
      if (lookahead == 'x')
        ADVANCE(77);
      END_STATE();
    case 71:
      if (lookahead == 's')
        ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == 'e')
        ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 74:
      if (lookahead == 'u')
        ADVANCE(75);
      END_STATE();
    case 75:
      if (lookahead == 'm')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 77:
      if (lookahead == 't')
        ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead == 'e')
        ADVANCE(79);
      END_STATE();
    case 79:
      if (lookahead == 'r')
        ADVANCE(80);
      END_STATE();
    case 80:
      if (lookahead == 'n')
        ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 82:
      if (lookahead == 'a')
        ADVANCE(83);
      if (lookahead == 'l')
        ADVANCE(86);
      if (lookahead == 'o')
        ADVANCE(88);
      END_STATE();
    case 83:
      if (lookahead == 'l')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 's')
        ADVANCE(85);
      END_STATE();
    case 85:
      if (lookahead == 'e')
        ADVANCE(5);
      END_STATE();
    case 86:
      if (lookahead == 'o')
        ADVANCE(87);
      END_STATE();
    case 87:
      if (lookahead == 'a')
        ADVANCE(42);
      END_STATE();
    case 88:
      if (lookahead == 'r')
        ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'm')
        ADVANCE(90);
      END_STATE();
    case 90:
      if (lookahead == 'a')
        ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 't')
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_format);
      END_STATE();
    case 93:
      if (lookahead == 'o')
        ADVANCE(94);
      END_STATE();
    case 94:
      if (lookahead == 't')
        ADVANCE(95);
      END_STATE();
    case 95:
      if (lookahead == 'o')
        ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 97:
      if (lookahead == 'f')
        ADVANCE(98);
      if (lookahead == 'n')
        ADVANCE(99);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 99:
      if (lookahead == 'd')
        ADVANCE(100);
      if (lookahead == 'l')
        ADVANCE(107);
      if (lookahead == 't')
        ADVANCE(39);
      END_STATE();
    case 100:
      if (lookahead == 'e')
        ADVANCE(101);
      END_STATE();
    case 101:
      if (lookahead == 'x')
        ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == 'v')
        ADVANCE(103);
      END_STATE();
    case 103:
      if (lookahead == 'a')
        ADVANCE(104);
      END_STATE();
    case 104:
      if (lookahead == 'r')
        ADVANCE(105);
      END_STATE();
    case 105:
      if (lookahead == 's')
        ADVANCE(106);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_indexvars);
      END_STATE();
    case 107:
      if (lookahead == 'i')
        ADVANCE(108);
      END_STATE();
    case 108:
      if (lookahead == 'n')
        ADVANCE(109);
      END_STATE();
    case 109:
      if (lookahead == 'e')
        ADVANCE(110);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 111:
      if (lookahead == 'o')
        ADVANCE(112);
      END_STATE();
    case 112:
      if (lookahead == 'n')
        ADVANCE(113);
      END_STATE();
    case 113:
      if (lookahead == 'g')
        ADVANCE(114);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 115:
      if (lookahead == 'e')
        ADVANCE(116);
      END_STATE();
    case 116:
      if (lookahead == 'g')
        ADVANCE(117);
      if (lookahead == 's')
        ADVANCE(123);
      if (lookahead == 't')
        ADVANCE(129);
      END_STATE();
    case 117:
      if (lookahead == 'i')
        ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == 's')
        ADVANCE(119);
      END_STATE();
    case 119:
      if (lookahead == 't')
        ADVANCE(120);
      END_STATE();
    case 120:
      if (lookahead == 'e')
        ADVANCE(121);
      END_STATE();
    case 121:
      if (lookahead == 'r')
        ADVANCE(122);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 123:
      if (lookahead == 't')
        ADVANCE(124);
      END_STATE();
    case 124:
      if (lookahead == 'r')
        ADVANCE(125);
      END_STATE();
    case 125:
      if (lookahead == 'i')
        ADVANCE(126);
      END_STATE();
    case 126:
      if (lookahead == 'c')
        ADVANCE(127);
      END_STATE();
    case 127:
      if (lookahead == 't')
        ADVANCE(128);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 129:
      if (lookahead == 'u')
        ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == 'r')
        ADVANCE(131);
      END_STATE();
    case 131:
      if (lookahead == 'n')
        ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 133:
      if (lookahead == 'h')
        ADVANCE(134);
      if (lookahead == 'i')
        ADVANCE(138);
      if (lookahead == 'p')
        ADVANCE(143);
      if (lookahead == 's')
        ADVANCE(148);
      if (lookahead == 't')
        ADVANCE(151);
      if (lookahead == 'w')
        ADVANCE(160);
      END_STATE();
    case 134:
      if (lookahead == 'o')
        ADVANCE(135);
      END_STATE();
    case 135:
      if (lookahead == 'r')
        ADVANCE(136);
      END_STATE();
    case 136:
      if (lookahead == 't')
        ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 138:
      if (lookahead == 'z')
        ADVANCE(139);
      END_STATE();
    case 139:
      if (lookahead == 'e')
        ADVANCE(140);
      END_STATE();
    case 140:
      if (lookahead == '_')
        ADVANCE(42);
      if (lookahead == 'o')
        ADVANCE(141);
      END_STATE();
    case 141:
      if (lookahead == 'f')
        ADVANCE(142);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 143:
      if (lookahead == 'a')
        ADVANCE(144);
      END_STATE();
    case 144:
      if (lookahead == 'r')
        ADVANCE(145);
      END_STATE();
    case 145:
      if (lookahead == 's')
        ADVANCE(146);
      END_STATE();
    case 146:
      if (lookahead == 'e')
        ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_sparse);
      END_STATE();
    case 148:
      if (lookahead == 'i')
        ADVANCE(149);
      END_STATE();
    case 149:
      if (lookahead == 'z')
        ADVANCE(150);
      END_STATE();
    case 150:
      if (lookahead == 'e')
        ADVANCE(41);
      END_STATE();
    case 151:
      if (lookahead == 'a')
        ADVANCE(152);
      if (lookahead == 'r')
        ADVANCE(156);
      END_STATE();
    case 152:
      if (lookahead == 't')
        ADVANCE(153);
      END_STATE();
    case 153:
      if (lookahead == 'i')
        ADVANCE(154);
      END_STATE();
    case 154:
      if (lookahead == 'c')
        ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 156:
      if (lookahead == 'u')
        ADVANCE(157);
      END_STATE();
    case 157:
      if (lookahead == 'c')
        ADVANCE(158);
      END_STATE();
    case 158:
      if (lookahead == 't')
        ADVANCE(159);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 160:
      if (lookahead == 'i')
        ADVANCE(161);
      END_STATE();
    case 161:
      if (lookahead == 't')
        ADVANCE(162);
      END_STATE();
    case 162:
      if (lookahead == 'c')
        ADVANCE(163);
      END_STATE();
    case 163:
      if (lookahead == 'h')
        ADVANCE(164);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 165:
      if (lookahead == 'e')
        ADVANCE(166);
      if (lookahead == 'r')
        ADVANCE(171);
      if (lookahead == 'y')
        ADVANCE(173);
      END_STATE();
    case 166:
      if (lookahead == 'n')
        ADVANCE(167);
      END_STATE();
    case 167:
      if (lookahead == 's')
        ADVANCE(168);
      END_STATE();
    case 168:
      if (lookahead == 'o')
        ADVANCE(169);
      END_STATE();
    case 169:
      if (lookahead == 'r')
        ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_tensor);
      END_STATE();
    case 171:
      if (lookahead == 'u')
        ADVANCE(172);
      END_STATE();
    case 172:
      if (lookahead == 'e')
        ADVANCE(13);
      END_STATE();
    case 173:
      if (lookahead == 'p')
        ADVANCE(174);
      END_STATE();
    case 174:
      if (lookahead == 'e')
        ADVANCE(175);
      END_STATE();
    case 175:
      if (lookahead == 'd')
        ADVANCE(176);
      END_STATE();
    case 176:
      if (lookahead == 'e')
        ADVANCE(177);
      END_STATE();
    case 177:
      if (lookahead == 'f')
        ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 179:
      if (lookahead == 'i')
        ADVANCE(180);
      if (lookahead == 'n')
        ADVANCE(183);
      END_STATE();
    case 180:
      if (lookahead == 'n')
        ADVANCE(181);
      END_STATE();
    case 181:
      if (lookahead == 't')
        ADVANCE(182);
      END_STATE();
    case 182:
      if (lookahead == '1')
        ADVANCE(40);
      if (lookahead == '3')
        ADVANCE(43);
      if (lookahead == '6')
        ADVANCE(44);
      if (lookahead == '8')
        ADVANCE(41);
      if (lookahead == 'p')
        ADVANCE(45);
      END_STATE();
    case 183:
      if (lookahead == 'i')
        ADVANCE(184);
      if (lookahead == 's')
        ADVANCE(187);
      END_STATE();
    case 184:
      if (lookahead == 'o')
        ADVANCE(185);
      END_STATE();
    case 185:
      if (lookahead == 'n')
        ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 187:
      if (lookahead == 'i')
        ADVANCE(188);
      END_STATE();
    case 188:
      if (lookahead == 'g')
        ADVANCE(189);
      END_STATE();
    case 189:
      if (lookahead == 'n')
        ADVANCE(190);
      END_STATE();
    case 190:
      if (lookahead == 'e')
        ADVANCE(191);
      END_STATE();
    case 191:
      if (lookahead == 'd')
        ADVANCE(192);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 193:
      if (lookahead == 'o')
        ADVANCE(194);
      END_STATE();
    case 194:
      if (lookahead == 'i')
        ADVANCE(195);
      if (lookahead == 'l')
        ADVANCE(196);
      END_STATE();
    case 195:
      if (lookahead == 'd')
        ADVANCE(28);
      END_STATE();
    case 196:
      if (lookahead == 'a')
        ADVANCE(197);
      END_STATE();
    case 197:
      if (lookahead == 't')
        ADVANCE(198);
      END_STATE();
    case 198:
      if (lookahead == 'i')
        ADVANCE(199);
      END_STATE();
    case 199:
      if (lookahead == 'l')
        ADVANCE(200);
      END_STATE();
    case 200:
      if (lookahead == 'e')
        ADVANCE(201);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 202:
      if (lookahead == 'h')
        ADVANCE(203);
      END_STATE();
    case 203:
      if (lookahead == 'i')
        ADVANCE(204);
      END_STATE();
    case 204:
      if (lookahead == 'l')
        ADVANCE(205);
      END_STATE();
    case 205:
      if (lookahead == 'e')
        ADVANCE(206);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 115},
  [2] = {.lex_state = 115},
  [3] = {.lex_state = 115},
  [4] = {.lex_state = 118},
  [5] = {.lex_state = 115},
  [6] = {.lex_state = 123},
  [7] = {.lex_state = 115},
  [8] = {.lex_state = 132},
  [9] = {.lex_state = 115},
  [10] = {.lex_state = 135},
  [11] = {.lex_state = 135},
  [12] = {.lex_state = 135},
  [13] = {.lex_state = 135},
  [14] = {.lex_state = 135},
  [15] = {.lex_state = 135},
  [16] = {.lex_state = 135},
  [17] = {.lex_state = 143},
  [18] = {.lex_state = 144},
  [19] = {.lex_state = 144},
  [20] = {.lex_state = 115},
  [21] = {.lex_state = 115},
  [22] = {.lex_state = 144},
  [23] = {.lex_state = 115},
  [24] = {.lex_state = 144},
  [25] = {.lex_state = 144},
  [26] = {.lex_state = 145},
  [27] = {.lex_state = 148},
  [28] = {.lex_state = 149},
  [29] = {.lex_state = 150},
  [30] = {.lex_state = 150},
  [31] = {.lex_state = 148},
  [32] = {.lex_state = 151},
  [33] = {.lex_state = 135},
  [34] = {.lex_state = 115},
  [35] = {.lex_state = 135},
  [36] = {.lex_state = 135},
  [37] = {.lex_state = 144},
  [38] = {.lex_state = 135},
  [39] = {.lex_state = 135},
  [40] = {.lex_state = 152},
  [41] = {.lex_state = 135},
  [42] = {.lex_state = 135},
  [43] = {.lex_state = 135},
  [44] = {.lex_state = 135},
  [45] = {.lex_state = 115},
  [46] = {.lex_state = 135},
  [47] = {.lex_state = 148},
  [48] = {.lex_state = 135},
  [49] = {.lex_state = 144},
  [50] = {.lex_state = 144},
  [51] = {.lex_state = 144},
  [52] = {.lex_state = 115},
  [53] = {.lex_state = 144},
  [54] = {.lex_state = 115},
  [55] = {.lex_state = 135},
  [56] = {.lex_state = 135},
  [57] = {.lex_state = 144},
  [58] = {.lex_state = 135},
  [59] = {.lex_state = 115},
  [60] = {.lex_state = 163},
  [61] = {.lex_state = 164},
  [62] = {.lex_state = 145},
  [63] = {.lex_state = 148},
  [64] = {.lex_state = 166},
  [65] = {.lex_state = 151},
  [66] = {.lex_state = 132},
  [67] = {.lex_state = 115},
  [68] = {.lex_state = 115},
  [69] = {.lex_state = 118},
  [70] = {.lex_state = 115},
  [71] = {.lex_state = 123},
  [72] = {.lex_state = 163},
  [73] = {.lex_state = 115},
  [74] = {.lex_state = 168},
  [75] = {.lex_state = 123},
  [76] = {.lex_state = 132},
  [77] = {.lex_state = 115},
  [78] = {.lex_state = 135},
  [79] = {.lex_state = 171},
  [80] = {.lex_state = 144},
  [81] = {.lex_state = 150},
  [82] = {.lex_state = 163},
  [83] = {.lex_state = 171},
  [84] = {.lex_state = 150},
  [85] = {.lex_state = 148},
  [86] = {.lex_state = 135},
  [87] = {.lex_state = 135},
  [88] = {.lex_state = 183},
  [89] = {.lex_state = 144},
  [90] = {.lex_state = 135},
  [91] = {.lex_state = 115},
  [92] = {.lex_state = 135},
  [93] = {.lex_state = 148},
  [94] = {.lex_state = 163},
  [95] = {.lex_state = 135},
  [96] = {.lex_state = 135},
  [97] = {.lex_state = 115},
  [98] = {.lex_state = 135},
  [99] = {.lex_state = 135},
  [100] = {.lex_state = 144},
  [101] = {.lex_state = 144},
  [102] = {.lex_state = 144},
  [103] = {.lex_state = 135},
  [104] = {.lex_state = 135},
  [105] = {.lex_state = 123},
  [106] = {.lex_state = 115},
  [107] = {.lex_state = 184},
  [108] = {.lex_state = 184},
  [109] = {.lex_state = 152},
  [110] = {.lex_state = 115},
  [111] = {.lex_state = 184},
  [112] = {.lex_state = 135},
  [113] = {.lex_state = 135},
  [114] = {.lex_state = 166},
  [115] = {.lex_state = 166},
  [116] = {.lex_state = 115},
  [117] = {.lex_state = 166},
  [118] = {.lex_state = 135},
  [119] = {.lex_state = 166},
  [120] = {.lex_state = 183},
  [121] = {.lex_state = 135},
  [122] = {.lex_state = 166},
  [123] = {.lex_state = 148},
  [124] = {.lex_state = 148},
  [125] = {.lex_state = 135},
  [126] = {.lex_state = 185},
  [127] = {.lex_state = 135},
  [128] = {.lex_state = 163},
  [129] = {.lex_state = 183},
  [130] = {.lex_state = 144},
  [131] = {.lex_state = 144},
  [132] = {.lex_state = 144},
  [133] = {.lex_state = 135},
  [134] = {.lex_state = 144},
  [135] = {.lex_state = 164},
  [136] = {.lex_state = 145},
  [137] = {.lex_state = 132},
  [138] = {.lex_state = 186},
  [139] = {.lex_state = 148},
  [140] = {.lex_state = 148},
  [141] = {.lex_state = 151},
  [142] = {.lex_state = 115},
  [143] = {.lex_state = 144},
  [144] = {.lex_state = 145},
  [145] = {.lex_state = 150},
  [146] = {.lex_state = 149},
  [147] = {.lex_state = 150},
  [148] = {.lex_state = 150},
  [149] = {.lex_state = 115},
  [150] = {.lex_state = 115},
  [151] = {.lex_state = 118},
  [152] = {.lex_state = 115},
  [153] = {.lex_state = 123},
  [154] = {.lex_state = 115},
  [155] = {.lex_state = 132},
  [156] = {.lex_state = 115},
  [157] = {.lex_state = 135},
  [158] = {.lex_state = 144},
  [159] = {.lex_state = 168},
  [160] = {.lex_state = 150},
  [161] = {.lex_state = 150},
  [162] = {.lex_state = 151},
  [163] = {.lex_state = 135},
  [164] = {.lex_state = 115},
  [165] = {.lex_state = 135},
  [166] = {.lex_state = 163},
  [167] = {.lex_state = 150},
  [168] = {.lex_state = 144},
  [169] = {.lex_state = 144},
  [170] = {.lex_state = 171},
  [171] = {.lex_state = 150},
  [172] = {.lex_state = 163},
  [173] = {.lex_state = 171},
  [174] = {.lex_state = 135},
  [175] = {.lex_state = 166},
  [176] = {.lex_state = 183},
  [177] = {.lex_state = 135},
  [178] = {.lex_state = 148},
  [179] = {.lex_state = 185},
  [180] = {.lex_state = 183},
  [181] = {.lex_state = 144},
  [182] = {.lex_state = 163},
  [183] = {.lex_state = 148},
  [184] = {.lex_state = 135},
  [185] = {.lex_state = 135},
  [186] = {.lex_state = 135},
  [187] = {.lex_state = 135},
  [188] = {.lex_state = 135},
  [189] = {.lex_state = 144},
  [190] = {.lex_state = 144},
  [191] = {.lex_state = 171},
  [192] = {.lex_state = 171},
  [193] = {.lex_state = 135},
  [194] = {.lex_state = 187},
  [195] = {.lex_state = 135},
  [196] = {.lex_state = 135},
  [197] = {.lex_state = 188},
  [198] = {.lex_state = 184},
  [199] = {.lex_state = 184},
  [200] = {.lex_state = 135},
  [201] = {.lex_state = 152},
  [202] = {.lex_state = 184},
  [203] = {.lex_state = 184},
  [204] = {.lex_state = 166},
  [205] = {.lex_state = 166},
  [206] = {.lex_state = 185},
  [207] = {.lex_state = 166},
  [208] = {.lex_state = 186},
  [209] = {.lex_state = 135},
  [210] = {.lex_state = 166},
  [211] = {.lex_state = 166},
  [212] = {.lex_state = 135},
  [213] = {.lex_state = 183},
  [214] = {.lex_state = 183},
  [215] = {.lex_state = 135},
  [216] = {.lex_state = 188},
  [217] = {.lex_state = 186},
  [218] = {.lex_state = 186},
  [219] = {.lex_state = 186},
  [220] = {.lex_state = 115},
  [221] = {.lex_state = 186},
  [222] = {.lex_state = 135},
  [223] = {.lex_state = 148},
  [224] = {.lex_state = 148},
  [225] = {.lex_state = 118},
  [226] = {.lex_state = 123},
  [227] = {.lex_state = 115},
  [228] = {.lex_state = 135},
  [229] = {.lex_state = 135},
  [230] = {.lex_state = 135},
  [231] = {.lex_state = 135},
  [232] = {.lex_state = 184},
  [233] = {.lex_state = 135},
  [234] = {.lex_state = 144},
  [235] = {.lex_state = 135},
  [236] = {.lex_state = 144},
  [237] = {.lex_state = 144},
  [238] = {.lex_state = 144},
  [239] = {.lex_state = 115},
  [240] = {.lex_state = 135},
  [241] = {.lex_state = 135},
  [242] = {.lex_state = 135},
  [243] = {.lex_state = 135},
  [244] = {.lex_state = 189},
  [245] = {.lex_state = 184},
  [246] = {.lex_state = 144},
  [247] = {.lex_state = 184},
  [248] = {.lex_state = 144},
  [249] = {.lex_state = 184},
  [250] = {.lex_state = 148},
  [251] = {.lex_state = 135},
  [252] = {.lex_state = 144},
  [253] = {.lex_state = 144},
  [254] = {.lex_state = 135},
  [255] = {.lex_state = 135},
  [256] = {.lex_state = 183},
  [257] = {.lex_state = 135},
  [258] = {.lex_state = 135},
  [259] = {.lex_state = 135},
  [260] = {.lex_state = 135},
  [261] = {.lex_state = 194},
  [262] = {.lex_state = 185},
  [263] = {.lex_state = 185},
  [264] = {.lex_state = 194},
  [265] = {.lex_state = 194},
  [266] = {.lex_state = 115},
  [267] = {.lex_state = 185},
  [268] = {.lex_state = 144},
  [269] = {.lex_state = 184},
  [270] = {.lex_state = 144},
  [271] = {.lex_state = 148},
  [272] = {.lex_state = 144},
  [273] = {.lex_state = 115},
  [274] = {.lex_state = 132},
  [275] = {.lex_state = 166},
  [276] = {.lex_state = 186},
  [277] = {.lex_state = 148},
  [278] = {.lex_state = 135},
  [279] = {.lex_state = 150},
  [280] = {.lex_state = 150},
  [281] = {.lex_state = 145},
  [282] = {.lex_state = 150},
  [283] = {.lex_state = 151},
  [284] = {.lex_state = 132},
  [285] = {.lex_state = 150},
  [286] = {.lex_state = 171},
  [287] = {.lex_state = 150},
  [288] = {.lex_state = 150},
  [289] = {.lex_state = 171},
  [290] = {.lex_state = 150},
  [291] = {.lex_state = 115},
  [292] = {.lex_state = 144},
  [293] = {.lex_state = 145},
  [294] = {.lex_state = 168},
  [295] = {.lex_state = 149},
  [296] = {.lex_state = 150},
  [297] = {.lex_state = 150},
  [298] = {.lex_state = 168},
  [299] = {.lex_state = 151},
  [300] = {.lex_state = 135},
  [301] = {.lex_state = 115},
  [302] = {.lex_state = 135},
  [303] = {.lex_state = 168},
  [304] = {.lex_state = 144},
  [305] = {.lex_state = 144},
  [306] = {.lex_state = 168},
  [307] = {.lex_state = 171},
  [308] = {.lex_state = 150},
  [309] = {.lex_state = 150},
  [310] = {.lex_state = 144},
  [311] = {.lex_state = 135},
  [312] = {.lex_state = 148},
  [313] = {.lex_state = 150},
  [314] = {.lex_state = 135},
  [315] = {.lex_state = 148},
  [316] = {.lex_state = 150},
  [317] = {.lex_state = 150},
  [318] = {.lex_state = 144},
  [319] = {.lex_state = 163},
  [320] = {.lex_state = 163},
  [321] = {.lex_state = 135},
  [322] = {.lex_state = 183},
  [323] = {.lex_state = 183},
  [324] = {.lex_state = 183},
  [325] = {.lex_state = 185},
  [326] = {.lex_state = 194},
  [327] = {.lex_state = 148},
  [328] = {.lex_state = 163},
  [329] = {.lex_state = 148},
  [330] = {.lex_state = 135},
  [331] = {.lex_state = 135},
  [332] = {.lex_state = 135},
  [333] = {.lex_state = 135},
  [334] = {.lex_state = 135},
  [335] = {.lex_state = 135},
  [336] = {.lex_state = 135},
  [337] = {.lex_state = 135},
  [338] = {.lex_state = 195},
  [339] = {.lex_state = 195},
  [340] = {.lex_state = 135},
  [341] = {.lex_state = 144},
  [342] = {.lex_state = 144},
  [343] = {.lex_state = 144},
  [344] = {.lex_state = 187},
  [345] = {.lex_state = 171},
  [346] = {.lex_state = 123},
  [347] = {.lex_state = 171},
  [348] = {.lex_state = 171},
  [349] = {.lex_state = 187},
  [350] = {.lex_state = 171},
  [351] = {.lex_state = 171},
  [352] = {.lex_state = 135},
  [353] = {.lex_state = 166},
  [354] = {.lex_state = 188},
  [355] = {.lex_state = 135},
  [356] = {.lex_state = 135},
  [357] = {.lex_state = 135},
  [358] = {.lex_state = 135},
  [359] = {.lex_state = 135},
  [360] = {.lex_state = 135},
  [361] = {.lex_state = 135},
  [362] = {.lex_state = 184},
  [363] = {.lex_state = 184},
  [364] = {.lex_state = 187},
  [365] = {.lex_state = 135},
  [366] = {.lex_state = 185},
  [367] = {.lex_state = 135},
  [368] = {.lex_state = 188},
  [369] = {.lex_state = 184},
  [370] = {.lex_state = 184},
  [371] = {.lex_state = 184},
  [372] = {.lex_state = 166},
  [373] = {.lex_state = 186},
  [374] = {.lex_state = 166},
  [375] = {.lex_state = 186},
  [376] = {.lex_state = 185},
  [377] = {.lex_state = 194},
  [378] = {.lex_state = 185},
  [379] = {.lex_state = 186},
  [380] = {.lex_state = 166},
  [381] = {.lex_state = 188},
  [382] = {.lex_state = 166},
  [383] = {.lex_state = 186},
  [384] = {.lex_state = 166},
  [385] = {.lex_state = 186},
  [386] = {.lex_state = 186},
  [387] = {.lex_state = 186},
  [388] = {.lex_state = 186},
  [389] = {.lex_state = 186},
  [390] = {.lex_state = 186},
  [391] = {.lex_state = 135},
  [392] = {.lex_state = 135},
  [393] = {.lex_state = 135},
  [394] = {.lex_state = 135},
  [395] = {.lex_state = 135},
  [396] = {.lex_state = 135},
  [397] = {.lex_state = 186},
  [398] = {.lex_state = 186},
  [399] = {.lex_state = 166},
  [400] = {.lex_state = 166},
  [401] = {.lex_state = 186},
  [402] = {.lex_state = 145},
  [403] = {.lex_state = 150},
  [404] = {.lex_state = 150},
  [405] = {.lex_state = 196},
  [406] = {.lex_state = 135},
  [407] = {.lex_state = 144},
  [408] = {.lex_state = 144},
  [409] = {.lex_state = 135},
  [410] = {.lex_state = 135},
  [411] = {.lex_state = 135},
  [412] = {.lex_state = 135},
  [413] = {.lex_state = 135},
  [414] = {.lex_state = 135},
  [415] = {.lex_state = 184},
  [416] = {.lex_state = 184},
  [417] = {.lex_state = 144},
  [418] = {.lex_state = 144},
  [419] = {.lex_state = 135},
  [420] = {.lex_state = 135},
  [421] = {.lex_state = 135},
  [422] = {.lex_state = 184},
  [423] = {.lex_state = 135},
  [424] = {.lex_state = 144},
  [425] = {.lex_state = 135},
  [426] = {.lex_state = 184},
  [427] = {.lex_state = 115},
  [428] = {.lex_state = 144},
  [429] = {.lex_state = 148},
  [430] = {.lex_state = 184},
  [431] = {.lex_state = 148},
  [432] = {.lex_state = 148},
  [433] = {.lex_state = 144},
  [434] = {.lex_state = 196},
  [435] = {.lex_state = 196},
  [436] = {.lex_state = 196},
  [437] = {.lex_state = 135},
  [438] = {.lex_state = 184},
  [439] = {.lex_state = 135},
  [440] = {.lex_state = 144},
  [441] = {.lex_state = 144},
  [442] = {.lex_state = 197},
  [443] = {.lex_state = 148},
  [444] = {.lex_state = 135},
  [445] = {.lex_state = 135},
  [446] = {.lex_state = 135},
  [447] = {.lex_state = 135},
  [448] = {.lex_state = 135},
  [449] = {.lex_state = 135},
  [450] = {.lex_state = 135},
  [451] = {.lex_state = 135},
  [452] = {.lex_state = 135},
  [453] = {.lex_state = 135},
  [454] = {.lex_state = 135},
  [455] = {.lex_state = 135},
  [456] = {.lex_state = 135},
  [457] = {.lex_state = 135},
  [458] = {.lex_state = 196},
  [459] = {.lex_state = 115},
  [460] = {.lex_state = 196},
  [461] = {.lex_state = 184},
  [462] = {.lex_state = 148},
  [463] = {.lex_state = 148},
  [464] = {.lex_state = 135},
  [465] = {.lex_state = 166},
  [466] = {.lex_state = 135},
  [467] = {.lex_state = 194},
  [468] = {.lex_state = 183},
  [469] = {.lex_state = 194},
  [470] = {.lex_state = 185},
  [471] = {.lex_state = 135},
  [472] = {.lex_state = 135},
  [473] = {.lex_state = 135},
  [474] = {.lex_state = 135},
  [475] = {.lex_state = 135},
  [476] = {.lex_state = 135},
  [477] = {.lex_state = 135},
  [478] = {.lex_state = 135},
  [479] = {.lex_state = 135},
  [480] = {.lex_state = 135},
  [481] = {.lex_state = 135},
  [482] = {.lex_state = 135},
  [483] = {.lex_state = 194},
  [484] = {.lex_state = 185},
  [485] = {.lex_state = 185},
  [486] = {.lex_state = 196},
  [487] = {.lex_state = 144},
  [488] = {.lex_state = 135},
  [489] = {.lex_state = 115},
  [490] = {.lex_state = 195},
  [491] = {.lex_state = 144},
  [492] = {.lex_state = 135},
  [493] = {.lex_state = 144},
  [494] = {.lex_state = 144},
  [495] = {.lex_state = 144},
  [496] = {.lex_state = 186},
  [497] = {.lex_state = 132},
  [498] = {.lex_state = 186},
  [499] = {.lex_state = 135},
  [500] = {.lex_state = 150},
  [501] = {.lex_state = 150},
  [502] = {.lex_state = 150},
  [503] = {.lex_state = 151},
  [504] = {.lex_state = 150},
  [505] = {.lex_state = 171},
  [506] = {.lex_state = 150},
  [507] = {.lex_state = 171},
  [508] = {.lex_state = 135},
  [509] = {.lex_state = 168},
  [510] = {.lex_state = 168},
  [511] = {.lex_state = 145},
  [512] = {.lex_state = 168},
  [513] = {.lex_state = 151},
  [514] = {.lex_state = 132},
  [515] = {.lex_state = 168},
  [516] = {.lex_state = 171},
  [517] = {.lex_state = 150},
  [518] = {.lex_state = 168},
  [519] = {.lex_state = 171},
  [520] = {.lex_state = 150},
  [521] = {.lex_state = 168},
  [522] = {.lex_state = 144},
  [523] = {.lex_state = 135},
  [524] = {.lex_state = 148},
  [525] = {.lex_state = 168},
  [526] = {.lex_state = 135},
  [527] = {.lex_state = 148},
  [528] = {.lex_state = 168},
  [529] = {.lex_state = 168},
  [530] = {.lex_state = 144},
  [531] = {.lex_state = 171},
  [532] = {.lex_state = 150},
  [533] = {.lex_state = 144},
  [534] = {.lex_state = 150},
  [535] = {.lex_state = 148},
  [536] = {.lex_state = 150},
  [537] = {.lex_state = 148},
  [538] = {.lex_state = 150},
  [539] = {.lex_state = 183},
  [540] = {.lex_state = 194},
  [541] = {.lex_state = 166},
  [542] = {.lex_state = 135},
  [543] = {.lex_state = 195},
  [544] = {.lex_state = 135},
  [545] = {.lex_state = 135},
  [546] = {.lex_state = 135},
  [547] = {.lex_state = 135},
  [548] = {.lex_state = 135},
  [549] = {.lex_state = 135},
  [550] = {.lex_state = 135},
  [551] = {.lex_state = 135},
  [552] = {.lex_state = 135},
  [553] = {.lex_state = 135},
  [554] = {.lex_state = 135},
  [555] = {.lex_state = 135},
  [556] = {.lex_state = 195},
  [557] = {.lex_state = 135},
  [558] = {.lex_state = 115},
  [559] = {.lex_state = 171},
  [560] = {.lex_state = 171},
  [561] = {.lex_state = 187},
  [562] = {.lex_state = 171},
  [563] = {.lex_state = 171},
  [564] = {.lex_state = 187},
  [565] = {.lex_state = 171},
  [566] = {.lex_state = 135},
  [567] = {.lex_state = 188},
  [568] = {.lex_state = 188},
  [569] = {.lex_state = 166},
  [570] = {.lex_state = 135},
  [571] = {.lex_state = 184},
  [572] = {.lex_state = 187},
  [573] = {.lex_state = 135},
  [574] = {.lex_state = 135},
  [575] = {.lex_state = 135},
  [576] = {.lex_state = 135},
  [577] = {.lex_state = 135},
  [578] = {.lex_state = 135},
  [579] = {.lex_state = 135},
  [580] = {.lex_state = 135},
  [581] = {.lex_state = 135},
  [582] = {.lex_state = 135},
  [583] = {.lex_state = 135},
  [584] = {.lex_state = 135},
  [585] = {.lex_state = 184},
  [586] = {.lex_state = 184},
  [587] = {.lex_state = 188},
  [588] = {.lex_state = 185},
  [589] = {.lex_state = 194},
  [590] = {.lex_state = 184},
  [591] = {.lex_state = 135},
  [592] = {.lex_state = 184},
  [593] = {.lex_state = 186},
  [594] = {.lex_state = 186},
  [595] = {.lex_state = 166},
  [596] = {.lex_state = 186},
  [597] = {.lex_state = 194},
  [598] = {.lex_state = 185},
  [599] = {.lex_state = 186},
  [600] = {.lex_state = 188},
  [601] = {.lex_state = 186},
  [602] = {.lex_state = 166},
  [603] = {.lex_state = 186},
  [604] = {.lex_state = 186},
  [605] = {.lex_state = 186},
  [606] = {.lex_state = 186},
  [607] = {.lex_state = 166},
  [608] = {.lex_state = 135},
  [609] = {.lex_state = 186},
  [610] = {.lex_state = 196},
  [611] = {.lex_state = 135},
  [612] = {.lex_state = 135},
  [613] = {.lex_state = 135},
  [614] = {.lex_state = 135},
  [615] = {.lex_state = 135},
  [616] = {.lex_state = 135},
  [617] = {.lex_state = 135},
  [618] = {.lex_state = 135},
  [619] = {.lex_state = 135},
  [620] = {.lex_state = 135},
  [621] = {.lex_state = 135},
  [622] = {.lex_state = 135},
  [623] = {.lex_state = 135},
  [624] = {.lex_state = 135},
  [625] = {.lex_state = 186},
  [626] = {.lex_state = 148},
  [627] = {.lex_state = 145},
  [628] = {.lex_state = 150},
  [629] = {.lex_state = 123},
  [630] = {.lex_state = 148},
  [631] = {.lex_state = 115},
  [632] = {.lex_state = 168},
  [633] = {.lex_state = 123},
  [634] = {.lex_state = 135},
  [635] = {.lex_state = 135},
  [636] = {.lex_state = 135},
  [637] = {.lex_state = 184},
  [638] = {.lex_state = 135},
  [639] = {.lex_state = 144},
  [640] = {.lex_state = 135},
  [641] = {.lex_state = 144},
  [642] = {.lex_state = 144},
  [643] = {.lex_state = 144},
  [644] = {.lex_state = 115},
  [645] = {.lex_state = 184},
  [646] = {.lex_state = 171},
  [647] = {.lex_state = 144},
  [648] = {.lex_state = 184},
  [649] = {.lex_state = 144},
  [650] = {.lex_state = 150},
  [651] = {.lex_state = 148},
  [652] = {.lex_state = 171},
  [653] = {.lex_state = 150},
  [654] = {.lex_state = 186},
  [655] = {.lex_state = 166},
  [656] = {.lex_state = 135},
  [657] = {.lex_state = 135},
  [658] = {.lex_state = 135},
  [659] = {.lex_state = 184},
  [660] = {.lex_state = 135},
  [661] = {.lex_state = 135},
  [662] = {.lex_state = 184},
  [663] = {.lex_state = 148},
  [664] = {.lex_state = 184},
  [665] = {.lex_state = 148},
  [666] = {.lex_state = 166},
  [667] = {.lex_state = 135},
  [668] = {.lex_state = 184},
  [669] = {.lex_state = 135},
  [670] = {.lex_state = 135},
  [671] = {.lex_state = 144},
  [672] = {.lex_state = 135},
  [673] = {.lex_state = 135},
  [674] = {.lex_state = 135},
  [675] = {.lex_state = 135},
  [676] = {.lex_state = 135},
  [677] = {.lex_state = 135},
  [678] = {.lex_state = 135},
  [679] = {.lex_state = 135},
  [680] = {.lex_state = 135},
  [681] = {.lex_state = 135},
  [682] = {.lex_state = 184},
  [683] = {.lex_state = 184},
  [684] = {.lex_state = 148},
  [685] = {.lex_state = 135},
  [686] = {.lex_state = 148},
  [687] = {.lex_state = 144},
  [688] = {.lex_state = 144},
  [689] = {.lex_state = 184},
  [690] = {.lex_state = 144},
  [691] = {.lex_state = 144},
  [692] = {.lex_state = 115},
  [693] = {.lex_state = 144},
  [694] = {.lex_state = 144},
  [695] = {.lex_state = 135},
  [696] = {.lex_state = 144},
  [697] = {.lex_state = 184},
  [698] = {.lex_state = 184},
  [699] = {.lex_state = 148},
  [700] = {.lex_state = 148},
  [701] = {.lex_state = 166},
  [702] = {.lex_state = 196},
  [703] = {.lex_state = 148},
  [704] = {.lex_state = 196},
  [705] = {.lex_state = 186},
  [706] = {.lex_state = 184},
  [707] = {.lex_state = 183},
  [708] = {.lex_state = 196},
  [709] = {.lex_state = 194},
  [710] = {.lex_state = 184},
  [711] = {.lex_state = 184},
  [712] = {.lex_state = 184},
  [713] = {.lex_state = 184},
  [714] = {.lex_state = 184},
  [715] = {.lex_state = 184},
  [716] = {.lex_state = 184},
  [717] = {.lex_state = 184},
  [718] = {.lex_state = 184},
  [719] = {.lex_state = 184},
  [720] = {.lex_state = 184},
  [721] = {.lex_state = 196},
  [722] = {.lex_state = 184},
  [723] = {.lex_state = 135},
  [724] = {.lex_state = 166},
  [725] = {.lex_state = 183},
  [726] = {.lex_state = 185},
  [727] = {.lex_state = 194},
  [728] = {.lex_state = 184},
  [729] = {.lex_state = 194},
  [730] = {.lex_state = 194},
  [731] = {.lex_state = 194},
  [732] = {.lex_state = 194},
  [733] = {.lex_state = 194},
  [734] = {.lex_state = 194},
  [735] = {.lex_state = 194},
  [736] = {.lex_state = 194},
  [737] = {.lex_state = 194},
  [738] = {.lex_state = 194},
  [739] = {.lex_state = 185},
  [740] = {.lex_state = 196},
  [741] = {.lex_state = 194},
  [742] = {.lex_state = 135},
  [743] = {.lex_state = 144},
  [744] = {.lex_state = 144},
  [745] = {.lex_state = 135},
  [746] = {.lex_state = 135},
  [747] = {.lex_state = 186},
  [748] = {.lex_state = 115},
  [749] = {.lex_state = 115},
  [750] = {.lex_state = 150},
  [751] = {.lex_state = 150},
  [752] = {.lex_state = 150},
  [753] = {.lex_state = 135},
  [754] = {.lex_state = 168},
  [755] = {.lex_state = 168},
  [756] = {.lex_state = 168},
  [757] = {.lex_state = 151},
  [758] = {.lex_state = 168},
  [759] = {.lex_state = 171},
  [760] = {.lex_state = 168},
  [761] = {.lex_state = 171},
  [762] = {.lex_state = 168},
  [763] = {.lex_state = 144},
  [764] = {.lex_state = 168},
  [765] = {.lex_state = 148},
  [766] = {.lex_state = 168},
  [767] = {.lex_state = 148},
  [768] = {.lex_state = 168},
  [769] = {.lex_state = 150},
  [770] = {.lex_state = 150},
  [771] = {.lex_state = 150},
  [772] = {.lex_state = 183},
  [773] = {.lex_state = 135},
  [774] = {.lex_state = 166},
  [775] = {.lex_state = 195},
  [776] = {.lex_state = 184},
  [777] = {.lex_state = 195},
  [778] = {.lex_state = 195},
  [779] = {.lex_state = 195},
  [780] = {.lex_state = 195},
  [781] = {.lex_state = 195},
  [782] = {.lex_state = 195},
  [783] = {.lex_state = 195},
  [784] = {.lex_state = 195},
  [785] = {.lex_state = 195},
  [786] = {.lex_state = 195},
  [787] = {.lex_state = 171},
  [788] = {.lex_state = 171},
  [789] = {.lex_state = 171},
  [790] = {.lex_state = 187},
  [791] = {.lex_state = 187},
  [792] = {.lex_state = 135},
  [793] = {.lex_state = 166},
  [794] = {.lex_state = 184},
  [795] = {.lex_state = 184},
  [796] = {.lex_state = 184},
  [797] = {.lex_state = 184},
  [798] = {.lex_state = 184},
  [799] = {.lex_state = 184},
  [800] = {.lex_state = 184},
  [801] = {.lex_state = 184},
  [802] = {.lex_state = 184},
  [803] = {.lex_state = 184},
  [804] = {.lex_state = 184},
  [805] = {.lex_state = 184},
  [806] = {.lex_state = 188},
  [807] = {.lex_state = 194},
  [808] = {.lex_state = 187},
  [809] = {.lex_state = 184},
  [810] = {.lex_state = 186},
  [811] = {.lex_state = 194},
  [812] = {.lex_state = 166},
  [813] = {.lex_state = 186},
  [814] = {.lex_state = 135},
  [815] = {.lex_state = 166},
  [816] = {.lex_state = 186},
  [817] = {.lex_state = 186},
  [818] = {.lex_state = 184},
  [819] = {.lex_state = 186},
  [820] = {.lex_state = 186},
  [821] = {.lex_state = 186},
  [822] = {.lex_state = 186},
  [823] = {.lex_state = 186},
  [824] = {.lex_state = 186},
  [825] = {.lex_state = 186},
  [826] = {.lex_state = 186},
  [827] = {.lex_state = 186},
  [828] = {.lex_state = 196},
  [829] = {.lex_state = 196},
  [830] = {.lex_state = 186},
  [831] = {.lex_state = 148},
  [832] = {.lex_state = 150},
  [833] = {.lex_state = 150},
  [834] = {.lex_state = 168},
  [835] = {.lex_state = 123},
  [836] = {.lex_state = 115},
  [837] = {.lex_state = 135},
  [838] = {.lex_state = 135},
  [839] = {.lex_state = 135},
  [840] = {.lex_state = 184},
  [841] = {.lex_state = 135},
  [842] = {.lex_state = 144},
  [843] = {.lex_state = 135},
  [844] = {.lex_state = 144},
  [845] = {.lex_state = 144},
  [846] = {.lex_state = 144},
  [847] = {.lex_state = 115},
  [848] = {.lex_state = 184},
  [849] = {.lex_state = 144},
  [850] = {.lex_state = 184},
  [851] = {.lex_state = 144},
  [852] = {.lex_state = 168},
  [853] = {.lex_state = 150},
  [854] = {.lex_state = 144},
  [855] = {.lex_state = 144},
  [856] = {.lex_state = 184},
  [857] = {.lex_state = 144},
  [858] = {.lex_state = 144},
  [859] = {.lex_state = 115},
  [860] = {.lex_state = 144},
  [861] = {.lex_state = 150},
  [862] = {.lex_state = 184},
  [863] = {.lex_state = 150},
  [864] = {.lex_state = 150},
  [865] = {.lex_state = 144},
  [866] = {.lex_state = 144},
  [867] = {.lex_state = 148},
  [868] = {.lex_state = 144},
  [869] = {.lex_state = 150},
  [870] = {.lex_state = 171},
  [871] = {.lex_state = 150},
  [872] = {.lex_state = 148},
  [873] = {.lex_state = 171},
  [874] = {.lex_state = 148},
  [875] = {.lex_state = 144},
  [876] = {.lex_state = 144},
  [877] = {.lex_state = 184},
  [878] = {.lex_state = 144},
  [879] = {.lex_state = 144},
  [880] = {.lex_state = 144},
  [881] = {.lex_state = 144},
  [882] = {.lex_state = 144},
  [883] = {.lex_state = 135},
  [884] = {.lex_state = 166},
  [885] = {.lex_state = 184},
  [886] = {.lex_state = 148},
  [887] = {.lex_state = 184},
  [888] = {.lex_state = 184},
  [889] = {.lex_state = 184},
  [890] = {.lex_state = 184},
  [891] = {.lex_state = 184},
  [892] = {.lex_state = 184},
  [893] = {.lex_state = 184},
  [894] = {.lex_state = 184},
  [895] = {.lex_state = 184},
  [896] = {.lex_state = 184},
  [897] = {.lex_state = 184},
  [898] = {.lex_state = 135},
  [899] = {.lex_state = 135},
  [900] = {.lex_state = 135},
  [901] = {.lex_state = 184},
  [902] = {.lex_state = 135},
  [903] = {.lex_state = 135},
  [904] = {.lex_state = 184},
  [905] = {.lex_state = 115},
  [906] = {.lex_state = 144},
  [907] = {.lex_state = 184},
  [908] = {.lex_state = 135},
  [909] = {.lex_state = 144},
  [910] = {.lex_state = 184},
  [911] = {.lex_state = 148},
  [912] = {.lex_state = 197},
  [913] = {.lex_state = 184},
  [914] = {.lex_state = 144},
  [915] = {.lex_state = 184},
  [916] = {.lex_state = 196},
  [917] = {.lex_state = 135},
  [918] = {.lex_state = 186},
  [919] = {.lex_state = 196},
  [920] = {.lex_state = 135},
  [921] = {.lex_state = 194},
  [922] = {.lex_state = 135},
  [923] = {.lex_state = 135},
  [924] = {.lex_state = 196},
  [925] = {.lex_state = 195},
  [926] = {.lex_state = 144},
  [927] = {.lex_state = 144},
  [928] = {.lex_state = 144},
  [929] = {.lex_state = 195},
  [930] = {.lex_state = 144},
  [931] = {.lex_state = 144},
  [932] = {.lex_state = 135},
  [933] = {.lex_state = 144},
  [934] = {.lex_state = 144},
  [935] = {.lex_state = 115},
  [936] = {.lex_state = 168},
  [937] = {.lex_state = 168},
  [938] = {.lex_state = 168},
  [939] = {.lex_state = 168},
  [940] = {.lex_state = 168},
  [941] = {.lex_state = 168},
  [942] = {.lex_state = 195},
  [943] = {.lex_state = 135},
  [944] = {.lex_state = 171},
  [945] = {.lex_state = 184},
  [946] = {.lex_state = 135},
  [947] = {.lex_state = 188},
  [948] = {.lex_state = 187},
  [949] = {.lex_state = 186},
  [950] = {.lex_state = 166},
  [951] = {.lex_state = 186},
  [952] = {.lex_state = 135},
  [953] = {.lex_state = 150},
  [954] = {.lex_state = 171},
  [955] = {.lex_state = 150},
  [956] = {.lex_state = 150},
  [957] = {.lex_state = 171},
  [958] = {.lex_state = 150},
  [959] = {.lex_state = 150},
  [960] = {.lex_state = 150},
  [961] = {.lex_state = 144},
  [962] = {.lex_state = 144},
  [963] = {.lex_state = 184},
  [964] = {.lex_state = 144},
  [965] = {.lex_state = 144},
  [966] = {.lex_state = 115},
  [967] = {.lex_state = 144},
  [968] = {.lex_state = 168},
  [969] = {.lex_state = 184},
  [970] = {.lex_state = 168},
  [971] = {.lex_state = 168},
  [972] = {.lex_state = 144},
  [973] = {.lex_state = 144},
  [974] = {.lex_state = 144},
  [975] = {.lex_state = 168},
  [976] = {.lex_state = 168},
  [977] = {.lex_state = 171},
  [978] = {.lex_state = 150},
  [979] = {.lex_state = 135},
  [980] = {.lex_state = 135},
  [981] = {.lex_state = 135},
  [982] = {.lex_state = 184},
  [983] = {.lex_state = 135},
  [984] = {.lex_state = 135},
  [985] = {.lex_state = 184},
  [986] = {.lex_state = 150},
  [987] = {.lex_state = 184},
  [988] = {.lex_state = 150},
  [989] = {.lex_state = 144},
  [990] = {.lex_state = 184},
  [991] = {.lex_state = 150},
  [992] = {.lex_state = 135},
  [993] = {.lex_state = 150},
  [994] = {.lex_state = 135},
  [995] = {.lex_state = 144},
  [996] = {.lex_state = 184},
  [997] = {.lex_state = 150},
  [998] = {.lex_state = 150},
  [999] = {.lex_state = 150},
  [1000] = {.lex_state = 148},
  [1001] = {.lex_state = 148},
  [1002] = {.lex_state = 148},
  [1003] = {.lex_state = 144},
  [1004] = {.lex_state = 184},
  [1005] = {.lex_state = 144},
  [1006] = {.lex_state = 184},
  [1007] = {.lex_state = 148},
  [1008] = {.lex_state = 184},
  [1009] = {.lex_state = 135},
  [1010] = {.lex_state = 144},
  [1011] = {.lex_state = 144},
  [1012] = {.lex_state = 184},
  [1013] = {.lex_state = 144},
  [1014] = {.lex_state = 144},
  [1015] = {.lex_state = 144},
  [1016] = {.lex_state = 144},
  [1017] = {.lex_state = 144},
  [1018] = {.lex_state = 135},
  [1019] = {.lex_state = 197},
  [1020] = {.lex_state = 184},
  [1021] = {.lex_state = 144},
  [1022] = {.lex_state = 144},
  [1023] = {.lex_state = 186},
  [1024] = {.lex_state = 197},
  [1025] = {.lex_state = 184},
  [1026] = {.lex_state = 186},
  [1027] = {.lex_state = 196},
  [1028] = {.lex_state = 186},
  [1029] = {.lex_state = 184},
  [1030] = {.lex_state = 194},
  [1031] = {.lex_state = 196},
  [1032] = {.lex_state = 135},
  [1033] = {.lex_state = 163},
  [1034] = {.lex_state = 135},
  [1035] = {.lex_state = 186},
  [1036] = {.lex_state = 144},
  [1037] = {.lex_state = 195},
  [1038] = {.lex_state = 184},
  [1039] = {.lex_state = 186},
  [1040] = {.lex_state = 150},
  [1041] = {.lex_state = 171},
  [1042] = {.lex_state = 150},
  [1043] = {.lex_state = 171},
  [1044] = {.lex_state = 168},
  [1045] = {.lex_state = 171},
  [1046] = {.lex_state = 150},
  [1047] = {.lex_state = 168},
  [1048] = {.lex_state = 171},
  [1049] = {.lex_state = 150},
  [1050] = {.lex_state = 135},
  [1051] = {.lex_state = 135},
  [1052] = {.lex_state = 135},
  [1053] = {.lex_state = 184},
  [1054] = {.lex_state = 135},
  [1055] = {.lex_state = 135},
  [1056] = {.lex_state = 184},
  [1057] = {.lex_state = 168},
  [1058] = {.lex_state = 184},
  [1059] = {.lex_state = 168},
  [1060] = {.lex_state = 144},
  [1061] = {.lex_state = 184},
  [1062] = {.lex_state = 168},
  [1063] = {.lex_state = 135},
  [1064] = {.lex_state = 168},
  [1065] = {.lex_state = 135},
  [1066] = {.lex_state = 144},
  [1067] = {.lex_state = 184},
  [1068] = {.lex_state = 168},
  [1069] = {.lex_state = 168},
  [1070] = {.lex_state = 168},
  [1071] = {.lex_state = 171},
  [1072] = {.lex_state = 144},
  [1073] = {.lex_state = 144},
  [1074] = {.lex_state = 184},
  [1075] = {.lex_state = 144},
  [1076] = {.lex_state = 144},
  [1077] = {.lex_state = 144},
  [1078] = {.lex_state = 144},
  [1079] = {.lex_state = 144},
  [1080] = {.lex_state = 150},
  [1081] = {.lex_state = 135},
  [1082] = {.lex_state = 150},
  [1083] = {.lex_state = 197},
  [1084] = {.lex_state = 184},
  [1085] = {.lex_state = 144},
  [1086] = {.lex_state = 144},
  [1087] = {.lex_state = 197},
  [1088] = {.lex_state = 184},
  [1089] = {.lex_state = 144},
  [1090] = {.lex_state = 184},
  [1091] = {.lex_state = 115},
  [1092] = {.lex_state = 144},
  [1093] = {.lex_state = 184},
  [1094] = {.lex_state = 144},
  [1095] = {.lex_state = 184},
  [1096] = {.lex_state = 144},
  [1097] = {.lex_state = 186},
  [1098] = {.lex_state = 197},
  [1099] = {.lex_state = 184},
  [1100] = {.lex_state = 148},
  [1101] = {.lex_state = 144},
  [1102] = {.lex_state = 186},
  [1103] = {.lex_state = 186},
  [1104] = {.lex_state = 197},
  [1105] = {.lex_state = 144},
  [1106] = {.lex_state = 144},
  [1107] = {.lex_state = 144},
  [1108] = {.lex_state = 135},
  [1109] = {.lex_state = 186},
  [1110] = {.lex_state = 150},
  [1111] = {.lex_state = 150},
  [1112] = {.lex_state = 168},
  [1113] = {.lex_state = 171},
  [1114] = {.lex_state = 168},
  [1115] = {.lex_state = 171},
  [1116] = {.lex_state = 144},
  [1117] = {.lex_state = 144},
  [1118] = {.lex_state = 184},
  [1119] = {.lex_state = 144},
  [1120] = {.lex_state = 144},
  [1121] = {.lex_state = 144},
  [1122] = {.lex_state = 144},
  [1123] = {.lex_state = 144},
  [1124] = {.lex_state = 168},
  [1125] = {.lex_state = 135},
  [1126] = {.lex_state = 168},
  [1127] = {.lex_state = 197},
  [1128] = {.lex_state = 184},
  [1129] = {.lex_state = 144},
  [1130] = {.lex_state = 150},
  [1131] = {.lex_state = 144},
  [1132] = {.lex_state = 184},
  [1133] = {.lex_state = 144},
  [1134] = {.lex_state = 184},
  [1135] = {.lex_state = 150},
  [1136] = {.lex_state = 186},
  [1137] = {.lex_state = 166},
  [1138] = {.lex_state = 144},
  [1139] = {.lex_state = 186},
  [1140] = {.lex_state = 197},
  [1141] = {.lex_state = 184},
  [1142] = {.lex_state = 144},
  [1143] = {.lex_state = 186},
  [1144] = {.lex_state = 197},
  [1145] = {.lex_state = 184},
  [1146] = {.lex_state = 144},
  [1147] = {.lex_state = 197},
  [1148] = {.lex_state = 184},
  [1149] = {.lex_state = 144},
  [1150] = {.lex_state = 144},
  [1151] = {.lex_state = 186},
  [1152] = {.lex_state = 186},
  [1153] = {.lex_state = 197},
  [1154] = {.lex_state = 148},
  [1155] = {.lex_state = 144},
  [1156] = {.lex_state = 186},
  [1157] = {.lex_state = 186},
  [1158] = {.lex_state = 135},
  [1159] = {.lex_state = 166},
  [1160] = {.lex_state = 150},
  [1161] = {.lex_state = 135},
  [1162] = {.lex_state = 144},
  [1163] = {.lex_state = 135},
  [1164] = {.lex_state = 168},
  [1165] = {.lex_state = 168},
  [1166] = {.lex_state = 168},
  [1167] = {.lex_state = 144},
  [1168] = {.lex_state = 184},
  [1169] = {.lex_state = 144},
  [1170] = {.lex_state = 184},
  [1171] = {.lex_state = 168},
  [1172] = {.lex_state = 186},
  [1173] = {.lex_state = 166},
  [1174] = {.lex_state = 144},
  [1175] = {.lex_state = 186},
  [1176] = {.lex_state = 197},
  [1177] = {.lex_state = 184},
  [1178] = {.lex_state = 144},
  [1179] = {.lex_state = 197},
  [1180] = {.lex_state = 184},
  [1181] = {.lex_state = 144},
  [1182] = {.lex_state = 150},
  [1183] = {.lex_state = 150},
  [1184] = {.lex_state = 144},
  [1185] = {.lex_state = 186},
  [1186] = {.lex_state = 186},
  [1187] = {.lex_state = 197},
  [1188] = {.lex_state = 144},
  [1189] = {.lex_state = 186},
  [1190] = {.lex_state = 186},
  [1191] = {.lex_state = 197},
  [1192] = {.lex_state = 144},
  [1193] = {.lex_state = 186},
  [1194] = {.lex_state = 197},
  [1195] = {.lex_state = 184},
  [1196] = {.lex_state = 144},
  [1197] = {.lex_state = 186},
  [1198] = {.lex_state = 186},
  [1199] = {.lex_state = 148},
  [1200] = {.lex_state = 144},
  [1201] = {.lex_state = 186},
  [1202] = {.lex_state = 144},
  [1203] = {.lex_state = 144},
  [1204] = {.lex_state = 144},
  [1205] = {.lex_state = 168},
  [1206] = {.lex_state = 135},
  [1207] = {.lex_state = 144},
  [1208] = {.lex_state = 197},
  [1209] = {.lex_state = 184},
  [1210] = {.lex_state = 144},
  [1211] = {.lex_state = 168},
  [1212] = {.lex_state = 168},
  [1213] = {.lex_state = 144},
  [1214] = {.lex_state = 186},
  [1215] = {.lex_state = 186},
  [1216] = {.lex_state = 197},
  [1217] = {.lex_state = 144},
  [1218] = {.lex_state = 186},
  [1219] = {.lex_state = 197},
  [1220] = {.lex_state = 184},
  [1221] = {.lex_state = 150},
  [1222] = {.lex_state = 144},
  [1223] = {.lex_state = 186},
  [1224] = {.lex_state = 186},
  [1225] = {.lex_state = 144},
  [1226] = {.lex_state = 186},
  [1227] = {.lex_state = 186},
  [1228] = {.lex_state = 144},
  [1229] = {.lex_state = 186},
  [1230] = {.lex_state = 186},
  [1231] = {.lex_state = 197},
  [1232] = {.lex_state = 144},
  [1233] = {.lex_state = 186},
  [1234] = {.lex_state = 148},
  [1235] = {.lex_state = 144},
  [1236] = {.lex_state = 163},
  [1237] = {.lex_state = 166},
  [1238] = {.lex_state = 144},
  [1239] = {.lex_state = 144},
  [1240] = {.lex_state = 186},
  [1241] = {.lex_state = 197},
  [1242] = {.lex_state = 184},
  [1243] = {.lex_state = 168},
  [1244] = {.lex_state = 144},
  [1245] = {.lex_state = 186},
  [1246] = {.lex_state = 186},
  [1247] = {.lex_state = 144},
  [1248] = {.lex_state = 186},
  [1249] = {.lex_state = 186},
  [1250] = {.lex_state = 197},
  [1251] = {.lex_state = 150},
  [1252] = {.lex_state = 144},
  [1253] = {.lex_state = 186},
  [1254] = {.lex_state = 144},
  [1255] = {.lex_state = 186},
  [1256] = {.lex_state = 144},
  [1257] = {.lex_state = 186},
  [1258] = {.lex_state = 186},
  [1259] = {.lex_state = 144},
  [1260] = {.lex_state = 148},
  [1261] = {.lex_state = 144},
  [1262] = {.lex_state = 166},
  [1263] = {.lex_state = 144},
  [1264] = {.lex_state = 186},
  [1265] = {.lex_state = 186},
  [1266] = {.lex_state = 197},
  [1267] = {.lex_state = 168},
  [1268] = {.lex_state = 144},
  [1269] = {.lex_state = 186},
  [1270] = {.lex_state = 144},
  [1271] = {.lex_state = 186},
  [1272] = {.lex_state = 186},
  [1273] = {.lex_state = 150},
  [1274] = {.lex_state = 144},
  [1275] = {.lex_state = 144},
  [1276] = {.lex_state = 144},
  [1277] = {.lex_state = 186},
  [1278] = {.lex_state = 150},
  [1279] = {.lex_state = 144},
  [1280] = {.lex_state = 144},
  [1281] = {.lex_state = 186},
  [1282] = {.lex_state = 186},
  [1283] = {.lex_state = 168},
  [1284] = {.lex_state = 144},
  [1285] = {.lex_state = 144},
  [1286] = {.lex_state = 186},
  [1287] = {.lex_state = 150},
  [1288] = {.lex_state = 144},
  [1289] = {.lex_state = 168},
  [1290] = {.lex_state = 144},
  [1291] = {.lex_state = 186},
  [1292] = {.lex_state = 168},
  [1293] = {.lex_state = 144},
  [1294] = {.lex_state = 144},
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_tensor] = ACTIONS(3),
    [anon_sym_format] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_indexvars] = ACTIONS(3),
    [anon_sym_dense] = ACTIONS(3),
    [anon_sym_sparse] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3),
    [sym_preproc_directive] = ACTIONS(3),
    [anon_sym_typedef] = ACTIONS(3),
    [anon_sym_extern] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(3),
    [anon_sym_auto] = ACTIONS(3),
    [anon_sym_register] = ACTIONS(3),
    [anon_sym_inline] = ACTIONS(3),
    [anon_sym_const] = ACTIONS(3),
    [anon_sym_restrict] = ACTIONS(3),
    [anon_sym_volatile] = ACTIONS(3),
    [anon_sym__Atomic] = ACTIONS(3),
    [anon_sym_unsigned] = ACTIONS(3),
    [anon_sym_long] = ACTIONS(3),
    [anon_sym_short] = ACTIONS(3),
    [sym_primitive_type] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(3),
    [anon_sym_struct] = ACTIONS(3),
    [anon_sym_union] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_switch] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_default] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(3),
    [anon_sym_continue] = ACTIONS(3),
    [anon_sym_goto] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_true] = ACTIONS(3),
    [sym_false] = ACTIONS(3),
    [sym_null] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_comment] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(17),
    [sym_ta_top_level] = STATE(20),
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(18),
    [sym_linkage_specification] = STATE(20),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_tensor] = ACTIONS(7),
    [anon_sym_indexvars] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(17),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [2] = {
    [anon_sym_format] = ACTIONS(43),
    [sym_comment] = ACTIONS(41),
  },
  [3] = {
    [sym_ta_name_list] = STATE(25),
    [sym_identifier] = ACTIONS(45),
    [sym_comment] = ACTIONS(41),
  },
  [4] = {
    [sym_string_literal] = STATE(27),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_system_lib_string] = ACTIONS(49),
    [sym_comment] = ACTIONS(41),
  },
  [5] = {
    [sym_identifier] = ACTIONS(51),
    [sym_comment] = ACTIONS(41),
  },
  [6] = {
    [sym_preproc_arg] = ACTIONS(53),
    [sym_comment] = ACTIONS(55),
  },
  [7] = {
    [sym_identifier] = ACTIONS(57),
    [sym_comment] = ACTIONS(41),
  },
  [8] = {
    [anon_sym_LF] = ACTIONS(59),
    [sym_preproc_arg] = ACTIONS(61),
    [sym_comment] = ACTIONS(55),
  },
  [9] = {
    [sym_type_qualifier] = STATE(34),
    [sym__type_specifier] = STATE(33),
    [sym_sized_type_specifier] = STATE(33),
    [sym_enum_specifier] = STATE(33),
    [sym_struct_specifier] = STATE(33),
    [sym_union_specifier] = STATE(33),
    [sym_macro_type_specifier] = STATE(33),
    [aux_sym_type_definition_repeat1] = STATE(34),
    [aux_sym_sized_type_specifier_repeat1] = STATE(35),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(63),
    [anon_sym_long] = ACTIONS(63),
    [anon_sym_short] = ACTIONS(63),
    [sym_primitive_type] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [10] = {
    [sym_string_literal] = STATE(36),
    [anon_sym_extern] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(67),
    [anon_sym_auto] = ACTIONS(67),
    [anon_sym_register] = ACTIONS(67),
    [anon_sym_inline] = ACTIONS(67),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym_unsigned] = ACTIONS(67),
    [anon_sym_long] = ACTIONS(67),
    [anon_sym_short] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_identifier] = ACTIONS(67),
    [sym_comment] = ACTIONS(41),
  },
  [11] = {
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_RPAREN] = ACTIONS(69),
    [anon_sym_SEMI] = ACTIONS(69),
    [anon_sym_COMMA] = ACTIONS(69),
    [anon_sym_extern] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_RBRACK] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(67),
    [anon_sym_auto] = ACTIONS(67),
    [anon_sym_register] = ACTIONS(67),
    [anon_sym_inline] = ACTIONS(67),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym_unsigned] = ACTIONS(67),
    [anon_sym_long] = ACTIONS(67),
    [anon_sym_short] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(67),
    [anon_sym_COLON] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(69),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_DASH_DASH] = ACTIONS(69),
    [anon_sym_PLUS_PLUS] = ACTIONS(69),
    [anon_sym_sizeof] = ACTIONS(67),
    [sym_number_literal] = ACTIONS(69),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_true] = ACTIONS(67),
    [sym_false] = ACTIONS(67),
    [sym_null] = ACTIONS(67),
    [sym_identifier] = ACTIONS(67),
    [sym_comment] = ACTIONS(41),
  },
  [12] = {
    [anon_sym_LPAREN] = ACTIONS(71),
    [anon_sym_RPAREN] = ACTIONS(71),
    [anon_sym_SEMI] = ACTIONS(71),
    [anon_sym_COMMA] = ACTIONS(71),
    [anon_sym_extern] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_RBRACK] = ACTIONS(71),
    [anon_sym_static] = ACTIONS(73),
    [anon_sym_auto] = ACTIONS(73),
    [anon_sym_register] = ACTIONS(73),
    [anon_sym_inline] = ACTIONS(73),
    [anon_sym_const] = ACTIONS(73),
    [anon_sym_restrict] = ACTIONS(73),
    [anon_sym_volatile] = ACTIONS(73),
    [anon_sym__Atomic] = ACTIONS(73),
    [anon_sym_unsigned] = ACTIONS(73),
    [anon_sym_long] = ACTIONS(73),
    [anon_sym_short] = ACTIONS(73),
    [sym_primitive_type] = ACTIONS(73),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(73),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_sizeof] = ACTIONS(73),
    [sym_number_literal] = ACTIONS(71),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_null] = ACTIONS(73),
    [sym_identifier] = ACTIONS(73),
    [sym_comment] = ACTIONS(41),
  },
  [13] = {
    [sym_enumerator_list] = STATE(39),
    [anon_sym_LBRACE] = ACTIONS(75),
    [sym_identifier] = ACTIONS(77),
    [sym_comment] = ACTIONS(41),
  },
  [14] = {
    [sym_field_declaration_list] = STATE(42),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_identifier] = ACTIONS(81),
    [sym_comment] = ACTIONS(41),
  },
  [15] = {
    [sym_field_declaration_list] = STATE(44),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_identifier] = ACTIONS(83),
    [sym_comment] = ACTIONS(41),
  },
  [16] = {
    [anon_sym_LPAREN] = ACTIONS(85),
    [anon_sym_RPAREN] = ACTIONS(88),
    [anon_sym_SEMI] = ACTIONS(88),
    [anon_sym_COMMA] = ACTIONS(88),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(88),
    [anon_sym_LBRACK] = ACTIONS(88),
    [anon_sym_RBRACK] = ACTIONS(88),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(88),
    [anon_sym_AMP] = ACTIONS(88),
    [anon_sym_BANG] = ACTIONS(88),
    [anon_sym_TILDE] = ACTIONS(88),
    [anon_sym_PLUS] = ACTIONS(90),
    [anon_sym_DASH] = ACTIONS(90),
    [anon_sym_DASH_DASH] = ACTIONS(88),
    [anon_sym_PLUS_PLUS] = ACTIONS(88),
    [anon_sym_sizeof] = ACTIONS(90),
    [sym_number_literal] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(88),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [sym_true] = ACTIONS(90),
    [sym_false] = ACTIONS(90),
    [sym_null] = ACTIONS(90),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [17] = {
    [ts_builtin_sym_end] = ACTIONS(92),
    [sym_comment] = ACTIONS(41),
  },
  [18] = {
    [sym__declarator] = STATE(49),
    [sym_pointer_declarator] = STATE(49),
    [sym_function_declarator] = STATE(49),
    [sym_array_declarator] = STATE(49),
    [sym_init_declarator] = STATE(50),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_SEMI] = ACTIONS(96),
    [anon_sym_STAR] = ACTIONS(98),
    [sym_identifier] = ACTIONS(100),
    [sym_comment] = ACTIONS(41),
  },
  [19] = {
    [sym_storage_class_specifier] = STATE(51),
    [sym_type_qualifier] = STATE(51),
    [aux_sym__declaration_specifiers_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(102),
    [anon_sym_SEMI] = ACTIONS(102),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(102),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(104),
    [sym_comment] = ACTIONS(41),
  },
  [20] = {
    [sym_ta_top_level] = STATE(52),
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_specifiers] = STATE(18),
    [sym_linkage_specification] = STATE(52),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(52),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [ts_builtin_sym_end] = ACTIONS(106),
    [anon_sym_tensor] = ACTIONS(7),
    [anon_sym_indexvars] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(17),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [21] = {
    [sym_storage_class_specifier] = STATE(54),
    [sym_type_qualifier] = STATE(54),
    [sym__type_specifier] = STATE(53),
    [sym_sized_type_specifier] = STATE(53),
    [sym_enum_specifier] = STATE(53),
    [sym_struct_specifier] = STATE(53),
    [sym_union_specifier] = STATE(53),
    [sym_macro_type_specifier] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(54),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(108),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [22] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(57),
    [anon_sym_LPAREN] = ACTIONS(110),
    [anon_sym_SEMI] = ACTIONS(110),
    [anon_sym_extern] = ACTIONS(112),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_static] = ACTIONS(112),
    [anon_sym_auto] = ACTIONS(112),
    [anon_sym_register] = ACTIONS(112),
    [anon_sym_inline] = ACTIONS(112),
    [anon_sym_const] = ACTIONS(112),
    [anon_sym_restrict] = ACTIONS(112),
    [anon_sym_volatile] = ACTIONS(112),
    [anon_sym__Atomic] = ACTIONS(112),
    [anon_sym_unsigned] = ACTIONS(114),
    [anon_sym_long] = ACTIONS(114),
    [anon_sym_short] = ACTIONS(114),
    [sym_primitive_type] = ACTIONS(116),
    [sym_identifier] = ACTIONS(118),
    [sym_comment] = ACTIONS(41),
  },
  [23] = {
    [sym_identifier] = ACTIONS(121),
    [sym_comment] = ACTIONS(41),
  },
  [24] = {
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_COMMA] = ACTIONS(125),
    [sym_comment] = ACTIONS(41),
  },
  [25] = {
    [anon_sym_SEMI] = ACTIONS(127),
    [sym_comment] = ACTIONS(41),
  },
  [26] = {
    [aux_sym_string_literal_repeat1] = STATE(62),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(131),
    [sym_escape_sequence] = ACTIONS(131),
    [sym_comment] = ACTIONS(55),
  },
  [27] = {
    [ts_builtin_sym_end] = ACTIONS(133),
    [anon_sym_tensor] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_indexvars] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(135),
    [sym_preproc_directive] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(135),
    [anon_sym_extern] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(135),
    [anon_sym_auto] = ACTIONS(135),
    [anon_sym_register] = ACTIONS(135),
    [anon_sym_inline] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(135),
    [anon_sym_restrict] = ACTIONS(135),
    [anon_sym_volatile] = ACTIONS(135),
    [anon_sym__Atomic] = ACTIONS(135),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(135),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_union] = ACTIONS(135),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(135),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(135),
    [anon_sym_for] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(135),
    [anon_sym_goto] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(133),
    [anon_sym_sizeof] = ACTIONS(135),
    [sym_number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(133),
    [anon_sym_DQUOTE] = ACTIONS(133),
    [sym_true] = ACTIONS(135),
    [sym_false] = ACTIONS(135),
    [sym_null] = ACTIONS(135),
    [sym_identifier] = ACTIONS(135),
    [sym_comment] = ACTIONS(41),
  },
  [28] = {
    [sym_preproc_params] = STATE(66),
    [anon_sym_LF] = ACTIONS(137),
    [anon_sym_LPAREN2] = ACTIONS(139),
    [sym_preproc_arg] = ACTIONS(141),
    [sym_comment] = ACTIONS(55),
  },
  [29] = {
    [sym_ta_top_level] = STATE(81),
    [sym_preproc_include] = STATE(81),
    [sym_preproc_def] = STATE(81),
    [sym_preproc_function_def] = STATE(81),
    [sym_preproc_call] = STATE(81),
    [sym_preproc_if] = STATE(81),
    [sym_preproc_ifdef] = STATE(81),
    [sym_preproc_else] = STATE(79),
    [sym_preproc_elif] = STATE(79),
    [sym_function_definition] = STATE(81),
    [sym_declaration] = STATE(81),
    [sym_type_definition] = STATE(81),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(81),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(81),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(153),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [30] = {
    [sym_ta_top_level] = STATE(84),
    [sym_preproc_include] = STATE(84),
    [sym_preproc_def] = STATE(84),
    [sym_preproc_function_def] = STATE(84),
    [sym_preproc_call] = STATE(84),
    [sym_preproc_if] = STATE(84),
    [sym_preproc_ifdef] = STATE(84),
    [sym_preproc_else] = STATE(83),
    [sym_preproc_elif] = STATE(83),
    [sym_function_definition] = STATE(84),
    [sym_declaration] = STATE(84),
    [sym_type_definition] = STATE(84),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(84),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(84),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(84),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(167),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [31] = {
    [ts_builtin_sym_end] = ACTIONS(169),
    [anon_sym_tensor] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_RBRACE] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_indexvars] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(171),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(171),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_static] = ACTIONS(171),
    [anon_sym_auto] = ACTIONS(171),
    [anon_sym_register] = ACTIONS(171),
    [anon_sym_inline] = ACTIONS(171),
    [anon_sym_const] = ACTIONS(171),
    [anon_sym_restrict] = ACTIONS(171),
    [anon_sym_volatile] = ACTIONS(171),
    [anon_sym__Atomic] = ACTIONS(171),
    [anon_sym_unsigned] = ACTIONS(171),
    [anon_sym_long] = ACTIONS(171),
    [anon_sym_short] = ACTIONS(171),
    [sym_primitive_type] = ACTIONS(171),
    [anon_sym_enum] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(171),
    [anon_sym_union] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(171),
    [anon_sym_switch] = ACTIONS(171),
    [anon_sym_case] = ACTIONS(171),
    [anon_sym_default] = ACTIONS(171),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_for] = ACTIONS(171),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(171),
    [anon_sym_continue] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(171),
    [anon_sym_DASH] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(169),
    [anon_sym_sizeof] = ACTIONS(171),
    [sym_number_literal] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(169),
    [sym_true] = ACTIONS(171),
    [sym_false] = ACTIONS(171),
    [sym_null] = ACTIONS(171),
    [sym_identifier] = ACTIONS(171),
    [sym_comment] = ACTIONS(41),
  },
  [32] = {
    [anon_sym_LF] = ACTIONS(173),
    [sym_comment] = ACTIONS(55),
  },
  [33] = {
    [sym__type_declarator] = STATE(89),
    [sym_pointer_type_declarator] = STATE(89),
    [sym_function_type_declarator] = STATE(89),
    [sym_array_type_declarator] = STATE(89),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(177),
    [sym_identifier] = ACTIONS(179),
    [sym_comment] = ACTIONS(41),
  },
  [34] = {
    [sym_type_qualifier] = STATE(91),
    [sym__type_specifier] = STATE(90),
    [sym_sized_type_specifier] = STATE(90),
    [sym_enum_specifier] = STATE(90),
    [sym_struct_specifier] = STATE(90),
    [sym_union_specifier] = STATE(90),
    [sym_macro_type_specifier] = STATE(90),
    [aux_sym_type_definition_repeat1] = STATE(91),
    [aux_sym_sized_type_specifier_repeat1] = STATE(35),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(63),
    [anon_sym_long] = ACTIONS(63),
    [anon_sym_short] = ACTIONS(63),
    [sym_primitive_type] = ACTIONS(181),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [35] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(92),
    [anon_sym_LPAREN] = ACTIONS(110),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_unsigned] = ACTIONS(183),
    [anon_sym_long] = ACTIONS(183),
    [anon_sym_short] = ACTIONS(183),
    [sym_primitive_type] = ACTIONS(116),
    [sym_identifier] = ACTIONS(118),
    [sym_comment] = ACTIONS(41),
  },
  [36] = {
    [sym_function_definition] = STATE(94),
    [sym_declaration] = STATE(94),
    [sym__declaration_specifiers] = STATE(95),
    [sym_declaration_list] = STATE(94),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [37] = {
    [sym_enumerator] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(191),
    [anon_sym_COMMA] = ACTIONS(193),
    [sym_identifier] = ACTIONS(195),
    [sym_comment] = ACTIONS(41),
  },
  [38] = {
    [sym_enumerator_list] = STATE(103),
    [anon_sym_LPAREN] = ACTIONS(197),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_RPAREN] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(197),
    [anon_sym_COMMA] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(199),
    [anon_sym_auto] = ACTIONS(199),
    [anon_sym_register] = ACTIONS(199),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym_const] = ACTIONS(199),
    [anon_sym_restrict] = ACTIONS(199),
    [anon_sym_volatile] = ACTIONS(199),
    [anon_sym__Atomic] = ACTIONS(199),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(197),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_DASH] = ACTIONS(197),
    [anon_sym_PLUS_PLUS] = ACTIONS(197),
    [anon_sym_sizeof] = ACTIONS(199),
    [sym_number_literal] = ACTIONS(197),
    [anon_sym_SQUOTE] = ACTIONS(197),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [sym_true] = ACTIONS(199),
    [sym_false] = ACTIONS(199),
    [sym_null] = ACTIONS(199),
    [sym_identifier] = ACTIONS(199),
    [sym_comment] = ACTIONS(41),
  },
  [39] = {
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_RPAREN] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(201),
    [anon_sym_COMMA] = ACTIONS(201),
    [anon_sym_extern] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(201),
    [anon_sym_RBRACK] = ACTIONS(201),
    [anon_sym_static] = ACTIONS(203),
    [anon_sym_auto] = ACTIONS(203),
    [anon_sym_register] = ACTIONS(203),
    [anon_sym_inline] = ACTIONS(203),
    [anon_sym_const] = ACTIONS(203),
    [anon_sym_restrict] = ACTIONS(203),
    [anon_sym_volatile] = ACTIONS(203),
    [anon_sym__Atomic] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(201),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(203),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_sizeof] = ACTIONS(203),
    [sym_number_literal] = ACTIONS(201),
    [anon_sym_SQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(201),
    [sym_true] = ACTIONS(203),
    [sym_false] = ACTIONS(203),
    [sym_null] = ACTIONS(203),
    [sym_identifier] = ACTIONS(203),
    [sym_comment] = ACTIONS(41),
  },
  [40] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(109),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(109),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(109),
    [sym_field_declaration] = STATE(109),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(109),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [anon_sym_RBRACE] = ACTIONS(205),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(207),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [41] = {
    [sym_field_declaration_list] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(215),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_SEMI] = ACTIONS(215),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_extern] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(215),
    [anon_sym_RBRACK] = ACTIONS(215),
    [anon_sym_static] = ACTIONS(217),
    [anon_sym_auto] = ACTIONS(217),
    [anon_sym_register] = ACTIONS(217),
    [anon_sym_inline] = ACTIONS(217),
    [anon_sym_const] = ACTIONS(217),
    [anon_sym_restrict] = ACTIONS(217),
    [anon_sym_volatile] = ACTIONS(217),
    [anon_sym__Atomic] = ACTIONS(217),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(217),
    [anon_sym_DASH_DASH] = ACTIONS(215),
    [anon_sym_PLUS_PLUS] = ACTIONS(215),
    [anon_sym_sizeof] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_identifier] = ACTIONS(217),
    [sym_comment] = ACTIONS(41),
  },
  [42] = {
    [anon_sym_LPAREN] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(219),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_COMMA] = ACTIONS(219),
    [anon_sym_extern] = ACTIONS(221),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_LBRACK] = ACTIONS(219),
    [anon_sym_RBRACK] = ACTIONS(219),
    [anon_sym_static] = ACTIONS(221),
    [anon_sym_auto] = ACTIONS(221),
    [anon_sym_register] = ACTIONS(221),
    [anon_sym_inline] = ACTIONS(221),
    [anon_sym_const] = ACTIONS(221),
    [anon_sym_restrict] = ACTIONS(221),
    [anon_sym_volatile] = ACTIONS(221),
    [anon_sym__Atomic] = ACTIONS(221),
    [anon_sym_COLON] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_DASH_DASH] = ACTIONS(219),
    [anon_sym_PLUS_PLUS] = ACTIONS(219),
    [anon_sym_sizeof] = ACTIONS(221),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_SQUOTE] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [sym_null] = ACTIONS(221),
    [sym_identifier] = ACTIONS(221),
    [sym_comment] = ACTIONS(41),
  },
  [43] = {
    [sym_field_declaration_list] = STATE(113),
    [anon_sym_LPAREN] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_RPAREN] = ACTIONS(223),
    [anon_sym_SEMI] = ACTIONS(223),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_STAR] = ACTIONS(223),
    [anon_sym_LBRACK] = ACTIONS(223),
    [anon_sym_RBRACK] = ACTIONS(223),
    [anon_sym_static] = ACTIONS(225),
    [anon_sym_auto] = ACTIONS(225),
    [anon_sym_register] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(225),
    [anon_sym_const] = ACTIONS(225),
    [anon_sym_restrict] = ACTIONS(225),
    [anon_sym_volatile] = ACTIONS(225),
    [anon_sym__Atomic] = ACTIONS(225),
    [anon_sym_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(223),
    [anon_sym_BANG] = ACTIONS(223),
    [anon_sym_TILDE] = ACTIONS(223),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_sizeof] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(223),
    [anon_sym_SQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_true] = ACTIONS(225),
    [sym_false] = ACTIONS(225),
    [sym_null] = ACTIONS(225),
    [sym_identifier] = ACTIONS(225),
    [sym_comment] = ACTIONS(41),
  },
  [44] = {
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(227),
    [anon_sym_SEMI] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_extern] = ACTIONS(229),
    [anon_sym_STAR] = ACTIONS(227),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_RBRACK] = ACTIONS(227),
    [anon_sym_static] = ACTIONS(229),
    [anon_sym_auto] = ACTIONS(229),
    [anon_sym_register] = ACTIONS(229),
    [anon_sym_inline] = ACTIONS(229),
    [anon_sym_const] = ACTIONS(229),
    [anon_sym_restrict] = ACTIONS(229),
    [anon_sym_volatile] = ACTIONS(229),
    [anon_sym__Atomic] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_DASH_DASH] = ACTIONS(227),
    [anon_sym_PLUS_PLUS] = ACTIONS(227),
    [anon_sym_sizeof] = ACTIONS(229),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [sym_null] = ACTIONS(229),
    [sym_identifier] = ACTIONS(229),
    [sym_comment] = ACTIONS(41),
  },
  [45] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym_type_descriptor] = STATE(115),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [46] = {
    [sym__declarator] = STATE(119),
    [sym_pointer_declarator] = STATE(119),
    [sym_function_declarator] = STATE(119),
    [sym_array_declarator] = STATE(119),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(235),
    [sym_identifier] = ACTIONS(237),
    [sym_comment] = ACTIONS(41),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(239),
    [anon_sym_tensor] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_RBRACE] = ACTIONS(239),
    [anon_sym_SEMI] = ACTIONS(239),
    [anon_sym_indexvars] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(241),
    [sym_preproc_directive] = ACTIONS(241),
    [anon_sym_typedef] = ACTIONS(241),
    [anon_sym_extern] = ACTIONS(241),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_static] = ACTIONS(241),
    [anon_sym_auto] = ACTIONS(241),
    [anon_sym_register] = ACTIONS(241),
    [anon_sym_inline] = ACTIONS(241),
    [anon_sym_const] = ACTIONS(241),
    [anon_sym_restrict] = ACTIONS(241),
    [anon_sym_volatile] = ACTIONS(241),
    [anon_sym__Atomic] = ACTIONS(241),
    [anon_sym_unsigned] = ACTIONS(241),
    [anon_sym_long] = ACTIONS(241),
    [anon_sym_short] = ACTIONS(241),
    [sym_primitive_type] = ACTIONS(241),
    [anon_sym_enum] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(241),
    [anon_sym_union] = ACTIONS(241),
    [anon_sym_if] = ACTIONS(241),
    [anon_sym_switch] = ACTIONS(241),
    [anon_sym_case] = ACTIONS(241),
    [anon_sym_default] = ACTIONS(241),
    [anon_sym_while] = ACTIONS(241),
    [anon_sym_do] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(241),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_break] = ACTIONS(241),
    [anon_sym_continue] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_BANG] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(239),
    [anon_sym_PLUS_PLUS] = ACTIONS(239),
    [anon_sym_sizeof] = ACTIONS(241),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(241),
    [sym_comment] = ACTIONS(41),
  },
  [48] = {
    [sym__declarator] = STATE(120),
    [sym_pointer_declarator] = STATE(120),
    [sym_function_declarator] = STATE(120),
    [sym_array_declarator] = STATE(120),
    [sym_type_qualifier] = STATE(121),
    [aux_sym_type_definition_repeat1] = STATE(121),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(98),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(243),
    [sym_comment] = ACTIONS(41),
  },
  [49] = {
    [sym_compound_statement] = STATE(128),
    [sym_parameter_list] = STATE(129),
    [aux_sym_declaration_repeat1] = STATE(130),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_COMMA] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(255),
    [sym_comment] = ACTIONS(41),
  },
  [50] = {
    [aux_sym_declaration_repeat1] = STATE(130),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_COMMA] = ACTIONS(251),
    [sym_comment] = ACTIONS(41),
  },
  [51] = {
    [sym_storage_class_specifier] = STATE(131),
    [sym_type_qualifier] = STATE(131),
    [aux_sym__declaration_specifiers_repeat1] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_SEMI] = ACTIONS(257),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(41),
  },
  [52] = {
    [sym_ta_top_level] = STATE(52),
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_specifiers] = STATE(18),
    [sym_linkage_specification] = STATE(52),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(52),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [ts_builtin_sym_end] = ACTIONS(261),
    [anon_sym_tensor] = ACTIONS(263),
    [anon_sym_indexvars] = ACTIONS(266),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(272),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(278),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(278),
    [sym_preproc_directive] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(284),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym_static] = ACTIONS(290),
    [anon_sym_auto] = ACTIONS(290),
    [anon_sym_register] = ACTIONS(290),
    [anon_sym_inline] = ACTIONS(290),
    [anon_sym_const] = ACTIONS(293),
    [anon_sym_restrict] = ACTIONS(293),
    [anon_sym_volatile] = ACTIONS(293),
    [anon_sym__Atomic] = ACTIONS(293),
    [anon_sym_unsigned] = ACTIONS(296),
    [anon_sym_long] = ACTIONS(296),
    [anon_sym_short] = ACTIONS(296),
    [sym_primitive_type] = ACTIONS(299),
    [anon_sym_enum] = ACTIONS(302),
    [anon_sym_struct] = ACTIONS(305),
    [anon_sym_union] = ACTIONS(308),
    [sym_identifier] = ACTIONS(311),
    [sym_comment] = ACTIONS(41),
  },
  [53] = {
    [sym_storage_class_specifier] = STATE(132),
    [sym_type_qualifier] = STATE(132),
    [aux_sym__declaration_specifiers_repeat1] = STATE(132),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_SEMI] = ACTIONS(257),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(41),
  },
  [54] = {
    [sym_storage_class_specifier] = STATE(54),
    [sym_type_qualifier] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(54),
    [anon_sym_extern] = ACTIONS(314),
    [anon_sym_static] = ACTIONS(314),
    [anon_sym_auto] = ACTIONS(314),
    [anon_sym_register] = ACTIONS(314),
    [anon_sym_inline] = ACTIONS(314),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [anon_sym_unsigned] = ACTIONS(320),
    [anon_sym_long] = ACTIONS(320),
    [anon_sym_short] = ACTIONS(320),
    [sym_primitive_type] = ACTIONS(320),
    [anon_sym_enum] = ACTIONS(320),
    [anon_sym_struct] = ACTIONS(320),
    [anon_sym_union] = ACTIONS(320),
    [sym_identifier] = ACTIONS(320),
    [sym_comment] = ACTIONS(41),
  },
  [55] = {
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(322),
    [anon_sym_SEMI] = ACTIONS(322),
    [anon_sym_COMMA] = ACTIONS(322),
    [anon_sym_extern] = ACTIONS(324),
    [anon_sym_STAR] = ACTIONS(322),
    [anon_sym_LBRACK] = ACTIONS(322),
    [anon_sym_RBRACK] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_auto] = ACTIONS(324),
    [anon_sym_register] = ACTIONS(324),
    [anon_sym_inline] = ACTIONS(324),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_restrict] = ACTIONS(324),
    [anon_sym_volatile] = ACTIONS(324),
    [anon_sym__Atomic] = ACTIONS(324),
    [anon_sym_COLON] = ACTIONS(322),
    [anon_sym_AMP] = ACTIONS(322),
    [anon_sym_BANG] = ACTIONS(322),
    [anon_sym_TILDE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_DASH] = ACTIONS(324),
    [anon_sym_DASH_DASH] = ACTIONS(322),
    [anon_sym_PLUS_PLUS] = ACTIONS(322),
    [anon_sym_sizeof] = ACTIONS(324),
    [sym_number_literal] = ACTIONS(322),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_DQUOTE] = ACTIONS(322),
    [sym_true] = ACTIONS(324),
    [sym_false] = ACTIONS(324),
    [sym_null] = ACTIONS(324),
    [sym_identifier] = ACTIONS(324),
    [sym_comment] = ACTIONS(41),
  },
  [56] = {
    [anon_sym_LPAREN] = ACTIONS(326),
    [anon_sym_RPAREN] = ACTIONS(326),
    [anon_sym_SEMI] = ACTIONS(326),
    [anon_sym_COMMA] = ACTIONS(326),
    [anon_sym_extern] = ACTIONS(328),
    [anon_sym_STAR] = ACTIONS(326),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_RBRACK] = ACTIONS(326),
    [anon_sym_static] = ACTIONS(328),
    [anon_sym_auto] = ACTIONS(328),
    [anon_sym_register] = ACTIONS(328),
    [anon_sym_inline] = ACTIONS(328),
    [anon_sym_const] = ACTIONS(328),
    [anon_sym_restrict] = ACTIONS(328),
    [anon_sym_volatile] = ACTIONS(328),
    [anon_sym__Atomic] = ACTIONS(328),
    [anon_sym_COLON] = ACTIONS(326),
    [anon_sym_AMP] = ACTIONS(326),
    [anon_sym_BANG] = ACTIONS(326),
    [anon_sym_TILDE] = ACTIONS(326),
    [anon_sym_PLUS] = ACTIONS(328),
    [anon_sym_DASH] = ACTIONS(328),
    [anon_sym_DASH_DASH] = ACTIONS(326),
    [anon_sym_PLUS_PLUS] = ACTIONS(326),
    [anon_sym_sizeof] = ACTIONS(328),
    [sym_number_literal] = ACTIONS(326),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_DQUOTE] = ACTIONS(326),
    [sym_true] = ACTIONS(328),
    [sym_false] = ACTIONS(328),
    [sym_null] = ACTIONS(328),
    [sym_identifier] = ACTIONS(328),
    [sym_comment] = ACTIONS(41),
  },
  [57] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(57),
    [anon_sym_LPAREN] = ACTIONS(330),
    [anon_sym_SEMI] = ACTIONS(330),
    [anon_sym_extern] = ACTIONS(332),
    [anon_sym_STAR] = ACTIONS(330),
    [anon_sym_static] = ACTIONS(332),
    [anon_sym_auto] = ACTIONS(332),
    [anon_sym_register] = ACTIONS(332),
    [anon_sym_inline] = ACTIONS(332),
    [anon_sym_const] = ACTIONS(332),
    [anon_sym_restrict] = ACTIONS(332),
    [anon_sym_volatile] = ACTIONS(332),
    [anon_sym__Atomic] = ACTIONS(332),
    [anon_sym_unsigned] = ACTIONS(334),
    [anon_sym_long] = ACTIONS(334),
    [anon_sym_short] = ACTIONS(334),
    [sym_primitive_type] = ACTIONS(332),
    [sym_identifier] = ACTIONS(332),
    [sym_comment] = ACTIONS(41),
  },
  [58] = {
    [anon_sym_LPAREN] = ACTIONS(337),
    [sym_comment] = ACTIONS(41),
  },
  [59] = {
    [sym_ta_name_list] = STATE(134),
    [sym_identifier] = ACTIONS(45),
    [sym_comment] = ACTIONS(41),
  },
  [60] = {
    [ts_builtin_sym_end] = ACTIONS(339),
    [anon_sym_tensor] = ACTIONS(341),
    [anon_sym_RBRACE] = ACTIONS(339),
    [anon_sym_indexvars] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(341),
    [sym_preproc_directive] = ACTIONS(341),
    [anon_sym_typedef] = ACTIONS(341),
    [anon_sym_extern] = ACTIONS(341),
    [anon_sym_static] = ACTIONS(341),
    [anon_sym_auto] = ACTIONS(341),
    [anon_sym_register] = ACTIONS(341),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_const] = ACTIONS(341),
    [anon_sym_restrict] = ACTIONS(341),
    [anon_sym_volatile] = ACTIONS(341),
    [anon_sym__Atomic] = ACTIONS(341),
    [anon_sym_unsigned] = ACTIONS(341),
    [anon_sym_long] = ACTIONS(341),
    [anon_sym_short] = ACTIONS(341),
    [sym_primitive_type] = ACTIONS(341),
    [anon_sym_enum] = ACTIONS(341),
    [anon_sym_struct] = ACTIONS(341),
    [anon_sym_union] = ACTIONS(341),
    [sym_identifier] = ACTIONS(341),
    [sym_comment] = ACTIONS(41),
  },
  [61] = {
    [ts_builtin_sym_end] = ACTIONS(343),
    [anon_sym_tensor] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_RBRACE] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_COMMA] = ACTIONS(343),
    [anon_sym_indexvars] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(345),
    [sym_preproc_directive] = ACTIONS(345),
    [anon_sym_typedef] = ACTIONS(345),
    [anon_sym_extern] = ACTIONS(345),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(343),
    [anon_sym_EQ] = ACTIONS(345),
    [anon_sym_static] = ACTIONS(345),
    [anon_sym_auto] = ACTIONS(345),
    [anon_sym_register] = ACTIONS(345),
    [anon_sym_inline] = ACTIONS(345),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_restrict] = ACTIONS(345),
    [anon_sym_volatile] = ACTIONS(345),
    [anon_sym__Atomic] = ACTIONS(345),
    [anon_sym_unsigned] = ACTIONS(345),
    [anon_sym_long] = ACTIONS(345),
    [anon_sym_short] = ACTIONS(345),
    [sym_primitive_type] = ACTIONS(345),
    [anon_sym_enum] = ACTIONS(345),
    [anon_sym_struct] = ACTIONS(345),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_COLON] = ACTIONS(343),
    [anon_sym_QMARK] = ACTIONS(343),
    [anon_sym_STAR_EQ] = ACTIONS(343),
    [anon_sym_SLASH_EQ] = ACTIONS(343),
    [anon_sym_PERCENT_EQ] = ACTIONS(343),
    [anon_sym_PLUS_EQ] = ACTIONS(343),
    [anon_sym_DASH_EQ] = ACTIONS(343),
    [anon_sym_LT_LT_EQ] = ACTIONS(343),
    [anon_sym_GT_GT_EQ] = ACTIONS(343),
    [anon_sym_AMP_EQ] = ACTIONS(343),
    [anon_sym_CARET_EQ] = ACTIONS(343),
    [anon_sym_PIPE_EQ] = ACTIONS(343),
    [anon_sym_AMP] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(343),
    [anon_sym_AMP_AMP] = ACTIONS(343),
    [anon_sym_PIPE] = ACTIONS(345),
    [anon_sym_CARET] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(343),
    [anon_sym_BANG_EQ] = ACTIONS(343),
    [anon_sym_LT] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(345),
    [anon_sym_LT_EQ] = ACTIONS(343),
    [anon_sym_GT_EQ] = ACTIONS(343),
    [anon_sym_LT_LT] = ACTIONS(345),
    [anon_sym_GT_GT] = ACTIONS(345),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_PERCENT] = ACTIONS(345),
    [anon_sym_DASH_DASH] = ACTIONS(343),
    [anon_sym_PLUS_PLUS] = ACTIONS(343),
    [anon_sym_DOT] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(343),
    [sym_identifier] = ACTIONS(345),
    [sym_comment] = ACTIONS(41),
  },
  [62] = {
    [aux_sym_string_literal_repeat1] = STATE(136),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(349),
    [sym_escape_sequence] = ACTIONS(349),
    [sym_comment] = ACTIONS(55),
  },
  [63] = {
    [ts_builtin_sym_end] = ACTIONS(351),
    [anon_sym_tensor] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(351),
    [anon_sym_SEMI] = ACTIONS(351),
    [anon_sym_indexvars] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(353),
    [sym_preproc_directive] = ACTIONS(353),
    [anon_sym_typedef] = ACTIONS(353),
    [anon_sym_extern] = ACTIONS(353),
    [anon_sym_STAR] = ACTIONS(351),
    [anon_sym_static] = ACTIONS(353),
    [anon_sym_auto] = ACTIONS(353),
    [anon_sym_register] = ACTIONS(353),
    [anon_sym_inline] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(353),
    [anon_sym_restrict] = ACTIONS(353),
    [anon_sym_volatile] = ACTIONS(353),
    [anon_sym__Atomic] = ACTIONS(353),
    [anon_sym_unsigned] = ACTIONS(353),
    [anon_sym_long] = ACTIONS(353),
    [anon_sym_short] = ACTIONS(353),
    [sym_primitive_type] = ACTIONS(353),
    [anon_sym_enum] = ACTIONS(353),
    [anon_sym_struct] = ACTIONS(353),
    [anon_sym_union] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_switch] = ACTIONS(353),
    [anon_sym_case] = ACTIONS(353),
    [anon_sym_default] = ACTIONS(353),
    [anon_sym_while] = ACTIONS(353),
    [anon_sym_do] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(353),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_continue] = ACTIONS(353),
    [anon_sym_goto] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(353),
    [anon_sym_DASH] = ACTIONS(353),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_sizeof] = ACTIONS(353),
    [sym_number_literal] = ACTIONS(351),
    [anon_sym_SQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_identifier] = ACTIONS(353),
    [sym_comment] = ACTIONS(41),
  },
  [64] = {
    [anon_sym_RPAREN] = ACTIONS(355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_comment] = ACTIONS(41),
  },
  [65] = {
    [anon_sym_LF] = ACTIONS(359),
    [sym_comment] = ACTIONS(55),
  },
  [66] = {
    [anon_sym_LF] = ACTIONS(361),
    [sym_preproc_arg] = ACTIONS(363),
    [sym_comment] = ACTIONS(55),
  },
  [67] = {
    [anon_sym_format] = ACTIONS(365),
    [sym_comment] = ACTIONS(41),
  },
  [68] = {
    [sym_ta_name_list] = STATE(143),
    [sym_identifier] = ACTIONS(45),
    [sym_comment] = ACTIONS(41),
  },
  [69] = {
    [sym_string_literal] = STATE(145),
    [anon_sym_DQUOTE] = ACTIONS(367),
    [sym_system_lib_string] = ACTIONS(369),
    [sym_comment] = ACTIONS(41),
  },
  [70] = {
    [sym_identifier] = ACTIONS(371),
    [sym_comment] = ACTIONS(41),
  },
  [71] = {
    [sym_preproc_arg] = ACTIONS(373),
    [sym_comment] = ACTIONS(55),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(375),
    [anon_sym_tensor] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_indexvars] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(377),
    [sym_preproc_directive] = ACTIONS(377),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(377),
    [anon_sym_static] = ACTIONS(377),
    [anon_sym_auto] = ACTIONS(377),
    [anon_sym_register] = ACTIONS(377),
    [anon_sym_inline] = ACTIONS(377),
    [anon_sym_const] = ACTIONS(377),
    [anon_sym_restrict] = ACTIONS(377),
    [anon_sym_volatile] = ACTIONS(377),
    [anon_sym__Atomic] = ACTIONS(377),
    [anon_sym_unsigned] = ACTIONS(377),
    [anon_sym_long] = ACTIONS(377),
    [anon_sym_short] = ACTIONS(377),
    [sym_primitive_type] = ACTIONS(377),
    [anon_sym_enum] = ACTIONS(377),
    [anon_sym_struct] = ACTIONS(377),
    [anon_sym_union] = ACTIONS(377),
    [sym_identifier] = ACTIONS(377),
    [sym_comment] = ACTIONS(41),
  },
  [73] = {
    [sym_identifier] = ACTIONS(379),
    [sym_comment] = ACTIONS(41),
  },
  [74] = {
    [sym_ta_top_level] = STATE(159),
    [sym_preproc_include] = STATE(159),
    [sym_preproc_def] = STATE(159),
    [sym_preproc_function_def] = STATE(159),
    [sym_preproc_call] = STATE(159),
    [sym_preproc_if] = STATE(159),
    [sym_preproc_ifdef] = STATE(159),
    [sym_function_definition] = STATE(159),
    [sym_declaration] = STATE(159),
    [sym_type_definition] = STATE(159),
    [sym__declaration_specifiers] = STATE(158),
    [sym_linkage_specification] = STATE(159),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(159),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(159),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(381),
    [anon_sym_indexvars] = ACTIONS(383),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(391),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(393),
    [sym_preproc_directive] = ACTIONS(395),
    [anon_sym_typedef] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(399),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [75] = {
    [sym_preproc_arg] = ACTIONS(401),
    [sym_comment] = ACTIONS(55),
  },
  [76] = {
    [anon_sym_LF] = ACTIONS(403),
    [sym_preproc_arg] = ACTIONS(405),
    [sym_comment] = ACTIONS(55),
  },
  [77] = {
    [sym_type_qualifier] = STATE(164),
    [sym__type_specifier] = STATE(163),
    [sym_sized_type_specifier] = STATE(163),
    [sym_enum_specifier] = STATE(163),
    [sym_struct_specifier] = STATE(163),
    [sym_union_specifier] = STATE(163),
    [sym_macro_type_specifier] = STATE(163),
    [aux_sym_type_definition_repeat1] = STATE(164),
    [aux_sym_sized_type_specifier_repeat1] = STATE(35),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(63),
    [anon_sym_long] = ACTIONS(63),
    [anon_sym_short] = ACTIONS(63),
    [sym_primitive_type] = ACTIONS(407),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [78] = {
    [sym_string_literal] = STATE(165),
    [anon_sym_extern] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(67),
    [anon_sym_auto] = ACTIONS(67),
    [anon_sym_register] = ACTIONS(67),
    [anon_sym_inline] = ACTIONS(67),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym_unsigned] = ACTIONS(67),
    [anon_sym_long] = ACTIONS(67),
    [anon_sym_short] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_identifier] = ACTIONS(67),
    [sym_comment] = ACTIONS(41),
  },
  [79] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(409),
    [sym_comment] = ACTIONS(41),
  },
  [80] = {
    [sym__declarator] = STATE(168),
    [sym_pointer_declarator] = STATE(168),
    [sym_function_declarator] = STATE(168),
    [sym_array_declarator] = STATE(168),
    [sym_init_declarator] = STATE(169),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(98),
    [sym_identifier] = ACTIONS(413),
    [sym_comment] = ACTIONS(41),
  },
  [81] = {
    [sym_ta_top_level] = STATE(171),
    [sym_preproc_include] = STATE(171),
    [sym_preproc_def] = STATE(171),
    [sym_preproc_function_def] = STATE(171),
    [sym_preproc_call] = STATE(171),
    [sym_preproc_if] = STATE(171),
    [sym_preproc_ifdef] = STATE(171),
    [sym_preproc_else] = STATE(170),
    [sym_preproc_elif] = STATE(170),
    [sym_function_definition] = STATE(171),
    [sym_declaration] = STATE(171),
    [sym_type_definition] = STATE(171),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(171),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(171),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(171),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(417),
    [anon_sym_tensor] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_indexvars] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(419),
    [sym_preproc_directive] = ACTIONS(419),
    [anon_sym_typedef] = ACTIONS(419),
    [anon_sym_extern] = ACTIONS(419),
    [anon_sym_static] = ACTIONS(419),
    [anon_sym_auto] = ACTIONS(419),
    [anon_sym_register] = ACTIONS(419),
    [anon_sym_inline] = ACTIONS(419),
    [anon_sym_const] = ACTIONS(419),
    [anon_sym_restrict] = ACTIONS(419),
    [anon_sym_volatile] = ACTIONS(419),
    [anon_sym__Atomic] = ACTIONS(419),
    [anon_sym_unsigned] = ACTIONS(419),
    [anon_sym_long] = ACTIONS(419),
    [anon_sym_short] = ACTIONS(419),
    [sym_primitive_type] = ACTIONS(419),
    [anon_sym_enum] = ACTIONS(419),
    [anon_sym_struct] = ACTIONS(419),
    [anon_sym_union] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_comment] = ACTIONS(41),
  },
  [83] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(421),
    [sym_comment] = ACTIONS(41),
  },
  [84] = {
    [sym_ta_top_level] = STATE(171),
    [sym_preproc_include] = STATE(171),
    [sym_preproc_def] = STATE(171),
    [sym_preproc_function_def] = STATE(171),
    [sym_preproc_call] = STATE(171),
    [sym_preproc_if] = STATE(171),
    [sym_preproc_ifdef] = STATE(171),
    [sym_preproc_else] = STATE(173),
    [sym_preproc_elif] = STATE(173),
    [sym_function_definition] = STATE(171),
    [sym_declaration] = STATE(171),
    [sym_type_definition] = STATE(171),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(171),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(171),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(171),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(423),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(425),
    [anon_sym_tensor] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_indexvars] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(427),
    [sym_preproc_directive] = ACTIONS(427),
    [anon_sym_typedef] = ACTIONS(427),
    [anon_sym_extern] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(427),
    [anon_sym_auto] = ACTIONS(427),
    [anon_sym_register] = ACTIONS(427),
    [anon_sym_inline] = ACTIONS(427),
    [anon_sym_const] = ACTIONS(427),
    [anon_sym_restrict] = ACTIONS(427),
    [anon_sym_volatile] = ACTIONS(427),
    [anon_sym__Atomic] = ACTIONS(427),
    [anon_sym_unsigned] = ACTIONS(427),
    [anon_sym_long] = ACTIONS(427),
    [anon_sym_short] = ACTIONS(427),
    [sym_primitive_type] = ACTIONS(427),
    [anon_sym_enum] = ACTIONS(427),
    [anon_sym_struct] = ACTIONS(427),
    [anon_sym_union] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_switch] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(427),
    [anon_sym_default] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(427),
    [anon_sym_continue] = ACTIONS(427),
    [anon_sym_goto] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_TILDE] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(425),
    [anon_sym_sizeof] = ACTIONS(427),
    [sym_number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(425),
    [anon_sym_DQUOTE] = ACTIONS(425),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_identifier] = ACTIONS(427),
    [sym_comment] = ACTIONS(41),
  },
  [86] = {
    [sym__type_declarator] = STATE(175),
    [sym_pointer_type_declarator] = STATE(175),
    [sym_function_type_declarator] = STATE(175),
    [sym_array_type_declarator] = STATE(175),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(429),
    [sym_identifier] = ACTIONS(179),
    [sym_comment] = ACTIONS(41),
  },
  [87] = {
    [sym__type_declarator] = STATE(176),
    [sym_pointer_type_declarator] = STATE(176),
    [sym_function_type_declarator] = STATE(176),
    [sym_array_type_declarator] = STATE(176),
    [sym_type_qualifier] = STATE(177),
    [aux_sym_type_definition_repeat1] = STATE(177),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(177),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(41),
  },
  [88] = {
    [anon_sym_LPAREN] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(433),
    [anon_sym_LBRACK] = ACTIONS(433),
    [sym_comment] = ACTIONS(41),
  },
  [89] = {
    [sym_parameter_list] = STATE(180),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(435),
    [anon_sym_LBRACK] = ACTIONS(437),
    [sym_comment] = ACTIONS(41),
  },
  [90] = {
    [sym__type_declarator] = STATE(181),
    [sym_pointer_type_declarator] = STATE(181),
    [sym_function_type_declarator] = STATE(181),
    [sym_array_type_declarator] = STATE(181),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(177),
    [sym_identifier] = ACTIONS(179),
    [sym_comment] = ACTIONS(41),
  },
  [91] = {
    [sym_type_qualifier] = STATE(91),
    [aux_sym_type_definition_repeat1] = STATE(91),
    [anon_sym_const] = ACTIONS(439),
    [anon_sym_restrict] = ACTIONS(439),
    [anon_sym_volatile] = ACTIONS(439),
    [anon_sym__Atomic] = ACTIONS(439),
    [anon_sym_unsigned] = ACTIONS(442),
    [anon_sym_long] = ACTIONS(442),
    [anon_sym_short] = ACTIONS(442),
    [sym_primitive_type] = ACTIONS(442),
    [anon_sym_enum] = ACTIONS(442),
    [anon_sym_struct] = ACTIONS(442),
    [anon_sym_union] = ACTIONS(442),
    [sym_identifier] = ACTIONS(442),
    [sym_comment] = ACTIONS(41),
  },
  [92] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(92),
    [anon_sym_LPAREN] = ACTIONS(330),
    [anon_sym_STAR] = ACTIONS(330),
    [anon_sym_unsigned] = ACTIONS(444),
    [anon_sym_long] = ACTIONS(444),
    [anon_sym_short] = ACTIONS(444),
    [sym_primitive_type] = ACTIONS(332),
    [sym_identifier] = ACTIONS(332),
    [sym_comment] = ACTIONS(41),
  },
  [93] = {
    [sym_ta_top_level] = STATE(183),
    [sym_preproc_include] = STATE(183),
    [sym_preproc_def] = STATE(183),
    [sym_preproc_function_def] = STATE(183),
    [sym_preproc_call] = STATE(183),
    [sym_preproc_if] = STATE(183),
    [sym_preproc_ifdef] = STATE(183),
    [sym_function_definition] = STATE(183),
    [sym_declaration] = STATE(183),
    [sym_type_definition] = STATE(183),
    [sym__declaration_specifiers] = STATE(18),
    [sym_linkage_specification] = STATE(183),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(183),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(183),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_indexvars] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(17),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [94] = {
    [ts_builtin_sym_end] = ACTIONS(449),
    [anon_sym_tensor] = ACTIONS(451),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_indexvars] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(451),
    [sym_preproc_directive] = ACTIONS(451),
    [anon_sym_typedef] = ACTIONS(451),
    [anon_sym_extern] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(451),
    [anon_sym_auto] = ACTIONS(451),
    [anon_sym_register] = ACTIONS(451),
    [anon_sym_inline] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(451),
    [anon_sym_restrict] = ACTIONS(451),
    [anon_sym_volatile] = ACTIONS(451),
    [anon_sym__Atomic] = ACTIONS(451),
    [anon_sym_unsigned] = ACTIONS(451),
    [anon_sym_long] = ACTIONS(451),
    [anon_sym_short] = ACTIONS(451),
    [sym_primitive_type] = ACTIONS(451),
    [anon_sym_enum] = ACTIONS(451),
    [anon_sym_struct] = ACTIONS(451),
    [anon_sym_union] = ACTIONS(451),
    [sym_identifier] = ACTIONS(451),
    [sym_comment] = ACTIONS(41),
  },
  [95] = {
    [sym__declarator] = STATE(49),
    [sym_pointer_declarator] = STATE(49),
    [sym_function_declarator] = STATE(49),
    [sym_array_declarator] = STATE(49),
    [sym_init_declarator] = STATE(50),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(98),
    [sym_identifier] = ACTIONS(100),
    [sym_comment] = ACTIONS(41),
  },
  [96] = {
    [sym_storage_class_specifier] = STATE(184),
    [sym_type_qualifier] = STATE(184),
    [aux_sym__declaration_specifiers_repeat1] = STATE(184),
    [anon_sym_LPAREN] = ACTIONS(102),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(102),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(104),
    [sym_comment] = ACTIONS(41),
  },
  [97] = {
    [sym_storage_class_specifier] = STATE(54),
    [sym_type_qualifier] = STATE(54),
    [sym__type_specifier] = STATE(185),
    [sym_sized_type_specifier] = STATE(185),
    [sym_enum_specifier] = STATE(185),
    [sym_struct_specifier] = STATE(185),
    [sym_union_specifier] = STATE(185),
    [sym_macro_type_specifier] = STATE(185),
    [aux_sym__declaration_specifiers_repeat1] = STATE(54),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(453),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [98] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(186),
    [anon_sym_LPAREN] = ACTIONS(110),
    [anon_sym_extern] = ACTIONS(112),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_static] = ACTIONS(112),
    [anon_sym_auto] = ACTIONS(112),
    [anon_sym_register] = ACTIONS(112),
    [anon_sym_inline] = ACTIONS(112),
    [anon_sym_const] = ACTIONS(112),
    [anon_sym_restrict] = ACTIONS(112),
    [anon_sym_volatile] = ACTIONS(112),
    [anon_sym__Atomic] = ACTIONS(112),
    [anon_sym_unsigned] = ACTIONS(455),
    [anon_sym_long] = ACTIONS(455),
    [anon_sym_short] = ACTIONS(455),
    [sym_primitive_type] = ACTIONS(116),
    [sym_identifier] = ACTIONS(118),
    [sym_comment] = ACTIONS(41),
  },
  [99] = {
    [anon_sym_LPAREN] = ACTIONS(457),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_COMMA] = ACTIONS(457),
    [anon_sym_extern] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(457),
    [anon_sym_static] = ACTIONS(459),
    [anon_sym_auto] = ACTIONS(459),
    [anon_sym_register] = ACTIONS(459),
    [anon_sym_inline] = ACTIONS(459),
    [anon_sym_const] = ACTIONS(459),
    [anon_sym_restrict] = ACTIONS(459),
    [anon_sym_volatile] = ACTIONS(459),
    [anon_sym__Atomic] = ACTIONS(459),
    [anon_sym_COLON] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_BANG] = ACTIONS(457),
    [anon_sym_TILDE] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(457),
    [anon_sym_PLUS_PLUS] = ACTIONS(457),
    [anon_sym_sizeof] = ACTIONS(459),
    [sym_number_literal] = ACTIONS(457),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_true] = ACTIONS(459),
    [sym_false] = ACTIONS(459),
    [sym_null] = ACTIONS(459),
    [sym_identifier] = ACTIONS(459),
    [sym_comment] = ACTIONS(41),
  },
  [100] = {
    [anon_sym_RBRACE] = ACTIONS(461),
    [sym_comment] = ACTIONS(41),
  },
  [101] = {
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(465),
    [sym_comment] = ACTIONS(41),
  },
  [102] = {
    [aux_sym_enumerator_list_repeat1] = STATE(190),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_COMMA] = ACTIONS(467),
    [sym_comment] = ACTIONS(41),
  },
  [103] = {
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_COMMA] = ACTIONS(469),
    [anon_sym_extern] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(469),
    [anon_sym_RBRACK] = ACTIONS(469),
    [anon_sym_static] = ACTIONS(471),
    [anon_sym_auto] = ACTIONS(471),
    [anon_sym_register] = ACTIONS(471),
    [anon_sym_inline] = ACTIONS(471),
    [anon_sym_const] = ACTIONS(471),
    [anon_sym_restrict] = ACTIONS(471),
    [anon_sym_volatile] = ACTIONS(471),
    [anon_sym__Atomic] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_DASH_DASH] = ACTIONS(469),
    [anon_sym_PLUS_PLUS] = ACTIONS(469),
    [anon_sym_sizeof] = ACTIONS(471),
    [sym_number_literal] = ACTIONS(469),
    [anon_sym_SQUOTE] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [sym_true] = ACTIONS(471),
    [sym_false] = ACTIONS(471),
    [sym_null] = ACTIONS(471),
    [sym_identifier] = ACTIONS(471),
    [sym_comment] = ACTIONS(41),
  },
  [104] = {
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_COMMA] = ACTIONS(473),
    [anon_sym_extern] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(473),
    [anon_sym_static] = ACTIONS(475),
    [anon_sym_auto] = ACTIONS(475),
    [anon_sym_register] = ACTIONS(475),
    [anon_sym_inline] = ACTIONS(475),
    [anon_sym_const] = ACTIONS(475),
    [anon_sym_restrict] = ACTIONS(475),
    [anon_sym_volatile] = ACTIONS(475),
    [anon_sym__Atomic] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_sizeof] = ACTIONS(475),
    [sym_number_literal] = ACTIONS(473),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [sym_true] = ACTIONS(475),
    [sym_false] = ACTIONS(475),
    [sym_null] = ACTIONS(475),
    [sym_identifier] = ACTIONS(475),
    [sym_comment] = ACTIONS(41),
  },
  [105] = {
    [sym_preproc_arg] = ACTIONS(477),
    [sym_comment] = ACTIONS(55),
  },
  [106] = {
    [sym_identifier] = ACTIONS(479),
    [sym_comment] = ACTIONS(41),
  },
  [107] = {
    [sym__field_declarator] = STATE(198),
    [sym_pointer_field_declarator] = STATE(198),
    [sym_function_field_declarator] = STATE(198),
    [sym_array_field_declarator] = STATE(198),
    [anon_sym_LPAREN] = ACTIONS(481),
    [anon_sym_SEMI] = ACTIONS(483),
    [anon_sym_STAR] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [sym_identifier] = ACTIONS(489),
    [sym_comment] = ACTIONS(41),
  },
  [108] = {
    [sym_storage_class_specifier] = STATE(199),
    [sym_type_qualifier] = STATE(199),
    [aux_sym__declaration_specifiers_repeat1] = STATE(199),
    [anon_sym_LPAREN] = ACTIONS(102),
    [anon_sym_SEMI] = ACTIONS(102),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(102),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(102),
    [sym_identifier] = ACTIONS(104),
    [sym_comment] = ACTIONS(41),
  },
  [109] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(201),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(201),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(201),
    [sym_field_declaration] = STATE(201),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(201),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [anon_sym_RBRACE] = ACTIONS(491),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(207),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [110] = {
    [sym_storage_class_specifier] = STATE(54),
    [sym_type_qualifier] = STATE(54),
    [sym__type_specifier] = STATE(202),
    [sym_sized_type_specifier] = STATE(202),
    [sym_enum_specifier] = STATE(202),
    [sym_struct_specifier] = STATE(202),
    [sym_union_specifier] = STATE(202),
    [sym_macro_type_specifier] = STATE(202),
    [aux_sym__declaration_specifiers_repeat1] = STATE(54),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(493),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [111] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(110),
    [anon_sym_SEMI] = ACTIONS(110),
    [anon_sym_extern] = ACTIONS(112),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_static] = ACTIONS(112),
    [anon_sym_auto] = ACTIONS(112),
    [anon_sym_register] = ACTIONS(112),
    [anon_sym_inline] = ACTIONS(112),
    [anon_sym_const] = ACTIONS(112),
    [anon_sym_restrict] = ACTIONS(112),
    [anon_sym_volatile] = ACTIONS(112),
    [anon_sym__Atomic] = ACTIONS(112),
    [anon_sym_unsigned] = ACTIONS(495),
    [anon_sym_long] = ACTIONS(495),
    [anon_sym_short] = ACTIONS(495),
    [sym_primitive_type] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(110),
    [sym_identifier] = ACTIONS(118),
    [sym_comment] = ACTIONS(41),
  },
  [112] = {
    [anon_sym_LPAREN] = ACTIONS(497),
    [anon_sym_RPAREN] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(497),
    [anon_sym_extern] = ACTIONS(499),
    [anon_sym_STAR] = ACTIONS(497),
    [anon_sym_LBRACK] = ACTIONS(497),
    [anon_sym_RBRACK] = ACTIONS(497),
    [anon_sym_static] = ACTIONS(499),
    [anon_sym_auto] = ACTIONS(499),
    [anon_sym_register] = ACTIONS(499),
    [anon_sym_inline] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(499),
    [anon_sym_restrict] = ACTIONS(499),
    [anon_sym_volatile] = ACTIONS(499),
    [anon_sym__Atomic] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_PLUS] = ACTIONS(499),
    [anon_sym_DASH] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(497),
    [anon_sym_sizeof] = ACTIONS(499),
    [sym_number_literal] = ACTIONS(497),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(497),
    [sym_true] = ACTIONS(499),
    [sym_false] = ACTIONS(499),
    [sym_null] = ACTIONS(499),
    [sym_identifier] = ACTIONS(499),
    [sym_comment] = ACTIONS(41),
  },
  [113] = {
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_RPAREN] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_extern] = ACTIONS(503),
    [anon_sym_STAR] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_auto] = ACTIONS(503),
    [anon_sym_register] = ACTIONS(503),
    [anon_sym_inline] = ACTIONS(503),
    [anon_sym_const] = ACTIONS(503),
    [anon_sym_restrict] = ACTIONS(503),
    [anon_sym_volatile] = ACTIONS(503),
    [anon_sym__Atomic] = ACTIONS(503),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(503),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_sizeof] = ACTIONS(503),
    [sym_number_literal] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [sym_true] = ACTIONS(503),
    [sym_false] = ACTIONS(503),
    [sym_null] = ACTIONS(503),
    [sym_identifier] = ACTIONS(503),
    [sym_comment] = ACTIONS(41),
  },
  [114] = {
    [sym__abstract_declarator] = STATE(207),
    [sym_abstract_pointer_declarator] = STATE(207),
    [sym_abstract_function_declarator] = STATE(207),
    [sym_abstract_array_declarator] = STATE(207),
    [sym_parameter_list] = STATE(208),
    [anon_sym_LPAREN] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(507),
    [anon_sym_STAR] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(511),
    [sym_comment] = ACTIONS(41),
  },
  [115] = {
    [anon_sym_RPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(41),
  },
  [116] = {
    [sym_type_qualifier] = STATE(91),
    [sym__type_specifier] = STATE(210),
    [sym_sized_type_specifier] = STATE(210),
    [sym_enum_specifier] = STATE(210),
    [sym_struct_specifier] = STATE(210),
    [sym_union_specifier] = STATE(210),
    [sym_macro_type_specifier] = STATE(210),
    [aux_sym_type_definition_repeat1] = STATE(91),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [117] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(211),
    [anon_sym_LPAREN] = ACTIONS(110),
    [anon_sym_RPAREN] = ACTIONS(110),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_LBRACK] = ACTIONS(110),
    [anon_sym_unsigned] = ACTIONS(517),
    [anon_sym_long] = ACTIONS(517),
    [anon_sym_short] = ACTIONS(517),
    [sym_primitive_type] = ACTIONS(116),
    [sym_identifier] = ACTIONS(519),
    [sym_comment] = ACTIONS(41),
  },
  [118] = {
    [sym__declarator] = STATE(120),
    [sym_pointer_declarator] = STATE(120),
    [sym_function_declarator] = STATE(120),
    [sym_array_declarator] = STATE(120),
    [sym_type_qualifier] = STATE(212),
    [aux_sym_type_definition_repeat1] = STATE(212),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(243),
    [sym_comment] = ACTIONS(41),
  },
  [119] = {
    [sym_parameter_list] = STATE(129),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(253),
    [sym_comment] = ACTIONS(41),
  },
  [120] = {
    [sym_parameter_list] = STATE(129),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(523),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(523),
    [sym_comment] = ACTIONS(41),
  },
  [121] = {
    [sym__declarator] = STATE(214),
    [sym_pointer_declarator] = STATE(214),
    [sym_function_declarator] = STATE(214),
    [sym_array_declarator] = STATE(214),
    [sym_type_qualifier] = STATE(215),
    [aux_sym_type_definition_repeat1] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(98),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(525),
    [sym_comment] = ACTIONS(41),
  },
  [122] = {
    [sym__declaration_specifiers] = STATE(218),
    [sym_storage_class_specifier] = STATE(220),
    [sym_type_qualifier] = STATE(220),
    [sym__type_specifier] = STATE(219),
    [sym_sized_type_specifier] = STATE(219),
    [sym_enum_specifier] = STATE(219),
    [sym_struct_specifier] = STATE(219),
    [sym_union_specifier] = STATE(219),
    [sym_parameter_declaration] = STATE(217),
    [sym_macro_type_specifier] = STATE(219),
    [aux_sym__declaration_specifiers_repeat1] = STATE(220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(221),
    [anon_sym_RPAREN] = ACTIONS(527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(529),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(531),
    [anon_sym_long] = ACTIONS(531),
    [anon_sym_short] = ACTIONS(531),
    [sym_primitive_type] = ACTIONS(533),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [123] = {
    [sym_preproc_include] = STATE(250),
    [sym_preproc_def] = STATE(250),
    [sym_preproc_function_def] = STATE(250),
    [sym_preproc_call] = STATE(250),
    [sym_preproc_if_in_compound_statement] = STATE(250),
    [sym_preproc_ifdef_in_compound_statement] = STATE(250),
    [sym_declaration] = STATE(250),
    [sym_type_definition] = STATE(250),
    [sym__declaration_specifiers] = STATE(246),
    [sym_compound_statement] = STATE(250),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(250),
    [sym_expression_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_switch_statement] = STATE(250),
    [sym_case_statement] = STATE(250),
    [sym_while_statement] = STATE(250),
    [sym_do_statement] = STATE(250),
    [sym_for_statement] = STATE(250),
    [sym_return_statement] = STATE(250),
    [sym_break_statement] = STATE(250),
    [sym_continue_statement] = STATE(250),
    [sym_goto_statement] = STATE(250),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(250),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(250),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_SEMI] = ACTIONS(539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(541),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(545),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(545),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(587),
    [sym_comment] = ACTIONS(41),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(589),
    [anon_sym_tensor] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_indexvars] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(591),
    [sym_preproc_directive] = ACTIONS(591),
    [anon_sym_typedef] = ACTIONS(591),
    [anon_sym_extern] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_static] = ACTIONS(591),
    [anon_sym_auto] = ACTIONS(591),
    [anon_sym_register] = ACTIONS(591),
    [anon_sym_inline] = ACTIONS(591),
    [anon_sym_const] = ACTIONS(591),
    [anon_sym_restrict] = ACTIONS(591),
    [anon_sym_volatile] = ACTIONS(591),
    [anon_sym__Atomic] = ACTIONS(591),
    [anon_sym_unsigned] = ACTIONS(591),
    [anon_sym_long] = ACTIONS(591),
    [anon_sym_short] = ACTIONS(591),
    [sym_primitive_type] = ACTIONS(591),
    [anon_sym_enum] = ACTIONS(591),
    [anon_sym_struct] = ACTIONS(591),
    [anon_sym_union] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(591),
    [anon_sym_else] = ACTIONS(591),
    [anon_sym_switch] = ACTIONS(591),
    [anon_sym_case] = ACTIONS(591),
    [anon_sym_default] = ACTIONS(591),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_do] = ACTIONS(591),
    [anon_sym_for] = ACTIONS(591),
    [anon_sym_return] = ACTIONS(591),
    [anon_sym_break] = ACTIONS(591),
    [anon_sym_continue] = ACTIONS(591),
    [anon_sym_goto] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [anon_sym_PLUS] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_sizeof] = ACTIONS(591),
    [sym_number_literal] = ACTIONS(589),
    [anon_sym_SQUOTE] = ACTIONS(589),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [sym_true] = ACTIONS(591),
    [sym_false] = ACTIONS(591),
    [sym_null] = ACTIONS(591),
    [sym_identifier] = ACTIONS(591),
    [sym_comment] = ACTIONS(41),
  },
  [125] = {
    [sym__declarator] = STATE(252),
    [sym_pointer_declarator] = STATE(252),
    [sym_function_declarator] = STATE(252),
    [sym_array_declarator] = STATE(252),
    [sym_init_declarator] = STATE(253),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(593),
    [sym_identifier] = ACTIONS(595),
    [sym_comment] = ACTIONS(41),
  },
  [126] = {
    [sym__declaration_specifiers] = STATE(262),
    [sym_storage_class_specifier] = STATE(266),
    [sym_type_qualifier] = STATE(266),
    [sym__type_specifier] = STATE(263),
    [sym_sized_type_specifier] = STATE(263),
    [sym_enum_specifier] = STATE(263),
    [sym_struct_specifier] = STATE(263),
    [sym_union_specifier] = STATE(263),
    [sym__expression] = STATE(264),
    [sym_conditional_expression] = STATE(264),
    [sym_assignment_expression] = STATE(264),
    [sym_pointer_expression] = STATE(264),
    [sym_logical_expression] = STATE(264),
    [sym_bitwise_expression] = STATE(264),
    [sym_equality_expression] = STATE(264),
    [sym_relational_expression] = STATE(264),
    [sym_shift_expression] = STATE(264),
    [sym_math_expression] = STATE(264),
    [sym_cast_expression] = STATE(264),
    [sym_sizeof_expression] = STATE(264),
    [sym_subscript_expression] = STATE(264),
    [sym_call_expression] = STATE(264),
    [sym_field_expression] = STATE(264),
    [sym_compound_literal_expression] = STATE(264),
    [sym_parenthesized_expression] = STATE(264),
    [sym_char_literal] = STATE(264),
    [sym_concatenated_string] = STATE(264),
    [sym_string_literal] = STATE(265),
    [sym_macro_type_specifier] = STATE(263),
    [aux_sym__declaration_specifiers_repeat1] = STATE(266),
    [aux_sym_sized_type_specifier_repeat1] = STATE(267),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(601),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(603),
    [anon_sym_long] = ACTIONS(603),
    [anon_sym_short] = ACTIONS(603),
    [sym_primitive_type] = ACTIONS(605),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(617),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(619),
    [sym_false] = ACTIONS(619),
    [sym_null] = ACTIONS(619),
    [sym_identifier] = ACTIONS(621),
    [sym_comment] = ACTIONS(41),
  },
  [127] = {
    [sym__expression] = STATE(269),
    [sym_conditional_expression] = STATE(269),
    [sym_assignment_expression] = STATE(269),
    [sym_pointer_expression] = STATE(269),
    [sym_logical_expression] = STATE(269),
    [sym_bitwise_expression] = STATE(269),
    [sym_equality_expression] = STATE(269),
    [sym_relational_expression] = STATE(269),
    [sym_shift_expression] = STATE(269),
    [sym_math_expression] = STATE(269),
    [sym_cast_expression] = STATE(269),
    [sym_sizeof_expression] = STATE(269),
    [sym_subscript_expression] = STATE(269),
    [sym_call_expression] = STATE(269),
    [sym_field_expression] = STATE(269),
    [sym_compound_literal_expression] = STATE(269),
    [sym_parenthesized_expression] = STATE(269),
    [sym_initializer_list] = STATE(270),
    [sym_char_literal] = STATE(269),
    [sym_concatenated_string] = STATE(269),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(627),
    [sym_false] = ACTIONS(627),
    [sym_null] = ACTIONS(627),
    [sym_identifier] = ACTIONS(627),
    [sym_comment] = ACTIONS(41),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(629),
    [anon_sym_tensor] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(629),
    [anon_sym_indexvars] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(631),
    [sym_preproc_directive] = ACTIONS(631),
    [anon_sym_typedef] = ACTIONS(631),
    [anon_sym_extern] = ACTIONS(631),
    [anon_sym_static] = ACTIONS(631),
    [anon_sym_auto] = ACTIONS(631),
    [anon_sym_register] = ACTIONS(631),
    [anon_sym_inline] = ACTIONS(631),
    [anon_sym_const] = ACTIONS(631),
    [anon_sym_restrict] = ACTIONS(631),
    [anon_sym_volatile] = ACTIONS(631),
    [anon_sym__Atomic] = ACTIONS(631),
    [anon_sym_unsigned] = ACTIONS(631),
    [anon_sym_long] = ACTIONS(631),
    [anon_sym_short] = ACTIONS(631),
    [sym_primitive_type] = ACTIONS(631),
    [anon_sym_enum] = ACTIONS(631),
    [anon_sym_struct] = ACTIONS(631),
    [anon_sym_union] = ACTIONS(631),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(41),
  },
  [129] = {
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_RPAREN] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_EQ] = ACTIONS(633),
    [sym_comment] = ACTIONS(41),
  },
  [130] = {
    [aux_sym_declaration_repeat1] = STATE(272),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(251),
    [sym_comment] = ACTIONS(41),
  },
  [131] = {
    [sym_storage_class_specifier] = STATE(131),
    [sym_type_qualifier] = STATE(131),
    [aux_sym__declaration_specifiers_repeat1] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_SEMI] = ACTIONS(637),
    [anon_sym_extern] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_static] = ACTIONS(314),
    [anon_sym_auto] = ACTIONS(314),
    [anon_sym_register] = ACTIONS(314),
    [anon_sym_inline] = ACTIONS(314),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [sym_identifier] = ACTIONS(320),
    [sym_comment] = ACTIONS(41),
  },
  [132] = {
    [sym_storage_class_specifier] = STATE(131),
    [sym_type_qualifier] = STATE(131),
    [aux_sym__declaration_specifiers_repeat1] = STATE(131),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(639),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(641),
    [sym_comment] = ACTIONS(41),
  },
  [133] = {
    [anon_sym_LBRACE] = ACTIONS(643),
    [sym_comment] = ACTIONS(41),
  },
  [134] = {
    [anon_sym_SEMI] = ACTIONS(645),
    [sym_comment] = ACTIONS(41),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(647),
    [anon_sym_tensor] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_RPAREN] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(647),
    [anon_sym_indexvars] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(649),
    [sym_preproc_directive] = ACTIONS(649),
    [anon_sym_typedef] = ACTIONS(649),
    [anon_sym_extern] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_LBRACK] = ACTIONS(647),
    [anon_sym_RBRACK] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(649),
    [anon_sym_auto] = ACTIONS(649),
    [anon_sym_register] = ACTIONS(649),
    [anon_sym_inline] = ACTIONS(649),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_restrict] = ACTIONS(649),
    [anon_sym_volatile] = ACTIONS(649),
    [anon_sym__Atomic] = ACTIONS(649),
    [anon_sym_unsigned] = ACTIONS(649),
    [anon_sym_long] = ACTIONS(649),
    [anon_sym_short] = ACTIONS(649),
    [sym_primitive_type] = ACTIONS(649),
    [anon_sym_enum] = ACTIONS(649),
    [anon_sym_struct] = ACTIONS(649),
    [anon_sym_union] = ACTIONS(649),
    [anon_sym_COLON] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_STAR_EQ] = ACTIONS(647),
    [anon_sym_SLASH_EQ] = ACTIONS(647),
    [anon_sym_PERCENT_EQ] = ACTIONS(647),
    [anon_sym_PLUS_EQ] = ACTIONS(647),
    [anon_sym_DASH_EQ] = ACTIONS(647),
    [anon_sym_LT_LT_EQ] = ACTIONS(647),
    [anon_sym_GT_GT_EQ] = ACTIONS(647),
    [anon_sym_AMP_EQ] = ACTIONS(647),
    [anon_sym_CARET_EQ] = ACTIONS(647),
    [anon_sym_PIPE_EQ] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(649),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(649),
    [anon_sym_CARET] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_LT] = ACTIONS(649),
    [anon_sym_GT] = ACTIONS(649),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_GT_EQ] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(649),
    [anon_sym_GT_GT] = ACTIONS(649),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(649),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_PERCENT] = ACTIONS(649),
    [anon_sym_DASH_DASH] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(647),
    [anon_sym_DQUOTE] = ACTIONS(647),
    [sym_identifier] = ACTIONS(649),
    [sym_comment] = ACTIONS(41),
  },
  [136] = {
    [aux_sym_string_literal_repeat1] = STATE(136),
    [anon_sym_DQUOTE] = ACTIONS(651),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(653),
    [sym_escape_sequence] = ACTIONS(653),
    [sym_comment] = ACTIONS(55),
  },
  [137] = {
    [anon_sym_LF] = ACTIONS(656),
    [sym_preproc_arg] = ACTIONS(656),
    [sym_comment] = ACTIONS(55),
  },
  [138] = {
    [aux_sym_preproc_params_repeat1] = STATE(276),
    [anon_sym_RPAREN] = ACTIONS(658),
    [anon_sym_COMMA] = ACTIONS(660),
    [sym_comment] = ACTIONS(41),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(662),
    [anon_sym_tensor] = ACTIONS(664),
    [anon_sym_LPAREN] = ACTIONS(662),
    [anon_sym_LBRACE] = ACTIONS(662),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_SEMI] = ACTIONS(662),
    [anon_sym_indexvars] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(664),
    [anon_sym_typedef] = ACTIONS(664),
    [anon_sym_extern] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_auto] = ACTIONS(664),
    [anon_sym_register] = ACTIONS(664),
    [anon_sym_inline] = ACTIONS(664),
    [anon_sym_const] = ACTIONS(664),
    [anon_sym_restrict] = ACTIONS(664),
    [anon_sym_volatile] = ACTIONS(664),
    [anon_sym__Atomic] = ACTIONS(664),
    [anon_sym_unsigned] = ACTIONS(664),
    [anon_sym_long] = ACTIONS(664),
    [anon_sym_short] = ACTIONS(664),
    [sym_primitive_type] = ACTIONS(664),
    [anon_sym_enum] = ACTIONS(664),
    [anon_sym_struct] = ACTIONS(664),
    [anon_sym_union] = ACTIONS(664),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(664),
    [anon_sym_case] = ACTIONS(664),
    [anon_sym_default] = ACTIONS(664),
    [anon_sym_while] = ACTIONS(664),
    [anon_sym_do] = ACTIONS(664),
    [anon_sym_for] = ACTIONS(664),
    [anon_sym_return] = ACTIONS(664),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_TILDE] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_DASH_DASH] = ACTIONS(662),
    [anon_sym_PLUS_PLUS] = ACTIONS(662),
    [anon_sym_sizeof] = ACTIONS(664),
    [sym_number_literal] = ACTIONS(662),
    [anon_sym_SQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(662),
    [sym_true] = ACTIONS(664),
    [sym_false] = ACTIONS(664),
    [sym_null] = ACTIONS(664),
    [sym_identifier] = ACTIONS(664),
    [sym_comment] = ACTIONS(41),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(666),
    [anon_sym_tensor] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_indexvars] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(668),
    [sym_preproc_directive] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_auto] = ACTIONS(668),
    [anon_sym_register] = ACTIONS(668),
    [anon_sym_inline] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_restrict] = ACTIONS(668),
    [anon_sym_volatile] = ACTIONS(668),
    [anon_sym__Atomic] = ACTIONS(668),
    [anon_sym_unsigned] = ACTIONS(668),
    [anon_sym_long] = ACTIONS(668),
    [anon_sym_short] = ACTIONS(668),
    [sym_primitive_type] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_union] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_switch] = ACTIONS(668),
    [anon_sym_case] = ACTIONS(668),
    [anon_sym_default] = ACTIONS(668),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(668),
    [anon_sym_for] = ACTIONS(668),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_break] = ACTIONS(668),
    [anon_sym_continue] = ACTIONS(668),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(666),
    [anon_sym_sizeof] = ACTIONS(668),
    [sym_number_literal] = ACTIONS(666),
    [anon_sym_SQUOTE] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [sym_true] = ACTIONS(668),
    [sym_false] = ACTIONS(668),
    [sym_null] = ACTIONS(668),
    [sym_identifier] = ACTIONS(668),
    [sym_comment] = ACTIONS(41),
  },
  [141] = {
    [anon_sym_LF] = ACTIONS(670),
    [sym_comment] = ACTIONS(55),
  },
  [142] = {
    [sym_identifier] = ACTIONS(672),
    [sym_comment] = ACTIONS(41),
  },
  [143] = {
    [anon_sym_SEMI] = ACTIONS(674),
    [sym_comment] = ACTIONS(41),
  },
  [144] = {
    [aux_sym_string_literal_repeat1] = STATE(281),
    [anon_sym_DQUOTE] = ACTIONS(676),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(678),
    [sym_escape_sequence] = ACTIONS(678),
    [sym_comment] = ACTIONS(55),
  },
  [145] = {
    [anon_sym_tensor] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_indexvars] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(135),
    [sym_preproc_directive] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(135),
    [anon_sym_extern] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(135),
    [anon_sym_auto] = ACTIONS(135),
    [anon_sym_register] = ACTIONS(135),
    [anon_sym_inline] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(135),
    [anon_sym_restrict] = ACTIONS(135),
    [anon_sym_volatile] = ACTIONS(135),
    [anon_sym__Atomic] = ACTIONS(135),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(135),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_union] = ACTIONS(135),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(135),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(135),
    [anon_sym_for] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(135),
    [anon_sym_goto] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(133),
    [anon_sym_sizeof] = ACTIONS(135),
    [sym_number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(133),
    [anon_sym_DQUOTE] = ACTIONS(133),
    [sym_true] = ACTIONS(135),
    [sym_false] = ACTIONS(135),
    [sym_null] = ACTIONS(135),
    [sym_identifier] = ACTIONS(135),
    [sym_comment] = ACTIONS(41),
  },
  [146] = {
    [sym_preproc_params] = STATE(284),
    [anon_sym_LF] = ACTIONS(680),
    [anon_sym_LPAREN2] = ACTIONS(139),
    [sym_preproc_arg] = ACTIONS(682),
    [sym_comment] = ACTIONS(55),
  },
  [147] = {
    [sym_ta_top_level] = STATE(287),
    [sym_preproc_include] = STATE(287),
    [sym_preproc_def] = STATE(287),
    [sym_preproc_function_def] = STATE(287),
    [sym_preproc_call] = STATE(287),
    [sym_preproc_if] = STATE(287),
    [sym_preproc_ifdef] = STATE(287),
    [sym_preproc_else] = STATE(286),
    [sym_preproc_elif] = STATE(286),
    [sym_function_definition] = STATE(287),
    [sym_declaration] = STATE(287),
    [sym_type_definition] = STATE(287),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(287),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(287),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(287),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(684),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [148] = {
    [sym_ta_top_level] = STATE(290),
    [sym_preproc_include] = STATE(290),
    [sym_preproc_def] = STATE(290),
    [sym_preproc_function_def] = STATE(290),
    [sym_preproc_call] = STATE(290),
    [sym_preproc_if] = STATE(290),
    [sym_preproc_ifdef] = STATE(290),
    [sym_preproc_else] = STATE(289),
    [sym_preproc_elif] = STATE(289),
    [sym_function_definition] = STATE(290),
    [sym_declaration] = STATE(290),
    [sym_type_definition] = STATE(290),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(290),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(290),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(290),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(686),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [149] = {
    [anon_sym_format] = ACTIONS(688),
    [sym_comment] = ACTIONS(41),
  },
  [150] = {
    [sym_ta_name_list] = STATE(292),
    [sym_identifier] = ACTIONS(45),
    [sym_comment] = ACTIONS(41),
  },
  [151] = {
    [sym_string_literal] = STATE(294),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_system_lib_string] = ACTIONS(692),
    [sym_comment] = ACTIONS(41),
  },
  [152] = {
    [sym_identifier] = ACTIONS(694),
    [sym_comment] = ACTIONS(41),
  },
  [153] = {
    [sym_preproc_arg] = ACTIONS(696),
    [sym_comment] = ACTIONS(55),
  },
  [154] = {
    [sym_identifier] = ACTIONS(698),
    [sym_comment] = ACTIONS(41),
  },
  [155] = {
    [anon_sym_LF] = ACTIONS(700),
    [sym_preproc_arg] = ACTIONS(702),
    [sym_comment] = ACTIONS(55),
  },
  [156] = {
    [sym_type_qualifier] = STATE(301),
    [sym__type_specifier] = STATE(300),
    [sym_sized_type_specifier] = STATE(300),
    [sym_enum_specifier] = STATE(300),
    [sym_struct_specifier] = STATE(300),
    [sym_union_specifier] = STATE(300),
    [sym_macro_type_specifier] = STATE(300),
    [aux_sym_type_definition_repeat1] = STATE(301),
    [aux_sym_sized_type_specifier_repeat1] = STATE(35),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(63),
    [anon_sym_long] = ACTIONS(63),
    [anon_sym_short] = ACTIONS(63),
    [sym_primitive_type] = ACTIONS(704),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [157] = {
    [sym_string_literal] = STATE(302),
    [anon_sym_extern] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(67),
    [anon_sym_auto] = ACTIONS(67),
    [anon_sym_register] = ACTIONS(67),
    [anon_sym_inline] = ACTIONS(67),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym_unsigned] = ACTIONS(67),
    [anon_sym_long] = ACTIONS(67),
    [anon_sym_short] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_identifier] = ACTIONS(67),
    [sym_comment] = ACTIONS(41),
  },
  [158] = {
    [sym__declarator] = STATE(304),
    [sym_pointer_declarator] = STATE(304),
    [sym_function_declarator] = STATE(304),
    [sym_array_declarator] = STATE(304),
    [sym_init_declarator] = STATE(305),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_SEMI] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(98),
    [sym_identifier] = ACTIONS(708),
    [sym_comment] = ACTIONS(41),
  },
  [159] = {
    [sym_ta_top_level] = STATE(306),
    [sym_preproc_include] = STATE(306),
    [sym_preproc_def] = STATE(306),
    [sym_preproc_function_def] = STATE(306),
    [sym_preproc_call] = STATE(306),
    [sym_preproc_if] = STATE(306),
    [sym_preproc_ifdef] = STATE(306),
    [sym_function_definition] = STATE(306),
    [sym_declaration] = STATE(306),
    [sym_type_definition] = STATE(306),
    [sym__declaration_specifiers] = STATE(158),
    [sym_linkage_specification] = STATE(306),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(306),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(306),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(381),
    [anon_sym_indexvars] = ACTIONS(383),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(710),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(393),
    [sym_preproc_directive] = ACTIONS(395),
    [anon_sym_typedef] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(399),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [160] = {
    [sym_ta_top_level] = STATE(308),
    [sym_preproc_include] = STATE(308),
    [sym_preproc_def] = STATE(308),
    [sym_preproc_function_def] = STATE(308),
    [sym_preproc_call] = STATE(308),
    [sym_preproc_if] = STATE(308),
    [sym_preproc_ifdef] = STATE(308),
    [sym_preproc_else] = STATE(307),
    [sym_preproc_elif] = STATE(307),
    [sym_function_definition] = STATE(308),
    [sym_declaration] = STATE(308),
    [sym_type_definition] = STATE(308),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(308),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(308),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(308),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [161] = {
    [anon_sym_tensor] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_indexvars] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(171),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(171),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_static] = ACTIONS(171),
    [anon_sym_auto] = ACTIONS(171),
    [anon_sym_register] = ACTIONS(171),
    [anon_sym_inline] = ACTIONS(171),
    [anon_sym_const] = ACTIONS(171),
    [anon_sym_restrict] = ACTIONS(171),
    [anon_sym_volatile] = ACTIONS(171),
    [anon_sym__Atomic] = ACTIONS(171),
    [anon_sym_unsigned] = ACTIONS(171),
    [anon_sym_long] = ACTIONS(171),
    [anon_sym_short] = ACTIONS(171),
    [sym_primitive_type] = ACTIONS(171),
    [anon_sym_enum] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(171),
    [anon_sym_union] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(171),
    [anon_sym_switch] = ACTIONS(171),
    [anon_sym_case] = ACTIONS(171),
    [anon_sym_default] = ACTIONS(171),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_for] = ACTIONS(171),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(171),
    [anon_sym_continue] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(171),
    [anon_sym_DASH] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(169),
    [anon_sym_sizeof] = ACTIONS(171),
    [sym_number_literal] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(169),
    [sym_true] = ACTIONS(171),
    [sym_false] = ACTIONS(171),
    [sym_null] = ACTIONS(171),
    [sym_identifier] = ACTIONS(171),
    [sym_comment] = ACTIONS(41),
  },
  [162] = {
    [anon_sym_LF] = ACTIONS(714),
    [sym_comment] = ACTIONS(55),
  },
  [163] = {
    [sym__type_declarator] = STATE(310),
    [sym_pointer_type_declarator] = STATE(310),
    [sym_function_type_declarator] = STATE(310),
    [sym_array_type_declarator] = STATE(310),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(177),
    [sym_identifier] = ACTIONS(179),
    [sym_comment] = ACTIONS(41),
  },
  [164] = {
    [sym_type_qualifier] = STATE(91),
    [sym__type_specifier] = STATE(311),
    [sym_sized_type_specifier] = STATE(311),
    [sym_enum_specifier] = STATE(311),
    [sym_struct_specifier] = STATE(311),
    [sym_union_specifier] = STATE(311),
    [sym_macro_type_specifier] = STATE(311),
    [aux_sym_type_definition_repeat1] = STATE(91),
    [aux_sym_sized_type_specifier_repeat1] = STATE(35),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(63),
    [anon_sym_long] = ACTIONS(63),
    [anon_sym_short] = ACTIONS(63),
    [sym_primitive_type] = ACTIONS(716),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [165] = {
    [sym_function_definition] = STATE(313),
    [sym_declaration] = STATE(313),
    [sym__declaration_specifiers] = STATE(314),
    [sym_declaration_list] = STATE(313),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LBRACE] = ACTIONS(718),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [166] = {
    [ts_builtin_sym_end] = ACTIONS(720),
    [anon_sym_tensor] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(720),
    [anon_sym_indexvars] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(722),
    [sym_preproc_directive] = ACTIONS(722),
    [anon_sym_typedef] = ACTIONS(722),
    [anon_sym_extern] = ACTIONS(722),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_auto] = ACTIONS(722),
    [anon_sym_register] = ACTIONS(722),
    [anon_sym_inline] = ACTIONS(722),
    [anon_sym_const] = ACTIONS(722),
    [anon_sym_restrict] = ACTIONS(722),
    [anon_sym_volatile] = ACTIONS(722),
    [anon_sym__Atomic] = ACTIONS(722),
    [anon_sym_unsigned] = ACTIONS(722),
    [anon_sym_long] = ACTIONS(722),
    [anon_sym_short] = ACTIONS(722),
    [sym_primitive_type] = ACTIONS(722),
    [anon_sym_enum] = ACTIONS(722),
    [anon_sym_struct] = ACTIONS(722),
    [anon_sym_union] = ACTIONS(722),
    [sym_identifier] = ACTIONS(722),
    [sym_comment] = ACTIONS(41),
  },
  [167] = {
    [anon_sym_tensor] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_SEMI] = ACTIONS(239),
    [anon_sym_indexvars] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(241),
    [sym_preproc_directive] = ACTIONS(241),
    [anon_sym_typedef] = ACTIONS(241),
    [anon_sym_extern] = ACTIONS(241),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_static] = ACTIONS(241),
    [anon_sym_auto] = ACTIONS(241),
    [anon_sym_register] = ACTIONS(241),
    [anon_sym_inline] = ACTIONS(241),
    [anon_sym_const] = ACTIONS(241),
    [anon_sym_restrict] = ACTIONS(241),
    [anon_sym_volatile] = ACTIONS(241),
    [anon_sym__Atomic] = ACTIONS(241),
    [anon_sym_unsigned] = ACTIONS(241),
    [anon_sym_long] = ACTIONS(241),
    [anon_sym_short] = ACTIONS(241),
    [sym_primitive_type] = ACTIONS(241),
    [anon_sym_enum] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(241),
    [anon_sym_union] = ACTIONS(241),
    [anon_sym_if] = ACTIONS(241),
    [anon_sym_switch] = ACTIONS(241),
    [anon_sym_case] = ACTIONS(241),
    [anon_sym_default] = ACTIONS(241),
    [anon_sym_while] = ACTIONS(241),
    [anon_sym_do] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(241),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_break] = ACTIONS(241),
    [anon_sym_continue] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_BANG] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(239),
    [anon_sym_PLUS_PLUS] = ACTIONS(239),
    [anon_sym_sizeof] = ACTIONS(241),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(241),
    [sym_comment] = ACTIONS(41),
  },
  [168] = {
    [sym_compound_statement] = STATE(317),
    [sym_parameter_list] = STATE(129),
    [aux_sym_declaration_repeat1] = STATE(318),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_COMMA] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(255),
    [sym_comment] = ACTIONS(41),
  },
  [169] = {
    [aux_sym_declaration_repeat1] = STATE(318),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_COMMA] = ACTIONS(251),
    [sym_comment] = ACTIONS(41),
  },
  [170] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(728),
    [sym_comment] = ACTIONS(41),
  },
  [171] = {
    [sym_ta_top_level] = STATE(171),
    [sym_preproc_include] = STATE(171),
    [sym_preproc_def] = STATE(171),
    [sym_preproc_function_def] = STATE(171),
    [sym_preproc_call] = STATE(171),
    [sym_preproc_if] = STATE(171),
    [sym_preproc_ifdef] = STATE(171),
    [sym_function_definition] = STATE(171),
    [sym_declaration] = STATE(171),
    [sym_type_definition] = STATE(171),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(171),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(171),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(171),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(730),
    [anon_sym_indexvars] = ACTIONS(733),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(736),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(742),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(747),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(747),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(745),
    [sym_preproc_directive] = ACTIONS(750),
    [anon_sym_typedef] = ACTIONS(753),
    [anon_sym_extern] = ACTIONS(756),
    [anon_sym_static] = ACTIONS(290),
    [anon_sym_auto] = ACTIONS(290),
    [anon_sym_register] = ACTIONS(290),
    [anon_sym_inline] = ACTIONS(290),
    [anon_sym_const] = ACTIONS(293),
    [anon_sym_restrict] = ACTIONS(293),
    [anon_sym_volatile] = ACTIONS(293),
    [anon_sym__Atomic] = ACTIONS(293),
    [anon_sym_unsigned] = ACTIONS(296),
    [anon_sym_long] = ACTIONS(296),
    [anon_sym_short] = ACTIONS(296),
    [sym_primitive_type] = ACTIONS(299),
    [anon_sym_enum] = ACTIONS(302),
    [anon_sym_struct] = ACTIONS(305),
    [anon_sym_union] = ACTIONS(308),
    [sym_identifier] = ACTIONS(311),
    [sym_comment] = ACTIONS(41),
  },
  [172] = {
    [ts_builtin_sym_end] = ACTIONS(759),
    [anon_sym_tensor] = ACTIONS(761),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_indexvars] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(761),
    [sym_preproc_directive] = ACTIONS(761),
    [anon_sym_typedef] = ACTIONS(761),
    [anon_sym_extern] = ACTIONS(761),
    [anon_sym_static] = ACTIONS(761),
    [anon_sym_auto] = ACTIONS(761),
    [anon_sym_register] = ACTIONS(761),
    [anon_sym_inline] = ACTIONS(761),
    [anon_sym_const] = ACTIONS(761),
    [anon_sym_restrict] = ACTIONS(761),
    [anon_sym_volatile] = ACTIONS(761),
    [anon_sym__Atomic] = ACTIONS(761),
    [anon_sym_unsigned] = ACTIONS(761),
    [anon_sym_long] = ACTIONS(761),
    [anon_sym_short] = ACTIONS(761),
    [sym_primitive_type] = ACTIONS(761),
    [anon_sym_enum] = ACTIONS(761),
    [anon_sym_struct] = ACTIONS(761),
    [anon_sym_union] = ACTIONS(761),
    [sym_identifier] = ACTIONS(761),
    [sym_comment] = ACTIONS(41),
  },
  [173] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(763),
    [sym_comment] = ACTIONS(41),
  },
  [174] = {
    [sym__type_declarator] = STATE(176),
    [sym_pointer_type_declarator] = STATE(176),
    [sym_function_type_declarator] = STATE(176),
    [sym_array_type_declarator] = STATE(176),
    [sym_type_qualifier] = STATE(321),
    [aux_sym_type_definition_repeat1] = STATE(321),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(429),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(41),
  },
  [175] = {
    [sym_parameter_list] = STATE(180),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_LBRACK] = ACTIONS(437),
    [sym_comment] = ACTIONS(41),
  },
  [176] = {
    [sym_parameter_list] = STATE(180),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(437),
    [sym_comment] = ACTIONS(41),
  },
  [177] = {
    [sym__type_declarator] = STATE(323),
    [sym_pointer_type_declarator] = STATE(323),
    [sym_function_type_declarator] = STATE(323),
    [sym_array_type_declarator] = STATE(323),
    [sym_type_qualifier] = STATE(215),
    [aux_sym_type_definition_repeat1] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(177),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(41),
  },
  [178] = {
    [ts_builtin_sym_end] = ACTIONS(769),
    [anon_sym_tensor] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_indexvars] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(771),
    [sym_preproc_directive] = ACTIONS(771),
    [anon_sym_typedef] = ACTIONS(771),
    [anon_sym_extern] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(769),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_auto] = ACTIONS(771),
    [anon_sym_register] = ACTIONS(771),
    [anon_sym_inline] = ACTIONS(771),
    [anon_sym_const] = ACTIONS(771),
    [anon_sym_restrict] = ACTIONS(771),
    [anon_sym_volatile] = ACTIONS(771),
    [anon_sym__Atomic] = ACTIONS(771),
    [anon_sym_unsigned] = ACTIONS(771),
    [anon_sym_long] = ACTIONS(771),
    [anon_sym_short] = ACTIONS(771),
    [sym_primitive_type] = ACTIONS(771),
    [anon_sym_enum] = ACTIONS(771),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_union] = ACTIONS(771),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_break] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_goto] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(769),
    [anon_sym_PLUS_PLUS] = ACTIONS(769),
    [anon_sym_sizeof] = ACTIONS(771),
    [sym_number_literal] = ACTIONS(769),
    [anon_sym_SQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [sym_true] = ACTIONS(771),
    [sym_false] = ACTIONS(771),
    [sym_null] = ACTIONS(771),
    [sym_identifier] = ACTIONS(771),
    [sym_comment] = ACTIONS(41),
  },
  [179] = {
    [sym__declaration_specifiers] = STATE(325),
    [sym_storage_class_specifier] = STATE(266),
    [sym_type_qualifier] = STATE(266),
    [sym__type_specifier] = STATE(263),
    [sym_sized_type_specifier] = STATE(263),
    [sym_enum_specifier] = STATE(263),
    [sym_struct_specifier] = STATE(263),
    [sym_union_specifier] = STATE(263),
    [sym__expression] = STATE(326),
    [sym_conditional_expression] = STATE(326),
    [sym_assignment_expression] = STATE(326),
    [sym_pointer_expression] = STATE(326),
    [sym_logical_expression] = STATE(326),
    [sym_bitwise_expression] = STATE(326),
    [sym_equality_expression] = STATE(326),
    [sym_relational_expression] = STATE(326),
    [sym_shift_expression] = STATE(326),
    [sym_math_expression] = STATE(326),
    [sym_cast_expression] = STATE(326),
    [sym_sizeof_expression] = STATE(326),
    [sym_subscript_expression] = STATE(326),
    [sym_call_expression] = STATE(326),
    [sym_field_expression] = STATE(326),
    [sym_compound_literal_expression] = STATE(326),
    [sym_parenthesized_expression] = STATE(326),
    [sym_char_literal] = STATE(326),
    [sym_concatenated_string] = STATE(326),
    [sym_string_literal] = STATE(265),
    [sym_macro_type_specifier] = STATE(263),
    [aux_sym__declaration_specifiers_repeat1] = STATE(266),
    [aux_sym_sized_type_specifier_repeat1] = STATE(267),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(773),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(603),
    [anon_sym_long] = ACTIONS(603),
    [anon_sym_short] = ACTIONS(603),
    [sym_primitive_type] = ACTIONS(605),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(775),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(777),
    [sym_false] = ACTIONS(777),
    [sym_null] = ACTIONS(777),
    [sym_identifier] = ACTIONS(621),
    [sym_comment] = ACTIONS(41),
  },
  [180] = {
    [anon_sym_LPAREN] = ACTIONS(779),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(779),
    [sym_comment] = ACTIONS(41),
  },
  [181] = {
    [sym_parameter_list] = STATE(180),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_LBRACK] = ACTIONS(437),
    [sym_comment] = ACTIONS(41),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(783),
    [anon_sym_tensor] = ACTIONS(785),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_indexvars] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(785),
    [sym_preproc_directive] = ACTIONS(785),
    [anon_sym_typedef] = ACTIONS(785),
    [anon_sym_extern] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(785),
    [anon_sym_auto] = ACTIONS(785),
    [anon_sym_register] = ACTIONS(785),
    [anon_sym_inline] = ACTIONS(785),
    [anon_sym_const] = ACTIONS(785),
    [anon_sym_restrict] = ACTIONS(785),
    [anon_sym_volatile] = ACTIONS(785),
    [anon_sym__Atomic] = ACTIONS(785),
    [anon_sym_unsigned] = ACTIONS(785),
    [anon_sym_long] = ACTIONS(785),
    [anon_sym_short] = ACTIONS(785),
    [sym_primitive_type] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_struct] = ACTIONS(785),
    [anon_sym_union] = ACTIONS(785),
    [sym_identifier] = ACTIONS(785),
    [sym_comment] = ACTIONS(41),
  },
  [183] = {
    [sym_ta_top_level] = STATE(329),
    [sym_preproc_include] = STATE(329),
    [sym_preproc_def] = STATE(329),
    [sym_preproc_function_def] = STATE(329),
    [sym_preproc_call] = STATE(329),
    [sym_preproc_if] = STATE(329),
    [sym_preproc_ifdef] = STATE(329),
    [sym_function_definition] = STATE(329),
    [sym_declaration] = STATE(329),
    [sym_type_definition] = STATE(329),
    [sym__declaration_specifiers] = STATE(18),
    [sym_linkage_specification] = STATE(329),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(329),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(329),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(787),
    [anon_sym_indexvars] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(17),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [184] = {
    [sym_storage_class_specifier] = STATE(330),
    [sym_type_qualifier] = STATE(330),
    [aux_sym__declaration_specifiers_repeat1] = STATE(330),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(41),
  },
  [185] = {
    [sym_storage_class_specifier] = STATE(331),
    [sym_type_qualifier] = STATE(331),
    [aux_sym__declaration_specifiers_repeat1] = STATE(331),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(41),
  },
  [186] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(186),
    [anon_sym_LPAREN] = ACTIONS(330),
    [anon_sym_extern] = ACTIONS(332),
    [anon_sym_STAR] = ACTIONS(330),
    [anon_sym_static] = ACTIONS(332),
    [anon_sym_auto] = ACTIONS(332),
    [anon_sym_register] = ACTIONS(332),
    [anon_sym_inline] = ACTIONS(332),
    [anon_sym_const] = ACTIONS(332),
    [anon_sym_restrict] = ACTIONS(332),
    [anon_sym_volatile] = ACTIONS(332),
    [anon_sym__Atomic] = ACTIONS(332),
    [anon_sym_unsigned] = ACTIONS(789),
    [anon_sym_long] = ACTIONS(789),
    [anon_sym_short] = ACTIONS(789),
    [sym_primitive_type] = ACTIONS(332),
    [sym_identifier] = ACTIONS(332),
    [sym_comment] = ACTIONS(41),
  },
  [187] = {
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(792),
    [anon_sym_SEMI] = ACTIONS(792),
    [anon_sym_COMMA] = ACTIONS(792),
    [anon_sym_extern] = ACTIONS(794),
    [anon_sym_STAR] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(792),
    [anon_sym_static] = ACTIONS(794),
    [anon_sym_auto] = ACTIONS(794),
    [anon_sym_register] = ACTIONS(794),
    [anon_sym_inline] = ACTIONS(794),
    [anon_sym_const] = ACTIONS(794),
    [anon_sym_restrict] = ACTIONS(794),
    [anon_sym_volatile] = ACTIONS(794),
    [anon_sym__Atomic] = ACTIONS(794),
    [anon_sym_COLON] = ACTIONS(792),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_PLUS] = ACTIONS(794),
    [anon_sym_DASH] = ACTIONS(794),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_sizeof] = ACTIONS(794),
    [sym_number_literal] = ACTIONS(792),
    [anon_sym_SQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(792),
    [sym_true] = ACTIONS(794),
    [sym_false] = ACTIONS(794),
    [sym_null] = ACTIONS(794),
    [sym_identifier] = ACTIONS(794),
    [sym_comment] = ACTIONS(41),
  },
  [188] = {
    [sym__expression] = STATE(338),
    [sym_conditional_expression] = STATE(338),
    [sym_assignment_expression] = STATE(338),
    [sym_pointer_expression] = STATE(338),
    [sym_logical_expression] = STATE(338),
    [sym_bitwise_expression] = STATE(338),
    [sym_equality_expression] = STATE(338),
    [sym_relational_expression] = STATE(338),
    [sym_shift_expression] = STATE(338),
    [sym_math_expression] = STATE(338),
    [sym_cast_expression] = STATE(338),
    [sym_sizeof_expression] = STATE(338),
    [sym_subscript_expression] = STATE(338),
    [sym_call_expression] = STATE(338),
    [sym_field_expression] = STATE(338),
    [sym_compound_literal_expression] = STATE(338),
    [sym_parenthesized_expression] = STATE(338),
    [sym_char_literal] = STATE(338),
    [sym_concatenated_string] = STATE(338),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(810),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(812),
    [sym_false] = ACTIONS(812),
    [sym_null] = ACTIONS(812),
    [sym_identifier] = ACTIONS(812),
    [sym_comment] = ACTIONS(41),
  },
  [189] = {
    [sym_enumerator] = STATE(341),
    [anon_sym_RBRACE] = ACTIONS(814),
    [sym_identifier] = ACTIONS(195),
    [sym_comment] = ACTIONS(41),
  },
  [190] = {
    [aux_sym_enumerator_list_repeat1] = STATE(343),
    [anon_sym_RBRACE] = ACTIONS(814),
    [anon_sym_COMMA] = ACTIONS(816),
    [sym_comment] = ACTIONS(41),
  },
  [191] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(348),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(348),
    [sym_preproc_else_in_field_declaration_list] = STATE(347),
    [sym_preproc_elif_in_field_declaration_list] = STATE(347),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(348),
    [sym_field_declaration] = STATE(348),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(348),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(207),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(818),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(820),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(822),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [192] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(351),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(351),
    [sym_preproc_else_in_field_declaration_list] = STATE(350),
    [sym_preproc_elif_in_field_declaration_list] = STATE(350),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(351),
    [sym_field_declaration] = STATE(351),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(351),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(207),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(824),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(820),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(822),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [193] = {
    [sym__field_declarator] = STATE(353),
    [sym_pointer_field_declarator] = STATE(353),
    [sym_function_field_declarator] = STATE(353),
    [sym_array_field_declarator] = STATE(353),
    [anon_sym_LPAREN] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(826),
    [sym_identifier] = ACTIONS(489),
    [sym_comment] = ACTIONS(41),
  },
  [194] = {
    [anon_sym_RBRACE] = ACTIONS(828),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(830),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(828),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(828),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(828),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(828),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(828),
    [anon_sym_extern] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(830),
    [anon_sym_auto] = ACTIONS(830),
    [anon_sym_register] = ACTIONS(830),
    [anon_sym_inline] = ACTIONS(830),
    [anon_sym_const] = ACTIONS(830),
    [anon_sym_restrict] = ACTIONS(830),
    [anon_sym_volatile] = ACTIONS(830),
    [anon_sym__Atomic] = ACTIONS(830),
    [anon_sym_unsigned] = ACTIONS(830),
    [anon_sym_long] = ACTIONS(830),
    [anon_sym_short] = ACTIONS(830),
    [sym_primitive_type] = ACTIONS(830),
    [anon_sym_enum] = ACTIONS(830),
    [anon_sym_struct] = ACTIONS(830),
    [anon_sym_union] = ACTIONS(830),
    [sym_identifier] = ACTIONS(830),
    [sym_comment] = ACTIONS(41),
  },
  [195] = {
    [sym__field_declarator] = STATE(354),
    [sym_pointer_field_declarator] = STATE(354),
    [sym_function_field_declarator] = STATE(354),
    [sym_array_field_declarator] = STATE(354),
    [sym_type_qualifier] = STATE(355),
    [aux_sym_type_definition_repeat1] = STATE(355),
    [anon_sym_LPAREN] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(485),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(832),
    [sym_comment] = ACTIONS(41),
  },
  [196] = {
    [sym__expression] = STATE(362),
    [sym_conditional_expression] = STATE(362),
    [sym_assignment_expression] = STATE(362),
    [sym_pointer_expression] = STATE(362),
    [sym_logical_expression] = STATE(362),
    [sym_bitwise_expression] = STATE(362),
    [sym_equality_expression] = STATE(362),
    [sym_relational_expression] = STATE(362),
    [sym_shift_expression] = STATE(362),
    [sym_math_expression] = STATE(362),
    [sym_cast_expression] = STATE(362),
    [sym_sizeof_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_call_expression] = STATE(362),
    [sym_field_expression] = STATE(362),
    [sym_compound_literal_expression] = STATE(362),
    [sym_parenthesized_expression] = STATE(362),
    [sym_char_literal] = STATE(362),
    [sym_concatenated_string] = STATE(362),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(848),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(850),
    [sym_false] = ACTIONS(850),
    [sym_null] = ACTIONS(850),
    [sym_identifier] = ACTIONS(850),
    [sym_comment] = ACTIONS(41),
  },
  [197] = {
    [anon_sym_LPAREN] = ACTIONS(852),
    [anon_sym_RPAREN] = ACTIONS(852),
    [anon_sym_SEMI] = ACTIONS(852),
    [anon_sym_COMMA] = ACTIONS(852),
    [anon_sym_LBRACK] = ACTIONS(852),
    [anon_sym_COLON] = ACTIONS(852),
    [sym_comment] = ACTIONS(41),
  },
  [198] = {
    [sym_parameter_list] = STATE(368),
    [aux_sym_field_declaration_repeat1] = STATE(369),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(854),
    [anon_sym_COMMA] = ACTIONS(856),
    [anon_sym_LBRACK] = ACTIONS(858),
    [anon_sym_COLON] = ACTIONS(860),
    [sym_comment] = ACTIONS(41),
  },
  [199] = {
    [sym_storage_class_specifier] = STATE(370),
    [sym_type_qualifier] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(370),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_SEMI] = ACTIONS(257),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(257),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(41),
  },
  [200] = {
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_RPAREN] = ACTIONS(862),
    [anon_sym_SEMI] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(862),
    [anon_sym_extern] = ACTIONS(864),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACK] = ACTIONS(862),
    [anon_sym_RBRACK] = ACTIONS(862),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_auto] = ACTIONS(864),
    [anon_sym_register] = ACTIONS(864),
    [anon_sym_inline] = ACTIONS(864),
    [anon_sym_const] = ACTIONS(864),
    [anon_sym_restrict] = ACTIONS(864),
    [anon_sym_volatile] = ACTIONS(864),
    [anon_sym__Atomic] = ACTIONS(864),
    [anon_sym_COLON] = ACTIONS(862),
    [anon_sym_AMP] = ACTIONS(862),
    [anon_sym_BANG] = ACTIONS(862),
    [anon_sym_TILDE] = ACTIONS(862),
    [anon_sym_PLUS] = ACTIONS(864),
    [anon_sym_DASH] = ACTIONS(864),
    [anon_sym_DASH_DASH] = ACTIONS(862),
    [anon_sym_PLUS_PLUS] = ACTIONS(862),
    [anon_sym_sizeof] = ACTIONS(864),
    [sym_number_literal] = ACTIONS(862),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE] = ACTIONS(862),
    [sym_true] = ACTIONS(864),
    [sym_false] = ACTIONS(864),
    [sym_null] = ACTIONS(864),
    [sym_identifier] = ACTIONS(864),
    [sym_comment] = ACTIONS(41),
  },
  [201] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(201),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(201),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(201),
    [sym_field_declaration] = STATE(201),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(201),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [anon_sym_RBRACE] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(871),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(871),
    [anon_sym_extern] = ACTIONS(874),
    [anon_sym_static] = ACTIONS(874),
    [anon_sym_auto] = ACTIONS(874),
    [anon_sym_register] = ACTIONS(874),
    [anon_sym_inline] = ACTIONS(874),
    [anon_sym_const] = ACTIONS(877),
    [anon_sym_restrict] = ACTIONS(877),
    [anon_sym_volatile] = ACTIONS(877),
    [anon_sym__Atomic] = ACTIONS(877),
    [anon_sym_unsigned] = ACTIONS(880),
    [anon_sym_long] = ACTIONS(880),
    [anon_sym_short] = ACTIONS(880),
    [sym_primitive_type] = ACTIONS(883),
    [anon_sym_enum] = ACTIONS(886),
    [anon_sym_struct] = ACTIONS(889),
    [anon_sym_union] = ACTIONS(892),
    [sym_identifier] = ACTIONS(895),
    [sym_comment] = ACTIONS(41),
  },
  [202] = {
    [sym_storage_class_specifier] = STATE(371),
    [sym_type_qualifier] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(371),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_SEMI] = ACTIONS(257),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(257),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(41),
  },
  [203] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(203),
    [anon_sym_LPAREN] = ACTIONS(330),
    [anon_sym_SEMI] = ACTIONS(330),
    [anon_sym_extern] = ACTIONS(332),
    [anon_sym_STAR] = ACTIONS(330),
    [anon_sym_static] = ACTIONS(332),
    [anon_sym_auto] = ACTIONS(332),
    [anon_sym_register] = ACTIONS(332),
    [anon_sym_inline] = ACTIONS(332),
    [anon_sym_const] = ACTIONS(332),
    [anon_sym_restrict] = ACTIONS(332),
    [anon_sym_volatile] = ACTIONS(332),
    [anon_sym__Atomic] = ACTIONS(332),
    [anon_sym_unsigned] = ACTIONS(898),
    [anon_sym_long] = ACTIONS(898),
    [anon_sym_short] = ACTIONS(898),
    [sym_primitive_type] = ACTIONS(332),
    [anon_sym_COLON] = ACTIONS(330),
    [sym_identifier] = ACTIONS(332),
    [sym_comment] = ACTIONS(41),
  },
  [204] = {
    [sym__declaration_specifiers] = STATE(218),
    [sym__abstract_declarator] = STATE(372),
    [sym_abstract_pointer_declarator] = STATE(372),
    [sym_abstract_function_declarator] = STATE(372),
    [sym_abstract_array_declarator] = STATE(372),
    [sym_storage_class_specifier] = STATE(220),
    [sym_type_qualifier] = STATE(220),
    [sym__type_specifier] = STATE(219),
    [sym_sized_type_specifier] = STATE(219),
    [sym_enum_specifier] = STATE(219),
    [sym_struct_specifier] = STATE(219),
    [sym_union_specifier] = STATE(219),
    [sym_parameter_list] = STATE(208),
    [sym_parameter_declaration] = STATE(217),
    [sym_macro_type_specifier] = STATE(219),
    [aux_sym__declaration_specifiers_repeat1] = STATE(220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(221),
    [anon_sym_LPAREN] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(529),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(531),
    [anon_sym_long] = ACTIONS(531),
    [anon_sym_short] = ACTIONS(531),
    [sym_primitive_type] = ACTIONS(533),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [205] = {
    [sym__abstract_declarator] = STATE(373),
    [sym_abstract_pointer_declarator] = STATE(373),
    [sym_abstract_function_declarator] = STATE(373),
    [sym_abstract_array_declarator] = STATE(373),
    [sym_type_qualifier] = STATE(374),
    [sym_parameter_list] = STATE(208),
    [aux_sym_type_definition_repeat1] = STATE(374),
    [anon_sym_LPAREN] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_STAR] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_const] = ACTIONS(903),
    [anon_sym_restrict] = ACTIONS(903),
    [anon_sym_volatile] = ACTIONS(903),
    [anon_sym__Atomic] = ACTIONS(903),
    [sym_comment] = ACTIONS(41),
  },
  [206] = {
    [sym__declaration_specifiers] = STATE(376),
    [sym_storage_class_specifier] = STATE(266),
    [sym_type_qualifier] = STATE(266),
    [sym__type_specifier] = STATE(263),
    [sym_sized_type_specifier] = STATE(263),
    [sym_enum_specifier] = STATE(263),
    [sym_struct_specifier] = STATE(263),
    [sym_union_specifier] = STATE(263),
    [sym__expression] = STATE(377),
    [sym_conditional_expression] = STATE(377),
    [sym_assignment_expression] = STATE(377),
    [sym_pointer_expression] = STATE(377),
    [sym_logical_expression] = STATE(377),
    [sym_bitwise_expression] = STATE(377),
    [sym_equality_expression] = STATE(377),
    [sym_relational_expression] = STATE(377),
    [sym_shift_expression] = STATE(377),
    [sym_math_expression] = STATE(377),
    [sym_cast_expression] = STATE(377),
    [sym_sizeof_expression] = STATE(377),
    [sym_subscript_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_field_expression] = STATE(377),
    [sym_compound_literal_expression] = STATE(377),
    [sym_parenthesized_expression] = STATE(377),
    [sym_char_literal] = STATE(377),
    [sym_concatenated_string] = STATE(377),
    [sym_string_literal] = STATE(265),
    [sym_macro_type_specifier] = STATE(263),
    [aux_sym__declaration_specifiers_repeat1] = STATE(266),
    [aux_sym_sized_type_specifier_repeat1] = STATE(267),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(603),
    [anon_sym_long] = ACTIONS(603),
    [anon_sym_short] = ACTIONS(603),
    [sym_primitive_type] = ACTIONS(605),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(907),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(909),
    [sym_false] = ACTIONS(909),
    [sym_null] = ACTIONS(909),
    [sym_identifier] = ACTIONS(621),
    [sym_comment] = ACTIONS(41),
  },
  [207] = {
    [sym_parameter_list] = STATE(379),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(913),
    [sym_comment] = ACTIONS(41),
  },
  [208] = {
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(915),
    [sym_comment] = ACTIONS(41),
  },
  [209] = {
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_extern] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_RBRACK] = ACTIONS(917),
    [anon_sym_static] = ACTIONS(919),
    [anon_sym_auto] = ACTIONS(919),
    [anon_sym_register] = ACTIONS(919),
    [anon_sym_inline] = ACTIONS(919),
    [anon_sym_const] = ACTIONS(919),
    [anon_sym_restrict] = ACTIONS(919),
    [anon_sym_volatile] = ACTIONS(919),
    [anon_sym__Atomic] = ACTIONS(919),
    [anon_sym_COLON] = ACTIONS(917),
    [anon_sym_AMP] = ACTIONS(917),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_TILDE] = ACTIONS(917),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(919),
    [anon_sym_DASH_DASH] = ACTIONS(917),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_sizeof] = ACTIONS(919),
    [sym_number_literal] = ACTIONS(917),
    [anon_sym_SQUOTE] = ACTIONS(917),
    [anon_sym_DQUOTE] = ACTIONS(917),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_null] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_comment] = ACTIONS(41),
  },
  [210] = {
    [sym__abstract_declarator] = STATE(380),
    [sym_abstract_pointer_declarator] = STATE(380),
    [sym_abstract_function_declarator] = STATE(380),
    [sym_abstract_array_declarator] = STATE(380),
    [sym_parameter_list] = STATE(208),
    [anon_sym_LPAREN] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(511),
    [sym_comment] = ACTIONS(41),
  },
  [211] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(211),
    [anon_sym_LPAREN] = ACTIONS(330),
    [anon_sym_RPAREN] = ACTIONS(330),
    [anon_sym_STAR] = ACTIONS(330),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_unsigned] = ACTIONS(921),
    [anon_sym_long] = ACTIONS(921),
    [anon_sym_short] = ACTIONS(921),
    [sym_primitive_type] = ACTIONS(332),
    [sym_identifier] = ACTIONS(332),
    [sym_comment] = ACTIONS(41),
  },
  [212] = {
    [sym__declarator] = STATE(214),
    [sym_pointer_declarator] = STATE(214),
    [sym_function_declarator] = STATE(214),
    [sym_array_declarator] = STATE(214),
    [sym_type_qualifier] = STATE(215),
    [aux_sym_type_definition_repeat1] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(525),
    [sym_comment] = ACTIONS(41),
  },
  [213] = {
    [anon_sym_LPAREN] = ACTIONS(924),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_RPAREN] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_COMMA] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(924),
    [anon_sym_EQ] = ACTIONS(924),
    [sym_comment] = ACTIONS(41),
  },
  [214] = {
    [sym_parameter_list] = STATE(129),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(926),
    [anon_sym_RPAREN] = ACTIONS(926),
    [anon_sym_SEMI] = ACTIONS(926),
    [anon_sym_COMMA] = ACTIONS(926),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(926),
    [sym_comment] = ACTIONS(41),
  },
  [215] = {
    [sym_type_qualifier] = STATE(215),
    [aux_sym_type_definition_repeat1] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_const] = ACTIONS(439),
    [anon_sym_restrict] = ACTIONS(439),
    [anon_sym_volatile] = ACTIONS(439),
    [anon_sym__Atomic] = ACTIONS(439),
    [sym_identifier] = ACTIONS(442),
    [sym_comment] = ACTIONS(41),
  },
  [216] = {
    [anon_sym_LPAREN] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(930),
    [anon_sym_RPAREN] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(930),
    [anon_sym_COMMA] = ACTIONS(930),
    [anon_sym_LBRACK] = ACTIONS(930),
    [anon_sym_EQ] = ACTIONS(930),
    [anon_sym_COLON] = ACTIONS(930),
    [sym_comment] = ACTIONS(41),
  },
  [217] = {
    [aux_sym_parameter_list_repeat1] = STATE(383),
    [anon_sym_RPAREN] = ACTIONS(932),
    [anon_sym_COMMA] = ACTIONS(934),
    [sym_comment] = ACTIONS(41),
  },
  [218] = {
    [sym__declarator] = STATE(386),
    [sym__abstract_declarator] = STATE(387),
    [sym_pointer_declarator] = STATE(386),
    [sym_abstract_pointer_declarator] = STATE(387),
    [sym_function_declarator] = STATE(386),
    [sym_abstract_function_declarator] = STATE(387),
    [sym_array_declarator] = STATE(386),
    [sym_abstract_array_declarator] = STATE(387),
    [sym_parameter_list] = STATE(208),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_RPAREN] = ACTIONS(938),
    [anon_sym_COMMA] = ACTIONS(938),
    [anon_sym_STAR] = ACTIONS(940),
    [anon_sym_LBRACK] = ACTIONS(511),
    [sym_identifier] = ACTIONS(942),
    [sym_comment] = ACTIONS(41),
  },
  [219] = {
    [sym_storage_class_specifier] = STATE(388),
    [sym_type_qualifier] = STATE(388),
    [aux_sym__declaration_specifiers_repeat1] = STATE(388),
    [anon_sym_LPAREN] = ACTIONS(102),
    [anon_sym_RPAREN] = ACTIONS(102),
    [anon_sym_COMMA] = ACTIONS(102),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(102),
    [anon_sym_LBRACK] = ACTIONS(102),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(104),
    [sym_comment] = ACTIONS(41),
  },
  [220] = {
    [sym_storage_class_specifier] = STATE(54),
    [sym_type_qualifier] = STATE(54),
    [sym__type_specifier] = STATE(389),
    [sym_sized_type_specifier] = STATE(389),
    [sym_enum_specifier] = STATE(389),
    [sym_struct_specifier] = STATE(389),
    [sym_union_specifier] = STATE(389),
    [sym_macro_type_specifier] = STATE(389),
    [aux_sym__declaration_specifiers_repeat1] = STATE(54),
    [aux_sym_sized_type_specifier_repeat1] = STATE(221),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(531),
    [anon_sym_long] = ACTIONS(531),
    [anon_sym_short] = ACTIONS(531),
    [sym_primitive_type] = ACTIONS(944),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [221] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(390),
    [anon_sym_LPAREN] = ACTIONS(110),
    [anon_sym_RPAREN] = ACTIONS(110),
    [anon_sym_COMMA] = ACTIONS(110),
    [anon_sym_extern] = ACTIONS(112),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_LBRACK] = ACTIONS(110),
    [anon_sym_static] = ACTIONS(112),
    [anon_sym_auto] = ACTIONS(112),
    [anon_sym_register] = ACTIONS(112),
    [anon_sym_inline] = ACTIONS(112),
    [anon_sym_const] = ACTIONS(112),
    [anon_sym_restrict] = ACTIONS(112),
    [anon_sym_volatile] = ACTIONS(112),
    [anon_sym__Atomic] = ACTIONS(112),
    [anon_sym_unsigned] = ACTIONS(946),
    [anon_sym_long] = ACTIONS(946),
    [anon_sym_short] = ACTIONS(946),
    [sym_primitive_type] = ACTIONS(116),
    [sym_identifier] = ACTIONS(118),
    [sym_comment] = ACTIONS(41),
  },
  [222] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(400),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [223] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [anon_sym_tensor] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_indexvars] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(970),
    [sym_preproc_directive] = ACTIONS(970),
    [anon_sym_typedef] = ACTIONS(970),
    [anon_sym_extern] = ACTIONS(970),
    [anon_sym_STAR] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_auto] = ACTIONS(970),
    [anon_sym_register] = ACTIONS(970),
    [anon_sym_inline] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [anon_sym_restrict] = ACTIONS(970),
    [anon_sym_volatile] = ACTIONS(970),
    [anon_sym__Atomic] = ACTIONS(970),
    [anon_sym_unsigned] = ACTIONS(970),
    [anon_sym_long] = ACTIONS(970),
    [anon_sym_short] = ACTIONS(970),
    [sym_primitive_type] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_struct] = ACTIONS(970),
    [anon_sym_union] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(970),
    [anon_sym_case] = ACTIONS(970),
    [anon_sym_default] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_do] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_goto] = ACTIONS(970),
    [anon_sym_AMP] = ACTIONS(968),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_sizeof] = ACTIONS(970),
    [sym_number_literal] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_null] = ACTIONS(970),
    [sym_identifier] = ACTIONS(970),
    [sym_comment] = ACTIONS(41),
  },
  [224] = {
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(972),
    [anon_sym_SEMI] = ACTIONS(972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(974),
    [sym_preproc_directive] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(974),
    [anon_sym_extern] = ACTIONS(974),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_static] = ACTIONS(974),
    [anon_sym_auto] = ACTIONS(974),
    [anon_sym_register] = ACTIONS(974),
    [anon_sym_inline] = ACTIONS(974),
    [anon_sym_const] = ACTIONS(974),
    [anon_sym_restrict] = ACTIONS(974),
    [anon_sym_volatile] = ACTIONS(974),
    [anon_sym__Atomic] = ACTIONS(974),
    [anon_sym_unsigned] = ACTIONS(974),
    [anon_sym_long] = ACTIONS(974),
    [anon_sym_short] = ACTIONS(974),
    [sym_primitive_type] = ACTIONS(974),
    [anon_sym_enum] = ACTIONS(974),
    [anon_sym_struct] = ACTIONS(974),
    [anon_sym_union] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(974),
    [anon_sym_else] = ACTIONS(974),
    [anon_sym_switch] = ACTIONS(974),
    [anon_sym_case] = ACTIONS(974),
    [anon_sym_default] = ACTIONS(974),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_do] = ACTIONS(974),
    [anon_sym_for] = ACTIONS(974),
    [anon_sym_return] = ACTIONS(974),
    [anon_sym_break] = ACTIONS(974),
    [anon_sym_continue] = ACTIONS(974),
    [anon_sym_goto] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(972),
    [anon_sym_BANG] = ACTIONS(972),
    [anon_sym_TILDE] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(974),
    [anon_sym_DASH_DASH] = ACTIONS(972),
    [anon_sym_PLUS_PLUS] = ACTIONS(972),
    [anon_sym_sizeof] = ACTIONS(974),
    [sym_number_literal] = ACTIONS(972),
    [anon_sym_SQUOTE] = ACTIONS(972),
    [anon_sym_DQUOTE] = ACTIONS(972),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [sym_null] = ACTIONS(974),
    [sym_identifier] = ACTIONS(974),
    [sym_comment] = ACTIONS(41),
  },
  [225] = {
    [sym_string_literal] = STATE(27),
    [anon_sym_DQUOTE] = ACTIONS(976),
    [sym_system_lib_string] = ACTIONS(49),
    [sym_comment] = ACTIONS(41),
  },
  [226] = {
    [sym_preproc_arg] = ACTIONS(978),
    [sym_comment] = ACTIONS(55),
  },
  [227] = {
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(41),
  },
  [228] = {
    [sym__expression] = STATE(405),
    [sym_conditional_expression] = STATE(405),
    [sym_assignment_expression] = STATE(405),
    [sym_pointer_expression] = STATE(405),
    [sym_logical_expression] = STATE(405),
    [sym_bitwise_expression] = STATE(405),
    [sym_equality_expression] = STATE(405),
    [sym_relational_expression] = STATE(405),
    [sym_shift_expression] = STATE(405),
    [sym_math_expression] = STATE(405),
    [sym_cast_expression] = STATE(405),
    [sym_sizeof_expression] = STATE(405),
    [sym_subscript_expression] = STATE(405),
    [sym_call_expression] = STATE(405),
    [sym_field_expression] = STATE(405),
    [sym_compound_literal_expression] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_char_literal] = STATE(405),
    [sym_concatenated_string] = STATE(405),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_identifier] = ACTIONS(984),
    [sym_comment] = ACTIONS(41),
  },
  [229] = {
    [sym_parenthesized_expression] = STATE(407),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [230] = {
    [sym_parenthesized_expression] = STATE(408),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [231] = {
    [sym__expression] = STATE(415),
    [sym_conditional_expression] = STATE(415),
    [sym_assignment_expression] = STATE(415),
    [sym_pointer_expression] = STATE(415),
    [sym_logical_expression] = STATE(415),
    [sym_bitwise_expression] = STATE(415),
    [sym_equality_expression] = STATE(415),
    [sym_relational_expression] = STATE(415),
    [sym_shift_expression] = STATE(415),
    [sym_math_expression] = STATE(415),
    [sym_cast_expression] = STATE(415),
    [sym_sizeof_expression] = STATE(415),
    [sym_subscript_expression] = STATE(415),
    [sym_call_expression] = STATE(415),
    [sym_field_expression] = STATE(415),
    [sym_compound_literal_expression] = STATE(415),
    [sym_parenthesized_expression] = STATE(415),
    [sym_char_literal] = STATE(415),
    [sym_concatenated_string] = STATE(415),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1004),
    [sym_false] = ACTIONS(1004),
    [sym_null] = ACTIONS(1004),
    [sym_identifier] = ACTIONS(1004),
    [sym_comment] = ACTIONS(41),
  },
  [232] = {
    [anon_sym_COLON] = ACTIONS(1006),
    [sym_comment] = ACTIONS(41),
  },
  [233] = {
    [sym_parenthesized_expression] = STATE(418),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [234] = {
    [sym_compound_statement] = STATE(427),
    [sym_labeled_statement] = STATE(427),
    [sym_expression_statement] = STATE(427),
    [sym_if_statement] = STATE(427),
    [sym_switch_statement] = STATE(427),
    [sym_case_statement] = STATE(427),
    [sym_while_statement] = STATE(427),
    [sym_do_statement] = STATE(427),
    [sym_for_statement] = STATE(427),
    [sym_return_statement] = STATE(427),
    [sym_break_statement] = STATE(427),
    [sym_continue_statement] = STATE(427),
    [sym_goto_statement] = STATE(427),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [235] = {
    [anon_sym_LPAREN] = ACTIONS(1024),
    [sym_comment] = ACTIONS(41),
  },
  [236] = {
    [sym__expression] = STATE(430),
    [sym_conditional_expression] = STATE(430),
    [sym_assignment_expression] = STATE(430),
    [sym_pointer_expression] = STATE(430),
    [sym_logical_expression] = STATE(430),
    [sym_bitwise_expression] = STATE(430),
    [sym_equality_expression] = STATE(430),
    [sym_relational_expression] = STATE(430),
    [sym_shift_expression] = STATE(430),
    [sym_math_expression] = STATE(430),
    [sym_cast_expression] = STATE(430),
    [sym_sizeof_expression] = STATE(430),
    [sym_subscript_expression] = STATE(430),
    [sym_call_expression] = STATE(430),
    [sym_field_expression] = STATE(430),
    [sym_compound_literal_expression] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_char_literal] = STATE(430),
    [sym_concatenated_string] = STATE(430),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(1028),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1030),
    [sym_false] = ACTIONS(1030),
    [sym_null] = ACTIONS(1030),
    [sym_identifier] = ACTIONS(1030),
    [sym_comment] = ACTIONS(41),
  },
  [237] = {
    [anon_sym_SEMI] = ACTIONS(1032),
    [sym_comment] = ACTIONS(41),
  },
  [238] = {
    [anon_sym_SEMI] = ACTIONS(1034),
    [sym_comment] = ACTIONS(41),
  },
  [239] = {
    [sym_identifier] = ACTIONS(1036),
    [sym_comment] = ACTIONS(41),
  },
  [240] = {
    [sym__expression] = STATE(434),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_char_literal] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1040),
    [sym_comment] = ACTIONS(41),
  },
  [241] = {
    [sym__expression] = STATE(435),
    [sym_conditional_expression] = STATE(435),
    [sym_assignment_expression] = STATE(435),
    [sym_pointer_expression] = STATE(435),
    [sym_logical_expression] = STATE(435),
    [sym_bitwise_expression] = STATE(435),
    [sym_equality_expression] = STATE(435),
    [sym_relational_expression] = STATE(435),
    [sym_shift_expression] = STATE(435),
    [sym_math_expression] = STATE(435),
    [sym_cast_expression] = STATE(435),
    [sym_sizeof_expression] = STATE(435),
    [sym_subscript_expression] = STATE(435),
    [sym_call_expression] = STATE(435),
    [sym_field_expression] = STATE(435),
    [sym_compound_literal_expression] = STATE(435),
    [sym_parenthesized_expression] = STATE(435),
    [sym_char_literal] = STATE(435),
    [sym_concatenated_string] = STATE(435),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_identifier] = ACTIONS(1044),
    [sym_comment] = ACTIONS(41),
  },
  [242] = {
    [sym__expression] = STATE(436),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_char_literal] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1048),
    [sym_comment] = ACTIONS(41),
  },
  [243] = {
    [sym__expression] = STATE(438),
    [sym_conditional_expression] = STATE(438),
    [sym_assignment_expression] = STATE(438),
    [sym_pointer_expression] = STATE(438),
    [sym_logical_expression] = STATE(438),
    [sym_bitwise_expression] = STATE(438),
    [sym_equality_expression] = STATE(438),
    [sym_relational_expression] = STATE(438),
    [sym_shift_expression] = STATE(438),
    [sym_math_expression] = STATE(438),
    [sym_cast_expression] = STATE(438),
    [sym_sizeof_expression] = STATE(438),
    [sym_subscript_expression] = STATE(438),
    [sym_call_expression] = STATE(438),
    [sym_field_expression] = STATE(438),
    [sym_compound_literal_expression] = STATE(438),
    [sym_parenthesized_expression] = STATE(438),
    [sym_char_literal] = STATE(438),
    [sym_concatenated_string] = STATE(438),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1052),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1054),
    [sym_false] = ACTIONS(1054),
    [sym_null] = ACTIONS(1054),
    [sym_identifier] = ACTIONS(1054),
    [sym_comment] = ACTIONS(41),
  },
  [244] = {
    [aux_sym_SLASH_LBRACK_CARET_BSLASHn_SQUOTE_RBRACK_SLASH] = ACTIONS(1056),
    [sym_escape_sequence] = ACTIONS(1058),
    [sym_comment] = ACTIONS(55),
  },
  [245] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1064),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(1074),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [246] = {
    [sym__declarator] = STATE(441),
    [sym_pointer_declarator] = STATE(441),
    [sym_function_declarator] = STATE(441),
    [sym_array_declarator] = STATE(441),
    [sym_init_declarator] = STATE(50),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_SEMI] = ACTIONS(96),
    [anon_sym_STAR] = ACTIONS(593),
    [sym_identifier] = ACTIONS(1076),
    [sym_comment] = ACTIONS(41),
  },
  [247] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1082),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1088),
    [anon_sym_QMARK] = ACTIONS(1090),
    [anon_sym_STAR_EQ] = ACTIONS(1092),
    [anon_sym_SLASH_EQ] = ACTIONS(1092),
    [anon_sym_PERCENT_EQ] = ACTIONS(1092),
    [anon_sym_PLUS_EQ] = ACTIONS(1092),
    [anon_sym_DASH_EQ] = ACTIONS(1092),
    [anon_sym_LT_LT_EQ] = ACTIONS(1092),
    [anon_sym_GT_GT_EQ] = ACTIONS(1092),
    [anon_sym_AMP_EQ] = ACTIONS(1092),
    [anon_sym_CARET_EQ] = ACTIONS(1092),
    [anon_sym_PIPE_EQ] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [248] = {
    [anon_sym_SEMI] = ACTIONS(1080),
    [sym_comment] = ACTIONS(41),
  },
  [249] = {
    [sym_string_literal] = STATE(461),
    [aux_sym_concatenated_string_repeat1] = STATE(461),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [250] = {
    [sym_preproc_include] = STATE(463),
    [sym_preproc_def] = STATE(463),
    [sym_preproc_function_def] = STATE(463),
    [sym_preproc_call] = STATE(463),
    [sym_preproc_if_in_compound_statement] = STATE(463),
    [sym_preproc_ifdef_in_compound_statement] = STATE(463),
    [sym_declaration] = STATE(463),
    [sym_type_definition] = STATE(463),
    [sym__declaration_specifiers] = STATE(246),
    [sym_compound_statement] = STATE(463),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(463),
    [sym_expression_statement] = STATE(463),
    [sym_if_statement] = STATE(463),
    [sym_switch_statement] = STATE(463),
    [sym_case_statement] = STATE(463),
    [sym_while_statement] = STATE(463),
    [sym_do_statement] = STATE(463),
    [sym_for_statement] = STATE(463),
    [sym_return_statement] = STATE(463),
    [sym_break_statement] = STATE(463),
    [sym_continue_statement] = STATE(463),
    [sym_goto_statement] = STATE(463),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(463),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(463),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_RBRACE] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(541),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(545),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(545),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(587),
    [sym_comment] = ACTIONS(41),
  },
  [251] = {
    [sym__declarator] = STATE(120),
    [sym_pointer_declarator] = STATE(120),
    [sym_function_declarator] = STATE(120),
    [sym_array_declarator] = STATE(120),
    [sym_type_qualifier] = STATE(464),
    [aux_sym_type_definition_repeat1] = STATE(464),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(593),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(243),
    [sym_comment] = ACTIONS(41),
  },
  [252] = {
    [sym_parameter_list] = STATE(129),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(1120),
    [anon_sym_COMMA] = ACTIONS(1120),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(255),
    [sym_comment] = ACTIONS(41),
  },
  [253] = {
    [anon_sym_SEMI] = ACTIONS(1120),
    [anon_sym_COMMA] = ACTIONS(1120),
    [sym_comment] = ACTIONS(41),
  },
  [254] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(465),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [255] = {
    [sym__expression] = STATE(405),
    [sym_conditional_expression] = STATE(405),
    [sym_assignment_expression] = STATE(405),
    [sym_pointer_expression] = STATE(405),
    [sym_logical_expression] = STATE(405),
    [sym_bitwise_expression] = STATE(405),
    [sym_equality_expression] = STATE(405),
    [sym_relational_expression] = STATE(405),
    [sym_shift_expression] = STATE(405),
    [sym_math_expression] = STATE(405),
    [sym_cast_expression] = STATE(405),
    [sym_sizeof_expression] = STATE(405),
    [sym_subscript_expression] = STATE(405),
    [sym_call_expression] = STATE(405),
    [sym_field_expression] = STATE(405),
    [sym_compound_literal_expression] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_char_literal] = STATE(405),
    [sym_concatenated_string] = STATE(405),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_identifier] = ACTIONS(984),
    [sym_comment] = ACTIONS(41),
  },
  [256] = {
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_SEMI] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_EQ] = ACTIONS(1122),
    [sym_comment] = ACTIONS(41),
  },
  [257] = {
    [sym__expression] = STATE(434),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_char_literal] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1040),
    [sym_comment] = ACTIONS(41),
  },
  [258] = {
    [sym__expression] = STATE(435),
    [sym_conditional_expression] = STATE(435),
    [sym_assignment_expression] = STATE(435),
    [sym_pointer_expression] = STATE(435),
    [sym_logical_expression] = STATE(435),
    [sym_bitwise_expression] = STATE(435),
    [sym_equality_expression] = STATE(435),
    [sym_relational_expression] = STATE(435),
    [sym_shift_expression] = STATE(435),
    [sym_math_expression] = STATE(435),
    [sym_cast_expression] = STATE(435),
    [sym_sizeof_expression] = STATE(435),
    [sym_subscript_expression] = STATE(435),
    [sym_call_expression] = STATE(435),
    [sym_field_expression] = STATE(435),
    [sym_compound_literal_expression] = STATE(435),
    [sym_parenthesized_expression] = STATE(435),
    [sym_char_literal] = STATE(435),
    [sym_concatenated_string] = STATE(435),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_identifier] = ACTIONS(1044),
    [sym_comment] = ACTIONS(41),
  },
  [259] = {
    [sym__expression] = STATE(436),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_char_literal] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1048),
    [sym_comment] = ACTIONS(41),
  },
  [260] = {
    [sym__expression] = STATE(467),
    [sym_conditional_expression] = STATE(467),
    [sym_assignment_expression] = STATE(467),
    [sym_pointer_expression] = STATE(467),
    [sym_logical_expression] = STATE(467),
    [sym_bitwise_expression] = STATE(467),
    [sym_equality_expression] = STATE(467),
    [sym_relational_expression] = STATE(467),
    [sym_shift_expression] = STATE(467),
    [sym_math_expression] = STATE(467),
    [sym_cast_expression] = STATE(467),
    [sym_sizeof_expression] = STATE(467),
    [sym_subscript_expression] = STATE(467),
    [sym_call_expression] = STATE(467),
    [sym_field_expression] = STATE(467),
    [sym_compound_literal_expression] = STATE(467),
    [sym_parenthesized_expression] = STATE(467),
    [sym_char_literal] = STATE(467),
    [sym_concatenated_string] = STATE(467),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(1124),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1128),
    [sym_false] = ACTIONS(1128),
    [sym_null] = ACTIONS(1128),
    [sym_identifier] = ACTIONS(1128),
    [sym_comment] = ACTIONS(41),
  },
  [261] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_RBRACK] = ACTIONS(1064),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(90),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_TILDE] = ACTIONS(88),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1064),
    [anon_sym_sizeof] = ACTIONS(90),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_number_literal] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(88),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [sym_true] = ACTIONS(90),
    [sym_false] = ACTIONS(90),
    [sym_null] = ACTIONS(90),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [262] = {
    [sym__expression] = STATE(469),
    [sym_conditional_expression] = STATE(469),
    [sym_assignment_expression] = STATE(469),
    [sym_pointer_expression] = STATE(469),
    [sym_logical_expression] = STATE(469),
    [sym_bitwise_expression] = STATE(469),
    [sym_equality_expression] = STATE(469),
    [sym_relational_expression] = STATE(469),
    [sym_shift_expression] = STATE(469),
    [sym_math_expression] = STATE(469),
    [sym_cast_expression] = STATE(469),
    [sym_sizeof_expression] = STATE(469),
    [sym_subscript_expression] = STATE(469),
    [sym_call_expression] = STATE(469),
    [sym_field_expression] = STATE(469),
    [sym_compound_literal_expression] = STATE(469),
    [sym_parenthesized_expression] = STATE(469),
    [sym_char_literal] = STATE(469),
    [sym_concatenated_string] = STATE(469),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(1130),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1132),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1134),
    [sym_false] = ACTIONS(1134),
    [sym_null] = ACTIONS(1134),
    [sym_identifier] = ACTIONS(1134),
    [sym_comment] = ACTIONS(41),
  },
  [263] = {
    [sym_storage_class_specifier] = STATE(470),
    [sym_type_qualifier] = STATE(470),
    [aux_sym__declaration_specifiers_repeat1] = STATE(470),
    [anon_sym_LPAREN] = ACTIONS(102),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(102),
    [anon_sym_RBRACK] = ACTIONS(102),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(102),
    [anon_sym_BANG] = ACTIONS(102),
    [anon_sym_TILDE] = ACTIONS(102),
    [anon_sym_PLUS] = ACTIONS(104),
    [anon_sym_DASH] = ACTIONS(104),
    [anon_sym_DASH_DASH] = ACTIONS(102),
    [anon_sym_PLUS_PLUS] = ACTIONS(102),
    [anon_sym_sizeof] = ACTIONS(104),
    [sym_number_literal] = ACTIONS(102),
    [anon_sym_SQUOTE] = ACTIONS(102),
    [anon_sym_DQUOTE] = ACTIONS(102),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_null] = ACTIONS(104),
    [sym_identifier] = ACTIONS(104),
    [sym_comment] = ACTIONS(41),
  },
  [264] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1130),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [265] = {
    [sym_string_literal] = STATE(483),
    [aux_sym_concatenated_string_repeat1] = STATE(483),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_RBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [266] = {
    [sym_storage_class_specifier] = STATE(54),
    [sym_type_qualifier] = STATE(54),
    [sym__type_specifier] = STATE(484),
    [sym_sized_type_specifier] = STATE(484),
    [sym_enum_specifier] = STATE(484),
    [sym_struct_specifier] = STATE(484),
    [sym_union_specifier] = STATE(484),
    [sym_macro_type_specifier] = STATE(484),
    [aux_sym__declaration_specifiers_repeat1] = STATE(54),
    [aux_sym_sized_type_specifier_repeat1] = STATE(267),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(603),
    [anon_sym_long] = ACTIONS(603),
    [anon_sym_short] = ACTIONS(603),
    [sym_primitive_type] = ACTIONS(1164),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [267] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(485),
    [anon_sym_LPAREN] = ACTIONS(110),
    [anon_sym_extern] = ACTIONS(112),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_RBRACK] = ACTIONS(110),
    [anon_sym_static] = ACTIONS(112),
    [anon_sym_auto] = ACTIONS(112),
    [anon_sym_register] = ACTIONS(112),
    [anon_sym_inline] = ACTIONS(112),
    [anon_sym_const] = ACTIONS(112),
    [anon_sym_restrict] = ACTIONS(112),
    [anon_sym_volatile] = ACTIONS(112),
    [anon_sym__Atomic] = ACTIONS(112),
    [anon_sym_unsigned] = ACTIONS(1166),
    [anon_sym_long] = ACTIONS(1166),
    [anon_sym_short] = ACTIONS(1166),
    [sym_primitive_type] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(110),
    [anon_sym_BANG] = ACTIONS(110),
    [anon_sym_TILDE] = ACTIONS(110),
    [anon_sym_PLUS] = ACTIONS(112),
    [anon_sym_DASH] = ACTIONS(112),
    [anon_sym_DASH_DASH] = ACTIONS(110),
    [anon_sym_PLUS_PLUS] = ACTIONS(110),
    [anon_sym_sizeof] = ACTIONS(112),
    [sym_number_literal] = ACTIONS(110),
    [anon_sym_SQUOTE] = ACTIONS(110),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [sym_true] = ACTIONS(112),
    [sym_false] = ACTIONS(112),
    [sym_null] = ACTIONS(112),
    [sym_identifier] = ACTIONS(118),
    [sym_comment] = ACTIONS(41),
  },
  [268] = {
    [sym__expression] = STATE(490),
    [sym_conditional_expression] = STATE(490),
    [sym_assignment_expression] = STATE(490),
    [sym_pointer_expression] = STATE(490),
    [sym_logical_expression] = STATE(490),
    [sym_bitwise_expression] = STATE(490),
    [sym_equality_expression] = STATE(490),
    [sym_relational_expression] = STATE(490),
    [sym_shift_expression] = STATE(490),
    [sym_math_expression] = STATE(490),
    [sym_cast_expression] = STATE(490),
    [sym_sizeof_expression] = STATE(490),
    [sym_subscript_expression] = STATE(490),
    [sym_call_expression] = STATE(490),
    [sym_field_expression] = STATE(490),
    [sym_compound_literal_expression] = STATE(490),
    [sym_parenthesized_expression] = STATE(490),
    [sym_initializer_list] = STATE(491),
    [sym_initializer_pair] = STATE(491),
    [sym_subscript_designator] = STATE(492),
    [sym_field_designator] = STATE(492),
    [sym_char_literal] = STATE(490),
    [sym_concatenated_string] = STATE(490),
    [sym_string_literal] = STATE(339),
    [aux_sym_initializer_pair_repeat1] = STATE(492),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1170),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [anon_sym_DOT] = ACTIONS(1174),
    [sym_number_literal] = ACTIONS(1176),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1178),
    [sym_false] = ACTIONS(1178),
    [sym_null] = ACTIONS(1178),
    [sym_identifier] = ACTIONS(1178),
    [sym_comment] = ACTIONS(41),
  },
  [269] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1180),
    [anon_sym_COMMA] = ACTIONS(1180),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1088),
    [anon_sym_QMARK] = ACTIONS(1090),
    [anon_sym_STAR_EQ] = ACTIONS(1092),
    [anon_sym_SLASH_EQ] = ACTIONS(1092),
    [anon_sym_PERCENT_EQ] = ACTIONS(1092),
    [anon_sym_PLUS_EQ] = ACTIONS(1092),
    [anon_sym_DASH_EQ] = ACTIONS(1092),
    [anon_sym_LT_LT_EQ] = ACTIONS(1092),
    [anon_sym_GT_GT_EQ] = ACTIONS(1092),
    [anon_sym_AMP_EQ] = ACTIONS(1092),
    [anon_sym_CARET_EQ] = ACTIONS(1092),
    [anon_sym_PIPE_EQ] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [270] = {
    [anon_sym_SEMI] = ACTIONS(1180),
    [anon_sym_COMMA] = ACTIONS(1180),
    [sym_comment] = ACTIONS(41),
  },
  [271] = {
    [ts_builtin_sym_end] = ACTIONS(1182),
    [anon_sym_tensor] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1182),
    [anon_sym_RBRACE] = ACTIONS(1182),
    [anon_sym_SEMI] = ACTIONS(1182),
    [anon_sym_indexvars] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1184),
    [sym_preproc_directive] = ACTIONS(1184),
    [anon_sym_typedef] = ACTIONS(1184),
    [anon_sym_extern] = ACTIONS(1184),
    [anon_sym_STAR] = ACTIONS(1182),
    [anon_sym_static] = ACTIONS(1184),
    [anon_sym_auto] = ACTIONS(1184),
    [anon_sym_register] = ACTIONS(1184),
    [anon_sym_inline] = ACTIONS(1184),
    [anon_sym_const] = ACTIONS(1184),
    [anon_sym_restrict] = ACTIONS(1184),
    [anon_sym_volatile] = ACTIONS(1184),
    [anon_sym__Atomic] = ACTIONS(1184),
    [anon_sym_unsigned] = ACTIONS(1184),
    [anon_sym_long] = ACTIONS(1184),
    [anon_sym_short] = ACTIONS(1184),
    [sym_primitive_type] = ACTIONS(1184),
    [anon_sym_enum] = ACTIONS(1184),
    [anon_sym_struct] = ACTIONS(1184),
    [anon_sym_union] = ACTIONS(1184),
    [anon_sym_if] = ACTIONS(1184),
    [anon_sym_else] = ACTIONS(1184),
    [anon_sym_switch] = ACTIONS(1184),
    [anon_sym_case] = ACTIONS(1184),
    [anon_sym_default] = ACTIONS(1184),
    [anon_sym_while] = ACTIONS(1184),
    [anon_sym_do] = ACTIONS(1184),
    [anon_sym_for] = ACTIONS(1184),
    [anon_sym_return] = ACTIONS(1184),
    [anon_sym_break] = ACTIONS(1184),
    [anon_sym_continue] = ACTIONS(1184),
    [anon_sym_goto] = ACTIONS(1184),
    [anon_sym_AMP] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1182),
    [anon_sym_TILDE] = ACTIONS(1182),
    [anon_sym_PLUS] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1184),
    [anon_sym_DASH_DASH] = ACTIONS(1182),
    [anon_sym_PLUS_PLUS] = ACTIONS(1182),
    [anon_sym_sizeof] = ACTIONS(1184),
    [sym_number_literal] = ACTIONS(1182),
    [anon_sym_SQUOTE] = ACTIONS(1182),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [sym_true] = ACTIONS(1184),
    [sym_false] = ACTIONS(1184),
    [sym_null] = ACTIONS(1184),
    [sym_identifier] = ACTIONS(1184),
    [sym_comment] = ACTIONS(41),
  },
  [272] = {
    [aux_sym_declaration_repeat1] = STATE(272),
    [anon_sym_SEMI] = ACTIONS(1120),
    [anon_sym_COMMA] = ACTIONS(1186),
    [sym_comment] = ACTIONS(41),
  },
  [273] = {
    [sym_ta_specifier_list] = STATE(494),
    [sym_ta_specifier_list_specifier] = STATE(495),
    [anon_sym_dense] = ACTIONS(1189),
    [anon_sym_sparse] = ACTIONS(1189),
    [sym_comment] = ACTIONS(41),
  },
  [274] = {
    [anon_sym_LF] = ACTIONS(1191),
    [sym_preproc_arg] = ACTIONS(1191),
    [sym_comment] = ACTIONS(55),
  },
  [275] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1193),
    [sym_identifier] = ACTIONS(1193),
    [sym_comment] = ACTIONS(41),
  },
  [276] = {
    [aux_sym_preproc_params_repeat1] = STATE(498),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(660),
    [sym_comment] = ACTIONS(41),
  },
  [277] = {
    [ts_builtin_sym_end] = ACTIONS(1197),
    [anon_sym_tensor] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1197),
    [anon_sym_indexvars] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1199),
    [sym_preproc_directive] = ACTIONS(1199),
    [anon_sym_typedef] = ACTIONS(1199),
    [anon_sym_extern] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1199),
    [anon_sym_auto] = ACTIONS(1199),
    [anon_sym_register] = ACTIONS(1199),
    [anon_sym_inline] = ACTIONS(1199),
    [anon_sym_const] = ACTIONS(1199),
    [anon_sym_restrict] = ACTIONS(1199),
    [anon_sym_volatile] = ACTIONS(1199),
    [anon_sym__Atomic] = ACTIONS(1199),
    [anon_sym_unsigned] = ACTIONS(1199),
    [anon_sym_long] = ACTIONS(1199),
    [anon_sym_short] = ACTIONS(1199),
    [sym_primitive_type] = ACTIONS(1199),
    [anon_sym_enum] = ACTIONS(1199),
    [anon_sym_struct] = ACTIONS(1199),
    [anon_sym_union] = ACTIONS(1199),
    [anon_sym_if] = ACTIONS(1199),
    [anon_sym_switch] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1199),
    [anon_sym_default] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(1199),
    [anon_sym_do] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1199),
    [anon_sym_return] = ACTIONS(1199),
    [anon_sym_break] = ACTIONS(1199),
    [anon_sym_continue] = ACTIONS(1199),
    [anon_sym_goto] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [sym_number_literal] = ACTIONS(1197),
    [anon_sym_SQUOTE] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_true] = ACTIONS(1199),
    [sym_false] = ACTIONS(1199),
    [sym_null] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1199),
    [sym_comment] = ACTIONS(41),
  },
  [278] = {
    [anon_sym_LPAREN] = ACTIONS(1201),
    [sym_comment] = ACTIONS(41),
  },
  [279] = {
    [anon_sym_tensor] = ACTIONS(341),
    [anon_sym_indexvars] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(341),
    [sym_preproc_directive] = ACTIONS(341),
    [anon_sym_typedef] = ACTIONS(341),
    [anon_sym_extern] = ACTIONS(341),
    [anon_sym_static] = ACTIONS(341),
    [anon_sym_auto] = ACTIONS(341),
    [anon_sym_register] = ACTIONS(341),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_const] = ACTIONS(341),
    [anon_sym_restrict] = ACTIONS(341),
    [anon_sym_volatile] = ACTIONS(341),
    [anon_sym__Atomic] = ACTIONS(341),
    [anon_sym_unsigned] = ACTIONS(341),
    [anon_sym_long] = ACTIONS(341),
    [anon_sym_short] = ACTIONS(341),
    [sym_primitive_type] = ACTIONS(341),
    [anon_sym_enum] = ACTIONS(341),
    [anon_sym_struct] = ACTIONS(341),
    [anon_sym_union] = ACTIONS(341),
    [sym_identifier] = ACTIONS(341),
    [sym_comment] = ACTIONS(41),
  },
  [280] = {
    [anon_sym_tensor] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_indexvars] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(345),
    [sym_preproc_directive] = ACTIONS(345),
    [anon_sym_typedef] = ACTIONS(345),
    [anon_sym_extern] = ACTIONS(345),
    [anon_sym_STAR] = ACTIONS(343),
    [anon_sym_static] = ACTIONS(345),
    [anon_sym_auto] = ACTIONS(345),
    [anon_sym_register] = ACTIONS(345),
    [anon_sym_inline] = ACTIONS(345),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_restrict] = ACTIONS(345),
    [anon_sym_volatile] = ACTIONS(345),
    [anon_sym__Atomic] = ACTIONS(345),
    [anon_sym_unsigned] = ACTIONS(345),
    [anon_sym_long] = ACTIONS(345),
    [anon_sym_short] = ACTIONS(345),
    [sym_primitive_type] = ACTIONS(345),
    [anon_sym_enum] = ACTIONS(345),
    [anon_sym_struct] = ACTIONS(345),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_switch] = ACTIONS(345),
    [anon_sym_case] = ACTIONS(345),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_do] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(345),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_continue] = ACTIONS(345),
    [anon_sym_goto] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(343),
    [anon_sym_BANG] = ACTIONS(343),
    [anon_sym_TILDE] = ACTIONS(343),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_DASH_DASH] = ACTIONS(343),
    [anon_sym_PLUS_PLUS] = ACTIONS(343),
    [anon_sym_sizeof] = ACTIONS(345),
    [sym_number_literal] = ACTIONS(343),
    [anon_sym_SQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(343),
    [sym_true] = ACTIONS(345),
    [sym_false] = ACTIONS(345),
    [sym_null] = ACTIONS(345),
    [sym_identifier] = ACTIONS(345),
    [sym_comment] = ACTIONS(41),
  },
  [281] = {
    [aux_sym_string_literal_repeat1] = STATE(136),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(349),
    [sym_escape_sequence] = ACTIONS(349),
    [sym_comment] = ACTIONS(55),
  },
  [282] = {
    [anon_sym_tensor] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_SEMI] = ACTIONS(351),
    [anon_sym_indexvars] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(353),
    [sym_preproc_directive] = ACTIONS(353),
    [anon_sym_typedef] = ACTIONS(353),
    [anon_sym_extern] = ACTIONS(353),
    [anon_sym_STAR] = ACTIONS(351),
    [anon_sym_static] = ACTIONS(353),
    [anon_sym_auto] = ACTIONS(353),
    [anon_sym_register] = ACTIONS(353),
    [anon_sym_inline] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(353),
    [anon_sym_restrict] = ACTIONS(353),
    [anon_sym_volatile] = ACTIONS(353),
    [anon_sym__Atomic] = ACTIONS(353),
    [anon_sym_unsigned] = ACTIONS(353),
    [anon_sym_long] = ACTIONS(353),
    [anon_sym_short] = ACTIONS(353),
    [sym_primitive_type] = ACTIONS(353),
    [anon_sym_enum] = ACTIONS(353),
    [anon_sym_struct] = ACTIONS(353),
    [anon_sym_union] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_switch] = ACTIONS(353),
    [anon_sym_case] = ACTIONS(353),
    [anon_sym_default] = ACTIONS(353),
    [anon_sym_while] = ACTIONS(353),
    [anon_sym_do] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(353),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_continue] = ACTIONS(353),
    [anon_sym_goto] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(353),
    [anon_sym_DASH] = ACTIONS(353),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_sizeof] = ACTIONS(353),
    [sym_number_literal] = ACTIONS(351),
    [anon_sym_SQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_identifier] = ACTIONS(353),
    [sym_comment] = ACTIONS(41),
  },
  [283] = {
    [anon_sym_LF] = ACTIONS(1205),
    [sym_comment] = ACTIONS(55),
  },
  [284] = {
    [anon_sym_LF] = ACTIONS(1207),
    [sym_preproc_arg] = ACTIONS(1209),
    [sym_comment] = ACTIONS(55),
  },
  [285] = {
    [anon_sym_tensor] = ACTIONS(377),
    [anon_sym_indexvars] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(377),
    [sym_preproc_directive] = ACTIONS(377),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(377),
    [anon_sym_static] = ACTIONS(377),
    [anon_sym_auto] = ACTIONS(377),
    [anon_sym_register] = ACTIONS(377),
    [anon_sym_inline] = ACTIONS(377),
    [anon_sym_const] = ACTIONS(377),
    [anon_sym_restrict] = ACTIONS(377),
    [anon_sym_volatile] = ACTIONS(377),
    [anon_sym__Atomic] = ACTIONS(377),
    [anon_sym_unsigned] = ACTIONS(377),
    [anon_sym_long] = ACTIONS(377),
    [anon_sym_short] = ACTIONS(377),
    [sym_primitive_type] = ACTIONS(377),
    [anon_sym_enum] = ACTIONS(377),
    [anon_sym_struct] = ACTIONS(377),
    [anon_sym_union] = ACTIONS(377),
    [sym_identifier] = ACTIONS(377),
    [sym_comment] = ACTIONS(41),
  },
  [286] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1211),
    [sym_comment] = ACTIONS(41),
  },
  [287] = {
    [sym_ta_top_level] = STATE(171),
    [sym_preproc_include] = STATE(171),
    [sym_preproc_def] = STATE(171),
    [sym_preproc_function_def] = STATE(171),
    [sym_preproc_call] = STATE(171),
    [sym_preproc_if] = STATE(171),
    [sym_preproc_ifdef] = STATE(171),
    [sym_preproc_else] = STATE(505),
    [sym_preproc_elif] = STATE(505),
    [sym_function_definition] = STATE(171),
    [sym_declaration] = STATE(171),
    [sym_type_definition] = STATE(171),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(171),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(171),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(171),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1213),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [288] = {
    [anon_sym_tensor] = ACTIONS(419),
    [anon_sym_indexvars] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(419),
    [sym_preproc_directive] = ACTIONS(419),
    [anon_sym_typedef] = ACTIONS(419),
    [anon_sym_extern] = ACTIONS(419),
    [anon_sym_static] = ACTIONS(419),
    [anon_sym_auto] = ACTIONS(419),
    [anon_sym_register] = ACTIONS(419),
    [anon_sym_inline] = ACTIONS(419),
    [anon_sym_const] = ACTIONS(419),
    [anon_sym_restrict] = ACTIONS(419),
    [anon_sym_volatile] = ACTIONS(419),
    [anon_sym__Atomic] = ACTIONS(419),
    [anon_sym_unsigned] = ACTIONS(419),
    [anon_sym_long] = ACTIONS(419),
    [anon_sym_short] = ACTIONS(419),
    [sym_primitive_type] = ACTIONS(419),
    [anon_sym_enum] = ACTIONS(419),
    [anon_sym_struct] = ACTIONS(419),
    [anon_sym_union] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_comment] = ACTIONS(41),
  },
  [289] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1215),
    [sym_comment] = ACTIONS(41),
  },
  [290] = {
    [sym_ta_top_level] = STATE(171),
    [sym_preproc_include] = STATE(171),
    [sym_preproc_def] = STATE(171),
    [sym_preproc_function_def] = STATE(171),
    [sym_preproc_call] = STATE(171),
    [sym_preproc_if] = STATE(171),
    [sym_preproc_ifdef] = STATE(171),
    [sym_preproc_else] = STATE(507),
    [sym_preproc_elif] = STATE(507),
    [sym_function_definition] = STATE(171),
    [sym_declaration] = STATE(171),
    [sym_type_definition] = STATE(171),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(171),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(171),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(171),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1217),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [291] = {
    [sym_identifier] = ACTIONS(1219),
    [sym_comment] = ACTIONS(41),
  },
  [292] = {
    [anon_sym_SEMI] = ACTIONS(1221),
    [sym_comment] = ACTIONS(41),
  },
  [293] = {
    [aux_sym_string_literal_repeat1] = STATE(511),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1225),
    [sym_escape_sequence] = ACTIONS(1225),
    [sym_comment] = ACTIONS(55),
  },
  [294] = {
    [anon_sym_tensor] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_indexvars] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(135),
    [sym_preproc_directive] = ACTIONS(135),
    [anon_sym_typedef] = ACTIONS(135),
    [anon_sym_extern] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(135),
    [anon_sym_auto] = ACTIONS(135),
    [anon_sym_register] = ACTIONS(135),
    [anon_sym_inline] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(135),
    [anon_sym_restrict] = ACTIONS(135),
    [anon_sym_volatile] = ACTIONS(135),
    [anon_sym__Atomic] = ACTIONS(135),
    [anon_sym_unsigned] = ACTIONS(135),
    [anon_sym_long] = ACTIONS(135),
    [anon_sym_short] = ACTIONS(135),
    [sym_primitive_type] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(135),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_union] = ACTIONS(135),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(135),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(135),
    [anon_sym_for] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(135),
    [anon_sym_goto] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(133),
    [anon_sym_sizeof] = ACTIONS(135),
    [sym_number_literal] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(133),
    [anon_sym_DQUOTE] = ACTIONS(133),
    [sym_true] = ACTIONS(135),
    [sym_false] = ACTIONS(135),
    [sym_null] = ACTIONS(135),
    [sym_identifier] = ACTIONS(135),
    [sym_comment] = ACTIONS(41),
  },
  [295] = {
    [sym_preproc_params] = STATE(514),
    [anon_sym_LF] = ACTIONS(1227),
    [anon_sym_LPAREN2] = ACTIONS(139),
    [sym_preproc_arg] = ACTIONS(1229),
    [sym_comment] = ACTIONS(55),
  },
  [296] = {
    [sym_ta_top_level] = STATE(517),
    [sym_preproc_include] = STATE(517),
    [sym_preproc_def] = STATE(517),
    [sym_preproc_function_def] = STATE(517),
    [sym_preproc_call] = STATE(517),
    [sym_preproc_if] = STATE(517),
    [sym_preproc_ifdef] = STATE(517),
    [sym_preproc_else] = STATE(516),
    [sym_preproc_elif] = STATE(516),
    [sym_function_definition] = STATE(517),
    [sym_declaration] = STATE(517),
    [sym_type_definition] = STATE(517),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(517),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(517),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(517),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1231),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [297] = {
    [sym_ta_top_level] = STATE(520),
    [sym_preproc_include] = STATE(520),
    [sym_preproc_def] = STATE(520),
    [sym_preproc_function_def] = STATE(520),
    [sym_preproc_call] = STATE(520),
    [sym_preproc_if] = STATE(520),
    [sym_preproc_ifdef] = STATE(520),
    [sym_preproc_else] = STATE(519),
    [sym_preproc_elif] = STATE(519),
    [sym_function_definition] = STATE(520),
    [sym_declaration] = STATE(520),
    [sym_type_definition] = STATE(520),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(520),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(520),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1233),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [298] = {
    [anon_sym_tensor] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_indexvars] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(171),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(171),
    [anon_sym_typedef] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(171),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_static] = ACTIONS(171),
    [anon_sym_auto] = ACTIONS(171),
    [anon_sym_register] = ACTIONS(171),
    [anon_sym_inline] = ACTIONS(171),
    [anon_sym_const] = ACTIONS(171),
    [anon_sym_restrict] = ACTIONS(171),
    [anon_sym_volatile] = ACTIONS(171),
    [anon_sym__Atomic] = ACTIONS(171),
    [anon_sym_unsigned] = ACTIONS(171),
    [anon_sym_long] = ACTIONS(171),
    [anon_sym_short] = ACTIONS(171),
    [sym_primitive_type] = ACTIONS(171),
    [anon_sym_enum] = ACTIONS(171),
    [anon_sym_struct] = ACTIONS(171),
    [anon_sym_union] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(171),
    [anon_sym_switch] = ACTIONS(171),
    [anon_sym_case] = ACTIONS(171),
    [anon_sym_default] = ACTIONS(171),
    [anon_sym_while] = ACTIONS(171),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_for] = ACTIONS(171),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(171),
    [anon_sym_continue] = ACTIONS(171),
    [anon_sym_goto] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_TILDE] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(171),
    [anon_sym_DASH] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(169),
    [anon_sym_PLUS_PLUS] = ACTIONS(169),
    [anon_sym_sizeof] = ACTIONS(171),
    [sym_number_literal] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(169),
    [sym_true] = ACTIONS(171),
    [sym_false] = ACTIONS(171),
    [sym_null] = ACTIONS(171),
    [sym_identifier] = ACTIONS(171),
    [sym_comment] = ACTIONS(41),
  },
  [299] = {
    [anon_sym_LF] = ACTIONS(1235),
    [sym_comment] = ACTIONS(55),
  },
  [300] = {
    [sym__type_declarator] = STATE(522),
    [sym_pointer_type_declarator] = STATE(522),
    [sym_function_type_declarator] = STATE(522),
    [sym_array_type_declarator] = STATE(522),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(177),
    [sym_identifier] = ACTIONS(179),
    [sym_comment] = ACTIONS(41),
  },
  [301] = {
    [sym_type_qualifier] = STATE(91),
    [sym__type_specifier] = STATE(523),
    [sym_sized_type_specifier] = STATE(523),
    [sym_enum_specifier] = STATE(523),
    [sym_struct_specifier] = STATE(523),
    [sym_union_specifier] = STATE(523),
    [sym_macro_type_specifier] = STATE(523),
    [aux_sym_type_definition_repeat1] = STATE(91),
    [aux_sym_sized_type_specifier_repeat1] = STATE(35),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(63),
    [anon_sym_long] = ACTIONS(63),
    [anon_sym_short] = ACTIONS(63),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [302] = {
    [sym_function_definition] = STATE(525),
    [sym_declaration] = STATE(525),
    [sym__declaration_specifiers] = STATE(526),
    [sym_declaration_list] = STATE(525),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [303] = {
    [anon_sym_tensor] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_SEMI] = ACTIONS(239),
    [anon_sym_indexvars] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(241),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(241),
    [sym_preproc_directive] = ACTIONS(241),
    [anon_sym_typedef] = ACTIONS(241),
    [anon_sym_extern] = ACTIONS(241),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_static] = ACTIONS(241),
    [anon_sym_auto] = ACTIONS(241),
    [anon_sym_register] = ACTIONS(241),
    [anon_sym_inline] = ACTIONS(241),
    [anon_sym_const] = ACTIONS(241),
    [anon_sym_restrict] = ACTIONS(241),
    [anon_sym_volatile] = ACTIONS(241),
    [anon_sym__Atomic] = ACTIONS(241),
    [anon_sym_unsigned] = ACTIONS(241),
    [anon_sym_long] = ACTIONS(241),
    [anon_sym_short] = ACTIONS(241),
    [sym_primitive_type] = ACTIONS(241),
    [anon_sym_enum] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(241),
    [anon_sym_union] = ACTIONS(241),
    [anon_sym_if] = ACTIONS(241),
    [anon_sym_switch] = ACTIONS(241),
    [anon_sym_case] = ACTIONS(241),
    [anon_sym_default] = ACTIONS(241),
    [anon_sym_while] = ACTIONS(241),
    [anon_sym_do] = ACTIONS(241),
    [anon_sym_for] = ACTIONS(241),
    [anon_sym_return] = ACTIONS(241),
    [anon_sym_break] = ACTIONS(241),
    [anon_sym_continue] = ACTIONS(241),
    [anon_sym_goto] = ACTIONS(241),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_BANG] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(241),
    [anon_sym_DASH_DASH] = ACTIONS(239),
    [anon_sym_PLUS_PLUS] = ACTIONS(239),
    [anon_sym_sizeof] = ACTIONS(241),
    [sym_number_literal] = ACTIONS(239),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_true] = ACTIONS(241),
    [sym_false] = ACTIONS(241),
    [sym_null] = ACTIONS(241),
    [sym_identifier] = ACTIONS(241),
    [sym_comment] = ACTIONS(41),
  },
  [304] = {
    [sym_compound_statement] = STATE(529),
    [sym_parameter_list] = STATE(129),
    [aux_sym_declaration_repeat1] = STATE(530),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_COMMA] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(255),
    [sym_comment] = ACTIONS(41),
  },
  [305] = {
    [aux_sym_declaration_repeat1] = STATE(530),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_COMMA] = ACTIONS(251),
    [sym_comment] = ACTIONS(41),
  },
  [306] = {
    [sym_ta_top_level] = STATE(306),
    [sym_preproc_include] = STATE(306),
    [sym_preproc_def] = STATE(306),
    [sym_preproc_function_def] = STATE(306),
    [sym_preproc_call] = STATE(306),
    [sym_preproc_if] = STATE(306),
    [sym_preproc_ifdef] = STATE(306),
    [sym_function_definition] = STATE(306),
    [sym_declaration] = STATE(306),
    [sym_type_definition] = STATE(306),
    [sym__declaration_specifiers] = STATE(158),
    [sym_linkage_specification] = STATE(306),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(306),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(306),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(1245),
    [anon_sym_indexvars] = ACTIONS(1248),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1251),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1254),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1257),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1260),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1260),
    [sym_preproc_directive] = ACTIONS(1263),
    [anon_sym_typedef] = ACTIONS(1266),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym_static] = ACTIONS(290),
    [anon_sym_auto] = ACTIONS(290),
    [anon_sym_register] = ACTIONS(290),
    [anon_sym_inline] = ACTIONS(290),
    [anon_sym_const] = ACTIONS(293),
    [anon_sym_restrict] = ACTIONS(293),
    [anon_sym_volatile] = ACTIONS(293),
    [anon_sym__Atomic] = ACTIONS(293),
    [anon_sym_unsigned] = ACTIONS(296),
    [anon_sym_long] = ACTIONS(296),
    [anon_sym_short] = ACTIONS(296),
    [sym_primitive_type] = ACTIONS(299),
    [anon_sym_enum] = ACTIONS(302),
    [anon_sym_struct] = ACTIONS(305),
    [anon_sym_union] = ACTIONS(308),
    [sym_identifier] = ACTIONS(311),
    [sym_comment] = ACTIONS(41),
  },
  [307] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1272),
    [sym_comment] = ACTIONS(41),
  },
  [308] = {
    [sym_ta_top_level] = STATE(171),
    [sym_preproc_include] = STATE(171),
    [sym_preproc_def] = STATE(171),
    [sym_preproc_function_def] = STATE(171),
    [sym_preproc_call] = STATE(171),
    [sym_preproc_if] = STATE(171),
    [sym_preproc_ifdef] = STATE(171),
    [sym_preproc_else] = STATE(531),
    [sym_preproc_elif] = STATE(531),
    [sym_function_definition] = STATE(171),
    [sym_declaration] = STATE(171),
    [sym_type_definition] = STATE(171),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(171),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(171),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(171),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [309] = {
    [anon_sym_tensor] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_indexvars] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(427),
    [sym_preproc_directive] = ACTIONS(427),
    [anon_sym_typedef] = ACTIONS(427),
    [anon_sym_extern] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(427),
    [anon_sym_auto] = ACTIONS(427),
    [anon_sym_register] = ACTIONS(427),
    [anon_sym_inline] = ACTIONS(427),
    [anon_sym_const] = ACTIONS(427),
    [anon_sym_restrict] = ACTIONS(427),
    [anon_sym_volatile] = ACTIONS(427),
    [anon_sym__Atomic] = ACTIONS(427),
    [anon_sym_unsigned] = ACTIONS(427),
    [anon_sym_long] = ACTIONS(427),
    [anon_sym_short] = ACTIONS(427),
    [sym_primitive_type] = ACTIONS(427),
    [anon_sym_enum] = ACTIONS(427),
    [anon_sym_struct] = ACTIONS(427),
    [anon_sym_union] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_switch] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(427),
    [anon_sym_default] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(427),
    [anon_sym_continue] = ACTIONS(427),
    [anon_sym_goto] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_TILDE] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(425),
    [anon_sym_sizeof] = ACTIONS(427),
    [sym_number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(425),
    [anon_sym_DQUOTE] = ACTIONS(425),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_identifier] = ACTIONS(427),
    [sym_comment] = ACTIONS(41),
  },
  [310] = {
    [sym_parameter_list] = STATE(180),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(437),
    [sym_comment] = ACTIONS(41),
  },
  [311] = {
    [sym__type_declarator] = STATE(533),
    [sym_pointer_type_declarator] = STATE(533),
    [sym_function_type_declarator] = STATE(533),
    [sym_array_type_declarator] = STATE(533),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(177),
    [sym_identifier] = ACTIONS(179),
    [sym_comment] = ACTIONS(41),
  },
  [312] = {
    [sym_ta_top_level] = STATE(535),
    [sym_preproc_include] = STATE(535),
    [sym_preproc_def] = STATE(535),
    [sym_preproc_function_def] = STATE(535),
    [sym_preproc_call] = STATE(535),
    [sym_preproc_if] = STATE(535),
    [sym_preproc_ifdef] = STATE(535),
    [sym_function_definition] = STATE(535),
    [sym_declaration] = STATE(535),
    [sym_type_definition] = STATE(535),
    [sym__declaration_specifiers] = STATE(18),
    [sym_linkage_specification] = STATE(535),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(535),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(535),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(1278),
    [anon_sym_indexvars] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(17),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [313] = {
    [anon_sym_tensor] = ACTIONS(451),
    [anon_sym_indexvars] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(451),
    [sym_preproc_directive] = ACTIONS(451),
    [anon_sym_typedef] = ACTIONS(451),
    [anon_sym_extern] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(451),
    [anon_sym_auto] = ACTIONS(451),
    [anon_sym_register] = ACTIONS(451),
    [anon_sym_inline] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(451),
    [anon_sym_restrict] = ACTIONS(451),
    [anon_sym_volatile] = ACTIONS(451),
    [anon_sym__Atomic] = ACTIONS(451),
    [anon_sym_unsigned] = ACTIONS(451),
    [anon_sym_long] = ACTIONS(451),
    [anon_sym_short] = ACTIONS(451),
    [sym_primitive_type] = ACTIONS(451),
    [anon_sym_enum] = ACTIONS(451),
    [anon_sym_struct] = ACTIONS(451),
    [anon_sym_union] = ACTIONS(451),
    [sym_identifier] = ACTIONS(451),
    [sym_comment] = ACTIONS(41),
  },
  [314] = {
    [sym__declarator] = STATE(168),
    [sym_pointer_declarator] = STATE(168),
    [sym_function_declarator] = STATE(168),
    [sym_array_declarator] = STATE(168),
    [sym_init_declarator] = STATE(169),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(98),
    [sym_identifier] = ACTIONS(413),
    [sym_comment] = ACTIONS(41),
  },
  [315] = {
    [sym_preproc_include] = STATE(537),
    [sym_preproc_def] = STATE(537),
    [sym_preproc_function_def] = STATE(537),
    [sym_preproc_call] = STATE(537),
    [sym_preproc_if_in_compound_statement] = STATE(537),
    [sym_preproc_ifdef_in_compound_statement] = STATE(537),
    [sym_declaration] = STATE(537),
    [sym_type_definition] = STATE(537),
    [sym__declaration_specifiers] = STATE(246),
    [sym_compound_statement] = STATE(537),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(537),
    [sym_expression_statement] = STATE(537),
    [sym_if_statement] = STATE(537),
    [sym_switch_statement] = STATE(537),
    [sym_case_statement] = STATE(537),
    [sym_while_statement] = STATE(537),
    [sym_do_statement] = STATE(537),
    [sym_for_statement] = STATE(537),
    [sym_return_statement] = STATE(537),
    [sym_break_statement] = STATE(537),
    [sym_continue_statement] = STATE(537),
    [sym_goto_statement] = STATE(537),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(537),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(537),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_RBRACE] = ACTIONS(1280),
    [anon_sym_SEMI] = ACTIONS(539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(541),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(545),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(545),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(587),
    [sym_comment] = ACTIONS(41),
  },
  [316] = {
    [anon_sym_tensor] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_indexvars] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(591),
    [sym_preproc_directive] = ACTIONS(591),
    [anon_sym_typedef] = ACTIONS(591),
    [anon_sym_extern] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_static] = ACTIONS(591),
    [anon_sym_auto] = ACTIONS(591),
    [anon_sym_register] = ACTIONS(591),
    [anon_sym_inline] = ACTIONS(591),
    [anon_sym_const] = ACTIONS(591),
    [anon_sym_restrict] = ACTIONS(591),
    [anon_sym_volatile] = ACTIONS(591),
    [anon_sym__Atomic] = ACTIONS(591),
    [anon_sym_unsigned] = ACTIONS(591),
    [anon_sym_long] = ACTIONS(591),
    [anon_sym_short] = ACTIONS(591),
    [sym_primitive_type] = ACTIONS(591),
    [anon_sym_enum] = ACTIONS(591),
    [anon_sym_struct] = ACTIONS(591),
    [anon_sym_union] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(591),
    [anon_sym_else] = ACTIONS(591),
    [anon_sym_switch] = ACTIONS(591),
    [anon_sym_case] = ACTIONS(591),
    [anon_sym_default] = ACTIONS(591),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_do] = ACTIONS(591),
    [anon_sym_for] = ACTIONS(591),
    [anon_sym_return] = ACTIONS(591),
    [anon_sym_break] = ACTIONS(591),
    [anon_sym_continue] = ACTIONS(591),
    [anon_sym_goto] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [anon_sym_PLUS] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_sizeof] = ACTIONS(591),
    [sym_number_literal] = ACTIONS(589),
    [anon_sym_SQUOTE] = ACTIONS(589),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [sym_true] = ACTIONS(591),
    [sym_false] = ACTIONS(591),
    [sym_null] = ACTIONS(591),
    [sym_identifier] = ACTIONS(591),
    [sym_comment] = ACTIONS(41),
  },
  [317] = {
    [anon_sym_tensor] = ACTIONS(631),
    [anon_sym_indexvars] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(631),
    [sym_preproc_directive] = ACTIONS(631),
    [anon_sym_typedef] = ACTIONS(631),
    [anon_sym_extern] = ACTIONS(631),
    [anon_sym_static] = ACTIONS(631),
    [anon_sym_auto] = ACTIONS(631),
    [anon_sym_register] = ACTIONS(631),
    [anon_sym_inline] = ACTIONS(631),
    [anon_sym_const] = ACTIONS(631),
    [anon_sym_restrict] = ACTIONS(631),
    [anon_sym_volatile] = ACTIONS(631),
    [anon_sym__Atomic] = ACTIONS(631),
    [anon_sym_unsigned] = ACTIONS(631),
    [anon_sym_long] = ACTIONS(631),
    [anon_sym_short] = ACTIONS(631),
    [sym_primitive_type] = ACTIONS(631),
    [anon_sym_enum] = ACTIONS(631),
    [anon_sym_struct] = ACTIONS(631),
    [anon_sym_union] = ACTIONS(631),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(41),
  },
  [318] = {
    [aux_sym_declaration_repeat1] = STATE(272),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_COMMA] = ACTIONS(251),
    [sym_comment] = ACTIONS(41),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(1284),
    [anon_sym_tensor] = ACTIONS(1286),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_indexvars] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1286),
    [sym_preproc_directive] = ACTIONS(1286),
    [anon_sym_typedef] = ACTIONS(1286),
    [anon_sym_extern] = ACTIONS(1286),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_auto] = ACTIONS(1286),
    [anon_sym_register] = ACTIONS(1286),
    [anon_sym_inline] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_restrict] = ACTIONS(1286),
    [anon_sym_volatile] = ACTIONS(1286),
    [anon_sym__Atomic] = ACTIONS(1286),
    [anon_sym_unsigned] = ACTIONS(1286),
    [anon_sym_long] = ACTIONS(1286),
    [anon_sym_short] = ACTIONS(1286),
    [sym_primitive_type] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
    [anon_sym_struct] = ACTIONS(1286),
    [anon_sym_union] = ACTIONS(1286),
    [sym_identifier] = ACTIONS(1286),
    [sym_comment] = ACTIONS(41),
  },
  [320] = {
    [ts_builtin_sym_end] = ACTIONS(1288),
    [anon_sym_tensor] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [anon_sym_indexvars] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1290),
    [sym_preproc_directive] = ACTIONS(1290),
    [anon_sym_typedef] = ACTIONS(1290),
    [anon_sym_extern] = ACTIONS(1290),
    [anon_sym_static] = ACTIONS(1290),
    [anon_sym_auto] = ACTIONS(1290),
    [anon_sym_register] = ACTIONS(1290),
    [anon_sym_inline] = ACTIONS(1290),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_restrict] = ACTIONS(1290),
    [anon_sym_volatile] = ACTIONS(1290),
    [anon_sym__Atomic] = ACTIONS(1290),
    [anon_sym_unsigned] = ACTIONS(1290),
    [anon_sym_long] = ACTIONS(1290),
    [anon_sym_short] = ACTIONS(1290),
    [sym_primitive_type] = ACTIONS(1290),
    [anon_sym_enum] = ACTIONS(1290),
    [anon_sym_struct] = ACTIONS(1290),
    [anon_sym_union] = ACTIONS(1290),
    [sym_identifier] = ACTIONS(1290),
    [sym_comment] = ACTIONS(41),
  },
  [321] = {
    [sym__type_declarator] = STATE(323),
    [sym_pointer_type_declarator] = STATE(323),
    [sym_function_type_declarator] = STATE(323),
    [sym_array_type_declarator] = STATE(323),
    [sym_type_qualifier] = STATE(215),
    [aux_sym_type_definition_repeat1] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(429),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(431),
    [sym_comment] = ACTIONS(41),
  },
  [322] = {
    [anon_sym_LPAREN] = ACTIONS(1292),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_SEMI] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [sym_comment] = ACTIONS(41),
  },
  [323] = {
    [sym_parameter_list] = STATE(180),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(437),
    [sym_comment] = ACTIONS(41),
  },
  [324] = {
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_RPAREN] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1296),
    [anon_sym_LBRACK] = ACTIONS(1296),
    [sym_comment] = ACTIONS(41),
  },
  [325] = {
    [sym__expression] = STATE(540),
    [sym_conditional_expression] = STATE(540),
    [sym_assignment_expression] = STATE(540),
    [sym_pointer_expression] = STATE(540),
    [sym_logical_expression] = STATE(540),
    [sym_bitwise_expression] = STATE(540),
    [sym_equality_expression] = STATE(540),
    [sym_relational_expression] = STATE(540),
    [sym_shift_expression] = STATE(540),
    [sym_math_expression] = STATE(540),
    [sym_cast_expression] = STATE(540),
    [sym_sizeof_expression] = STATE(540),
    [sym_subscript_expression] = STATE(540),
    [sym_call_expression] = STATE(540),
    [sym_field_expression] = STATE(540),
    [sym_compound_literal_expression] = STATE(540),
    [sym_parenthesized_expression] = STATE(540),
    [sym_char_literal] = STATE(540),
    [sym_concatenated_string] = STATE(540),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(1298),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1302),
    [sym_false] = ACTIONS(1302),
    [sym_null] = ACTIONS(1302),
    [sym_identifier] = ACTIONS(1302),
    [sym_comment] = ACTIONS(41),
  },
  [326] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(1304),
    [anon_sym_tensor] = ACTIONS(1306),
    [anon_sym_LPAREN] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_indexvars] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1306),
    [sym_preproc_directive] = ACTIONS(1306),
    [anon_sym_typedef] = ACTIONS(1306),
    [anon_sym_extern] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1306),
    [anon_sym_auto] = ACTIONS(1306),
    [anon_sym_register] = ACTIONS(1306),
    [anon_sym_inline] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym_unsigned] = ACTIONS(1306),
    [anon_sym_long] = ACTIONS(1306),
    [anon_sym_short] = ACTIONS(1306),
    [sym_primitive_type] = ACTIONS(1306),
    [anon_sym_enum] = ACTIONS(1306),
    [anon_sym_struct] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1306),
    [anon_sym_case] = ACTIONS(1306),
    [anon_sym_default] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_do] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_goto] = ACTIONS(1306),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_sizeof] = ACTIONS(1306),
    [sym_number_literal] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [sym_null] = ACTIONS(1306),
    [sym_identifier] = ACTIONS(1306),
    [sym_comment] = ACTIONS(41),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(1308),
    [anon_sym_tensor] = ACTIONS(1310),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_indexvars] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1310),
    [sym_preproc_directive] = ACTIONS(1310),
    [anon_sym_typedef] = ACTIONS(1310),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_auto] = ACTIONS(1310),
    [anon_sym_register] = ACTIONS(1310),
    [anon_sym_inline] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [anon_sym_restrict] = ACTIONS(1310),
    [anon_sym_volatile] = ACTIONS(1310),
    [anon_sym__Atomic] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
    [anon_sym_struct] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1310),
    [sym_identifier] = ACTIONS(1310),
    [sym_comment] = ACTIONS(41),
  },
  [329] = {
    [sym_ta_top_level] = STATE(329),
    [sym_preproc_include] = STATE(329),
    [sym_preproc_def] = STATE(329),
    [sym_preproc_function_def] = STATE(329),
    [sym_preproc_call] = STATE(329),
    [sym_preproc_if] = STATE(329),
    [sym_preproc_ifdef] = STATE(329),
    [sym_function_definition] = STATE(329),
    [sym_declaration] = STATE(329),
    [sym_type_definition] = STATE(329),
    [sym__declaration_specifiers] = STATE(18),
    [sym_linkage_specification] = STATE(329),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(329),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(329),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_indexvars] = ACTIONS(266),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(269),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(272),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(275),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(278),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(278),
    [sym_preproc_directive] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(284),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym_static] = ACTIONS(290),
    [anon_sym_auto] = ACTIONS(290),
    [anon_sym_register] = ACTIONS(290),
    [anon_sym_inline] = ACTIONS(290),
    [anon_sym_const] = ACTIONS(293),
    [anon_sym_restrict] = ACTIONS(293),
    [anon_sym_volatile] = ACTIONS(293),
    [anon_sym__Atomic] = ACTIONS(293),
    [anon_sym_unsigned] = ACTIONS(296),
    [anon_sym_long] = ACTIONS(296),
    [anon_sym_short] = ACTIONS(296),
    [sym_primitive_type] = ACTIONS(299),
    [anon_sym_enum] = ACTIONS(302),
    [anon_sym_struct] = ACTIONS(305),
    [anon_sym_union] = ACTIONS(308),
    [sym_identifier] = ACTIONS(311),
    [sym_comment] = ACTIONS(41),
  },
  [330] = {
    [sym_storage_class_specifier] = STATE(330),
    [sym_type_qualifier] = STATE(330),
    [aux_sym__declaration_specifiers_repeat1] = STATE(330),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_extern] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_static] = ACTIONS(314),
    [anon_sym_auto] = ACTIONS(314),
    [anon_sym_register] = ACTIONS(314),
    [anon_sym_inline] = ACTIONS(314),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [sym_identifier] = ACTIONS(320),
    [sym_comment] = ACTIONS(41),
  },
  [331] = {
    [sym_storage_class_specifier] = STATE(330),
    [sym_type_qualifier] = STATE(330),
    [aux_sym__declaration_specifiers_repeat1] = STATE(330),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(639),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(641),
    [sym_comment] = ACTIONS(41),
  },
  [332] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(541),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [333] = {
    [sym__expression] = STATE(405),
    [sym_conditional_expression] = STATE(405),
    [sym_assignment_expression] = STATE(405),
    [sym_pointer_expression] = STATE(405),
    [sym_logical_expression] = STATE(405),
    [sym_bitwise_expression] = STATE(405),
    [sym_equality_expression] = STATE(405),
    [sym_relational_expression] = STATE(405),
    [sym_shift_expression] = STATE(405),
    [sym_math_expression] = STATE(405),
    [sym_cast_expression] = STATE(405),
    [sym_sizeof_expression] = STATE(405),
    [sym_subscript_expression] = STATE(405),
    [sym_call_expression] = STATE(405),
    [sym_field_expression] = STATE(405),
    [sym_compound_literal_expression] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_char_literal] = STATE(405),
    [sym_concatenated_string] = STATE(405),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_identifier] = ACTIONS(984),
    [sym_comment] = ACTIONS(41),
  },
  [334] = {
    [sym__expression] = STATE(434),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_char_literal] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1040),
    [sym_comment] = ACTIONS(41),
  },
  [335] = {
    [sym__expression] = STATE(435),
    [sym_conditional_expression] = STATE(435),
    [sym_assignment_expression] = STATE(435),
    [sym_pointer_expression] = STATE(435),
    [sym_logical_expression] = STATE(435),
    [sym_bitwise_expression] = STATE(435),
    [sym_equality_expression] = STATE(435),
    [sym_relational_expression] = STATE(435),
    [sym_shift_expression] = STATE(435),
    [sym_math_expression] = STATE(435),
    [sym_cast_expression] = STATE(435),
    [sym_sizeof_expression] = STATE(435),
    [sym_subscript_expression] = STATE(435),
    [sym_call_expression] = STATE(435),
    [sym_field_expression] = STATE(435),
    [sym_compound_literal_expression] = STATE(435),
    [sym_parenthesized_expression] = STATE(435),
    [sym_char_literal] = STATE(435),
    [sym_concatenated_string] = STATE(435),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_identifier] = ACTIONS(1044),
    [sym_comment] = ACTIONS(41),
  },
  [336] = {
    [sym__expression] = STATE(436),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_char_literal] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1048),
    [sym_comment] = ACTIONS(41),
  },
  [337] = {
    [sym__expression] = STATE(543),
    [sym_conditional_expression] = STATE(543),
    [sym_assignment_expression] = STATE(543),
    [sym_pointer_expression] = STATE(543),
    [sym_logical_expression] = STATE(543),
    [sym_bitwise_expression] = STATE(543),
    [sym_equality_expression] = STATE(543),
    [sym_relational_expression] = STATE(543),
    [sym_shift_expression] = STATE(543),
    [sym_math_expression] = STATE(543),
    [sym_cast_expression] = STATE(543),
    [sym_sizeof_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_call_expression] = STATE(543),
    [sym_field_expression] = STATE(543),
    [sym_compound_literal_expression] = STATE(543),
    [sym_parenthesized_expression] = STATE(543),
    [sym_char_literal] = STATE(543),
    [sym_concatenated_string] = STATE(543),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(1312),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(1314),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1316),
    [sym_false] = ACTIONS(1316),
    [sym_null] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1316),
    [sym_comment] = ACTIONS(41),
  },
  [338] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1318),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_EQ] = ACTIONS(1326),
    [anon_sym_SLASH_EQ] = ACTIONS(1326),
    [anon_sym_PERCENT_EQ] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1326),
    [anon_sym_DASH_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_GT_EQ] = ACTIONS(1326),
    [anon_sym_AMP_EQ] = ACTIONS(1326),
    [anon_sym_CARET_EQ] = ACTIONS(1326),
    [anon_sym_PIPE_EQ] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(1330),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [339] = {
    [sym_string_literal] = STATE(556),
    [aux_sym_concatenated_string_repeat1] = STATE(556),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [340] = {
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_RPAREN] = ACTIONS(1348),
    [anon_sym_SEMI] = ACTIONS(1348),
    [anon_sym_COMMA] = ACTIONS(1348),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_RBRACK] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1348),
    [anon_sym_AMP] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1348),
    [anon_sym_sizeof] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1348),
    [anon_sym_DQUOTE] = ACTIONS(1348),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [sym_null] = ACTIONS(1350),
    [sym_identifier] = ACTIONS(1350),
    [sym_comment] = ACTIONS(41),
  },
  [341] = {
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_COMMA] = ACTIONS(1352),
    [sym_comment] = ACTIONS(41),
  },
  [342] = {
    [sym_enumerator] = STATE(341),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(195),
    [sym_comment] = ACTIONS(41),
  },
  [343] = {
    [aux_sym_enumerator_list_repeat1] = STATE(343),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_COMMA] = ACTIONS(1356),
    [sym_comment] = ACTIONS(41),
  },
  [344] = {
    [anon_sym_RBRACE] = ACTIONS(1359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1359),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [sym_identifier] = ACTIONS(1361),
    [sym_comment] = ACTIONS(41),
  },
  [345] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(559),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(559),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(559),
    [sym_field_declaration] = STATE(559),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(559),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(207),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1363),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [346] = {
    [sym_preproc_arg] = ACTIONS(1365),
    [sym_comment] = ACTIONS(55),
  },
  [347] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1367),
    [sym_comment] = ACTIONS(41),
  },
  [348] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(563),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(563),
    [sym_preproc_else_in_field_declaration_list] = STATE(562),
    [sym_preproc_elif_in_field_declaration_list] = STATE(562),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(563),
    [sym_field_declaration] = STATE(563),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(563),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(207),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1367),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(820),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(822),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [349] = {
    [anon_sym_RBRACE] = ACTIONS(1369),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1369),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1369),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1369),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1369),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1369),
    [anon_sym_extern] = ACTIONS(1371),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_auto] = ACTIONS(1371),
    [anon_sym_register] = ACTIONS(1371),
    [anon_sym_inline] = ACTIONS(1371),
    [anon_sym_const] = ACTIONS(1371),
    [anon_sym_restrict] = ACTIONS(1371),
    [anon_sym_volatile] = ACTIONS(1371),
    [anon_sym__Atomic] = ACTIONS(1371),
    [anon_sym_unsigned] = ACTIONS(1371),
    [anon_sym_long] = ACTIONS(1371),
    [anon_sym_short] = ACTIONS(1371),
    [sym_primitive_type] = ACTIONS(1371),
    [anon_sym_enum] = ACTIONS(1371),
    [anon_sym_struct] = ACTIONS(1371),
    [anon_sym_union] = ACTIONS(1371),
    [sym_identifier] = ACTIONS(1371),
    [sym_comment] = ACTIONS(41),
  },
  [350] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1373),
    [sym_comment] = ACTIONS(41),
  },
  [351] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(563),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(563),
    [sym_preproc_else_in_field_declaration_list] = STATE(565),
    [sym_preproc_elif_in_field_declaration_list] = STATE(565),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(563),
    [sym_field_declaration] = STATE(563),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(563),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(207),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1373),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(820),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(822),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [352] = {
    [sym__field_declarator] = STATE(354),
    [sym_pointer_field_declarator] = STATE(354),
    [sym_function_field_declarator] = STATE(354),
    [sym_array_field_declarator] = STATE(354),
    [sym_type_qualifier] = STATE(566),
    [aux_sym_type_definition_repeat1] = STATE(566),
    [anon_sym_LPAREN] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(826),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(832),
    [sym_comment] = ACTIONS(41),
  },
  [353] = {
    [sym_parameter_list] = STATE(368),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(858),
    [sym_comment] = ACTIONS(41),
  },
  [354] = {
    [sym_parameter_list] = STATE(368),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(1377),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_COMMA] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(858),
    [anon_sym_COLON] = ACTIONS(1377),
    [sym_comment] = ACTIONS(41),
  },
  [355] = {
    [sym__field_declarator] = STATE(568),
    [sym_pointer_field_declarator] = STATE(568),
    [sym_function_field_declarator] = STATE(568),
    [sym_array_field_declarator] = STATE(568),
    [sym_type_qualifier] = STATE(215),
    [aux_sym_type_definition_repeat1] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(485),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(832),
    [sym_comment] = ACTIONS(41),
  },
  [356] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(569),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [357] = {
    [sym__expression] = STATE(405),
    [sym_conditional_expression] = STATE(405),
    [sym_assignment_expression] = STATE(405),
    [sym_pointer_expression] = STATE(405),
    [sym_logical_expression] = STATE(405),
    [sym_bitwise_expression] = STATE(405),
    [sym_equality_expression] = STATE(405),
    [sym_relational_expression] = STATE(405),
    [sym_shift_expression] = STATE(405),
    [sym_math_expression] = STATE(405),
    [sym_cast_expression] = STATE(405),
    [sym_sizeof_expression] = STATE(405),
    [sym_subscript_expression] = STATE(405),
    [sym_call_expression] = STATE(405),
    [sym_field_expression] = STATE(405),
    [sym_compound_literal_expression] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_char_literal] = STATE(405),
    [sym_concatenated_string] = STATE(405),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_identifier] = ACTIONS(984),
    [sym_comment] = ACTIONS(41),
  },
  [358] = {
    [sym__expression] = STATE(434),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_char_literal] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1040),
    [sym_comment] = ACTIONS(41),
  },
  [359] = {
    [sym__expression] = STATE(435),
    [sym_conditional_expression] = STATE(435),
    [sym_assignment_expression] = STATE(435),
    [sym_pointer_expression] = STATE(435),
    [sym_logical_expression] = STATE(435),
    [sym_bitwise_expression] = STATE(435),
    [sym_equality_expression] = STATE(435),
    [sym_relational_expression] = STATE(435),
    [sym_shift_expression] = STATE(435),
    [sym_math_expression] = STATE(435),
    [sym_cast_expression] = STATE(435),
    [sym_sizeof_expression] = STATE(435),
    [sym_subscript_expression] = STATE(435),
    [sym_call_expression] = STATE(435),
    [sym_field_expression] = STATE(435),
    [sym_compound_literal_expression] = STATE(435),
    [sym_parenthesized_expression] = STATE(435),
    [sym_char_literal] = STATE(435),
    [sym_concatenated_string] = STATE(435),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_identifier] = ACTIONS(1044),
    [sym_comment] = ACTIONS(41),
  },
  [360] = {
    [sym__expression] = STATE(436),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_char_literal] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1048),
    [sym_comment] = ACTIONS(41),
  },
  [361] = {
    [sym__expression] = STATE(571),
    [sym_conditional_expression] = STATE(571),
    [sym_assignment_expression] = STATE(571),
    [sym_pointer_expression] = STATE(571),
    [sym_logical_expression] = STATE(571),
    [sym_bitwise_expression] = STATE(571),
    [sym_equality_expression] = STATE(571),
    [sym_relational_expression] = STATE(571),
    [sym_shift_expression] = STATE(571),
    [sym_math_expression] = STATE(571),
    [sym_cast_expression] = STATE(571),
    [sym_sizeof_expression] = STATE(571),
    [sym_subscript_expression] = STATE(571),
    [sym_call_expression] = STATE(571),
    [sym_field_expression] = STATE(571),
    [sym_compound_literal_expression] = STATE(571),
    [sym_parenthesized_expression] = STATE(571),
    [sym_char_literal] = STATE(571),
    [sym_concatenated_string] = STATE(571),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(1381),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_identifier] = ACTIONS(1383),
    [sym_comment] = ACTIONS(41),
  },
  [362] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [363] = {
    [sym_string_literal] = STATE(585),
    [aux_sym_concatenated_string_repeat1] = STATE(585),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [364] = {
    [anon_sym_RBRACE] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1417),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1415),
    [anon_sym_extern] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(1417),
    [anon_sym_auto] = ACTIONS(1417),
    [anon_sym_register] = ACTIONS(1417),
    [anon_sym_inline] = ACTIONS(1417),
    [anon_sym_const] = ACTIONS(1417),
    [anon_sym_restrict] = ACTIONS(1417),
    [anon_sym_volatile] = ACTIONS(1417),
    [anon_sym__Atomic] = ACTIONS(1417),
    [anon_sym_unsigned] = ACTIONS(1417),
    [anon_sym_long] = ACTIONS(1417),
    [anon_sym_short] = ACTIONS(1417),
    [sym_primitive_type] = ACTIONS(1417),
    [anon_sym_enum] = ACTIONS(1417),
    [anon_sym_struct] = ACTIONS(1417),
    [anon_sym_union] = ACTIONS(1417),
    [sym_identifier] = ACTIONS(1417),
    [sym_comment] = ACTIONS(41),
  },
  [365] = {
    [sym__field_declarator] = STATE(586),
    [sym_pointer_field_declarator] = STATE(586),
    [sym_function_field_declarator] = STATE(586),
    [sym_array_field_declarator] = STATE(586),
    [anon_sym_LPAREN] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(485),
    [sym_identifier] = ACTIONS(489),
    [sym_comment] = ACTIONS(41),
  },
  [366] = {
    [sym__declaration_specifiers] = STATE(588),
    [sym_storage_class_specifier] = STATE(266),
    [sym_type_qualifier] = STATE(266),
    [sym__type_specifier] = STATE(263),
    [sym_sized_type_specifier] = STATE(263),
    [sym_enum_specifier] = STATE(263),
    [sym_struct_specifier] = STATE(263),
    [sym_union_specifier] = STATE(263),
    [sym__expression] = STATE(589),
    [sym_conditional_expression] = STATE(589),
    [sym_assignment_expression] = STATE(589),
    [sym_pointer_expression] = STATE(589),
    [sym_logical_expression] = STATE(589),
    [sym_bitwise_expression] = STATE(589),
    [sym_equality_expression] = STATE(589),
    [sym_relational_expression] = STATE(589),
    [sym_shift_expression] = STATE(589),
    [sym_math_expression] = STATE(589),
    [sym_cast_expression] = STATE(589),
    [sym_sizeof_expression] = STATE(589),
    [sym_subscript_expression] = STATE(589),
    [sym_call_expression] = STATE(589),
    [sym_field_expression] = STATE(589),
    [sym_compound_literal_expression] = STATE(589),
    [sym_parenthesized_expression] = STATE(589),
    [sym_char_literal] = STATE(589),
    [sym_concatenated_string] = STATE(589),
    [sym_string_literal] = STATE(265),
    [sym_macro_type_specifier] = STATE(263),
    [aux_sym__declaration_specifiers_repeat1] = STATE(266),
    [aux_sym_sized_type_specifier_repeat1] = STATE(267),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(1419),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(603),
    [anon_sym_long] = ACTIONS(603),
    [anon_sym_short] = ACTIONS(603),
    [sym_primitive_type] = ACTIONS(605),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1421),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1423),
    [sym_false] = ACTIONS(1423),
    [sym_null] = ACTIONS(1423),
    [sym_identifier] = ACTIONS(621),
    [sym_comment] = ACTIONS(41),
  },
  [367] = {
    [sym__expression] = STATE(590),
    [sym_conditional_expression] = STATE(590),
    [sym_assignment_expression] = STATE(590),
    [sym_pointer_expression] = STATE(590),
    [sym_logical_expression] = STATE(590),
    [sym_bitwise_expression] = STATE(590),
    [sym_equality_expression] = STATE(590),
    [sym_relational_expression] = STATE(590),
    [sym_shift_expression] = STATE(590),
    [sym_math_expression] = STATE(590),
    [sym_cast_expression] = STATE(590),
    [sym_sizeof_expression] = STATE(590),
    [sym_subscript_expression] = STATE(590),
    [sym_call_expression] = STATE(590),
    [sym_field_expression] = STATE(590),
    [sym_compound_literal_expression] = STATE(590),
    [sym_parenthesized_expression] = STATE(590),
    [sym_char_literal] = STATE(590),
    [sym_concatenated_string] = STATE(590),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1427),
    [sym_false] = ACTIONS(1427),
    [sym_null] = ACTIONS(1427),
    [sym_identifier] = ACTIONS(1427),
    [sym_comment] = ACTIONS(41),
  },
  [368] = {
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_RPAREN] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1429),
    [anon_sym_COMMA] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1429),
    [anon_sym_COLON] = ACTIONS(1429),
    [sym_comment] = ACTIONS(41),
  },
  [369] = {
    [aux_sym_field_declaration_repeat1] = STATE(592),
    [anon_sym_SEMI] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(856),
    [anon_sym_COLON] = ACTIONS(1431),
    [sym_comment] = ACTIONS(41),
  },
  [370] = {
    [sym_storage_class_specifier] = STATE(370),
    [sym_type_qualifier] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(370),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_SEMI] = ACTIONS(637),
    [anon_sym_extern] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_static] = ACTIONS(314),
    [anon_sym_auto] = ACTIONS(314),
    [anon_sym_register] = ACTIONS(314),
    [anon_sym_inline] = ACTIONS(314),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [anon_sym_COLON] = ACTIONS(637),
    [sym_identifier] = ACTIONS(320),
    [sym_comment] = ACTIONS(41),
  },
  [371] = {
    [sym_storage_class_specifier] = STATE(370),
    [sym_type_qualifier] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(370),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(639),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(639),
    [sym_identifier] = ACTIONS(641),
    [sym_comment] = ACTIONS(41),
  },
  [372] = {
    [sym_parameter_list] = STATE(379),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(913),
    [sym_comment] = ACTIONS(41),
  },
  [373] = {
    [sym_parameter_list] = STATE(379),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(913),
    [sym_comment] = ACTIONS(41),
  },
  [374] = {
    [sym__abstract_declarator] = STATE(594),
    [sym_abstract_pointer_declarator] = STATE(594),
    [sym_abstract_function_declarator] = STATE(594),
    [sym_abstract_array_declarator] = STATE(594),
    [sym_type_qualifier] = STATE(595),
    [sym_parameter_list] = STATE(208),
    [aux_sym_type_definition_repeat1] = STATE(595),
    [anon_sym_LPAREN] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(1435),
    [anon_sym_STAR] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_const] = ACTIONS(903),
    [anon_sym_restrict] = ACTIONS(903),
    [anon_sym_volatile] = ACTIONS(903),
    [anon_sym__Atomic] = ACTIONS(903),
    [sym_comment] = ACTIONS(41),
  },
  [375] = {
    [anon_sym_LPAREN] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [sym_comment] = ACTIONS(41),
  },
  [376] = {
    [sym__expression] = STATE(597),
    [sym_conditional_expression] = STATE(597),
    [sym_assignment_expression] = STATE(597),
    [sym_pointer_expression] = STATE(597),
    [sym_logical_expression] = STATE(597),
    [sym_bitwise_expression] = STATE(597),
    [sym_equality_expression] = STATE(597),
    [sym_relational_expression] = STATE(597),
    [sym_shift_expression] = STATE(597),
    [sym_math_expression] = STATE(597),
    [sym_cast_expression] = STATE(597),
    [sym_sizeof_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_call_expression] = STATE(597),
    [sym_field_expression] = STATE(597),
    [sym_compound_literal_expression] = STATE(597),
    [sym_parenthesized_expression] = STATE(597),
    [sym_char_literal] = STATE(597),
    [sym_concatenated_string] = STATE(597),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_identifier] = ACTIONS(1443),
    [sym_comment] = ACTIONS(41),
  },
  [377] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [378] = {
    [sym__declaration_specifiers] = STATE(598),
    [sym_storage_class_specifier] = STATE(266),
    [sym_type_qualifier] = STATE(266),
    [sym__type_specifier] = STATE(263),
    [sym_sized_type_specifier] = STATE(263),
    [sym_enum_specifier] = STATE(263),
    [sym_struct_specifier] = STATE(263),
    [sym_union_specifier] = STATE(263),
    [sym__expression] = STATE(597),
    [sym_conditional_expression] = STATE(597),
    [sym_assignment_expression] = STATE(597),
    [sym_pointer_expression] = STATE(597),
    [sym_logical_expression] = STATE(597),
    [sym_bitwise_expression] = STATE(597),
    [sym_equality_expression] = STATE(597),
    [sym_relational_expression] = STATE(597),
    [sym_shift_expression] = STATE(597),
    [sym_math_expression] = STATE(597),
    [sym_cast_expression] = STATE(597),
    [sym_sizeof_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_call_expression] = STATE(597),
    [sym_field_expression] = STATE(597),
    [sym_compound_literal_expression] = STATE(597),
    [sym_parenthesized_expression] = STATE(597),
    [sym_char_literal] = STATE(597),
    [sym_concatenated_string] = STATE(597),
    [sym_string_literal] = STATE(265),
    [sym_macro_type_specifier] = STATE(263),
    [aux_sym__declaration_specifiers_repeat1] = STATE(266),
    [aux_sym_sized_type_specifier_repeat1] = STATE(267),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(1439),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(603),
    [anon_sym_long] = ACTIONS(603),
    [anon_sym_short] = ACTIONS(603),
    [sym_primitive_type] = ACTIONS(605),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_identifier] = ACTIONS(621),
    [sym_comment] = ACTIONS(41),
  },
  [379] = {
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_RPAREN] = ACTIONS(1445),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [sym_comment] = ACTIONS(41),
  },
  [380] = {
    [sym_parameter_list] = STATE(379),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(913),
    [sym_comment] = ACTIONS(41),
  },
  [381] = {
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1449),
    [anon_sym_EQ] = ACTIONS(1449),
    [anon_sym_COLON] = ACTIONS(1449),
    [sym_comment] = ACTIONS(41),
  },
  [382] = {
    [sym__declaration_specifiers] = STATE(218),
    [sym_storage_class_specifier] = STATE(220),
    [sym_type_qualifier] = STATE(220),
    [sym__type_specifier] = STATE(219),
    [sym_sized_type_specifier] = STATE(219),
    [sym_enum_specifier] = STATE(219),
    [sym_struct_specifier] = STATE(219),
    [sym_union_specifier] = STATE(219),
    [sym_parameter_declaration] = STATE(599),
    [sym_macro_type_specifier] = STATE(219),
    [aux_sym__declaration_specifiers_repeat1] = STATE(220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(531),
    [anon_sym_long] = ACTIONS(531),
    [anon_sym_short] = ACTIONS(531),
    [sym_primitive_type] = ACTIONS(533),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [383] = {
    [aux_sym_parameter_list_repeat1] = STATE(601),
    [anon_sym_RPAREN] = ACTIONS(1453),
    [anon_sym_COMMA] = ACTIONS(934),
    [sym_comment] = ACTIONS(41),
  },
  [384] = {
    [sym__declaration_specifiers] = STATE(218),
    [sym__declarator] = STATE(119),
    [sym__abstract_declarator] = STATE(372),
    [sym_pointer_declarator] = STATE(119),
    [sym_abstract_pointer_declarator] = STATE(372),
    [sym_function_declarator] = STATE(119),
    [sym_abstract_function_declarator] = STATE(372),
    [sym_array_declarator] = STATE(119),
    [sym_abstract_array_declarator] = STATE(372),
    [sym_storage_class_specifier] = STATE(220),
    [sym_type_qualifier] = STATE(220),
    [sym__type_specifier] = STATE(219),
    [sym_sized_type_specifier] = STATE(219),
    [sym_enum_specifier] = STATE(219),
    [sym_struct_specifier] = STATE(219),
    [sym_union_specifier] = STATE(219),
    [sym_parameter_list] = STATE(208),
    [sym_parameter_declaration] = STATE(217),
    [sym_macro_type_specifier] = STATE(219),
    [aux_sym__declaration_specifiers_repeat1] = STATE(220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(221),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_RPAREN] = ACTIONS(527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(529),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(531),
    [anon_sym_long] = ACTIONS(531),
    [anon_sym_short] = ACTIONS(531),
    [sym_primitive_type] = ACTIONS(533),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(1457),
    [sym_comment] = ACTIONS(41),
  },
  [385] = {
    [sym__declarator] = STATE(120),
    [sym__abstract_declarator] = STATE(373),
    [sym_pointer_declarator] = STATE(120),
    [sym_abstract_pointer_declarator] = STATE(373),
    [sym_function_declarator] = STATE(120),
    [sym_abstract_function_declarator] = STATE(373),
    [sym_array_declarator] = STATE(120),
    [sym_abstract_array_declarator] = STATE(373),
    [sym_type_qualifier] = STATE(604),
    [sym_parameter_list] = STATE(208),
    [aux_sym_type_definition_repeat1] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_STAR] = ACTIONS(940),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(243),
    [sym_comment] = ACTIONS(41),
  },
  [386] = {
    [sym_parameter_list] = STATE(129),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(253),
    [sym_comment] = ACTIONS(41),
  },
  [387] = {
    [sym_parameter_list] = STATE(379),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(913),
    [sym_comment] = ACTIONS(41),
  },
  [388] = {
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(257),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(41),
  },
  [389] = {
    [sym_storage_class_specifier] = STATE(606),
    [sym_type_qualifier] = STATE(606),
    [aux_sym__declaration_specifiers_repeat1] = STATE(606),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(257),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(41),
  },
  [390] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(390),
    [anon_sym_LPAREN] = ACTIONS(330),
    [anon_sym_RPAREN] = ACTIONS(330),
    [anon_sym_COMMA] = ACTIONS(330),
    [anon_sym_extern] = ACTIONS(332),
    [anon_sym_STAR] = ACTIONS(330),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_static] = ACTIONS(332),
    [anon_sym_auto] = ACTIONS(332),
    [anon_sym_register] = ACTIONS(332),
    [anon_sym_inline] = ACTIONS(332),
    [anon_sym_const] = ACTIONS(332),
    [anon_sym_restrict] = ACTIONS(332),
    [anon_sym_volatile] = ACTIONS(332),
    [anon_sym__Atomic] = ACTIONS(332),
    [anon_sym_unsigned] = ACTIONS(1461),
    [anon_sym_long] = ACTIONS(1461),
    [anon_sym_short] = ACTIONS(1461),
    [sym_primitive_type] = ACTIONS(332),
    [sym_identifier] = ACTIONS(332),
    [sym_comment] = ACTIONS(41),
  },
  [391] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(607),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [392] = {
    [sym__expression] = STATE(405),
    [sym_conditional_expression] = STATE(405),
    [sym_assignment_expression] = STATE(405),
    [sym_pointer_expression] = STATE(405),
    [sym_logical_expression] = STATE(405),
    [sym_bitwise_expression] = STATE(405),
    [sym_equality_expression] = STATE(405),
    [sym_relational_expression] = STATE(405),
    [sym_shift_expression] = STATE(405),
    [sym_math_expression] = STATE(405),
    [sym_cast_expression] = STATE(405),
    [sym_sizeof_expression] = STATE(405),
    [sym_subscript_expression] = STATE(405),
    [sym_call_expression] = STATE(405),
    [sym_field_expression] = STATE(405),
    [sym_compound_literal_expression] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_char_literal] = STATE(405),
    [sym_concatenated_string] = STATE(405),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_identifier] = ACTIONS(984),
    [sym_comment] = ACTIONS(41),
  },
  [393] = {
    [sym__expression] = STATE(434),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_char_literal] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1040),
    [sym_comment] = ACTIONS(41),
  },
  [394] = {
    [sym__expression] = STATE(435),
    [sym_conditional_expression] = STATE(435),
    [sym_assignment_expression] = STATE(435),
    [sym_pointer_expression] = STATE(435),
    [sym_logical_expression] = STATE(435),
    [sym_bitwise_expression] = STATE(435),
    [sym_equality_expression] = STATE(435),
    [sym_relational_expression] = STATE(435),
    [sym_shift_expression] = STATE(435),
    [sym_math_expression] = STATE(435),
    [sym_cast_expression] = STATE(435),
    [sym_sizeof_expression] = STATE(435),
    [sym_subscript_expression] = STATE(435),
    [sym_call_expression] = STATE(435),
    [sym_field_expression] = STATE(435),
    [sym_compound_literal_expression] = STATE(435),
    [sym_parenthesized_expression] = STATE(435),
    [sym_char_literal] = STATE(435),
    [sym_concatenated_string] = STATE(435),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_identifier] = ACTIONS(1044),
    [sym_comment] = ACTIONS(41),
  },
  [395] = {
    [sym__expression] = STATE(436),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_char_literal] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1048),
    [sym_comment] = ACTIONS(41),
  },
  [396] = {
    [sym__expression] = STATE(609),
    [sym_conditional_expression] = STATE(609),
    [sym_assignment_expression] = STATE(609),
    [sym_pointer_expression] = STATE(609),
    [sym_logical_expression] = STATE(609),
    [sym_bitwise_expression] = STATE(609),
    [sym_equality_expression] = STATE(609),
    [sym_relational_expression] = STATE(609),
    [sym_shift_expression] = STATE(609),
    [sym_math_expression] = STATE(609),
    [sym_cast_expression] = STATE(609),
    [sym_sizeof_expression] = STATE(609),
    [sym_subscript_expression] = STATE(609),
    [sym_call_expression] = STATE(609),
    [sym_field_expression] = STATE(609),
    [sym_compound_literal_expression] = STATE(609),
    [sym_parenthesized_expression] = STATE(609),
    [sym_char_literal] = STATE(609),
    [sym_concatenated_string] = STATE(609),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_identifier] = ACTIONS(1468),
    [sym_comment] = ACTIONS(41),
  },
  [397] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_RPAREN] = ACTIONS(1064),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1064),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(41),
  },
  [398] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [399] = {
    [anon_sym_RPAREN] = ACTIONS(1470),
    [sym_comment] = ACTIONS(41),
  },
  [400] = {
    [anon_sym_RPAREN] = ACTIONS(1502),
    [sym_comment] = ACTIONS(41),
  },
  [401] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_concatenated_string_repeat1] = STATE(625),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [402] = {
    [aux_sym_string_literal_repeat1] = STATE(627),
    [anon_sym_DQUOTE] = ACTIONS(1504),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(1506),
    [sym_escape_sequence] = ACTIONS(1506),
    [sym_comment] = ACTIONS(55),
  },
  [403] = {
    [sym_preproc_include] = STATE(650),
    [sym_preproc_def] = STATE(650),
    [sym_preproc_function_def] = STATE(650),
    [sym_preproc_call] = STATE(650),
    [sym_preproc_if_in_compound_statement] = STATE(650),
    [sym_preproc_ifdef_in_compound_statement] = STATE(650),
    [sym_preproc_else_in_compound_statement] = STATE(646),
    [sym_preproc_elif_in_compound_statement] = STATE(646),
    [sym_declaration] = STATE(650),
    [sym_type_definition] = STATE(650),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(650),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(650),
    [sym_expression_statement] = STATE(650),
    [sym_if_statement] = STATE(650),
    [sym_switch_statement] = STATE(650),
    [sym_case_statement] = STATE(650),
    [sym_while_statement] = STATE(650),
    [sym_do_statement] = STATE(650),
    [sym_for_statement] = STATE(650),
    [sym_return_statement] = STATE(650),
    [sym_break_statement] = STATE(650),
    [sym_continue_statement] = STATE(650),
    [sym_goto_statement] = STATE(650),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(650),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(650),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1512),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [404] = {
    [sym_preproc_include] = STATE(653),
    [sym_preproc_def] = STATE(653),
    [sym_preproc_function_def] = STATE(653),
    [sym_preproc_call] = STATE(653),
    [sym_preproc_if_in_compound_statement] = STATE(653),
    [sym_preproc_ifdef_in_compound_statement] = STATE(653),
    [sym_preproc_else_in_compound_statement] = STATE(652),
    [sym_preproc_elif_in_compound_statement] = STATE(652),
    [sym_declaration] = STATE(653),
    [sym_type_definition] = STATE(653),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(653),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(653),
    [sym_expression_statement] = STATE(653),
    [sym_if_statement] = STATE(653),
    [sym_switch_statement] = STATE(653),
    [sym_case_statement] = STATE(653),
    [sym_while_statement] = STATE(653),
    [sym_do_statement] = STATE(653),
    [sym_for_statement] = STATE(653),
    [sym_return_statement] = STATE(653),
    [sym_break_statement] = STATE(653),
    [sym_continue_statement] = STATE(653),
    [sym_goto_statement] = STATE(653),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(653),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(653),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1548),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [405] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1550),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_STAR] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1550),
    [anon_sym_EQ] = ACTIONS(1552),
    [anon_sym_COLON] = ACTIONS(1550),
    [anon_sym_QMARK] = ACTIONS(1550),
    [anon_sym_STAR_EQ] = ACTIONS(1550),
    [anon_sym_SLASH_EQ] = ACTIONS(1550),
    [anon_sym_PERCENT_EQ] = ACTIONS(1550),
    [anon_sym_PLUS_EQ] = ACTIONS(1550),
    [anon_sym_DASH_EQ] = ACTIONS(1550),
    [anon_sym_LT_LT_EQ] = ACTIONS(1550),
    [anon_sym_GT_GT_EQ] = ACTIONS(1550),
    [anon_sym_AMP_EQ] = ACTIONS(1550),
    [anon_sym_CARET_EQ] = ACTIONS(1550),
    [anon_sym_PIPE_EQ] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1552),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_CARET] = ACTIONS(1552),
    [anon_sym_EQ_EQ] = ACTIONS(1550),
    [anon_sym_BANG_EQ] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(1552),
    [anon_sym_GT] = ACTIONS(1552),
    [anon_sym_LT_EQ] = ACTIONS(1550),
    [anon_sym_GT_EQ] = ACTIONS(1550),
    [anon_sym_LT_LT] = ACTIONS(1552),
    [anon_sym_GT_GT] = ACTIONS(1552),
    [anon_sym_PLUS] = ACTIONS(1552),
    [anon_sym_DASH] = ACTIONS(1552),
    [anon_sym_SLASH] = ACTIONS(1552),
    [anon_sym_PERCENT] = ACTIONS(1552),
    [anon_sym_DASH_DASH] = ACTIONS(1550),
    [anon_sym_PLUS_PLUS] = ACTIONS(1550),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [406] = {
    [sym__expression] = STATE(654),
    [sym_comma_expression] = STATE(655),
    [sym_conditional_expression] = STATE(654),
    [sym_assignment_expression] = STATE(654),
    [sym_pointer_expression] = STATE(654),
    [sym_logical_expression] = STATE(654),
    [sym_bitwise_expression] = STATE(654),
    [sym_equality_expression] = STATE(654),
    [sym_relational_expression] = STATE(654),
    [sym_shift_expression] = STATE(654),
    [sym_math_expression] = STATE(654),
    [sym_cast_expression] = STATE(654),
    [sym_sizeof_expression] = STATE(654),
    [sym_subscript_expression] = STATE(654),
    [sym_call_expression] = STATE(654),
    [sym_field_expression] = STATE(654),
    [sym_compound_literal_expression] = STATE(654),
    [sym_parenthesized_expression] = STATE(654),
    [sym_char_literal] = STATE(654),
    [sym_concatenated_string] = STATE(654),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(1554),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1556),
    [sym_false] = ACTIONS(1556),
    [sym_null] = ACTIONS(1556),
    [sym_identifier] = ACTIONS(1556),
    [sym_comment] = ACTIONS(41),
  },
  [407] = {
    [sym_compound_statement] = STATE(663),
    [sym_labeled_statement] = STATE(663),
    [sym_expression_statement] = STATE(663),
    [sym_if_statement] = STATE(663),
    [sym_switch_statement] = STATE(663),
    [sym_case_statement] = STATE(663),
    [sym_while_statement] = STATE(663),
    [sym_do_statement] = STATE(663),
    [sym_for_statement] = STATE(663),
    [sym_return_statement] = STATE(663),
    [sym_break_statement] = STATE(663),
    [sym_continue_statement] = STATE(663),
    [sym_goto_statement] = STATE(663),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [408] = {
    [sym_compound_statement] = STATE(665),
    [sym_labeled_statement] = STATE(665),
    [sym_expression_statement] = STATE(665),
    [sym_if_statement] = STATE(665),
    [sym_switch_statement] = STATE(665),
    [sym_case_statement] = STATE(665),
    [sym_while_statement] = STATE(665),
    [sym_do_statement] = STATE(665),
    [sym_for_statement] = STATE(665),
    [sym_return_statement] = STATE(665),
    [sym_break_statement] = STATE(665),
    [sym_continue_statement] = STATE(665),
    [sym_goto_statement] = STATE(665),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1572),
    [sym_comment] = ACTIONS(41),
  },
  [409] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(666),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [410] = {
    [sym__expression] = STATE(405),
    [sym_conditional_expression] = STATE(405),
    [sym_assignment_expression] = STATE(405),
    [sym_pointer_expression] = STATE(405),
    [sym_logical_expression] = STATE(405),
    [sym_bitwise_expression] = STATE(405),
    [sym_equality_expression] = STATE(405),
    [sym_relational_expression] = STATE(405),
    [sym_shift_expression] = STATE(405),
    [sym_math_expression] = STATE(405),
    [sym_cast_expression] = STATE(405),
    [sym_sizeof_expression] = STATE(405),
    [sym_subscript_expression] = STATE(405),
    [sym_call_expression] = STATE(405),
    [sym_field_expression] = STATE(405),
    [sym_compound_literal_expression] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_char_literal] = STATE(405),
    [sym_concatenated_string] = STATE(405),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_identifier] = ACTIONS(984),
    [sym_comment] = ACTIONS(41),
  },
  [411] = {
    [sym__expression] = STATE(434),
    [sym_conditional_expression] = STATE(434),
    [sym_assignment_expression] = STATE(434),
    [sym_pointer_expression] = STATE(434),
    [sym_logical_expression] = STATE(434),
    [sym_bitwise_expression] = STATE(434),
    [sym_equality_expression] = STATE(434),
    [sym_relational_expression] = STATE(434),
    [sym_shift_expression] = STATE(434),
    [sym_math_expression] = STATE(434),
    [sym_cast_expression] = STATE(434),
    [sym_sizeof_expression] = STATE(434),
    [sym_subscript_expression] = STATE(434),
    [sym_call_expression] = STATE(434),
    [sym_field_expression] = STATE(434),
    [sym_compound_literal_expression] = STATE(434),
    [sym_parenthesized_expression] = STATE(434),
    [sym_char_literal] = STATE(434),
    [sym_concatenated_string] = STATE(434),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1040),
    [sym_comment] = ACTIONS(41),
  },
  [412] = {
    [sym__expression] = STATE(435),
    [sym_conditional_expression] = STATE(435),
    [sym_assignment_expression] = STATE(435),
    [sym_pointer_expression] = STATE(435),
    [sym_logical_expression] = STATE(435),
    [sym_bitwise_expression] = STATE(435),
    [sym_equality_expression] = STATE(435),
    [sym_relational_expression] = STATE(435),
    [sym_shift_expression] = STATE(435),
    [sym_math_expression] = STATE(435),
    [sym_cast_expression] = STATE(435),
    [sym_sizeof_expression] = STATE(435),
    [sym_subscript_expression] = STATE(435),
    [sym_call_expression] = STATE(435),
    [sym_field_expression] = STATE(435),
    [sym_compound_literal_expression] = STATE(435),
    [sym_parenthesized_expression] = STATE(435),
    [sym_char_literal] = STATE(435),
    [sym_concatenated_string] = STATE(435),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_identifier] = ACTIONS(1044),
    [sym_comment] = ACTIONS(41),
  },
  [413] = {
    [sym__expression] = STATE(436),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_char_literal] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1048),
    [sym_comment] = ACTIONS(41),
  },
  [414] = {
    [sym__expression] = STATE(668),
    [sym_conditional_expression] = STATE(668),
    [sym_assignment_expression] = STATE(668),
    [sym_pointer_expression] = STATE(668),
    [sym_logical_expression] = STATE(668),
    [sym_bitwise_expression] = STATE(668),
    [sym_equality_expression] = STATE(668),
    [sym_relational_expression] = STATE(668),
    [sym_shift_expression] = STATE(668),
    [sym_math_expression] = STATE(668),
    [sym_cast_expression] = STATE(668),
    [sym_sizeof_expression] = STATE(668),
    [sym_subscript_expression] = STATE(668),
    [sym_call_expression] = STATE(668),
    [sym_field_expression] = STATE(668),
    [sym_compound_literal_expression] = STATE(668),
    [sym_parenthesized_expression] = STATE(668),
    [sym_char_literal] = STATE(668),
    [sym_concatenated_string] = STATE(668),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1576),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1578),
    [sym_false] = ACTIONS(1578),
    [sym_null] = ACTIONS(1578),
    [sym_identifier] = ACTIONS(1578),
    [sym_comment] = ACTIONS(41),
  },
  [415] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [416] = {
    [sym_string_literal] = STATE(682),
    [aux_sym_concatenated_string_repeat1] = STATE(682),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [417] = {
    [sym_declaration] = STATE(684),
    [sym_type_definition] = STATE(684),
    [sym__declaration_specifiers] = STATE(685),
    [sym_compound_statement] = STATE(684),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(684),
    [sym_expression_statement] = STATE(684),
    [sym_if_statement] = STATE(684),
    [sym_switch_statement] = STATE(684),
    [sym_case_statement] = STATE(684),
    [sym_while_statement] = STATE(684),
    [sym_do_statement] = STATE(684),
    [sym_for_statement] = STATE(684),
    [sym_return_statement] = STATE(684),
    [sym_break_statement] = STATE(684),
    [sym_continue_statement] = STATE(684),
    [sym_goto_statement] = STATE(684),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1610),
    [sym_comment] = ACTIONS(41),
  },
  [418] = {
    [sym_compound_statement] = STATE(686),
    [sym_labeled_statement] = STATE(686),
    [sym_expression_statement] = STATE(686),
    [sym_if_statement] = STATE(686),
    [sym_switch_statement] = STATE(686),
    [sym_case_statement] = STATE(686),
    [sym_while_statement] = STATE(686),
    [sym_do_statement] = STATE(686),
    [sym_for_statement] = STATE(686),
    [sym_return_statement] = STATE(686),
    [sym_break_statement] = STATE(686),
    [sym_continue_statement] = STATE(686),
    [sym_goto_statement] = STATE(686),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1572),
    [sym_comment] = ACTIONS(41),
  },
  [419] = {
    [sym_parenthesized_expression] = STATE(687),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [420] = {
    [sym_parenthesized_expression] = STATE(688),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [421] = {
    [sym__expression] = STATE(689),
    [sym_conditional_expression] = STATE(689),
    [sym_assignment_expression] = STATE(689),
    [sym_pointer_expression] = STATE(689),
    [sym_logical_expression] = STATE(689),
    [sym_bitwise_expression] = STATE(689),
    [sym_equality_expression] = STATE(689),
    [sym_relational_expression] = STATE(689),
    [sym_shift_expression] = STATE(689),
    [sym_math_expression] = STATE(689),
    [sym_cast_expression] = STATE(689),
    [sym_sizeof_expression] = STATE(689),
    [sym_subscript_expression] = STATE(689),
    [sym_call_expression] = STATE(689),
    [sym_field_expression] = STATE(689),
    [sym_compound_literal_expression] = STATE(689),
    [sym_parenthesized_expression] = STATE(689),
    [sym_char_literal] = STATE(689),
    [sym_concatenated_string] = STATE(689),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1612),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1614),
    [sym_false] = ACTIONS(1614),
    [sym_null] = ACTIONS(1614),
    [sym_identifier] = ACTIONS(1614),
    [sym_comment] = ACTIONS(41),
  },
  [422] = {
    [anon_sym_COLON] = ACTIONS(1616),
    [sym_comment] = ACTIONS(41),
  },
  [423] = {
    [sym_parenthesized_expression] = STATE(691),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [424] = {
    [sym_compound_statement] = STATE(692),
    [sym_labeled_statement] = STATE(692),
    [sym_expression_statement] = STATE(692),
    [sym_if_statement] = STATE(692),
    [sym_switch_statement] = STATE(692),
    [sym_case_statement] = STATE(692),
    [sym_while_statement] = STATE(692),
    [sym_do_statement] = STATE(692),
    [sym_for_statement] = STATE(692),
    [sym_return_statement] = STATE(692),
    [sym_break_statement] = STATE(692),
    [sym_continue_statement] = STATE(692),
    [sym_goto_statement] = STATE(692),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [425] = {
    [anon_sym_LPAREN] = ACTIONS(1618),
    [sym_comment] = ACTIONS(41),
  },
  [426] = {
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(1620),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(41),
  },
  [427] = {
    [anon_sym_while] = ACTIONS(1622),
    [sym_comment] = ACTIONS(41),
  },
  [428] = {
    [sym_declaration] = STATE(696),
    [sym__declaration_specifiers] = STATE(685),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym__expression] = STATE(698),
    [sym_conditional_expression] = STATE(698),
    [sym_assignment_expression] = STATE(698),
    [sym_pointer_expression] = STATE(698),
    [sym_logical_expression] = STATE(698),
    [sym_bitwise_expression] = STATE(698),
    [sym_equality_expression] = STATE(698),
    [sym_relational_expression] = STATE(698),
    [sym_shift_expression] = STATE(698),
    [sym_math_expression] = STATE(698),
    [sym_cast_expression] = STATE(698),
    [sym_sizeof_expression] = STATE(698),
    [sym_subscript_expression] = STATE(698),
    [sym_call_expression] = STATE(698),
    [sym_field_expression] = STATE(698),
    [sym_compound_literal_expression] = STATE(698),
    [sym_parenthesized_expression] = STATE(698),
    [sym_char_literal] = STATE(698),
    [sym_concatenated_string] = STATE(698),
    [sym_string_literal] = STATE(363),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(1624),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1628),
    [sym_false] = ACTIONS(1628),
    [sym_null] = ACTIONS(1628),
    [sym_identifier] = ACTIONS(1630),
    [sym_comment] = ACTIONS(41),
  },
  [429] = {
    [anon_sym_LPAREN] = ACTIONS(1632),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_RBRACE] = ACTIONS(1632),
    [anon_sym_SEMI] = ACTIONS(1632),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1634),
    [sym_preproc_directive] = ACTIONS(1634),
    [anon_sym_typedef] = ACTIONS(1634),
    [anon_sym_extern] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_static] = ACTIONS(1634),
    [anon_sym_auto] = ACTIONS(1634),
    [anon_sym_register] = ACTIONS(1634),
    [anon_sym_inline] = ACTIONS(1634),
    [anon_sym_const] = ACTIONS(1634),
    [anon_sym_restrict] = ACTIONS(1634),
    [anon_sym_volatile] = ACTIONS(1634),
    [anon_sym__Atomic] = ACTIONS(1634),
    [anon_sym_unsigned] = ACTIONS(1634),
    [anon_sym_long] = ACTIONS(1634),
    [anon_sym_short] = ACTIONS(1634),
    [sym_primitive_type] = ACTIONS(1634),
    [anon_sym_enum] = ACTIONS(1634),
    [anon_sym_struct] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_if] = ACTIONS(1634),
    [anon_sym_else] = ACTIONS(1634),
    [anon_sym_switch] = ACTIONS(1634),
    [anon_sym_case] = ACTIONS(1634),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_while] = ACTIONS(1634),
    [anon_sym_do] = ACTIONS(1634),
    [anon_sym_for] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1634),
    [anon_sym_break] = ACTIONS(1634),
    [anon_sym_continue] = ACTIONS(1634),
    [anon_sym_goto] = ACTIONS(1634),
    [anon_sym_AMP] = ACTIONS(1632),
    [anon_sym_BANG] = ACTIONS(1632),
    [anon_sym_TILDE] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1634),
    [anon_sym_DASH] = ACTIONS(1634),
    [anon_sym_DASH_DASH] = ACTIONS(1632),
    [anon_sym_PLUS_PLUS] = ACTIONS(1632),
    [anon_sym_sizeof] = ACTIONS(1634),
    [sym_number_literal] = ACTIONS(1632),
    [anon_sym_SQUOTE] = ACTIONS(1632),
    [anon_sym_DQUOTE] = ACTIONS(1632),
    [sym_true] = ACTIONS(1634),
    [sym_false] = ACTIONS(1634),
    [sym_null] = ACTIONS(1634),
    [sym_identifier] = ACTIONS(1634),
    [sym_comment] = ACTIONS(41),
  },
  [430] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1636),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [431] = {
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_LBRACE] = ACTIONS(1638),
    [anon_sym_RBRACE] = ACTIONS(1638),
    [anon_sym_SEMI] = ACTIONS(1638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1640),
    [sym_preproc_directive] = ACTIONS(1640),
    [anon_sym_typedef] = ACTIONS(1640),
    [anon_sym_extern] = ACTIONS(1640),
    [anon_sym_STAR] = ACTIONS(1638),
    [anon_sym_static] = ACTIONS(1640),
    [anon_sym_auto] = ACTIONS(1640),
    [anon_sym_register] = ACTIONS(1640),
    [anon_sym_inline] = ACTIONS(1640),
    [anon_sym_const] = ACTIONS(1640),
    [anon_sym_restrict] = ACTIONS(1640),
    [anon_sym_volatile] = ACTIONS(1640),
    [anon_sym__Atomic] = ACTIONS(1640),
    [anon_sym_unsigned] = ACTIONS(1640),
    [anon_sym_long] = ACTIONS(1640),
    [anon_sym_short] = ACTIONS(1640),
    [sym_primitive_type] = ACTIONS(1640),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1640),
    [anon_sym_union] = ACTIONS(1640),
    [anon_sym_if] = ACTIONS(1640),
    [anon_sym_else] = ACTIONS(1640),
    [anon_sym_switch] = ACTIONS(1640),
    [anon_sym_case] = ACTIONS(1640),
    [anon_sym_default] = ACTIONS(1640),
    [anon_sym_while] = ACTIONS(1640),
    [anon_sym_do] = ACTIONS(1640),
    [anon_sym_for] = ACTIONS(1640),
    [anon_sym_return] = ACTIONS(1640),
    [anon_sym_break] = ACTIONS(1640),
    [anon_sym_continue] = ACTIONS(1640),
    [anon_sym_goto] = ACTIONS(1640),
    [anon_sym_AMP] = ACTIONS(1638),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1638),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_DASH_DASH] = ACTIONS(1638),
    [anon_sym_PLUS_PLUS] = ACTIONS(1638),
    [anon_sym_sizeof] = ACTIONS(1640),
    [sym_number_literal] = ACTIONS(1638),
    [anon_sym_SQUOTE] = ACTIONS(1638),
    [anon_sym_DQUOTE] = ACTIONS(1638),
    [sym_true] = ACTIONS(1640),
    [sym_false] = ACTIONS(1640),
    [sym_null] = ACTIONS(1640),
    [sym_identifier] = ACTIONS(1640),
    [sym_comment] = ACTIONS(41),
  },
  [432] = {
    [anon_sym_LPAREN] = ACTIONS(1642),
    [anon_sym_LBRACE] = ACTIONS(1642),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_SEMI] = ACTIONS(1642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1644),
    [sym_preproc_directive] = ACTIONS(1644),
    [anon_sym_typedef] = ACTIONS(1644),
    [anon_sym_extern] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1642),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_auto] = ACTIONS(1644),
    [anon_sym_register] = ACTIONS(1644),
    [anon_sym_inline] = ACTIONS(1644),
    [anon_sym_const] = ACTIONS(1644),
    [anon_sym_restrict] = ACTIONS(1644),
    [anon_sym_volatile] = ACTIONS(1644),
    [anon_sym__Atomic] = ACTIONS(1644),
    [anon_sym_unsigned] = ACTIONS(1644),
    [anon_sym_long] = ACTIONS(1644),
    [anon_sym_short] = ACTIONS(1644),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1644),
    [anon_sym_struct] = ACTIONS(1644),
    [anon_sym_union] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_else] = ACTIONS(1644),
    [anon_sym_switch] = ACTIONS(1644),
    [anon_sym_case] = ACTIONS(1644),
    [anon_sym_default] = ACTIONS(1644),
    [anon_sym_while] = ACTIONS(1644),
    [anon_sym_do] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_return] = ACTIONS(1644),
    [anon_sym_break] = ACTIONS(1644),
    [anon_sym_continue] = ACTIONS(1644),
    [anon_sym_goto] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1642),
    [anon_sym_TILDE] = ACTIONS(1642),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_DASH_DASH] = ACTIONS(1642),
    [anon_sym_PLUS_PLUS] = ACTIONS(1642),
    [anon_sym_sizeof] = ACTIONS(1644),
    [sym_number_literal] = ACTIONS(1642),
    [anon_sym_SQUOTE] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1644),
    [sym_comment] = ACTIONS(41),
  },
  [433] = {
    [anon_sym_SEMI] = ACTIONS(1646),
    [sym_comment] = ACTIONS(41),
  },
  [434] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_SEMI] = ACTIONS(1648),
    [anon_sym_COMMA] = ACTIONS(1648),
    [anon_sym_STAR] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1648),
    [anon_sym_EQ] = ACTIONS(1650),
    [anon_sym_COLON] = ACTIONS(1648),
    [anon_sym_QMARK] = ACTIONS(1648),
    [anon_sym_STAR_EQ] = ACTIONS(1648),
    [anon_sym_SLASH_EQ] = ACTIONS(1648),
    [anon_sym_PERCENT_EQ] = ACTIONS(1648),
    [anon_sym_PLUS_EQ] = ACTIONS(1648),
    [anon_sym_DASH_EQ] = ACTIONS(1648),
    [anon_sym_LT_LT_EQ] = ACTIONS(1648),
    [anon_sym_GT_GT_EQ] = ACTIONS(1648),
    [anon_sym_AMP_EQ] = ACTIONS(1648),
    [anon_sym_CARET_EQ] = ACTIONS(1648),
    [anon_sym_PIPE_EQ] = ACTIONS(1648),
    [anon_sym_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_CARET] = ACTIONS(1650),
    [anon_sym_EQ_EQ] = ACTIONS(1648),
    [anon_sym_BANG_EQ] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(1650),
    [anon_sym_GT] = ACTIONS(1650),
    [anon_sym_LT_EQ] = ACTIONS(1648),
    [anon_sym_GT_EQ] = ACTIONS(1648),
    [anon_sym_LT_LT] = ACTIONS(1650),
    [anon_sym_GT_GT] = ACTIONS(1650),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_SLASH] = ACTIONS(1650),
    [anon_sym_PERCENT] = ACTIONS(1650),
    [anon_sym_DASH_DASH] = ACTIONS(1648),
    [anon_sym_PLUS_PLUS] = ACTIONS(1648),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [435] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_RPAREN] = ACTIONS(1652),
    [anon_sym_SEMI] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1652),
    [anon_sym_EQ] = ACTIONS(1654),
    [anon_sym_COLON] = ACTIONS(1652),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_STAR_EQ] = ACTIONS(1652),
    [anon_sym_SLASH_EQ] = ACTIONS(1652),
    [anon_sym_PERCENT_EQ] = ACTIONS(1652),
    [anon_sym_PLUS_EQ] = ACTIONS(1652),
    [anon_sym_DASH_EQ] = ACTIONS(1652),
    [anon_sym_LT_LT_EQ] = ACTIONS(1652),
    [anon_sym_GT_GT_EQ] = ACTIONS(1652),
    [anon_sym_AMP_EQ] = ACTIONS(1652),
    [anon_sym_CARET_EQ] = ACTIONS(1652),
    [anon_sym_PIPE_EQ] = ACTIONS(1652),
    [anon_sym_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1652),
    [anon_sym_AMP_AMP] = ACTIONS(1652),
    [anon_sym_PIPE] = ACTIONS(1654),
    [anon_sym_CARET] = ACTIONS(1654),
    [anon_sym_EQ_EQ] = ACTIONS(1652),
    [anon_sym_BANG_EQ] = ACTIONS(1652),
    [anon_sym_LT] = ACTIONS(1654),
    [anon_sym_GT] = ACTIONS(1654),
    [anon_sym_LT_EQ] = ACTIONS(1652),
    [anon_sym_GT_EQ] = ACTIONS(1652),
    [anon_sym_LT_LT] = ACTIONS(1654),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_PLUS] = ACTIONS(1654),
    [anon_sym_DASH] = ACTIONS(1654),
    [anon_sym_SLASH] = ACTIONS(1654),
    [anon_sym_PERCENT] = ACTIONS(1654),
    [anon_sym_DASH_DASH] = ACTIONS(1652),
    [anon_sym_PLUS_PLUS] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [436] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_COMMA] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1656),
    [anon_sym_EQ] = ACTIONS(1658),
    [anon_sym_COLON] = ACTIONS(1656),
    [anon_sym_QMARK] = ACTIONS(1656),
    [anon_sym_STAR_EQ] = ACTIONS(1656),
    [anon_sym_SLASH_EQ] = ACTIONS(1656),
    [anon_sym_PERCENT_EQ] = ACTIONS(1656),
    [anon_sym_PLUS_EQ] = ACTIONS(1656),
    [anon_sym_DASH_EQ] = ACTIONS(1656),
    [anon_sym_LT_LT_EQ] = ACTIONS(1656),
    [anon_sym_GT_GT_EQ] = ACTIONS(1656),
    [anon_sym_AMP_EQ] = ACTIONS(1656),
    [anon_sym_CARET_EQ] = ACTIONS(1656),
    [anon_sym_PIPE_EQ] = ACTIONS(1656),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1658),
    [anon_sym_CARET] = ACTIONS(1658),
    [anon_sym_EQ_EQ] = ACTIONS(1656),
    [anon_sym_BANG_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1658),
    [anon_sym_GT] = ACTIONS(1658),
    [anon_sym_LT_EQ] = ACTIONS(1656),
    [anon_sym_GT_EQ] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1658),
    [anon_sym_GT_GT] = ACTIONS(1658),
    [anon_sym_PLUS] = ACTIONS(1658),
    [anon_sym_DASH] = ACTIONS(1658),
    [anon_sym_SLASH] = ACTIONS(1658),
    [anon_sym_PERCENT] = ACTIONS(1658),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [437] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(701),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [438] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(1660),
    [anon_sym_STAR_EQ] = ACTIONS(1660),
    [anon_sym_SLASH_EQ] = ACTIONS(1660),
    [anon_sym_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_PLUS_EQ] = ACTIONS(1660),
    [anon_sym_DASH_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_GT_EQ] = ACTIONS(1660),
    [anon_sym_AMP_EQ] = ACTIONS(1660),
    [anon_sym_CARET_EQ] = ACTIONS(1660),
    [anon_sym_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_CARET] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1660),
    [anon_sym_BANG_EQ] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [439] = {
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [sym_comment] = ACTIONS(41),
  },
  [440] = {
    [sym_compound_statement] = STATE(703),
    [sym_labeled_statement] = STATE(703),
    [sym_expression_statement] = STATE(703),
    [sym_if_statement] = STATE(703),
    [sym_switch_statement] = STATE(703),
    [sym_case_statement] = STATE(703),
    [sym_while_statement] = STATE(703),
    [sym_do_statement] = STATE(703),
    [sym_for_statement] = STATE(703),
    [sym_return_statement] = STATE(703),
    [sym_break_statement] = STATE(703),
    [sym_continue_statement] = STATE(703),
    [sym_goto_statement] = STATE(703),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1572),
    [sym_comment] = ACTIONS(41),
  },
  [441] = {
    [sym_parameter_list] = STATE(129),
    [aux_sym_declaration_repeat1] = STATE(130),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_COMMA] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(255),
    [sym_comment] = ACTIONS(41),
  },
  [442] = {
    [sym__expression] = STATE(705),
    [sym_conditional_expression] = STATE(705),
    [sym_assignment_expression] = STATE(705),
    [sym_pointer_expression] = STATE(705),
    [sym_logical_expression] = STATE(705),
    [sym_bitwise_expression] = STATE(705),
    [sym_equality_expression] = STATE(705),
    [sym_relational_expression] = STATE(705),
    [sym_shift_expression] = STATE(705),
    [sym_math_expression] = STATE(705),
    [sym_cast_expression] = STATE(705),
    [sym_sizeof_expression] = STATE(705),
    [sym_subscript_expression] = STATE(705),
    [sym_call_expression] = STATE(705),
    [sym_field_expression] = STATE(705),
    [sym_compound_literal_expression] = STATE(705),
    [sym_parenthesized_expression] = STATE(705),
    [sym_char_literal] = STATE(705),
    [sym_concatenated_string] = STATE(705),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(1666),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(1668),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1670),
    [sym_false] = ACTIONS(1670),
    [sym_null] = ACTIONS(1670),
    [sym_identifier] = ACTIONS(1670),
    [sym_comment] = ACTIONS(41),
  },
  [443] = {
    [anon_sym_LPAREN] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_RBRACE] = ACTIONS(1672),
    [anon_sym_SEMI] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1674),
    [sym_preproc_directive] = ACTIONS(1674),
    [anon_sym_typedef] = ACTIONS(1674),
    [anon_sym_extern] = ACTIONS(1674),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1674),
    [anon_sym_auto] = ACTIONS(1674),
    [anon_sym_register] = ACTIONS(1674),
    [anon_sym_inline] = ACTIONS(1674),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_restrict] = ACTIONS(1674),
    [anon_sym_volatile] = ACTIONS(1674),
    [anon_sym__Atomic] = ACTIONS(1674),
    [anon_sym_unsigned] = ACTIONS(1674),
    [anon_sym_long] = ACTIONS(1674),
    [anon_sym_short] = ACTIONS(1674),
    [sym_primitive_type] = ACTIONS(1674),
    [anon_sym_enum] = ACTIONS(1674),
    [anon_sym_struct] = ACTIONS(1674),
    [anon_sym_union] = ACTIONS(1674),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_else] = ACTIONS(1674),
    [anon_sym_switch] = ACTIONS(1674),
    [anon_sym_case] = ACTIONS(1674),
    [anon_sym_default] = ACTIONS(1674),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1674),
    [anon_sym_for] = ACTIONS(1674),
    [anon_sym_return] = ACTIONS(1674),
    [anon_sym_break] = ACTIONS(1674),
    [anon_sym_continue] = ACTIONS(1674),
    [anon_sym_goto] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DASH_DASH] = ACTIONS(1672),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_sizeof] = ACTIONS(1674),
    [sym_number_literal] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1674),
    [sym_comment] = ACTIONS(41),
  },
  [444] = {
    [sym__expression] = STATE(706),
    [sym_comma_expression] = STATE(707),
    [sym_conditional_expression] = STATE(706),
    [sym_assignment_expression] = STATE(706),
    [sym_pointer_expression] = STATE(706),
    [sym_logical_expression] = STATE(706),
    [sym_bitwise_expression] = STATE(706),
    [sym_equality_expression] = STATE(706),
    [sym_relational_expression] = STATE(706),
    [sym_shift_expression] = STATE(706),
    [sym_math_expression] = STATE(706),
    [sym_cast_expression] = STATE(706),
    [sym_sizeof_expression] = STATE(706),
    [sym_subscript_expression] = STATE(706),
    [sym_call_expression] = STATE(706),
    [sym_field_expression] = STATE(706),
    [sym_compound_literal_expression] = STATE(706),
    [sym_parenthesized_expression] = STATE(706),
    [sym_char_literal] = STATE(706),
    [sym_concatenated_string] = STATE(706),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1676),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_null] = ACTIONS(1678),
    [sym_identifier] = ACTIONS(1678),
    [sym_comment] = ACTIONS(41),
  },
  [445] = {
    [sym__expression] = STATE(708),
    [sym_conditional_expression] = STATE(708),
    [sym_assignment_expression] = STATE(708),
    [sym_pointer_expression] = STATE(708),
    [sym_logical_expression] = STATE(708),
    [sym_bitwise_expression] = STATE(708),
    [sym_equality_expression] = STATE(708),
    [sym_relational_expression] = STATE(708),
    [sym_shift_expression] = STATE(708),
    [sym_math_expression] = STATE(708),
    [sym_cast_expression] = STATE(708),
    [sym_sizeof_expression] = STATE(708),
    [sym_subscript_expression] = STATE(708),
    [sym_call_expression] = STATE(708),
    [sym_field_expression] = STATE(708),
    [sym_compound_literal_expression] = STATE(708),
    [sym_parenthesized_expression] = STATE(708),
    [sym_char_literal] = STATE(708),
    [sym_concatenated_string] = STATE(708),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(41),
  },
  [446] = {
    [sym__expression] = STATE(709),
    [sym_conditional_expression] = STATE(709),
    [sym_assignment_expression] = STATE(709),
    [sym_pointer_expression] = STATE(709),
    [sym_logical_expression] = STATE(709),
    [sym_bitwise_expression] = STATE(709),
    [sym_equality_expression] = STATE(709),
    [sym_relational_expression] = STATE(709),
    [sym_shift_expression] = STATE(709),
    [sym_math_expression] = STATE(709),
    [sym_cast_expression] = STATE(709),
    [sym_sizeof_expression] = STATE(709),
    [sym_subscript_expression] = STATE(709),
    [sym_call_expression] = STATE(709),
    [sym_field_expression] = STATE(709),
    [sym_compound_literal_expression] = STATE(709),
    [sym_parenthesized_expression] = STATE(709),
    [sym_char_literal] = STATE(709),
    [sym_concatenated_string] = STATE(709),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1684),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1686),
    [sym_false] = ACTIONS(1686),
    [sym_null] = ACTIONS(1686),
    [sym_identifier] = ACTIONS(1686),
    [sym_comment] = ACTIONS(41),
  },
  [447] = {
    [sym__expression] = STATE(710),
    [sym_conditional_expression] = STATE(710),
    [sym_assignment_expression] = STATE(710),
    [sym_pointer_expression] = STATE(710),
    [sym_logical_expression] = STATE(710),
    [sym_bitwise_expression] = STATE(710),
    [sym_equality_expression] = STATE(710),
    [sym_relational_expression] = STATE(710),
    [sym_shift_expression] = STATE(710),
    [sym_math_expression] = STATE(710),
    [sym_cast_expression] = STATE(710),
    [sym_sizeof_expression] = STATE(710),
    [sym_subscript_expression] = STATE(710),
    [sym_call_expression] = STATE(710),
    [sym_field_expression] = STATE(710),
    [sym_compound_literal_expression] = STATE(710),
    [sym_parenthesized_expression] = STATE(710),
    [sym_char_literal] = STATE(710),
    [sym_concatenated_string] = STATE(710),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1688),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_null] = ACTIONS(1690),
    [sym_identifier] = ACTIONS(1690),
    [sym_comment] = ACTIONS(41),
  },
  [448] = {
    [sym__expression] = STATE(711),
    [sym_conditional_expression] = STATE(711),
    [sym_assignment_expression] = STATE(711),
    [sym_pointer_expression] = STATE(711),
    [sym_logical_expression] = STATE(711),
    [sym_bitwise_expression] = STATE(711),
    [sym_equality_expression] = STATE(711),
    [sym_relational_expression] = STATE(711),
    [sym_shift_expression] = STATE(711),
    [sym_math_expression] = STATE(711),
    [sym_cast_expression] = STATE(711),
    [sym_sizeof_expression] = STATE(711),
    [sym_subscript_expression] = STATE(711),
    [sym_call_expression] = STATE(711),
    [sym_field_expression] = STATE(711),
    [sym_compound_literal_expression] = STATE(711),
    [sym_parenthesized_expression] = STATE(711),
    [sym_char_literal] = STATE(711),
    [sym_concatenated_string] = STATE(711),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1692),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1694),
    [sym_false] = ACTIONS(1694),
    [sym_null] = ACTIONS(1694),
    [sym_identifier] = ACTIONS(1694),
    [sym_comment] = ACTIONS(41),
  },
  [449] = {
    [sym__expression] = STATE(712),
    [sym_conditional_expression] = STATE(712),
    [sym_assignment_expression] = STATE(712),
    [sym_pointer_expression] = STATE(712),
    [sym_logical_expression] = STATE(712),
    [sym_bitwise_expression] = STATE(712),
    [sym_equality_expression] = STATE(712),
    [sym_relational_expression] = STATE(712),
    [sym_shift_expression] = STATE(712),
    [sym_math_expression] = STATE(712),
    [sym_cast_expression] = STATE(712),
    [sym_sizeof_expression] = STATE(712),
    [sym_subscript_expression] = STATE(712),
    [sym_call_expression] = STATE(712),
    [sym_field_expression] = STATE(712),
    [sym_compound_literal_expression] = STATE(712),
    [sym_parenthesized_expression] = STATE(712),
    [sym_char_literal] = STATE(712),
    [sym_concatenated_string] = STATE(712),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1696),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_null] = ACTIONS(1698),
    [sym_identifier] = ACTIONS(1698),
    [sym_comment] = ACTIONS(41),
  },
  [450] = {
    [sym__expression] = STATE(713),
    [sym_conditional_expression] = STATE(713),
    [sym_assignment_expression] = STATE(713),
    [sym_pointer_expression] = STATE(713),
    [sym_logical_expression] = STATE(713),
    [sym_bitwise_expression] = STATE(713),
    [sym_equality_expression] = STATE(713),
    [sym_relational_expression] = STATE(713),
    [sym_shift_expression] = STATE(713),
    [sym_math_expression] = STATE(713),
    [sym_cast_expression] = STATE(713),
    [sym_sizeof_expression] = STATE(713),
    [sym_subscript_expression] = STATE(713),
    [sym_call_expression] = STATE(713),
    [sym_field_expression] = STATE(713),
    [sym_compound_literal_expression] = STATE(713),
    [sym_parenthesized_expression] = STATE(713),
    [sym_char_literal] = STATE(713),
    [sym_concatenated_string] = STATE(713),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1700),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1702),
    [sym_false] = ACTIONS(1702),
    [sym_null] = ACTIONS(1702),
    [sym_identifier] = ACTIONS(1702),
    [sym_comment] = ACTIONS(41),
  },
  [451] = {
    [sym__expression] = STATE(714),
    [sym_conditional_expression] = STATE(714),
    [sym_assignment_expression] = STATE(714),
    [sym_pointer_expression] = STATE(714),
    [sym_logical_expression] = STATE(714),
    [sym_bitwise_expression] = STATE(714),
    [sym_equality_expression] = STATE(714),
    [sym_relational_expression] = STATE(714),
    [sym_shift_expression] = STATE(714),
    [sym_math_expression] = STATE(714),
    [sym_cast_expression] = STATE(714),
    [sym_sizeof_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_call_expression] = STATE(714),
    [sym_field_expression] = STATE(714),
    [sym_compound_literal_expression] = STATE(714),
    [sym_parenthesized_expression] = STATE(714),
    [sym_char_literal] = STATE(714),
    [sym_concatenated_string] = STATE(714),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1704),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1706),
    [sym_false] = ACTIONS(1706),
    [sym_null] = ACTIONS(1706),
    [sym_identifier] = ACTIONS(1706),
    [sym_comment] = ACTIONS(41),
  },
  [452] = {
    [sym__expression] = STATE(715),
    [sym_conditional_expression] = STATE(715),
    [sym_assignment_expression] = STATE(715),
    [sym_pointer_expression] = STATE(715),
    [sym_logical_expression] = STATE(715),
    [sym_bitwise_expression] = STATE(715),
    [sym_equality_expression] = STATE(715),
    [sym_relational_expression] = STATE(715),
    [sym_shift_expression] = STATE(715),
    [sym_math_expression] = STATE(715),
    [sym_cast_expression] = STATE(715),
    [sym_sizeof_expression] = STATE(715),
    [sym_subscript_expression] = STATE(715),
    [sym_call_expression] = STATE(715),
    [sym_field_expression] = STATE(715),
    [sym_compound_literal_expression] = STATE(715),
    [sym_parenthesized_expression] = STATE(715),
    [sym_char_literal] = STATE(715),
    [sym_concatenated_string] = STATE(715),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1708),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1710),
    [sym_false] = ACTIONS(1710),
    [sym_null] = ACTIONS(1710),
    [sym_identifier] = ACTIONS(1710),
    [sym_comment] = ACTIONS(41),
  },
  [453] = {
    [sym__expression] = STATE(716),
    [sym_conditional_expression] = STATE(716),
    [sym_assignment_expression] = STATE(716),
    [sym_pointer_expression] = STATE(716),
    [sym_logical_expression] = STATE(716),
    [sym_bitwise_expression] = STATE(716),
    [sym_equality_expression] = STATE(716),
    [sym_relational_expression] = STATE(716),
    [sym_shift_expression] = STATE(716),
    [sym_math_expression] = STATE(716),
    [sym_cast_expression] = STATE(716),
    [sym_sizeof_expression] = STATE(716),
    [sym_subscript_expression] = STATE(716),
    [sym_call_expression] = STATE(716),
    [sym_field_expression] = STATE(716),
    [sym_compound_literal_expression] = STATE(716),
    [sym_parenthesized_expression] = STATE(716),
    [sym_char_literal] = STATE(716),
    [sym_concatenated_string] = STATE(716),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1712),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1714),
    [sym_false] = ACTIONS(1714),
    [sym_null] = ACTIONS(1714),
    [sym_identifier] = ACTIONS(1714),
    [sym_comment] = ACTIONS(41),
  },
  [454] = {
    [sym__expression] = STATE(717),
    [sym_conditional_expression] = STATE(717),
    [sym_assignment_expression] = STATE(717),
    [sym_pointer_expression] = STATE(717),
    [sym_logical_expression] = STATE(717),
    [sym_bitwise_expression] = STATE(717),
    [sym_equality_expression] = STATE(717),
    [sym_relational_expression] = STATE(717),
    [sym_shift_expression] = STATE(717),
    [sym_math_expression] = STATE(717),
    [sym_cast_expression] = STATE(717),
    [sym_sizeof_expression] = STATE(717),
    [sym_subscript_expression] = STATE(717),
    [sym_call_expression] = STATE(717),
    [sym_field_expression] = STATE(717),
    [sym_compound_literal_expression] = STATE(717),
    [sym_parenthesized_expression] = STATE(717),
    [sym_char_literal] = STATE(717),
    [sym_concatenated_string] = STATE(717),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1716),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1718),
    [sym_false] = ACTIONS(1718),
    [sym_null] = ACTIONS(1718),
    [sym_identifier] = ACTIONS(1718),
    [sym_comment] = ACTIONS(41),
  },
  [455] = {
    [sym__expression] = STATE(718),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_char_literal] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1720),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1722),
    [sym_false] = ACTIONS(1722),
    [sym_null] = ACTIONS(1722),
    [sym_identifier] = ACTIONS(1722),
    [sym_comment] = ACTIONS(41),
  },
  [456] = {
    [sym__expression] = STATE(719),
    [sym_conditional_expression] = STATE(719),
    [sym_assignment_expression] = STATE(719),
    [sym_pointer_expression] = STATE(719),
    [sym_logical_expression] = STATE(719),
    [sym_bitwise_expression] = STATE(719),
    [sym_equality_expression] = STATE(719),
    [sym_relational_expression] = STATE(719),
    [sym_shift_expression] = STATE(719),
    [sym_math_expression] = STATE(719),
    [sym_cast_expression] = STATE(719),
    [sym_sizeof_expression] = STATE(719),
    [sym_subscript_expression] = STATE(719),
    [sym_call_expression] = STATE(719),
    [sym_field_expression] = STATE(719),
    [sym_compound_literal_expression] = STATE(719),
    [sym_parenthesized_expression] = STATE(719),
    [sym_char_literal] = STATE(719),
    [sym_concatenated_string] = STATE(719),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1724),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1726),
    [sym_false] = ACTIONS(1726),
    [sym_null] = ACTIONS(1726),
    [sym_identifier] = ACTIONS(1726),
    [sym_comment] = ACTIONS(41),
  },
  [457] = {
    [sym__expression] = STATE(720),
    [sym_conditional_expression] = STATE(720),
    [sym_assignment_expression] = STATE(720),
    [sym_pointer_expression] = STATE(720),
    [sym_logical_expression] = STATE(720),
    [sym_bitwise_expression] = STATE(720),
    [sym_equality_expression] = STATE(720),
    [sym_relational_expression] = STATE(720),
    [sym_shift_expression] = STATE(720),
    [sym_math_expression] = STATE(720),
    [sym_cast_expression] = STATE(720),
    [sym_sizeof_expression] = STATE(720),
    [sym_subscript_expression] = STATE(720),
    [sym_call_expression] = STATE(720),
    [sym_field_expression] = STATE(720),
    [sym_compound_literal_expression] = STATE(720),
    [sym_parenthesized_expression] = STATE(720),
    [sym_char_literal] = STATE(720),
    [sym_concatenated_string] = STATE(720),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1728),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_null] = ACTIONS(1730),
    [sym_identifier] = ACTIONS(1730),
    [sym_comment] = ACTIONS(41),
  },
  [458] = {
    [anon_sym_LPAREN] = ACTIONS(1656),
    [anon_sym_RBRACE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_COMMA] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_LBRACK] = ACTIONS(1656),
    [anon_sym_RBRACK] = ACTIONS(1656),
    [anon_sym_EQ] = ACTIONS(1658),
    [anon_sym_COLON] = ACTIONS(1656),
    [anon_sym_QMARK] = ACTIONS(1656),
    [anon_sym_STAR_EQ] = ACTIONS(1656),
    [anon_sym_SLASH_EQ] = ACTIONS(1656),
    [anon_sym_PERCENT_EQ] = ACTIONS(1656),
    [anon_sym_PLUS_EQ] = ACTIONS(1656),
    [anon_sym_DASH_EQ] = ACTIONS(1656),
    [anon_sym_LT_LT_EQ] = ACTIONS(1656),
    [anon_sym_GT_GT_EQ] = ACTIONS(1656),
    [anon_sym_AMP_EQ] = ACTIONS(1656),
    [anon_sym_CARET_EQ] = ACTIONS(1656),
    [anon_sym_PIPE_EQ] = ACTIONS(1656),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1658),
    [anon_sym_CARET] = ACTIONS(1658),
    [anon_sym_EQ_EQ] = ACTIONS(1656),
    [anon_sym_BANG_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1658),
    [anon_sym_GT] = ACTIONS(1658),
    [anon_sym_LT_EQ] = ACTIONS(1656),
    [anon_sym_GT_EQ] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1658),
    [anon_sym_GT_GT] = ACTIONS(1658),
    [anon_sym_PLUS] = ACTIONS(1658),
    [anon_sym_DASH] = ACTIONS(1658),
    [anon_sym_SLASH] = ACTIONS(1658),
    [anon_sym_PERCENT] = ACTIONS(1658),
    [anon_sym_DASH_DASH] = ACTIONS(1656),
    [anon_sym_PLUS_PLUS] = ACTIONS(1656),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_DASH_GT] = ACTIONS(1656),
    [sym_comment] = ACTIONS(41),
  },
  [459] = {
    [sym_identifier] = ACTIONS(1732),
    [sym_comment] = ACTIONS(41),
  },
  [460] = {
    [anon_sym_LPAREN] = ACTIONS(1734),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_COMMA] = ACTIONS(1734),
    [anon_sym_STAR] = ACTIONS(1736),
    [anon_sym_LBRACK] = ACTIONS(1734),
    [anon_sym_RBRACK] = ACTIONS(1734),
    [anon_sym_EQ] = ACTIONS(1736),
    [anon_sym_COLON] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(1734),
    [anon_sym_STAR_EQ] = ACTIONS(1734),
    [anon_sym_SLASH_EQ] = ACTIONS(1734),
    [anon_sym_PERCENT_EQ] = ACTIONS(1734),
    [anon_sym_PLUS_EQ] = ACTIONS(1734),
    [anon_sym_DASH_EQ] = ACTIONS(1734),
    [anon_sym_LT_LT_EQ] = ACTIONS(1734),
    [anon_sym_GT_GT_EQ] = ACTIONS(1734),
    [anon_sym_AMP_EQ] = ACTIONS(1734),
    [anon_sym_CARET_EQ] = ACTIONS(1734),
    [anon_sym_PIPE_EQ] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1736),
    [anon_sym_PIPE_PIPE] = ACTIONS(1734),
    [anon_sym_AMP_AMP] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1736),
    [anon_sym_CARET] = ACTIONS(1736),
    [anon_sym_EQ_EQ] = ACTIONS(1734),
    [anon_sym_BANG_EQ] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1736),
    [anon_sym_GT] = ACTIONS(1736),
    [anon_sym_LT_EQ] = ACTIONS(1734),
    [anon_sym_GT_EQ] = ACTIONS(1734),
    [anon_sym_LT_LT] = ACTIONS(1736),
    [anon_sym_GT_GT] = ACTIONS(1736),
    [anon_sym_PLUS] = ACTIONS(1736),
    [anon_sym_DASH] = ACTIONS(1736),
    [anon_sym_SLASH] = ACTIONS(1736),
    [anon_sym_PERCENT] = ACTIONS(1736),
    [anon_sym_DASH_DASH] = ACTIONS(1734),
    [anon_sym_PLUS_PLUS] = ACTIONS(1734),
    [anon_sym_DOT] = ACTIONS(1734),
    [anon_sym_DASH_GT] = ACTIONS(1734),
    [sym_comment] = ACTIONS(41),
  },
  [461] = {
    [sym_string_literal] = STATE(722),
    [aux_sym_concatenated_string_repeat1] = STATE(722),
    [anon_sym_LPAREN] = ACTIONS(1738),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_COMMA] = ACTIONS(1738),
    [anon_sym_STAR] = ACTIONS(1740),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_EQ] = ACTIONS(1740),
    [anon_sym_QMARK] = ACTIONS(1738),
    [anon_sym_STAR_EQ] = ACTIONS(1738),
    [anon_sym_SLASH_EQ] = ACTIONS(1738),
    [anon_sym_PERCENT_EQ] = ACTIONS(1738),
    [anon_sym_PLUS_EQ] = ACTIONS(1738),
    [anon_sym_DASH_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_GT_EQ] = ACTIONS(1738),
    [anon_sym_AMP_EQ] = ACTIONS(1738),
    [anon_sym_CARET_EQ] = ACTIONS(1738),
    [anon_sym_PIPE_EQ] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1740),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE] = ACTIONS(1740),
    [anon_sym_CARET] = ACTIONS(1740),
    [anon_sym_EQ_EQ] = ACTIONS(1738),
    [anon_sym_BANG_EQ] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1740),
    [anon_sym_GT] = ACTIONS(1740),
    [anon_sym_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT] = ACTIONS(1740),
    [anon_sym_GT_GT] = ACTIONS(1740),
    [anon_sym_PLUS] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1740),
    [anon_sym_SLASH] = ACTIONS(1740),
    [anon_sym_PERCENT] = ACTIONS(1740),
    [anon_sym_DASH_DASH] = ACTIONS(1738),
    [anon_sym_PLUS_PLUS] = ACTIONS(1738),
    [anon_sym_DOT] = ACTIONS(1738),
    [anon_sym_DASH_GT] = ACTIONS(1738),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(1742),
    [anon_sym_tensor] = ACTIONS(1744),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(1742),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_indexvars] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1744),
    [sym_preproc_directive] = ACTIONS(1744),
    [anon_sym_typedef] = ACTIONS(1744),
    [anon_sym_extern] = ACTIONS(1744),
    [anon_sym_STAR] = ACTIONS(1742),
    [anon_sym_static] = ACTIONS(1744),
    [anon_sym_auto] = ACTIONS(1744),
    [anon_sym_register] = ACTIONS(1744),
    [anon_sym_inline] = ACTIONS(1744),
    [anon_sym_const] = ACTIONS(1744),
    [anon_sym_restrict] = ACTIONS(1744),
    [anon_sym_volatile] = ACTIONS(1744),
    [anon_sym__Atomic] = ACTIONS(1744),
    [anon_sym_unsigned] = ACTIONS(1744),
    [anon_sym_long] = ACTIONS(1744),
    [anon_sym_short] = ACTIONS(1744),
    [sym_primitive_type] = ACTIONS(1744),
    [anon_sym_enum] = ACTIONS(1744),
    [anon_sym_struct] = ACTIONS(1744),
    [anon_sym_union] = ACTIONS(1744),
    [anon_sym_if] = ACTIONS(1744),
    [anon_sym_else] = ACTIONS(1744),
    [anon_sym_switch] = ACTIONS(1744),
    [anon_sym_case] = ACTIONS(1744),
    [anon_sym_default] = ACTIONS(1744),
    [anon_sym_while] = ACTIONS(1744),
    [anon_sym_do] = ACTIONS(1744),
    [anon_sym_for] = ACTIONS(1744),
    [anon_sym_return] = ACTIONS(1744),
    [anon_sym_break] = ACTIONS(1744),
    [anon_sym_continue] = ACTIONS(1744),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1742),
    [anon_sym_BANG] = ACTIONS(1742),
    [anon_sym_TILDE] = ACTIONS(1742),
    [anon_sym_PLUS] = ACTIONS(1744),
    [anon_sym_DASH] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1742),
    [anon_sym_PLUS_PLUS] = ACTIONS(1742),
    [anon_sym_sizeof] = ACTIONS(1744),
    [sym_number_literal] = ACTIONS(1742),
    [anon_sym_SQUOTE] = ACTIONS(1742),
    [anon_sym_DQUOTE] = ACTIONS(1742),
    [sym_true] = ACTIONS(1744),
    [sym_false] = ACTIONS(1744),
    [sym_null] = ACTIONS(1744),
    [sym_identifier] = ACTIONS(1744),
    [sym_comment] = ACTIONS(41),
  },
  [463] = {
    [sym_preproc_include] = STATE(463),
    [sym_preproc_def] = STATE(463),
    [sym_preproc_function_def] = STATE(463),
    [sym_preproc_call] = STATE(463),
    [sym_preproc_if_in_compound_statement] = STATE(463),
    [sym_preproc_ifdef_in_compound_statement] = STATE(463),
    [sym_declaration] = STATE(463),
    [sym_type_definition] = STATE(463),
    [sym__declaration_specifiers] = STATE(246),
    [sym_compound_statement] = STATE(463),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(463),
    [sym_expression_statement] = STATE(463),
    [sym_if_statement] = STATE(463),
    [sym_switch_statement] = STATE(463),
    [sym_case_statement] = STATE(463),
    [sym_while_statement] = STATE(463),
    [sym_do_statement] = STATE(463),
    [sym_for_statement] = STATE(463),
    [sym_return_statement] = STATE(463),
    [sym_break_statement] = STATE(463),
    [sym_continue_statement] = STATE(463),
    [sym_goto_statement] = STATE(463),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(463),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(463),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(1746),
    [anon_sym_LBRACE] = ACTIONS(1749),
    [anon_sym_RBRACE] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1754),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1757),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1760),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1763),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1766),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1766),
    [sym_preproc_directive] = ACTIONS(1769),
    [anon_sym_typedef] = ACTIONS(1772),
    [anon_sym_extern] = ACTIONS(1775),
    [anon_sym_STAR] = ACTIONS(1778),
    [anon_sym_static] = ACTIONS(1775),
    [anon_sym_auto] = ACTIONS(1775),
    [anon_sym_register] = ACTIONS(1775),
    [anon_sym_inline] = ACTIONS(1775),
    [anon_sym_const] = ACTIONS(1781),
    [anon_sym_restrict] = ACTIONS(1781),
    [anon_sym_volatile] = ACTIONS(1781),
    [anon_sym__Atomic] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1784),
    [anon_sym_long] = ACTIONS(1784),
    [anon_sym_short] = ACTIONS(1784),
    [sym_primitive_type] = ACTIONS(1787),
    [anon_sym_enum] = ACTIONS(1790),
    [anon_sym_struct] = ACTIONS(1793),
    [anon_sym_union] = ACTIONS(1796),
    [anon_sym_if] = ACTIONS(1799),
    [anon_sym_switch] = ACTIONS(1802),
    [anon_sym_case] = ACTIONS(1805),
    [anon_sym_default] = ACTIONS(1808),
    [anon_sym_while] = ACTIONS(1811),
    [anon_sym_do] = ACTIONS(1814),
    [anon_sym_for] = ACTIONS(1817),
    [anon_sym_return] = ACTIONS(1820),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_continue] = ACTIONS(1826),
    [anon_sym_goto] = ACTIONS(1829),
    [anon_sym_AMP] = ACTIONS(1778),
    [anon_sym_BANG] = ACTIONS(1832),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS] = ACTIONS(1838),
    [anon_sym_DASH] = ACTIONS(1838),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1844),
    [sym_number_literal] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1850),
    [anon_sym_DQUOTE] = ACTIONS(1853),
    [sym_true] = ACTIONS(1856),
    [sym_false] = ACTIONS(1856),
    [sym_null] = ACTIONS(1856),
    [sym_identifier] = ACTIONS(1859),
    [sym_comment] = ACTIONS(41),
  },
  [464] = {
    [sym__declarator] = STATE(214),
    [sym_pointer_declarator] = STATE(214),
    [sym_function_declarator] = STATE(214),
    [sym_array_declarator] = STATE(214),
    [sym_type_qualifier] = STATE(215),
    [aux_sym_type_definition_repeat1] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(593),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(525),
    [sym_comment] = ACTIONS(41),
  },
  [465] = {
    [anon_sym_RPAREN] = ACTIONS(1862),
    [sym_comment] = ACTIONS(41),
  },
  [466] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(724),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [467] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [anon_sym_EQ] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(1660),
    [anon_sym_STAR_EQ] = ACTIONS(1660),
    [anon_sym_SLASH_EQ] = ACTIONS(1660),
    [anon_sym_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_PLUS_EQ] = ACTIONS(1660),
    [anon_sym_DASH_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_GT_EQ] = ACTIONS(1660),
    [anon_sym_AMP_EQ] = ACTIONS(1660),
    [anon_sym_CARET_EQ] = ACTIONS(1660),
    [anon_sym_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_CARET] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1660),
    [anon_sym_BANG_EQ] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [468] = {
    [anon_sym_LPAREN] = ACTIONS(1864),
    [anon_sym_LBRACE] = ACTIONS(1864),
    [anon_sym_RPAREN] = ACTIONS(1864),
    [anon_sym_SEMI] = ACTIONS(1864),
    [anon_sym_COMMA] = ACTIONS(1864),
    [anon_sym_LBRACK] = ACTIONS(1864),
    [anon_sym_EQ] = ACTIONS(1864),
    [sym_comment] = ACTIONS(41),
  },
  [469] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1866),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [470] = {
    [sym_storage_class_specifier] = STATE(726),
    [sym_type_qualifier] = STATE(726),
    [aux_sym__declaration_specifiers_repeat1] = STATE(726),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_RBRACK] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(257),
    [anon_sym_BANG] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(257),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_DASH] = ACTIONS(259),
    [anon_sym_DASH_DASH] = ACTIONS(257),
    [anon_sym_PLUS_PLUS] = ACTIONS(257),
    [anon_sym_sizeof] = ACTIONS(259),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(41),
  },
  [471] = {
    [sym__expression] = STATE(708),
    [sym_conditional_expression] = STATE(708),
    [sym_assignment_expression] = STATE(708),
    [sym_pointer_expression] = STATE(708),
    [sym_logical_expression] = STATE(708),
    [sym_bitwise_expression] = STATE(708),
    [sym_equality_expression] = STATE(708),
    [sym_relational_expression] = STATE(708),
    [sym_shift_expression] = STATE(708),
    [sym_math_expression] = STATE(708),
    [sym_cast_expression] = STATE(708),
    [sym_sizeof_expression] = STATE(708),
    [sym_subscript_expression] = STATE(708),
    [sym_call_expression] = STATE(708),
    [sym_field_expression] = STATE(708),
    [sym_compound_literal_expression] = STATE(708),
    [sym_parenthesized_expression] = STATE(708),
    [sym_char_literal] = STATE(708),
    [sym_concatenated_string] = STATE(708),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(41),
  },
  [472] = {
    [sym__expression] = STATE(727),
    [sym_conditional_expression] = STATE(727),
    [sym_assignment_expression] = STATE(727),
    [sym_pointer_expression] = STATE(727),
    [sym_logical_expression] = STATE(727),
    [sym_bitwise_expression] = STATE(727),
    [sym_equality_expression] = STATE(727),
    [sym_relational_expression] = STATE(727),
    [sym_shift_expression] = STATE(727),
    [sym_math_expression] = STATE(727),
    [sym_cast_expression] = STATE(727),
    [sym_sizeof_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_call_expression] = STATE(727),
    [sym_field_expression] = STATE(727),
    [sym_compound_literal_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_char_literal] = STATE(727),
    [sym_concatenated_string] = STATE(727),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1868),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1870),
    [sym_false] = ACTIONS(1870),
    [sym_null] = ACTIONS(1870),
    [sym_identifier] = ACTIONS(1870),
    [sym_comment] = ACTIONS(41),
  },
  [473] = {
    [sym__expression] = STATE(728),
    [sym_conditional_expression] = STATE(728),
    [sym_assignment_expression] = STATE(728),
    [sym_pointer_expression] = STATE(728),
    [sym_logical_expression] = STATE(728),
    [sym_bitwise_expression] = STATE(728),
    [sym_equality_expression] = STATE(728),
    [sym_relational_expression] = STATE(728),
    [sym_shift_expression] = STATE(728),
    [sym_math_expression] = STATE(728),
    [sym_cast_expression] = STATE(728),
    [sym_sizeof_expression] = STATE(728),
    [sym_subscript_expression] = STATE(728),
    [sym_call_expression] = STATE(728),
    [sym_field_expression] = STATE(728),
    [sym_compound_literal_expression] = STATE(728),
    [sym_parenthesized_expression] = STATE(728),
    [sym_char_literal] = STATE(728),
    [sym_concatenated_string] = STATE(728),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1872),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1874),
    [sym_false] = ACTIONS(1874),
    [sym_null] = ACTIONS(1874),
    [sym_identifier] = ACTIONS(1874),
    [sym_comment] = ACTIONS(41),
  },
  [474] = {
    [sym__expression] = STATE(729),
    [sym_conditional_expression] = STATE(729),
    [sym_assignment_expression] = STATE(729),
    [sym_pointer_expression] = STATE(729),
    [sym_logical_expression] = STATE(729),
    [sym_bitwise_expression] = STATE(729),
    [sym_equality_expression] = STATE(729),
    [sym_relational_expression] = STATE(729),
    [sym_shift_expression] = STATE(729),
    [sym_math_expression] = STATE(729),
    [sym_cast_expression] = STATE(729),
    [sym_sizeof_expression] = STATE(729),
    [sym_subscript_expression] = STATE(729),
    [sym_call_expression] = STATE(729),
    [sym_field_expression] = STATE(729),
    [sym_compound_literal_expression] = STATE(729),
    [sym_parenthesized_expression] = STATE(729),
    [sym_char_literal] = STATE(729),
    [sym_concatenated_string] = STATE(729),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1878),
    [sym_false] = ACTIONS(1878),
    [sym_null] = ACTIONS(1878),
    [sym_identifier] = ACTIONS(1878),
    [sym_comment] = ACTIONS(41),
  },
  [475] = {
    [sym__expression] = STATE(730),
    [sym_conditional_expression] = STATE(730),
    [sym_assignment_expression] = STATE(730),
    [sym_pointer_expression] = STATE(730),
    [sym_logical_expression] = STATE(730),
    [sym_bitwise_expression] = STATE(730),
    [sym_equality_expression] = STATE(730),
    [sym_relational_expression] = STATE(730),
    [sym_shift_expression] = STATE(730),
    [sym_math_expression] = STATE(730),
    [sym_cast_expression] = STATE(730),
    [sym_sizeof_expression] = STATE(730),
    [sym_subscript_expression] = STATE(730),
    [sym_call_expression] = STATE(730),
    [sym_field_expression] = STATE(730),
    [sym_compound_literal_expression] = STATE(730),
    [sym_parenthesized_expression] = STATE(730),
    [sym_char_literal] = STATE(730),
    [sym_concatenated_string] = STATE(730),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1880),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1882),
    [sym_false] = ACTIONS(1882),
    [sym_null] = ACTIONS(1882),
    [sym_identifier] = ACTIONS(1882),
    [sym_comment] = ACTIONS(41),
  },
  [476] = {
    [sym__expression] = STATE(731),
    [sym_conditional_expression] = STATE(731),
    [sym_assignment_expression] = STATE(731),
    [sym_pointer_expression] = STATE(731),
    [sym_logical_expression] = STATE(731),
    [sym_bitwise_expression] = STATE(731),
    [sym_equality_expression] = STATE(731),
    [sym_relational_expression] = STATE(731),
    [sym_shift_expression] = STATE(731),
    [sym_math_expression] = STATE(731),
    [sym_cast_expression] = STATE(731),
    [sym_sizeof_expression] = STATE(731),
    [sym_subscript_expression] = STATE(731),
    [sym_call_expression] = STATE(731),
    [sym_field_expression] = STATE(731),
    [sym_compound_literal_expression] = STATE(731),
    [sym_parenthesized_expression] = STATE(731),
    [sym_char_literal] = STATE(731),
    [sym_concatenated_string] = STATE(731),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1884),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1886),
    [sym_false] = ACTIONS(1886),
    [sym_null] = ACTIONS(1886),
    [sym_identifier] = ACTIONS(1886),
    [sym_comment] = ACTIONS(41),
  },
  [477] = {
    [sym__expression] = STATE(732),
    [sym_conditional_expression] = STATE(732),
    [sym_assignment_expression] = STATE(732),
    [sym_pointer_expression] = STATE(732),
    [sym_logical_expression] = STATE(732),
    [sym_bitwise_expression] = STATE(732),
    [sym_equality_expression] = STATE(732),
    [sym_relational_expression] = STATE(732),
    [sym_shift_expression] = STATE(732),
    [sym_math_expression] = STATE(732),
    [sym_cast_expression] = STATE(732),
    [sym_sizeof_expression] = STATE(732),
    [sym_subscript_expression] = STATE(732),
    [sym_call_expression] = STATE(732),
    [sym_field_expression] = STATE(732),
    [sym_compound_literal_expression] = STATE(732),
    [sym_parenthesized_expression] = STATE(732),
    [sym_char_literal] = STATE(732),
    [sym_concatenated_string] = STATE(732),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1888),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1890),
    [sym_false] = ACTIONS(1890),
    [sym_null] = ACTIONS(1890),
    [sym_identifier] = ACTIONS(1890),
    [sym_comment] = ACTIONS(41),
  },
  [478] = {
    [sym__expression] = STATE(733),
    [sym_conditional_expression] = STATE(733),
    [sym_assignment_expression] = STATE(733),
    [sym_pointer_expression] = STATE(733),
    [sym_logical_expression] = STATE(733),
    [sym_bitwise_expression] = STATE(733),
    [sym_equality_expression] = STATE(733),
    [sym_relational_expression] = STATE(733),
    [sym_shift_expression] = STATE(733),
    [sym_math_expression] = STATE(733),
    [sym_cast_expression] = STATE(733),
    [sym_sizeof_expression] = STATE(733),
    [sym_subscript_expression] = STATE(733),
    [sym_call_expression] = STATE(733),
    [sym_field_expression] = STATE(733),
    [sym_compound_literal_expression] = STATE(733),
    [sym_parenthesized_expression] = STATE(733),
    [sym_char_literal] = STATE(733),
    [sym_concatenated_string] = STATE(733),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1892),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1894),
    [sym_false] = ACTIONS(1894),
    [sym_null] = ACTIONS(1894),
    [sym_identifier] = ACTIONS(1894),
    [sym_comment] = ACTIONS(41),
  },
  [479] = {
    [sym__expression] = STATE(734),
    [sym_conditional_expression] = STATE(734),
    [sym_assignment_expression] = STATE(734),
    [sym_pointer_expression] = STATE(734),
    [sym_logical_expression] = STATE(734),
    [sym_bitwise_expression] = STATE(734),
    [sym_equality_expression] = STATE(734),
    [sym_relational_expression] = STATE(734),
    [sym_shift_expression] = STATE(734),
    [sym_math_expression] = STATE(734),
    [sym_cast_expression] = STATE(734),
    [sym_sizeof_expression] = STATE(734),
    [sym_subscript_expression] = STATE(734),
    [sym_call_expression] = STATE(734),
    [sym_field_expression] = STATE(734),
    [sym_compound_literal_expression] = STATE(734),
    [sym_parenthesized_expression] = STATE(734),
    [sym_char_literal] = STATE(734),
    [sym_concatenated_string] = STATE(734),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1896),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1898),
    [sym_false] = ACTIONS(1898),
    [sym_null] = ACTIONS(1898),
    [sym_identifier] = ACTIONS(1898),
    [sym_comment] = ACTIONS(41),
  },
  [480] = {
    [sym__expression] = STATE(735),
    [sym_conditional_expression] = STATE(735),
    [sym_assignment_expression] = STATE(735),
    [sym_pointer_expression] = STATE(735),
    [sym_logical_expression] = STATE(735),
    [sym_bitwise_expression] = STATE(735),
    [sym_equality_expression] = STATE(735),
    [sym_relational_expression] = STATE(735),
    [sym_shift_expression] = STATE(735),
    [sym_math_expression] = STATE(735),
    [sym_cast_expression] = STATE(735),
    [sym_sizeof_expression] = STATE(735),
    [sym_subscript_expression] = STATE(735),
    [sym_call_expression] = STATE(735),
    [sym_field_expression] = STATE(735),
    [sym_compound_literal_expression] = STATE(735),
    [sym_parenthesized_expression] = STATE(735),
    [sym_char_literal] = STATE(735),
    [sym_concatenated_string] = STATE(735),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1900),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1902),
    [sym_false] = ACTIONS(1902),
    [sym_null] = ACTIONS(1902),
    [sym_identifier] = ACTIONS(1902),
    [sym_comment] = ACTIONS(41),
  },
  [481] = {
    [sym__expression] = STATE(736),
    [sym_conditional_expression] = STATE(736),
    [sym_assignment_expression] = STATE(736),
    [sym_pointer_expression] = STATE(736),
    [sym_logical_expression] = STATE(736),
    [sym_bitwise_expression] = STATE(736),
    [sym_equality_expression] = STATE(736),
    [sym_relational_expression] = STATE(736),
    [sym_shift_expression] = STATE(736),
    [sym_math_expression] = STATE(736),
    [sym_cast_expression] = STATE(736),
    [sym_sizeof_expression] = STATE(736),
    [sym_subscript_expression] = STATE(736),
    [sym_call_expression] = STATE(736),
    [sym_field_expression] = STATE(736),
    [sym_compound_literal_expression] = STATE(736),
    [sym_parenthesized_expression] = STATE(736),
    [sym_char_literal] = STATE(736),
    [sym_concatenated_string] = STATE(736),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_identifier] = ACTIONS(1906),
    [sym_comment] = ACTIONS(41),
  },
  [482] = {
    [sym__expression] = STATE(737),
    [sym_conditional_expression] = STATE(737),
    [sym_assignment_expression] = STATE(737),
    [sym_pointer_expression] = STATE(737),
    [sym_logical_expression] = STATE(737),
    [sym_bitwise_expression] = STATE(737),
    [sym_equality_expression] = STATE(737),
    [sym_relational_expression] = STATE(737),
    [sym_shift_expression] = STATE(737),
    [sym_math_expression] = STATE(737),
    [sym_cast_expression] = STATE(737),
    [sym_sizeof_expression] = STATE(737),
    [sym_subscript_expression] = STATE(737),
    [sym_call_expression] = STATE(737),
    [sym_field_expression] = STATE(737),
    [sym_compound_literal_expression] = STATE(737),
    [sym_parenthesized_expression] = STATE(737),
    [sym_char_literal] = STATE(737),
    [sym_concatenated_string] = STATE(737),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1908),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [sym_null] = ACTIONS(1910),
    [sym_identifier] = ACTIONS(1910),
    [sym_comment] = ACTIONS(41),
  },
  [483] = {
    [sym_string_literal] = STATE(738),
    [aux_sym_concatenated_string_repeat1] = STATE(738),
    [anon_sym_LPAREN] = ACTIONS(1738),
    [anon_sym_STAR] = ACTIONS(1740),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_RBRACK] = ACTIONS(1738),
    [anon_sym_EQ] = ACTIONS(1740),
    [anon_sym_QMARK] = ACTIONS(1738),
    [anon_sym_STAR_EQ] = ACTIONS(1738),
    [anon_sym_SLASH_EQ] = ACTIONS(1738),
    [anon_sym_PERCENT_EQ] = ACTIONS(1738),
    [anon_sym_PLUS_EQ] = ACTIONS(1738),
    [anon_sym_DASH_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_GT_EQ] = ACTIONS(1738),
    [anon_sym_AMP_EQ] = ACTIONS(1738),
    [anon_sym_CARET_EQ] = ACTIONS(1738),
    [anon_sym_PIPE_EQ] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1740),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE] = ACTIONS(1740),
    [anon_sym_CARET] = ACTIONS(1740),
    [anon_sym_EQ_EQ] = ACTIONS(1738),
    [anon_sym_BANG_EQ] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1740),
    [anon_sym_GT] = ACTIONS(1740),
    [anon_sym_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT] = ACTIONS(1740),
    [anon_sym_GT_GT] = ACTIONS(1740),
    [anon_sym_PLUS] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1740),
    [anon_sym_SLASH] = ACTIONS(1740),
    [anon_sym_PERCENT] = ACTIONS(1740),
    [anon_sym_DASH_DASH] = ACTIONS(1738),
    [anon_sym_PLUS_PLUS] = ACTIONS(1738),
    [anon_sym_DOT] = ACTIONS(1738),
    [anon_sym_DASH_GT] = ACTIONS(1738),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [484] = {
    [sym_storage_class_specifier] = STATE(739),
    [sym_type_qualifier] = STATE(739),
    [aux_sym__declaration_specifiers_repeat1] = STATE(739),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(257),
    [anon_sym_RBRACK] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(257),
    [anon_sym_BANG] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(257),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_DASH] = ACTIONS(259),
    [anon_sym_DASH_DASH] = ACTIONS(257),
    [anon_sym_PLUS_PLUS] = ACTIONS(257),
    [anon_sym_sizeof] = ACTIONS(259),
    [sym_number_literal] = ACTIONS(257),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_null] = ACTIONS(259),
    [sym_identifier] = ACTIONS(259),
    [sym_comment] = ACTIONS(41),
  },
  [485] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(485),
    [anon_sym_LPAREN] = ACTIONS(330),
    [anon_sym_extern] = ACTIONS(332),
    [anon_sym_STAR] = ACTIONS(330),
    [anon_sym_RBRACK] = ACTIONS(330),
    [anon_sym_static] = ACTIONS(332),
    [anon_sym_auto] = ACTIONS(332),
    [anon_sym_register] = ACTIONS(332),
    [anon_sym_inline] = ACTIONS(332),
    [anon_sym_const] = ACTIONS(332),
    [anon_sym_restrict] = ACTIONS(332),
    [anon_sym_volatile] = ACTIONS(332),
    [anon_sym__Atomic] = ACTIONS(332),
    [anon_sym_unsigned] = ACTIONS(1912),
    [anon_sym_long] = ACTIONS(1912),
    [anon_sym_short] = ACTIONS(1912),
    [sym_primitive_type] = ACTIONS(332),
    [anon_sym_AMP] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(330),
    [anon_sym_TILDE] = ACTIONS(330),
    [anon_sym_PLUS] = ACTIONS(332),
    [anon_sym_DASH] = ACTIONS(332),
    [anon_sym_DASH_DASH] = ACTIONS(330),
    [anon_sym_PLUS_PLUS] = ACTIONS(330),
    [anon_sym_sizeof] = ACTIONS(332),
    [sym_number_literal] = ACTIONS(330),
    [anon_sym_SQUOTE] = ACTIONS(330),
    [anon_sym_DQUOTE] = ACTIONS(330),
    [sym_true] = ACTIONS(332),
    [sym_false] = ACTIONS(332),
    [sym_null] = ACTIONS(332),
    [sym_identifier] = ACTIONS(332),
    [sym_comment] = ACTIONS(41),
  },
  [486] = {
    [anon_sym_LPAREN] = ACTIONS(1915),
    [anon_sym_RBRACE] = ACTIONS(1915),
    [anon_sym_RPAREN] = ACTIONS(1915),
    [anon_sym_SEMI] = ACTIONS(1915),
    [anon_sym_COMMA] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(1915),
    [anon_sym_RBRACK] = ACTIONS(1915),
    [anon_sym_EQ] = ACTIONS(1917),
    [anon_sym_COLON] = ACTIONS(1915),
    [anon_sym_QMARK] = ACTIONS(1915),
    [anon_sym_STAR_EQ] = ACTIONS(1915),
    [anon_sym_SLASH_EQ] = ACTIONS(1915),
    [anon_sym_PERCENT_EQ] = ACTIONS(1915),
    [anon_sym_PLUS_EQ] = ACTIONS(1915),
    [anon_sym_DASH_EQ] = ACTIONS(1915),
    [anon_sym_LT_LT_EQ] = ACTIONS(1915),
    [anon_sym_GT_GT_EQ] = ACTIONS(1915),
    [anon_sym_AMP_EQ] = ACTIONS(1915),
    [anon_sym_CARET_EQ] = ACTIONS(1915),
    [anon_sym_PIPE_EQ] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_PIPE_PIPE] = ACTIONS(1915),
    [anon_sym_AMP_AMP] = ACTIONS(1915),
    [anon_sym_PIPE] = ACTIONS(1917),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_EQ_EQ] = ACTIONS(1915),
    [anon_sym_BANG_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1917),
    [anon_sym_GT_GT] = ACTIONS(1917),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1917),
    [anon_sym_PERCENT] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1915),
    [anon_sym_PLUS_PLUS] = ACTIONS(1915),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DASH_GT] = ACTIONS(1915),
    [sym_comment] = ACTIONS(41),
  },
  [487] = {
    [anon_sym_RBRACE] = ACTIONS(1919),
    [sym_comment] = ACTIONS(41),
  },
  [488] = {
    [sym__expression] = STATE(741),
    [sym_conditional_expression] = STATE(741),
    [sym_assignment_expression] = STATE(741),
    [sym_pointer_expression] = STATE(741),
    [sym_logical_expression] = STATE(741),
    [sym_bitwise_expression] = STATE(741),
    [sym_equality_expression] = STATE(741),
    [sym_relational_expression] = STATE(741),
    [sym_shift_expression] = STATE(741),
    [sym_math_expression] = STATE(741),
    [sym_cast_expression] = STATE(741),
    [sym_sizeof_expression] = STATE(741),
    [sym_subscript_expression] = STATE(741),
    [sym_call_expression] = STATE(741),
    [sym_field_expression] = STATE(741),
    [sym_compound_literal_expression] = STATE(741),
    [sym_parenthesized_expression] = STATE(741),
    [sym_char_literal] = STATE(741),
    [sym_concatenated_string] = STATE(741),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(1921),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1923),
    [sym_false] = ACTIONS(1923),
    [sym_null] = ACTIONS(1923),
    [sym_identifier] = ACTIONS(1923),
    [sym_comment] = ACTIONS(41),
  },
  [489] = {
    [sym_identifier] = ACTIONS(1925),
    [sym_comment] = ACTIONS(41),
  },
  [490] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_initializer_list_repeat1] = STATE(744),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1919),
    [anon_sym_COMMA] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_EQ] = ACTIONS(1326),
    [anon_sym_SLASH_EQ] = ACTIONS(1326),
    [anon_sym_PERCENT_EQ] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1326),
    [anon_sym_DASH_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_GT_EQ] = ACTIONS(1326),
    [anon_sym_AMP_EQ] = ACTIONS(1326),
    [anon_sym_CARET_EQ] = ACTIONS(1326),
    [anon_sym_PIPE_EQ] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(1330),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [491] = {
    [aux_sym_initializer_list_repeat1] = STATE(744),
    [anon_sym_RBRACE] = ACTIONS(1919),
    [anon_sym_COMMA] = ACTIONS(1927),
    [sym_comment] = ACTIONS(41),
  },
  [492] = {
    [sym_subscript_designator] = STATE(746),
    [sym_field_designator] = STATE(746),
    [aux_sym_initializer_pair_repeat1] = STATE(746),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_EQ] = ACTIONS(1929),
    [anon_sym_DOT] = ACTIONS(1174),
    [sym_comment] = ACTIONS(41),
  },
  [493] = {
    [anon_sym_RBRACE] = ACTIONS(1931),
    [anon_sym_COMMA] = ACTIONS(1931),
    [sym_comment] = ACTIONS(41),
  },
  [494] = {
    [anon_sym_RBRACE] = ACTIONS(1933),
    [sym_comment] = ACTIONS(41),
  },
  [495] = {
    [anon_sym_RBRACE] = ACTIONS(1935),
    [anon_sym_COMMA] = ACTIONS(1937),
    [sym_comment] = ACTIONS(41),
  },
  [496] = {
    [anon_sym_RPAREN] = ACTIONS(1939),
    [anon_sym_COMMA] = ACTIONS(1939),
    [sym_comment] = ACTIONS(41),
  },
  [497] = {
    [anon_sym_LF] = ACTIONS(1941),
    [sym_preproc_arg] = ACTIONS(1941),
    [sym_comment] = ACTIONS(55),
  },
  [498] = {
    [aux_sym_preproc_params_repeat1] = STATE(498),
    [anon_sym_RPAREN] = ACTIONS(1939),
    [anon_sym_COMMA] = ACTIONS(1943),
    [sym_comment] = ACTIONS(41),
  },
  [499] = {
    [anon_sym_LBRACE] = ACTIONS(1946),
    [sym_comment] = ACTIONS(41),
  },
  [500] = {
    [anon_sym_tensor] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_indexvars] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(649),
    [sym_preproc_directive] = ACTIONS(649),
    [anon_sym_typedef] = ACTIONS(649),
    [anon_sym_extern] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_static] = ACTIONS(649),
    [anon_sym_auto] = ACTIONS(649),
    [anon_sym_register] = ACTIONS(649),
    [anon_sym_inline] = ACTIONS(649),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_restrict] = ACTIONS(649),
    [anon_sym_volatile] = ACTIONS(649),
    [anon_sym__Atomic] = ACTIONS(649),
    [anon_sym_unsigned] = ACTIONS(649),
    [anon_sym_long] = ACTIONS(649),
    [anon_sym_short] = ACTIONS(649),
    [sym_primitive_type] = ACTIONS(649),
    [anon_sym_enum] = ACTIONS(649),
    [anon_sym_struct] = ACTIONS(649),
    [anon_sym_union] = ACTIONS(649),
    [anon_sym_if] = ACTIONS(649),
    [anon_sym_switch] = ACTIONS(649),
    [anon_sym_case] = ACTIONS(649),
    [anon_sym_default] = ACTIONS(649),
    [anon_sym_while] = ACTIONS(649),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(649),
    [anon_sym_break] = ACTIONS(649),
    [anon_sym_continue] = ACTIONS(649),
    [anon_sym_goto] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(649),
    [anon_sym_DASH_DASH] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(647),
    [anon_sym_sizeof] = ACTIONS(649),
    [sym_number_literal] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(647),
    [anon_sym_DQUOTE] = ACTIONS(647),
    [sym_true] = ACTIONS(649),
    [sym_false] = ACTIONS(649),
    [sym_null] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_comment] = ACTIONS(41),
  },
  [501] = {
    [anon_sym_tensor] = ACTIONS(664),
    [anon_sym_LPAREN] = ACTIONS(662),
    [anon_sym_LBRACE] = ACTIONS(662),
    [anon_sym_SEMI] = ACTIONS(662),
    [anon_sym_indexvars] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(664),
    [anon_sym_typedef] = ACTIONS(664),
    [anon_sym_extern] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_auto] = ACTIONS(664),
    [anon_sym_register] = ACTIONS(664),
    [anon_sym_inline] = ACTIONS(664),
    [anon_sym_const] = ACTIONS(664),
    [anon_sym_restrict] = ACTIONS(664),
    [anon_sym_volatile] = ACTIONS(664),
    [anon_sym__Atomic] = ACTIONS(664),
    [anon_sym_unsigned] = ACTIONS(664),
    [anon_sym_long] = ACTIONS(664),
    [anon_sym_short] = ACTIONS(664),
    [sym_primitive_type] = ACTIONS(664),
    [anon_sym_enum] = ACTIONS(664),
    [anon_sym_struct] = ACTIONS(664),
    [anon_sym_union] = ACTIONS(664),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(664),
    [anon_sym_case] = ACTIONS(664),
    [anon_sym_default] = ACTIONS(664),
    [anon_sym_while] = ACTIONS(664),
    [anon_sym_do] = ACTIONS(664),
    [anon_sym_for] = ACTIONS(664),
    [anon_sym_return] = ACTIONS(664),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_TILDE] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_DASH_DASH] = ACTIONS(662),
    [anon_sym_PLUS_PLUS] = ACTIONS(662),
    [anon_sym_sizeof] = ACTIONS(664),
    [sym_number_literal] = ACTIONS(662),
    [anon_sym_SQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(662),
    [sym_true] = ACTIONS(664),
    [sym_false] = ACTIONS(664),
    [sym_null] = ACTIONS(664),
    [sym_identifier] = ACTIONS(664),
    [sym_comment] = ACTIONS(41),
  },
  [502] = {
    [anon_sym_tensor] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_indexvars] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(668),
    [sym_preproc_directive] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_auto] = ACTIONS(668),
    [anon_sym_register] = ACTIONS(668),
    [anon_sym_inline] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_restrict] = ACTIONS(668),
    [anon_sym_volatile] = ACTIONS(668),
    [anon_sym__Atomic] = ACTIONS(668),
    [anon_sym_unsigned] = ACTIONS(668),
    [anon_sym_long] = ACTIONS(668),
    [anon_sym_short] = ACTIONS(668),
    [sym_primitive_type] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_union] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_switch] = ACTIONS(668),
    [anon_sym_case] = ACTIONS(668),
    [anon_sym_default] = ACTIONS(668),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(668),
    [anon_sym_for] = ACTIONS(668),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_break] = ACTIONS(668),
    [anon_sym_continue] = ACTIONS(668),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(666),
    [anon_sym_sizeof] = ACTIONS(668),
    [sym_number_literal] = ACTIONS(666),
    [anon_sym_SQUOTE] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [sym_true] = ACTIONS(668),
    [sym_false] = ACTIONS(668),
    [sym_null] = ACTIONS(668),
    [sym_identifier] = ACTIONS(668),
    [sym_comment] = ACTIONS(41),
  },
  [503] = {
    [anon_sym_LF] = ACTIONS(1948),
    [sym_comment] = ACTIONS(55),
  },
  [504] = {
    [anon_sym_tensor] = ACTIONS(722),
    [anon_sym_indexvars] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(722),
    [sym_preproc_directive] = ACTIONS(722),
    [anon_sym_typedef] = ACTIONS(722),
    [anon_sym_extern] = ACTIONS(722),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_auto] = ACTIONS(722),
    [anon_sym_register] = ACTIONS(722),
    [anon_sym_inline] = ACTIONS(722),
    [anon_sym_const] = ACTIONS(722),
    [anon_sym_restrict] = ACTIONS(722),
    [anon_sym_volatile] = ACTIONS(722),
    [anon_sym__Atomic] = ACTIONS(722),
    [anon_sym_unsigned] = ACTIONS(722),
    [anon_sym_long] = ACTIONS(722),
    [anon_sym_short] = ACTIONS(722),
    [sym_primitive_type] = ACTIONS(722),
    [anon_sym_enum] = ACTIONS(722),
    [anon_sym_struct] = ACTIONS(722),
    [anon_sym_union] = ACTIONS(722),
    [sym_identifier] = ACTIONS(722),
    [sym_comment] = ACTIONS(41),
  },
  [505] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1950),
    [sym_comment] = ACTIONS(41),
  },
  [506] = {
    [anon_sym_tensor] = ACTIONS(761),
    [anon_sym_indexvars] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(761),
    [sym_preproc_directive] = ACTIONS(761),
    [anon_sym_typedef] = ACTIONS(761),
    [anon_sym_extern] = ACTIONS(761),
    [anon_sym_static] = ACTIONS(761),
    [anon_sym_auto] = ACTIONS(761),
    [anon_sym_register] = ACTIONS(761),
    [anon_sym_inline] = ACTIONS(761),
    [anon_sym_const] = ACTIONS(761),
    [anon_sym_restrict] = ACTIONS(761),
    [anon_sym_volatile] = ACTIONS(761),
    [anon_sym__Atomic] = ACTIONS(761),
    [anon_sym_unsigned] = ACTIONS(761),
    [anon_sym_long] = ACTIONS(761),
    [anon_sym_short] = ACTIONS(761),
    [sym_primitive_type] = ACTIONS(761),
    [anon_sym_enum] = ACTIONS(761),
    [anon_sym_struct] = ACTIONS(761),
    [anon_sym_union] = ACTIONS(761),
    [sym_identifier] = ACTIONS(761),
    [sym_comment] = ACTIONS(41),
  },
  [507] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1952),
    [sym_comment] = ACTIONS(41),
  },
  [508] = {
    [anon_sym_LPAREN] = ACTIONS(1954),
    [sym_comment] = ACTIONS(41),
  },
  [509] = {
    [anon_sym_tensor] = ACTIONS(341),
    [anon_sym_indexvars] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(341),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(341),
    [sym_preproc_directive] = ACTIONS(341),
    [anon_sym_typedef] = ACTIONS(341),
    [anon_sym_extern] = ACTIONS(341),
    [anon_sym_static] = ACTIONS(341),
    [anon_sym_auto] = ACTIONS(341),
    [anon_sym_register] = ACTIONS(341),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_const] = ACTIONS(341),
    [anon_sym_restrict] = ACTIONS(341),
    [anon_sym_volatile] = ACTIONS(341),
    [anon_sym__Atomic] = ACTIONS(341),
    [anon_sym_unsigned] = ACTIONS(341),
    [anon_sym_long] = ACTIONS(341),
    [anon_sym_short] = ACTIONS(341),
    [sym_primitive_type] = ACTIONS(341),
    [anon_sym_enum] = ACTIONS(341),
    [anon_sym_struct] = ACTIONS(341),
    [anon_sym_union] = ACTIONS(341),
    [sym_identifier] = ACTIONS(341),
    [sym_comment] = ACTIONS(41),
  },
  [510] = {
    [anon_sym_tensor] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_indexvars] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(345),
    [sym_preproc_directive] = ACTIONS(345),
    [anon_sym_typedef] = ACTIONS(345),
    [anon_sym_extern] = ACTIONS(345),
    [anon_sym_STAR] = ACTIONS(343),
    [anon_sym_static] = ACTIONS(345),
    [anon_sym_auto] = ACTIONS(345),
    [anon_sym_register] = ACTIONS(345),
    [anon_sym_inline] = ACTIONS(345),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_restrict] = ACTIONS(345),
    [anon_sym_volatile] = ACTIONS(345),
    [anon_sym__Atomic] = ACTIONS(345),
    [anon_sym_unsigned] = ACTIONS(345),
    [anon_sym_long] = ACTIONS(345),
    [anon_sym_short] = ACTIONS(345),
    [sym_primitive_type] = ACTIONS(345),
    [anon_sym_enum] = ACTIONS(345),
    [anon_sym_struct] = ACTIONS(345),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_switch] = ACTIONS(345),
    [anon_sym_case] = ACTIONS(345),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_do] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(345),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_continue] = ACTIONS(345),
    [anon_sym_goto] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(343),
    [anon_sym_BANG] = ACTIONS(343),
    [anon_sym_TILDE] = ACTIONS(343),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_DASH_DASH] = ACTIONS(343),
    [anon_sym_PLUS_PLUS] = ACTIONS(343),
    [anon_sym_sizeof] = ACTIONS(345),
    [sym_number_literal] = ACTIONS(343),
    [anon_sym_SQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(343),
    [sym_true] = ACTIONS(345),
    [sym_false] = ACTIONS(345),
    [sym_null] = ACTIONS(345),
    [sym_identifier] = ACTIONS(345),
    [sym_comment] = ACTIONS(41),
  },
  [511] = {
    [aux_sym_string_literal_repeat1] = STATE(136),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(349),
    [sym_escape_sequence] = ACTIONS(349),
    [sym_comment] = ACTIONS(55),
  },
  [512] = {
    [anon_sym_tensor] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_SEMI] = ACTIONS(351),
    [anon_sym_indexvars] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(353),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(353),
    [sym_preproc_directive] = ACTIONS(353),
    [anon_sym_typedef] = ACTIONS(353),
    [anon_sym_extern] = ACTIONS(353),
    [anon_sym_STAR] = ACTIONS(351),
    [anon_sym_static] = ACTIONS(353),
    [anon_sym_auto] = ACTIONS(353),
    [anon_sym_register] = ACTIONS(353),
    [anon_sym_inline] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(353),
    [anon_sym_restrict] = ACTIONS(353),
    [anon_sym_volatile] = ACTIONS(353),
    [anon_sym__Atomic] = ACTIONS(353),
    [anon_sym_unsigned] = ACTIONS(353),
    [anon_sym_long] = ACTIONS(353),
    [anon_sym_short] = ACTIONS(353),
    [sym_primitive_type] = ACTIONS(353),
    [anon_sym_enum] = ACTIONS(353),
    [anon_sym_struct] = ACTIONS(353),
    [anon_sym_union] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_switch] = ACTIONS(353),
    [anon_sym_case] = ACTIONS(353),
    [anon_sym_default] = ACTIONS(353),
    [anon_sym_while] = ACTIONS(353),
    [anon_sym_do] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(353),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_continue] = ACTIONS(353),
    [anon_sym_goto] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(353),
    [anon_sym_DASH] = ACTIONS(353),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_sizeof] = ACTIONS(353),
    [sym_number_literal] = ACTIONS(351),
    [anon_sym_SQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(351),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_null] = ACTIONS(353),
    [sym_identifier] = ACTIONS(353),
    [sym_comment] = ACTIONS(41),
  },
  [513] = {
    [anon_sym_LF] = ACTIONS(1958),
    [sym_comment] = ACTIONS(55),
  },
  [514] = {
    [anon_sym_LF] = ACTIONS(1960),
    [sym_preproc_arg] = ACTIONS(1962),
    [sym_comment] = ACTIONS(55),
  },
  [515] = {
    [anon_sym_tensor] = ACTIONS(377),
    [anon_sym_indexvars] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(377),
    [sym_preproc_directive] = ACTIONS(377),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(377),
    [anon_sym_static] = ACTIONS(377),
    [anon_sym_auto] = ACTIONS(377),
    [anon_sym_register] = ACTIONS(377),
    [anon_sym_inline] = ACTIONS(377),
    [anon_sym_const] = ACTIONS(377),
    [anon_sym_restrict] = ACTIONS(377),
    [anon_sym_volatile] = ACTIONS(377),
    [anon_sym__Atomic] = ACTIONS(377),
    [anon_sym_unsigned] = ACTIONS(377),
    [anon_sym_long] = ACTIONS(377),
    [anon_sym_short] = ACTIONS(377),
    [sym_primitive_type] = ACTIONS(377),
    [anon_sym_enum] = ACTIONS(377),
    [anon_sym_struct] = ACTIONS(377),
    [anon_sym_union] = ACTIONS(377),
    [sym_identifier] = ACTIONS(377),
    [sym_comment] = ACTIONS(41),
  },
  [516] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1964),
    [sym_comment] = ACTIONS(41),
  },
  [517] = {
    [sym_ta_top_level] = STATE(171),
    [sym_preproc_include] = STATE(171),
    [sym_preproc_def] = STATE(171),
    [sym_preproc_function_def] = STATE(171),
    [sym_preproc_call] = STATE(171),
    [sym_preproc_if] = STATE(171),
    [sym_preproc_ifdef] = STATE(171),
    [sym_preproc_else] = STATE(759),
    [sym_preproc_elif] = STATE(759),
    [sym_function_definition] = STATE(171),
    [sym_declaration] = STATE(171),
    [sym_type_definition] = STATE(171),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(171),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(171),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(171),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1966),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [518] = {
    [anon_sym_tensor] = ACTIONS(419),
    [anon_sym_indexvars] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(419),
    [sym_preproc_directive] = ACTIONS(419),
    [anon_sym_typedef] = ACTIONS(419),
    [anon_sym_extern] = ACTIONS(419),
    [anon_sym_static] = ACTIONS(419),
    [anon_sym_auto] = ACTIONS(419),
    [anon_sym_register] = ACTIONS(419),
    [anon_sym_inline] = ACTIONS(419),
    [anon_sym_const] = ACTIONS(419),
    [anon_sym_restrict] = ACTIONS(419),
    [anon_sym_volatile] = ACTIONS(419),
    [anon_sym__Atomic] = ACTIONS(419),
    [anon_sym_unsigned] = ACTIONS(419),
    [anon_sym_long] = ACTIONS(419),
    [anon_sym_short] = ACTIONS(419),
    [sym_primitive_type] = ACTIONS(419),
    [anon_sym_enum] = ACTIONS(419),
    [anon_sym_struct] = ACTIONS(419),
    [anon_sym_union] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_comment] = ACTIONS(41),
  },
  [519] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1968),
    [sym_comment] = ACTIONS(41),
  },
  [520] = {
    [sym_ta_top_level] = STATE(171),
    [sym_preproc_include] = STATE(171),
    [sym_preproc_def] = STATE(171),
    [sym_preproc_function_def] = STATE(171),
    [sym_preproc_call] = STATE(171),
    [sym_preproc_if] = STATE(171),
    [sym_preproc_ifdef] = STATE(171),
    [sym_preproc_else] = STATE(761),
    [sym_preproc_elif] = STATE(761),
    [sym_function_definition] = STATE(171),
    [sym_declaration] = STATE(171),
    [sym_type_definition] = STATE(171),
    [sym__declaration_specifiers] = STATE(80),
    [sym_linkage_specification] = STATE(171),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(171),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(171),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(143),
    [anon_sym_indexvars] = ACTIONS(145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(159),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [521] = {
    [anon_sym_tensor] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_indexvars] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(427),
    [sym_preproc_directive] = ACTIONS(427),
    [anon_sym_typedef] = ACTIONS(427),
    [anon_sym_extern] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(427),
    [anon_sym_auto] = ACTIONS(427),
    [anon_sym_register] = ACTIONS(427),
    [anon_sym_inline] = ACTIONS(427),
    [anon_sym_const] = ACTIONS(427),
    [anon_sym_restrict] = ACTIONS(427),
    [anon_sym_volatile] = ACTIONS(427),
    [anon_sym__Atomic] = ACTIONS(427),
    [anon_sym_unsigned] = ACTIONS(427),
    [anon_sym_long] = ACTIONS(427),
    [anon_sym_short] = ACTIONS(427),
    [sym_primitive_type] = ACTIONS(427),
    [anon_sym_enum] = ACTIONS(427),
    [anon_sym_struct] = ACTIONS(427),
    [anon_sym_union] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_switch] = ACTIONS(427),
    [anon_sym_case] = ACTIONS(427),
    [anon_sym_default] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(427),
    [anon_sym_continue] = ACTIONS(427),
    [anon_sym_goto] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_TILDE] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(425),
    [anon_sym_sizeof] = ACTIONS(427),
    [sym_number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(425),
    [anon_sym_DQUOTE] = ACTIONS(425),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_identifier] = ACTIONS(427),
    [sym_comment] = ACTIONS(41),
  },
  [522] = {
    [sym_parameter_list] = STATE(180),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(437),
    [sym_comment] = ACTIONS(41),
  },
  [523] = {
    [sym__type_declarator] = STATE(763),
    [sym_pointer_type_declarator] = STATE(763),
    [sym_function_type_declarator] = STATE(763),
    [sym_array_type_declarator] = STATE(763),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(177),
    [sym_identifier] = ACTIONS(179),
    [sym_comment] = ACTIONS(41),
  },
  [524] = {
    [sym_ta_top_level] = STATE(765),
    [sym_preproc_include] = STATE(765),
    [sym_preproc_def] = STATE(765),
    [sym_preproc_function_def] = STATE(765),
    [sym_preproc_call] = STATE(765),
    [sym_preproc_if] = STATE(765),
    [sym_preproc_ifdef] = STATE(765),
    [sym_function_definition] = STATE(765),
    [sym_declaration] = STATE(765),
    [sym_type_definition] = STATE(765),
    [sym__declaration_specifiers] = STATE(18),
    [sym_linkage_specification] = STATE(765),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(765),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(765),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(1974),
    [anon_sym_indexvars] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(17),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [525] = {
    [anon_sym_tensor] = ACTIONS(451),
    [anon_sym_indexvars] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(451),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(451),
    [sym_preproc_directive] = ACTIONS(451),
    [anon_sym_typedef] = ACTIONS(451),
    [anon_sym_extern] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(451),
    [anon_sym_auto] = ACTIONS(451),
    [anon_sym_register] = ACTIONS(451),
    [anon_sym_inline] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(451),
    [anon_sym_restrict] = ACTIONS(451),
    [anon_sym_volatile] = ACTIONS(451),
    [anon_sym__Atomic] = ACTIONS(451),
    [anon_sym_unsigned] = ACTIONS(451),
    [anon_sym_long] = ACTIONS(451),
    [anon_sym_short] = ACTIONS(451),
    [sym_primitive_type] = ACTIONS(451),
    [anon_sym_enum] = ACTIONS(451),
    [anon_sym_struct] = ACTIONS(451),
    [anon_sym_union] = ACTIONS(451),
    [sym_identifier] = ACTIONS(451),
    [sym_comment] = ACTIONS(41),
  },
  [526] = {
    [sym__declarator] = STATE(304),
    [sym_pointer_declarator] = STATE(304),
    [sym_function_declarator] = STATE(304),
    [sym_array_declarator] = STATE(304),
    [sym_init_declarator] = STATE(305),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(98),
    [sym_identifier] = ACTIONS(708),
    [sym_comment] = ACTIONS(41),
  },
  [527] = {
    [sym_preproc_include] = STATE(767),
    [sym_preproc_def] = STATE(767),
    [sym_preproc_function_def] = STATE(767),
    [sym_preproc_call] = STATE(767),
    [sym_preproc_if_in_compound_statement] = STATE(767),
    [sym_preproc_ifdef_in_compound_statement] = STATE(767),
    [sym_declaration] = STATE(767),
    [sym_type_definition] = STATE(767),
    [sym__declaration_specifiers] = STATE(246),
    [sym_compound_statement] = STATE(767),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(767),
    [sym_expression_statement] = STATE(767),
    [sym_if_statement] = STATE(767),
    [sym_switch_statement] = STATE(767),
    [sym_case_statement] = STATE(767),
    [sym_while_statement] = STATE(767),
    [sym_do_statement] = STATE(767),
    [sym_for_statement] = STATE(767),
    [sym_return_statement] = STATE(767),
    [sym_break_statement] = STATE(767),
    [sym_continue_statement] = STATE(767),
    [sym_goto_statement] = STATE(767),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(767),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(767),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_RBRACE] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(541),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(545),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(545),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(587),
    [sym_comment] = ACTIONS(41),
  },
  [528] = {
    [anon_sym_tensor] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_indexvars] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(591),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(591),
    [sym_preproc_directive] = ACTIONS(591),
    [anon_sym_typedef] = ACTIONS(591),
    [anon_sym_extern] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_static] = ACTIONS(591),
    [anon_sym_auto] = ACTIONS(591),
    [anon_sym_register] = ACTIONS(591),
    [anon_sym_inline] = ACTIONS(591),
    [anon_sym_const] = ACTIONS(591),
    [anon_sym_restrict] = ACTIONS(591),
    [anon_sym_volatile] = ACTIONS(591),
    [anon_sym__Atomic] = ACTIONS(591),
    [anon_sym_unsigned] = ACTIONS(591),
    [anon_sym_long] = ACTIONS(591),
    [anon_sym_short] = ACTIONS(591),
    [sym_primitive_type] = ACTIONS(591),
    [anon_sym_enum] = ACTIONS(591),
    [anon_sym_struct] = ACTIONS(591),
    [anon_sym_union] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(591),
    [anon_sym_else] = ACTIONS(591),
    [anon_sym_switch] = ACTIONS(591),
    [anon_sym_case] = ACTIONS(591),
    [anon_sym_default] = ACTIONS(591),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_do] = ACTIONS(591),
    [anon_sym_for] = ACTIONS(591),
    [anon_sym_return] = ACTIONS(591),
    [anon_sym_break] = ACTIONS(591),
    [anon_sym_continue] = ACTIONS(591),
    [anon_sym_goto] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [anon_sym_PLUS] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_sizeof] = ACTIONS(591),
    [sym_number_literal] = ACTIONS(589),
    [anon_sym_SQUOTE] = ACTIONS(589),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [sym_true] = ACTIONS(591),
    [sym_false] = ACTIONS(591),
    [sym_null] = ACTIONS(591),
    [sym_identifier] = ACTIONS(591),
    [sym_comment] = ACTIONS(41),
  },
  [529] = {
    [anon_sym_tensor] = ACTIONS(631),
    [anon_sym_indexvars] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(631),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(631),
    [sym_preproc_directive] = ACTIONS(631),
    [anon_sym_typedef] = ACTIONS(631),
    [anon_sym_extern] = ACTIONS(631),
    [anon_sym_static] = ACTIONS(631),
    [anon_sym_auto] = ACTIONS(631),
    [anon_sym_register] = ACTIONS(631),
    [anon_sym_inline] = ACTIONS(631),
    [anon_sym_const] = ACTIONS(631),
    [anon_sym_restrict] = ACTIONS(631),
    [anon_sym_volatile] = ACTIONS(631),
    [anon_sym__Atomic] = ACTIONS(631),
    [anon_sym_unsigned] = ACTIONS(631),
    [anon_sym_long] = ACTIONS(631),
    [anon_sym_short] = ACTIONS(631),
    [sym_primitive_type] = ACTIONS(631),
    [anon_sym_enum] = ACTIONS(631),
    [anon_sym_struct] = ACTIONS(631),
    [anon_sym_union] = ACTIONS(631),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(41),
  },
  [530] = {
    [aux_sym_declaration_repeat1] = STATE(272),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_COMMA] = ACTIONS(251),
    [sym_comment] = ACTIONS(41),
  },
  [531] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1980),
    [sym_comment] = ACTIONS(41),
  },
  [532] = {
    [anon_sym_tensor] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_indexvars] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(771),
    [sym_preproc_directive] = ACTIONS(771),
    [anon_sym_typedef] = ACTIONS(771),
    [anon_sym_extern] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(769),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_auto] = ACTIONS(771),
    [anon_sym_register] = ACTIONS(771),
    [anon_sym_inline] = ACTIONS(771),
    [anon_sym_const] = ACTIONS(771),
    [anon_sym_restrict] = ACTIONS(771),
    [anon_sym_volatile] = ACTIONS(771),
    [anon_sym__Atomic] = ACTIONS(771),
    [anon_sym_unsigned] = ACTIONS(771),
    [anon_sym_long] = ACTIONS(771),
    [anon_sym_short] = ACTIONS(771),
    [sym_primitive_type] = ACTIONS(771),
    [anon_sym_enum] = ACTIONS(771),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_union] = ACTIONS(771),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_break] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_goto] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(769),
    [anon_sym_PLUS_PLUS] = ACTIONS(769),
    [anon_sym_sizeof] = ACTIONS(771),
    [sym_number_literal] = ACTIONS(769),
    [anon_sym_SQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [sym_true] = ACTIONS(771),
    [sym_false] = ACTIONS(771),
    [sym_null] = ACTIONS(771),
    [sym_identifier] = ACTIONS(771),
    [sym_comment] = ACTIONS(41),
  },
  [533] = {
    [sym_parameter_list] = STATE(180),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(437),
    [sym_comment] = ACTIONS(41),
  },
  [534] = {
    [anon_sym_tensor] = ACTIONS(785),
    [anon_sym_indexvars] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(785),
    [sym_preproc_directive] = ACTIONS(785),
    [anon_sym_typedef] = ACTIONS(785),
    [anon_sym_extern] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(785),
    [anon_sym_auto] = ACTIONS(785),
    [anon_sym_register] = ACTIONS(785),
    [anon_sym_inline] = ACTIONS(785),
    [anon_sym_const] = ACTIONS(785),
    [anon_sym_restrict] = ACTIONS(785),
    [anon_sym_volatile] = ACTIONS(785),
    [anon_sym__Atomic] = ACTIONS(785),
    [anon_sym_unsigned] = ACTIONS(785),
    [anon_sym_long] = ACTIONS(785),
    [anon_sym_short] = ACTIONS(785),
    [sym_primitive_type] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_struct] = ACTIONS(785),
    [anon_sym_union] = ACTIONS(785),
    [sym_identifier] = ACTIONS(785),
    [sym_comment] = ACTIONS(41),
  },
  [535] = {
    [sym_ta_top_level] = STATE(329),
    [sym_preproc_include] = STATE(329),
    [sym_preproc_def] = STATE(329),
    [sym_preproc_function_def] = STATE(329),
    [sym_preproc_call] = STATE(329),
    [sym_preproc_if] = STATE(329),
    [sym_preproc_ifdef] = STATE(329),
    [sym_function_definition] = STATE(329),
    [sym_declaration] = STATE(329),
    [sym_type_definition] = STATE(329),
    [sym__declaration_specifiers] = STATE(18),
    [sym_linkage_specification] = STATE(329),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(329),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(329),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [anon_sym_indexvars] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(17),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [536] = {
    [anon_sym_tensor] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_indexvars] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(970),
    [sym_preproc_directive] = ACTIONS(970),
    [anon_sym_typedef] = ACTIONS(970),
    [anon_sym_extern] = ACTIONS(970),
    [anon_sym_STAR] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_auto] = ACTIONS(970),
    [anon_sym_register] = ACTIONS(970),
    [anon_sym_inline] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [anon_sym_restrict] = ACTIONS(970),
    [anon_sym_volatile] = ACTIONS(970),
    [anon_sym__Atomic] = ACTIONS(970),
    [anon_sym_unsigned] = ACTIONS(970),
    [anon_sym_long] = ACTIONS(970),
    [anon_sym_short] = ACTIONS(970),
    [sym_primitive_type] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_struct] = ACTIONS(970),
    [anon_sym_union] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(970),
    [anon_sym_case] = ACTIONS(970),
    [anon_sym_default] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_do] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_goto] = ACTIONS(970),
    [anon_sym_AMP] = ACTIONS(968),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_sizeof] = ACTIONS(970),
    [sym_number_literal] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_null] = ACTIONS(970),
    [sym_identifier] = ACTIONS(970),
    [sym_comment] = ACTIONS(41),
  },
  [537] = {
    [sym_preproc_include] = STATE(463),
    [sym_preproc_def] = STATE(463),
    [sym_preproc_function_def] = STATE(463),
    [sym_preproc_call] = STATE(463),
    [sym_preproc_if_in_compound_statement] = STATE(463),
    [sym_preproc_ifdef_in_compound_statement] = STATE(463),
    [sym_declaration] = STATE(463),
    [sym_type_definition] = STATE(463),
    [sym__declaration_specifiers] = STATE(246),
    [sym_compound_statement] = STATE(463),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(463),
    [sym_expression_statement] = STATE(463),
    [sym_if_statement] = STATE(463),
    [sym_switch_statement] = STATE(463),
    [sym_case_statement] = STATE(463),
    [sym_while_statement] = STATE(463),
    [sym_do_statement] = STATE(463),
    [sym_for_statement] = STATE(463),
    [sym_return_statement] = STATE(463),
    [sym_break_statement] = STATE(463),
    [sym_continue_statement] = STATE(463),
    [sym_goto_statement] = STATE(463),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(463),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(463),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_SEMI] = ACTIONS(539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(541),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(545),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(545),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(587),
    [sym_comment] = ACTIONS(41),
  },
  [538] = {
    [anon_sym_tensor] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1182),
    [anon_sym_SEMI] = ACTIONS(1182),
    [anon_sym_indexvars] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1184),
    [sym_preproc_directive] = ACTIONS(1184),
    [anon_sym_typedef] = ACTIONS(1184),
    [anon_sym_extern] = ACTIONS(1184),
    [anon_sym_STAR] = ACTIONS(1182),
    [anon_sym_static] = ACTIONS(1184),
    [anon_sym_auto] = ACTIONS(1184),
    [anon_sym_register] = ACTIONS(1184),
    [anon_sym_inline] = ACTIONS(1184),
    [anon_sym_const] = ACTIONS(1184),
    [anon_sym_restrict] = ACTIONS(1184),
    [anon_sym_volatile] = ACTIONS(1184),
    [anon_sym__Atomic] = ACTIONS(1184),
    [anon_sym_unsigned] = ACTIONS(1184),
    [anon_sym_long] = ACTIONS(1184),
    [anon_sym_short] = ACTIONS(1184),
    [sym_primitive_type] = ACTIONS(1184),
    [anon_sym_enum] = ACTIONS(1184),
    [anon_sym_struct] = ACTIONS(1184),
    [anon_sym_union] = ACTIONS(1184),
    [anon_sym_if] = ACTIONS(1184),
    [anon_sym_else] = ACTIONS(1184),
    [anon_sym_switch] = ACTIONS(1184),
    [anon_sym_case] = ACTIONS(1184),
    [anon_sym_default] = ACTIONS(1184),
    [anon_sym_while] = ACTIONS(1184),
    [anon_sym_do] = ACTIONS(1184),
    [anon_sym_for] = ACTIONS(1184),
    [anon_sym_return] = ACTIONS(1184),
    [anon_sym_break] = ACTIONS(1184),
    [anon_sym_continue] = ACTIONS(1184),
    [anon_sym_goto] = ACTIONS(1184),
    [anon_sym_AMP] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1182),
    [anon_sym_TILDE] = ACTIONS(1182),
    [anon_sym_PLUS] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1184),
    [anon_sym_DASH_DASH] = ACTIONS(1182),
    [anon_sym_PLUS_PLUS] = ACTIONS(1182),
    [anon_sym_sizeof] = ACTIONS(1184),
    [sym_number_literal] = ACTIONS(1182),
    [anon_sym_SQUOTE] = ACTIONS(1182),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [sym_true] = ACTIONS(1184),
    [sym_false] = ACTIONS(1184),
    [sym_null] = ACTIONS(1184),
    [sym_identifier] = ACTIONS(1184),
    [sym_comment] = ACTIONS(41),
  },
  [539] = {
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [sym_comment] = ACTIONS(41),
  },
  [540] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1990),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [541] = {
    [anon_sym_RPAREN] = ACTIONS(1992),
    [sym_comment] = ACTIONS(41),
  },
  [542] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(774),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [543] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(1660),
    [anon_sym_STAR_EQ] = ACTIONS(1660),
    [anon_sym_SLASH_EQ] = ACTIONS(1660),
    [anon_sym_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_PLUS_EQ] = ACTIONS(1660),
    [anon_sym_DASH_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_GT_EQ] = ACTIONS(1660),
    [anon_sym_AMP_EQ] = ACTIONS(1660),
    [anon_sym_CARET_EQ] = ACTIONS(1660),
    [anon_sym_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_CARET] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1660),
    [anon_sym_BANG_EQ] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [544] = {
    [sym__expression] = STATE(708),
    [sym_conditional_expression] = STATE(708),
    [sym_assignment_expression] = STATE(708),
    [sym_pointer_expression] = STATE(708),
    [sym_logical_expression] = STATE(708),
    [sym_bitwise_expression] = STATE(708),
    [sym_equality_expression] = STATE(708),
    [sym_relational_expression] = STATE(708),
    [sym_shift_expression] = STATE(708),
    [sym_math_expression] = STATE(708),
    [sym_cast_expression] = STATE(708),
    [sym_sizeof_expression] = STATE(708),
    [sym_subscript_expression] = STATE(708),
    [sym_call_expression] = STATE(708),
    [sym_field_expression] = STATE(708),
    [sym_compound_literal_expression] = STATE(708),
    [sym_parenthesized_expression] = STATE(708),
    [sym_char_literal] = STATE(708),
    [sym_concatenated_string] = STATE(708),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(41),
  },
  [545] = {
    [sym__expression] = STATE(775),
    [sym_conditional_expression] = STATE(775),
    [sym_assignment_expression] = STATE(775),
    [sym_pointer_expression] = STATE(775),
    [sym_logical_expression] = STATE(775),
    [sym_bitwise_expression] = STATE(775),
    [sym_equality_expression] = STATE(775),
    [sym_relational_expression] = STATE(775),
    [sym_shift_expression] = STATE(775),
    [sym_math_expression] = STATE(775),
    [sym_cast_expression] = STATE(775),
    [sym_sizeof_expression] = STATE(775),
    [sym_subscript_expression] = STATE(775),
    [sym_call_expression] = STATE(775),
    [sym_field_expression] = STATE(775),
    [sym_compound_literal_expression] = STATE(775),
    [sym_parenthesized_expression] = STATE(775),
    [sym_char_literal] = STATE(775),
    [sym_concatenated_string] = STATE(775),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_identifier] = ACTIONS(1996),
    [sym_comment] = ACTIONS(41),
  },
  [546] = {
    [sym__expression] = STATE(776),
    [sym_conditional_expression] = STATE(776),
    [sym_assignment_expression] = STATE(776),
    [sym_pointer_expression] = STATE(776),
    [sym_logical_expression] = STATE(776),
    [sym_bitwise_expression] = STATE(776),
    [sym_equality_expression] = STATE(776),
    [sym_relational_expression] = STATE(776),
    [sym_shift_expression] = STATE(776),
    [sym_math_expression] = STATE(776),
    [sym_cast_expression] = STATE(776),
    [sym_sizeof_expression] = STATE(776),
    [sym_subscript_expression] = STATE(776),
    [sym_call_expression] = STATE(776),
    [sym_field_expression] = STATE(776),
    [sym_compound_literal_expression] = STATE(776),
    [sym_parenthesized_expression] = STATE(776),
    [sym_char_literal] = STATE(776),
    [sym_concatenated_string] = STATE(776),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1998),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2000),
    [sym_false] = ACTIONS(2000),
    [sym_null] = ACTIONS(2000),
    [sym_identifier] = ACTIONS(2000),
    [sym_comment] = ACTIONS(41),
  },
  [547] = {
    [sym__expression] = STATE(777),
    [sym_conditional_expression] = STATE(777),
    [sym_assignment_expression] = STATE(777),
    [sym_pointer_expression] = STATE(777),
    [sym_logical_expression] = STATE(777),
    [sym_bitwise_expression] = STATE(777),
    [sym_equality_expression] = STATE(777),
    [sym_relational_expression] = STATE(777),
    [sym_shift_expression] = STATE(777),
    [sym_math_expression] = STATE(777),
    [sym_cast_expression] = STATE(777),
    [sym_sizeof_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_field_expression] = STATE(777),
    [sym_compound_literal_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_char_literal] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2004),
    [sym_false] = ACTIONS(2004),
    [sym_null] = ACTIONS(2004),
    [sym_identifier] = ACTIONS(2004),
    [sym_comment] = ACTIONS(41),
  },
  [548] = {
    [sym__expression] = STATE(778),
    [sym_conditional_expression] = STATE(778),
    [sym_assignment_expression] = STATE(778),
    [sym_pointer_expression] = STATE(778),
    [sym_logical_expression] = STATE(778),
    [sym_bitwise_expression] = STATE(778),
    [sym_equality_expression] = STATE(778),
    [sym_relational_expression] = STATE(778),
    [sym_shift_expression] = STATE(778),
    [sym_math_expression] = STATE(778),
    [sym_cast_expression] = STATE(778),
    [sym_sizeof_expression] = STATE(778),
    [sym_subscript_expression] = STATE(778),
    [sym_call_expression] = STATE(778),
    [sym_field_expression] = STATE(778),
    [sym_compound_literal_expression] = STATE(778),
    [sym_parenthesized_expression] = STATE(778),
    [sym_char_literal] = STATE(778),
    [sym_concatenated_string] = STATE(778),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2006),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2008),
    [sym_false] = ACTIONS(2008),
    [sym_null] = ACTIONS(2008),
    [sym_identifier] = ACTIONS(2008),
    [sym_comment] = ACTIONS(41),
  },
  [549] = {
    [sym__expression] = STATE(779),
    [sym_conditional_expression] = STATE(779),
    [sym_assignment_expression] = STATE(779),
    [sym_pointer_expression] = STATE(779),
    [sym_logical_expression] = STATE(779),
    [sym_bitwise_expression] = STATE(779),
    [sym_equality_expression] = STATE(779),
    [sym_relational_expression] = STATE(779),
    [sym_shift_expression] = STATE(779),
    [sym_math_expression] = STATE(779),
    [sym_cast_expression] = STATE(779),
    [sym_sizeof_expression] = STATE(779),
    [sym_subscript_expression] = STATE(779),
    [sym_call_expression] = STATE(779),
    [sym_field_expression] = STATE(779),
    [sym_compound_literal_expression] = STATE(779),
    [sym_parenthesized_expression] = STATE(779),
    [sym_char_literal] = STATE(779),
    [sym_concatenated_string] = STATE(779),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [sym_null] = ACTIONS(2012),
    [sym_identifier] = ACTIONS(2012),
    [sym_comment] = ACTIONS(41),
  },
  [550] = {
    [sym__expression] = STATE(780),
    [sym_conditional_expression] = STATE(780),
    [sym_assignment_expression] = STATE(780),
    [sym_pointer_expression] = STATE(780),
    [sym_logical_expression] = STATE(780),
    [sym_bitwise_expression] = STATE(780),
    [sym_equality_expression] = STATE(780),
    [sym_relational_expression] = STATE(780),
    [sym_shift_expression] = STATE(780),
    [sym_math_expression] = STATE(780),
    [sym_cast_expression] = STATE(780),
    [sym_sizeof_expression] = STATE(780),
    [sym_subscript_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_compound_literal_expression] = STATE(780),
    [sym_parenthesized_expression] = STATE(780),
    [sym_char_literal] = STATE(780),
    [sym_concatenated_string] = STATE(780),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2016),
    [sym_false] = ACTIONS(2016),
    [sym_null] = ACTIONS(2016),
    [sym_identifier] = ACTIONS(2016),
    [sym_comment] = ACTIONS(41),
  },
  [551] = {
    [sym__expression] = STATE(781),
    [sym_conditional_expression] = STATE(781),
    [sym_assignment_expression] = STATE(781),
    [sym_pointer_expression] = STATE(781),
    [sym_logical_expression] = STATE(781),
    [sym_bitwise_expression] = STATE(781),
    [sym_equality_expression] = STATE(781),
    [sym_relational_expression] = STATE(781),
    [sym_shift_expression] = STATE(781),
    [sym_math_expression] = STATE(781),
    [sym_cast_expression] = STATE(781),
    [sym_sizeof_expression] = STATE(781),
    [sym_subscript_expression] = STATE(781),
    [sym_call_expression] = STATE(781),
    [sym_field_expression] = STATE(781),
    [sym_compound_literal_expression] = STATE(781),
    [sym_parenthesized_expression] = STATE(781),
    [sym_char_literal] = STATE(781),
    [sym_concatenated_string] = STATE(781),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2018),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2020),
    [sym_false] = ACTIONS(2020),
    [sym_null] = ACTIONS(2020),
    [sym_identifier] = ACTIONS(2020),
    [sym_comment] = ACTIONS(41),
  },
  [552] = {
    [sym__expression] = STATE(782),
    [sym_conditional_expression] = STATE(782),
    [sym_assignment_expression] = STATE(782),
    [sym_pointer_expression] = STATE(782),
    [sym_logical_expression] = STATE(782),
    [sym_bitwise_expression] = STATE(782),
    [sym_equality_expression] = STATE(782),
    [sym_relational_expression] = STATE(782),
    [sym_shift_expression] = STATE(782),
    [sym_math_expression] = STATE(782),
    [sym_cast_expression] = STATE(782),
    [sym_sizeof_expression] = STATE(782),
    [sym_subscript_expression] = STATE(782),
    [sym_call_expression] = STATE(782),
    [sym_field_expression] = STATE(782),
    [sym_compound_literal_expression] = STATE(782),
    [sym_parenthesized_expression] = STATE(782),
    [sym_char_literal] = STATE(782),
    [sym_concatenated_string] = STATE(782),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2024),
    [sym_false] = ACTIONS(2024),
    [sym_null] = ACTIONS(2024),
    [sym_identifier] = ACTIONS(2024),
    [sym_comment] = ACTIONS(41),
  },
  [553] = {
    [sym__expression] = STATE(783),
    [sym_conditional_expression] = STATE(783),
    [sym_assignment_expression] = STATE(783),
    [sym_pointer_expression] = STATE(783),
    [sym_logical_expression] = STATE(783),
    [sym_bitwise_expression] = STATE(783),
    [sym_equality_expression] = STATE(783),
    [sym_relational_expression] = STATE(783),
    [sym_shift_expression] = STATE(783),
    [sym_math_expression] = STATE(783),
    [sym_cast_expression] = STATE(783),
    [sym_sizeof_expression] = STATE(783),
    [sym_subscript_expression] = STATE(783),
    [sym_call_expression] = STATE(783),
    [sym_field_expression] = STATE(783),
    [sym_compound_literal_expression] = STATE(783),
    [sym_parenthesized_expression] = STATE(783),
    [sym_char_literal] = STATE(783),
    [sym_concatenated_string] = STATE(783),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2026),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2028),
    [sym_false] = ACTIONS(2028),
    [sym_null] = ACTIONS(2028),
    [sym_identifier] = ACTIONS(2028),
    [sym_comment] = ACTIONS(41),
  },
  [554] = {
    [sym__expression] = STATE(784),
    [sym_conditional_expression] = STATE(784),
    [sym_assignment_expression] = STATE(784),
    [sym_pointer_expression] = STATE(784),
    [sym_logical_expression] = STATE(784),
    [sym_bitwise_expression] = STATE(784),
    [sym_equality_expression] = STATE(784),
    [sym_relational_expression] = STATE(784),
    [sym_shift_expression] = STATE(784),
    [sym_math_expression] = STATE(784),
    [sym_cast_expression] = STATE(784),
    [sym_sizeof_expression] = STATE(784),
    [sym_subscript_expression] = STATE(784),
    [sym_call_expression] = STATE(784),
    [sym_field_expression] = STATE(784),
    [sym_compound_literal_expression] = STATE(784),
    [sym_parenthesized_expression] = STATE(784),
    [sym_char_literal] = STATE(784),
    [sym_concatenated_string] = STATE(784),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2030),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_identifier] = ACTIONS(2032),
    [sym_comment] = ACTIONS(41),
  },
  [555] = {
    [sym__expression] = STATE(785),
    [sym_conditional_expression] = STATE(785),
    [sym_assignment_expression] = STATE(785),
    [sym_pointer_expression] = STATE(785),
    [sym_logical_expression] = STATE(785),
    [sym_bitwise_expression] = STATE(785),
    [sym_equality_expression] = STATE(785),
    [sym_relational_expression] = STATE(785),
    [sym_shift_expression] = STATE(785),
    [sym_math_expression] = STATE(785),
    [sym_cast_expression] = STATE(785),
    [sym_sizeof_expression] = STATE(785),
    [sym_subscript_expression] = STATE(785),
    [sym_call_expression] = STATE(785),
    [sym_field_expression] = STATE(785),
    [sym_compound_literal_expression] = STATE(785),
    [sym_parenthesized_expression] = STATE(785),
    [sym_char_literal] = STATE(785),
    [sym_concatenated_string] = STATE(785),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [sym_null] = ACTIONS(2036),
    [sym_identifier] = ACTIONS(2036),
    [sym_comment] = ACTIONS(41),
  },
  [556] = {
    [sym_string_literal] = STATE(786),
    [aux_sym_concatenated_string_repeat1] = STATE(786),
    [anon_sym_LPAREN] = ACTIONS(1738),
    [anon_sym_RBRACE] = ACTIONS(1738),
    [anon_sym_COMMA] = ACTIONS(1738),
    [anon_sym_STAR] = ACTIONS(1740),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_EQ] = ACTIONS(1740),
    [anon_sym_QMARK] = ACTIONS(1738),
    [anon_sym_STAR_EQ] = ACTIONS(1738),
    [anon_sym_SLASH_EQ] = ACTIONS(1738),
    [anon_sym_PERCENT_EQ] = ACTIONS(1738),
    [anon_sym_PLUS_EQ] = ACTIONS(1738),
    [anon_sym_DASH_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_GT_EQ] = ACTIONS(1738),
    [anon_sym_AMP_EQ] = ACTIONS(1738),
    [anon_sym_CARET_EQ] = ACTIONS(1738),
    [anon_sym_PIPE_EQ] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1740),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE] = ACTIONS(1740),
    [anon_sym_CARET] = ACTIONS(1740),
    [anon_sym_EQ_EQ] = ACTIONS(1738),
    [anon_sym_BANG_EQ] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1740),
    [anon_sym_GT] = ACTIONS(1740),
    [anon_sym_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT] = ACTIONS(1740),
    [anon_sym_GT_GT] = ACTIONS(1740),
    [anon_sym_PLUS] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1740),
    [anon_sym_SLASH] = ACTIONS(1740),
    [anon_sym_PERCENT] = ACTIONS(1740),
    [anon_sym_DASH_DASH] = ACTIONS(1738),
    [anon_sym_PLUS_PLUS] = ACTIONS(1738),
    [anon_sym_DOT] = ACTIONS(1738),
    [anon_sym_DASH_GT] = ACTIONS(1738),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [557] = {
    [anon_sym_LPAREN] = ACTIONS(2038),
    [anon_sym_RPAREN] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_COMMA] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_RBRACK] = ACTIONS(2038),
    [anon_sym_static] = ACTIONS(2040),
    [anon_sym_auto] = ACTIONS(2040),
    [anon_sym_register] = ACTIONS(2040),
    [anon_sym_inline] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2040),
    [anon_sym_restrict] = ACTIONS(2040),
    [anon_sym_volatile] = ACTIONS(2040),
    [anon_sym__Atomic] = ACTIONS(2040),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_DASH_DASH] = ACTIONS(2038),
    [anon_sym_PLUS_PLUS] = ACTIONS(2038),
    [anon_sym_sizeof] = ACTIONS(2040),
    [sym_number_literal] = ACTIONS(2038),
    [anon_sym_SQUOTE] = ACTIONS(2038),
    [anon_sym_DQUOTE] = ACTIONS(2038),
    [sym_true] = ACTIONS(2040),
    [sym_false] = ACTIONS(2040),
    [sym_null] = ACTIONS(2040),
    [sym_identifier] = ACTIONS(2040),
    [sym_comment] = ACTIONS(41),
  },
  [558] = {
    [sym_enumerator] = STATE(341),
    [sym_identifier] = ACTIONS(195),
    [sym_comment] = ACTIONS(41),
  },
  [559] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(787),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(787),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(787),
    [sym_field_declaration] = STATE(787),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(787),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(207),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [560] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(789),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(789),
    [sym_preproc_else_in_field_declaration_list] = STATE(788),
    [sym_preproc_elif_in_field_declaration_list] = STATE(788),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(789),
    [sym_field_declaration] = STATE(789),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(789),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(207),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(820),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(822),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [561] = {
    [anon_sym_RBRACE] = ACTIONS(2046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2048),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2046),
    [anon_sym_extern] = ACTIONS(2048),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_auto] = ACTIONS(2048),
    [anon_sym_register] = ACTIONS(2048),
    [anon_sym_inline] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_restrict] = ACTIONS(2048),
    [anon_sym_volatile] = ACTIONS(2048),
    [anon_sym__Atomic] = ACTIONS(2048),
    [anon_sym_unsigned] = ACTIONS(2048),
    [anon_sym_long] = ACTIONS(2048),
    [anon_sym_short] = ACTIONS(2048),
    [sym_primitive_type] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [sym_identifier] = ACTIONS(2048),
    [sym_comment] = ACTIONS(41),
  },
  [562] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2050),
    [sym_comment] = ACTIONS(41),
  },
  [563] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(563),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(563),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(563),
    [sym_field_declaration] = STATE(563),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(563),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(871),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(871),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(866),
    [anon_sym_extern] = ACTIONS(874),
    [anon_sym_static] = ACTIONS(874),
    [anon_sym_auto] = ACTIONS(874),
    [anon_sym_register] = ACTIONS(874),
    [anon_sym_inline] = ACTIONS(874),
    [anon_sym_const] = ACTIONS(877),
    [anon_sym_restrict] = ACTIONS(877),
    [anon_sym_volatile] = ACTIONS(877),
    [anon_sym__Atomic] = ACTIONS(877),
    [anon_sym_unsigned] = ACTIONS(880),
    [anon_sym_long] = ACTIONS(880),
    [anon_sym_short] = ACTIONS(880),
    [sym_primitive_type] = ACTIONS(883),
    [anon_sym_enum] = ACTIONS(886),
    [anon_sym_struct] = ACTIONS(889),
    [anon_sym_union] = ACTIONS(892),
    [sym_identifier] = ACTIONS(895),
    [sym_comment] = ACTIONS(41),
  },
  [564] = {
    [anon_sym_RBRACE] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2052),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_auto] = ACTIONS(2054),
    [anon_sym_register] = ACTIONS(2054),
    [anon_sym_inline] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_restrict] = ACTIONS(2054),
    [anon_sym_volatile] = ACTIONS(2054),
    [anon_sym__Atomic] = ACTIONS(2054),
    [anon_sym_unsigned] = ACTIONS(2054),
    [anon_sym_long] = ACTIONS(2054),
    [anon_sym_short] = ACTIONS(2054),
    [sym_primitive_type] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2054),
    [sym_comment] = ACTIONS(41),
  },
  [565] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2056),
    [sym_comment] = ACTIONS(41),
  },
  [566] = {
    [sym__field_declarator] = STATE(568),
    [sym_pointer_field_declarator] = STATE(568),
    [sym_function_field_declarator] = STATE(568),
    [sym_array_field_declarator] = STATE(568),
    [sym_type_qualifier] = STATE(215),
    [aux_sym_type_definition_repeat1] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(826),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(832),
    [sym_comment] = ACTIONS(41),
  },
  [567] = {
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_RPAREN] = ACTIONS(2058),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_COMMA] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_COLON] = ACTIONS(2058),
    [sym_comment] = ACTIONS(41),
  },
  [568] = {
    [sym_parameter_list] = STATE(368),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_COMMA] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(858),
    [anon_sym_COLON] = ACTIONS(2060),
    [sym_comment] = ACTIONS(41),
  },
  [569] = {
    [anon_sym_RPAREN] = ACTIONS(2062),
    [sym_comment] = ACTIONS(41),
  },
  [570] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(793),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [571] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(1660),
    [anon_sym_STAR_EQ] = ACTIONS(1660),
    [anon_sym_SLASH_EQ] = ACTIONS(1660),
    [anon_sym_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_PLUS_EQ] = ACTIONS(1660),
    [anon_sym_DASH_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_GT_EQ] = ACTIONS(1660),
    [anon_sym_AMP_EQ] = ACTIONS(1660),
    [anon_sym_CARET_EQ] = ACTIONS(1660),
    [anon_sym_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_CARET] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1660),
    [anon_sym_BANG_EQ] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [572] = {
    [anon_sym_RBRACE] = ACTIONS(2064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2064),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2064),
    [anon_sym_extern] = ACTIONS(2066),
    [anon_sym_static] = ACTIONS(2066),
    [anon_sym_auto] = ACTIONS(2066),
    [anon_sym_register] = ACTIONS(2066),
    [anon_sym_inline] = ACTIONS(2066),
    [anon_sym_const] = ACTIONS(2066),
    [anon_sym_restrict] = ACTIONS(2066),
    [anon_sym_volatile] = ACTIONS(2066),
    [anon_sym__Atomic] = ACTIONS(2066),
    [anon_sym_unsigned] = ACTIONS(2066),
    [anon_sym_long] = ACTIONS(2066),
    [anon_sym_short] = ACTIONS(2066),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2066),
    [anon_sym_struct] = ACTIONS(2066),
    [anon_sym_union] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(2066),
    [sym_comment] = ACTIONS(41),
  },
  [573] = {
    [sym__expression] = STATE(708),
    [sym_conditional_expression] = STATE(708),
    [sym_assignment_expression] = STATE(708),
    [sym_pointer_expression] = STATE(708),
    [sym_logical_expression] = STATE(708),
    [sym_bitwise_expression] = STATE(708),
    [sym_equality_expression] = STATE(708),
    [sym_relational_expression] = STATE(708),
    [sym_shift_expression] = STATE(708),
    [sym_math_expression] = STATE(708),
    [sym_cast_expression] = STATE(708),
    [sym_sizeof_expression] = STATE(708),
    [sym_subscript_expression] = STATE(708),
    [sym_call_expression] = STATE(708),
    [sym_field_expression] = STATE(708),
    [sym_compound_literal_expression] = STATE(708),
    [sym_parenthesized_expression] = STATE(708),
    [sym_char_literal] = STATE(708),
    [sym_concatenated_string] = STATE(708),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(41),
  },
  [574] = {
    [sym__expression] = STATE(794),
    [sym_conditional_expression] = STATE(794),
    [sym_assignment_expression] = STATE(794),
    [sym_pointer_expression] = STATE(794),
    [sym_logical_expression] = STATE(794),
    [sym_bitwise_expression] = STATE(794),
    [sym_equality_expression] = STATE(794),
    [sym_relational_expression] = STATE(794),
    [sym_shift_expression] = STATE(794),
    [sym_math_expression] = STATE(794),
    [sym_cast_expression] = STATE(794),
    [sym_sizeof_expression] = STATE(794),
    [sym_subscript_expression] = STATE(794),
    [sym_call_expression] = STATE(794),
    [sym_field_expression] = STATE(794),
    [sym_compound_literal_expression] = STATE(794),
    [sym_parenthesized_expression] = STATE(794),
    [sym_char_literal] = STATE(794),
    [sym_concatenated_string] = STATE(794),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2068),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2070),
    [sym_false] = ACTIONS(2070),
    [sym_null] = ACTIONS(2070),
    [sym_identifier] = ACTIONS(2070),
    [sym_comment] = ACTIONS(41),
  },
  [575] = {
    [sym__expression] = STATE(795),
    [sym_conditional_expression] = STATE(795),
    [sym_assignment_expression] = STATE(795),
    [sym_pointer_expression] = STATE(795),
    [sym_logical_expression] = STATE(795),
    [sym_bitwise_expression] = STATE(795),
    [sym_equality_expression] = STATE(795),
    [sym_relational_expression] = STATE(795),
    [sym_shift_expression] = STATE(795),
    [sym_math_expression] = STATE(795),
    [sym_cast_expression] = STATE(795),
    [sym_sizeof_expression] = STATE(795),
    [sym_subscript_expression] = STATE(795),
    [sym_call_expression] = STATE(795),
    [sym_field_expression] = STATE(795),
    [sym_compound_literal_expression] = STATE(795),
    [sym_parenthesized_expression] = STATE(795),
    [sym_char_literal] = STATE(795),
    [sym_concatenated_string] = STATE(795),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2072),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2074),
    [sym_false] = ACTIONS(2074),
    [sym_null] = ACTIONS(2074),
    [sym_identifier] = ACTIONS(2074),
    [sym_comment] = ACTIONS(41),
  },
  [576] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_char_literal] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2076),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2078),
    [sym_false] = ACTIONS(2078),
    [sym_null] = ACTIONS(2078),
    [sym_identifier] = ACTIONS(2078),
    [sym_comment] = ACTIONS(41),
  },
  [577] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_char_literal] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2080),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2082),
    [sym_false] = ACTIONS(2082),
    [sym_null] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2082),
    [sym_comment] = ACTIONS(41),
  },
  [578] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_char_literal] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2084),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2086),
    [sym_false] = ACTIONS(2086),
    [sym_null] = ACTIONS(2086),
    [sym_identifier] = ACTIONS(2086),
    [sym_comment] = ACTIONS(41),
  },
  [579] = {
    [sym__expression] = STATE(799),
    [sym_conditional_expression] = STATE(799),
    [sym_assignment_expression] = STATE(799),
    [sym_pointer_expression] = STATE(799),
    [sym_logical_expression] = STATE(799),
    [sym_bitwise_expression] = STATE(799),
    [sym_equality_expression] = STATE(799),
    [sym_relational_expression] = STATE(799),
    [sym_shift_expression] = STATE(799),
    [sym_math_expression] = STATE(799),
    [sym_cast_expression] = STATE(799),
    [sym_sizeof_expression] = STATE(799),
    [sym_subscript_expression] = STATE(799),
    [sym_call_expression] = STATE(799),
    [sym_field_expression] = STATE(799),
    [sym_compound_literal_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(799),
    [sym_char_literal] = STATE(799),
    [sym_concatenated_string] = STATE(799),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2090),
    [sym_false] = ACTIONS(2090),
    [sym_null] = ACTIONS(2090),
    [sym_identifier] = ACTIONS(2090),
    [sym_comment] = ACTIONS(41),
  },
  [580] = {
    [sym__expression] = STATE(800),
    [sym_conditional_expression] = STATE(800),
    [sym_assignment_expression] = STATE(800),
    [sym_pointer_expression] = STATE(800),
    [sym_logical_expression] = STATE(800),
    [sym_bitwise_expression] = STATE(800),
    [sym_equality_expression] = STATE(800),
    [sym_relational_expression] = STATE(800),
    [sym_shift_expression] = STATE(800),
    [sym_math_expression] = STATE(800),
    [sym_cast_expression] = STATE(800),
    [sym_sizeof_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_call_expression] = STATE(800),
    [sym_field_expression] = STATE(800),
    [sym_compound_literal_expression] = STATE(800),
    [sym_parenthesized_expression] = STATE(800),
    [sym_char_literal] = STATE(800),
    [sym_concatenated_string] = STATE(800),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2092),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [sym_null] = ACTIONS(2094),
    [sym_identifier] = ACTIONS(2094),
    [sym_comment] = ACTIONS(41),
  },
  [581] = {
    [sym__expression] = STATE(801),
    [sym_conditional_expression] = STATE(801),
    [sym_assignment_expression] = STATE(801),
    [sym_pointer_expression] = STATE(801),
    [sym_logical_expression] = STATE(801),
    [sym_bitwise_expression] = STATE(801),
    [sym_equality_expression] = STATE(801),
    [sym_relational_expression] = STATE(801),
    [sym_shift_expression] = STATE(801),
    [sym_math_expression] = STATE(801),
    [sym_cast_expression] = STATE(801),
    [sym_sizeof_expression] = STATE(801),
    [sym_subscript_expression] = STATE(801),
    [sym_call_expression] = STATE(801),
    [sym_field_expression] = STATE(801),
    [sym_compound_literal_expression] = STATE(801),
    [sym_parenthesized_expression] = STATE(801),
    [sym_char_literal] = STATE(801),
    [sym_concatenated_string] = STATE(801),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2096),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2098),
    [sym_false] = ACTIONS(2098),
    [sym_null] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2098),
    [sym_comment] = ACTIONS(41),
  },
  [582] = {
    [sym__expression] = STATE(802),
    [sym_conditional_expression] = STATE(802),
    [sym_assignment_expression] = STATE(802),
    [sym_pointer_expression] = STATE(802),
    [sym_logical_expression] = STATE(802),
    [sym_bitwise_expression] = STATE(802),
    [sym_equality_expression] = STATE(802),
    [sym_relational_expression] = STATE(802),
    [sym_shift_expression] = STATE(802),
    [sym_math_expression] = STATE(802),
    [sym_cast_expression] = STATE(802),
    [sym_sizeof_expression] = STATE(802),
    [sym_subscript_expression] = STATE(802),
    [sym_call_expression] = STATE(802),
    [sym_field_expression] = STATE(802),
    [sym_compound_literal_expression] = STATE(802),
    [sym_parenthesized_expression] = STATE(802),
    [sym_char_literal] = STATE(802),
    [sym_concatenated_string] = STATE(802),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2100),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2102),
    [sym_false] = ACTIONS(2102),
    [sym_null] = ACTIONS(2102),
    [sym_identifier] = ACTIONS(2102),
    [sym_comment] = ACTIONS(41),
  },
  [583] = {
    [sym__expression] = STATE(803),
    [sym_conditional_expression] = STATE(803),
    [sym_assignment_expression] = STATE(803),
    [sym_pointer_expression] = STATE(803),
    [sym_logical_expression] = STATE(803),
    [sym_bitwise_expression] = STATE(803),
    [sym_equality_expression] = STATE(803),
    [sym_relational_expression] = STATE(803),
    [sym_shift_expression] = STATE(803),
    [sym_math_expression] = STATE(803),
    [sym_cast_expression] = STATE(803),
    [sym_sizeof_expression] = STATE(803),
    [sym_subscript_expression] = STATE(803),
    [sym_call_expression] = STATE(803),
    [sym_field_expression] = STATE(803),
    [sym_compound_literal_expression] = STATE(803),
    [sym_parenthesized_expression] = STATE(803),
    [sym_char_literal] = STATE(803),
    [sym_concatenated_string] = STATE(803),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2104),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2106),
    [sym_false] = ACTIONS(2106),
    [sym_null] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2106),
    [sym_comment] = ACTIONS(41),
  },
  [584] = {
    [sym__expression] = STATE(804),
    [sym_conditional_expression] = STATE(804),
    [sym_assignment_expression] = STATE(804),
    [sym_pointer_expression] = STATE(804),
    [sym_logical_expression] = STATE(804),
    [sym_bitwise_expression] = STATE(804),
    [sym_equality_expression] = STATE(804),
    [sym_relational_expression] = STATE(804),
    [sym_shift_expression] = STATE(804),
    [sym_math_expression] = STATE(804),
    [sym_cast_expression] = STATE(804),
    [sym_sizeof_expression] = STATE(804),
    [sym_subscript_expression] = STATE(804),
    [sym_call_expression] = STATE(804),
    [sym_field_expression] = STATE(804),
    [sym_compound_literal_expression] = STATE(804),
    [sym_parenthesized_expression] = STATE(804),
    [sym_char_literal] = STATE(804),
    [sym_concatenated_string] = STATE(804),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2108),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2110),
    [sym_false] = ACTIONS(2110),
    [sym_null] = ACTIONS(2110),
    [sym_identifier] = ACTIONS(2110),
    [sym_comment] = ACTIONS(41),
  },
  [585] = {
    [sym_string_literal] = STATE(805),
    [aux_sym_concatenated_string_repeat1] = STATE(805),
    [anon_sym_LPAREN] = ACTIONS(1738),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_STAR] = ACTIONS(1740),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_EQ] = ACTIONS(1740),
    [anon_sym_QMARK] = ACTIONS(1738),
    [anon_sym_STAR_EQ] = ACTIONS(1738),
    [anon_sym_SLASH_EQ] = ACTIONS(1738),
    [anon_sym_PERCENT_EQ] = ACTIONS(1738),
    [anon_sym_PLUS_EQ] = ACTIONS(1738),
    [anon_sym_DASH_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_GT_EQ] = ACTIONS(1738),
    [anon_sym_AMP_EQ] = ACTIONS(1738),
    [anon_sym_CARET_EQ] = ACTIONS(1738),
    [anon_sym_PIPE_EQ] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1740),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE] = ACTIONS(1740),
    [anon_sym_CARET] = ACTIONS(1740),
    [anon_sym_EQ_EQ] = ACTIONS(1738),
    [anon_sym_BANG_EQ] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1740),
    [anon_sym_GT] = ACTIONS(1740),
    [anon_sym_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT] = ACTIONS(1740),
    [anon_sym_GT_GT] = ACTIONS(1740),
    [anon_sym_PLUS] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1740),
    [anon_sym_SLASH] = ACTIONS(1740),
    [anon_sym_PERCENT] = ACTIONS(1740),
    [anon_sym_DASH_DASH] = ACTIONS(1738),
    [anon_sym_PLUS_PLUS] = ACTIONS(1738),
    [anon_sym_DOT] = ACTIONS(1738),
    [anon_sym_DASH_GT] = ACTIONS(1738),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [586] = {
    [sym_parameter_list] = STATE(368),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(2112),
    [anon_sym_COMMA] = ACTIONS(2112),
    [anon_sym_LBRACK] = ACTIONS(858),
    [anon_sym_COLON] = ACTIONS(2112),
    [sym_comment] = ACTIONS(41),
  },
  [587] = {
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_RPAREN] = ACTIONS(2114),
    [anon_sym_SEMI] = ACTIONS(2114),
    [anon_sym_COMMA] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_COLON] = ACTIONS(2114),
    [sym_comment] = ACTIONS(41),
  },
  [588] = {
    [sym__expression] = STATE(807),
    [sym_conditional_expression] = STATE(807),
    [sym_assignment_expression] = STATE(807),
    [sym_pointer_expression] = STATE(807),
    [sym_logical_expression] = STATE(807),
    [sym_bitwise_expression] = STATE(807),
    [sym_equality_expression] = STATE(807),
    [sym_relational_expression] = STATE(807),
    [sym_shift_expression] = STATE(807),
    [sym_math_expression] = STATE(807),
    [sym_cast_expression] = STATE(807),
    [sym_sizeof_expression] = STATE(807),
    [sym_subscript_expression] = STATE(807),
    [sym_call_expression] = STATE(807),
    [sym_field_expression] = STATE(807),
    [sym_compound_literal_expression] = STATE(807),
    [sym_parenthesized_expression] = STATE(807),
    [sym_char_literal] = STATE(807),
    [sym_concatenated_string] = STATE(807),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(2116),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(2118),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2120),
    [sym_false] = ACTIONS(2120),
    [sym_null] = ACTIONS(2120),
    [sym_identifier] = ACTIONS(2120),
    [sym_comment] = ACTIONS(41),
  },
  [589] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2116),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [590] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2122),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [591] = {
    [sym__expression] = STATE(809),
    [sym_conditional_expression] = STATE(809),
    [sym_assignment_expression] = STATE(809),
    [sym_pointer_expression] = STATE(809),
    [sym_logical_expression] = STATE(809),
    [sym_bitwise_expression] = STATE(809),
    [sym_equality_expression] = STATE(809),
    [sym_relational_expression] = STATE(809),
    [sym_shift_expression] = STATE(809),
    [sym_math_expression] = STATE(809),
    [sym_cast_expression] = STATE(809),
    [sym_sizeof_expression] = STATE(809),
    [sym_subscript_expression] = STATE(809),
    [sym_call_expression] = STATE(809),
    [sym_field_expression] = STATE(809),
    [sym_compound_literal_expression] = STATE(809),
    [sym_parenthesized_expression] = STATE(809),
    [sym_char_literal] = STATE(809),
    [sym_concatenated_string] = STATE(809),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2124),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_identifier] = ACTIONS(2126),
    [sym_comment] = ACTIONS(41),
  },
  [592] = {
    [aux_sym_field_declaration_repeat1] = STATE(592),
    [anon_sym_SEMI] = ACTIONS(2112),
    [anon_sym_COMMA] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2112),
    [sym_comment] = ACTIONS(41),
  },
  [593] = {
    [anon_sym_LPAREN] = ACTIONS(2131),
    [anon_sym_RPAREN] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2131),
    [sym_comment] = ACTIONS(41),
  },
  [594] = {
    [sym_parameter_list] = STATE(379),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_RPAREN] = ACTIONS(2133),
    [anon_sym_COMMA] = ACTIONS(2133),
    [anon_sym_LBRACK] = ACTIONS(913),
    [sym_comment] = ACTIONS(41),
  },
  [595] = {
    [sym_type_qualifier] = STATE(595),
    [aux_sym_type_definition_repeat1] = STATE(595),
    [anon_sym_LPAREN] = ACTIONS(928),
    [anon_sym_RPAREN] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(928),
    [anon_sym_const] = ACTIONS(2135),
    [anon_sym_restrict] = ACTIONS(2135),
    [anon_sym_volatile] = ACTIONS(2135),
    [anon_sym__Atomic] = ACTIONS(2135),
    [sym_comment] = ACTIONS(41),
  },
  [596] = {
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_RPAREN] = ACTIONS(2138),
    [anon_sym_COMMA] = ACTIONS(2138),
    [anon_sym_LBRACK] = ACTIONS(2138),
    [sym_comment] = ACTIONS(41),
  },
  [597] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2140),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [598] = {
    [sym__expression] = STATE(811),
    [sym_conditional_expression] = STATE(811),
    [sym_assignment_expression] = STATE(811),
    [sym_pointer_expression] = STATE(811),
    [sym_logical_expression] = STATE(811),
    [sym_bitwise_expression] = STATE(811),
    [sym_equality_expression] = STATE(811),
    [sym_relational_expression] = STATE(811),
    [sym_shift_expression] = STATE(811),
    [sym_math_expression] = STATE(811),
    [sym_cast_expression] = STATE(811),
    [sym_sizeof_expression] = STATE(811),
    [sym_subscript_expression] = STATE(811),
    [sym_call_expression] = STATE(811),
    [sym_field_expression] = STATE(811),
    [sym_compound_literal_expression] = STATE(811),
    [sym_parenthesized_expression] = STATE(811),
    [sym_char_literal] = STATE(811),
    [sym_concatenated_string] = STATE(811),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(2140),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2144),
    [sym_false] = ACTIONS(2144),
    [sym_null] = ACTIONS(2144),
    [sym_identifier] = ACTIONS(2144),
    [sym_comment] = ACTIONS(41),
  },
  [599] = {
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [sym_comment] = ACTIONS(41),
  },
  [600] = {
    [anon_sym_LPAREN] = ACTIONS(2148),
    [anon_sym_LBRACE] = ACTIONS(2148),
    [anon_sym_RPAREN] = ACTIONS(2148),
    [anon_sym_SEMI] = ACTIONS(2148),
    [anon_sym_COMMA] = ACTIONS(2148),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_EQ] = ACTIONS(2148),
    [anon_sym_COLON] = ACTIONS(2148),
    [sym_comment] = ACTIONS(41),
  },
  [601] = {
    [aux_sym_parameter_list_repeat1] = STATE(601),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2150),
    [sym_comment] = ACTIONS(41),
  },
  [602] = {
    [sym__declarator] = STATE(120),
    [sym__abstract_declarator] = STATE(373),
    [sym_pointer_declarator] = STATE(120),
    [sym_abstract_pointer_declarator] = STATE(373),
    [sym_function_declarator] = STATE(120),
    [sym_abstract_function_declarator] = STATE(373),
    [sym_array_declarator] = STATE(120),
    [sym_abstract_array_declarator] = STATE(373),
    [sym_type_qualifier] = STATE(812),
    [sym_parameter_list] = STATE(208),
    [aux_sym_type_definition_repeat1] = STATE(812),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(243),
    [sym_comment] = ACTIONS(41),
  },
  [603] = {
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(2157),
    [anon_sym_COMMA] = ACTIONS(88),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(88),
    [anon_sym_LBRACK] = ACTIONS(2157),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [604] = {
    [sym__declarator] = STATE(214),
    [sym__abstract_declarator] = STATE(594),
    [sym_pointer_declarator] = STATE(214),
    [sym_abstract_pointer_declarator] = STATE(594),
    [sym_function_declarator] = STATE(214),
    [sym_abstract_function_declarator] = STATE(594),
    [sym_array_declarator] = STATE(214),
    [sym_abstract_array_declarator] = STATE(594),
    [sym_type_qualifier] = STATE(813),
    [sym_parameter_list] = STATE(208),
    [aux_sym_type_definition_repeat1] = STATE(813),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_RPAREN] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1435),
    [anon_sym_STAR] = ACTIONS(940),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(525),
    [sym_comment] = ACTIONS(41),
  },
  [605] = {
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_RPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(637),
    [anon_sym_extern] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_static] = ACTIONS(314),
    [anon_sym_auto] = ACTIONS(314),
    [anon_sym_register] = ACTIONS(314),
    [anon_sym_inline] = ACTIONS(314),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [sym_identifier] = ACTIONS(320),
    [sym_comment] = ACTIONS(41),
  },
  [606] = {
    [sym_storage_class_specifier] = STATE(605),
    [sym_type_qualifier] = STATE(605),
    [aux_sym__declaration_specifiers_repeat1] = STATE(605),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(641),
    [sym_comment] = ACTIONS(41),
  },
  [607] = {
    [anon_sym_RPAREN] = ACTIONS(2160),
    [sym_comment] = ACTIONS(41),
  },
  [608] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(815),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [609] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(1660),
    [anon_sym_STAR_EQ] = ACTIONS(1660),
    [anon_sym_SLASH_EQ] = ACTIONS(1660),
    [anon_sym_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_PLUS_EQ] = ACTIONS(1660),
    [anon_sym_DASH_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_GT_EQ] = ACTIONS(1660),
    [anon_sym_AMP_EQ] = ACTIONS(1660),
    [anon_sym_CARET_EQ] = ACTIONS(1660),
    [anon_sym_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_CARET] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1660),
    [anon_sym_BANG_EQ] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [610] = {
    [anon_sym_LPAREN] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_SEMI] = ACTIONS(2162),
    [anon_sym_COMMA] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(2164),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_RBRACK] = ACTIONS(2162),
    [anon_sym_EQ] = ACTIONS(2164),
    [anon_sym_COLON] = ACTIONS(2162),
    [anon_sym_else] = ACTIONS(2162),
    [anon_sym_while] = ACTIONS(2162),
    [anon_sym_QMARK] = ACTIONS(2162),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_AMP] = ACTIONS(2164),
    [anon_sym_PIPE_PIPE] = ACTIONS(2162),
    [anon_sym_AMP_AMP] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2164),
    [anon_sym_CARET] = ACTIONS(2164),
    [anon_sym_EQ_EQ] = ACTIONS(2162),
    [anon_sym_BANG_EQ] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(2164),
    [anon_sym_GT] = ACTIONS(2164),
    [anon_sym_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT] = ACTIONS(2164),
    [anon_sym_GT_GT] = ACTIONS(2164),
    [anon_sym_PLUS] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2164),
    [anon_sym_SLASH] = ACTIONS(2164),
    [anon_sym_PERCENT] = ACTIONS(2164),
    [anon_sym_DASH_DASH] = ACTIONS(2162),
    [anon_sym_PLUS_PLUS] = ACTIONS(2162),
    [anon_sym_DOT] = ACTIONS(2162),
    [anon_sym_DASH_GT] = ACTIONS(2162),
    [sym_comment] = ACTIONS(41),
  },
  [611] = {
    [sym__expression] = STATE(816),
    [sym_comma_expression] = STATE(707),
    [sym_conditional_expression] = STATE(816),
    [sym_assignment_expression] = STATE(816),
    [sym_pointer_expression] = STATE(816),
    [sym_logical_expression] = STATE(816),
    [sym_bitwise_expression] = STATE(816),
    [sym_equality_expression] = STATE(816),
    [sym_relational_expression] = STATE(816),
    [sym_shift_expression] = STATE(816),
    [sym_math_expression] = STATE(816),
    [sym_cast_expression] = STATE(816),
    [sym_sizeof_expression] = STATE(816),
    [sym_subscript_expression] = STATE(816),
    [sym_call_expression] = STATE(816),
    [sym_field_expression] = STATE(816),
    [sym_compound_literal_expression] = STATE(816),
    [sym_parenthesized_expression] = STATE(816),
    [sym_char_literal] = STATE(816),
    [sym_concatenated_string] = STATE(816),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [sym_null] = ACTIONS(2168),
    [sym_identifier] = ACTIONS(2168),
    [sym_comment] = ACTIONS(41),
  },
  [612] = {
    [sym__expression] = STATE(708),
    [sym_conditional_expression] = STATE(708),
    [sym_assignment_expression] = STATE(708),
    [sym_pointer_expression] = STATE(708),
    [sym_logical_expression] = STATE(708),
    [sym_bitwise_expression] = STATE(708),
    [sym_equality_expression] = STATE(708),
    [sym_relational_expression] = STATE(708),
    [sym_shift_expression] = STATE(708),
    [sym_math_expression] = STATE(708),
    [sym_cast_expression] = STATE(708),
    [sym_sizeof_expression] = STATE(708),
    [sym_subscript_expression] = STATE(708),
    [sym_call_expression] = STATE(708),
    [sym_field_expression] = STATE(708),
    [sym_compound_literal_expression] = STATE(708),
    [sym_parenthesized_expression] = STATE(708),
    [sym_char_literal] = STATE(708),
    [sym_concatenated_string] = STATE(708),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(41),
  },
  [613] = {
    [sym__expression] = STATE(817),
    [sym_conditional_expression] = STATE(817),
    [sym_assignment_expression] = STATE(817),
    [sym_pointer_expression] = STATE(817),
    [sym_logical_expression] = STATE(817),
    [sym_bitwise_expression] = STATE(817),
    [sym_equality_expression] = STATE(817),
    [sym_relational_expression] = STATE(817),
    [sym_shift_expression] = STATE(817),
    [sym_math_expression] = STATE(817),
    [sym_cast_expression] = STATE(817),
    [sym_sizeof_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_call_expression] = STATE(817),
    [sym_field_expression] = STATE(817),
    [sym_compound_literal_expression] = STATE(817),
    [sym_parenthesized_expression] = STATE(817),
    [sym_char_literal] = STATE(817),
    [sym_concatenated_string] = STATE(817),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2170),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_identifier] = ACTIONS(2172),
    [sym_comment] = ACTIONS(41),
  },
  [614] = {
    [sym__expression] = STATE(818),
    [sym_conditional_expression] = STATE(818),
    [sym_assignment_expression] = STATE(818),
    [sym_pointer_expression] = STATE(818),
    [sym_logical_expression] = STATE(818),
    [sym_bitwise_expression] = STATE(818),
    [sym_equality_expression] = STATE(818),
    [sym_relational_expression] = STATE(818),
    [sym_shift_expression] = STATE(818),
    [sym_math_expression] = STATE(818),
    [sym_cast_expression] = STATE(818),
    [sym_sizeof_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_call_expression] = STATE(818),
    [sym_field_expression] = STATE(818),
    [sym_compound_literal_expression] = STATE(818),
    [sym_parenthesized_expression] = STATE(818),
    [sym_char_literal] = STATE(818),
    [sym_concatenated_string] = STATE(818),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [sym_null] = ACTIONS(2176),
    [sym_identifier] = ACTIONS(2176),
    [sym_comment] = ACTIONS(41),
  },
  [615] = {
    [sym__expression] = STATE(819),
    [sym_conditional_expression] = STATE(819),
    [sym_assignment_expression] = STATE(819),
    [sym_pointer_expression] = STATE(819),
    [sym_logical_expression] = STATE(819),
    [sym_bitwise_expression] = STATE(819),
    [sym_equality_expression] = STATE(819),
    [sym_relational_expression] = STATE(819),
    [sym_shift_expression] = STATE(819),
    [sym_math_expression] = STATE(819),
    [sym_cast_expression] = STATE(819),
    [sym_sizeof_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_call_expression] = STATE(819),
    [sym_field_expression] = STATE(819),
    [sym_compound_literal_expression] = STATE(819),
    [sym_parenthesized_expression] = STATE(819),
    [sym_char_literal] = STATE(819),
    [sym_concatenated_string] = STATE(819),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [sym_null] = ACTIONS(2180),
    [sym_identifier] = ACTIONS(2180),
    [sym_comment] = ACTIONS(41),
  },
  [616] = {
    [sym__expression] = STATE(820),
    [sym_conditional_expression] = STATE(820),
    [sym_assignment_expression] = STATE(820),
    [sym_pointer_expression] = STATE(820),
    [sym_logical_expression] = STATE(820),
    [sym_bitwise_expression] = STATE(820),
    [sym_equality_expression] = STATE(820),
    [sym_relational_expression] = STATE(820),
    [sym_shift_expression] = STATE(820),
    [sym_math_expression] = STATE(820),
    [sym_cast_expression] = STATE(820),
    [sym_sizeof_expression] = STATE(820),
    [sym_subscript_expression] = STATE(820),
    [sym_call_expression] = STATE(820),
    [sym_field_expression] = STATE(820),
    [sym_compound_literal_expression] = STATE(820),
    [sym_parenthesized_expression] = STATE(820),
    [sym_char_literal] = STATE(820),
    [sym_concatenated_string] = STATE(820),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2184),
    [sym_false] = ACTIONS(2184),
    [sym_null] = ACTIONS(2184),
    [sym_identifier] = ACTIONS(2184),
    [sym_comment] = ACTIONS(41),
  },
  [617] = {
    [sym__expression] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(821),
    [sym_logical_expression] = STATE(821),
    [sym_bitwise_expression] = STATE(821),
    [sym_equality_expression] = STATE(821),
    [sym_relational_expression] = STATE(821),
    [sym_shift_expression] = STATE(821),
    [sym_math_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_subscript_expression] = STATE(821),
    [sym_call_expression] = STATE(821),
    [sym_field_expression] = STATE(821),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(821),
    [sym_char_literal] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_identifier] = ACTIONS(2188),
    [sym_comment] = ACTIONS(41),
  },
  [618] = {
    [sym__expression] = STATE(822),
    [sym_conditional_expression] = STATE(822),
    [sym_assignment_expression] = STATE(822),
    [sym_pointer_expression] = STATE(822),
    [sym_logical_expression] = STATE(822),
    [sym_bitwise_expression] = STATE(822),
    [sym_equality_expression] = STATE(822),
    [sym_relational_expression] = STATE(822),
    [sym_shift_expression] = STATE(822),
    [sym_math_expression] = STATE(822),
    [sym_cast_expression] = STATE(822),
    [sym_sizeof_expression] = STATE(822),
    [sym_subscript_expression] = STATE(822),
    [sym_call_expression] = STATE(822),
    [sym_field_expression] = STATE(822),
    [sym_compound_literal_expression] = STATE(822),
    [sym_parenthesized_expression] = STATE(822),
    [sym_char_literal] = STATE(822),
    [sym_concatenated_string] = STATE(822),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_identifier] = ACTIONS(2192),
    [sym_comment] = ACTIONS(41),
  },
  [619] = {
    [sym__expression] = STATE(823),
    [sym_conditional_expression] = STATE(823),
    [sym_assignment_expression] = STATE(823),
    [sym_pointer_expression] = STATE(823),
    [sym_logical_expression] = STATE(823),
    [sym_bitwise_expression] = STATE(823),
    [sym_equality_expression] = STATE(823),
    [sym_relational_expression] = STATE(823),
    [sym_shift_expression] = STATE(823),
    [sym_math_expression] = STATE(823),
    [sym_cast_expression] = STATE(823),
    [sym_sizeof_expression] = STATE(823),
    [sym_subscript_expression] = STATE(823),
    [sym_call_expression] = STATE(823),
    [sym_field_expression] = STATE(823),
    [sym_compound_literal_expression] = STATE(823),
    [sym_parenthesized_expression] = STATE(823),
    [sym_char_literal] = STATE(823),
    [sym_concatenated_string] = STATE(823),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2194),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_identifier] = ACTIONS(2196),
    [sym_comment] = ACTIONS(41),
  },
  [620] = {
    [sym__expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_assignment_expression] = STATE(824),
    [sym_pointer_expression] = STATE(824),
    [sym_logical_expression] = STATE(824),
    [sym_bitwise_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_math_expression] = STATE(824),
    [sym_cast_expression] = STATE(824),
    [sym_sizeof_expression] = STATE(824),
    [sym_subscript_expression] = STATE(824),
    [sym_call_expression] = STATE(824),
    [sym_field_expression] = STATE(824),
    [sym_compound_literal_expression] = STATE(824),
    [sym_parenthesized_expression] = STATE(824),
    [sym_char_literal] = STATE(824),
    [sym_concatenated_string] = STATE(824),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2198),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_identifier] = ACTIONS(2200),
    [sym_comment] = ACTIONS(41),
  },
  [621] = {
    [sym__expression] = STATE(825),
    [sym_conditional_expression] = STATE(825),
    [sym_assignment_expression] = STATE(825),
    [sym_pointer_expression] = STATE(825),
    [sym_logical_expression] = STATE(825),
    [sym_bitwise_expression] = STATE(825),
    [sym_equality_expression] = STATE(825),
    [sym_relational_expression] = STATE(825),
    [sym_shift_expression] = STATE(825),
    [sym_math_expression] = STATE(825),
    [sym_cast_expression] = STATE(825),
    [sym_sizeof_expression] = STATE(825),
    [sym_subscript_expression] = STATE(825),
    [sym_call_expression] = STATE(825),
    [sym_field_expression] = STATE(825),
    [sym_compound_literal_expression] = STATE(825),
    [sym_parenthesized_expression] = STATE(825),
    [sym_char_literal] = STATE(825),
    [sym_concatenated_string] = STATE(825),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2202),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_identifier] = ACTIONS(2204),
    [sym_comment] = ACTIONS(41),
  },
  [622] = {
    [sym__expression] = STATE(826),
    [sym_conditional_expression] = STATE(826),
    [sym_assignment_expression] = STATE(826),
    [sym_pointer_expression] = STATE(826),
    [sym_logical_expression] = STATE(826),
    [sym_bitwise_expression] = STATE(826),
    [sym_equality_expression] = STATE(826),
    [sym_relational_expression] = STATE(826),
    [sym_shift_expression] = STATE(826),
    [sym_math_expression] = STATE(826),
    [sym_cast_expression] = STATE(826),
    [sym_sizeof_expression] = STATE(826),
    [sym_subscript_expression] = STATE(826),
    [sym_call_expression] = STATE(826),
    [sym_field_expression] = STATE(826),
    [sym_compound_literal_expression] = STATE(826),
    [sym_parenthesized_expression] = STATE(826),
    [sym_char_literal] = STATE(826),
    [sym_concatenated_string] = STATE(826),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2206),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2208),
    [sym_false] = ACTIONS(2208),
    [sym_null] = ACTIONS(2208),
    [sym_identifier] = ACTIONS(2208),
    [sym_comment] = ACTIONS(41),
  },
  [623] = {
    [sym__expression] = STATE(827),
    [sym_conditional_expression] = STATE(827),
    [sym_assignment_expression] = STATE(827),
    [sym_pointer_expression] = STATE(827),
    [sym_logical_expression] = STATE(827),
    [sym_bitwise_expression] = STATE(827),
    [sym_equality_expression] = STATE(827),
    [sym_relational_expression] = STATE(827),
    [sym_shift_expression] = STATE(827),
    [sym_math_expression] = STATE(827),
    [sym_cast_expression] = STATE(827),
    [sym_sizeof_expression] = STATE(827),
    [sym_subscript_expression] = STATE(827),
    [sym_call_expression] = STATE(827),
    [sym_field_expression] = STATE(827),
    [sym_compound_literal_expression] = STATE(827),
    [sym_parenthesized_expression] = STATE(827),
    [sym_char_literal] = STATE(827),
    [sym_concatenated_string] = STATE(827),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2210),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_identifier] = ACTIONS(2212),
    [sym_comment] = ACTIONS(41),
  },
  [624] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [625] = {
    [sym_string_literal] = STATE(830),
    [aux_sym_concatenated_string_repeat1] = STATE(830),
    [anon_sym_LPAREN] = ACTIONS(1738),
    [anon_sym_RPAREN] = ACTIONS(1738),
    [anon_sym_COMMA] = ACTIONS(1738),
    [anon_sym_STAR] = ACTIONS(1740),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_EQ] = ACTIONS(1740),
    [anon_sym_QMARK] = ACTIONS(1738),
    [anon_sym_STAR_EQ] = ACTIONS(1738),
    [anon_sym_SLASH_EQ] = ACTIONS(1738),
    [anon_sym_PERCENT_EQ] = ACTIONS(1738),
    [anon_sym_PLUS_EQ] = ACTIONS(1738),
    [anon_sym_DASH_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_GT_EQ] = ACTIONS(1738),
    [anon_sym_AMP_EQ] = ACTIONS(1738),
    [anon_sym_CARET_EQ] = ACTIONS(1738),
    [anon_sym_PIPE_EQ] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1740),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE] = ACTIONS(1740),
    [anon_sym_CARET] = ACTIONS(1740),
    [anon_sym_EQ_EQ] = ACTIONS(1738),
    [anon_sym_BANG_EQ] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1740),
    [anon_sym_GT] = ACTIONS(1740),
    [anon_sym_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT] = ACTIONS(1740),
    [anon_sym_GT_GT] = ACTIONS(1740),
    [anon_sym_PLUS] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1740),
    [anon_sym_SLASH] = ACTIONS(1740),
    [anon_sym_PERCENT] = ACTIONS(1740),
    [anon_sym_DASH_DASH] = ACTIONS(1738),
    [anon_sym_PLUS_PLUS] = ACTIONS(1738),
    [anon_sym_DOT] = ACTIONS(1738),
    [anon_sym_DASH_GT] = ACTIONS(1738),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [626] = {
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_RBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(343),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(345),
    [sym_preproc_directive] = ACTIONS(345),
    [anon_sym_typedef] = ACTIONS(345),
    [anon_sym_extern] = ACTIONS(345),
    [anon_sym_STAR] = ACTIONS(343),
    [anon_sym_static] = ACTIONS(345),
    [anon_sym_auto] = ACTIONS(345),
    [anon_sym_register] = ACTIONS(345),
    [anon_sym_inline] = ACTIONS(345),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_restrict] = ACTIONS(345),
    [anon_sym_volatile] = ACTIONS(345),
    [anon_sym__Atomic] = ACTIONS(345),
    [anon_sym_unsigned] = ACTIONS(345),
    [anon_sym_long] = ACTIONS(345),
    [anon_sym_short] = ACTIONS(345),
    [sym_primitive_type] = ACTIONS(345),
    [anon_sym_enum] = ACTIONS(345),
    [anon_sym_struct] = ACTIONS(345),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_switch] = ACTIONS(345),
    [anon_sym_case] = ACTIONS(345),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_do] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(345),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_continue] = ACTIONS(345),
    [anon_sym_goto] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(343),
    [anon_sym_BANG] = ACTIONS(343),
    [anon_sym_TILDE] = ACTIONS(343),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_DASH_DASH] = ACTIONS(343),
    [anon_sym_PLUS_PLUS] = ACTIONS(343),
    [anon_sym_sizeof] = ACTIONS(345),
    [sym_number_literal] = ACTIONS(343),
    [anon_sym_SQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(343),
    [sym_true] = ACTIONS(345),
    [sym_false] = ACTIONS(345),
    [sym_null] = ACTIONS(345),
    [sym_identifier] = ACTIONS(345),
    [sym_comment] = ACTIONS(41),
  },
  [627] = {
    [aux_sym_string_literal_repeat1] = STATE(136),
    [anon_sym_DQUOTE] = ACTIONS(2218),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_BSLASHn_RBRACK_SLASH] = ACTIONS(349),
    [sym_escape_sequence] = ACTIONS(349),
    [sym_comment] = ACTIONS(55),
  },
  [628] = {
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(972),
    [anon_sym_SEMI] = ACTIONS(972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(974),
    [sym_preproc_directive] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(974),
    [anon_sym_extern] = ACTIONS(974),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_static] = ACTIONS(974),
    [anon_sym_auto] = ACTIONS(974),
    [anon_sym_register] = ACTIONS(974),
    [anon_sym_inline] = ACTIONS(974),
    [anon_sym_const] = ACTIONS(974),
    [anon_sym_restrict] = ACTIONS(974),
    [anon_sym_volatile] = ACTIONS(974),
    [anon_sym__Atomic] = ACTIONS(974),
    [anon_sym_unsigned] = ACTIONS(974),
    [anon_sym_long] = ACTIONS(974),
    [anon_sym_short] = ACTIONS(974),
    [sym_primitive_type] = ACTIONS(974),
    [anon_sym_enum] = ACTIONS(974),
    [anon_sym_struct] = ACTIONS(974),
    [anon_sym_union] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(974),
    [anon_sym_else] = ACTIONS(974),
    [anon_sym_switch] = ACTIONS(974),
    [anon_sym_case] = ACTIONS(974),
    [anon_sym_default] = ACTIONS(974),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_do] = ACTIONS(974),
    [anon_sym_for] = ACTIONS(974),
    [anon_sym_return] = ACTIONS(974),
    [anon_sym_break] = ACTIONS(974),
    [anon_sym_continue] = ACTIONS(974),
    [anon_sym_goto] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(972),
    [anon_sym_BANG] = ACTIONS(972),
    [anon_sym_TILDE] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(974),
    [anon_sym_DASH_DASH] = ACTIONS(972),
    [anon_sym_PLUS_PLUS] = ACTIONS(972),
    [anon_sym_sizeof] = ACTIONS(974),
    [sym_number_literal] = ACTIONS(972),
    [anon_sym_SQUOTE] = ACTIONS(972),
    [anon_sym_DQUOTE] = ACTIONS(972),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [sym_null] = ACTIONS(974),
    [sym_identifier] = ACTIONS(974),
    [sym_comment] = ACTIONS(41),
  },
  [629] = {
    [sym_preproc_arg] = ACTIONS(2220),
    [sym_comment] = ACTIONS(55),
  },
  [630] = {
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_auto] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2222),
    [anon_sym_PLUS_PLUS] = ACTIONS(2222),
    [anon_sym_sizeof] = ACTIONS(2224),
    [sym_number_literal] = ACTIONS(2222),
    [anon_sym_SQUOTE] = ACTIONS(2222),
    [anon_sym_DQUOTE] = ACTIONS(2222),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_identifier] = ACTIONS(2224),
    [sym_comment] = ACTIONS(41),
  },
  [631] = {
    [sym_identifier] = ACTIONS(2226),
    [sym_comment] = ACTIONS(41),
  },
  [632] = {
    [sym_preproc_include] = STATE(852),
    [sym_preproc_def] = STATE(852),
    [sym_preproc_function_def] = STATE(852),
    [sym_preproc_call] = STATE(852),
    [sym_preproc_if_in_compound_statement] = STATE(852),
    [sym_preproc_ifdef_in_compound_statement] = STATE(852),
    [sym_declaration] = STATE(852),
    [sym_type_definition] = STATE(852),
    [sym__declaration_specifiers] = STATE(849),
    [sym_compound_statement] = STATE(852),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(852),
    [sym_expression_statement] = STATE(852),
    [sym_if_statement] = STATE(852),
    [sym_switch_statement] = STATE(852),
    [sym_case_statement] = STATE(852),
    [sym_while_statement] = STATE(852),
    [sym_do_statement] = STATE(852),
    [sym_for_statement] = STATE(852),
    [sym_return_statement] = STATE(852),
    [sym_break_statement] = STATE(852),
    [sym_continue_statement] = STATE(852),
    [sym_goto_statement] = STATE(852),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(852),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(852),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2230),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2232),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2234),
    [sym_preproc_directive] = ACTIONS(395),
    [anon_sym_typedef] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(41),
  },
  [633] = {
    [sym_preproc_arg] = ACTIONS(2264),
    [sym_comment] = ACTIONS(55),
  },
  [634] = {
    [sym_parenthesized_expression] = STATE(854),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [635] = {
    [sym_parenthesized_expression] = STATE(855),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [636] = {
    [sym__expression] = STATE(856),
    [sym_conditional_expression] = STATE(856),
    [sym_assignment_expression] = STATE(856),
    [sym_pointer_expression] = STATE(856),
    [sym_logical_expression] = STATE(856),
    [sym_bitwise_expression] = STATE(856),
    [sym_equality_expression] = STATE(856),
    [sym_relational_expression] = STATE(856),
    [sym_shift_expression] = STATE(856),
    [sym_math_expression] = STATE(856),
    [sym_cast_expression] = STATE(856),
    [sym_sizeof_expression] = STATE(856),
    [sym_subscript_expression] = STATE(856),
    [sym_call_expression] = STATE(856),
    [sym_field_expression] = STATE(856),
    [sym_compound_literal_expression] = STATE(856),
    [sym_parenthesized_expression] = STATE(856),
    [sym_char_literal] = STATE(856),
    [sym_concatenated_string] = STATE(856),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [sym_null] = ACTIONS(2268),
    [sym_identifier] = ACTIONS(2268),
    [sym_comment] = ACTIONS(41),
  },
  [637] = {
    [anon_sym_COLON] = ACTIONS(2270),
    [sym_comment] = ACTIONS(41),
  },
  [638] = {
    [sym_parenthesized_expression] = STATE(858),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [639] = {
    [sym_compound_statement] = STATE(859),
    [sym_labeled_statement] = STATE(859),
    [sym_expression_statement] = STATE(859),
    [sym_if_statement] = STATE(859),
    [sym_switch_statement] = STATE(859),
    [sym_case_statement] = STATE(859),
    [sym_while_statement] = STATE(859),
    [sym_do_statement] = STATE(859),
    [sym_for_statement] = STATE(859),
    [sym_return_statement] = STATE(859),
    [sym_break_statement] = STATE(859),
    [sym_continue_statement] = STATE(859),
    [sym_goto_statement] = STATE(859),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [640] = {
    [anon_sym_LPAREN] = ACTIONS(2272),
    [sym_comment] = ACTIONS(41),
  },
  [641] = {
    [sym__expression] = STATE(862),
    [sym_conditional_expression] = STATE(862),
    [sym_assignment_expression] = STATE(862),
    [sym_pointer_expression] = STATE(862),
    [sym_logical_expression] = STATE(862),
    [sym_bitwise_expression] = STATE(862),
    [sym_equality_expression] = STATE(862),
    [sym_relational_expression] = STATE(862),
    [sym_shift_expression] = STATE(862),
    [sym_math_expression] = STATE(862),
    [sym_cast_expression] = STATE(862),
    [sym_sizeof_expression] = STATE(862),
    [sym_subscript_expression] = STATE(862),
    [sym_call_expression] = STATE(862),
    [sym_field_expression] = STATE(862),
    [sym_compound_literal_expression] = STATE(862),
    [sym_parenthesized_expression] = STATE(862),
    [sym_char_literal] = STATE(862),
    [sym_concatenated_string] = STATE(862),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2278),
    [sym_false] = ACTIONS(2278),
    [sym_null] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2278),
    [sym_comment] = ACTIONS(41),
  },
  [642] = {
    [anon_sym_SEMI] = ACTIONS(2280),
    [sym_comment] = ACTIONS(41),
  },
  [643] = {
    [anon_sym_SEMI] = ACTIONS(2282),
    [sym_comment] = ACTIONS(41),
  },
  [644] = {
    [sym_identifier] = ACTIONS(2284),
    [sym_comment] = ACTIONS(41),
  },
  [645] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1064),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(2286),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [646] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2288),
    [sym_comment] = ACTIONS(41),
  },
  [647] = {
    [sym__declarator] = STATE(868),
    [sym_pointer_declarator] = STATE(868),
    [sym_function_declarator] = STATE(868),
    [sym_array_declarator] = STATE(868),
    [sym_init_declarator] = STATE(169),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(593),
    [sym_identifier] = ACTIONS(2290),
    [sym_comment] = ACTIONS(41),
  },
  [648] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(1082),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1088),
    [anon_sym_QMARK] = ACTIONS(1090),
    [anon_sym_STAR_EQ] = ACTIONS(1092),
    [anon_sym_SLASH_EQ] = ACTIONS(1092),
    [anon_sym_PERCENT_EQ] = ACTIONS(1092),
    [anon_sym_PLUS_EQ] = ACTIONS(1092),
    [anon_sym_DASH_EQ] = ACTIONS(1092),
    [anon_sym_LT_LT_EQ] = ACTIONS(1092),
    [anon_sym_GT_GT_EQ] = ACTIONS(1092),
    [anon_sym_AMP_EQ] = ACTIONS(1092),
    [anon_sym_CARET_EQ] = ACTIONS(1092),
    [anon_sym_PIPE_EQ] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [649] = {
    [anon_sym_SEMI] = ACTIONS(2292),
    [sym_comment] = ACTIONS(41),
  },
  [650] = {
    [sym_preproc_include] = STATE(871),
    [sym_preproc_def] = STATE(871),
    [sym_preproc_function_def] = STATE(871),
    [sym_preproc_call] = STATE(871),
    [sym_preproc_if_in_compound_statement] = STATE(871),
    [sym_preproc_ifdef_in_compound_statement] = STATE(871),
    [sym_preproc_else_in_compound_statement] = STATE(870),
    [sym_preproc_elif_in_compound_statement] = STATE(870),
    [sym_declaration] = STATE(871),
    [sym_type_definition] = STATE(871),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(871),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(871),
    [sym_expression_statement] = STATE(871),
    [sym_if_statement] = STATE(871),
    [sym_switch_statement] = STATE(871),
    [sym_case_statement] = STATE(871),
    [sym_while_statement] = STATE(871),
    [sym_do_statement] = STATE(871),
    [sym_for_statement] = STATE(871),
    [sym_return_statement] = STATE(871),
    [sym_break_statement] = STATE(871),
    [sym_continue_statement] = STATE(871),
    [sym_goto_statement] = STATE(871),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(871),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(871),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [651] = {
    [anon_sym_LPAREN] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2296),
    [anon_sym_RBRACE] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2296),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2298),
    [sym_preproc_directive] = ACTIONS(2298),
    [anon_sym_typedef] = ACTIONS(2298),
    [anon_sym_extern] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_auto] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2298),
    [anon_sym_inline] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym_unsigned] = ACTIONS(2298),
    [anon_sym_long] = ACTIONS(2298),
    [anon_sym_short] = ACTIONS(2298),
    [sym_primitive_type] = ACTIONS(2298),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_struct] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2298),
    [anon_sym_if] = ACTIONS(2298),
    [anon_sym_switch] = ACTIONS(2298),
    [anon_sym_case] = ACTIONS(2298),
    [anon_sym_default] = ACTIONS(2298),
    [anon_sym_while] = ACTIONS(2298),
    [anon_sym_do] = ACTIONS(2298),
    [anon_sym_for] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2298),
    [anon_sym_break] = ACTIONS(2298),
    [anon_sym_continue] = ACTIONS(2298),
    [anon_sym_goto] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2296),
    [anon_sym_PLUS_PLUS] = ACTIONS(2296),
    [anon_sym_sizeof] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2296),
    [anon_sym_SQUOTE] = ACTIONS(2296),
    [anon_sym_DQUOTE] = ACTIONS(2296),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [sym_null] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2298),
    [sym_comment] = ACTIONS(41),
  },
  [652] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2300),
    [sym_comment] = ACTIONS(41),
  },
  [653] = {
    [sym_preproc_include] = STATE(871),
    [sym_preproc_def] = STATE(871),
    [sym_preproc_function_def] = STATE(871),
    [sym_preproc_call] = STATE(871),
    [sym_preproc_if_in_compound_statement] = STATE(871),
    [sym_preproc_ifdef_in_compound_statement] = STATE(871),
    [sym_preproc_else_in_compound_statement] = STATE(873),
    [sym_preproc_elif_in_compound_statement] = STATE(873),
    [sym_declaration] = STATE(871),
    [sym_type_definition] = STATE(871),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(871),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(871),
    [sym_expression_statement] = STATE(871),
    [sym_if_statement] = STATE(871),
    [sym_switch_statement] = STATE(871),
    [sym_case_statement] = STATE(871),
    [sym_while_statement] = STATE(871),
    [sym_do_statement] = STATE(871),
    [sym_for_statement] = STATE(871),
    [sym_return_statement] = STATE(871),
    [sym_break_statement] = STATE(871),
    [sym_continue_statement] = STATE(871),
    [sym_goto_statement] = STATE(871),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(871),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(871),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2302),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [654] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2304),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [655] = {
    [anon_sym_RPAREN] = ACTIONS(2304),
    [sym_comment] = ACTIONS(41),
  },
  [656] = {
    [sym_parenthesized_expression] = STATE(875),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [657] = {
    [sym_parenthesized_expression] = STATE(876),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [658] = {
    [sym__expression] = STATE(877),
    [sym_conditional_expression] = STATE(877),
    [sym_assignment_expression] = STATE(877),
    [sym_pointer_expression] = STATE(877),
    [sym_logical_expression] = STATE(877),
    [sym_bitwise_expression] = STATE(877),
    [sym_equality_expression] = STATE(877),
    [sym_relational_expression] = STATE(877),
    [sym_shift_expression] = STATE(877),
    [sym_math_expression] = STATE(877),
    [sym_cast_expression] = STATE(877),
    [sym_sizeof_expression] = STATE(877),
    [sym_subscript_expression] = STATE(877),
    [sym_call_expression] = STATE(877),
    [sym_field_expression] = STATE(877),
    [sym_compound_literal_expression] = STATE(877),
    [sym_parenthesized_expression] = STATE(877),
    [sym_char_literal] = STATE(877),
    [sym_concatenated_string] = STATE(877),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_identifier] = ACTIONS(2308),
    [sym_comment] = ACTIONS(41),
  },
  [659] = {
    [anon_sym_COLON] = ACTIONS(2310),
    [sym_comment] = ACTIONS(41),
  },
  [660] = {
    [sym_parenthesized_expression] = STATE(879),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [661] = {
    [anon_sym_LPAREN] = ACTIONS(2312),
    [sym_comment] = ACTIONS(41),
  },
  [662] = {
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(2314),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(41),
  },
  [663] = {
    [anon_sym_LPAREN] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_RBRACE] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2316),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2318),
    [sym_preproc_directive] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_auto] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2320),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2318),
    [sym_comment] = ACTIONS(41),
  },
  [664] = {
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(1074),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(41),
  },
  [665] = {
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2322),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2324),
    [sym_preproc_directive] = ACTIONS(2324),
    [anon_sym_typedef] = ACTIONS(2324),
    [anon_sym_extern] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_auto] = ACTIONS(2324),
    [anon_sym_register] = ACTIONS(2324),
    [anon_sym_inline] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_restrict] = ACTIONS(2324),
    [anon_sym_volatile] = ACTIONS(2324),
    [anon_sym__Atomic] = ACTIONS(2324),
    [anon_sym_unsigned] = ACTIONS(2324),
    [anon_sym_long] = ACTIONS(2324),
    [anon_sym_short] = ACTIONS(2324),
    [sym_primitive_type] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
    [anon_sym_struct] = ACTIONS(2324),
    [anon_sym_union] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_else] = ACTIONS(2324),
    [anon_sym_switch] = ACTIONS(2324),
    [anon_sym_case] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_do] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_goto] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_TILDE] = ACTIONS(2322),
    [anon_sym_PLUS] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2324),
    [anon_sym_DASH_DASH] = ACTIONS(2322),
    [anon_sym_PLUS_PLUS] = ACTIONS(2322),
    [anon_sym_sizeof] = ACTIONS(2324),
    [sym_number_literal] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2322),
    [anon_sym_DQUOTE] = ACTIONS(2322),
    [sym_true] = ACTIONS(2324),
    [sym_false] = ACTIONS(2324),
    [sym_null] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2324),
    [sym_comment] = ACTIONS(41),
  },
  [666] = {
    [anon_sym_RPAREN] = ACTIONS(2326),
    [sym_comment] = ACTIONS(41),
  },
  [667] = {
    [sym_type_qualifier] = STATE(116),
    [sym__type_specifier] = STATE(114),
    [sym_sized_type_specifier] = STATE(114),
    [sym_enum_specifier] = STATE(114),
    [sym_struct_specifier] = STATE(114),
    [sym_union_specifier] = STATE(114),
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_type_descriptor] = STATE(884),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [sym_macro_type_specifier] = STATE(114),
    [aux_sym_type_definition_repeat1] = STATE(116),
    [aux_sym_sized_type_specifier_repeat1] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(231),
    [anon_sym_long] = ACTIONS(231),
    [anon_sym_short] = ACTIONS(231),
    [sym_primitive_type] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(41),
  },
  [668] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1662),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_QMARK] = ACTIONS(1660),
    [anon_sym_STAR_EQ] = ACTIONS(1660),
    [anon_sym_SLASH_EQ] = ACTIONS(1660),
    [anon_sym_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_PLUS_EQ] = ACTIONS(1660),
    [anon_sym_DASH_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_GT_EQ] = ACTIONS(1660),
    [anon_sym_AMP_EQ] = ACTIONS(1660),
    [anon_sym_CARET_EQ] = ACTIONS(1660),
    [anon_sym_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_CARET] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1660),
    [anon_sym_BANG_EQ] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_LT_EQ] = ACTIONS(1660),
    [anon_sym_GT_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [669] = {
    [sym__expression] = STATE(708),
    [sym_conditional_expression] = STATE(708),
    [sym_assignment_expression] = STATE(708),
    [sym_pointer_expression] = STATE(708),
    [sym_logical_expression] = STATE(708),
    [sym_bitwise_expression] = STATE(708),
    [sym_equality_expression] = STATE(708),
    [sym_relational_expression] = STATE(708),
    [sym_shift_expression] = STATE(708),
    [sym_math_expression] = STATE(708),
    [sym_cast_expression] = STATE(708),
    [sym_sizeof_expression] = STATE(708),
    [sym_subscript_expression] = STATE(708),
    [sym_call_expression] = STATE(708),
    [sym_field_expression] = STATE(708),
    [sym_compound_literal_expression] = STATE(708),
    [sym_parenthesized_expression] = STATE(708),
    [sym_char_literal] = STATE(708),
    [sym_concatenated_string] = STATE(708),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1682),
    [sym_comment] = ACTIONS(41),
  },
  [670] = {
    [sym__expression] = STATE(885),
    [sym_conditional_expression] = STATE(885),
    [sym_assignment_expression] = STATE(885),
    [sym_pointer_expression] = STATE(885),
    [sym_logical_expression] = STATE(885),
    [sym_bitwise_expression] = STATE(885),
    [sym_equality_expression] = STATE(885),
    [sym_relational_expression] = STATE(885),
    [sym_shift_expression] = STATE(885),
    [sym_math_expression] = STATE(885),
    [sym_cast_expression] = STATE(885),
    [sym_sizeof_expression] = STATE(885),
    [sym_subscript_expression] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_field_expression] = STATE(885),
    [sym_compound_literal_expression] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym_char_literal] = STATE(885),
    [sym_concatenated_string] = STATE(885),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [sym_null] = ACTIONS(2330),
    [sym_identifier] = ACTIONS(2330),
    [sym_comment] = ACTIONS(41),
  },
  [671] = {
    [sym_declaration] = STATE(886),
    [sym_type_definition] = STATE(886),
    [sym__declaration_specifiers] = STATE(685),
    [sym_compound_statement] = STATE(886),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(886),
    [sym_expression_statement] = STATE(886),
    [sym_if_statement] = STATE(886),
    [sym_switch_statement] = STATE(886),
    [sym_case_statement] = STATE(886),
    [sym_while_statement] = STATE(886),
    [sym_do_statement] = STATE(886),
    [sym_for_statement] = STATE(886),
    [sym_return_statement] = STATE(886),
    [sym_break_statement] = STATE(886),
    [sym_continue_statement] = STATE(886),
    [sym_goto_statement] = STATE(886),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1610),
    [sym_comment] = ACTIONS(41),
  },
  [672] = {
    [sym__expression] = STATE(887),
    [sym_conditional_expression] = STATE(887),
    [sym_assignment_expression] = STATE(887),
    [sym_pointer_expression] = STATE(887),
    [sym_logical_expression] = STATE(887),
    [sym_bitwise_expression] = STATE(887),
    [sym_equality_expression] = STATE(887),
    [sym_relational_expression] = STATE(887),
    [sym_shift_expression] = STATE(887),
    [sym_math_expression] = STATE(887),
    [sym_cast_expression] = STATE(887),
    [sym_sizeof_expression] = STATE(887),
    [sym_subscript_expression] = STATE(887),
    [sym_call_expression] = STATE(887),
    [sym_field_expression] = STATE(887),
    [sym_compound_literal_expression] = STATE(887),
    [sym_parenthesized_expression] = STATE(887),
    [sym_char_literal] = STATE(887),
    [sym_concatenated_string] = STATE(887),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [sym_null] = ACTIONS(2334),
    [sym_identifier] = ACTIONS(2334),
    [sym_comment] = ACTIONS(41),
  },
  [673] = {
    [sym__expression] = STATE(888),
    [sym_conditional_expression] = STATE(888),
    [sym_assignment_expression] = STATE(888),
    [sym_pointer_expression] = STATE(888),
    [sym_logical_expression] = STATE(888),
    [sym_bitwise_expression] = STATE(888),
    [sym_equality_expression] = STATE(888),
    [sym_relational_expression] = STATE(888),
    [sym_shift_expression] = STATE(888),
    [sym_math_expression] = STATE(888),
    [sym_cast_expression] = STATE(888),
    [sym_sizeof_expression] = STATE(888),
    [sym_subscript_expression] = STATE(888),
    [sym_call_expression] = STATE(888),
    [sym_field_expression] = STATE(888),
    [sym_compound_literal_expression] = STATE(888),
    [sym_parenthesized_expression] = STATE(888),
    [sym_char_literal] = STATE(888),
    [sym_concatenated_string] = STATE(888),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [sym_null] = ACTIONS(2338),
    [sym_identifier] = ACTIONS(2338),
    [sym_comment] = ACTIONS(41),
  },
  [674] = {
    [sym__expression] = STATE(889),
    [sym_conditional_expression] = STATE(889),
    [sym_assignment_expression] = STATE(889),
    [sym_pointer_expression] = STATE(889),
    [sym_logical_expression] = STATE(889),
    [sym_bitwise_expression] = STATE(889),
    [sym_equality_expression] = STATE(889),
    [sym_relational_expression] = STATE(889),
    [sym_shift_expression] = STATE(889),
    [sym_math_expression] = STATE(889),
    [sym_cast_expression] = STATE(889),
    [sym_sizeof_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_call_expression] = STATE(889),
    [sym_field_expression] = STATE(889),
    [sym_compound_literal_expression] = STATE(889),
    [sym_parenthesized_expression] = STATE(889),
    [sym_char_literal] = STATE(889),
    [sym_concatenated_string] = STATE(889),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [sym_null] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(2342),
    [sym_comment] = ACTIONS(41),
  },
  [675] = {
    [sym__expression] = STATE(890),
    [sym_conditional_expression] = STATE(890),
    [sym_assignment_expression] = STATE(890),
    [sym_pointer_expression] = STATE(890),
    [sym_logical_expression] = STATE(890),
    [sym_bitwise_expression] = STATE(890),
    [sym_equality_expression] = STATE(890),
    [sym_relational_expression] = STATE(890),
    [sym_shift_expression] = STATE(890),
    [sym_math_expression] = STATE(890),
    [sym_cast_expression] = STATE(890),
    [sym_sizeof_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_call_expression] = STATE(890),
    [sym_field_expression] = STATE(890),
    [sym_compound_literal_expression] = STATE(890),
    [sym_parenthesized_expression] = STATE(890),
    [sym_char_literal] = STATE(890),
    [sym_concatenated_string] = STATE(890),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2346),
    [sym_false] = ACTIONS(2346),
    [sym_null] = ACTIONS(2346),
    [sym_identifier] = ACTIONS(2346),
    [sym_comment] = ACTIONS(41),
  },
  [676] = {
    [sym__expression] = STATE(891),
    [sym_conditional_expression] = STATE(891),
    [sym_assignment_expression] = STATE(891),
    [sym_pointer_expression] = STATE(891),
    [sym_logical_expression] = STATE(891),
    [sym_bitwise_expression] = STATE(891),
    [sym_equality_expression] = STATE(891),
    [sym_relational_expression] = STATE(891),
    [sym_shift_expression] = STATE(891),
    [sym_math_expression] = STATE(891),
    [sym_cast_expression] = STATE(891),
    [sym_sizeof_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_call_expression] = STATE(891),
    [sym_field_expression] = STATE(891),
    [sym_compound_literal_expression] = STATE(891),
    [sym_parenthesized_expression] = STATE(891),
    [sym_char_literal] = STATE(891),
    [sym_concatenated_string] = STATE(891),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2350),
    [sym_false] = ACTIONS(2350),
    [sym_null] = ACTIONS(2350),
    [sym_identifier] = ACTIONS(2350),
    [sym_comment] = ACTIONS(41),
  },
  [677] = {
    [sym__expression] = STATE(892),
    [sym_conditional_expression] = STATE(892),
    [sym_assignment_expression] = STATE(892),
    [sym_pointer_expression] = STATE(892),
    [sym_logical_expression] = STATE(892),
    [sym_bitwise_expression] = STATE(892),
    [sym_equality_expression] = STATE(892),
    [sym_relational_expression] = STATE(892),
    [sym_shift_expression] = STATE(892),
    [sym_math_expression] = STATE(892),
    [sym_cast_expression] = STATE(892),
    [sym_sizeof_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_call_expression] = STATE(892),
    [sym_field_expression] = STATE(892),
    [sym_compound_literal_expression] = STATE(892),
    [sym_parenthesized_expression] = STATE(892),
    [sym_char_literal] = STATE(892),
    [sym_concatenated_string] = STATE(892),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2352),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_identifier] = ACTIONS(2354),
    [sym_comment] = ACTIONS(41),
  },
  [678] = {
    [sym__expression] = STATE(893),
    [sym_conditional_expression] = STATE(893),
    [sym_assignment_expression] = STATE(893),
    [sym_pointer_expression] = STATE(893),
    [sym_logical_expression] = STATE(893),
    [sym_bitwise_expression] = STATE(893),
    [sym_equality_expression] = STATE(893),
    [sym_relational_expression] = STATE(893),
    [sym_shift_expression] = STATE(893),
    [sym_math_expression] = STATE(893),
    [sym_cast_expression] = STATE(893),
    [sym_sizeof_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_call_expression] = STATE(893),
    [sym_field_expression] = STATE(893),
    [sym_compound_literal_expression] = STATE(893),
    [sym_parenthesized_expression] = STATE(893),
    [sym_char_literal] = STATE(893),
    [sym_concatenated_string] = STATE(893),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2358),
    [sym_false] = ACTIONS(2358),
    [sym_null] = ACTIONS(2358),
    [sym_identifier] = ACTIONS(2358),
    [sym_comment] = ACTIONS(41),
  },
  [679] = {
    [sym__expression] = STATE(894),
    [sym_conditional_expression] = STATE(894),
    [sym_assignment_expression] = STATE(894),
    [sym_pointer_expression] = STATE(894),
    [sym_logical_expression] = STATE(894),
    [sym_bitwise_expression] = STATE(894),
    [sym_equality_expression] = STATE(894),
    [sym_relational_expression] = STATE(894),
    [sym_shift_expression] = STATE(894),
    [sym_math_expression] = STATE(894),
    [sym_cast_expression] = STATE(894),
    [sym_sizeof_expression] = STATE(894),
    [sym_subscript_expression] = STATE(894),
    [sym_call_expression] = STATE(894),
    [sym_field_expression] = STATE(894),
    [sym_compound_literal_expression] = STATE(894),
    [sym_parenthesized_expression] = STATE(894),
    [sym_char_literal] = STATE(894),
    [sym_concatenated_string] = STATE(894),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [sym_null] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2362),
    [sym_comment] = ACTIONS(41),
  },
  [680] = {
    [sym__expression] = STATE(895),
    [sym_conditional_expression] = STATE(895),
    [sym_assignment_expression] = STATE(895),
    [sym_pointer_expression] = STATE(895),
    [sym_logical_expression] = STATE(895),
    [sym_bitwise_expression] = STATE(895),
    [sym_equality_expression] = STATE(895),
    [sym_relational_expression] = STATE(895),
    [sym_shift_expression] = STATE(895),
    [sym_math_expression] = STATE(895),
    [sym_cast_expression] = STATE(895),
    [sym_sizeof_expression] = STATE(895),
    [sym_subscript_expression] = STATE(895),
    [sym_call_expression] = STATE(895),
    [sym_field_expression] = STATE(895),
    [sym_compound_literal_expression] = STATE(895),
    [sym_parenthesized_expression] = STATE(895),
    [sym_char_literal] = STATE(895),
    [sym_concatenated_string] = STATE(895),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [sym_null] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2366),
    [sym_comment] = ACTIONS(41),
  },
  [681] = {
    [sym__expression] = STATE(896),
    [sym_conditional_expression] = STATE(896),
    [sym_assignment_expression] = STATE(896),
    [sym_pointer_expression] = STATE(896),
    [sym_logical_expression] = STATE(896),
    [sym_bitwise_expression] = STATE(896),
    [sym_equality_expression] = STATE(896),
    [sym_relational_expression] = STATE(896),
    [sym_shift_expression] = STATE(896),
    [sym_math_expression] = STATE(896),
    [sym_cast_expression] = STATE(896),
    [sym_sizeof_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_call_expression] = STATE(896),
    [sym_field_expression] = STATE(896),
    [sym_compound_literal_expression] = STATE(896),
    [sym_parenthesized_expression] = STATE(896),
    [sym_char_literal] = STATE(896),
    [sym_concatenated_string] = STATE(896),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [sym_null] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2370),
    [sym_comment] = ACTIONS(41),
  },
  [682] = {
    [sym_string_literal] = STATE(897),
    [aux_sym_concatenated_string_repeat1] = STATE(897),
    [anon_sym_LPAREN] = ACTIONS(1738),
    [anon_sym_STAR] = ACTIONS(1740),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_EQ] = ACTIONS(1740),
    [anon_sym_COLON] = ACTIONS(1738),
    [anon_sym_QMARK] = ACTIONS(1738),
    [anon_sym_STAR_EQ] = ACTIONS(1738),
    [anon_sym_SLASH_EQ] = ACTIONS(1738),
    [anon_sym_PERCENT_EQ] = ACTIONS(1738),
    [anon_sym_PLUS_EQ] = ACTIONS(1738),
    [anon_sym_DASH_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_GT_EQ] = ACTIONS(1738),
    [anon_sym_AMP_EQ] = ACTIONS(1738),
    [anon_sym_CARET_EQ] = ACTIONS(1738),
    [anon_sym_PIPE_EQ] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1740),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE] = ACTIONS(1740),
    [anon_sym_CARET] = ACTIONS(1740),
    [anon_sym_EQ_EQ] = ACTIONS(1738),
    [anon_sym_BANG_EQ] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1740),
    [anon_sym_GT] = ACTIONS(1740),
    [anon_sym_LT_EQ] = ACTIONS(1738),
    [anon_sym_GT_EQ] = ACTIONS(1738),
    [anon_sym_LT_LT] = ACTIONS(1740),
    [anon_sym_GT_GT] = ACTIONS(1740),
    [anon_sym_PLUS] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1740),
    [anon_sym_SLASH] = ACTIONS(1740),
    [anon_sym_PERCENT] = ACTIONS(1740),
    [anon_sym_DASH_DASH] = ACTIONS(1738),
    [anon_sym_PLUS_PLUS] = ACTIONS(1738),
    [anon_sym_DOT] = ACTIONS(1738),
    [anon_sym_DASH_GT] = ACTIONS(1738),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_comment] = ACTIONS(41),
  },
  [683] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(1074),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [684] = {
    [anon_sym_LPAREN] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2374),
    [sym_preproc_directive] = ACTIONS(2374),
    [anon_sym_typedef] = ACTIONS(2374),
    [anon_sym_extern] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_auto] = ACTIONS(2374),
    [anon_sym_register] = ACTIONS(2374),
    [anon_sym_inline] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_restrict] = ACTIONS(2374),
    [anon_sym_volatile] = ACTIONS(2374),
    [anon_sym__Atomic] = ACTIONS(2374),
    [anon_sym_unsigned] = ACTIONS(2374),
    [anon_sym_long] = ACTIONS(2374),
    [anon_sym_short] = ACTIONS(2374),
    [sym_primitive_type] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
    [anon_sym_struct] = ACTIONS(2374),
    [anon_sym_union] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2374),
    [anon_sym_switch] = ACTIONS(2374),
    [anon_sym_case] = ACTIONS(2374),
    [anon_sym_default] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_do] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_goto] = ACTIONS(2374),
    [anon_sym_AMP] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2374),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [sym_null] = ACTIONS(2374),
    [sym_identifier] = ACTIONS(2374),
    [sym_comment] = ACTIONS(41),
  },
  [685] = {
    [sym__declarator] = STATE(441),
    [sym_pointer_declarator] = STATE(441),
    [sym_function_declarator] = STATE(441),
    [sym_array_declarator] = STATE(441),
    [sym_init_declarator] = STATE(50),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(593),
    [sym_identifier] = ACTIONS(1076),
    [sym_comment] = ACTIONS(41),
  },
  [686] = {
    [anon_sym_LPAREN] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_RBRACE] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_auto] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2376),
    [anon_sym_sizeof] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [sym_null] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(2378),
    [sym_comment] = ACTIONS(41),
  },
  [687] = {
    [sym_compound_statement] = STATE(905),
    [sym_labeled_statement] = STATE(905),
    [sym_expression_statement] = STATE(905),
    [sym_if_statement] = STATE(905),
    [sym_switch_statement] = STATE(905),
    [sym_case_statement] = STATE(905),
    [sym_while_statement] = STATE(905),
    [sym_do_statement] = STATE(905),
    [sym_for_statement] = STATE(905),
    [sym_return_statement] = STATE(905),
    [sym_break_statement] = STATE(905),
    [sym_continue_statement] = STATE(905),
    [sym_goto_statement] = STATE(905),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [688] = {
    [sym_compound_statement] = STATE(665),
    [sym_labeled_statement] = STATE(665),
    [sym_expression_statement] = STATE(665),
    [sym_if_statement] = STATE(665),
    [sym_switch_statement] = STATE(665),
    [sym_case_statement] = STATE(665),
    [sym_while_statement] = STATE(665),
    [sym_do_statement] = STATE(665),
    [sym_for_statement] = STATE(665),
    [sym_return_statement] = STATE(665),
    [sym_break_statement] = STATE(665),
    [sym_continue_statement] = STATE(665),
    [sym_goto_statement] = STATE(665),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [689] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2394),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [690] = {
    [sym_declaration] = STATE(684),
    [sym_type_definition] = STATE(684),
    [sym__declaration_specifiers] = STATE(685),
    [sym_compound_statement] = STATE(684),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(684),
    [sym_expression_statement] = STATE(684),
    [sym_if_statement] = STATE(684),
    [sym_switch_statement] = STATE(684),
    [sym_case_statement] = STATE(684),
    [sym_while_statement] = STATE(684),
    [sym_do_statement] = STATE(684),
    [sym_for_statement] = STATE(684),
    [sym_return_statement] = STATE(684),
    [sym_break_statement] = STATE(684),
    [sym_continue_statement] = STATE(684),
    [sym_goto_statement] = STATE(684),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2396),
    [sym_comment] = ACTIONS(41),
  },
  [691] = {
    [sym_compound_statement] = STATE(686),
    [sym_labeled_statement] = STATE(686),
    [sym_expression_statement] = STATE(686),
    [sym_if_statement] = STATE(686),
    [sym_switch_statement] = STATE(686),
    [sym_case_statement] = STATE(686),
    [sym_while_statement] = STATE(686),
    [sym_do_statement] = STATE(686),
    [sym_for_statement] = STATE(686),
    [sym_return_statement] = STATE(686),
    [sym_break_statement] = STATE(686),
    [sym_continue_statement] = STATE(686),
    [sym_goto_statement] = STATE(686),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [692] = {
    [anon_sym_while] = ACTIONS(2398),
    [sym_comment] = ACTIONS(41),
  },
  [693] = {
    [sym_declaration] = STATE(909),
    [sym__declaration_specifiers] = STATE(685),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym__expression] = STATE(910),
    [sym_conditional_expression] = STATE(910),
    [sym_assignment_expression] = STATE(910),
    [sym_pointer_expression] = STATE(910),
    [sym_logical_expression] = STATE(910),
    [sym_bitwise_expression] = STATE(910),
    [sym_equality_expression] = STATE(910),
    [sym_relational_expression] = STATE(910),
    [sym_shift_expression] = STATE(910),
    [sym_math_expression] = STATE(910),
    [sym_cast_expression] = STATE(910),
    [sym_sizeof_expression] = STATE(910),
    [sym_subscript_expression] = STATE(910),
    [sym_call_expression] = STATE(910),
    [sym_field_expression] = STATE(910),
    [sym_compound_literal_expression] = STATE(910),
    [sym_parenthesized_expression] = STATE(910),
    [sym_char_literal] = STATE(910),
    [sym_concatenated_string] = STATE(910),
    [sym_string_literal] = STATE(363),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [sym_null] = ACTIONS(2404),
    [sym_identifier] = ACTIONS(1630),
    [sym_comment] = ACTIONS(41),
  },
  [694] = {
    [sym_compound_statement] = STATE(703),
    [sym_labeled_statement] = STATE(703),
    [sym_expression_statement] = STATE(703),
    [sym_if_statement] = STATE(703),
    [sym_switch_statement] = STATE(703),
    [sym_case_statement] = STATE(703),
    [sym_while_statement] = STATE(703),
    [sym_do_statement] = STATE(703),
    [sym_for_statement] = STATE(703),
    [sym_return_statement] = STATE(703),
    [sym_break_statement] = STATE(703),
    [sym_continue_statement] = STATE(703),
    [sym_goto_statement] = STATE(703),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [695] = {
    [sym_parenthesized_expression] = STATE(911),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [696] = {
    [sym__expression] = STATE(913),
    [sym_conditional_expression] = STATE(913),
    [sym_assignment_expression] = STATE(913),
    [sym_pointer_expression] = STATE(913),
    [sym_logical_expression] = STATE(913),
    [sym_bitwise_expression] = STATE(913),
    [sym_equality_expression] = STATE(913),
    [sym_relational_expression] = STATE(913),
    [sym_shift_expression] = STATE(913),
    [sym_math_expression] = STATE(913),
    [sym_cast_expression] = STATE(913),
    [sym_sizeof_expression] = STATE(913),
    [sym_subscript_expression] = STATE(913),
    [sym_call_expression] = STATE(913),
    [sym_field_expression] = STATE(913),
    [sym_compound_literal_expression] = STATE(913),
    [sym_parenthesized_expression] = STATE(913),
    [sym_char_literal] = STATE(913),
    [sym_concatenated_string] = STATE(913),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [sym_null] = ACTIONS(2410),
    [sym_identifier] = ACTIONS(2410),
    [sym_comment] = ACTIONS(41),
  },
  [697] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [698] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [699] = {
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2416),
    [sym_preproc_directive] = ACTIONS(2416),
    [anon_sym_typedef] = ACTIONS(2416),
    [anon_sym_extern] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_auto] = ACTIONS(2416),
    [anon_sym_register] = ACTIONS(2416),
    [anon_sym_inline] = ACTIONS(2416),
    [anon_sym_const] = ACTIONS(2416),
    [anon_sym_restrict] = ACTIONS(2416),
    [anon_sym_volatile] = ACTIONS(2416),
    [anon_sym__Atomic] = ACTIONS(2416),
    [anon_sym_unsigned] = ACTIONS(2416),
    [anon_sym_long] = ACTIONS(2416),
    [anon_sym_short] = ACTIONS(2416),
    [sym_primitive_type] = ACTIONS(2416),
    [anon_sym_enum] = ACTIONS(2416),
    [anon_sym_struct] = ACTIONS(2416),
    [anon_sym_union] = ACTIONS(2416),
    [anon_sym_if] = ACTIONS(2416),
    [anon_sym_else] = ACTIONS(2416),
    [anon_sym_switch] = ACTIONS(2416),
    [anon_sym_case] = ACTIONS(2416),
    [anon_sym_default] = ACTIONS(2416),
    [anon_sym_while] = ACTIONS(2416),
    [anon_sym_do] = ACTIONS(2416),
    [anon_sym_for] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2416),
    [anon_sym_break] = ACTIONS(2416),
    [anon_sym_continue] = ACTIONS(2416),
    [anon_sym_goto] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_TILDE] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2414),
    [anon_sym_sizeof] = ACTIONS(2416),
    [sym_number_literal] = ACTIONS(2414),
    [anon_sym_SQUOTE] = ACTIONS(2414),
    [anon_sym_DQUOTE] = ACTIONS(2414),
    [sym_true] = ACTIONS(2416),
    [sym_false] = ACTIONS(2416),
    [sym_null] = ACTIONS(2416),
    [sym_identifier] = ACTIONS(2416),
    [sym_comment] = ACTIONS(41),
  },
  [700] = {
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_RBRACE] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2420),
    [sym_preproc_directive] = ACTIONS(2420),
    [anon_sym_typedef] = ACTIONS(2420),
    [anon_sym_extern] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2420),
    [anon_sym_auto] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2420),
    [anon_sym_inline] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2420),
    [anon_sym_restrict] = ACTIONS(2420),
    [anon_sym_volatile] = ACTIONS(2420),
    [anon_sym__Atomic] = ACTIONS(2420),
    [anon_sym_unsigned] = ACTIONS(2420),
    [anon_sym_long] = ACTIONS(2420),
    [anon_sym_short] = ACTIONS(2420),
    [sym_primitive_type] = ACTIONS(2420),
    [anon_sym_enum] = ACTIONS(2420),
    [anon_sym_struct] = ACTIONS(2420),
    [anon_sym_union] = ACTIONS(2420),
    [anon_sym_if] = ACTIONS(2420),
    [anon_sym_else] = ACTIONS(2420),
    [anon_sym_switch] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(2420),
    [anon_sym_default] = ACTIONS(2420),
    [anon_sym_while] = ACTIONS(2420),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2420),
    [anon_sym_break] = ACTIONS(2420),
    [anon_sym_continue] = ACTIONS(2420),
    [anon_sym_goto] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2418),
    [anon_sym_sizeof] = ACTIONS(2420),
    [sym_number_literal] = ACTIONS(2418),
    [anon_sym_SQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [sym_true] = ACTIONS(2420),
    [sym_false] = ACTIONS(2420),
    [sym_null] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2420),
    [sym_comment] = ACTIONS(41),
  },
  [701] = {
    [anon_sym_RPAREN] = ACTIONS(2422),
    [sym_comment] = ACTIONS(41),
  },
  [702] = {
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_EQ] = ACTIONS(2426),
    [anon_sym_COLON] = ACTIONS(2424),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_STAR_EQ] = ACTIONS(2424),
    [anon_sym_SLASH_EQ] = ACTIONS(2424),
    [anon_sym_PERCENT_EQ] = ACTIONS(2424),
    [anon_sym_PLUS_EQ] = ACTIONS(2424),
    [anon_sym_DASH_EQ] = ACTIONS(2424),
    [anon_sym_LT_LT_EQ] = ACTIONS(2424),
    [anon_sym_GT_GT_EQ] = ACTIONS(2424),
    [anon_sym_AMP_EQ] = ACTIONS(2424),
    [anon_sym_CARET_EQ] = ACTIONS(2424),
    [anon_sym_PIPE_EQ] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_CARET] = ACTIONS(2426),
    [anon_sym_EQ_EQ] = ACTIONS(2424),
    [anon_sym_BANG_EQ] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2426),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [anon_sym_PERCENT] = ACTIONS(2426),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_DASH_GT] = ACTIONS(2424),
    [sym_comment] = ACTIONS(41),
  },
  [703] = {
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2430),
    [sym_preproc_directive] = ACTIONS(2430),
    [anon_sym_typedef] = ACTIONS(2430),
    [anon_sym_extern] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_auto] = ACTIONS(2430),
    [anon_sym_register] = ACTIONS(2430),
    [anon_sym_inline] = ACTIONS(2430),
    [anon_sym_const] = ACTIONS(2430),
    [anon_sym_restrict] = ACTIONS(2430),
    [anon_sym_volatile] = ACTIONS(2430),
    [anon_sym__Atomic] = ACTIONS(2430),
    [anon_sym_unsigned] = ACTIONS(2430),
    [anon_sym_long] = ACTIONS(2430),
    [anon_sym_short] = ACTIONS(2430),
    [sym_primitive_type] = ACTIONS(2430),
    [anon_sym_enum] = ACTIONS(2430),
    [anon_sym_struct] = ACTIONS(2430),
    [anon_sym_union] = ACTIONS(2430),
    [anon_sym_if] = ACTIONS(2430),
    [anon_sym_else] = ACTIONS(2430),
    [anon_sym_switch] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(2430),
    [anon_sym_default] = ACTIONS(2430),
    [anon_sym_while] = ACTIONS(2430),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_for] = ACTIONS(2430),
    [anon_sym_return] = ACTIONS(2430),
    [anon_sym_break] = ACTIONS(2430),
    [anon_sym_continue] = ACTIONS(2430),
    [anon_sym_goto] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_sizeof] = ACTIONS(2430),
    [sym_number_literal] = ACTIONS(2428),
    [anon_sym_SQUOTE] = ACTIONS(2428),
    [anon_sym_DQUOTE] = ACTIONS(2428),
    [sym_true] = ACTIONS(2430),
    [sym_false] = ACTIONS(2430),
    [sym_null] = ACTIONS(2430),
    [sym_identifier] = ACTIONS(2430),
    [sym_comment] = ACTIONS(41),
  },
  [704] = {
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_STAR] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_EQ] = ACTIONS(2434),
    [anon_sym_COLON] = ACTIONS(2432),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_STAR_EQ] = ACTIONS(2432),
    [anon_sym_SLASH_EQ] = ACTIONS(2432),
    [anon_sym_PERCENT_EQ] = ACTIONS(2432),
    [anon_sym_PLUS_EQ] = ACTIONS(2432),
    [anon_sym_DASH_EQ] = ACTIONS(2432),
    [anon_sym_LT_LT_EQ] = ACTIONS(2432),
    [anon_sym_GT_GT_EQ] = ACTIONS(2432),
    [anon_sym_AMP_EQ] = ACTIONS(2432),
    [anon_sym_CARET_EQ] = ACTIONS(2432),
    [anon_sym_PIPE_EQ] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_PIPE_PIPE] = ACTIONS(2432),
    [anon_sym_AMP_AMP] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_CARET] = ACTIONS(2434),
    [anon_sym_EQ_EQ] = ACTIONS(2432),
    [anon_sym_BANG_EQ] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_LT_EQ] = ACTIONS(2432),
    [anon_sym_GT_EQ] = ACTIONS(2432),
    [anon_sym_LT_LT] = ACTIONS(2434),
    [anon_sym_GT_GT] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2434),
    [anon_sym_PERCENT] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_DOT] = ACTIONS(2432),
    [anon_sym_DASH_GT] = ACTIONS(2432),
    [sym_comment] = ACTIONS(41),
  },
  [705] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(918),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2436),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [706] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_COMMA] = ACTIONS(1082),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1088),
    [anon_sym_QMARK] = ACTIONS(1090),
    [anon_sym_STAR_EQ] = ACTIONS(1092),
    [anon_sym_SLASH_EQ] = ACTIONS(1092),
    [anon_sym_PERCENT_EQ] = ACTIONS(1092),
    [anon_sym_PLUS_EQ] = ACTIONS(1092),
    [anon_sym_DASH_EQ] = ACTIONS(1092),
    [anon_sym_LT_LT_EQ] = ACTIONS(1092),
    [anon_sym_GT_GT_EQ] = ACTIONS(1092),
    [anon_sym_AMP_EQ] = ACTIONS(1092),
    [anon_sym_CARET_EQ] = ACTIONS(1092),
    [anon_sym_PIPE_EQ] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [707] = {
    [anon_sym_RPAREN] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(2440),
    [sym_comment] = ACTIONS(41),
  },
  [708] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2442),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_COLON] = ACTIONS(2442),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_STAR_EQ] = ACTIONS(2442),
    [anon_sym_SLASH_EQ] = ACTIONS(2442),
    [anon_sym_PERCENT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_GT_EQ] = ACTIONS(2442),
    [anon_sym_AMP_EQ] = ACTIONS(2442),
    [anon_sym_CARET_EQ] = ACTIONS(2442),
    [anon_sym_PIPE_EQ] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(2444),
    [anon_sym_PERCENT] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [709] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2446),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [710] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_COMMA] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1088),
    [anon_sym_QMARK] = ACTIONS(2448),
    [anon_sym_STAR_EQ] = ACTIONS(1092),
    [anon_sym_SLASH_EQ] = ACTIONS(1092),
    [anon_sym_PERCENT_EQ] = ACTIONS(1092),
    [anon_sym_PLUS_EQ] = ACTIONS(1092),
    [anon_sym_DASH_EQ] = ACTIONS(1092),
    [anon_sym_LT_LT_EQ] = ACTIONS(1092),
    [anon_sym_GT_GT_EQ] = ACTIONS(1092),
    [anon_sym_AMP_EQ] = ACTIONS(1092),
    [anon_sym_CARET_EQ] = ACTIONS(1092),
    [anon_sym_PIPE_EQ] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [711] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [712] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [713] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [714] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [715] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [716] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [717] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2460),
    [anon_sym_STAR_EQ] = ACTIONS(2460),
    [anon_sym_SLASH_EQ] = ACTIONS(2460),
    [anon_sym_PERCENT_EQ] = ACTIONS(2460),
    [anon_sym_PLUS_EQ] = ACTIONS(2460),
    [anon_sym_DASH_EQ] = ACTIONS(2460),
    [anon_sym_LT_LT_EQ] = ACTIONS(2460),
    [anon_sym_GT_GT_EQ] = ACTIONS(2460),
    [anon_sym_AMP_EQ] = ACTIONS(2460),
    [anon_sym_CARET_EQ] = ACTIONS(2460),
    [anon_sym_PIPE_EQ] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [718] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_STAR_EQ] = ACTIONS(2464),
    [anon_sym_SLASH_EQ] = ACTIONS(2464),
    [anon_sym_PERCENT_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_EQ] = ACTIONS(2464),
    [anon_sym_DASH_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_GT_EQ] = ACTIONS(2464),
    [anon_sym_AMP_EQ] = ACTIONS(2464),
    [anon_sym_CARET_EQ] = ACTIONS(2464),
    [anon_sym_PIPE_EQ] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [719] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_STAR_EQ] = ACTIONS(2468),
    [anon_sym_SLASH_EQ] = ACTIONS(2468),
    [anon_sym_PERCENT_EQ] = ACTIONS(2468),
    [anon_sym_PLUS_EQ] = ACTIONS(2468),
    [anon_sym_DASH_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_GT_EQ] = ACTIONS(2468),
    [anon_sym_AMP_EQ] = ACTIONS(2468),
    [anon_sym_CARET_EQ] = ACTIONS(2468),
    [anon_sym_PIPE_EQ] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT] = ACTIONS(2470),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [720] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_STAR_EQ] = ACTIONS(2442),
    [anon_sym_SLASH_EQ] = ACTIONS(2442),
    [anon_sym_PERCENT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_GT_EQ] = ACTIONS(2442),
    [anon_sym_AMP_EQ] = ACTIONS(2442),
    [anon_sym_CARET_EQ] = ACTIONS(2442),
    [anon_sym_PIPE_EQ] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [721] = {
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_EQ] = ACTIONS(2474),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_QMARK] = ACTIONS(2472),
    [anon_sym_STAR_EQ] = ACTIONS(2472),
    [anon_sym_SLASH_EQ] = ACTIONS(2472),
    [anon_sym_PERCENT_EQ] = ACTIONS(2472),
    [anon_sym_PLUS_EQ] = ACTIONS(2472),
    [anon_sym_DASH_EQ] = ACTIONS(2472),
    [anon_sym_LT_LT_EQ] = ACTIONS(2472),
    [anon_sym_GT_GT_EQ] = ACTIONS(2472),
    [anon_sym_AMP_EQ] = ACTIONS(2472),
    [anon_sym_CARET_EQ] = ACTIONS(2472),
    [anon_sym_PIPE_EQ] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2474),
    [anon_sym_CARET] = ACTIONS(2474),
    [anon_sym_EQ_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_LT_EQ] = ACTIONS(2472),
    [anon_sym_GT_EQ] = ACTIONS(2472),
    [anon_sym_LT_LT] = ACTIONS(2474),
    [anon_sym_GT_GT] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DOT] = ACTIONS(2472),
    [anon_sym_DASH_GT] = ACTIONS(2472),
    [sym_comment] = ACTIONS(41),
  },
  [722] = {
    [sym_string_literal] = STATE(722),
    [aux_sym_concatenated_string_repeat1] = STATE(722),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_STAR_EQ] = ACTIONS(2476),
    [anon_sym_SLASH_EQ] = ACTIONS(2476),
    [anon_sym_PERCENT_EQ] = ACTIONS(2476),
    [anon_sym_PLUS_EQ] = ACTIONS(2476),
    [anon_sym_DASH_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_GT_EQ] = ACTIONS(2476),
    [anon_sym_AMP_EQ] = ACTIONS(2476),
    [anon_sym_CARET_EQ] = ACTIONS(2476),
    [anon_sym_PIPE_EQ] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2478),
    [anon_sym_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_DASH_GT] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(41),
  },
  [723] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [724] = {
    [anon_sym_RPAREN] = ACTIONS(2483),
    [sym_comment] = ACTIONS(41),
  },
  [725] = {
    [anon_sym_LPAREN] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_EQ] = ACTIONS(2485),
    [sym_comment] = ACTIONS(41),
  },
  [726] = {
    [sym_storage_class_specifier] = STATE(726),
    [sym_type_qualifier] = STATE(726),
    [aux_sym__declaration_specifiers_repeat1] = STATE(726),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_extern] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(637),
    [anon_sym_static] = ACTIONS(314),
    [anon_sym_auto] = ACTIONS(314),
    [anon_sym_register] = ACTIONS(314),
    [anon_sym_inline] = ACTIONS(314),
    [anon_sym_const] = ACTIONS(317),
    [anon_sym_restrict] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym__Atomic] = ACTIONS(317),
    [anon_sym_AMP] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(637),
    [anon_sym_TILDE] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(320),
    [anon_sym_DASH] = ACTIONS(320),
    [anon_sym_DASH_DASH] = ACTIONS(637),
    [anon_sym_PLUS_PLUS] = ACTIONS(637),
    [anon_sym_sizeof] = ACTIONS(320),
    [sym_number_literal] = ACTIONS(637),
    [anon_sym_SQUOTE] = ACTIONS(637),
    [anon_sym_DQUOTE] = ACTIONS(637),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_null] = ACTIONS(320),
    [sym_identifier] = ACTIONS(320),
    [sym_comment] = ACTIONS(41),
  },
  [727] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2448),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(2448),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [728] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2487),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [729] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2452),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [730] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2456),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [731] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2456),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [732] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2452),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [733] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2452),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [734] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2460),
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2460),
    [anon_sym_STAR_EQ] = ACTIONS(2460),
    [anon_sym_SLASH_EQ] = ACTIONS(2460),
    [anon_sym_PERCENT_EQ] = ACTIONS(2460),
    [anon_sym_PLUS_EQ] = ACTIONS(2460),
    [anon_sym_DASH_EQ] = ACTIONS(2460),
    [anon_sym_LT_LT_EQ] = ACTIONS(2460),
    [anon_sym_GT_GT_EQ] = ACTIONS(2460),
    [anon_sym_AMP_EQ] = ACTIONS(2460),
    [anon_sym_CARET_EQ] = ACTIONS(2460),
    [anon_sym_PIPE_EQ] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [735] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_STAR_EQ] = ACTIONS(2464),
    [anon_sym_SLASH_EQ] = ACTIONS(2464),
    [anon_sym_PERCENT_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_EQ] = ACTIONS(2464),
    [anon_sym_DASH_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_GT_EQ] = ACTIONS(2464),
    [anon_sym_AMP_EQ] = ACTIONS(2464),
    [anon_sym_CARET_EQ] = ACTIONS(2464),
    [anon_sym_PIPE_EQ] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [736] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2468),
    [anon_sym_EQ] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_STAR_EQ] = ACTIONS(2468),
    [anon_sym_SLASH_EQ] = ACTIONS(2468),
    [anon_sym_PERCENT_EQ] = ACTIONS(2468),
    [anon_sym_PLUS_EQ] = ACTIONS(2468),
    [anon_sym_DASH_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_GT_EQ] = ACTIONS(2468),
    [anon_sym_AMP_EQ] = ACTIONS(2468),
    [anon_sym_CARET_EQ] = ACTIONS(2468),
    [anon_sym_PIPE_EQ] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT] = ACTIONS(2470),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [737] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2442),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_STAR_EQ] = ACTIONS(2442),
    [anon_sym_SLASH_EQ] = ACTIONS(2442),
    [anon_sym_PERCENT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_GT_EQ] = ACTIONS(2442),
    [anon_sym_AMP_EQ] = ACTIONS(2442),
    [anon_sym_CARET_EQ] = ACTIONS(2442),
    [anon_sym_PIPE_EQ] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [738] = {
    [sym_string_literal] = STATE(738),
    [aux_sym_concatenated_string_repeat1] = STATE(738),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_STAR_EQ] = ACTIONS(2476),
    [anon_sym_SLASH_EQ] = ACTIONS(2476),
    [anon_sym_PERCENT_EQ] = ACTIONS(2476),
    [anon_sym_PLUS_EQ] = ACTIONS(2476),
    [anon_sym_DASH_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_GT_EQ] = ACTIONS(2476),
    [anon_sym_AMP_EQ] = ACTIONS(2476),
    [anon_sym_CARET_EQ] = ACTIONS(2476),
    [anon_sym_PIPE_EQ] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2478),
    [anon_sym_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_DASH_GT] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(41),
  },
  [739] = {
    [sym_storage_class_specifier] = STATE(726),
    [sym_type_qualifier] = STATE(726),
    [aux_sym__declaration_specifiers_repeat1] = STATE(726),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_BANG] = ACTIONS(639),
    [anon_sym_TILDE] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(639),
    [anon_sym_sizeof] = ACTIONS(641),
    [sym_number_literal] = ACTIONS(639),
    [anon_sym_SQUOTE] = ACTIONS(639),
    [anon_sym_DQUOTE] = ACTIONS(639),
    [sym_true] = ACTIONS(641),
    [sym_false] = ACTIONS(641),
    [sym_null] = ACTIONS(641),
    [sym_identifier] = ACTIONS(641),
    [sym_comment] = ACTIONS(41),
  },
  [740] = {
    [anon_sym_LPAREN] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_STAR] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2489),
    [anon_sym_RBRACK] = ACTIONS(2489),
    [anon_sym_EQ] = ACTIONS(2491),
    [anon_sym_COLON] = ACTIONS(2489),
    [anon_sym_QMARK] = ACTIONS(2489),
    [anon_sym_STAR_EQ] = ACTIONS(2489),
    [anon_sym_SLASH_EQ] = ACTIONS(2489),
    [anon_sym_PERCENT_EQ] = ACTIONS(2489),
    [anon_sym_PLUS_EQ] = ACTIONS(2489),
    [anon_sym_DASH_EQ] = ACTIONS(2489),
    [anon_sym_LT_LT_EQ] = ACTIONS(2489),
    [anon_sym_GT_GT_EQ] = ACTIONS(2489),
    [anon_sym_AMP_EQ] = ACTIONS(2489),
    [anon_sym_CARET_EQ] = ACTIONS(2489),
    [anon_sym_PIPE_EQ] = ACTIONS(2489),
    [anon_sym_AMP] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2489),
    [anon_sym_AMP_AMP] = ACTIONS(2489),
    [anon_sym_PIPE] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2491),
    [anon_sym_EQ_EQ] = ACTIONS(2489),
    [anon_sym_BANG_EQ] = ACTIONS(2489),
    [anon_sym_LT] = ACTIONS(2491),
    [anon_sym_GT] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2489),
    [anon_sym_GT_EQ] = ACTIONS(2489),
    [anon_sym_LT_LT] = ACTIONS(2491),
    [anon_sym_GT_GT] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_SLASH] = ACTIONS(2491),
    [anon_sym_PERCENT] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_DOT] = ACTIONS(2489),
    [anon_sym_DASH_GT] = ACTIONS(2489),
    [sym_comment] = ACTIONS(41),
  },
  [741] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2493),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [742] = {
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(2495),
    [anon_sym_DOT] = ACTIONS(2495),
    [sym_comment] = ACTIONS(41),
  },
  [743] = {
    [sym__expression] = STATE(925),
    [sym_conditional_expression] = STATE(925),
    [sym_assignment_expression] = STATE(925),
    [sym_pointer_expression] = STATE(925),
    [sym_logical_expression] = STATE(925),
    [sym_bitwise_expression] = STATE(925),
    [sym_equality_expression] = STATE(925),
    [sym_relational_expression] = STATE(925),
    [sym_shift_expression] = STATE(925),
    [sym_math_expression] = STATE(925),
    [sym_cast_expression] = STATE(925),
    [sym_sizeof_expression] = STATE(925),
    [sym_subscript_expression] = STATE(925),
    [sym_call_expression] = STATE(925),
    [sym_field_expression] = STATE(925),
    [sym_compound_literal_expression] = STATE(925),
    [sym_parenthesized_expression] = STATE(925),
    [sym_initializer_list] = STATE(926),
    [sym_initializer_pair] = STATE(926),
    [sym_subscript_designator] = STATE(492),
    [sym_field_designator] = STATE(492),
    [sym_char_literal] = STATE(925),
    [sym_concatenated_string] = STATE(925),
    [sym_string_literal] = STATE(339),
    [aux_sym_initializer_pair_repeat1] = STATE(492),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(2497),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [anon_sym_DOT] = ACTIONS(1174),
    [sym_number_literal] = ACTIONS(2499),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2501),
    [sym_false] = ACTIONS(2501),
    [sym_null] = ACTIONS(2501),
    [sym_identifier] = ACTIONS(2501),
    [sym_comment] = ACTIONS(41),
  },
  [744] = {
    [aux_sym_initializer_list_repeat1] = STATE(928),
    [anon_sym_RBRACE] = ACTIONS(2497),
    [anon_sym_COMMA] = ACTIONS(2503),
    [sym_comment] = ACTIONS(41),
  },
  [745] = {
    [sym__expression] = STATE(929),
    [sym_conditional_expression] = STATE(929),
    [sym_assignment_expression] = STATE(929),
    [sym_pointer_expression] = STATE(929),
    [sym_logical_expression] = STATE(929),
    [sym_bitwise_expression] = STATE(929),
    [sym_equality_expression] = STATE(929),
    [sym_relational_expression] = STATE(929),
    [sym_shift_expression] = STATE(929),
    [sym_math_expression] = STATE(929),
    [sym_cast_expression] = STATE(929),
    [sym_sizeof_expression] = STATE(929),
    [sym_subscript_expression] = STATE(929),
    [sym_call_expression] = STATE(929),
    [sym_field_expression] = STATE(929),
    [sym_compound_literal_expression] = STATE(929),
    [sym_parenthesized_expression] = STATE(929),
    [sym_initializer_list] = STATE(930),
    [sym_char_literal] = STATE(929),
    [sym_concatenated_string] = STATE(929),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2505),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2507),
    [sym_false] = ACTIONS(2507),
    [sym_null] = ACTIONS(2507),
    [sym_identifier] = ACTIONS(2507),
    [sym_comment] = ACTIONS(41),
  },
  [746] = {
    [sym_subscript_designator] = STATE(746),
    [sym_field_designator] = STATE(746),
    [aux_sym_initializer_pair_repeat1] = STATE(746),
    [anon_sym_LBRACK] = ACTIONS(2509),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_DOT] = ACTIONS(2514),
    [sym_comment] = ACTIONS(41),
  },
  [747] = {
    [anon_sym_RPAREN] = ACTIONS(2517),
    [anon_sym_COMMA] = ACTIONS(2519),
    [sym_comment] = ACTIONS(41),
  },
  [748] = {
    [sym_ta_specifier_list] = STATE(933),
    [sym_ta_specifier_list_specifier] = STATE(495),
    [anon_sym_dense] = ACTIONS(1189),
    [anon_sym_sparse] = ACTIONS(1189),
    [sym_comment] = ACTIONS(41),
  },
  [749] = {
    [sym_ta_specifier_list] = STATE(934),
    [sym_ta_specifier_list_specifier] = STATE(495),
    [anon_sym_dense] = ACTIONS(1189),
    [anon_sym_sparse] = ACTIONS(1189),
    [sym_comment] = ACTIONS(41),
  },
  [750] = {
    [anon_sym_tensor] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1197),
    [anon_sym_indexvars] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1199),
    [sym_preproc_directive] = ACTIONS(1199),
    [anon_sym_typedef] = ACTIONS(1199),
    [anon_sym_extern] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1199),
    [anon_sym_auto] = ACTIONS(1199),
    [anon_sym_register] = ACTIONS(1199),
    [anon_sym_inline] = ACTIONS(1199),
    [anon_sym_const] = ACTIONS(1199),
    [anon_sym_restrict] = ACTIONS(1199),
    [anon_sym_volatile] = ACTIONS(1199),
    [anon_sym__Atomic] = ACTIONS(1199),
    [anon_sym_unsigned] = ACTIONS(1199),
    [anon_sym_long] = ACTIONS(1199),
    [anon_sym_short] = ACTIONS(1199),
    [sym_primitive_type] = ACTIONS(1199),
    [anon_sym_enum] = ACTIONS(1199),
    [anon_sym_struct] = ACTIONS(1199),
    [anon_sym_union] = ACTIONS(1199),
    [anon_sym_if] = ACTIONS(1199),
    [anon_sym_switch] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1199),
    [anon_sym_default] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(1199),
    [anon_sym_do] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1199),
    [anon_sym_return] = ACTIONS(1199),
    [anon_sym_break] = ACTIONS(1199),
    [anon_sym_continue] = ACTIONS(1199),
    [anon_sym_goto] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [sym_number_literal] = ACTIONS(1197),
    [anon_sym_SQUOTE] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_true] = ACTIONS(1199),
    [sym_false] = ACTIONS(1199),
    [sym_null] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1199),
    [sym_comment] = ACTIONS(41),
  },
  [751] = {
    [anon_sym_tensor] = ACTIONS(1286),
    [anon_sym_indexvars] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1286),
    [sym_preproc_directive] = ACTIONS(1286),
    [anon_sym_typedef] = ACTIONS(1286),
    [anon_sym_extern] = ACTIONS(1286),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_auto] = ACTIONS(1286),
    [anon_sym_register] = ACTIONS(1286),
    [anon_sym_inline] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_restrict] = ACTIONS(1286),
    [anon_sym_volatile] = ACTIONS(1286),
    [anon_sym__Atomic] = ACTIONS(1286),
    [anon_sym_unsigned] = ACTIONS(1286),
    [anon_sym_long] = ACTIONS(1286),
    [anon_sym_short] = ACTIONS(1286),
    [sym_primitive_type] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
    [anon_sym_struct] = ACTIONS(1286),
    [anon_sym_union] = ACTIONS(1286),
    [sym_identifier] = ACTIONS(1286),
    [sym_comment] = ACTIONS(41),
  },
  [752] = {
    [anon_sym_tensor] = ACTIONS(1290),
    [anon_sym_indexvars] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1290),
    [sym_preproc_directive] = ACTIONS(1290),
    [anon_sym_typedef] = ACTIONS(1290),
    [anon_sym_extern] = ACTIONS(1290),
    [anon_sym_static] = ACTIONS(1290),
    [anon_sym_auto] = ACTIONS(1290),
    [anon_sym_register] = ACTIONS(1290),
    [anon_sym_inline] = ACTIONS(1290),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_restrict] = ACTIONS(1290),
    [anon_sym_volatile] = ACTIONS(1290),
    [anon_sym__Atomic] = ACTIONS(1290),
    [anon_sym_unsigned] = ACTIONS(1290),
    [anon_sym_long] = ACTIONS(1290),
    [anon_sym_short] = ACTIONS(1290),
    [sym_primitive_type] = ACTIONS(1290),
    [anon_sym_enum] = ACTIONS(1290),
    [anon_sym_struct] = ACTIONS(1290),
    [anon_sym_union] = ACTIONS(1290),
    [sym_identifier] = ACTIONS(1290),
    [sym_comment] = ACTIONS(41),
  },
  [753] = {
    [anon_sym_LBRACE] = ACTIONS(2521),
    [sym_comment] = ACTIONS(41),
  },
  [754] = {
    [anon_sym_tensor] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_indexvars] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(649),
    [sym_preproc_directive] = ACTIONS(649),
    [anon_sym_typedef] = ACTIONS(649),
    [anon_sym_extern] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_static] = ACTIONS(649),
    [anon_sym_auto] = ACTIONS(649),
    [anon_sym_register] = ACTIONS(649),
    [anon_sym_inline] = ACTIONS(649),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_restrict] = ACTIONS(649),
    [anon_sym_volatile] = ACTIONS(649),
    [anon_sym__Atomic] = ACTIONS(649),
    [anon_sym_unsigned] = ACTIONS(649),
    [anon_sym_long] = ACTIONS(649),
    [anon_sym_short] = ACTIONS(649),
    [sym_primitive_type] = ACTIONS(649),
    [anon_sym_enum] = ACTIONS(649),
    [anon_sym_struct] = ACTIONS(649),
    [anon_sym_union] = ACTIONS(649),
    [anon_sym_if] = ACTIONS(649),
    [anon_sym_switch] = ACTIONS(649),
    [anon_sym_case] = ACTIONS(649),
    [anon_sym_default] = ACTIONS(649),
    [anon_sym_while] = ACTIONS(649),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(649),
    [anon_sym_break] = ACTIONS(649),
    [anon_sym_continue] = ACTIONS(649),
    [anon_sym_goto] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(649),
    [anon_sym_DASH_DASH] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(647),
    [anon_sym_sizeof] = ACTIONS(649),
    [sym_number_literal] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(647),
    [anon_sym_DQUOTE] = ACTIONS(647),
    [sym_true] = ACTIONS(649),
    [sym_false] = ACTIONS(649),
    [sym_null] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_comment] = ACTIONS(41),
  },
  [755] = {
    [anon_sym_tensor] = ACTIONS(664),
    [anon_sym_LPAREN] = ACTIONS(662),
    [anon_sym_LBRACE] = ACTIONS(662),
    [anon_sym_SEMI] = ACTIONS(662),
    [anon_sym_indexvars] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(664),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(664),
    [sym_preproc_directive] = ACTIONS(664),
    [anon_sym_typedef] = ACTIONS(664),
    [anon_sym_extern] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_auto] = ACTIONS(664),
    [anon_sym_register] = ACTIONS(664),
    [anon_sym_inline] = ACTIONS(664),
    [anon_sym_const] = ACTIONS(664),
    [anon_sym_restrict] = ACTIONS(664),
    [anon_sym_volatile] = ACTIONS(664),
    [anon_sym__Atomic] = ACTIONS(664),
    [anon_sym_unsigned] = ACTIONS(664),
    [anon_sym_long] = ACTIONS(664),
    [anon_sym_short] = ACTIONS(664),
    [sym_primitive_type] = ACTIONS(664),
    [anon_sym_enum] = ACTIONS(664),
    [anon_sym_struct] = ACTIONS(664),
    [anon_sym_union] = ACTIONS(664),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(664),
    [anon_sym_case] = ACTIONS(664),
    [anon_sym_default] = ACTIONS(664),
    [anon_sym_while] = ACTIONS(664),
    [anon_sym_do] = ACTIONS(664),
    [anon_sym_for] = ACTIONS(664),
    [anon_sym_return] = ACTIONS(664),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_TILDE] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_DASH_DASH] = ACTIONS(662),
    [anon_sym_PLUS_PLUS] = ACTIONS(662),
    [anon_sym_sizeof] = ACTIONS(664),
    [sym_number_literal] = ACTIONS(662),
    [anon_sym_SQUOTE] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(662),
    [sym_true] = ACTIONS(664),
    [sym_false] = ACTIONS(664),
    [sym_null] = ACTIONS(664),
    [sym_identifier] = ACTIONS(664),
    [sym_comment] = ACTIONS(41),
  },
  [756] = {
    [anon_sym_tensor] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_indexvars] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(668),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(668),
    [sym_preproc_directive] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_auto] = ACTIONS(668),
    [anon_sym_register] = ACTIONS(668),
    [anon_sym_inline] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_restrict] = ACTIONS(668),
    [anon_sym_volatile] = ACTIONS(668),
    [anon_sym__Atomic] = ACTIONS(668),
    [anon_sym_unsigned] = ACTIONS(668),
    [anon_sym_long] = ACTIONS(668),
    [anon_sym_short] = ACTIONS(668),
    [sym_primitive_type] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_union] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_switch] = ACTIONS(668),
    [anon_sym_case] = ACTIONS(668),
    [anon_sym_default] = ACTIONS(668),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(668),
    [anon_sym_for] = ACTIONS(668),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_break] = ACTIONS(668),
    [anon_sym_continue] = ACTIONS(668),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(666),
    [anon_sym_sizeof] = ACTIONS(668),
    [sym_number_literal] = ACTIONS(666),
    [anon_sym_SQUOTE] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [sym_true] = ACTIONS(668),
    [sym_false] = ACTIONS(668),
    [sym_null] = ACTIONS(668),
    [sym_identifier] = ACTIONS(668),
    [sym_comment] = ACTIONS(41),
  },
  [757] = {
    [anon_sym_LF] = ACTIONS(2523),
    [sym_comment] = ACTIONS(55),
  },
  [758] = {
    [anon_sym_tensor] = ACTIONS(722),
    [anon_sym_indexvars] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(722),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(722),
    [sym_preproc_directive] = ACTIONS(722),
    [anon_sym_typedef] = ACTIONS(722),
    [anon_sym_extern] = ACTIONS(722),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_auto] = ACTIONS(722),
    [anon_sym_register] = ACTIONS(722),
    [anon_sym_inline] = ACTIONS(722),
    [anon_sym_const] = ACTIONS(722),
    [anon_sym_restrict] = ACTIONS(722),
    [anon_sym_volatile] = ACTIONS(722),
    [anon_sym__Atomic] = ACTIONS(722),
    [anon_sym_unsigned] = ACTIONS(722),
    [anon_sym_long] = ACTIONS(722),
    [anon_sym_short] = ACTIONS(722),
    [sym_primitive_type] = ACTIONS(722),
    [anon_sym_enum] = ACTIONS(722),
    [anon_sym_struct] = ACTIONS(722),
    [anon_sym_union] = ACTIONS(722),
    [sym_identifier] = ACTIONS(722),
    [sym_comment] = ACTIONS(41),
  },
  [759] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2525),
    [sym_comment] = ACTIONS(41),
  },
  [760] = {
    [anon_sym_tensor] = ACTIONS(761),
    [anon_sym_indexvars] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(761),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(761),
    [sym_preproc_directive] = ACTIONS(761),
    [anon_sym_typedef] = ACTIONS(761),
    [anon_sym_extern] = ACTIONS(761),
    [anon_sym_static] = ACTIONS(761),
    [anon_sym_auto] = ACTIONS(761),
    [anon_sym_register] = ACTIONS(761),
    [anon_sym_inline] = ACTIONS(761),
    [anon_sym_const] = ACTIONS(761),
    [anon_sym_restrict] = ACTIONS(761),
    [anon_sym_volatile] = ACTIONS(761),
    [anon_sym__Atomic] = ACTIONS(761),
    [anon_sym_unsigned] = ACTIONS(761),
    [anon_sym_long] = ACTIONS(761),
    [anon_sym_short] = ACTIONS(761),
    [sym_primitive_type] = ACTIONS(761),
    [anon_sym_enum] = ACTIONS(761),
    [anon_sym_struct] = ACTIONS(761),
    [anon_sym_union] = ACTIONS(761),
    [sym_identifier] = ACTIONS(761),
    [sym_comment] = ACTIONS(41),
  },
  [761] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2527),
    [sym_comment] = ACTIONS(41),
  },
  [762] = {
    [anon_sym_tensor] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_indexvars] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(771),
    [sym_preproc_directive] = ACTIONS(771),
    [anon_sym_typedef] = ACTIONS(771),
    [anon_sym_extern] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(769),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_auto] = ACTIONS(771),
    [anon_sym_register] = ACTIONS(771),
    [anon_sym_inline] = ACTIONS(771),
    [anon_sym_const] = ACTIONS(771),
    [anon_sym_restrict] = ACTIONS(771),
    [anon_sym_volatile] = ACTIONS(771),
    [anon_sym__Atomic] = ACTIONS(771),
    [anon_sym_unsigned] = ACTIONS(771),
    [anon_sym_long] = ACTIONS(771),
    [anon_sym_short] = ACTIONS(771),
    [sym_primitive_type] = ACTIONS(771),
    [anon_sym_enum] = ACTIONS(771),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_union] = ACTIONS(771),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_break] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_goto] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(769),
    [anon_sym_PLUS_PLUS] = ACTIONS(769),
    [anon_sym_sizeof] = ACTIONS(771),
    [sym_number_literal] = ACTIONS(769),
    [anon_sym_SQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [sym_true] = ACTIONS(771),
    [sym_false] = ACTIONS(771),
    [sym_null] = ACTIONS(771),
    [sym_identifier] = ACTIONS(771),
    [sym_comment] = ACTIONS(41),
  },
  [763] = {
    [sym_parameter_list] = STATE(180),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_LBRACK] = ACTIONS(437),
    [sym_comment] = ACTIONS(41),
  },
  [764] = {
    [anon_sym_tensor] = ACTIONS(785),
    [anon_sym_indexvars] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(785),
    [sym_preproc_directive] = ACTIONS(785),
    [anon_sym_typedef] = ACTIONS(785),
    [anon_sym_extern] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(785),
    [anon_sym_auto] = ACTIONS(785),
    [anon_sym_register] = ACTIONS(785),
    [anon_sym_inline] = ACTIONS(785),
    [anon_sym_const] = ACTIONS(785),
    [anon_sym_restrict] = ACTIONS(785),
    [anon_sym_volatile] = ACTIONS(785),
    [anon_sym__Atomic] = ACTIONS(785),
    [anon_sym_unsigned] = ACTIONS(785),
    [anon_sym_long] = ACTIONS(785),
    [anon_sym_short] = ACTIONS(785),
    [sym_primitive_type] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_struct] = ACTIONS(785),
    [anon_sym_union] = ACTIONS(785),
    [sym_identifier] = ACTIONS(785),
    [sym_comment] = ACTIONS(41),
  },
  [765] = {
    [sym_ta_top_level] = STATE(329),
    [sym_preproc_include] = STATE(329),
    [sym_preproc_def] = STATE(329),
    [sym_preproc_function_def] = STATE(329),
    [sym_preproc_call] = STATE(329),
    [sym_preproc_if] = STATE(329),
    [sym_preproc_ifdef] = STATE(329),
    [sym_function_definition] = STATE(329),
    [sym_declaration] = STATE(329),
    [sym_type_definition] = STATE(329),
    [sym__declaration_specifiers] = STATE(18),
    [sym_linkage_specification] = STATE(329),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym__empty_declaration] = STATE(329),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_translation_unit_repeat1] = STATE(329),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_tensor] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2531),
    [anon_sym_indexvars] = ACTIONS(9),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(11),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(15),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(17),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(17),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [766] = {
    [anon_sym_tensor] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_indexvars] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(970),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(970),
    [sym_preproc_directive] = ACTIONS(970),
    [anon_sym_typedef] = ACTIONS(970),
    [anon_sym_extern] = ACTIONS(970),
    [anon_sym_STAR] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_auto] = ACTIONS(970),
    [anon_sym_register] = ACTIONS(970),
    [anon_sym_inline] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [anon_sym_restrict] = ACTIONS(970),
    [anon_sym_volatile] = ACTIONS(970),
    [anon_sym__Atomic] = ACTIONS(970),
    [anon_sym_unsigned] = ACTIONS(970),
    [anon_sym_long] = ACTIONS(970),
    [anon_sym_short] = ACTIONS(970),
    [sym_primitive_type] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_struct] = ACTIONS(970),
    [anon_sym_union] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(970),
    [anon_sym_case] = ACTIONS(970),
    [anon_sym_default] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_do] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_goto] = ACTIONS(970),
    [anon_sym_AMP] = ACTIONS(968),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_sizeof] = ACTIONS(970),
    [sym_number_literal] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_null] = ACTIONS(970),
    [sym_identifier] = ACTIONS(970),
    [sym_comment] = ACTIONS(41),
  },
  [767] = {
    [sym_preproc_include] = STATE(463),
    [sym_preproc_def] = STATE(463),
    [sym_preproc_function_def] = STATE(463),
    [sym_preproc_call] = STATE(463),
    [sym_preproc_if_in_compound_statement] = STATE(463),
    [sym_preproc_ifdef_in_compound_statement] = STATE(463),
    [sym_declaration] = STATE(463),
    [sym_type_definition] = STATE(463),
    [sym__declaration_specifiers] = STATE(246),
    [sym_compound_statement] = STATE(463),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(463),
    [sym_expression_statement] = STATE(463),
    [sym_if_statement] = STATE(463),
    [sym_switch_statement] = STATE(463),
    [sym_case_statement] = STATE(463),
    [sym_while_statement] = STATE(463),
    [sym_do_statement] = STATE(463),
    [sym_for_statement] = STATE(463),
    [sym_return_statement] = STATE(463),
    [sym_break_statement] = STATE(463),
    [sym_continue_statement] = STATE(463),
    [sym_goto_statement] = STATE(463),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(463),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(463),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_SEMI] = ACTIONS(539),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(541),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(13),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(545),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(545),
    [sym_preproc_directive] = ACTIONS(19),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(587),
    [sym_comment] = ACTIONS(41),
  },
  [768] = {
    [anon_sym_tensor] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1182),
    [anon_sym_SEMI] = ACTIONS(1182),
    [anon_sym_indexvars] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1184),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1184),
    [sym_preproc_directive] = ACTIONS(1184),
    [anon_sym_typedef] = ACTIONS(1184),
    [anon_sym_extern] = ACTIONS(1184),
    [anon_sym_STAR] = ACTIONS(1182),
    [anon_sym_static] = ACTIONS(1184),
    [anon_sym_auto] = ACTIONS(1184),
    [anon_sym_register] = ACTIONS(1184),
    [anon_sym_inline] = ACTIONS(1184),
    [anon_sym_const] = ACTIONS(1184),
    [anon_sym_restrict] = ACTIONS(1184),
    [anon_sym_volatile] = ACTIONS(1184),
    [anon_sym__Atomic] = ACTIONS(1184),
    [anon_sym_unsigned] = ACTIONS(1184),
    [anon_sym_long] = ACTIONS(1184),
    [anon_sym_short] = ACTIONS(1184),
    [sym_primitive_type] = ACTIONS(1184),
    [anon_sym_enum] = ACTIONS(1184),
    [anon_sym_struct] = ACTIONS(1184),
    [anon_sym_union] = ACTIONS(1184),
    [anon_sym_if] = ACTIONS(1184),
    [anon_sym_else] = ACTIONS(1184),
    [anon_sym_switch] = ACTIONS(1184),
    [anon_sym_case] = ACTIONS(1184),
    [anon_sym_default] = ACTIONS(1184),
    [anon_sym_while] = ACTIONS(1184),
    [anon_sym_do] = ACTIONS(1184),
    [anon_sym_for] = ACTIONS(1184),
    [anon_sym_return] = ACTIONS(1184),
    [anon_sym_break] = ACTIONS(1184),
    [anon_sym_continue] = ACTIONS(1184),
    [anon_sym_goto] = ACTIONS(1184),
    [anon_sym_AMP] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1182),
    [anon_sym_TILDE] = ACTIONS(1182),
    [anon_sym_PLUS] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1184),
    [anon_sym_DASH_DASH] = ACTIONS(1182),
    [anon_sym_PLUS_PLUS] = ACTIONS(1182),
    [anon_sym_sizeof] = ACTIONS(1184),
    [sym_number_literal] = ACTIONS(1182),
    [anon_sym_SQUOTE] = ACTIONS(1182),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [sym_true] = ACTIONS(1184),
    [sym_false] = ACTIONS(1184),
    [sym_null] = ACTIONS(1184),
    [sym_identifier] = ACTIONS(1184),
    [sym_comment] = ACTIONS(41),
  },
  [769] = {
    [anon_sym_tensor] = ACTIONS(1306),
    [anon_sym_LPAREN] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_indexvars] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1306),
    [sym_preproc_directive] = ACTIONS(1306),
    [anon_sym_typedef] = ACTIONS(1306),
    [anon_sym_extern] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1306),
    [anon_sym_auto] = ACTIONS(1306),
    [anon_sym_register] = ACTIONS(1306),
    [anon_sym_inline] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym_unsigned] = ACTIONS(1306),
    [anon_sym_long] = ACTIONS(1306),
    [anon_sym_short] = ACTIONS(1306),
    [sym_primitive_type] = ACTIONS(1306),
    [anon_sym_enum] = ACTIONS(1306),
    [anon_sym_struct] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1306),
    [anon_sym_case] = ACTIONS(1306),
    [anon_sym_default] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_do] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_goto] = ACTIONS(1306),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_sizeof] = ACTIONS(1306),
    [sym_number_literal] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [sym_null] = ACTIONS(1306),
    [sym_identifier] = ACTIONS(1306),
    [sym_comment] = ACTIONS(41),
  },
  [770] = {
    [anon_sym_tensor] = ACTIONS(1310),
    [anon_sym_indexvars] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1310),
    [sym_preproc_directive] = ACTIONS(1310),
    [anon_sym_typedef] = ACTIONS(1310),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_auto] = ACTIONS(1310),
    [anon_sym_register] = ACTIONS(1310),
    [anon_sym_inline] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [anon_sym_restrict] = ACTIONS(1310),
    [anon_sym_volatile] = ACTIONS(1310),
    [anon_sym__Atomic] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
    [anon_sym_struct] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1310),
    [sym_identifier] = ACTIONS(1310),
    [sym_comment] = ACTIONS(41),
  },
  [771] = {
    [anon_sym_tensor] = ACTIONS(1744),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(1742),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_indexvars] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1744),
    [sym_preproc_directive] = ACTIONS(1744),
    [anon_sym_typedef] = ACTIONS(1744),
    [anon_sym_extern] = ACTIONS(1744),
    [anon_sym_STAR] = ACTIONS(1742),
    [anon_sym_static] = ACTIONS(1744),
    [anon_sym_auto] = ACTIONS(1744),
    [anon_sym_register] = ACTIONS(1744),
    [anon_sym_inline] = ACTIONS(1744),
    [anon_sym_const] = ACTIONS(1744),
    [anon_sym_restrict] = ACTIONS(1744),
    [anon_sym_volatile] = ACTIONS(1744),
    [anon_sym__Atomic] = ACTIONS(1744),
    [anon_sym_unsigned] = ACTIONS(1744),
    [anon_sym_long] = ACTIONS(1744),
    [anon_sym_short] = ACTIONS(1744),
    [sym_primitive_type] = ACTIONS(1744),
    [anon_sym_enum] = ACTIONS(1744),
    [anon_sym_struct] = ACTIONS(1744),
    [anon_sym_union] = ACTIONS(1744),
    [anon_sym_if] = ACTIONS(1744),
    [anon_sym_else] = ACTIONS(1744),
    [anon_sym_switch] = ACTIONS(1744),
    [anon_sym_case] = ACTIONS(1744),
    [anon_sym_default] = ACTIONS(1744),
    [anon_sym_while] = ACTIONS(1744),
    [anon_sym_do] = ACTIONS(1744),
    [anon_sym_for] = ACTIONS(1744),
    [anon_sym_return] = ACTIONS(1744),
    [anon_sym_break] = ACTIONS(1744),
    [anon_sym_continue] = ACTIONS(1744),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1742),
    [anon_sym_BANG] = ACTIONS(1742),
    [anon_sym_TILDE] = ACTIONS(1742),
    [anon_sym_PLUS] = ACTIONS(1744),
    [anon_sym_DASH] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1742),
    [anon_sym_PLUS_PLUS] = ACTIONS(1742),
    [anon_sym_sizeof] = ACTIONS(1744),
    [sym_number_literal] = ACTIONS(1742),
    [anon_sym_SQUOTE] = ACTIONS(1742),
    [anon_sym_DQUOTE] = ACTIONS(1742),
    [sym_true] = ACTIONS(1744),
    [sym_false] = ACTIONS(1744),
    [sym_null] = ACTIONS(1744),
    [sym_identifier] = ACTIONS(1744),
    [sym_comment] = ACTIONS(41),
  },
  [772] = {
    [anon_sym_LPAREN] = ACTIONS(2535),
    [anon_sym_RPAREN] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2535),
    [sym_comment] = ACTIONS(41),
  },
  [773] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [774] = {
    [anon_sym_RPAREN] = ACTIONS(2537),
    [sym_comment] = ACTIONS(41),
  },
  [775] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_COMMA] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_QMARK] = ACTIONS(2448),
    [anon_sym_STAR_EQ] = ACTIONS(1326),
    [anon_sym_SLASH_EQ] = ACTIONS(1326),
    [anon_sym_PERCENT_EQ] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1326),
    [anon_sym_DASH_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_GT_EQ] = ACTIONS(1326),
    [anon_sym_AMP_EQ] = ACTIONS(1326),
    [anon_sym_CARET_EQ] = ACTIONS(1326),
    [anon_sym_PIPE_EQ] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(1330),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [776] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2539),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [777] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [778] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [779] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [780] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [781] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [782] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2460),
    [anon_sym_STAR_EQ] = ACTIONS(2460),
    [anon_sym_SLASH_EQ] = ACTIONS(2460),
    [anon_sym_PERCENT_EQ] = ACTIONS(2460),
    [anon_sym_PLUS_EQ] = ACTIONS(2460),
    [anon_sym_DASH_EQ] = ACTIONS(2460),
    [anon_sym_LT_LT_EQ] = ACTIONS(2460),
    [anon_sym_GT_GT_EQ] = ACTIONS(2460),
    [anon_sym_AMP_EQ] = ACTIONS(2460),
    [anon_sym_CARET_EQ] = ACTIONS(2460),
    [anon_sym_PIPE_EQ] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [783] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_STAR_EQ] = ACTIONS(2464),
    [anon_sym_SLASH_EQ] = ACTIONS(2464),
    [anon_sym_PERCENT_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_EQ] = ACTIONS(2464),
    [anon_sym_DASH_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_GT_EQ] = ACTIONS(2464),
    [anon_sym_AMP_EQ] = ACTIONS(2464),
    [anon_sym_CARET_EQ] = ACTIONS(2464),
    [anon_sym_PIPE_EQ] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [784] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_STAR_EQ] = ACTIONS(2468),
    [anon_sym_SLASH_EQ] = ACTIONS(2468),
    [anon_sym_PERCENT_EQ] = ACTIONS(2468),
    [anon_sym_PLUS_EQ] = ACTIONS(2468),
    [anon_sym_DASH_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_GT_EQ] = ACTIONS(2468),
    [anon_sym_AMP_EQ] = ACTIONS(2468),
    [anon_sym_CARET_EQ] = ACTIONS(2468),
    [anon_sym_PIPE_EQ] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT] = ACTIONS(2470),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [785] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_STAR_EQ] = ACTIONS(2442),
    [anon_sym_SLASH_EQ] = ACTIONS(2442),
    [anon_sym_PERCENT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_GT_EQ] = ACTIONS(2442),
    [anon_sym_AMP_EQ] = ACTIONS(2442),
    [anon_sym_CARET_EQ] = ACTIONS(2442),
    [anon_sym_PIPE_EQ] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [786] = {
    [sym_string_literal] = STATE(786),
    [aux_sym_concatenated_string_repeat1] = STATE(786),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_STAR_EQ] = ACTIONS(2476),
    [anon_sym_SLASH_EQ] = ACTIONS(2476),
    [anon_sym_PERCENT_EQ] = ACTIONS(2476),
    [anon_sym_PLUS_EQ] = ACTIONS(2476),
    [anon_sym_DASH_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_GT_EQ] = ACTIONS(2476),
    [anon_sym_AMP_EQ] = ACTIONS(2476),
    [anon_sym_CARET_EQ] = ACTIONS(2476),
    [anon_sym_PIPE_EQ] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2478),
    [anon_sym_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_DASH_GT] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(41),
  },
  [787] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(787),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(787),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(787),
    [sym_field_declaration] = STATE(787),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(787),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(871),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(871),
    [anon_sym_extern] = ACTIONS(874),
    [anon_sym_static] = ACTIONS(874),
    [anon_sym_auto] = ACTIONS(874),
    [anon_sym_register] = ACTIONS(874),
    [anon_sym_inline] = ACTIONS(874),
    [anon_sym_const] = ACTIONS(877),
    [anon_sym_restrict] = ACTIONS(877),
    [anon_sym_volatile] = ACTIONS(877),
    [anon_sym__Atomic] = ACTIONS(877),
    [anon_sym_unsigned] = ACTIONS(880),
    [anon_sym_long] = ACTIONS(880),
    [anon_sym_short] = ACTIONS(880),
    [sym_primitive_type] = ACTIONS(883),
    [anon_sym_enum] = ACTIONS(886),
    [anon_sym_struct] = ACTIONS(889),
    [anon_sym_union] = ACTIONS(892),
    [sym_identifier] = ACTIONS(895),
    [sym_comment] = ACTIONS(41),
  },
  [788] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2541),
    [sym_comment] = ACTIONS(41),
  },
  [789] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(563),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(563),
    [sym_preproc_else_in_field_declaration_list] = STATE(944),
    [sym_preproc_elif_in_field_declaration_list] = STATE(944),
    [sym__declaration_specifiers] = STATE(107),
    [sym_storage_class_specifier] = STATE(110),
    [sym_type_qualifier] = STATE(110),
    [sym__type_specifier] = STATE(108),
    [sym_sized_type_specifier] = STATE(108),
    [sym_enum_specifier] = STATE(108),
    [sym_struct_specifier] = STATE(108),
    [sym_union_specifier] = STATE(108),
    [sym__field_declaration_list_item] = STATE(563),
    [sym_field_declaration] = STATE(563),
    [sym_macro_type_specifier] = STATE(108),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(563),
    [aux_sym__declaration_specifiers_repeat1] = STATE(110),
    [aux_sym_sized_type_specifier_repeat1] = STATE(111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(207),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2541),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(209),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(820),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(822),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(211),
    [anon_sym_long] = ACTIONS(211),
    [anon_sym_short] = ACTIONS(211),
    [sym_primitive_type] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [sym_identifier] = ACTIONS(39),
    [sym_comment] = ACTIONS(41),
  },
  [790] = {
    [anon_sym_RBRACE] = ACTIONS(2543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2545),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2543),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2543),
    [anon_sym_extern] = ACTIONS(2545),
    [anon_sym_static] = ACTIONS(2545),
    [anon_sym_auto] = ACTIONS(2545),
    [anon_sym_register] = ACTIONS(2545),
    [anon_sym_inline] = ACTIONS(2545),
    [anon_sym_const] = ACTIONS(2545),
    [anon_sym_restrict] = ACTIONS(2545),
    [anon_sym_volatile] = ACTIONS(2545),
    [anon_sym__Atomic] = ACTIONS(2545),
    [anon_sym_unsigned] = ACTIONS(2545),
    [anon_sym_long] = ACTIONS(2545),
    [anon_sym_short] = ACTIONS(2545),
    [sym_primitive_type] = ACTIONS(2545),
    [anon_sym_enum] = ACTIONS(2545),
    [anon_sym_struct] = ACTIONS(2545),
    [anon_sym_union] = ACTIONS(2545),
    [sym_identifier] = ACTIONS(2545),
    [sym_comment] = ACTIONS(41),
  },
  [791] = {
    [anon_sym_RBRACE] = ACTIONS(2547),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2549),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2547),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2547),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2547),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2547),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2547),
    [anon_sym_extern] = ACTIONS(2549),
    [anon_sym_static] = ACTIONS(2549),
    [anon_sym_auto] = ACTIONS(2549),
    [anon_sym_register] = ACTIONS(2549),
    [anon_sym_inline] = ACTIONS(2549),
    [anon_sym_const] = ACTIONS(2549),
    [anon_sym_restrict] = ACTIONS(2549),
    [anon_sym_volatile] = ACTIONS(2549),
    [anon_sym__Atomic] = ACTIONS(2549),
    [anon_sym_unsigned] = ACTIONS(2549),
    [anon_sym_long] = ACTIONS(2549),
    [anon_sym_short] = ACTIONS(2549),
    [sym_primitive_type] = ACTIONS(2549),
    [anon_sym_enum] = ACTIONS(2549),
    [anon_sym_struct] = ACTIONS(2549),
    [anon_sym_union] = ACTIONS(2549),
    [sym_identifier] = ACTIONS(2549),
    [sym_comment] = ACTIONS(41),
  },
  [792] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [793] = {
    [anon_sym_RPAREN] = ACTIONS(2551),
    [sym_comment] = ACTIONS(41),
  },
  [794] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(2448),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [795] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [796] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [797] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [798] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [799] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [800] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [801] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2460),
    [anon_sym_STAR_EQ] = ACTIONS(2460),
    [anon_sym_SLASH_EQ] = ACTIONS(2460),
    [anon_sym_PERCENT_EQ] = ACTIONS(2460),
    [anon_sym_PLUS_EQ] = ACTIONS(2460),
    [anon_sym_DASH_EQ] = ACTIONS(2460),
    [anon_sym_LT_LT_EQ] = ACTIONS(2460),
    [anon_sym_GT_GT_EQ] = ACTIONS(2460),
    [anon_sym_AMP_EQ] = ACTIONS(2460),
    [anon_sym_CARET_EQ] = ACTIONS(2460),
    [anon_sym_PIPE_EQ] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [802] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_STAR_EQ] = ACTIONS(2464),
    [anon_sym_SLASH_EQ] = ACTIONS(2464),
    [anon_sym_PERCENT_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_EQ] = ACTIONS(2464),
    [anon_sym_DASH_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_GT_EQ] = ACTIONS(2464),
    [anon_sym_AMP_EQ] = ACTIONS(2464),
    [anon_sym_CARET_EQ] = ACTIONS(2464),
    [anon_sym_PIPE_EQ] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [803] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_STAR_EQ] = ACTIONS(2468),
    [anon_sym_SLASH_EQ] = ACTIONS(2468),
    [anon_sym_PERCENT_EQ] = ACTIONS(2468),
    [anon_sym_PLUS_EQ] = ACTIONS(2468),
    [anon_sym_DASH_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_GT_EQ] = ACTIONS(2468),
    [anon_sym_AMP_EQ] = ACTIONS(2468),
    [anon_sym_CARET_EQ] = ACTIONS(2468),
    [anon_sym_PIPE_EQ] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT] = ACTIONS(2470),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [804] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_STAR_EQ] = ACTIONS(2442),
    [anon_sym_SLASH_EQ] = ACTIONS(2442),
    [anon_sym_PERCENT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_GT_EQ] = ACTIONS(2442),
    [anon_sym_AMP_EQ] = ACTIONS(2442),
    [anon_sym_CARET_EQ] = ACTIONS(2442),
    [anon_sym_PIPE_EQ] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [805] = {
    [sym_string_literal] = STATE(805),
    [aux_sym_concatenated_string_repeat1] = STATE(805),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_STAR_EQ] = ACTIONS(2476),
    [anon_sym_SLASH_EQ] = ACTIONS(2476),
    [anon_sym_PERCENT_EQ] = ACTIONS(2476),
    [anon_sym_PLUS_EQ] = ACTIONS(2476),
    [anon_sym_DASH_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_GT_EQ] = ACTIONS(2476),
    [anon_sym_AMP_EQ] = ACTIONS(2476),
    [anon_sym_CARET_EQ] = ACTIONS(2476),
    [anon_sym_PIPE_EQ] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2478),
    [anon_sym_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_DASH_GT] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(41),
  },
  [806] = {
    [anon_sym_LPAREN] = ACTIONS(2555),
    [anon_sym_RPAREN] = ACTIONS(2555),
    [anon_sym_SEMI] = ACTIONS(2555),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_LBRACK] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2555),
    [sym_comment] = ACTIONS(41),
  },
  [807] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [808] = {
    [anon_sym_RBRACE] = ACTIONS(2559),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2561),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2559),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2559),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2559),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2559),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2559),
    [anon_sym_extern] = ACTIONS(2561),
    [anon_sym_static] = ACTIONS(2561),
    [anon_sym_auto] = ACTIONS(2561),
    [anon_sym_register] = ACTIONS(2561),
    [anon_sym_inline] = ACTIONS(2561),
    [anon_sym_const] = ACTIONS(2561),
    [anon_sym_restrict] = ACTIONS(2561),
    [anon_sym_volatile] = ACTIONS(2561),
    [anon_sym__Atomic] = ACTIONS(2561),
    [anon_sym_unsigned] = ACTIONS(2561),
    [anon_sym_long] = ACTIONS(2561),
    [anon_sym_short] = ACTIONS(2561),
    [sym_primitive_type] = ACTIONS(2561),
    [anon_sym_enum] = ACTIONS(2561),
    [anon_sym_struct] = ACTIONS(2561),
    [anon_sym_union] = ACTIONS(2561),
    [sym_identifier] = ACTIONS(2561),
    [sym_comment] = ACTIONS(41),
  },
  [809] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [810] = {
    [anon_sym_LPAREN] = ACTIONS(2565),
    [anon_sym_RPAREN] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_LBRACK] = ACTIONS(2565),
    [sym_comment] = ACTIONS(41),
  },
  [811] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [812] = {
    [sym__declarator] = STATE(214),
    [sym__abstract_declarator] = STATE(594),
    [sym_pointer_declarator] = STATE(214),
    [sym_abstract_pointer_declarator] = STATE(594),
    [sym_function_declarator] = STATE(214),
    [sym_abstract_function_declarator] = STATE(594),
    [sym_array_declarator] = STATE(214),
    [sym_abstract_array_declarator] = STATE(594),
    [sym_type_qualifier] = STATE(950),
    [sym_parameter_list] = STATE(208),
    [aux_sym_type_definition_repeat1] = STATE(950),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_RPAREN] = ACTIONS(1435),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [sym_identifier] = ACTIONS(525),
    [sym_comment] = ACTIONS(41),
  },
  [813] = {
    [sym_type_qualifier] = STATE(813),
    [aux_sym_type_definition_repeat1] = STATE(813),
    [anon_sym_LPAREN] = ACTIONS(928),
    [anon_sym_RPAREN] = ACTIONS(928),
    [anon_sym_COMMA] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(928),
    [anon_sym_const] = ACTIONS(439),
    [anon_sym_restrict] = ACTIONS(439),
    [anon_sym_volatile] = ACTIONS(439),
    [anon_sym__Atomic] = ACTIONS(439),
    [sym_identifier] = ACTIONS(442),
    [sym_comment] = ACTIONS(41),
  },
  [814] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [815] = {
    [anon_sym_RPAREN] = ACTIONS(2569),
    [sym_comment] = ACTIONS(41),
  },
  [816] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2440),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [817] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_COMMA] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(2448),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [818] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2571),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [819] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [820] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [821] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [822] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [823] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [824] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2460),
    [anon_sym_STAR_EQ] = ACTIONS(2460),
    [anon_sym_SLASH_EQ] = ACTIONS(2460),
    [anon_sym_PERCENT_EQ] = ACTIONS(2460),
    [anon_sym_PLUS_EQ] = ACTIONS(2460),
    [anon_sym_DASH_EQ] = ACTIONS(2460),
    [anon_sym_LT_LT_EQ] = ACTIONS(2460),
    [anon_sym_GT_GT_EQ] = ACTIONS(2460),
    [anon_sym_AMP_EQ] = ACTIONS(2460),
    [anon_sym_CARET_EQ] = ACTIONS(2460),
    [anon_sym_PIPE_EQ] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [825] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_STAR_EQ] = ACTIONS(2464),
    [anon_sym_SLASH_EQ] = ACTIONS(2464),
    [anon_sym_PERCENT_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_EQ] = ACTIONS(2464),
    [anon_sym_DASH_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_GT_EQ] = ACTIONS(2464),
    [anon_sym_AMP_EQ] = ACTIONS(2464),
    [anon_sym_CARET_EQ] = ACTIONS(2464),
    [anon_sym_PIPE_EQ] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [826] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_STAR_EQ] = ACTIONS(2468),
    [anon_sym_SLASH_EQ] = ACTIONS(2468),
    [anon_sym_PERCENT_EQ] = ACTIONS(2468),
    [anon_sym_PLUS_EQ] = ACTIONS(2468),
    [anon_sym_DASH_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_GT_EQ] = ACTIONS(2468),
    [anon_sym_AMP_EQ] = ACTIONS(2468),
    [anon_sym_CARET_EQ] = ACTIONS(2468),
    [anon_sym_PIPE_EQ] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT] = ACTIONS(2470),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [827] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_STAR_EQ] = ACTIONS(2442),
    [anon_sym_SLASH_EQ] = ACTIONS(2442),
    [anon_sym_PERCENT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_GT_EQ] = ACTIONS(2442),
    [anon_sym_AMP_EQ] = ACTIONS(2442),
    [anon_sym_CARET_EQ] = ACTIONS(2442),
    [anon_sym_PIPE_EQ] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [828] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2573),
    [anon_sym_COMMA] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2575),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(2573),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_COLON] = ACTIONS(2573),
    [anon_sym_QMARK] = ACTIONS(2573),
    [anon_sym_STAR_EQ] = ACTIONS(2573),
    [anon_sym_SLASH_EQ] = ACTIONS(2573),
    [anon_sym_PERCENT_EQ] = ACTIONS(2573),
    [anon_sym_PLUS_EQ] = ACTIONS(2573),
    [anon_sym_DASH_EQ] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2573),
    [anon_sym_AMP_EQ] = ACTIONS(2573),
    [anon_sym_CARET_EQ] = ACTIONS(2573),
    [anon_sym_PIPE_EQ] = ACTIONS(2573),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2573),
    [anon_sym_AMP_AMP] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_CARET] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2573),
    [anon_sym_BANG_EQ] = ACTIONS(2573),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_LT_LT] = ACTIONS(2575),
    [anon_sym_GT_GT] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2575),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [829] = {
    [anon_sym_LPAREN] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_RBRACK] = ACTIONS(2577),
    [anon_sym_EQ] = ACTIONS(2579),
    [anon_sym_COLON] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_STAR_EQ] = ACTIONS(2577),
    [anon_sym_SLASH_EQ] = ACTIONS(2577),
    [anon_sym_PERCENT_EQ] = ACTIONS(2577),
    [anon_sym_PLUS_EQ] = ACTIONS(2577),
    [anon_sym_DASH_EQ] = ACTIONS(2577),
    [anon_sym_LT_LT_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT_EQ] = ACTIONS(2577),
    [anon_sym_AMP_EQ] = ACTIONS(2577),
    [anon_sym_CARET_EQ] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_AMP] = ACTIONS(2579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_PIPE] = ACTIONS(2579),
    [anon_sym_CARET] = ACTIONS(2579),
    [anon_sym_EQ_EQ] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_LT] = ACTIONS(2579),
    [anon_sym_GT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2577),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_GT_GT] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_SLASH] = ACTIONS(2579),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2577),
    [anon_sym_PLUS_PLUS] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2577),
    [anon_sym_DASH_GT] = ACTIONS(2577),
    [sym_comment] = ACTIONS(41),
  },
  [830] = {
    [sym_string_literal] = STATE(830),
    [aux_sym_concatenated_string_repeat1] = STATE(830),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_RPAREN] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_STAR_EQ] = ACTIONS(2476),
    [anon_sym_SLASH_EQ] = ACTIONS(2476),
    [anon_sym_PERCENT_EQ] = ACTIONS(2476),
    [anon_sym_PLUS_EQ] = ACTIONS(2476),
    [anon_sym_DASH_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_GT_EQ] = ACTIONS(2476),
    [anon_sym_AMP_EQ] = ACTIONS(2476),
    [anon_sym_CARET_EQ] = ACTIONS(2476),
    [anon_sym_PIPE_EQ] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2478),
    [anon_sym_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_DASH_GT] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(41),
  },
  [831] = {
    [anon_sym_LPAREN] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(649),
    [sym_preproc_directive] = ACTIONS(649),
    [anon_sym_typedef] = ACTIONS(649),
    [anon_sym_extern] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_static] = ACTIONS(649),
    [anon_sym_auto] = ACTIONS(649),
    [anon_sym_register] = ACTIONS(649),
    [anon_sym_inline] = ACTIONS(649),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_restrict] = ACTIONS(649),
    [anon_sym_volatile] = ACTIONS(649),
    [anon_sym__Atomic] = ACTIONS(649),
    [anon_sym_unsigned] = ACTIONS(649),
    [anon_sym_long] = ACTIONS(649),
    [anon_sym_short] = ACTIONS(649),
    [sym_primitive_type] = ACTIONS(649),
    [anon_sym_enum] = ACTIONS(649),
    [anon_sym_struct] = ACTIONS(649),
    [anon_sym_union] = ACTIONS(649),
    [anon_sym_if] = ACTIONS(649),
    [anon_sym_switch] = ACTIONS(649),
    [anon_sym_case] = ACTIONS(649),
    [anon_sym_default] = ACTIONS(649),
    [anon_sym_while] = ACTIONS(649),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(649),
    [anon_sym_break] = ACTIONS(649),
    [anon_sym_continue] = ACTIONS(649),
    [anon_sym_goto] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(649),
    [anon_sym_DASH_DASH] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(647),
    [anon_sym_sizeof] = ACTIONS(649),
    [sym_number_literal] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(647),
    [anon_sym_DQUOTE] = ACTIONS(647),
    [sym_true] = ACTIONS(649),
    [sym_false] = ACTIONS(649),
    [sym_null] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_comment] = ACTIONS(41),
  },
  [832] = {
    [sym_preproc_include] = STATE(955),
    [sym_preproc_def] = STATE(955),
    [sym_preproc_function_def] = STATE(955),
    [sym_preproc_call] = STATE(955),
    [sym_preproc_if_in_compound_statement] = STATE(955),
    [sym_preproc_ifdef_in_compound_statement] = STATE(955),
    [sym_preproc_else_in_compound_statement] = STATE(954),
    [sym_preproc_elif_in_compound_statement] = STATE(954),
    [sym_declaration] = STATE(955),
    [sym_type_definition] = STATE(955),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(955),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(955),
    [sym_expression_statement] = STATE(955),
    [sym_if_statement] = STATE(955),
    [sym_switch_statement] = STATE(955),
    [sym_case_statement] = STATE(955),
    [sym_while_statement] = STATE(955),
    [sym_do_statement] = STATE(955),
    [sym_for_statement] = STATE(955),
    [sym_return_statement] = STATE(955),
    [sym_break_statement] = STATE(955),
    [sym_continue_statement] = STATE(955),
    [sym_goto_statement] = STATE(955),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(955),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(955),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2581),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [833] = {
    [sym_preproc_include] = STATE(958),
    [sym_preproc_def] = STATE(958),
    [sym_preproc_function_def] = STATE(958),
    [sym_preproc_call] = STATE(958),
    [sym_preproc_if_in_compound_statement] = STATE(958),
    [sym_preproc_ifdef_in_compound_statement] = STATE(958),
    [sym_preproc_else_in_compound_statement] = STATE(957),
    [sym_preproc_elif_in_compound_statement] = STATE(957),
    [sym_declaration] = STATE(958),
    [sym_type_definition] = STATE(958),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(958),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(958),
    [sym_expression_statement] = STATE(958),
    [sym_if_statement] = STATE(958),
    [sym_switch_statement] = STATE(958),
    [sym_case_statement] = STATE(958),
    [sym_while_statement] = STATE(958),
    [sym_do_statement] = STATE(958),
    [sym_for_statement] = STATE(958),
    [sym_return_statement] = STATE(958),
    [sym_break_statement] = STATE(958),
    [sym_continue_statement] = STATE(958),
    [sym_goto_statement] = STATE(958),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(958),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(958),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [834] = {
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(972),
    [anon_sym_SEMI] = ACTIONS(972),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(974),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(974),
    [sym_preproc_directive] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(974),
    [anon_sym_extern] = ACTIONS(974),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_static] = ACTIONS(974),
    [anon_sym_auto] = ACTIONS(974),
    [anon_sym_register] = ACTIONS(974),
    [anon_sym_inline] = ACTIONS(974),
    [anon_sym_const] = ACTIONS(974),
    [anon_sym_restrict] = ACTIONS(974),
    [anon_sym_volatile] = ACTIONS(974),
    [anon_sym__Atomic] = ACTIONS(974),
    [anon_sym_unsigned] = ACTIONS(974),
    [anon_sym_long] = ACTIONS(974),
    [anon_sym_short] = ACTIONS(974),
    [sym_primitive_type] = ACTIONS(974),
    [anon_sym_enum] = ACTIONS(974),
    [anon_sym_struct] = ACTIONS(974),
    [anon_sym_union] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(974),
    [anon_sym_else] = ACTIONS(974),
    [anon_sym_switch] = ACTIONS(974),
    [anon_sym_case] = ACTIONS(974),
    [anon_sym_default] = ACTIONS(974),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_do] = ACTIONS(974),
    [anon_sym_for] = ACTIONS(974),
    [anon_sym_return] = ACTIONS(974),
    [anon_sym_break] = ACTIONS(974),
    [anon_sym_continue] = ACTIONS(974),
    [anon_sym_goto] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(972),
    [anon_sym_BANG] = ACTIONS(972),
    [anon_sym_TILDE] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(974),
    [anon_sym_DASH_DASH] = ACTIONS(972),
    [anon_sym_PLUS_PLUS] = ACTIONS(972),
    [anon_sym_sizeof] = ACTIONS(974),
    [sym_number_literal] = ACTIONS(972),
    [anon_sym_SQUOTE] = ACTIONS(972),
    [anon_sym_DQUOTE] = ACTIONS(972),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [sym_null] = ACTIONS(974),
    [sym_identifier] = ACTIONS(974),
    [sym_comment] = ACTIONS(41),
  },
  [835] = {
    [sym_preproc_arg] = ACTIONS(2585),
    [sym_comment] = ACTIONS(55),
  },
  [836] = {
    [sym_identifier] = ACTIONS(2587),
    [sym_comment] = ACTIONS(41),
  },
  [837] = {
    [sym_parenthesized_expression] = STATE(961),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [838] = {
    [sym_parenthesized_expression] = STATE(962),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [839] = {
    [sym__expression] = STATE(963),
    [sym_conditional_expression] = STATE(963),
    [sym_assignment_expression] = STATE(963),
    [sym_pointer_expression] = STATE(963),
    [sym_logical_expression] = STATE(963),
    [sym_bitwise_expression] = STATE(963),
    [sym_equality_expression] = STATE(963),
    [sym_relational_expression] = STATE(963),
    [sym_shift_expression] = STATE(963),
    [sym_math_expression] = STATE(963),
    [sym_cast_expression] = STATE(963),
    [sym_sizeof_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_call_expression] = STATE(963),
    [sym_field_expression] = STATE(963),
    [sym_compound_literal_expression] = STATE(963),
    [sym_parenthesized_expression] = STATE(963),
    [sym_char_literal] = STATE(963),
    [sym_concatenated_string] = STATE(963),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2589),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2591),
    [sym_false] = ACTIONS(2591),
    [sym_null] = ACTIONS(2591),
    [sym_identifier] = ACTIONS(2591),
    [sym_comment] = ACTIONS(41),
  },
  [840] = {
    [anon_sym_COLON] = ACTIONS(2593),
    [sym_comment] = ACTIONS(41),
  },
  [841] = {
    [sym_parenthesized_expression] = STATE(965),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [842] = {
    [sym_compound_statement] = STATE(966),
    [sym_labeled_statement] = STATE(966),
    [sym_expression_statement] = STATE(966),
    [sym_if_statement] = STATE(966),
    [sym_switch_statement] = STATE(966),
    [sym_case_statement] = STATE(966),
    [sym_while_statement] = STATE(966),
    [sym_do_statement] = STATE(966),
    [sym_for_statement] = STATE(966),
    [sym_return_statement] = STATE(966),
    [sym_break_statement] = STATE(966),
    [sym_continue_statement] = STATE(966),
    [sym_goto_statement] = STATE(966),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [843] = {
    [anon_sym_LPAREN] = ACTIONS(2595),
    [sym_comment] = ACTIONS(41),
  },
  [844] = {
    [sym__expression] = STATE(969),
    [sym_conditional_expression] = STATE(969),
    [sym_assignment_expression] = STATE(969),
    [sym_pointer_expression] = STATE(969),
    [sym_logical_expression] = STATE(969),
    [sym_bitwise_expression] = STATE(969),
    [sym_equality_expression] = STATE(969),
    [sym_relational_expression] = STATE(969),
    [sym_shift_expression] = STATE(969),
    [sym_math_expression] = STATE(969),
    [sym_cast_expression] = STATE(969),
    [sym_sizeof_expression] = STATE(969),
    [sym_subscript_expression] = STATE(969),
    [sym_call_expression] = STATE(969),
    [sym_field_expression] = STATE(969),
    [sym_compound_literal_expression] = STATE(969),
    [sym_parenthesized_expression] = STATE(969),
    [sym_char_literal] = STATE(969),
    [sym_concatenated_string] = STATE(969),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(2597),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2601),
    [sym_false] = ACTIONS(2601),
    [sym_null] = ACTIONS(2601),
    [sym_identifier] = ACTIONS(2601),
    [sym_comment] = ACTIONS(41),
  },
  [845] = {
    [anon_sym_SEMI] = ACTIONS(2603),
    [sym_comment] = ACTIONS(41),
  },
  [846] = {
    [anon_sym_SEMI] = ACTIONS(2605),
    [sym_comment] = ACTIONS(41),
  },
  [847] = {
    [sym_identifier] = ACTIONS(2607),
    [sym_comment] = ACTIONS(41),
  },
  [848] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1064),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [849] = {
    [sym__declarator] = STATE(974),
    [sym_pointer_declarator] = STATE(974),
    [sym_function_declarator] = STATE(974),
    [sym_array_declarator] = STATE(974),
    [sym_init_declarator] = STATE(305),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_SEMI] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(593),
    [sym_identifier] = ACTIONS(2611),
    [sym_comment] = ACTIONS(41),
  },
  [850] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2613),
    [anon_sym_COMMA] = ACTIONS(1082),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1088),
    [anon_sym_QMARK] = ACTIONS(1090),
    [anon_sym_STAR_EQ] = ACTIONS(1092),
    [anon_sym_SLASH_EQ] = ACTIONS(1092),
    [anon_sym_PERCENT_EQ] = ACTIONS(1092),
    [anon_sym_PLUS_EQ] = ACTIONS(1092),
    [anon_sym_DASH_EQ] = ACTIONS(1092),
    [anon_sym_LT_LT_EQ] = ACTIONS(1092),
    [anon_sym_GT_GT_EQ] = ACTIONS(1092),
    [anon_sym_AMP_EQ] = ACTIONS(1092),
    [anon_sym_CARET_EQ] = ACTIONS(1092),
    [anon_sym_PIPE_EQ] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [851] = {
    [anon_sym_SEMI] = ACTIONS(2613),
    [sym_comment] = ACTIONS(41),
  },
  [852] = {
    [sym_preproc_include] = STATE(976),
    [sym_preproc_def] = STATE(976),
    [sym_preproc_function_def] = STATE(976),
    [sym_preproc_call] = STATE(976),
    [sym_preproc_if_in_compound_statement] = STATE(976),
    [sym_preproc_ifdef_in_compound_statement] = STATE(976),
    [sym_declaration] = STATE(976),
    [sym_type_definition] = STATE(976),
    [sym__declaration_specifiers] = STATE(849),
    [sym_compound_statement] = STATE(976),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(976),
    [sym_expression_statement] = STATE(976),
    [sym_if_statement] = STATE(976),
    [sym_switch_statement] = STATE(976),
    [sym_case_statement] = STATE(976),
    [sym_while_statement] = STATE(976),
    [sym_do_statement] = STATE(976),
    [sym_for_statement] = STATE(976),
    [sym_return_statement] = STATE(976),
    [sym_break_statement] = STATE(976),
    [sym_continue_statement] = STATE(976),
    [sym_goto_statement] = STATE(976),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(976),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(976),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2230),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2234),
    [sym_preproc_directive] = ACTIONS(395),
    [anon_sym_typedef] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(41),
  },
  [853] = {
    [sym_preproc_include] = STATE(978),
    [sym_preproc_def] = STATE(978),
    [sym_preproc_function_def] = STATE(978),
    [sym_preproc_call] = STATE(978),
    [sym_preproc_if_in_compound_statement] = STATE(978),
    [sym_preproc_ifdef_in_compound_statement] = STATE(978),
    [sym_preproc_else_in_compound_statement] = STATE(977),
    [sym_preproc_elif_in_compound_statement] = STATE(977),
    [sym_declaration] = STATE(978),
    [sym_type_definition] = STATE(978),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(978),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(978),
    [sym_expression_statement] = STATE(978),
    [sym_if_statement] = STATE(978),
    [sym_switch_statement] = STATE(978),
    [sym_case_statement] = STATE(978),
    [sym_while_statement] = STATE(978),
    [sym_do_statement] = STATE(978),
    [sym_for_statement] = STATE(978),
    [sym_return_statement] = STATE(978),
    [sym_break_statement] = STATE(978),
    [sym_continue_statement] = STATE(978),
    [sym_goto_statement] = STATE(978),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(978),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [854] = {
    [sym_compound_statement] = STATE(986),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [855] = {
    [sym_compound_statement] = STATE(988),
    [sym_labeled_statement] = STATE(988),
    [sym_expression_statement] = STATE(988),
    [sym_if_statement] = STATE(988),
    [sym_switch_statement] = STATE(988),
    [sym_case_statement] = STATE(988),
    [sym_while_statement] = STATE(988),
    [sym_do_statement] = STATE(988),
    [sym_for_statement] = STATE(988),
    [sym_return_statement] = STATE(988),
    [sym_break_statement] = STATE(988),
    [sym_continue_statement] = STATE(988),
    [sym_goto_statement] = STATE(988),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2633),
    [sym_comment] = ACTIONS(41),
  },
  [856] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2635),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [857] = {
    [sym_declaration] = STATE(991),
    [sym_type_definition] = STATE(991),
    [sym__declaration_specifiers] = STATE(992),
    [sym_compound_statement] = STATE(991),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(991),
    [sym_expression_statement] = STATE(991),
    [sym_if_statement] = STATE(991),
    [sym_switch_statement] = STATE(991),
    [sym_case_statement] = STATE(991),
    [sym_while_statement] = STATE(991),
    [sym_do_statement] = STATE(991),
    [sym_for_statement] = STATE(991),
    [sym_return_statement] = STATE(991),
    [sym_break_statement] = STATE(991),
    [sym_continue_statement] = STATE(991),
    [sym_goto_statement] = STATE(991),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2637),
    [sym_comment] = ACTIONS(41),
  },
  [858] = {
    [sym_compound_statement] = STATE(993),
    [sym_labeled_statement] = STATE(993),
    [sym_expression_statement] = STATE(993),
    [sym_if_statement] = STATE(993),
    [sym_switch_statement] = STATE(993),
    [sym_case_statement] = STATE(993),
    [sym_while_statement] = STATE(993),
    [sym_do_statement] = STATE(993),
    [sym_for_statement] = STATE(993),
    [sym_return_statement] = STATE(993),
    [sym_break_statement] = STATE(993),
    [sym_continue_statement] = STATE(993),
    [sym_goto_statement] = STATE(993),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2633),
    [sym_comment] = ACTIONS(41),
  },
  [859] = {
    [anon_sym_while] = ACTIONS(2639),
    [sym_comment] = ACTIONS(41),
  },
  [860] = {
    [sym_declaration] = STATE(995),
    [sym__declaration_specifiers] = STATE(685),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym__expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_assignment_expression] = STATE(996),
    [sym_pointer_expression] = STATE(996),
    [sym_logical_expression] = STATE(996),
    [sym_bitwise_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_math_expression] = STATE(996),
    [sym_cast_expression] = STATE(996),
    [sym_sizeof_expression] = STATE(996),
    [sym_subscript_expression] = STATE(996),
    [sym_call_expression] = STATE(996),
    [sym_field_expression] = STATE(996),
    [sym_compound_literal_expression] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym_char_literal] = STATE(996),
    [sym_concatenated_string] = STATE(996),
    [sym_string_literal] = STATE(363),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2643),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2645),
    [sym_false] = ACTIONS(2645),
    [sym_null] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(1630),
    [sym_comment] = ACTIONS(41),
  },
  [861] = {
    [anon_sym_LPAREN] = ACTIONS(1632),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_SEMI] = ACTIONS(1632),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1634),
    [sym_preproc_directive] = ACTIONS(1634),
    [anon_sym_typedef] = ACTIONS(1634),
    [anon_sym_extern] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_static] = ACTIONS(1634),
    [anon_sym_auto] = ACTIONS(1634),
    [anon_sym_register] = ACTIONS(1634),
    [anon_sym_inline] = ACTIONS(1634),
    [anon_sym_const] = ACTIONS(1634),
    [anon_sym_restrict] = ACTIONS(1634),
    [anon_sym_volatile] = ACTIONS(1634),
    [anon_sym__Atomic] = ACTIONS(1634),
    [anon_sym_unsigned] = ACTIONS(1634),
    [anon_sym_long] = ACTIONS(1634),
    [anon_sym_short] = ACTIONS(1634),
    [sym_primitive_type] = ACTIONS(1634),
    [anon_sym_enum] = ACTIONS(1634),
    [anon_sym_struct] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_if] = ACTIONS(1634),
    [anon_sym_else] = ACTIONS(1634),
    [anon_sym_switch] = ACTIONS(1634),
    [anon_sym_case] = ACTIONS(1634),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_while] = ACTIONS(1634),
    [anon_sym_do] = ACTIONS(1634),
    [anon_sym_for] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1634),
    [anon_sym_break] = ACTIONS(1634),
    [anon_sym_continue] = ACTIONS(1634),
    [anon_sym_goto] = ACTIONS(1634),
    [anon_sym_AMP] = ACTIONS(1632),
    [anon_sym_BANG] = ACTIONS(1632),
    [anon_sym_TILDE] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1634),
    [anon_sym_DASH] = ACTIONS(1634),
    [anon_sym_DASH_DASH] = ACTIONS(1632),
    [anon_sym_PLUS_PLUS] = ACTIONS(1632),
    [anon_sym_sizeof] = ACTIONS(1634),
    [sym_number_literal] = ACTIONS(1632),
    [anon_sym_SQUOTE] = ACTIONS(1632),
    [anon_sym_DQUOTE] = ACTIONS(1632),
    [sym_true] = ACTIONS(1634),
    [sym_false] = ACTIONS(1634),
    [sym_null] = ACTIONS(1634),
    [sym_identifier] = ACTIONS(1634),
    [sym_comment] = ACTIONS(41),
  },
  [862] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [863] = {
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_LBRACE] = ACTIONS(1638),
    [anon_sym_SEMI] = ACTIONS(1638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1640),
    [sym_preproc_directive] = ACTIONS(1640),
    [anon_sym_typedef] = ACTIONS(1640),
    [anon_sym_extern] = ACTIONS(1640),
    [anon_sym_STAR] = ACTIONS(1638),
    [anon_sym_static] = ACTIONS(1640),
    [anon_sym_auto] = ACTIONS(1640),
    [anon_sym_register] = ACTIONS(1640),
    [anon_sym_inline] = ACTIONS(1640),
    [anon_sym_const] = ACTIONS(1640),
    [anon_sym_restrict] = ACTIONS(1640),
    [anon_sym_volatile] = ACTIONS(1640),
    [anon_sym__Atomic] = ACTIONS(1640),
    [anon_sym_unsigned] = ACTIONS(1640),
    [anon_sym_long] = ACTIONS(1640),
    [anon_sym_short] = ACTIONS(1640),
    [sym_primitive_type] = ACTIONS(1640),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1640),
    [anon_sym_union] = ACTIONS(1640),
    [anon_sym_if] = ACTIONS(1640),
    [anon_sym_else] = ACTIONS(1640),
    [anon_sym_switch] = ACTIONS(1640),
    [anon_sym_case] = ACTIONS(1640),
    [anon_sym_default] = ACTIONS(1640),
    [anon_sym_while] = ACTIONS(1640),
    [anon_sym_do] = ACTIONS(1640),
    [anon_sym_for] = ACTIONS(1640),
    [anon_sym_return] = ACTIONS(1640),
    [anon_sym_break] = ACTIONS(1640),
    [anon_sym_continue] = ACTIONS(1640),
    [anon_sym_goto] = ACTIONS(1640),
    [anon_sym_AMP] = ACTIONS(1638),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1638),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_DASH_DASH] = ACTIONS(1638),
    [anon_sym_PLUS_PLUS] = ACTIONS(1638),
    [anon_sym_sizeof] = ACTIONS(1640),
    [sym_number_literal] = ACTIONS(1638),
    [anon_sym_SQUOTE] = ACTIONS(1638),
    [anon_sym_DQUOTE] = ACTIONS(1638),
    [sym_true] = ACTIONS(1640),
    [sym_false] = ACTIONS(1640),
    [sym_null] = ACTIONS(1640),
    [sym_identifier] = ACTIONS(1640),
    [sym_comment] = ACTIONS(41),
  },
  [864] = {
    [anon_sym_LPAREN] = ACTIONS(1642),
    [anon_sym_LBRACE] = ACTIONS(1642),
    [anon_sym_SEMI] = ACTIONS(1642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1644),
    [sym_preproc_directive] = ACTIONS(1644),
    [anon_sym_typedef] = ACTIONS(1644),
    [anon_sym_extern] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1642),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_auto] = ACTIONS(1644),
    [anon_sym_register] = ACTIONS(1644),
    [anon_sym_inline] = ACTIONS(1644),
    [anon_sym_const] = ACTIONS(1644),
    [anon_sym_restrict] = ACTIONS(1644),
    [anon_sym_volatile] = ACTIONS(1644),
    [anon_sym__Atomic] = ACTIONS(1644),
    [anon_sym_unsigned] = ACTIONS(1644),
    [anon_sym_long] = ACTIONS(1644),
    [anon_sym_short] = ACTIONS(1644),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1644),
    [anon_sym_struct] = ACTIONS(1644),
    [anon_sym_union] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_else] = ACTIONS(1644),
    [anon_sym_switch] = ACTIONS(1644),
    [anon_sym_case] = ACTIONS(1644),
    [anon_sym_default] = ACTIONS(1644),
    [anon_sym_while] = ACTIONS(1644),
    [anon_sym_do] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_return] = ACTIONS(1644),
    [anon_sym_break] = ACTIONS(1644),
    [anon_sym_continue] = ACTIONS(1644),
    [anon_sym_goto] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1642),
    [anon_sym_TILDE] = ACTIONS(1642),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_DASH_DASH] = ACTIONS(1642),
    [anon_sym_PLUS_PLUS] = ACTIONS(1642),
    [anon_sym_sizeof] = ACTIONS(1644),
    [sym_number_literal] = ACTIONS(1642),
    [anon_sym_SQUOTE] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1644),
    [sym_comment] = ACTIONS(41),
  },
  [865] = {
    [anon_sym_SEMI] = ACTIONS(2649),
    [sym_comment] = ACTIONS(41),
  },
  [866] = {
    [sym_compound_statement] = STATE(999),
    [sym_labeled_statement] = STATE(999),
    [sym_expression_statement] = STATE(999),
    [sym_if_statement] = STATE(999),
    [sym_switch_statement] = STATE(999),
    [sym_case_statement] = STATE(999),
    [sym_while_statement] = STATE(999),
    [sym_do_statement] = STATE(999),
    [sym_for_statement] = STATE(999),
    [sym_return_statement] = STATE(999),
    [sym_break_statement] = STATE(999),
    [sym_continue_statement] = STATE(999),
    [sym_goto_statement] = STATE(999),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2633),
    [sym_comment] = ACTIONS(41),
  },
  [867] = {
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_RBRACE] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2651),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_auto] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [sym_primitive_type] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_sizeof] = ACTIONS(2653),
    [sym_number_literal] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [sym_null] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_comment] = ACTIONS(41),
  },
  [868] = {
    [sym_parameter_list] = STATE(129),
    [aux_sym_declaration_repeat1] = STATE(318),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(726),
    [anon_sym_COMMA] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(255),
    [sym_comment] = ACTIONS(41),
  },
  [869] = {
    [anon_sym_LPAREN] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_SEMI] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1674),
    [sym_preproc_directive] = ACTIONS(1674),
    [anon_sym_typedef] = ACTIONS(1674),
    [anon_sym_extern] = ACTIONS(1674),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1674),
    [anon_sym_auto] = ACTIONS(1674),
    [anon_sym_register] = ACTIONS(1674),
    [anon_sym_inline] = ACTIONS(1674),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_restrict] = ACTIONS(1674),
    [anon_sym_volatile] = ACTIONS(1674),
    [anon_sym__Atomic] = ACTIONS(1674),
    [anon_sym_unsigned] = ACTIONS(1674),
    [anon_sym_long] = ACTIONS(1674),
    [anon_sym_short] = ACTIONS(1674),
    [sym_primitive_type] = ACTIONS(1674),
    [anon_sym_enum] = ACTIONS(1674),
    [anon_sym_struct] = ACTIONS(1674),
    [anon_sym_union] = ACTIONS(1674),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_else] = ACTIONS(1674),
    [anon_sym_switch] = ACTIONS(1674),
    [anon_sym_case] = ACTIONS(1674),
    [anon_sym_default] = ACTIONS(1674),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1674),
    [anon_sym_for] = ACTIONS(1674),
    [anon_sym_return] = ACTIONS(1674),
    [anon_sym_break] = ACTIONS(1674),
    [anon_sym_continue] = ACTIONS(1674),
    [anon_sym_goto] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DASH_DASH] = ACTIONS(1672),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_sizeof] = ACTIONS(1674),
    [sym_number_literal] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1674),
    [sym_comment] = ACTIONS(41),
  },
  [870] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2655),
    [sym_comment] = ACTIONS(41),
  },
  [871] = {
    [sym_preproc_include] = STATE(871),
    [sym_preproc_def] = STATE(871),
    [sym_preproc_function_def] = STATE(871),
    [sym_preproc_call] = STATE(871),
    [sym_preproc_if_in_compound_statement] = STATE(871),
    [sym_preproc_ifdef_in_compound_statement] = STATE(871),
    [sym_declaration] = STATE(871),
    [sym_type_definition] = STATE(871),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(871),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(871),
    [sym_expression_statement] = STATE(871),
    [sym_if_statement] = STATE(871),
    [sym_switch_statement] = STATE(871),
    [sym_case_statement] = STATE(871),
    [sym_while_statement] = STATE(871),
    [sym_do_statement] = STATE(871),
    [sym_for_statement] = STATE(871),
    [sym_return_statement] = STATE(871),
    [sym_break_statement] = STATE(871),
    [sym_continue_statement] = STATE(871),
    [sym_goto_statement] = STATE(871),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(871),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(871),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(1746),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2660),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2663),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2666),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2669),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2672),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2680),
    [anon_sym_extern] = ACTIONS(1775),
    [anon_sym_STAR] = ACTIONS(1778),
    [anon_sym_static] = ACTIONS(1775),
    [anon_sym_auto] = ACTIONS(1775),
    [anon_sym_register] = ACTIONS(1775),
    [anon_sym_inline] = ACTIONS(1775),
    [anon_sym_const] = ACTIONS(1781),
    [anon_sym_restrict] = ACTIONS(1781),
    [anon_sym_volatile] = ACTIONS(1781),
    [anon_sym__Atomic] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1784),
    [anon_sym_long] = ACTIONS(1784),
    [anon_sym_short] = ACTIONS(1784),
    [sym_primitive_type] = ACTIONS(1787),
    [anon_sym_enum] = ACTIONS(1790),
    [anon_sym_struct] = ACTIONS(1793),
    [anon_sym_union] = ACTIONS(1796),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_switch] = ACTIONS(2686),
    [anon_sym_case] = ACTIONS(2689),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2704),
    [anon_sym_break] = ACTIONS(2707),
    [anon_sym_continue] = ACTIONS(2710),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(1778),
    [anon_sym_BANG] = ACTIONS(1832),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS] = ACTIONS(1838),
    [anon_sym_DASH] = ACTIONS(1838),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1844),
    [sym_number_literal] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(1850),
    [anon_sym_DQUOTE] = ACTIONS(1853),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [sym_null] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2722),
    [sym_comment] = ACTIONS(41),
  },
  [872] = {
    [anon_sym_LPAREN] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2725),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_auto] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [sym_null] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2727),
    [sym_comment] = ACTIONS(41),
  },
  [873] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2729),
    [sym_comment] = ACTIONS(41),
  },
  [874] = {
    [anon_sym_LPAREN] = ACTIONS(2162),
    [anon_sym_LBRACE] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_SEMI] = ACTIONS(2162),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2164),
    [sym_preproc_directive] = ACTIONS(2164),
    [anon_sym_typedef] = ACTIONS(2164),
    [anon_sym_extern] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_auto] = ACTIONS(2164),
    [anon_sym_register] = ACTIONS(2164),
    [anon_sym_inline] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_restrict] = ACTIONS(2164),
    [anon_sym_volatile] = ACTIONS(2164),
    [anon_sym__Atomic] = ACTIONS(2164),
    [anon_sym_unsigned] = ACTIONS(2164),
    [anon_sym_long] = ACTIONS(2164),
    [anon_sym_short] = ACTIONS(2164),
    [sym_primitive_type] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_else] = ACTIONS(2164),
    [anon_sym_switch] = ACTIONS(2164),
    [anon_sym_case] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [anon_sym_do] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_goto] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_PLUS] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2164),
    [anon_sym_DASH_DASH] = ACTIONS(2162),
    [anon_sym_PLUS_PLUS] = ACTIONS(2162),
    [anon_sym_sizeof] = ACTIONS(2164),
    [sym_number_literal] = ACTIONS(2162),
    [anon_sym_SQUOTE] = ACTIONS(2162),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [sym_true] = ACTIONS(2164),
    [sym_false] = ACTIONS(2164),
    [sym_null] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2164),
    [sym_comment] = ACTIONS(41),
  },
  [875] = {
    [sym_compound_statement] = STATE(1002),
    [sym_labeled_statement] = STATE(1002),
    [sym_expression_statement] = STATE(1002),
    [sym_if_statement] = STATE(1002),
    [sym_switch_statement] = STATE(1002),
    [sym_case_statement] = STATE(1002),
    [sym_while_statement] = STATE(1002),
    [sym_do_statement] = STATE(1002),
    [sym_for_statement] = STATE(1002),
    [sym_return_statement] = STATE(1002),
    [sym_break_statement] = STATE(1002),
    [sym_continue_statement] = STATE(1002),
    [sym_goto_statement] = STATE(1002),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [876] = {
    [sym_compound_statement] = STATE(665),
    [sym_labeled_statement] = STATE(665),
    [sym_expression_statement] = STATE(665),
    [sym_if_statement] = STATE(665),
    [sym_switch_statement] = STATE(665),
    [sym_case_statement] = STATE(665),
    [sym_while_statement] = STATE(665),
    [sym_do_statement] = STATE(665),
    [sym_for_statement] = STATE(665),
    [sym_return_statement] = STATE(665),
    [sym_break_statement] = STATE(665),
    [sym_continue_statement] = STATE(665),
    [sym_goto_statement] = STATE(665),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [877] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2731),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [878] = {
    [sym_declaration] = STATE(684),
    [sym_type_definition] = STATE(684),
    [sym__declaration_specifiers] = STATE(685),
    [sym_compound_statement] = STATE(684),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(684),
    [sym_expression_statement] = STATE(684),
    [sym_if_statement] = STATE(684),
    [sym_switch_statement] = STATE(684),
    [sym_case_statement] = STATE(684),
    [sym_while_statement] = STATE(684),
    [sym_do_statement] = STATE(684),
    [sym_for_statement] = STATE(684),
    [sym_return_statement] = STATE(684),
    [sym_break_statement] = STATE(684),
    [sym_continue_statement] = STATE(684),
    [sym_goto_statement] = STATE(684),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2733),
    [sym_comment] = ACTIONS(41),
  },
  [879] = {
    [sym_compound_statement] = STATE(686),
    [sym_labeled_statement] = STATE(686),
    [sym_expression_statement] = STATE(686),
    [sym_if_statement] = STATE(686),
    [sym_switch_statement] = STATE(686),
    [sym_case_statement] = STATE(686),
    [sym_while_statement] = STATE(686),
    [sym_do_statement] = STATE(686),
    [sym_for_statement] = STATE(686),
    [sym_return_statement] = STATE(686),
    [sym_break_statement] = STATE(686),
    [sym_continue_statement] = STATE(686),
    [sym_goto_statement] = STATE(686),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [880] = {
    [sym_declaration] = STATE(1005),
    [sym__declaration_specifiers] = STATE(685),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym__expression] = STATE(1006),
    [sym_conditional_expression] = STATE(1006),
    [sym_assignment_expression] = STATE(1006),
    [sym_pointer_expression] = STATE(1006),
    [sym_logical_expression] = STATE(1006),
    [sym_bitwise_expression] = STATE(1006),
    [sym_equality_expression] = STATE(1006),
    [sym_relational_expression] = STATE(1006),
    [sym_shift_expression] = STATE(1006),
    [sym_math_expression] = STATE(1006),
    [sym_cast_expression] = STATE(1006),
    [sym_sizeof_expression] = STATE(1006),
    [sym_subscript_expression] = STATE(1006),
    [sym_call_expression] = STATE(1006),
    [sym_field_expression] = STATE(1006),
    [sym_compound_literal_expression] = STATE(1006),
    [sym_parenthesized_expression] = STATE(1006),
    [sym_char_literal] = STATE(1006),
    [sym_concatenated_string] = STATE(1006),
    [sym_string_literal] = STATE(363),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [sym_null] = ACTIONS(2739),
    [sym_identifier] = ACTIONS(1630),
    [sym_comment] = ACTIONS(41),
  },
  [881] = {
    [sym_compound_statement] = STATE(703),
    [sym_labeled_statement] = STATE(703),
    [sym_expression_statement] = STATE(703),
    [sym_if_statement] = STATE(703),
    [sym_switch_statement] = STATE(703),
    [sym_case_statement] = STATE(703),
    [sym_while_statement] = STATE(703),
    [sym_do_statement] = STATE(703),
    [sym_for_statement] = STATE(703),
    [sym_return_statement] = STATE(703),
    [sym_break_statement] = STATE(703),
    [sym_continue_statement] = STATE(703),
    [sym_goto_statement] = STATE(703),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [882] = {
    [sym_compound_statement] = STATE(1007),
    [sym_labeled_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_if_statement] = STATE(1007),
    [sym_switch_statement] = STATE(1007),
    [sym_case_statement] = STATE(1007),
    [sym_while_statement] = STATE(1007),
    [sym_do_statement] = STATE(1007),
    [sym_for_statement] = STATE(1007),
    [sym_return_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_goto_statement] = STATE(1007),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1572),
    [sym_comment] = ACTIONS(41),
  },
  [883] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [884] = {
    [anon_sym_RPAREN] = ACTIONS(2741),
    [sym_comment] = ACTIONS(41),
  },
  [885] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2448),
    [anon_sym_QMARK] = ACTIONS(2448),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [886] = {
    [anon_sym_LPAREN] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2743),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2745),
    [sym_preproc_directive] = ACTIONS(2745),
    [anon_sym_typedef] = ACTIONS(2745),
    [anon_sym_extern] = ACTIONS(2745),
    [anon_sym_STAR] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2745),
    [anon_sym_auto] = ACTIONS(2745),
    [anon_sym_register] = ACTIONS(2745),
    [anon_sym_inline] = ACTIONS(2745),
    [anon_sym_const] = ACTIONS(2745),
    [anon_sym_restrict] = ACTIONS(2745),
    [anon_sym_volatile] = ACTIONS(2745),
    [anon_sym__Atomic] = ACTIONS(2745),
    [anon_sym_unsigned] = ACTIONS(2745),
    [anon_sym_long] = ACTIONS(2745),
    [anon_sym_short] = ACTIONS(2745),
    [sym_primitive_type] = ACTIONS(2745),
    [anon_sym_enum] = ACTIONS(2745),
    [anon_sym_struct] = ACTIONS(2745),
    [anon_sym_union] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(2745),
    [anon_sym_else] = ACTIONS(2745),
    [anon_sym_switch] = ACTIONS(2745),
    [anon_sym_case] = ACTIONS(2745),
    [anon_sym_default] = ACTIONS(2745),
    [anon_sym_while] = ACTIONS(2745),
    [anon_sym_do] = ACTIONS(2745),
    [anon_sym_for] = ACTIONS(2745),
    [anon_sym_return] = ACTIONS(2745),
    [anon_sym_break] = ACTIONS(2745),
    [anon_sym_continue] = ACTIONS(2745),
    [anon_sym_goto] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_BANG] = ACTIONS(2743),
    [anon_sym_TILDE] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2745),
    [anon_sym_DASH_DASH] = ACTIONS(2743),
    [anon_sym_PLUS_PLUS] = ACTIONS(2743),
    [anon_sym_sizeof] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2743),
    [anon_sym_SQUOTE] = ACTIONS(2743),
    [anon_sym_DQUOTE] = ACTIONS(2743),
    [sym_true] = ACTIONS(2745),
    [sym_false] = ACTIONS(2745),
    [sym_null] = ACTIONS(2745),
    [sym_identifier] = ACTIONS(2745),
    [sym_comment] = ACTIONS(41),
  },
  [887] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2747),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [888] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_COLON] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [889] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_COLON] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [890] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_COLON] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_STAR_EQ] = ACTIONS(2456),
    [anon_sym_SLASH_EQ] = ACTIONS(2456),
    [anon_sym_PERCENT_EQ] = ACTIONS(2456),
    [anon_sym_PLUS_EQ] = ACTIONS(2456),
    [anon_sym_DASH_EQ] = ACTIONS(2456),
    [anon_sym_LT_LT_EQ] = ACTIONS(2456),
    [anon_sym_GT_GT_EQ] = ACTIONS(2456),
    [anon_sym_AMP_EQ] = ACTIONS(2456),
    [anon_sym_CARET_EQ] = ACTIONS(2456),
    [anon_sym_PIPE_EQ] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [891] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_COLON] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [892] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_COLON] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_STAR_EQ] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(2452),
    [anon_sym_PERCENT_EQ] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(2452),
    [anon_sym_DASH_EQ] = ACTIONS(2452),
    [anon_sym_LT_LT_EQ] = ACTIONS(2452),
    [anon_sym_GT_GT_EQ] = ACTIONS(2452),
    [anon_sym_AMP_EQ] = ACTIONS(2452),
    [anon_sym_CARET_EQ] = ACTIONS(2452),
    [anon_sym_PIPE_EQ] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [893] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_COLON] = ACTIONS(2460),
    [anon_sym_QMARK] = ACTIONS(2460),
    [anon_sym_STAR_EQ] = ACTIONS(2460),
    [anon_sym_SLASH_EQ] = ACTIONS(2460),
    [anon_sym_PERCENT_EQ] = ACTIONS(2460),
    [anon_sym_PLUS_EQ] = ACTIONS(2460),
    [anon_sym_DASH_EQ] = ACTIONS(2460),
    [anon_sym_LT_LT_EQ] = ACTIONS(2460),
    [anon_sym_GT_GT_EQ] = ACTIONS(2460),
    [anon_sym_AMP_EQ] = ACTIONS(2460),
    [anon_sym_CARET_EQ] = ACTIONS(2460),
    [anon_sym_PIPE_EQ] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [894] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_COLON] = ACTIONS(2464),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_STAR_EQ] = ACTIONS(2464),
    [anon_sym_SLASH_EQ] = ACTIONS(2464),
    [anon_sym_PERCENT_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_EQ] = ACTIONS(2464),
    [anon_sym_DASH_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_GT_EQ] = ACTIONS(2464),
    [anon_sym_AMP_EQ] = ACTIONS(2464),
    [anon_sym_CARET_EQ] = ACTIONS(2464),
    [anon_sym_PIPE_EQ] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [895] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2470),
    [anon_sym_COLON] = ACTIONS(2468),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_STAR_EQ] = ACTIONS(2468),
    [anon_sym_SLASH_EQ] = ACTIONS(2468),
    [anon_sym_PERCENT_EQ] = ACTIONS(2468),
    [anon_sym_PLUS_EQ] = ACTIONS(2468),
    [anon_sym_DASH_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_GT_EQ] = ACTIONS(2468),
    [anon_sym_AMP_EQ] = ACTIONS(2468),
    [anon_sym_CARET_EQ] = ACTIONS(2468),
    [anon_sym_PIPE_EQ] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_LT_LT] = ACTIONS(2470),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [896] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_COLON] = ACTIONS(2442),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_STAR_EQ] = ACTIONS(2442),
    [anon_sym_SLASH_EQ] = ACTIONS(2442),
    [anon_sym_PERCENT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_GT_EQ] = ACTIONS(2442),
    [anon_sym_AMP_EQ] = ACTIONS(2442),
    [anon_sym_CARET_EQ] = ACTIONS(2442),
    [anon_sym_PIPE_EQ] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [897] = {
    [sym_string_literal] = STATE(897),
    [aux_sym_concatenated_string_repeat1] = STATE(897),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_COLON] = ACTIONS(2476),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_STAR_EQ] = ACTIONS(2476),
    [anon_sym_SLASH_EQ] = ACTIONS(2476),
    [anon_sym_PERCENT_EQ] = ACTIONS(2476),
    [anon_sym_PLUS_EQ] = ACTIONS(2476),
    [anon_sym_DASH_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_GT_EQ] = ACTIONS(2476),
    [anon_sym_AMP_EQ] = ACTIONS(2476),
    [anon_sym_CARET_EQ] = ACTIONS(2476),
    [anon_sym_PIPE_EQ] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2478),
    [anon_sym_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_DASH_GT] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(41),
  },
  [898] = {
    [sym_parenthesized_expression] = STATE(1010),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [899] = {
    [sym_parenthesized_expression] = STATE(1011),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [900] = {
    [sym__expression] = STATE(1012),
    [sym_conditional_expression] = STATE(1012),
    [sym_assignment_expression] = STATE(1012),
    [sym_pointer_expression] = STATE(1012),
    [sym_logical_expression] = STATE(1012),
    [sym_bitwise_expression] = STATE(1012),
    [sym_equality_expression] = STATE(1012),
    [sym_relational_expression] = STATE(1012),
    [sym_shift_expression] = STATE(1012),
    [sym_math_expression] = STATE(1012),
    [sym_cast_expression] = STATE(1012),
    [sym_sizeof_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1012),
    [sym_call_expression] = STATE(1012),
    [sym_field_expression] = STATE(1012),
    [sym_compound_literal_expression] = STATE(1012),
    [sym_parenthesized_expression] = STATE(1012),
    [sym_char_literal] = STATE(1012),
    [sym_concatenated_string] = STATE(1012),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [sym_null] = ACTIONS(2751),
    [sym_identifier] = ACTIONS(2751),
    [sym_comment] = ACTIONS(41),
  },
  [901] = {
    [anon_sym_COLON] = ACTIONS(2753),
    [sym_comment] = ACTIONS(41),
  },
  [902] = {
    [sym_parenthesized_expression] = STATE(1014),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [903] = {
    [anon_sym_LPAREN] = ACTIONS(2755),
    [sym_comment] = ACTIONS(41),
  },
  [904] = {
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(2757),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(41),
  },
  [905] = {
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2316),
    [sym_comment] = ACTIONS(41),
  },
  [906] = {
    [sym_declaration] = STATE(886),
    [sym_type_definition] = STATE(886),
    [sym__declaration_specifiers] = STATE(685),
    [sym_compound_statement] = STATE(886),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(886),
    [sym_expression_statement] = STATE(886),
    [sym_if_statement] = STATE(886),
    [sym_switch_statement] = STATE(886),
    [sym_case_statement] = STATE(886),
    [sym_while_statement] = STATE(886),
    [sym_do_statement] = STATE(886),
    [sym_for_statement] = STATE(886),
    [sym_return_statement] = STATE(886),
    [sym_break_statement] = STATE(886),
    [sym_continue_statement] = STATE(886),
    [sym_goto_statement] = STATE(886),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2396),
    [sym_comment] = ACTIONS(41),
  },
  [907] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(1620),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [908] = {
    [sym_parenthesized_expression] = STATE(911),
    [anon_sym_LPAREN] = ACTIONS(2761),
    [sym_comment] = ACTIONS(41),
  },
  [909] = {
    [sym__expression] = STATE(1020),
    [sym_conditional_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1020),
    [sym_pointer_expression] = STATE(1020),
    [sym_logical_expression] = STATE(1020),
    [sym_bitwise_expression] = STATE(1020),
    [sym_equality_expression] = STATE(1020),
    [sym_relational_expression] = STATE(1020),
    [sym_shift_expression] = STATE(1020),
    [sym_math_expression] = STATE(1020),
    [sym_cast_expression] = STATE(1020),
    [sym_sizeof_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_call_expression] = STATE(1020),
    [sym_field_expression] = STATE(1020),
    [sym_compound_literal_expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_char_literal] = STATE(1020),
    [sym_concatenated_string] = STATE(1020),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [sym_null] = ACTIONS(2767),
    [sym_identifier] = ACTIONS(2767),
    [sym_comment] = ACTIONS(41),
  },
  [910] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [911] = {
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2773),
    [sym_preproc_directive] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_auto] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [sym_primitive_type] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_switch] = ACTIONS(2773),
    [anon_sym_case] = ACTIONS(2773),
    [anon_sym_default] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_goto] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_TILDE] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_sizeof] = ACTIONS(2773),
    [sym_number_literal] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [anon_sym_DQUOTE] = ACTIONS(2771),
    [sym_true] = ACTIONS(2773),
    [sym_false] = ACTIONS(2773),
    [sym_null] = ACTIONS(2773),
    [sym_identifier] = ACTIONS(2773),
    [sym_comment] = ACTIONS(41),
  },
  [912] = {
    [sym__expression] = STATE(1023),
    [sym_conditional_expression] = STATE(1023),
    [sym_assignment_expression] = STATE(1023),
    [sym_pointer_expression] = STATE(1023),
    [sym_logical_expression] = STATE(1023),
    [sym_bitwise_expression] = STATE(1023),
    [sym_equality_expression] = STATE(1023),
    [sym_relational_expression] = STATE(1023),
    [sym_shift_expression] = STATE(1023),
    [sym_math_expression] = STATE(1023),
    [sym_cast_expression] = STATE(1023),
    [sym_sizeof_expression] = STATE(1023),
    [sym_subscript_expression] = STATE(1023),
    [sym_call_expression] = STATE(1023),
    [sym_field_expression] = STATE(1023),
    [sym_compound_literal_expression] = STATE(1023),
    [sym_parenthesized_expression] = STATE(1023),
    [sym_char_literal] = STATE(1023),
    [sym_concatenated_string] = STATE(1023),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2777),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [sym_null] = ACTIONS(2779),
    [sym_identifier] = ACTIONS(2779),
    [sym_comment] = ACTIONS(41),
  },
  [913] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [914] = {
    [sym__expression] = STATE(1025),
    [sym_conditional_expression] = STATE(1025),
    [sym_assignment_expression] = STATE(1025),
    [sym_pointer_expression] = STATE(1025),
    [sym_logical_expression] = STATE(1025),
    [sym_bitwise_expression] = STATE(1025),
    [sym_equality_expression] = STATE(1025),
    [sym_relational_expression] = STATE(1025),
    [sym_shift_expression] = STATE(1025),
    [sym_math_expression] = STATE(1025),
    [sym_cast_expression] = STATE(1025),
    [sym_sizeof_expression] = STATE(1025),
    [sym_subscript_expression] = STATE(1025),
    [sym_call_expression] = STATE(1025),
    [sym_field_expression] = STATE(1025),
    [sym_compound_literal_expression] = STATE(1025),
    [sym_parenthesized_expression] = STATE(1025),
    [sym_char_literal] = STATE(1025),
    [sym_concatenated_string] = STATE(1025),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2785),
    [sym_false] = ACTIONS(2785),
    [sym_null] = ACTIONS(2785),
    [sym_identifier] = ACTIONS(2785),
    [sym_comment] = ACTIONS(41),
  },
  [915] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_STAR_EQ] = ACTIONS(2787),
    [anon_sym_SLASH_EQ] = ACTIONS(2787),
    [anon_sym_PERCENT_EQ] = ACTIONS(2787),
    [anon_sym_PLUS_EQ] = ACTIONS(2787),
    [anon_sym_DASH_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_GT_EQ] = ACTIONS(2787),
    [anon_sym_AMP_EQ] = ACTIONS(2787),
    [anon_sym_CARET_EQ] = ACTIONS(2787),
    [anon_sym_PIPE_EQ] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(2793),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_EQ_EQ] = ACTIONS(2787),
    [anon_sym_BANG_EQ] = ACTIONS(2787),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(2787),
    [anon_sym_DASH_GT] = ACTIONS(2787),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [916] = {
    [anon_sym_LPAREN] = ACTIONS(2795),
    [anon_sym_RBRACE] = ACTIONS(2795),
    [anon_sym_RPAREN] = ACTIONS(2795),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_COMMA] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_RBRACK] = ACTIONS(2795),
    [anon_sym_EQ] = ACTIONS(2797),
    [anon_sym_COLON] = ACTIONS(2795),
    [anon_sym_QMARK] = ACTIONS(2795),
    [anon_sym_STAR_EQ] = ACTIONS(2795),
    [anon_sym_SLASH_EQ] = ACTIONS(2795),
    [anon_sym_PERCENT_EQ] = ACTIONS(2795),
    [anon_sym_PLUS_EQ] = ACTIONS(2795),
    [anon_sym_DASH_EQ] = ACTIONS(2795),
    [anon_sym_LT_LT_EQ] = ACTIONS(2795),
    [anon_sym_GT_GT_EQ] = ACTIONS(2795),
    [anon_sym_AMP_EQ] = ACTIONS(2795),
    [anon_sym_CARET_EQ] = ACTIONS(2795),
    [anon_sym_PIPE_EQ] = ACTIONS(2795),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym_PIPE_PIPE] = ACTIONS(2795),
    [anon_sym_AMP_AMP] = ACTIONS(2795),
    [anon_sym_PIPE] = ACTIONS(2797),
    [anon_sym_CARET] = ACTIONS(2797),
    [anon_sym_EQ_EQ] = ACTIONS(2795),
    [anon_sym_BANG_EQ] = ACTIONS(2795),
    [anon_sym_LT] = ACTIONS(2797),
    [anon_sym_GT] = ACTIONS(2797),
    [anon_sym_LT_EQ] = ACTIONS(2795),
    [anon_sym_GT_EQ] = ACTIONS(2795),
    [anon_sym_LT_LT] = ACTIONS(2797),
    [anon_sym_GT_GT] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_SLASH] = ACTIONS(2797),
    [anon_sym_PERCENT] = ACTIONS(2797),
    [anon_sym_DASH_DASH] = ACTIONS(2795),
    [anon_sym_PLUS_PLUS] = ACTIONS(2795),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_DASH_GT] = ACTIONS(2795),
    [sym_comment] = ACTIONS(41),
  },
  [917] = {
    [sym__expression] = STATE(1026),
    [sym_conditional_expression] = STATE(1026),
    [sym_assignment_expression] = STATE(1026),
    [sym_pointer_expression] = STATE(1026),
    [sym_logical_expression] = STATE(1026),
    [sym_bitwise_expression] = STATE(1026),
    [sym_equality_expression] = STATE(1026),
    [sym_relational_expression] = STATE(1026),
    [sym_shift_expression] = STATE(1026),
    [sym_math_expression] = STATE(1026),
    [sym_cast_expression] = STATE(1026),
    [sym_sizeof_expression] = STATE(1026),
    [sym_subscript_expression] = STATE(1026),
    [sym_call_expression] = STATE(1026),
    [sym_field_expression] = STATE(1026),
    [sym_compound_literal_expression] = STATE(1026),
    [sym_parenthesized_expression] = STATE(1026),
    [sym_char_literal] = STATE(1026),
    [sym_concatenated_string] = STATE(1026),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2799),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2801),
    [sym_false] = ACTIONS(2801),
    [sym_null] = ACTIONS(2801),
    [sym_identifier] = ACTIONS(2801),
    [sym_comment] = ACTIONS(41),
  },
  [918] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(2803),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [919] = {
    [anon_sym_LPAREN] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(2805),
    [anon_sym_RPAREN] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2805),
    [anon_sym_COMMA] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_RBRACK] = ACTIONS(2805),
    [anon_sym_EQ] = ACTIONS(2807),
    [anon_sym_COLON] = ACTIONS(2805),
    [anon_sym_QMARK] = ACTIONS(2805),
    [anon_sym_STAR_EQ] = ACTIONS(2805),
    [anon_sym_SLASH_EQ] = ACTIONS(2805),
    [anon_sym_PERCENT_EQ] = ACTIONS(2805),
    [anon_sym_PLUS_EQ] = ACTIONS(2805),
    [anon_sym_DASH_EQ] = ACTIONS(2805),
    [anon_sym_LT_LT_EQ] = ACTIONS(2805),
    [anon_sym_GT_GT_EQ] = ACTIONS(2805),
    [anon_sym_AMP_EQ] = ACTIONS(2805),
    [anon_sym_CARET_EQ] = ACTIONS(2805),
    [anon_sym_PIPE_EQ] = ACTIONS(2805),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2805),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2805),
    [anon_sym_BANG_EQ] = ACTIONS(2805),
    [anon_sym_LT] = ACTIONS(2807),
    [anon_sym_GT] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2805),
    [anon_sym_GT_EQ] = ACTIONS(2805),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2805),
    [anon_sym_PLUS_PLUS] = ACTIONS(2805),
    [anon_sym_DOT] = ACTIONS(2805),
    [anon_sym_DASH_GT] = ACTIONS(2805),
    [sym_comment] = ACTIONS(41),
  },
  [920] = {
    [sym__expression] = STATE(1029),
    [sym_conditional_expression] = STATE(1029),
    [sym_assignment_expression] = STATE(1029),
    [sym_pointer_expression] = STATE(1029),
    [sym_logical_expression] = STATE(1029),
    [sym_bitwise_expression] = STATE(1029),
    [sym_equality_expression] = STATE(1029),
    [sym_relational_expression] = STATE(1029),
    [sym_shift_expression] = STATE(1029),
    [sym_math_expression] = STATE(1029),
    [sym_cast_expression] = STATE(1029),
    [sym_sizeof_expression] = STATE(1029),
    [sym_subscript_expression] = STATE(1029),
    [sym_call_expression] = STATE(1029),
    [sym_field_expression] = STATE(1029),
    [sym_compound_literal_expression] = STATE(1029),
    [sym_parenthesized_expression] = STATE(1029),
    [sym_char_literal] = STATE(1029),
    [sym_concatenated_string] = STATE(1029),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2811),
    [sym_false] = ACTIONS(2811),
    [sym_null] = ACTIONS(2811),
    [sym_identifier] = ACTIONS(2811),
    [sym_comment] = ACTIONS(41),
  },
  [921] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_RBRACK] = ACTIONS(2787),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_STAR_EQ] = ACTIONS(2787),
    [anon_sym_SLASH_EQ] = ACTIONS(2787),
    [anon_sym_PERCENT_EQ] = ACTIONS(2787),
    [anon_sym_PLUS_EQ] = ACTIONS(2787),
    [anon_sym_DASH_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_GT_EQ] = ACTIONS(2787),
    [anon_sym_AMP_EQ] = ACTIONS(2787),
    [anon_sym_CARET_EQ] = ACTIONS(2787),
    [anon_sym_PIPE_EQ] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_PIPE_PIPE] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_EQ_EQ] = ACTIONS(2787),
    [anon_sym_BANG_EQ] = ACTIONS(2787),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [anon_sym_DOT] = ACTIONS(2787),
    [anon_sym_DASH_GT] = ACTIONS(2787),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [922] = {
    [sym__expression] = STATE(1030),
    [sym_conditional_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1030),
    [sym_pointer_expression] = STATE(1030),
    [sym_logical_expression] = STATE(1030),
    [sym_bitwise_expression] = STATE(1030),
    [sym_equality_expression] = STATE(1030),
    [sym_relational_expression] = STATE(1030),
    [sym_shift_expression] = STATE(1030),
    [sym_math_expression] = STATE(1030),
    [sym_cast_expression] = STATE(1030),
    [sym_sizeof_expression] = STATE(1030),
    [sym_subscript_expression] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_field_expression] = STATE(1030),
    [sym_compound_literal_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_char_literal] = STATE(1030),
    [sym_concatenated_string] = STATE(1030),
    [sym_string_literal] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_sizeof] = ACTIONS(615),
    [sym_number_literal] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [sym_null] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2819),
    [sym_comment] = ACTIONS(41),
  },
  [923] = {
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_DOT] = ACTIONS(2821),
    [sym_comment] = ACTIONS(41),
  },
  [924] = {
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(2823),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_RBRACK] = ACTIONS(2823),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_COLON] = ACTIONS(2823),
    [anon_sym_QMARK] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DOT] = ACTIONS(2823),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [sym_comment] = ACTIONS(41),
  },
  [925] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_EQ] = ACTIONS(1326),
    [anon_sym_SLASH_EQ] = ACTIONS(1326),
    [anon_sym_PERCENT_EQ] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1326),
    [anon_sym_DASH_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_GT_EQ] = ACTIONS(1326),
    [anon_sym_AMP_EQ] = ACTIONS(1326),
    [anon_sym_CARET_EQ] = ACTIONS(1326),
    [anon_sym_PIPE_EQ] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(1330),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [926] = {
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2827),
    [sym_comment] = ACTIONS(41),
  },
  [927] = {
    [sym__expression] = STATE(925),
    [sym_conditional_expression] = STATE(925),
    [sym_assignment_expression] = STATE(925),
    [sym_pointer_expression] = STATE(925),
    [sym_logical_expression] = STATE(925),
    [sym_bitwise_expression] = STATE(925),
    [sym_equality_expression] = STATE(925),
    [sym_relational_expression] = STATE(925),
    [sym_shift_expression] = STATE(925),
    [sym_math_expression] = STATE(925),
    [sym_cast_expression] = STATE(925),
    [sym_sizeof_expression] = STATE(925),
    [sym_subscript_expression] = STATE(925),
    [sym_call_expression] = STATE(925),
    [sym_field_expression] = STATE(925),
    [sym_compound_literal_expression] = STATE(925),
    [sym_parenthesized_expression] = STATE(925),
    [sym_initializer_list] = STATE(926),
    [sym_initializer_pair] = STATE(926),
    [sym_subscript_designator] = STATE(492),
    [sym_field_designator] = STATE(492),
    [sym_char_literal] = STATE(925),
    [sym_concatenated_string] = STATE(925),
    [sym_string_literal] = STATE(339),
    [aux_sym_initializer_pair_repeat1] = STATE(492),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [anon_sym_DOT] = ACTIONS(1174),
    [sym_number_literal] = ACTIONS(2499),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2501),
    [sym_false] = ACTIONS(2501),
    [sym_null] = ACTIONS(2501),
    [sym_identifier] = ACTIONS(2501),
    [sym_comment] = ACTIONS(41),
  },
  [928] = {
    [aux_sym_initializer_list_repeat1] = STATE(928),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2831),
    [sym_comment] = ACTIONS(41),
  },
  [929] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_COMMA] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_EQ] = ACTIONS(1326),
    [anon_sym_SLASH_EQ] = ACTIONS(1326),
    [anon_sym_PERCENT_EQ] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1326),
    [anon_sym_DASH_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_GT_EQ] = ACTIONS(1326),
    [anon_sym_AMP_EQ] = ACTIONS(1326),
    [anon_sym_CARET_EQ] = ACTIONS(1326),
    [anon_sym_PIPE_EQ] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(1330),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [930] = {
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_COMMA] = ACTIONS(2834),
    [sym_comment] = ACTIONS(41),
  },
  [931] = {
    [anon_sym_SEMI] = ACTIONS(2836),
    [sym_comment] = ACTIONS(41),
  },
  [932] = {
    [anon_sym_LBRACE] = ACTIONS(2838),
    [sym_comment] = ACTIONS(41),
  },
  [933] = {
    [anon_sym_RBRACE] = ACTIONS(2840),
    [sym_comment] = ACTIONS(41),
  },
  [934] = {
    [anon_sym_RBRACE] = ACTIONS(2842),
    [sym_comment] = ACTIONS(41),
  },
  [935] = {
    [sym_ta_specifier_list] = STATE(1036),
    [sym_ta_specifier_list_specifier] = STATE(495),
    [anon_sym_dense] = ACTIONS(1189),
    [anon_sym_sparse] = ACTIONS(1189),
    [sym_comment] = ACTIONS(41),
  },
  [936] = {
    [anon_sym_tensor] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1197),
    [anon_sym_indexvars] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1199),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1199),
    [sym_preproc_directive] = ACTIONS(1199),
    [anon_sym_typedef] = ACTIONS(1199),
    [anon_sym_extern] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1199),
    [anon_sym_auto] = ACTIONS(1199),
    [anon_sym_register] = ACTIONS(1199),
    [anon_sym_inline] = ACTIONS(1199),
    [anon_sym_const] = ACTIONS(1199),
    [anon_sym_restrict] = ACTIONS(1199),
    [anon_sym_volatile] = ACTIONS(1199),
    [anon_sym__Atomic] = ACTIONS(1199),
    [anon_sym_unsigned] = ACTIONS(1199),
    [anon_sym_long] = ACTIONS(1199),
    [anon_sym_short] = ACTIONS(1199),
    [sym_primitive_type] = ACTIONS(1199),
    [anon_sym_enum] = ACTIONS(1199),
    [anon_sym_struct] = ACTIONS(1199),
    [anon_sym_union] = ACTIONS(1199),
    [anon_sym_if] = ACTIONS(1199),
    [anon_sym_switch] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1199),
    [anon_sym_default] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(1199),
    [anon_sym_do] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1199),
    [anon_sym_return] = ACTIONS(1199),
    [anon_sym_break] = ACTIONS(1199),
    [anon_sym_continue] = ACTIONS(1199),
    [anon_sym_goto] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [sym_number_literal] = ACTIONS(1197),
    [anon_sym_SQUOTE] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_true] = ACTIONS(1199),
    [sym_false] = ACTIONS(1199),
    [sym_null] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1199),
    [sym_comment] = ACTIONS(41),
  },
  [937] = {
    [anon_sym_tensor] = ACTIONS(1286),
    [anon_sym_indexvars] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1286),
    [sym_preproc_directive] = ACTIONS(1286),
    [anon_sym_typedef] = ACTIONS(1286),
    [anon_sym_extern] = ACTIONS(1286),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_auto] = ACTIONS(1286),
    [anon_sym_register] = ACTIONS(1286),
    [anon_sym_inline] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_restrict] = ACTIONS(1286),
    [anon_sym_volatile] = ACTIONS(1286),
    [anon_sym__Atomic] = ACTIONS(1286),
    [anon_sym_unsigned] = ACTIONS(1286),
    [anon_sym_long] = ACTIONS(1286),
    [anon_sym_short] = ACTIONS(1286),
    [sym_primitive_type] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
    [anon_sym_struct] = ACTIONS(1286),
    [anon_sym_union] = ACTIONS(1286),
    [sym_identifier] = ACTIONS(1286),
    [sym_comment] = ACTIONS(41),
  },
  [938] = {
    [anon_sym_tensor] = ACTIONS(1290),
    [anon_sym_indexvars] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1290),
    [sym_preproc_directive] = ACTIONS(1290),
    [anon_sym_typedef] = ACTIONS(1290),
    [anon_sym_extern] = ACTIONS(1290),
    [anon_sym_static] = ACTIONS(1290),
    [anon_sym_auto] = ACTIONS(1290),
    [anon_sym_register] = ACTIONS(1290),
    [anon_sym_inline] = ACTIONS(1290),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_restrict] = ACTIONS(1290),
    [anon_sym_volatile] = ACTIONS(1290),
    [anon_sym__Atomic] = ACTIONS(1290),
    [anon_sym_unsigned] = ACTIONS(1290),
    [anon_sym_long] = ACTIONS(1290),
    [anon_sym_short] = ACTIONS(1290),
    [sym_primitive_type] = ACTIONS(1290),
    [anon_sym_enum] = ACTIONS(1290),
    [anon_sym_struct] = ACTIONS(1290),
    [anon_sym_union] = ACTIONS(1290),
    [sym_identifier] = ACTIONS(1290),
    [sym_comment] = ACTIONS(41),
  },
  [939] = {
    [anon_sym_tensor] = ACTIONS(1306),
    [anon_sym_LPAREN] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_indexvars] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1306),
    [sym_preproc_directive] = ACTIONS(1306),
    [anon_sym_typedef] = ACTIONS(1306),
    [anon_sym_extern] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1306),
    [anon_sym_auto] = ACTIONS(1306),
    [anon_sym_register] = ACTIONS(1306),
    [anon_sym_inline] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym_unsigned] = ACTIONS(1306),
    [anon_sym_long] = ACTIONS(1306),
    [anon_sym_short] = ACTIONS(1306),
    [sym_primitive_type] = ACTIONS(1306),
    [anon_sym_enum] = ACTIONS(1306),
    [anon_sym_struct] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1306),
    [anon_sym_case] = ACTIONS(1306),
    [anon_sym_default] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_do] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_goto] = ACTIONS(1306),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_sizeof] = ACTIONS(1306),
    [sym_number_literal] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [sym_null] = ACTIONS(1306),
    [sym_identifier] = ACTIONS(1306),
    [sym_comment] = ACTIONS(41),
  },
  [940] = {
    [anon_sym_tensor] = ACTIONS(1310),
    [anon_sym_indexvars] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1310),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1310),
    [sym_preproc_directive] = ACTIONS(1310),
    [anon_sym_typedef] = ACTIONS(1310),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_auto] = ACTIONS(1310),
    [anon_sym_register] = ACTIONS(1310),
    [anon_sym_inline] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [anon_sym_restrict] = ACTIONS(1310),
    [anon_sym_volatile] = ACTIONS(1310),
    [anon_sym__Atomic] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
    [anon_sym_struct] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1310),
    [sym_identifier] = ACTIONS(1310),
    [sym_comment] = ACTIONS(41),
  },
  [941] = {
    [anon_sym_tensor] = ACTIONS(1744),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(1742),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_indexvars] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1744),
    [sym_preproc_directive] = ACTIONS(1744),
    [anon_sym_typedef] = ACTIONS(1744),
    [anon_sym_extern] = ACTIONS(1744),
    [anon_sym_STAR] = ACTIONS(1742),
    [anon_sym_static] = ACTIONS(1744),
    [anon_sym_auto] = ACTIONS(1744),
    [anon_sym_register] = ACTIONS(1744),
    [anon_sym_inline] = ACTIONS(1744),
    [anon_sym_const] = ACTIONS(1744),
    [anon_sym_restrict] = ACTIONS(1744),
    [anon_sym_volatile] = ACTIONS(1744),
    [anon_sym__Atomic] = ACTIONS(1744),
    [anon_sym_unsigned] = ACTIONS(1744),
    [anon_sym_long] = ACTIONS(1744),
    [anon_sym_short] = ACTIONS(1744),
    [sym_primitive_type] = ACTIONS(1744),
    [anon_sym_enum] = ACTIONS(1744),
    [anon_sym_struct] = ACTIONS(1744),
    [anon_sym_union] = ACTIONS(1744),
    [anon_sym_if] = ACTIONS(1744),
    [anon_sym_else] = ACTIONS(1744),
    [anon_sym_switch] = ACTIONS(1744),
    [anon_sym_case] = ACTIONS(1744),
    [anon_sym_default] = ACTIONS(1744),
    [anon_sym_while] = ACTIONS(1744),
    [anon_sym_do] = ACTIONS(1744),
    [anon_sym_for] = ACTIONS(1744),
    [anon_sym_return] = ACTIONS(1744),
    [anon_sym_break] = ACTIONS(1744),
    [anon_sym_continue] = ACTIONS(1744),
    [anon_sym_goto] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1742),
    [anon_sym_BANG] = ACTIONS(1742),
    [anon_sym_TILDE] = ACTIONS(1742),
    [anon_sym_PLUS] = ACTIONS(1744),
    [anon_sym_DASH] = ACTIONS(1744),
    [anon_sym_DASH_DASH] = ACTIONS(1742),
    [anon_sym_PLUS_PLUS] = ACTIONS(1742),
    [anon_sym_sizeof] = ACTIONS(1744),
    [sym_number_literal] = ACTIONS(1742),
    [anon_sym_SQUOTE] = ACTIONS(1742),
    [anon_sym_DQUOTE] = ACTIONS(1742),
    [sym_true] = ACTIONS(1744),
    [sym_false] = ACTIONS(1744),
    [sym_null] = ACTIONS(1744),
    [sym_identifier] = ACTIONS(1744),
    [sym_comment] = ACTIONS(41),
  },
  [942] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_STAR_EQ] = ACTIONS(2787),
    [anon_sym_SLASH_EQ] = ACTIONS(2787),
    [anon_sym_PERCENT_EQ] = ACTIONS(2787),
    [anon_sym_PLUS_EQ] = ACTIONS(2787),
    [anon_sym_DASH_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_GT_EQ] = ACTIONS(2787),
    [anon_sym_AMP_EQ] = ACTIONS(2787),
    [anon_sym_CARET_EQ] = ACTIONS(2787),
    [anon_sym_PIPE_EQ] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2844),
    [anon_sym_PIPE_PIPE] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(2846),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_EQ_EQ] = ACTIONS(2787),
    [anon_sym_BANG_EQ] = ACTIONS(2787),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [anon_sym_DOT] = ACTIONS(2787),
    [anon_sym_DASH_GT] = ACTIONS(2787),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [943] = {
    [sym__expression] = STATE(1037),
    [sym_conditional_expression] = STATE(1037),
    [sym_assignment_expression] = STATE(1037),
    [sym_pointer_expression] = STATE(1037),
    [sym_logical_expression] = STATE(1037),
    [sym_bitwise_expression] = STATE(1037),
    [sym_equality_expression] = STATE(1037),
    [sym_relational_expression] = STATE(1037),
    [sym_shift_expression] = STATE(1037),
    [sym_math_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1037),
    [sym_sizeof_expression] = STATE(1037),
    [sym_subscript_expression] = STATE(1037),
    [sym_call_expression] = STATE(1037),
    [sym_field_expression] = STATE(1037),
    [sym_compound_literal_expression] = STATE(1037),
    [sym_parenthesized_expression] = STATE(1037),
    [sym_char_literal] = STATE(1037),
    [sym_concatenated_string] = STATE(1037),
    [sym_string_literal] = STATE(339),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [sym_number_literal] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [sym_null] = ACTIONS(2850),
    [sym_identifier] = ACTIONS(2850),
    [sym_comment] = ACTIONS(41),
  },
  [944] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2852),
    [sym_comment] = ACTIONS(41),
  },
  [945] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_STAR_EQ] = ACTIONS(2787),
    [anon_sym_SLASH_EQ] = ACTIONS(2787),
    [anon_sym_PERCENT_EQ] = ACTIONS(2787),
    [anon_sym_PLUS_EQ] = ACTIONS(2787),
    [anon_sym_DASH_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_GT_EQ] = ACTIONS(2787),
    [anon_sym_AMP_EQ] = ACTIONS(2787),
    [anon_sym_CARET_EQ] = ACTIONS(2787),
    [anon_sym_PIPE_EQ] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2854),
    [anon_sym_PIPE_PIPE] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(2856),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(2787),
    [anon_sym_BANG_EQ] = ACTIONS(2787),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [anon_sym_DOT] = ACTIONS(2787),
    [anon_sym_DASH_GT] = ACTIONS(2787),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [946] = {
    [sym__expression] = STATE(1038),
    [sym_conditional_expression] = STATE(1038),
    [sym_assignment_expression] = STATE(1038),
    [sym_pointer_expression] = STATE(1038),
    [sym_logical_expression] = STATE(1038),
    [sym_bitwise_expression] = STATE(1038),
    [sym_equality_expression] = STATE(1038),
    [sym_relational_expression] = STATE(1038),
    [sym_shift_expression] = STATE(1038),
    [sym_math_expression] = STATE(1038),
    [sym_cast_expression] = STATE(1038),
    [sym_sizeof_expression] = STATE(1038),
    [sym_subscript_expression] = STATE(1038),
    [sym_call_expression] = STATE(1038),
    [sym_field_expression] = STATE(1038),
    [sym_compound_literal_expression] = STATE(1038),
    [sym_parenthesized_expression] = STATE(1038),
    [sym_char_literal] = STATE(1038),
    [sym_concatenated_string] = STATE(1038),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [sym_null] = ACTIONS(2860),
    [sym_identifier] = ACTIONS(2860),
    [sym_comment] = ACTIONS(41),
  },
  [947] = {
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_RPAREN] = ACTIONS(2862),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_COMMA] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_COLON] = ACTIONS(2862),
    [sym_comment] = ACTIONS(41),
  },
  [948] = {
    [anon_sym_RBRACE] = ACTIONS(2864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2864),
    [anon_sym_extern] = ACTIONS(2866),
    [anon_sym_static] = ACTIONS(2866),
    [anon_sym_auto] = ACTIONS(2866),
    [anon_sym_register] = ACTIONS(2866),
    [anon_sym_inline] = ACTIONS(2866),
    [anon_sym_const] = ACTIONS(2866),
    [anon_sym_restrict] = ACTIONS(2866),
    [anon_sym_volatile] = ACTIONS(2866),
    [anon_sym__Atomic] = ACTIONS(2866),
    [anon_sym_unsigned] = ACTIONS(2866),
    [anon_sym_long] = ACTIONS(2866),
    [anon_sym_short] = ACTIONS(2866),
    [sym_primitive_type] = ACTIONS(2866),
    [anon_sym_enum] = ACTIONS(2866),
    [anon_sym_struct] = ACTIONS(2866),
    [anon_sym_union] = ACTIONS(2866),
    [sym_identifier] = ACTIONS(2866),
    [sym_comment] = ACTIONS(41),
  },
  [949] = {
    [anon_sym_LPAREN] = ACTIONS(2868),
    [anon_sym_RPAREN] = ACTIONS(2868),
    [anon_sym_COMMA] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [sym_comment] = ACTIONS(41),
  },
  [950] = {
    [sym_type_qualifier] = STATE(950),
    [aux_sym_type_definition_repeat1] = STATE(950),
    [anon_sym_LPAREN] = ACTIONS(928),
    [anon_sym_RPAREN] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(928),
    [anon_sym_const] = ACTIONS(439),
    [anon_sym_restrict] = ACTIONS(439),
    [anon_sym_volatile] = ACTIONS(439),
    [anon_sym__Atomic] = ACTIONS(439),
    [sym_identifier] = ACTIONS(442),
    [sym_comment] = ACTIONS(41),
  },
  [951] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_STAR_EQ] = ACTIONS(2787),
    [anon_sym_SLASH_EQ] = ACTIONS(2787),
    [anon_sym_PERCENT_EQ] = ACTIONS(2787),
    [anon_sym_PLUS_EQ] = ACTIONS(2787),
    [anon_sym_DASH_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_GT_EQ] = ACTIONS(2787),
    [anon_sym_AMP_EQ] = ACTIONS(2787),
    [anon_sym_CARET_EQ] = ACTIONS(2787),
    [anon_sym_PIPE_EQ] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2870),
    [anon_sym_PIPE_PIPE] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_EQ_EQ] = ACTIONS(2787),
    [anon_sym_BANG_EQ] = ACTIONS(2787),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(2787),
    [anon_sym_DASH_GT] = ACTIONS(2787),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [952] = {
    [sym__expression] = STATE(1039),
    [sym_conditional_expression] = STATE(1039),
    [sym_assignment_expression] = STATE(1039),
    [sym_pointer_expression] = STATE(1039),
    [sym_logical_expression] = STATE(1039),
    [sym_bitwise_expression] = STATE(1039),
    [sym_equality_expression] = STATE(1039),
    [sym_relational_expression] = STATE(1039),
    [sym_shift_expression] = STATE(1039),
    [sym_math_expression] = STATE(1039),
    [sym_cast_expression] = STATE(1039),
    [sym_sizeof_expression] = STATE(1039),
    [sym_subscript_expression] = STATE(1039),
    [sym_call_expression] = STATE(1039),
    [sym_field_expression] = STATE(1039),
    [sym_compound_literal_expression] = STATE(1039),
    [sym_parenthesized_expression] = STATE(1039),
    [sym_char_literal] = STATE(1039),
    [sym_concatenated_string] = STATE(1039),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2876),
    [sym_false] = ACTIONS(2876),
    [sym_null] = ACTIONS(2876),
    [sym_identifier] = ACTIONS(2876),
    [sym_comment] = ACTIONS(41),
  },
  [953] = {
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_auto] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2222),
    [anon_sym_PLUS_PLUS] = ACTIONS(2222),
    [anon_sym_sizeof] = ACTIONS(2224),
    [sym_number_literal] = ACTIONS(2222),
    [anon_sym_SQUOTE] = ACTIONS(2222),
    [anon_sym_DQUOTE] = ACTIONS(2222),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_identifier] = ACTIONS(2224),
    [sym_comment] = ACTIONS(41),
  },
  [954] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2878),
    [sym_comment] = ACTIONS(41),
  },
  [955] = {
    [sym_preproc_include] = STATE(871),
    [sym_preproc_def] = STATE(871),
    [sym_preproc_function_def] = STATE(871),
    [sym_preproc_call] = STATE(871),
    [sym_preproc_if_in_compound_statement] = STATE(871),
    [sym_preproc_ifdef_in_compound_statement] = STATE(871),
    [sym_preproc_else_in_compound_statement] = STATE(1041),
    [sym_preproc_elif_in_compound_statement] = STATE(1041),
    [sym_declaration] = STATE(871),
    [sym_type_definition] = STATE(871),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(871),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(871),
    [sym_expression_statement] = STATE(871),
    [sym_if_statement] = STATE(871),
    [sym_switch_statement] = STATE(871),
    [sym_case_statement] = STATE(871),
    [sym_while_statement] = STATE(871),
    [sym_do_statement] = STATE(871),
    [sym_for_statement] = STATE(871),
    [sym_return_statement] = STATE(871),
    [sym_break_statement] = STATE(871),
    [sym_continue_statement] = STATE(871),
    [sym_goto_statement] = STATE(871),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(871),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(871),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2880),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [956] = {
    [anon_sym_LPAREN] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2296),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2298),
    [sym_preproc_directive] = ACTIONS(2298),
    [anon_sym_typedef] = ACTIONS(2298),
    [anon_sym_extern] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_auto] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2298),
    [anon_sym_inline] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym_unsigned] = ACTIONS(2298),
    [anon_sym_long] = ACTIONS(2298),
    [anon_sym_short] = ACTIONS(2298),
    [sym_primitive_type] = ACTIONS(2298),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_struct] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2298),
    [anon_sym_if] = ACTIONS(2298),
    [anon_sym_switch] = ACTIONS(2298),
    [anon_sym_case] = ACTIONS(2298),
    [anon_sym_default] = ACTIONS(2298),
    [anon_sym_while] = ACTIONS(2298),
    [anon_sym_do] = ACTIONS(2298),
    [anon_sym_for] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2298),
    [anon_sym_break] = ACTIONS(2298),
    [anon_sym_continue] = ACTIONS(2298),
    [anon_sym_goto] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2296),
    [anon_sym_PLUS_PLUS] = ACTIONS(2296),
    [anon_sym_sizeof] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2296),
    [anon_sym_SQUOTE] = ACTIONS(2296),
    [anon_sym_DQUOTE] = ACTIONS(2296),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [sym_null] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2298),
    [sym_comment] = ACTIONS(41),
  },
  [957] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2882),
    [sym_comment] = ACTIONS(41),
  },
  [958] = {
    [sym_preproc_include] = STATE(871),
    [sym_preproc_def] = STATE(871),
    [sym_preproc_function_def] = STATE(871),
    [sym_preproc_call] = STATE(871),
    [sym_preproc_if_in_compound_statement] = STATE(871),
    [sym_preproc_ifdef_in_compound_statement] = STATE(871),
    [sym_preproc_else_in_compound_statement] = STATE(1043),
    [sym_preproc_elif_in_compound_statement] = STATE(1043),
    [sym_declaration] = STATE(871),
    [sym_type_definition] = STATE(871),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(871),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(871),
    [sym_expression_statement] = STATE(871),
    [sym_if_statement] = STATE(871),
    [sym_switch_statement] = STATE(871),
    [sym_case_statement] = STATE(871),
    [sym_while_statement] = STATE(871),
    [sym_do_statement] = STATE(871),
    [sym_for_statement] = STATE(871),
    [sym_return_statement] = STATE(871),
    [sym_break_statement] = STATE(871),
    [sym_continue_statement] = STATE(871),
    [sym_goto_statement] = STATE(871),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(871),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(871),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [959] = {
    [sym_preproc_include] = STATE(1046),
    [sym_preproc_def] = STATE(1046),
    [sym_preproc_function_def] = STATE(1046),
    [sym_preproc_call] = STATE(1046),
    [sym_preproc_if_in_compound_statement] = STATE(1046),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1046),
    [sym_preproc_else_in_compound_statement] = STATE(1045),
    [sym_preproc_elif_in_compound_statement] = STATE(1045),
    [sym_declaration] = STATE(1046),
    [sym_type_definition] = STATE(1046),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(1046),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(1046),
    [sym_expression_statement] = STATE(1046),
    [sym_if_statement] = STATE(1046),
    [sym_switch_statement] = STATE(1046),
    [sym_case_statement] = STATE(1046),
    [sym_while_statement] = STATE(1046),
    [sym_do_statement] = STATE(1046),
    [sym_for_statement] = STATE(1046),
    [sym_return_statement] = STATE(1046),
    [sym_break_statement] = STATE(1046),
    [sym_continue_statement] = STATE(1046),
    [sym_goto_statement] = STATE(1046),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(1046),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1046),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2886),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [960] = {
    [sym_preproc_include] = STATE(1049),
    [sym_preproc_def] = STATE(1049),
    [sym_preproc_function_def] = STATE(1049),
    [sym_preproc_call] = STATE(1049),
    [sym_preproc_if_in_compound_statement] = STATE(1049),
    [sym_preproc_ifdef_in_compound_statement] = STATE(1049),
    [sym_preproc_else_in_compound_statement] = STATE(1048),
    [sym_preproc_elif_in_compound_statement] = STATE(1048),
    [sym_declaration] = STATE(1049),
    [sym_type_definition] = STATE(1049),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(1049),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(1049),
    [sym_expression_statement] = STATE(1049),
    [sym_if_statement] = STATE(1049),
    [sym_switch_statement] = STATE(1049),
    [sym_case_statement] = STATE(1049),
    [sym_while_statement] = STATE(1049),
    [sym_do_statement] = STATE(1049),
    [sym_for_statement] = STATE(1049),
    [sym_return_statement] = STATE(1049),
    [sym_break_statement] = STATE(1049),
    [sym_continue_statement] = STATE(1049),
    [sym_goto_statement] = STATE(1049),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(1049),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1049),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2888),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [961] = {
    [sym_compound_statement] = STATE(1057),
    [sym_labeled_statement] = STATE(1057),
    [sym_expression_statement] = STATE(1057),
    [sym_if_statement] = STATE(1057),
    [sym_switch_statement] = STATE(1057),
    [sym_case_statement] = STATE(1057),
    [sym_while_statement] = STATE(1057),
    [sym_do_statement] = STATE(1057),
    [sym_for_statement] = STATE(1057),
    [sym_return_statement] = STATE(1057),
    [sym_break_statement] = STATE(1057),
    [sym_continue_statement] = STATE(1057),
    [sym_goto_statement] = STATE(1057),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
  [962] = {
    [sym_compound_statement] = STATE(1059),
    [sym_labeled_statement] = STATE(1059),
    [sym_expression_statement] = STATE(1059),
    [sym_if_statement] = STATE(1059),
    [sym_switch_statement] = STATE(1059),
    [sym_case_statement] = STATE(1059),
    [sym_while_statement] = STATE(1059),
    [sym_do_statement] = STATE(1059),
    [sym_for_statement] = STATE(1059),
    [sym_return_statement] = STATE(1059),
    [sym_break_statement] = STATE(1059),
    [sym_continue_statement] = STATE(1059),
    [sym_goto_statement] = STATE(1059),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2904),
    [sym_comment] = ACTIONS(41),
  },
  [963] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [964] = {
    [sym_declaration] = STATE(1062),
    [sym_type_definition] = STATE(1062),
    [sym__declaration_specifiers] = STATE(1063),
    [sym_compound_statement] = STATE(1062),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(1062),
    [sym_expression_statement] = STATE(1062),
    [sym_if_statement] = STATE(1062),
    [sym_switch_statement] = STATE(1062),
    [sym_case_statement] = STATE(1062),
    [sym_while_statement] = STATE(1062),
    [sym_do_statement] = STATE(1062),
    [sym_for_statement] = STATE(1062),
    [sym_return_statement] = STATE(1062),
    [sym_break_statement] = STATE(1062),
    [sym_continue_statement] = STATE(1062),
    [sym_goto_statement] = STATE(1062),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2908),
    [sym_comment] = ACTIONS(41),
  },
  [965] = {
    [sym_compound_statement] = STATE(1064),
    [sym_labeled_statement] = STATE(1064),
    [sym_expression_statement] = STATE(1064),
    [sym_if_statement] = STATE(1064),
    [sym_switch_statement] = STATE(1064),
    [sym_case_statement] = STATE(1064),
    [sym_while_statement] = STATE(1064),
    [sym_do_statement] = STATE(1064),
    [sym_for_statement] = STATE(1064),
    [sym_return_statement] = STATE(1064),
    [sym_break_statement] = STATE(1064),
    [sym_continue_statement] = STATE(1064),
    [sym_goto_statement] = STATE(1064),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2904),
    [sym_comment] = ACTIONS(41),
  },
  [966] = {
    [anon_sym_while] = ACTIONS(2910),
    [sym_comment] = ACTIONS(41),
  },
  [967] = {
    [sym_declaration] = STATE(1066),
    [sym__declaration_specifiers] = STATE(685),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym__expression] = STATE(1067),
    [sym_conditional_expression] = STATE(1067),
    [sym_assignment_expression] = STATE(1067),
    [sym_pointer_expression] = STATE(1067),
    [sym_logical_expression] = STATE(1067),
    [sym_bitwise_expression] = STATE(1067),
    [sym_equality_expression] = STATE(1067),
    [sym_relational_expression] = STATE(1067),
    [sym_shift_expression] = STATE(1067),
    [sym_math_expression] = STATE(1067),
    [sym_cast_expression] = STATE(1067),
    [sym_sizeof_expression] = STATE(1067),
    [sym_subscript_expression] = STATE(1067),
    [sym_call_expression] = STATE(1067),
    [sym_field_expression] = STATE(1067),
    [sym_compound_literal_expression] = STATE(1067),
    [sym_parenthesized_expression] = STATE(1067),
    [sym_char_literal] = STATE(1067),
    [sym_concatenated_string] = STATE(1067),
    [sym_string_literal] = STATE(363),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(2912),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(2914),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2916),
    [sym_false] = ACTIONS(2916),
    [sym_null] = ACTIONS(2916),
    [sym_identifier] = ACTIONS(1630),
    [sym_comment] = ACTIONS(41),
  },
  [968] = {
    [anon_sym_LPAREN] = ACTIONS(1632),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_SEMI] = ACTIONS(1632),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1634),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1634),
    [sym_preproc_directive] = ACTIONS(1634),
    [anon_sym_typedef] = ACTIONS(1634),
    [anon_sym_extern] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_static] = ACTIONS(1634),
    [anon_sym_auto] = ACTIONS(1634),
    [anon_sym_register] = ACTIONS(1634),
    [anon_sym_inline] = ACTIONS(1634),
    [anon_sym_const] = ACTIONS(1634),
    [anon_sym_restrict] = ACTIONS(1634),
    [anon_sym_volatile] = ACTIONS(1634),
    [anon_sym__Atomic] = ACTIONS(1634),
    [anon_sym_unsigned] = ACTIONS(1634),
    [anon_sym_long] = ACTIONS(1634),
    [anon_sym_short] = ACTIONS(1634),
    [sym_primitive_type] = ACTIONS(1634),
    [anon_sym_enum] = ACTIONS(1634),
    [anon_sym_struct] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_if] = ACTIONS(1634),
    [anon_sym_else] = ACTIONS(1634),
    [anon_sym_switch] = ACTIONS(1634),
    [anon_sym_case] = ACTIONS(1634),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_while] = ACTIONS(1634),
    [anon_sym_do] = ACTIONS(1634),
    [anon_sym_for] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1634),
    [anon_sym_break] = ACTIONS(1634),
    [anon_sym_continue] = ACTIONS(1634),
    [anon_sym_goto] = ACTIONS(1634),
    [anon_sym_AMP] = ACTIONS(1632),
    [anon_sym_BANG] = ACTIONS(1632),
    [anon_sym_TILDE] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1634),
    [anon_sym_DASH] = ACTIONS(1634),
    [anon_sym_DASH_DASH] = ACTIONS(1632),
    [anon_sym_PLUS_PLUS] = ACTIONS(1632),
    [anon_sym_sizeof] = ACTIONS(1634),
    [sym_number_literal] = ACTIONS(1632),
    [anon_sym_SQUOTE] = ACTIONS(1632),
    [anon_sym_DQUOTE] = ACTIONS(1632),
    [sym_true] = ACTIONS(1634),
    [sym_false] = ACTIONS(1634),
    [sym_null] = ACTIONS(1634),
    [sym_identifier] = ACTIONS(1634),
    [sym_comment] = ACTIONS(41),
  },
  [969] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(2918),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [970] = {
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_LBRACE] = ACTIONS(1638),
    [anon_sym_SEMI] = ACTIONS(1638),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1640),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1640),
    [sym_preproc_directive] = ACTIONS(1640),
    [anon_sym_typedef] = ACTIONS(1640),
    [anon_sym_extern] = ACTIONS(1640),
    [anon_sym_STAR] = ACTIONS(1638),
    [anon_sym_static] = ACTIONS(1640),
    [anon_sym_auto] = ACTIONS(1640),
    [anon_sym_register] = ACTIONS(1640),
    [anon_sym_inline] = ACTIONS(1640),
    [anon_sym_const] = ACTIONS(1640),
    [anon_sym_restrict] = ACTIONS(1640),
    [anon_sym_volatile] = ACTIONS(1640),
    [anon_sym__Atomic] = ACTIONS(1640),
    [anon_sym_unsigned] = ACTIONS(1640),
    [anon_sym_long] = ACTIONS(1640),
    [anon_sym_short] = ACTIONS(1640),
    [sym_primitive_type] = ACTIONS(1640),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_struct] = ACTIONS(1640),
    [anon_sym_union] = ACTIONS(1640),
    [anon_sym_if] = ACTIONS(1640),
    [anon_sym_else] = ACTIONS(1640),
    [anon_sym_switch] = ACTIONS(1640),
    [anon_sym_case] = ACTIONS(1640),
    [anon_sym_default] = ACTIONS(1640),
    [anon_sym_while] = ACTIONS(1640),
    [anon_sym_do] = ACTIONS(1640),
    [anon_sym_for] = ACTIONS(1640),
    [anon_sym_return] = ACTIONS(1640),
    [anon_sym_break] = ACTIONS(1640),
    [anon_sym_continue] = ACTIONS(1640),
    [anon_sym_goto] = ACTIONS(1640),
    [anon_sym_AMP] = ACTIONS(1638),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_TILDE] = ACTIONS(1638),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_DASH_DASH] = ACTIONS(1638),
    [anon_sym_PLUS_PLUS] = ACTIONS(1638),
    [anon_sym_sizeof] = ACTIONS(1640),
    [sym_number_literal] = ACTIONS(1638),
    [anon_sym_SQUOTE] = ACTIONS(1638),
    [anon_sym_DQUOTE] = ACTIONS(1638),
    [sym_true] = ACTIONS(1640),
    [sym_false] = ACTIONS(1640),
    [sym_null] = ACTIONS(1640),
    [sym_identifier] = ACTIONS(1640),
    [sym_comment] = ACTIONS(41),
  },
  [971] = {
    [anon_sym_LPAREN] = ACTIONS(1642),
    [anon_sym_LBRACE] = ACTIONS(1642),
    [anon_sym_SEMI] = ACTIONS(1642),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1644),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1644),
    [sym_preproc_directive] = ACTIONS(1644),
    [anon_sym_typedef] = ACTIONS(1644),
    [anon_sym_extern] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1642),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_auto] = ACTIONS(1644),
    [anon_sym_register] = ACTIONS(1644),
    [anon_sym_inline] = ACTIONS(1644),
    [anon_sym_const] = ACTIONS(1644),
    [anon_sym_restrict] = ACTIONS(1644),
    [anon_sym_volatile] = ACTIONS(1644),
    [anon_sym__Atomic] = ACTIONS(1644),
    [anon_sym_unsigned] = ACTIONS(1644),
    [anon_sym_long] = ACTIONS(1644),
    [anon_sym_short] = ACTIONS(1644),
    [sym_primitive_type] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1644),
    [anon_sym_struct] = ACTIONS(1644),
    [anon_sym_union] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_else] = ACTIONS(1644),
    [anon_sym_switch] = ACTIONS(1644),
    [anon_sym_case] = ACTIONS(1644),
    [anon_sym_default] = ACTIONS(1644),
    [anon_sym_while] = ACTIONS(1644),
    [anon_sym_do] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_return] = ACTIONS(1644),
    [anon_sym_break] = ACTIONS(1644),
    [anon_sym_continue] = ACTIONS(1644),
    [anon_sym_goto] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1642),
    [anon_sym_TILDE] = ACTIONS(1642),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_DASH_DASH] = ACTIONS(1642),
    [anon_sym_PLUS_PLUS] = ACTIONS(1642),
    [anon_sym_sizeof] = ACTIONS(1644),
    [sym_number_literal] = ACTIONS(1642),
    [anon_sym_SQUOTE] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1644),
    [sym_comment] = ACTIONS(41),
  },
  [972] = {
    [anon_sym_SEMI] = ACTIONS(2920),
    [sym_comment] = ACTIONS(41),
  },
  [973] = {
    [sym_compound_statement] = STATE(1070),
    [sym_labeled_statement] = STATE(1070),
    [sym_expression_statement] = STATE(1070),
    [sym_if_statement] = STATE(1070),
    [sym_switch_statement] = STATE(1070),
    [sym_case_statement] = STATE(1070),
    [sym_while_statement] = STATE(1070),
    [sym_do_statement] = STATE(1070),
    [sym_for_statement] = STATE(1070),
    [sym_return_statement] = STATE(1070),
    [sym_break_statement] = STATE(1070),
    [sym_continue_statement] = STATE(1070),
    [sym_goto_statement] = STATE(1070),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2904),
    [sym_comment] = ACTIONS(41),
  },
  [974] = {
    [sym_parameter_list] = STATE(129),
    [aux_sym_declaration_repeat1] = STATE(530),
    [anon_sym_LPAREN] = ACTIONS(245),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_COMMA] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(255),
    [sym_comment] = ACTIONS(41),
  },
  [975] = {
    [anon_sym_LPAREN] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_SEMI] = ACTIONS(1672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1674),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1674),
    [sym_preproc_directive] = ACTIONS(1674),
    [anon_sym_typedef] = ACTIONS(1674),
    [anon_sym_extern] = ACTIONS(1674),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1674),
    [anon_sym_auto] = ACTIONS(1674),
    [anon_sym_register] = ACTIONS(1674),
    [anon_sym_inline] = ACTIONS(1674),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_restrict] = ACTIONS(1674),
    [anon_sym_volatile] = ACTIONS(1674),
    [anon_sym__Atomic] = ACTIONS(1674),
    [anon_sym_unsigned] = ACTIONS(1674),
    [anon_sym_long] = ACTIONS(1674),
    [anon_sym_short] = ACTIONS(1674),
    [sym_primitive_type] = ACTIONS(1674),
    [anon_sym_enum] = ACTIONS(1674),
    [anon_sym_struct] = ACTIONS(1674),
    [anon_sym_union] = ACTIONS(1674),
    [anon_sym_if] = ACTIONS(1674),
    [anon_sym_else] = ACTIONS(1674),
    [anon_sym_switch] = ACTIONS(1674),
    [anon_sym_case] = ACTIONS(1674),
    [anon_sym_default] = ACTIONS(1674),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1674),
    [anon_sym_for] = ACTIONS(1674),
    [anon_sym_return] = ACTIONS(1674),
    [anon_sym_break] = ACTIONS(1674),
    [anon_sym_continue] = ACTIONS(1674),
    [anon_sym_goto] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DASH_DASH] = ACTIONS(1672),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_sizeof] = ACTIONS(1674),
    [sym_number_literal] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1674),
    [sym_comment] = ACTIONS(41),
  },
  [976] = {
    [sym_preproc_include] = STATE(976),
    [sym_preproc_def] = STATE(976),
    [sym_preproc_function_def] = STATE(976),
    [sym_preproc_call] = STATE(976),
    [sym_preproc_if_in_compound_statement] = STATE(976),
    [sym_preproc_ifdef_in_compound_statement] = STATE(976),
    [sym_declaration] = STATE(976),
    [sym_type_definition] = STATE(976),
    [sym__declaration_specifiers] = STATE(849),
    [sym_compound_statement] = STATE(976),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(976),
    [sym_expression_statement] = STATE(976),
    [sym_if_statement] = STATE(976),
    [sym_switch_statement] = STATE(976),
    [sym_case_statement] = STATE(976),
    [sym_while_statement] = STATE(976),
    [sym_do_statement] = STATE(976),
    [sym_for_statement] = STATE(976),
    [sym_return_statement] = STATE(976),
    [sym_break_statement] = STATE(976),
    [sym_continue_statement] = STATE(976),
    [sym_goto_statement] = STATE(976),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(976),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(976),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(1746),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_SEMI] = ACTIONS(2925),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2928),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2931),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2934),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2672),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2937),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2937),
    [sym_preproc_directive] = ACTIONS(2940),
    [anon_sym_typedef] = ACTIONS(2943),
    [anon_sym_extern] = ACTIONS(1775),
    [anon_sym_STAR] = ACTIONS(1778),
    [anon_sym_static] = ACTIONS(1775),
    [anon_sym_auto] = ACTIONS(1775),
    [anon_sym_register] = ACTIONS(1775),
    [anon_sym_inline] = ACTIONS(1775),
    [anon_sym_const] = ACTIONS(1781),
    [anon_sym_restrict] = ACTIONS(1781),
    [anon_sym_volatile] = ACTIONS(1781),
    [anon_sym__Atomic] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1784),
    [anon_sym_long] = ACTIONS(1784),
    [anon_sym_short] = ACTIONS(1784),
    [sym_primitive_type] = ACTIONS(1787),
    [anon_sym_enum] = ACTIONS(1790),
    [anon_sym_struct] = ACTIONS(1793),
    [anon_sym_union] = ACTIONS(1796),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2949),
    [anon_sym_case] = ACTIONS(2952),
    [anon_sym_default] = ACTIONS(2955),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2961),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2973),
    [anon_sym_goto] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(1778),
    [anon_sym_BANG] = ACTIONS(1832),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_PLUS] = ACTIONS(1838),
    [anon_sym_DASH] = ACTIONS(1838),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1844),
    [sym_number_literal] = ACTIONS(2979),
    [anon_sym_SQUOTE] = ACTIONS(1850),
    [anon_sym_DQUOTE] = ACTIONS(1853),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [sym_null] = ACTIONS(2982),
    [sym_identifier] = ACTIONS(2985),
    [sym_comment] = ACTIONS(41),
  },
  [977] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2988),
    [sym_comment] = ACTIONS(41),
  },
  [978] = {
    [sym_preproc_include] = STATE(871),
    [sym_preproc_def] = STATE(871),
    [sym_preproc_function_def] = STATE(871),
    [sym_preproc_call] = STATE(871),
    [sym_preproc_if_in_compound_statement] = STATE(871),
    [sym_preproc_ifdef_in_compound_statement] = STATE(871),
    [sym_preproc_else_in_compound_statement] = STATE(1071),
    [sym_preproc_elif_in_compound_statement] = STATE(1071),
    [sym_declaration] = STATE(871),
    [sym_type_definition] = STATE(871),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(871),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(871),
    [sym_expression_statement] = STATE(871),
    [sym_if_statement] = STATE(871),
    [sym_switch_statement] = STATE(871),
    [sym_case_statement] = STATE(871),
    [sym_while_statement] = STATE(871),
    [sym_do_statement] = STATE(871),
    [sym_for_statement] = STATE(871),
    [sym_return_statement] = STATE(871),
    [sym_break_statement] = STATE(871),
    [sym_continue_statement] = STATE(871),
    [sym_goto_statement] = STATE(871),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(871),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(871),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2990),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [979] = {
    [sym_parenthesized_expression] = STATE(1072),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [980] = {
    [sym_parenthesized_expression] = STATE(1073),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [981] = {
    [sym__expression] = STATE(1074),
    [sym_conditional_expression] = STATE(1074),
    [sym_assignment_expression] = STATE(1074),
    [sym_pointer_expression] = STATE(1074),
    [sym_logical_expression] = STATE(1074),
    [sym_bitwise_expression] = STATE(1074),
    [sym_equality_expression] = STATE(1074),
    [sym_relational_expression] = STATE(1074),
    [sym_shift_expression] = STATE(1074),
    [sym_math_expression] = STATE(1074),
    [sym_cast_expression] = STATE(1074),
    [sym_sizeof_expression] = STATE(1074),
    [sym_subscript_expression] = STATE(1074),
    [sym_call_expression] = STATE(1074),
    [sym_field_expression] = STATE(1074),
    [sym_compound_literal_expression] = STATE(1074),
    [sym_parenthesized_expression] = STATE(1074),
    [sym_char_literal] = STATE(1074),
    [sym_concatenated_string] = STATE(1074),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(2992),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2994),
    [sym_false] = ACTIONS(2994),
    [sym_null] = ACTIONS(2994),
    [sym_identifier] = ACTIONS(2994),
    [sym_comment] = ACTIONS(41),
  },
  [982] = {
    [anon_sym_COLON] = ACTIONS(2996),
    [sym_comment] = ACTIONS(41),
  },
  [983] = {
    [sym_parenthesized_expression] = STATE(1076),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [984] = {
    [anon_sym_LPAREN] = ACTIONS(2998),
    [sym_comment] = ACTIONS(41),
  },
  [985] = {
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(3000),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(41),
  },
  [986] = {
    [anon_sym_LPAREN] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2316),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2318),
    [sym_preproc_directive] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_auto] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2318),
    [sym_comment] = ACTIONS(41),
  },
  [987] = {
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(2286),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(41),
  },
  [988] = {
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2322),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2324),
    [sym_preproc_directive] = ACTIONS(2324),
    [anon_sym_typedef] = ACTIONS(2324),
    [anon_sym_extern] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_auto] = ACTIONS(2324),
    [anon_sym_register] = ACTIONS(2324),
    [anon_sym_inline] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_restrict] = ACTIONS(2324),
    [anon_sym_volatile] = ACTIONS(2324),
    [anon_sym__Atomic] = ACTIONS(2324),
    [anon_sym_unsigned] = ACTIONS(2324),
    [anon_sym_long] = ACTIONS(2324),
    [anon_sym_short] = ACTIONS(2324),
    [sym_primitive_type] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
    [anon_sym_struct] = ACTIONS(2324),
    [anon_sym_union] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_else] = ACTIONS(2324),
    [anon_sym_switch] = ACTIONS(2324),
    [anon_sym_case] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_do] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_goto] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_TILDE] = ACTIONS(2322),
    [anon_sym_PLUS] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2324),
    [anon_sym_DASH_DASH] = ACTIONS(2322),
    [anon_sym_PLUS_PLUS] = ACTIONS(2322),
    [anon_sym_sizeof] = ACTIONS(2324),
    [sym_number_literal] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2322),
    [anon_sym_DQUOTE] = ACTIONS(2322),
    [sym_true] = ACTIONS(2324),
    [sym_false] = ACTIONS(2324),
    [sym_null] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2324),
    [sym_comment] = ACTIONS(41),
  },
  [989] = {
    [sym_declaration] = STATE(1080),
    [sym_type_definition] = STATE(1080),
    [sym__declaration_specifiers] = STATE(992),
    [sym_compound_statement] = STATE(1080),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(1080),
    [sym_expression_statement] = STATE(1080),
    [sym_if_statement] = STATE(1080),
    [sym_switch_statement] = STATE(1080),
    [sym_case_statement] = STATE(1080),
    [sym_while_statement] = STATE(1080),
    [sym_do_statement] = STATE(1080),
    [sym_for_statement] = STATE(1080),
    [sym_return_statement] = STATE(1080),
    [sym_break_statement] = STATE(1080),
    [sym_continue_statement] = STATE(1080),
    [sym_goto_statement] = STATE(1080),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2637),
    [sym_comment] = ACTIONS(41),
  },
  [990] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(2286),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [991] = {
    [anon_sym_LPAREN] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2374),
    [sym_preproc_directive] = ACTIONS(2374),
    [anon_sym_typedef] = ACTIONS(2374),
    [anon_sym_extern] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_auto] = ACTIONS(2374),
    [anon_sym_register] = ACTIONS(2374),
    [anon_sym_inline] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_restrict] = ACTIONS(2374),
    [anon_sym_volatile] = ACTIONS(2374),
    [anon_sym__Atomic] = ACTIONS(2374),
    [anon_sym_unsigned] = ACTIONS(2374),
    [anon_sym_long] = ACTIONS(2374),
    [anon_sym_short] = ACTIONS(2374),
    [sym_primitive_type] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
    [anon_sym_struct] = ACTIONS(2374),
    [anon_sym_union] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2374),
    [anon_sym_switch] = ACTIONS(2374),
    [anon_sym_case] = ACTIONS(2374),
    [anon_sym_default] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_do] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_goto] = ACTIONS(2374),
    [anon_sym_AMP] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2374),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [sym_null] = ACTIONS(2374),
    [sym_identifier] = ACTIONS(2374),
    [sym_comment] = ACTIONS(41),
  },
  [992] = {
    [sym__declarator] = STATE(868),
    [sym_pointer_declarator] = STATE(868),
    [sym_function_declarator] = STATE(868),
    [sym_array_declarator] = STATE(868),
    [sym_init_declarator] = STATE(169),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(593),
    [sym_identifier] = ACTIONS(2290),
    [sym_comment] = ACTIONS(41),
  },
  [993] = {
    [anon_sym_LPAREN] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_auto] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2376),
    [anon_sym_sizeof] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [sym_null] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(2378),
    [sym_comment] = ACTIONS(41),
  },
  [994] = {
    [sym_parenthesized_expression] = STATE(1082),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [sym_comment] = ACTIONS(41),
  },
  [995] = {
    [sym__expression] = STATE(1084),
    [sym_conditional_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1084),
    [sym_pointer_expression] = STATE(1084),
    [sym_logical_expression] = STATE(1084),
    [sym_bitwise_expression] = STATE(1084),
    [sym_equality_expression] = STATE(1084),
    [sym_relational_expression] = STATE(1084),
    [sym_shift_expression] = STATE(1084),
    [sym_math_expression] = STATE(1084),
    [sym_cast_expression] = STATE(1084),
    [sym_sizeof_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_call_expression] = STATE(1084),
    [sym_field_expression] = STATE(1084),
    [sym_compound_literal_expression] = STATE(1084),
    [sym_parenthesized_expression] = STATE(1084),
    [sym_char_literal] = STATE(1084),
    [sym_concatenated_string] = STATE(1084),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3008),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3010),
    [sym_false] = ACTIONS(3010),
    [sym_null] = ACTIONS(3010),
    [sym_identifier] = ACTIONS(3010),
    [sym_comment] = ACTIONS(41),
  },
  [996] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [997] = {
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2416),
    [sym_preproc_directive] = ACTIONS(2416),
    [anon_sym_typedef] = ACTIONS(2416),
    [anon_sym_extern] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_auto] = ACTIONS(2416),
    [anon_sym_register] = ACTIONS(2416),
    [anon_sym_inline] = ACTIONS(2416),
    [anon_sym_const] = ACTIONS(2416),
    [anon_sym_restrict] = ACTIONS(2416),
    [anon_sym_volatile] = ACTIONS(2416),
    [anon_sym__Atomic] = ACTIONS(2416),
    [anon_sym_unsigned] = ACTIONS(2416),
    [anon_sym_long] = ACTIONS(2416),
    [anon_sym_short] = ACTIONS(2416),
    [sym_primitive_type] = ACTIONS(2416),
    [anon_sym_enum] = ACTIONS(2416),
    [anon_sym_struct] = ACTIONS(2416),
    [anon_sym_union] = ACTIONS(2416),
    [anon_sym_if] = ACTIONS(2416),
    [anon_sym_else] = ACTIONS(2416),
    [anon_sym_switch] = ACTIONS(2416),
    [anon_sym_case] = ACTIONS(2416),
    [anon_sym_default] = ACTIONS(2416),
    [anon_sym_while] = ACTIONS(2416),
    [anon_sym_do] = ACTIONS(2416),
    [anon_sym_for] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2416),
    [anon_sym_break] = ACTIONS(2416),
    [anon_sym_continue] = ACTIONS(2416),
    [anon_sym_goto] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_TILDE] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2414),
    [anon_sym_sizeof] = ACTIONS(2416),
    [sym_number_literal] = ACTIONS(2414),
    [anon_sym_SQUOTE] = ACTIONS(2414),
    [anon_sym_DQUOTE] = ACTIONS(2414),
    [sym_true] = ACTIONS(2416),
    [sym_false] = ACTIONS(2416),
    [sym_null] = ACTIONS(2416),
    [sym_identifier] = ACTIONS(2416),
    [sym_comment] = ACTIONS(41),
  },
  [998] = {
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2420),
    [sym_preproc_directive] = ACTIONS(2420),
    [anon_sym_typedef] = ACTIONS(2420),
    [anon_sym_extern] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2420),
    [anon_sym_auto] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2420),
    [anon_sym_inline] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2420),
    [anon_sym_restrict] = ACTIONS(2420),
    [anon_sym_volatile] = ACTIONS(2420),
    [anon_sym__Atomic] = ACTIONS(2420),
    [anon_sym_unsigned] = ACTIONS(2420),
    [anon_sym_long] = ACTIONS(2420),
    [anon_sym_short] = ACTIONS(2420),
    [sym_primitive_type] = ACTIONS(2420),
    [anon_sym_enum] = ACTIONS(2420),
    [anon_sym_struct] = ACTIONS(2420),
    [anon_sym_union] = ACTIONS(2420),
    [anon_sym_if] = ACTIONS(2420),
    [anon_sym_else] = ACTIONS(2420),
    [anon_sym_switch] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(2420),
    [anon_sym_default] = ACTIONS(2420),
    [anon_sym_while] = ACTIONS(2420),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2420),
    [anon_sym_break] = ACTIONS(2420),
    [anon_sym_continue] = ACTIONS(2420),
    [anon_sym_goto] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2418),
    [anon_sym_sizeof] = ACTIONS(2420),
    [sym_number_literal] = ACTIONS(2418),
    [anon_sym_SQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [sym_true] = ACTIONS(2420),
    [sym_false] = ACTIONS(2420),
    [sym_null] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2420),
    [sym_comment] = ACTIONS(41),
  },
  [999] = {
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2430),
    [sym_preproc_directive] = ACTIONS(2430),
    [anon_sym_typedef] = ACTIONS(2430),
    [anon_sym_extern] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_auto] = ACTIONS(2430),
    [anon_sym_register] = ACTIONS(2430),
    [anon_sym_inline] = ACTIONS(2430),
    [anon_sym_const] = ACTIONS(2430),
    [anon_sym_restrict] = ACTIONS(2430),
    [anon_sym_volatile] = ACTIONS(2430),
    [anon_sym__Atomic] = ACTIONS(2430),
    [anon_sym_unsigned] = ACTIONS(2430),
    [anon_sym_long] = ACTIONS(2430),
    [anon_sym_short] = ACTIONS(2430),
    [sym_primitive_type] = ACTIONS(2430),
    [anon_sym_enum] = ACTIONS(2430),
    [anon_sym_struct] = ACTIONS(2430),
    [anon_sym_union] = ACTIONS(2430),
    [anon_sym_if] = ACTIONS(2430),
    [anon_sym_else] = ACTIONS(2430),
    [anon_sym_switch] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(2430),
    [anon_sym_default] = ACTIONS(2430),
    [anon_sym_while] = ACTIONS(2430),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_for] = ACTIONS(2430),
    [anon_sym_return] = ACTIONS(2430),
    [anon_sym_break] = ACTIONS(2430),
    [anon_sym_continue] = ACTIONS(2430),
    [anon_sym_goto] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_sizeof] = ACTIONS(2430),
    [sym_number_literal] = ACTIONS(2428),
    [anon_sym_SQUOTE] = ACTIONS(2428),
    [anon_sym_DQUOTE] = ACTIONS(2428),
    [sym_true] = ACTIONS(2430),
    [sym_false] = ACTIONS(2430),
    [sym_null] = ACTIONS(2430),
    [sym_identifier] = ACTIONS(2430),
    [sym_comment] = ACTIONS(41),
  },
  [1000] = {
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3014),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3016),
    [sym_preproc_directive] = ACTIONS(3016),
    [anon_sym_typedef] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_auto] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [sym_primitive_type] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_goto] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_sizeof] = ACTIONS(3016),
    [sym_number_literal] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [sym_null] = ACTIONS(3016),
    [sym_identifier] = ACTIONS(3016),
    [sym_comment] = ACTIONS(41),
  },
  [1001] = {
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_auto] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [sym_primitive_type] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_sizeof] = ACTIONS(3020),
    [sym_number_literal] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [sym_null] = ACTIONS(3020),
    [sym_identifier] = ACTIONS(3020),
    [sym_comment] = ACTIONS(41),
  },
  [1002] = {
    [anon_sym_LPAREN] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_RBRACE] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2316),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2318),
    [sym_preproc_directive] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_auto] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2318),
    [sym_comment] = ACTIONS(41),
  },
  [1003] = {
    [sym_declaration] = STATE(886),
    [sym_type_definition] = STATE(886),
    [sym__declaration_specifiers] = STATE(685),
    [sym_compound_statement] = STATE(886),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(886),
    [sym_expression_statement] = STATE(886),
    [sym_if_statement] = STATE(886),
    [sym_switch_statement] = STATE(886),
    [sym_case_statement] = STATE(886),
    [sym_while_statement] = STATE(886),
    [sym_do_statement] = STATE(886),
    [sym_for_statement] = STATE(886),
    [sym_return_statement] = STATE(886),
    [sym_break_statement] = STATE(886),
    [sym_continue_statement] = STATE(886),
    [sym_goto_statement] = STATE(886),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2733),
    [sym_comment] = ACTIONS(41),
  },
  [1004] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(2314),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [1005] = {
    [sym__expression] = STATE(1088),
    [sym_conditional_expression] = STATE(1088),
    [sym_assignment_expression] = STATE(1088),
    [sym_pointer_expression] = STATE(1088),
    [sym_logical_expression] = STATE(1088),
    [sym_bitwise_expression] = STATE(1088),
    [sym_equality_expression] = STATE(1088),
    [sym_relational_expression] = STATE(1088),
    [sym_shift_expression] = STATE(1088),
    [sym_math_expression] = STATE(1088),
    [sym_cast_expression] = STATE(1088),
    [sym_sizeof_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1088),
    [sym_call_expression] = STATE(1088),
    [sym_field_expression] = STATE(1088),
    [sym_compound_literal_expression] = STATE(1088),
    [sym_parenthesized_expression] = STATE(1088),
    [sym_char_literal] = STATE(1088),
    [sym_concatenated_string] = STATE(1088),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3026),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3028),
    [sym_false] = ACTIONS(3028),
    [sym_null] = ACTIONS(3028),
    [sym_identifier] = ACTIONS(3028),
    [sym_comment] = ACTIONS(41),
  },
  [1006] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1007] = {
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_auto] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [sym_null] = ACTIONS(3034),
    [sym_identifier] = ACTIONS(3034),
    [sym_comment] = ACTIONS(41),
  },
  [1008] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(829),
    [sym_char_literal] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_COLON] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_STAR_EQ] = ACTIONS(2787),
    [anon_sym_SLASH_EQ] = ACTIONS(2787),
    [anon_sym_PERCENT_EQ] = ACTIONS(2787),
    [anon_sym_PLUS_EQ] = ACTIONS(2787),
    [anon_sym_DASH_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_GT_EQ] = ACTIONS(2787),
    [anon_sym_AMP_EQ] = ACTIONS(2787),
    [anon_sym_CARET_EQ] = ACTIONS(2787),
    [anon_sym_PIPE_EQ] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_EQ_EQ] = ACTIONS(2787),
    [anon_sym_BANG_EQ] = ACTIONS(2787),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_LT_EQ] = ACTIONS(2787),
    [anon_sym_GT_EQ] = ACTIONS(2787),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [anon_sym_DOT] = ACTIONS(2787),
    [anon_sym_DASH_GT] = ACTIONS(2787),
    [sym_number_literal] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(41),
  },
  [1009] = {
    [sym__expression] = STATE(1090),
    [sym_conditional_expression] = STATE(1090),
    [sym_assignment_expression] = STATE(1090),
    [sym_pointer_expression] = STATE(1090),
    [sym_logical_expression] = STATE(1090),
    [sym_bitwise_expression] = STATE(1090),
    [sym_equality_expression] = STATE(1090),
    [sym_relational_expression] = STATE(1090),
    [sym_shift_expression] = STATE(1090),
    [sym_math_expression] = STATE(1090),
    [sym_cast_expression] = STATE(1090),
    [sym_sizeof_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1090),
    [sym_call_expression] = STATE(1090),
    [sym_field_expression] = STATE(1090),
    [sym_compound_literal_expression] = STATE(1090),
    [sym_parenthesized_expression] = STATE(1090),
    [sym_char_literal] = STATE(1090),
    [sym_concatenated_string] = STATE(1090),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [sym_null] = ACTIONS(3042),
    [sym_identifier] = ACTIONS(3042),
    [sym_comment] = ACTIONS(41),
  },
  [1010] = {
    [sym_compound_statement] = STATE(1091),
    [sym_labeled_statement] = STATE(1091),
    [sym_expression_statement] = STATE(1091),
    [sym_if_statement] = STATE(1091),
    [sym_switch_statement] = STATE(1091),
    [sym_case_statement] = STATE(1091),
    [sym_while_statement] = STATE(1091),
    [sym_do_statement] = STATE(1091),
    [sym_for_statement] = STATE(1091),
    [sym_return_statement] = STATE(1091),
    [sym_break_statement] = STATE(1091),
    [sym_continue_statement] = STATE(1091),
    [sym_goto_statement] = STATE(1091),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [1011] = {
    [sym_compound_statement] = STATE(665),
    [sym_labeled_statement] = STATE(665),
    [sym_expression_statement] = STATE(665),
    [sym_if_statement] = STATE(665),
    [sym_switch_statement] = STATE(665),
    [sym_case_statement] = STATE(665),
    [sym_while_statement] = STATE(665),
    [sym_do_statement] = STATE(665),
    [sym_for_statement] = STATE(665),
    [sym_return_statement] = STATE(665),
    [sym_break_statement] = STATE(665),
    [sym_continue_statement] = STATE(665),
    [sym_goto_statement] = STATE(665),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [1012] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(3044),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1013] = {
    [sym_declaration] = STATE(684),
    [sym_type_definition] = STATE(684),
    [sym__declaration_specifiers] = STATE(685),
    [sym_compound_statement] = STATE(684),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(684),
    [sym_expression_statement] = STATE(684),
    [sym_if_statement] = STATE(684),
    [sym_switch_statement] = STATE(684),
    [sym_case_statement] = STATE(684),
    [sym_while_statement] = STATE(684),
    [sym_do_statement] = STATE(684),
    [sym_for_statement] = STATE(684),
    [sym_return_statement] = STATE(684),
    [sym_break_statement] = STATE(684),
    [sym_continue_statement] = STATE(684),
    [sym_goto_statement] = STATE(684),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(3046),
    [sym_comment] = ACTIONS(41),
  },
  [1014] = {
    [sym_compound_statement] = STATE(686),
    [sym_labeled_statement] = STATE(686),
    [sym_expression_statement] = STATE(686),
    [sym_if_statement] = STATE(686),
    [sym_switch_statement] = STATE(686),
    [sym_case_statement] = STATE(686),
    [sym_while_statement] = STATE(686),
    [sym_do_statement] = STATE(686),
    [sym_for_statement] = STATE(686),
    [sym_return_statement] = STATE(686),
    [sym_break_statement] = STATE(686),
    [sym_continue_statement] = STATE(686),
    [sym_goto_statement] = STATE(686),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [1015] = {
    [sym_declaration] = STATE(1094),
    [sym__declaration_specifiers] = STATE(685),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym__expression] = STATE(1095),
    [sym_conditional_expression] = STATE(1095),
    [sym_assignment_expression] = STATE(1095),
    [sym_pointer_expression] = STATE(1095),
    [sym_logical_expression] = STATE(1095),
    [sym_bitwise_expression] = STATE(1095),
    [sym_equality_expression] = STATE(1095),
    [sym_relational_expression] = STATE(1095),
    [sym_shift_expression] = STATE(1095),
    [sym_math_expression] = STATE(1095),
    [sym_cast_expression] = STATE(1095),
    [sym_sizeof_expression] = STATE(1095),
    [sym_subscript_expression] = STATE(1095),
    [sym_call_expression] = STATE(1095),
    [sym_field_expression] = STATE(1095),
    [sym_compound_literal_expression] = STATE(1095),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_char_literal] = STATE(1095),
    [sym_concatenated_string] = STATE(1095),
    [sym_string_literal] = STATE(363),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3050),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [sym_null] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(1630),
    [sym_comment] = ACTIONS(41),
  },
  [1016] = {
    [sym_compound_statement] = STATE(703),
    [sym_labeled_statement] = STATE(703),
    [sym_expression_statement] = STATE(703),
    [sym_if_statement] = STATE(703),
    [sym_switch_statement] = STATE(703),
    [sym_case_statement] = STATE(703),
    [sym_while_statement] = STATE(703),
    [sym_do_statement] = STATE(703),
    [sym_for_statement] = STATE(703),
    [sym_return_statement] = STATE(703),
    [sym_break_statement] = STATE(703),
    [sym_continue_statement] = STATE(703),
    [sym_goto_statement] = STATE(703),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [1017] = {
    [sym_compound_statement] = STATE(1007),
    [sym_labeled_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_if_statement] = STATE(1007),
    [sym_switch_statement] = STATE(1007),
    [sym_case_statement] = STATE(1007),
    [sym_while_statement] = STATE(1007),
    [sym_do_statement] = STATE(1007),
    [sym_for_statement] = STATE(1007),
    [sym_return_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_goto_statement] = STATE(1007),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [1018] = {
    [sym__expression] = STATE(398),
    [sym_comma_expression] = STATE(399),
    [sym_conditional_expression] = STATE(398),
    [sym_assignment_expression] = STATE(398),
    [sym_pointer_expression] = STATE(398),
    [sym_logical_expression] = STATE(398),
    [sym_bitwise_expression] = STATE(398),
    [sym_equality_expression] = STATE(398),
    [sym_relational_expression] = STATE(398),
    [sym_shift_expression] = STATE(398),
    [sym_math_expression] = STATE(398),
    [sym_cast_expression] = STATE(398),
    [sym_sizeof_expression] = STATE(398),
    [sym_subscript_expression] = STATE(398),
    [sym_call_expression] = STATE(398),
    [sym_field_expression] = STATE(398),
    [sym_compound_literal_expression] = STATE(398),
    [sym_parenthesized_expression] = STATE(398),
    [sym_char_literal] = STATE(398),
    [sym_concatenated_string] = STATE(398),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(964),
    [sym_comment] = ACTIONS(41),
  },
  [1019] = {
    [sym__expression] = STATE(1097),
    [sym_conditional_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1097),
    [sym_pointer_expression] = STATE(1097),
    [sym_logical_expression] = STATE(1097),
    [sym_bitwise_expression] = STATE(1097),
    [sym_equality_expression] = STATE(1097),
    [sym_relational_expression] = STATE(1097),
    [sym_shift_expression] = STATE(1097),
    [sym_math_expression] = STATE(1097),
    [sym_cast_expression] = STATE(1097),
    [sym_sizeof_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_call_expression] = STATE(1097),
    [sym_field_expression] = STATE(1097),
    [sym_compound_literal_expression] = STATE(1097),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_char_literal] = STATE(1097),
    [sym_concatenated_string] = STATE(1097),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [sym_null] = ACTIONS(3058),
    [sym_identifier] = ACTIONS(3058),
    [sym_comment] = ACTIONS(41),
  },
  [1020] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1021] = {
    [sym__expression] = STATE(1099),
    [sym_conditional_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1099),
    [sym_pointer_expression] = STATE(1099),
    [sym_logical_expression] = STATE(1099),
    [sym_bitwise_expression] = STATE(1099),
    [sym_equality_expression] = STATE(1099),
    [sym_relational_expression] = STATE(1099),
    [sym_shift_expression] = STATE(1099),
    [sym_math_expression] = STATE(1099),
    [sym_cast_expression] = STATE(1099),
    [sym_sizeof_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_call_expression] = STATE(1099),
    [sym_field_expression] = STATE(1099),
    [sym_compound_literal_expression] = STATE(1099),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_char_literal] = STATE(1099),
    [sym_concatenated_string] = STATE(1099),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [sym_null] = ACTIONS(3064),
    [sym_identifier] = ACTIONS(3064),
    [sym_comment] = ACTIONS(41),
  },
  [1022] = {
    [sym_compound_statement] = STATE(1100),
    [sym_labeled_statement] = STATE(1100),
    [sym_expression_statement] = STATE(1100),
    [sym_if_statement] = STATE(1100),
    [sym_switch_statement] = STATE(1100),
    [sym_case_statement] = STATE(1100),
    [sym_while_statement] = STATE(1100),
    [sym_do_statement] = STATE(1100),
    [sym_for_statement] = STATE(1100),
    [sym_return_statement] = STATE(1100),
    [sym_break_statement] = STATE(1100),
    [sym_continue_statement] = STATE(1100),
    [sym_goto_statement] = STATE(1100),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1572),
    [sym_comment] = ACTIONS(41),
  },
  [1023] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1102),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1024] = {
    [sym__expression] = STATE(1103),
    [sym_conditional_expression] = STATE(1103),
    [sym_assignment_expression] = STATE(1103),
    [sym_pointer_expression] = STATE(1103),
    [sym_logical_expression] = STATE(1103),
    [sym_bitwise_expression] = STATE(1103),
    [sym_equality_expression] = STATE(1103),
    [sym_relational_expression] = STATE(1103),
    [sym_shift_expression] = STATE(1103),
    [sym_math_expression] = STATE(1103),
    [sym_cast_expression] = STATE(1103),
    [sym_sizeof_expression] = STATE(1103),
    [sym_subscript_expression] = STATE(1103),
    [sym_call_expression] = STATE(1103),
    [sym_field_expression] = STATE(1103),
    [sym_compound_literal_expression] = STATE(1103),
    [sym_parenthesized_expression] = STATE(1103),
    [sym_char_literal] = STATE(1103),
    [sym_concatenated_string] = STATE(1103),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3068),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3070),
    [sym_false] = ACTIONS(3070),
    [sym_null] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_comment] = ACTIONS(41),
  },
  [1025] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1026] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3074),
    [anon_sym_COMMA] = ACTIONS(3074),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1027] = {
    [anon_sym_LPAREN] = ACTIONS(3076),
    [anon_sym_RBRACE] = ACTIONS(3076),
    [anon_sym_RPAREN] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3076),
    [anon_sym_COMMA] = ACTIONS(3076),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_RBRACK] = ACTIONS(3076),
    [anon_sym_EQ] = ACTIONS(3078),
    [anon_sym_COLON] = ACTIONS(3076),
    [anon_sym_QMARK] = ACTIONS(3076),
    [anon_sym_STAR_EQ] = ACTIONS(3076),
    [anon_sym_SLASH_EQ] = ACTIONS(3076),
    [anon_sym_PERCENT_EQ] = ACTIONS(3076),
    [anon_sym_PLUS_EQ] = ACTIONS(3076),
    [anon_sym_DASH_EQ] = ACTIONS(3076),
    [anon_sym_LT_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT_GT_EQ] = ACTIONS(3076),
    [anon_sym_AMP_EQ] = ACTIONS(3076),
    [anon_sym_CARET_EQ] = ACTIONS(3076),
    [anon_sym_PIPE_EQ] = ACTIONS(3076),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_PIPE_PIPE] = ACTIONS(3076),
    [anon_sym_AMP_AMP] = ACTIONS(3076),
    [anon_sym_PIPE] = ACTIONS(3078),
    [anon_sym_CARET] = ACTIONS(3078),
    [anon_sym_EQ_EQ] = ACTIONS(3076),
    [anon_sym_BANG_EQ] = ACTIONS(3076),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_GT] = ACTIONS(3078),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3076),
    [anon_sym_LT_LT] = ACTIONS(3078),
    [anon_sym_GT_GT] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_SLASH] = ACTIONS(3078),
    [anon_sym_PERCENT] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3076),
    [anon_sym_PLUS_PLUS] = ACTIONS(3076),
    [anon_sym_DOT] = ACTIONS(3076),
    [anon_sym_DASH_GT] = ACTIONS(3076),
    [sym_comment] = ACTIONS(41),
  },
  [1028] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3074),
    [anon_sym_COMMA] = ACTIONS(3080),
    [sym_comment] = ACTIONS(41),
  },
  [1029] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1088),
    [anon_sym_QMARK] = ACTIONS(1090),
    [anon_sym_STAR_EQ] = ACTIONS(1092),
    [anon_sym_SLASH_EQ] = ACTIONS(1092),
    [anon_sym_PERCENT_EQ] = ACTIONS(1092),
    [anon_sym_PLUS_EQ] = ACTIONS(1092),
    [anon_sym_DASH_EQ] = ACTIONS(1092),
    [anon_sym_LT_LT_EQ] = ACTIONS(1092),
    [anon_sym_GT_GT_EQ] = ACTIONS(1092),
    [anon_sym_AMP_EQ] = ACTIONS(1092),
    [anon_sym_CARET_EQ] = ACTIONS(1092),
    [anon_sym_PIPE_EQ] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1106),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1030] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(1140),
    [anon_sym_STAR_EQ] = ACTIONS(1142),
    [anon_sym_SLASH_EQ] = ACTIONS(1142),
    [anon_sym_PERCENT_EQ] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(1142),
    [anon_sym_DASH_EQ] = ACTIONS(1142),
    [anon_sym_LT_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT_GT_EQ] = ACTIONS(1142),
    [anon_sym_AMP_EQ] = ACTIONS(1142),
    [anon_sym_CARET_EQ] = ACTIONS(1142),
    [anon_sym_PIPE_EQ] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(1152),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1160),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1162),
    [anon_sym_DASH] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1031] = {
    [anon_sym_LPAREN] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3087),
    [anon_sym_COLON] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_STAR_EQ] = ACTIONS(3085),
    [anon_sym_SLASH_EQ] = ACTIONS(3085),
    [anon_sym_PERCENT_EQ] = ACTIONS(3085),
    [anon_sym_PLUS_EQ] = ACTIONS(3085),
    [anon_sym_DASH_EQ] = ACTIONS(3085),
    [anon_sym_LT_LT_EQ] = ACTIONS(3085),
    [anon_sym_GT_GT_EQ] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3085),
    [anon_sym_CARET_EQ] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_BANG_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3085),
    [anon_sym_LT_LT] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_SLASH] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_DASH_GT] = ACTIONS(3085),
    [sym_comment] = ACTIONS(41),
  },
  [1032] = {
    [sym__expression] = STATE(925),
    [sym_conditional_expression] = STATE(925),
    [sym_assignment_expression] = STATE(925),
    [sym_pointer_expression] = STATE(925),
    [sym_logical_expression] = STATE(925),
    [sym_bitwise_expression] = STATE(925),
    [sym_equality_expression] = STATE(925),
    [sym_relational_expression] = STATE(925),
    [sym_shift_expression] = STATE(925),
    [sym_math_expression] = STATE(925),
    [sym_cast_expression] = STATE(925),
    [sym_sizeof_expression] = STATE(925),
    [sym_subscript_expression] = STATE(925),
    [sym_call_expression] = STATE(925),
    [sym_field_expression] = STATE(925),
    [sym_compound_literal_expression] = STATE(925),
    [sym_parenthesized_expression] = STATE(925),
    [sym_initializer_list] = STATE(926),
    [sym_initializer_pair] = STATE(926),
    [sym_subscript_designator] = STATE(492),
    [sym_field_designator] = STATE(492),
    [sym_char_literal] = STATE(925),
    [sym_concatenated_string] = STATE(925),
    [sym_string_literal] = STATE(339),
    [aux_sym_initializer_pair_repeat1] = STATE(492),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_sizeof] = ACTIONS(808),
    [anon_sym_DOT] = ACTIONS(1174),
    [sym_number_literal] = ACTIONS(2499),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2501),
    [sym_false] = ACTIONS(2501),
    [sym_null] = ACTIONS(2501),
    [sym_identifier] = ACTIONS(2501),
    [sym_comment] = ACTIONS(41),
  },
  [1033] = {
    [ts_builtin_sym_end] = ACTIONS(3089),
    [anon_sym_tensor] = ACTIONS(3091),
    [anon_sym_RBRACE] = ACTIONS(3089),
    [anon_sym_indexvars] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3091),
    [sym_preproc_directive] = ACTIONS(3091),
    [anon_sym_typedef] = ACTIONS(3091),
    [anon_sym_extern] = ACTIONS(3091),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_auto] = ACTIONS(3091),
    [anon_sym_register] = ACTIONS(3091),
    [anon_sym_inline] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3091),
    [anon_sym_restrict] = ACTIONS(3091),
    [anon_sym_volatile] = ACTIONS(3091),
    [anon_sym__Atomic] = ACTIONS(3091),
    [anon_sym_unsigned] = ACTIONS(3091),
    [anon_sym_long] = ACTIONS(3091),
    [anon_sym_short] = ACTIONS(3091),
    [sym_primitive_type] = ACTIONS(3091),
    [anon_sym_enum] = ACTIONS(3091),
    [anon_sym_struct] = ACTIONS(3091),
    [anon_sym_union] = ACTIONS(3091),
    [sym_identifier] = ACTIONS(3091),
    [sym_comment] = ACTIONS(41),
  },
  [1034] = {
    [sym_ta_integer_list] = STATE(1106),
    [sym_number_literal] = ACTIONS(3093),
    [sym_comment] = ACTIONS(41),
  },
  [1035] = {
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [sym_comment] = ACTIONS(41),
  },
  [1036] = {
    [anon_sym_RBRACE] = ACTIONS(3099),
    [sym_comment] = ACTIONS(41),
  },
  [1037] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_EQ] = ACTIONS(1326),
    [anon_sym_SLASH_EQ] = ACTIONS(1326),
    [anon_sym_PERCENT_EQ] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1326),
    [anon_sym_DASH_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT_GT_EQ] = ACTIONS(1326),
    [anon_sym_AMP_EQ] = ACTIONS(1326),
    [anon_sym_CARET_EQ] = ACTIONS(1326),
    [anon_sym_PIPE_EQ] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(1330),
    [anon_sym_AMP_AMP] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PERCENT] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1038] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1039] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1040] = {
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2651),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_auto] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [sym_primitive_type] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_sizeof] = ACTIONS(2653),
    [sym_number_literal] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [sym_null] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_comment] = ACTIONS(41),
  },
  [1041] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3101),
    [sym_comment] = ACTIONS(41),
  },
  [1042] = {
    [anon_sym_LPAREN] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2725),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_auto] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [sym_null] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2727),
    [sym_comment] = ACTIONS(41),
  },
  [1043] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3103),
    [sym_comment] = ACTIONS(41),
  },
  [1044] = {
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2224),
    [sym_preproc_directive] = ACTIONS(2224),
    [anon_sym_typedef] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_auto] = ACTIONS(2224),
    [anon_sym_register] = ACTIONS(2224),
    [anon_sym_inline] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_restrict] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym__Atomic] = ACTIONS(2224),
    [anon_sym_unsigned] = ACTIONS(2224),
    [anon_sym_long] = ACTIONS(2224),
    [anon_sym_short] = ACTIONS(2224),
    [sym_primitive_type] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2222),
    [anon_sym_PLUS_PLUS] = ACTIONS(2222),
    [anon_sym_sizeof] = ACTIONS(2224),
    [sym_number_literal] = ACTIONS(2222),
    [anon_sym_SQUOTE] = ACTIONS(2222),
    [anon_sym_DQUOTE] = ACTIONS(2222),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_identifier] = ACTIONS(2224),
    [sym_comment] = ACTIONS(41),
  },
  [1045] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3105),
    [sym_comment] = ACTIONS(41),
  },
  [1046] = {
    [sym_preproc_include] = STATE(871),
    [sym_preproc_def] = STATE(871),
    [sym_preproc_function_def] = STATE(871),
    [sym_preproc_call] = STATE(871),
    [sym_preproc_if_in_compound_statement] = STATE(871),
    [sym_preproc_ifdef_in_compound_statement] = STATE(871),
    [sym_preproc_else_in_compound_statement] = STATE(1113),
    [sym_preproc_elif_in_compound_statement] = STATE(1113),
    [sym_declaration] = STATE(871),
    [sym_type_definition] = STATE(871),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(871),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(871),
    [sym_expression_statement] = STATE(871),
    [sym_if_statement] = STATE(871),
    [sym_switch_statement] = STATE(871),
    [sym_case_statement] = STATE(871),
    [sym_while_statement] = STATE(871),
    [sym_do_statement] = STATE(871),
    [sym_for_statement] = STATE(871),
    [sym_return_statement] = STATE(871),
    [sym_break_statement] = STATE(871),
    [sym_continue_statement] = STATE(871),
    [sym_goto_statement] = STATE(871),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(871),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(871),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3107),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [1047] = {
    [anon_sym_LPAREN] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2296),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2298),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2298),
    [sym_preproc_directive] = ACTIONS(2298),
    [anon_sym_typedef] = ACTIONS(2298),
    [anon_sym_extern] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_auto] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2298),
    [anon_sym_inline] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym_unsigned] = ACTIONS(2298),
    [anon_sym_long] = ACTIONS(2298),
    [anon_sym_short] = ACTIONS(2298),
    [sym_primitive_type] = ACTIONS(2298),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_struct] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2298),
    [anon_sym_if] = ACTIONS(2298),
    [anon_sym_switch] = ACTIONS(2298),
    [anon_sym_case] = ACTIONS(2298),
    [anon_sym_default] = ACTIONS(2298),
    [anon_sym_while] = ACTIONS(2298),
    [anon_sym_do] = ACTIONS(2298),
    [anon_sym_for] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2298),
    [anon_sym_break] = ACTIONS(2298),
    [anon_sym_continue] = ACTIONS(2298),
    [anon_sym_goto] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2296),
    [anon_sym_PLUS_PLUS] = ACTIONS(2296),
    [anon_sym_sizeof] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2296),
    [anon_sym_SQUOTE] = ACTIONS(2296),
    [anon_sym_DQUOTE] = ACTIONS(2296),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [sym_null] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2298),
    [sym_comment] = ACTIONS(41),
  },
  [1048] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3109),
    [sym_comment] = ACTIONS(41),
  },
  [1049] = {
    [sym_preproc_include] = STATE(871),
    [sym_preproc_def] = STATE(871),
    [sym_preproc_function_def] = STATE(871),
    [sym_preproc_call] = STATE(871),
    [sym_preproc_if_in_compound_statement] = STATE(871),
    [sym_preproc_ifdef_in_compound_statement] = STATE(871),
    [sym_preproc_else_in_compound_statement] = STATE(1115),
    [sym_preproc_elif_in_compound_statement] = STATE(1115),
    [sym_declaration] = STATE(871),
    [sym_type_definition] = STATE(871),
    [sym__declaration_specifiers] = STATE(647),
    [sym_compound_statement] = STATE(871),
    [sym_storage_class_specifier] = STATE(21),
    [sym_type_qualifier] = STATE(21),
    [sym__type_specifier] = STATE(19),
    [sym_sized_type_specifier] = STATE(19),
    [sym_enum_specifier] = STATE(19),
    [sym_struct_specifier] = STATE(19),
    [sym_union_specifier] = STATE(19),
    [sym_labeled_statement] = STATE(871),
    [sym_expression_statement] = STATE(871),
    [sym_if_statement] = STATE(871),
    [sym_switch_statement] = STATE(871),
    [sym_case_statement] = STATE(871),
    [sym_while_statement] = STATE(871),
    [sym_do_statement] = STATE(871),
    [sym_for_statement] = STATE(871),
    [sym_return_statement] = STATE(871),
    [sym_break_statement] = STATE(871),
    [sym_continue_statement] = STATE(871),
    [sym_goto_statement] = STATE(871),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym__empty_declaration] = STATE(871),
    [sym_macro_type_specifier] = STATE(19),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(871),
    [aux_sym__declaration_specifiers_repeat1] = STATE(21),
    [aux_sym_sized_type_specifier_repeat1] = STATE(22),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1510),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3111),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1514),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1516),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(161),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(29),
    [anon_sym_long] = ACTIONS(29),
    [anon_sym_short] = ACTIONS(29),
    [sym_primitive_type] = ACTIONS(31),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [sym_comment] = ACTIONS(41),
  },
  [1050] = {
    [sym_parenthesized_expression] = STATE(1116),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [1051] = {
    [sym_parenthesized_expression] = STATE(1117),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [1052] = {
    [sym__expression] = STATE(1118),
    [sym_conditional_expression] = STATE(1118),
    [sym_assignment_expression] = STATE(1118),
    [sym_pointer_expression] = STATE(1118),
    [sym_logical_expression] = STATE(1118),
    [sym_bitwise_expression] = STATE(1118),
    [sym_equality_expression] = STATE(1118),
    [sym_relational_expression] = STATE(1118),
    [sym_shift_expression] = STATE(1118),
    [sym_math_expression] = STATE(1118),
    [sym_cast_expression] = STATE(1118),
    [sym_sizeof_expression] = STATE(1118),
    [sym_subscript_expression] = STATE(1118),
    [sym_call_expression] = STATE(1118),
    [sym_field_expression] = STATE(1118),
    [sym_compound_literal_expression] = STATE(1118),
    [sym_parenthesized_expression] = STATE(1118),
    [sym_char_literal] = STATE(1118),
    [sym_concatenated_string] = STATE(1118),
    [sym_string_literal] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3115),
    [sym_false] = ACTIONS(3115),
    [sym_null] = ACTIONS(3115),
    [sym_identifier] = ACTIONS(3115),
    [sym_comment] = ACTIONS(41),
  },
  [1053] = {
    [anon_sym_COLON] = ACTIONS(3117),
    [sym_comment] = ACTIONS(41),
  },
  [1054] = {
    [sym_parenthesized_expression] = STATE(1120),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(41),
  },
  [1055] = {
    [anon_sym_LPAREN] = ACTIONS(3119),
    [sym_comment] = ACTIONS(41),
  },
  [1056] = {
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(3121),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(41),
  },
  [1057] = {
    [anon_sym_LPAREN] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2316),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2318),
    [sym_preproc_directive] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_auto] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(3123),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2318),
    [sym_comment] = ACTIONS(41),
  },
  [1058] = {
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(41),
  },
  [1059] = {
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2322),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2324),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2324),
    [sym_preproc_directive] = ACTIONS(2324),
    [anon_sym_typedef] = ACTIONS(2324),
    [anon_sym_extern] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_auto] = ACTIONS(2324),
    [anon_sym_register] = ACTIONS(2324),
    [anon_sym_inline] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_restrict] = ACTIONS(2324),
    [anon_sym_volatile] = ACTIONS(2324),
    [anon_sym__Atomic] = ACTIONS(2324),
    [anon_sym_unsigned] = ACTIONS(2324),
    [anon_sym_long] = ACTIONS(2324),
    [anon_sym_short] = ACTIONS(2324),
    [sym_primitive_type] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
    [anon_sym_struct] = ACTIONS(2324),
    [anon_sym_union] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_else] = ACTIONS(2324),
    [anon_sym_switch] = ACTIONS(2324),
    [anon_sym_case] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_do] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_goto] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_TILDE] = ACTIONS(2322),
    [anon_sym_PLUS] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2324),
    [anon_sym_DASH_DASH] = ACTIONS(2322),
    [anon_sym_PLUS_PLUS] = ACTIONS(2322),
    [anon_sym_sizeof] = ACTIONS(2324),
    [sym_number_literal] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2322),
    [anon_sym_DQUOTE] = ACTIONS(2322),
    [sym_true] = ACTIONS(2324),
    [sym_false] = ACTIONS(2324),
    [sym_null] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2324),
    [sym_comment] = ACTIONS(41),
  },
  [1060] = {
    [sym_declaration] = STATE(1124),
    [sym_type_definition] = STATE(1124),
    [sym__declaration_specifiers] = STATE(1063),
    [sym_compound_statement] = STATE(1124),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(1124),
    [sym_expression_statement] = STATE(1124),
    [sym_if_statement] = STATE(1124),
    [sym_switch_statement] = STATE(1124),
    [sym_case_statement] = STATE(1124),
    [sym_while_statement] = STATE(1124),
    [sym_do_statement] = STATE(1124),
    [sym_for_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_goto_statement] = STATE(1124),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2908),
    [sym_comment] = ACTIONS(41),
  },
  [1061] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [1062] = {
    [anon_sym_LPAREN] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2372),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2374),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2374),
    [sym_preproc_directive] = ACTIONS(2374),
    [anon_sym_typedef] = ACTIONS(2374),
    [anon_sym_extern] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_auto] = ACTIONS(2374),
    [anon_sym_register] = ACTIONS(2374),
    [anon_sym_inline] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_restrict] = ACTIONS(2374),
    [anon_sym_volatile] = ACTIONS(2374),
    [anon_sym__Atomic] = ACTIONS(2374),
    [anon_sym_unsigned] = ACTIONS(2374),
    [anon_sym_long] = ACTIONS(2374),
    [anon_sym_short] = ACTIONS(2374),
    [sym_primitive_type] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
    [anon_sym_struct] = ACTIONS(2374),
    [anon_sym_union] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2374),
    [anon_sym_switch] = ACTIONS(2374),
    [anon_sym_case] = ACTIONS(2374),
    [anon_sym_default] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_do] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_goto] = ACTIONS(2374),
    [anon_sym_AMP] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2374),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [sym_null] = ACTIONS(2374),
    [sym_identifier] = ACTIONS(2374),
    [sym_comment] = ACTIONS(41),
  },
  [1063] = {
    [sym__declarator] = STATE(974),
    [sym_pointer_declarator] = STATE(974),
    [sym_function_declarator] = STATE(974),
    [sym_array_declarator] = STATE(974),
    [sym_init_declarator] = STATE(305),
    [anon_sym_LPAREN] = ACTIONS(94),
    [anon_sym_STAR] = ACTIONS(593),
    [sym_identifier] = ACTIONS(2611),
    [sym_comment] = ACTIONS(41),
  },
  [1064] = {
    [anon_sym_LPAREN] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2376),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2378),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_auto] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2376),
    [anon_sym_sizeof] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [sym_null] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(2378),
    [sym_comment] = ACTIONS(41),
  },
  [1065] = {
    [sym_parenthesized_expression] = STATE(1126),
    [anon_sym_LPAREN] = ACTIONS(3125),
    [sym_comment] = ACTIONS(41),
  },
  [1066] = {
    [sym__expression] = STATE(1128),
    [sym_conditional_expression] = STATE(1128),
    [sym_assignment_expression] = STATE(1128),
    [sym_pointer_expression] = STATE(1128),
    [sym_logical_expression] = STATE(1128),
    [sym_bitwise_expression] = STATE(1128),
    [sym_equality_expression] = STATE(1128),
    [sym_relational_expression] = STATE(1128),
    [sym_shift_expression] = STATE(1128),
    [sym_math_expression] = STATE(1128),
    [sym_cast_expression] = STATE(1128),
    [sym_sizeof_expression] = STATE(1128),
    [sym_subscript_expression] = STATE(1128),
    [sym_call_expression] = STATE(1128),
    [sym_field_expression] = STATE(1128),
    [sym_compound_literal_expression] = STATE(1128),
    [sym_parenthesized_expression] = STATE(1128),
    [sym_char_literal] = STATE(1128),
    [sym_concatenated_string] = STATE(1128),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3127),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3129),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3131),
    [sym_false] = ACTIONS(3131),
    [sym_null] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_comment] = ACTIONS(41),
  },
  [1067] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1068] = {
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2414),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2416),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2416),
    [sym_preproc_directive] = ACTIONS(2416),
    [anon_sym_typedef] = ACTIONS(2416),
    [anon_sym_extern] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_auto] = ACTIONS(2416),
    [anon_sym_register] = ACTIONS(2416),
    [anon_sym_inline] = ACTIONS(2416),
    [anon_sym_const] = ACTIONS(2416),
    [anon_sym_restrict] = ACTIONS(2416),
    [anon_sym_volatile] = ACTIONS(2416),
    [anon_sym__Atomic] = ACTIONS(2416),
    [anon_sym_unsigned] = ACTIONS(2416),
    [anon_sym_long] = ACTIONS(2416),
    [anon_sym_short] = ACTIONS(2416),
    [sym_primitive_type] = ACTIONS(2416),
    [anon_sym_enum] = ACTIONS(2416),
    [anon_sym_struct] = ACTIONS(2416),
    [anon_sym_union] = ACTIONS(2416),
    [anon_sym_if] = ACTIONS(2416),
    [anon_sym_else] = ACTIONS(2416),
    [anon_sym_switch] = ACTIONS(2416),
    [anon_sym_case] = ACTIONS(2416),
    [anon_sym_default] = ACTIONS(2416),
    [anon_sym_while] = ACTIONS(2416),
    [anon_sym_do] = ACTIONS(2416),
    [anon_sym_for] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2416),
    [anon_sym_break] = ACTIONS(2416),
    [anon_sym_continue] = ACTIONS(2416),
    [anon_sym_goto] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_TILDE] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2414),
    [anon_sym_sizeof] = ACTIONS(2416),
    [sym_number_literal] = ACTIONS(2414),
    [anon_sym_SQUOTE] = ACTIONS(2414),
    [anon_sym_DQUOTE] = ACTIONS(2414),
    [sym_true] = ACTIONS(2416),
    [sym_false] = ACTIONS(2416),
    [sym_null] = ACTIONS(2416),
    [sym_identifier] = ACTIONS(2416),
    [sym_comment] = ACTIONS(41),
  },
  [1069] = {
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2418),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2420),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2420),
    [sym_preproc_directive] = ACTIONS(2420),
    [anon_sym_typedef] = ACTIONS(2420),
    [anon_sym_extern] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2420),
    [anon_sym_auto] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2420),
    [anon_sym_inline] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2420),
    [anon_sym_restrict] = ACTIONS(2420),
    [anon_sym_volatile] = ACTIONS(2420),
    [anon_sym__Atomic] = ACTIONS(2420),
    [anon_sym_unsigned] = ACTIONS(2420),
    [anon_sym_long] = ACTIONS(2420),
    [anon_sym_short] = ACTIONS(2420),
    [sym_primitive_type] = ACTIONS(2420),
    [anon_sym_enum] = ACTIONS(2420),
    [anon_sym_struct] = ACTIONS(2420),
    [anon_sym_union] = ACTIONS(2420),
    [anon_sym_if] = ACTIONS(2420),
    [anon_sym_else] = ACTIONS(2420),
    [anon_sym_switch] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(2420),
    [anon_sym_default] = ACTIONS(2420),
    [anon_sym_while] = ACTIONS(2420),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2420),
    [anon_sym_break] = ACTIONS(2420),
    [anon_sym_continue] = ACTIONS(2420),
    [anon_sym_goto] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2418),
    [anon_sym_sizeof] = ACTIONS(2420),
    [sym_number_literal] = ACTIONS(2418),
    [anon_sym_SQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [sym_true] = ACTIONS(2420),
    [sym_false] = ACTIONS(2420),
    [sym_null] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2420),
    [sym_comment] = ACTIONS(41),
  },
  [1070] = {
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2430),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2430),
    [sym_preproc_directive] = ACTIONS(2430),
    [anon_sym_typedef] = ACTIONS(2430),
    [anon_sym_extern] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_auto] = ACTIONS(2430),
    [anon_sym_register] = ACTIONS(2430),
    [anon_sym_inline] = ACTIONS(2430),
    [anon_sym_const] = ACTIONS(2430),
    [anon_sym_restrict] = ACTIONS(2430),
    [anon_sym_volatile] = ACTIONS(2430),
    [anon_sym__Atomic] = ACTIONS(2430),
    [anon_sym_unsigned] = ACTIONS(2430),
    [anon_sym_long] = ACTIONS(2430),
    [anon_sym_short] = ACTIONS(2430),
    [sym_primitive_type] = ACTIONS(2430),
    [anon_sym_enum] = ACTIONS(2430),
    [anon_sym_struct] = ACTIONS(2430),
    [anon_sym_union] = ACTIONS(2430),
    [anon_sym_if] = ACTIONS(2430),
    [anon_sym_else] = ACTIONS(2430),
    [anon_sym_switch] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(2430),
    [anon_sym_default] = ACTIONS(2430),
    [anon_sym_while] = ACTIONS(2430),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_for] = ACTIONS(2430),
    [anon_sym_return] = ACTIONS(2430),
    [anon_sym_break] = ACTIONS(2430),
    [anon_sym_continue] = ACTIONS(2430),
    [anon_sym_goto] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_sizeof] = ACTIONS(2430),
    [sym_number_literal] = ACTIONS(2428),
    [anon_sym_SQUOTE] = ACTIONS(2428),
    [anon_sym_DQUOTE] = ACTIONS(2428),
    [sym_true] = ACTIONS(2430),
    [sym_false] = ACTIONS(2430),
    [sym_null] = ACTIONS(2430),
    [sym_identifier] = ACTIONS(2430),
    [sym_comment] = ACTIONS(41),
  },
  [1071] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3135),
    [sym_comment] = ACTIONS(41),
  },
  [1072] = {
    [sym_compound_statement] = STATE(1130),
    [sym_labeled_statement] = STATE(1130),
    [sym_expression_statement] = STATE(1130),
    [sym_if_statement] = STATE(1130),
    [sym_switch_statement] = STATE(1130),
    [sym_case_statement] = STATE(1130),
    [sym_while_statement] = STATE(1130),
    [sym_do_statement] = STATE(1130),
    [sym_for_statement] = STATE(1130),
    [sym_return_statement] = STATE(1130),
    [sym_break_statement] = STATE(1130),
    [sym_continue_statement] = STATE(1130),
    [sym_goto_statement] = STATE(1130),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [1073] = {
    [sym_compound_statement] = STATE(988),
    [sym_labeled_statement] = STATE(988),
    [sym_expression_statement] = STATE(988),
    [sym_if_statement] = STATE(988),
    [sym_switch_statement] = STATE(988),
    [sym_case_statement] = STATE(988),
    [sym_while_statement] = STATE(988),
    [sym_do_statement] = STATE(988),
    [sym_for_statement] = STATE(988),
    [sym_return_statement] = STATE(988),
    [sym_break_statement] = STATE(988),
    [sym_continue_statement] = STATE(988),
    [sym_goto_statement] = STATE(988),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [1074] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(3137),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1075] = {
    [sym_declaration] = STATE(991),
    [sym_type_definition] = STATE(991),
    [sym__declaration_specifiers] = STATE(992),
    [sym_compound_statement] = STATE(991),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(991),
    [sym_expression_statement] = STATE(991),
    [sym_if_statement] = STATE(991),
    [sym_switch_statement] = STATE(991),
    [sym_case_statement] = STATE(991),
    [sym_while_statement] = STATE(991),
    [sym_do_statement] = STATE(991),
    [sym_for_statement] = STATE(991),
    [sym_return_statement] = STATE(991),
    [sym_break_statement] = STATE(991),
    [sym_continue_statement] = STATE(991),
    [sym_goto_statement] = STATE(991),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(3139),
    [sym_comment] = ACTIONS(41),
  },
  [1076] = {
    [sym_compound_statement] = STATE(993),
    [sym_labeled_statement] = STATE(993),
    [sym_expression_statement] = STATE(993),
    [sym_if_statement] = STATE(993),
    [sym_switch_statement] = STATE(993),
    [sym_case_statement] = STATE(993),
    [sym_while_statement] = STATE(993),
    [sym_do_statement] = STATE(993),
    [sym_for_statement] = STATE(993),
    [sym_return_statement] = STATE(993),
    [sym_break_statement] = STATE(993),
    [sym_continue_statement] = STATE(993),
    [sym_goto_statement] = STATE(993),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [1077] = {
    [sym_declaration] = STATE(1133),
    [sym__declaration_specifiers] = STATE(685),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym__expression] = STATE(1134),
    [sym_conditional_expression] = STATE(1134),
    [sym_assignment_expression] = STATE(1134),
    [sym_pointer_expression] = STATE(1134),
    [sym_logical_expression] = STATE(1134),
    [sym_bitwise_expression] = STATE(1134),
    [sym_equality_expression] = STATE(1134),
    [sym_relational_expression] = STATE(1134),
    [sym_shift_expression] = STATE(1134),
    [sym_math_expression] = STATE(1134),
    [sym_cast_expression] = STATE(1134),
    [sym_sizeof_expression] = STATE(1134),
    [sym_subscript_expression] = STATE(1134),
    [sym_call_expression] = STATE(1134),
    [sym_field_expression] = STATE(1134),
    [sym_compound_literal_expression] = STATE(1134),
    [sym_parenthesized_expression] = STATE(1134),
    [sym_char_literal] = STATE(1134),
    [sym_concatenated_string] = STATE(1134),
    [sym_string_literal] = STATE(363),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3143),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3145),
    [sym_false] = ACTIONS(3145),
    [sym_null] = ACTIONS(3145),
    [sym_identifier] = ACTIONS(1630),
    [sym_comment] = ACTIONS(41),
  },
  [1078] = {
    [sym_compound_statement] = STATE(999),
    [sym_labeled_statement] = STATE(999),
    [sym_expression_statement] = STATE(999),
    [sym_if_statement] = STATE(999),
    [sym_switch_statement] = STATE(999),
    [sym_case_statement] = STATE(999),
    [sym_while_statement] = STATE(999),
    [sym_do_statement] = STATE(999),
    [sym_for_statement] = STATE(999),
    [sym_return_statement] = STATE(999),
    [sym_break_statement] = STATE(999),
    [sym_continue_statement] = STATE(999),
    [sym_goto_statement] = STATE(999),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [1079] = {
    [sym_compound_statement] = STATE(1135),
    [sym_labeled_statement] = STATE(1135),
    [sym_expression_statement] = STATE(1135),
    [sym_if_statement] = STATE(1135),
    [sym_switch_statement] = STATE(1135),
    [sym_case_statement] = STATE(1135),
    [sym_while_statement] = STATE(1135),
    [sym_do_statement] = STATE(1135),
    [sym_for_statement] = STATE(1135),
    [sym_return_statement] = STATE(1135),
    [sym_break_statement] = STATE(1135),
    [sym_continue_statement] = STATE(1135),
    [sym_goto_statement] = STATE(1135),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2633),
    [sym_comment] = ACTIONS(41),
  },
  [1080] = {
    [anon_sym_LPAREN] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2743),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2745),
    [sym_preproc_directive] = ACTIONS(2745),
    [anon_sym_typedef] = ACTIONS(2745),
    [anon_sym_extern] = ACTIONS(2745),
    [anon_sym_STAR] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2745),
    [anon_sym_auto] = ACTIONS(2745),
    [anon_sym_register] = ACTIONS(2745),
    [anon_sym_inline] = ACTIONS(2745),
    [anon_sym_const] = ACTIONS(2745),
    [anon_sym_restrict] = ACTIONS(2745),
    [anon_sym_volatile] = ACTIONS(2745),
    [anon_sym__Atomic] = ACTIONS(2745),
    [anon_sym_unsigned] = ACTIONS(2745),
    [anon_sym_long] = ACTIONS(2745),
    [anon_sym_short] = ACTIONS(2745),
    [sym_primitive_type] = ACTIONS(2745),
    [anon_sym_enum] = ACTIONS(2745),
    [anon_sym_struct] = ACTIONS(2745),
    [anon_sym_union] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(2745),
    [anon_sym_else] = ACTIONS(2745),
    [anon_sym_switch] = ACTIONS(2745),
    [anon_sym_case] = ACTIONS(2745),
    [anon_sym_default] = ACTIONS(2745),
    [anon_sym_while] = ACTIONS(2745),
    [anon_sym_do] = ACTIONS(2745),
    [anon_sym_for] = ACTIONS(2745),
    [anon_sym_return] = ACTIONS(2745),
    [anon_sym_break] = ACTIONS(2745),
    [anon_sym_continue] = ACTIONS(2745),
    [anon_sym_goto] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_BANG] = ACTIONS(2743),
    [anon_sym_TILDE] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2745),
    [anon_sym_DASH_DASH] = ACTIONS(2743),
    [anon_sym_PLUS_PLUS] = ACTIONS(2743),
    [anon_sym_sizeof] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2743),
    [anon_sym_SQUOTE] = ACTIONS(2743),
    [anon_sym_DQUOTE] = ACTIONS(2743),
    [sym_true] = ACTIONS(2745),
    [sym_false] = ACTIONS(2745),
    [sym_null] = ACTIONS(2745),
    [sym_identifier] = ACTIONS(2745),
    [sym_comment] = ACTIONS(41),
  },
  [1081] = {
    [sym__expression] = STATE(1136),
    [sym_comma_expression] = STATE(1137),
    [sym_conditional_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1136),
    [sym_pointer_expression] = STATE(1136),
    [sym_logical_expression] = STATE(1136),
    [sym_bitwise_expression] = STATE(1136),
    [sym_equality_expression] = STATE(1136),
    [sym_relational_expression] = STATE(1136),
    [sym_shift_expression] = STATE(1136),
    [sym_math_expression] = STATE(1136),
    [sym_cast_expression] = STATE(1136),
    [sym_sizeof_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_call_expression] = STATE(1136),
    [sym_field_expression] = STATE(1136),
    [sym_compound_literal_expression] = STATE(1136),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_char_literal] = STATE(1136),
    [sym_concatenated_string] = STATE(1136),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3147),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3149),
    [sym_false] = ACTIONS(3149),
    [sym_null] = ACTIONS(3149),
    [sym_identifier] = ACTIONS(3149),
    [sym_comment] = ACTIONS(41),
  },
  [1082] = {
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2773),
    [sym_preproc_directive] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_auto] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [sym_primitive_type] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_switch] = ACTIONS(2773),
    [anon_sym_case] = ACTIONS(2773),
    [anon_sym_default] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_goto] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_TILDE] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_sizeof] = ACTIONS(2773),
    [sym_number_literal] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [anon_sym_DQUOTE] = ACTIONS(2771),
    [sym_true] = ACTIONS(2773),
    [sym_false] = ACTIONS(2773),
    [sym_null] = ACTIONS(2773),
    [sym_identifier] = ACTIONS(2773),
    [sym_comment] = ACTIONS(41),
  },
  [1083] = {
    [sym__expression] = STATE(1139),
    [sym_conditional_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_pointer_expression] = STATE(1139),
    [sym_logical_expression] = STATE(1139),
    [sym_bitwise_expression] = STATE(1139),
    [sym_equality_expression] = STATE(1139),
    [sym_relational_expression] = STATE(1139),
    [sym_shift_expression] = STATE(1139),
    [sym_math_expression] = STATE(1139),
    [sym_cast_expression] = STATE(1139),
    [sym_sizeof_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_field_expression] = STATE(1139),
    [sym_compound_literal_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_char_literal] = STATE(1139),
    [sym_concatenated_string] = STATE(1139),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3151),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3153),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3155),
    [sym_false] = ACTIONS(3155),
    [sym_null] = ACTIONS(3155),
    [sym_identifier] = ACTIONS(3155),
    [sym_comment] = ACTIONS(41),
  },
  [1084] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1085] = {
    [sym__expression] = STATE(1141),
    [sym_conditional_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1141),
    [sym_pointer_expression] = STATE(1141),
    [sym_logical_expression] = STATE(1141),
    [sym_bitwise_expression] = STATE(1141),
    [sym_equality_expression] = STATE(1141),
    [sym_relational_expression] = STATE(1141),
    [sym_shift_expression] = STATE(1141),
    [sym_math_expression] = STATE(1141),
    [sym_cast_expression] = STATE(1141),
    [sym_sizeof_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_call_expression] = STATE(1141),
    [sym_field_expression] = STATE(1141),
    [sym_compound_literal_expression] = STATE(1141),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_char_literal] = STATE(1141),
    [sym_concatenated_string] = STATE(1141),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3159),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3161),
    [sym_false] = ACTIONS(3161),
    [sym_null] = ACTIONS(3161),
    [sym_identifier] = ACTIONS(3161),
    [sym_comment] = ACTIONS(41),
  },
  [1086] = {
    [sym_compound_statement] = STATE(1007),
    [sym_labeled_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_if_statement] = STATE(1007),
    [sym_switch_statement] = STATE(1007),
    [sym_case_statement] = STATE(1007),
    [sym_while_statement] = STATE(1007),
    [sym_do_statement] = STATE(1007),
    [sym_for_statement] = STATE(1007),
    [sym_return_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_goto_statement] = STATE(1007),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [1087] = {
    [sym__expression] = STATE(1143),
    [sym_conditional_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1143),
    [sym_pointer_expression] = STATE(1143),
    [sym_logical_expression] = STATE(1143),
    [sym_bitwise_expression] = STATE(1143),
    [sym_equality_expression] = STATE(1143),
    [sym_relational_expression] = STATE(1143),
    [sym_shift_expression] = STATE(1143),
    [sym_math_expression] = STATE(1143),
    [sym_cast_expression] = STATE(1143),
    [sym_sizeof_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_call_expression] = STATE(1143),
    [sym_field_expression] = STATE(1143),
    [sym_compound_literal_expression] = STATE(1143),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_char_literal] = STATE(1143),
    [sym_concatenated_string] = STATE(1143),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3163),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_identifier] = ACTIONS(3167),
    [sym_comment] = ACTIONS(41),
  },
  [1088] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1089] = {
    [sym__expression] = STATE(1145),
    [sym_conditional_expression] = STATE(1145),
    [sym_assignment_expression] = STATE(1145),
    [sym_pointer_expression] = STATE(1145),
    [sym_logical_expression] = STATE(1145),
    [sym_bitwise_expression] = STATE(1145),
    [sym_equality_expression] = STATE(1145),
    [sym_relational_expression] = STATE(1145),
    [sym_shift_expression] = STATE(1145),
    [sym_math_expression] = STATE(1145),
    [sym_cast_expression] = STATE(1145),
    [sym_sizeof_expression] = STATE(1145),
    [sym_subscript_expression] = STATE(1145),
    [sym_call_expression] = STATE(1145),
    [sym_field_expression] = STATE(1145),
    [sym_compound_literal_expression] = STATE(1145),
    [sym_parenthesized_expression] = STATE(1145),
    [sym_char_literal] = STATE(1145),
    [sym_concatenated_string] = STATE(1145),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3171),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3173),
    [sym_false] = ACTIONS(3173),
    [sym_null] = ACTIONS(3173),
    [sym_identifier] = ACTIONS(3173),
    [sym_comment] = ACTIONS(41),
  },
  [1090] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1091] = {
    [anon_sym_else] = ACTIONS(3175),
    [anon_sym_while] = ACTIONS(2316),
    [sym_comment] = ACTIONS(41),
  },
  [1092] = {
    [sym_declaration] = STATE(886),
    [sym_type_definition] = STATE(886),
    [sym__declaration_specifiers] = STATE(685),
    [sym_compound_statement] = STATE(886),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(886),
    [sym_expression_statement] = STATE(886),
    [sym_if_statement] = STATE(886),
    [sym_switch_statement] = STATE(886),
    [sym_case_statement] = STATE(886),
    [sym_while_statement] = STATE(886),
    [sym_do_statement] = STATE(886),
    [sym_for_statement] = STATE(886),
    [sym_return_statement] = STATE(886),
    [sym_break_statement] = STATE(886),
    [sym_continue_statement] = STATE(886),
    [sym_goto_statement] = STATE(886),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_typedef] = ACTIONS(21),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(3046),
    [sym_comment] = ACTIONS(41),
  },
  [1093] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(2757),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [1094] = {
    [sym__expression] = STATE(1148),
    [sym_conditional_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1148),
    [sym_pointer_expression] = STATE(1148),
    [sym_logical_expression] = STATE(1148),
    [sym_bitwise_expression] = STATE(1148),
    [sym_equality_expression] = STATE(1148),
    [sym_relational_expression] = STATE(1148),
    [sym_shift_expression] = STATE(1148),
    [sym_math_expression] = STATE(1148),
    [sym_cast_expression] = STATE(1148),
    [sym_sizeof_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_call_expression] = STATE(1148),
    [sym_field_expression] = STATE(1148),
    [sym_compound_literal_expression] = STATE(1148),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_char_literal] = STATE(1148),
    [sym_concatenated_string] = STATE(1148),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3177),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3179),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3181),
    [sym_false] = ACTIONS(3181),
    [sym_null] = ACTIONS(3181),
    [sym_identifier] = ACTIONS(3181),
    [sym_comment] = ACTIONS(41),
  },
  [1095] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3183),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1096] = {
    [sym_compound_statement] = STATE(1100),
    [sym_labeled_statement] = STATE(1100),
    [sym_expression_statement] = STATE(1100),
    [sym_if_statement] = STATE(1100),
    [sym_switch_statement] = STATE(1100),
    [sym_case_statement] = STATE(1100),
    [sym_while_statement] = STATE(1100),
    [sym_do_statement] = STATE(1100),
    [sym_for_statement] = STATE(1100),
    [sym_return_statement] = STATE(1100),
    [sym_break_statement] = STATE(1100),
    [sym_continue_statement] = STATE(1100),
    [sym_goto_statement] = STATE(1100),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [1097] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1151),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3185),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1098] = {
    [sym__expression] = STATE(1152),
    [sym_conditional_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1152),
    [sym_pointer_expression] = STATE(1152),
    [sym_logical_expression] = STATE(1152),
    [sym_bitwise_expression] = STATE(1152),
    [sym_equality_expression] = STATE(1152),
    [sym_relational_expression] = STATE(1152),
    [sym_shift_expression] = STATE(1152),
    [sym_math_expression] = STATE(1152),
    [sym_cast_expression] = STATE(1152),
    [sym_sizeof_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_call_expression] = STATE(1152),
    [sym_field_expression] = STATE(1152),
    [sym_compound_literal_expression] = STATE(1152),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_char_literal] = STATE(1152),
    [sym_concatenated_string] = STATE(1152),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3185),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_null] = ACTIONS(3189),
    [sym_identifier] = ACTIONS(3189),
    [sym_comment] = ACTIONS(41),
  },
  [1099] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3191),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1100] = {
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_RBRACE] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3193),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3195),
    [sym_preproc_directive] = ACTIONS(3195),
    [anon_sym_typedef] = ACTIONS(3195),
    [anon_sym_extern] = ACTIONS(3195),
    [anon_sym_STAR] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3195),
    [anon_sym_auto] = ACTIONS(3195),
    [anon_sym_register] = ACTIONS(3195),
    [anon_sym_inline] = ACTIONS(3195),
    [anon_sym_const] = ACTIONS(3195),
    [anon_sym_restrict] = ACTIONS(3195),
    [anon_sym_volatile] = ACTIONS(3195),
    [anon_sym__Atomic] = ACTIONS(3195),
    [anon_sym_unsigned] = ACTIONS(3195),
    [anon_sym_long] = ACTIONS(3195),
    [anon_sym_short] = ACTIONS(3195),
    [sym_primitive_type] = ACTIONS(3195),
    [anon_sym_enum] = ACTIONS(3195),
    [anon_sym_struct] = ACTIONS(3195),
    [anon_sym_union] = ACTIONS(3195),
    [anon_sym_if] = ACTIONS(3195),
    [anon_sym_else] = ACTIONS(3195),
    [anon_sym_switch] = ACTIONS(3195),
    [anon_sym_case] = ACTIONS(3195),
    [anon_sym_default] = ACTIONS(3195),
    [anon_sym_while] = ACTIONS(3195),
    [anon_sym_do] = ACTIONS(3195),
    [anon_sym_for] = ACTIONS(3195),
    [anon_sym_return] = ACTIONS(3195),
    [anon_sym_break] = ACTIONS(3195),
    [anon_sym_continue] = ACTIONS(3195),
    [anon_sym_goto] = ACTIONS(3195),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_DASH_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_PLUS] = ACTIONS(3193),
    [anon_sym_sizeof] = ACTIONS(3195),
    [sym_number_literal] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [sym_true] = ACTIONS(3195),
    [sym_false] = ACTIONS(3195),
    [sym_null] = ACTIONS(3195),
    [sym_identifier] = ACTIONS(3195),
    [sym_comment] = ACTIONS(41),
  },
  [1101] = {
    [sym_compound_statement] = STATE(1154),
    [sym_labeled_statement] = STATE(1154),
    [sym_expression_statement] = STATE(1154),
    [sym_if_statement] = STATE(1154),
    [sym_switch_statement] = STATE(1154),
    [sym_case_statement] = STATE(1154),
    [sym_while_statement] = STATE(1154),
    [sym_do_statement] = STATE(1154),
    [sym_for_statement] = STATE(1154),
    [sym_return_statement] = STATE(1154),
    [sym_break_statement] = STATE(1154),
    [sym_continue_statement] = STATE(1154),
    [sym_goto_statement] = STATE(1154),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1572),
    [sym_comment] = ACTIONS(41),
  },
  [1102] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3197),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1103] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1156),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3197),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1104] = {
    [sym__expression] = STATE(1157),
    [sym_conditional_expression] = STATE(1157),
    [sym_assignment_expression] = STATE(1157),
    [sym_pointer_expression] = STATE(1157),
    [sym_logical_expression] = STATE(1157),
    [sym_bitwise_expression] = STATE(1157),
    [sym_equality_expression] = STATE(1157),
    [sym_relational_expression] = STATE(1157),
    [sym_shift_expression] = STATE(1157),
    [sym_math_expression] = STATE(1157),
    [sym_cast_expression] = STATE(1157),
    [sym_sizeof_expression] = STATE(1157),
    [sym_subscript_expression] = STATE(1157),
    [sym_call_expression] = STATE(1157),
    [sym_field_expression] = STATE(1157),
    [sym_compound_literal_expression] = STATE(1157),
    [sym_parenthesized_expression] = STATE(1157),
    [sym_char_literal] = STATE(1157),
    [sym_concatenated_string] = STATE(1157),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3197),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3199),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3201),
    [sym_false] = ACTIONS(3201),
    [sym_null] = ACTIONS(3201),
    [sym_identifier] = ACTIONS(3201),
    [sym_comment] = ACTIONS(41),
  },
  [1105] = {
    [anon_sym_RBRACE] = ACTIONS(3203),
    [anon_sym_COMMA] = ACTIONS(3205),
    [sym_comment] = ACTIONS(41),
  },
  [1106] = {
    [anon_sym_RBRACE] = ACTIONS(3207),
    [sym_comment] = ACTIONS(41),
  },
  [1107] = {
    [anon_sym_SEMI] = ACTIONS(3209),
    [sym_comment] = ACTIONS(41),
  },
  [1108] = {
    [anon_sym_LBRACE] = ACTIONS(3211),
    [sym_comment] = ACTIONS(41),
  },
  [1109] = {
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_COMMA] = ACTIONS(3215),
    [sym_comment] = ACTIONS(41),
  },
  [1110] = {
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3014),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3016),
    [sym_preproc_directive] = ACTIONS(3016),
    [anon_sym_typedef] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_auto] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [sym_primitive_type] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_goto] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_sizeof] = ACTIONS(3016),
    [sym_number_literal] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [sym_null] = ACTIONS(3016),
    [sym_identifier] = ACTIONS(3016),
    [sym_comment] = ACTIONS(41),
  },
  [1111] = {
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_auto] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [sym_primitive_type] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_sizeof] = ACTIONS(3020),
    [sym_number_literal] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [sym_null] = ACTIONS(3020),
    [sym_identifier] = ACTIONS(3020),
    [sym_comment] = ACTIONS(41),
  },
  [1112] = {
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2651),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2653),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_auto] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [sym_primitive_type] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_sizeof] = ACTIONS(2653),
    [sym_number_literal] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [sym_null] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_comment] = ACTIONS(41),
  },
  [1113] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3217),
    [sym_comment] = ACTIONS(41),
  },
  [1114] = {
    [anon_sym_LPAREN] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2725),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_auto] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [sym_null] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2727),
    [sym_comment] = ACTIONS(41),
  },
  [1115] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3219),
    [sym_comment] = ACTIONS(41),
  },
  [1116] = {
    [sym_compound_statement] = STATE(1166),
    [sym_labeled_statement] = STATE(1166),
    [sym_expression_statement] = STATE(1166),
    [sym_if_statement] = STATE(1166),
    [sym_switch_statement] = STATE(1166),
    [sym_case_statement] = STATE(1166),
    [sym_while_statement] = STATE(1166),
    [sym_do_statement] = STATE(1166),
    [sym_for_statement] = STATE(1166),
    [sym_return_statement] = STATE(1166),
    [sym_break_statement] = STATE(1166),
    [sym_continue_statement] = STATE(1166),
    [sym_goto_statement] = STATE(1166),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
  [1117] = {
    [sym_compound_statement] = STATE(1059),
    [sym_labeled_statement] = STATE(1059),
    [sym_expression_statement] = STATE(1059),
    [sym_if_statement] = STATE(1059),
    [sym_switch_statement] = STATE(1059),
    [sym_case_statement] = STATE(1059),
    [sym_while_statement] = STATE(1059),
    [sym_do_statement] = STATE(1059),
    [sym_for_statement] = STATE(1059),
    [sym_return_statement] = STATE(1059),
    [sym_break_statement] = STATE(1059),
    [sym_continue_statement] = STATE(1059),
    [sym_goto_statement] = STATE(1059),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
  [1118] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(3221),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_STAR_EQ] = ACTIONS(1588),
    [anon_sym_SLASH_EQ] = ACTIONS(1588),
    [anon_sym_PERCENT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_GT_EQ] = ACTIONS(1588),
    [anon_sym_AMP_EQ] = ACTIONS(1588),
    [anon_sym_CARET_EQ] = ACTIONS(1588),
    [anon_sym_PIPE_EQ] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1604),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1119] = {
    [sym_declaration] = STATE(1062),
    [sym_type_definition] = STATE(1062),
    [sym__declaration_specifiers] = STATE(1063),
    [sym_compound_statement] = STATE(1062),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(1062),
    [sym_expression_statement] = STATE(1062),
    [sym_if_statement] = STATE(1062),
    [sym_switch_statement] = STATE(1062),
    [sym_case_statement] = STATE(1062),
    [sym_while_statement] = STATE(1062),
    [sym_do_statement] = STATE(1062),
    [sym_for_statement] = STATE(1062),
    [sym_return_statement] = STATE(1062),
    [sym_break_statement] = STATE(1062),
    [sym_continue_statement] = STATE(1062),
    [sym_goto_statement] = STATE(1062),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(3223),
    [sym_comment] = ACTIONS(41),
  },
  [1120] = {
    [sym_compound_statement] = STATE(1064),
    [sym_labeled_statement] = STATE(1064),
    [sym_expression_statement] = STATE(1064),
    [sym_if_statement] = STATE(1064),
    [sym_switch_statement] = STATE(1064),
    [sym_case_statement] = STATE(1064),
    [sym_while_statement] = STATE(1064),
    [sym_do_statement] = STATE(1064),
    [sym_for_statement] = STATE(1064),
    [sym_return_statement] = STATE(1064),
    [sym_break_statement] = STATE(1064),
    [sym_continue_statement] = STATE(1064),
    [sym_goto_statement] = STATE(1064),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
  [1121] = {
    [sym_declaration] = STATE(1169),
    [sym__declaration_specifiers] = STATE(685),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym__expression] = STATE(1170),
    [sym_conditional_expression] = STATE(1170),
    [sym_assignment_expression] = STATE(1170),
    [sym_pointer_expression] = STATE(1170),
    [sym_logical_expression] = STATE(1170),
    [sym_bitwise_expression] = STATE(1170),
    [sym_equality_expression] = STATE(1170),
    [sym_relational_expression] = STATE(1170),
    [sym_shift_expression] = STATE(1170),
    [sym_math_expression] = STATE(1170),
    [sym_cast_expression] = STATE(1170),
    [sym_sizeof_expression] = STATE(1170),
    [sym_subscript_expression] = STATE(1170),
    [sym_call_expression] = STATE(1170),
    [sym_field_expression] = STATE(1170),
    [sym_compound_literal_expression] = STATE(1170),
    [sym_parenthesized_expression] = STATE(1170),
    [sym_char_literal] = STATE(1170),
    [sym_concatenated_string] = STATE(1170),
    [sym_string_literal] = STATE(363),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3229),
    [sym_false] = ACTIONS(3229),
    [sym_null] = ACTIONS(3229),
    [sym_identifier] = ACTIONS(1630),
    [sym_comment] = ACTIONS(41),
  },
  [1122] = {
    [sym_compound_statement] = STATE(1070),
    [sym_labeled_statement] = STATE(1070),
    [sym_expression_statement] = STATE(1070),
    [sym_if_statement] = STATE(1070),
    [sym_switch_statement] = STATE(1070),
    [sym_case_statement] = STATE(1070),
    [sym_while_statement] = STATE(1070),
    [sym_do_statement] = STATE(1070),
    [sym_for_statement] = STATE(1070),
    [sym_return_statement] = STATE(1070),
    [sym_break_statement] = STATE(1070),
    [sym_continue_statement] = STATE(1070),
    [sym_goto_statement] = STATE(1070),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
  [1123] = {
    [sym_compound_statement] = STATE(1171),
    [sym_labeled_statement] = STATE(1171),
    [sym_expression_statement] = STATE(1171),
    [sym_if_statement] = STATE(1171),
    [sym_switch_statement] = STATE(1171),
    [sym_case_statement] = STATE(1171),
    [sym_while_statement] = STATE(1171),
    [sym_do_statement] = STATE(1171),
    [sym_for_statement] = STATE(1171),
    [sym_return_statement] = STATE(1171),
    [sym_break_statement] = STATE(1171),
    [sym_continue_statement] = STATE(1171),
    [sym_goto_statement] = STATE(1171),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2904),
    [sym_comment] = ACTIONS(41),
  },
  [1124] = {
    [anon_sym_LPAREN] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2743),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2745),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2745),
    [sym_preproc_directive] = ACTIONS(2745),
    [anon_sym_typedef] = ACTIONS(2745),
    [anon_sym_extern] = ACTIONS(2745),
    [anon_sym_STAR] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2745),
    [anon_sym_auto] = ACTIONS(2745),
    [anon_sym_register] = ACTIONS(2745),
    [anon_sym_inline] = ACTIONS(2745),
    [anon_sym_const] = ACTIONS(2745),
    [anon_sym_restrict] = ACTIONS(2745),
    [anon_sym_volatile] = ACTIONS(2745),
    [anon_sym__Atomic] = ACTIONS(2745),
    [anon_sym_unsigned] = ACTIONS(2745),
    [anon_sym_long] = ACTIONS(2745),
    [anon_sym_short] = ACTIONS(2745),
    [sym_primitive_type] = ACTIONS(2745),
    [anon_sym_enum] = ACTIONS(2745),
    [anon_sym_struct] = ACTIONS(2745),
    [anon_sym_union] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(2745),
    [anon_sym_else] = ACTIONS(2745),
    [anon_sym_switch] = ACTIONS(2745),
    [anon_sym_case] = ACTIONS(2745),
    [anon_sym_default] = ACTIONS(2745),
    [anon_sym_while] = ACTIONS(2745),
    [anon_sym_do] = ACTIONS(2745),
    [anon_sym_for] = ACTIONS(2745),
    [anon_sym_return] = ACTIONS(2745),
    [anon_sym_break] = ACTIONS(2745),
    [anon_sym_continue] = ACTIONS(2745),
    [anon_sym_goto] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_BANG] = ACTIONS(2743),
    [anon_sym_TILDE] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2745),
    [anon_sym_DASH_DASH] = ACTIONS(2743),
    [anon_sym_PLUS_PLUS] = ACTIONS(2743),
    [anon_sym_sizeof] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2743),
    [anon_sym_SQUOTE] = ACTIONS(2743),
    [anon_sym_DQUOTE] = ACTIONS(2743),
    [sym_true] = ACTIONS(2745),
    [sym_false] = ACTIONS(2745),
    [sym_null] = ACTIONS(2745),
    [sym_identifier] = ACTIONS(2745),
    [sym_comment] = ACTIONS(41),
  },
  [1125] = {
    [sym__expression] = STATE(1172),
    [sym_comma_expression] = STATE(1173),
    [sym_conditional_expression] = STATE(1172),
    [sym_assignment_expression] = STATE(1172),
    [sym_pointer_expression] = STATE(1172),
    [sym_logical_expression] = STATE(1172),
    [sym_bitwise_expression] = STATE(1172),
    [sym_equality_expression] = STATE(1172),
    [sym_relational_expression] = STATE(1172),
    [sym_shift_expression] = STATE(1172),
    [sym_math_expression] = STATE(1172),
    [sym_cast_expression] = STATE(1172),
    [sym_sizeof_expression] = STATE(1172),
    [sym_subscript_expression] = STATE(1172),
    [sym_call_expression] = STATE(1172),
    [sym_field_expression] = STATE(1172),
    [sym_compound_literal_expression] = STATE(1172),
    [sym_parenthesized_expression] = STATE(1172),
    [sym_char_literal] = STATE(1172),
    [sym_concatenated_string] = STATE(1172),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3233),
    [sym_false] = ACTIONS(3233),
    [sym_null] = ACTIONS(3233),
    [sym_identifier] = ACTIONS(3233),
    [sym_comment] = ACTIONS(41),
  },
  [1126] = {
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2771),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2773),
    [sym_preproc_directive] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_auto] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [sym_primitive_type] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_switch] = ACTIONS(2773),
    [anon_sym_case] = ACTIONS(2773),
    [anon_sym_default] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_goto] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_TILDE] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_sizeof] = ACTIONS(2773),
    [sym_number_literal] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [anon_sym_DQUOTE] = ACTIONS(2771),
    [sym_true] = ACTIONS(2773),
    [sym_false] = ACTIONS(2773),
    [sym_null] = ACTIONS(2773),
    [sym_identifier] = ACTIONS(2773),
    [sym_comment] = ACTIONS(41),
  },
  [1127] = {
    [sym__expression] = STATE(1175),
    [sym_conditional_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1175),
    [sym_pointer_expression] = STATE(1175),
    [sym_logical_expression] = STATE(1175),
    [sym_bitwise_expression] = STATE(1175),
    [sym_equality_expression] = STATE(1175),
    [sym_relational_expression] = STATE(1175),
    [sym_shift_expression] = STATE(1175),
    [sym_math_expression] = STATE(1175),
    [sym_cast_expression] = STATE(1175),
    [sym_sizeof_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_call_expression] = STATE(1175),
    [sym_field_expression] = STATE(1175),
    [sym_compound_literal_expression] = STATE(1175),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_char_literal] = STATE(1175),
    [sym_concatenated_string] = STATE(1175),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3237),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [sym_null] = ACTIONS(3239),
    [sym_identifier] = ACTIONS(3239),
    [sym_comment] = ACTIONS(41),
  },
  [1128] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1129] = {
    [sym__expression] = STATE(1177),
    [sym_conditional_expression] = STATE(1177),
    [sym_assignment_expression] = STATE(1177),
    [sym_pointer_expression] = STATE(1177),
    [sym_logical_expression] = STATE(1177),
    [sym_bitwise_expression] = STATE(1177),
    [sym_equality_expression] = STATE(1177),
    [sym_relational_expression] = STATE(1177),
    [sym_shift_expression] = STATE(1177),
    [sym_math_expression] = STATE(1177),
    [sym_cast_expression] = STATE(1177),
    [sym_sizeof_expression] = STATE(1177),
    [sym_subscript_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_compound_literal_expression] = STATE(1177),
    [sym_parenthesized_expression] = STATE(1177),
    [sym_char_literal] = STATE(1177),
    [sym_concatenated_string] = STATE(1177),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3245),
    [sym_false] = ACTIONS(3245),
    [sym_null] = ACTIONS(3245),
    [sym_identifier] = ACTIONS(3245),
    [sym_comment] = ACTIONS(41),
  },
  [1130] = {
    [anon_sym_LPAREN] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2316),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2318),
    [sym_preproc_directive] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_auto] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2318),
    [sym_comment] = ACTIONS(41),
  },
  [1131] = {
    [sym_declaration] = STATE(1080),
    [sym_type_definition] = STATE(1080),
    [sym__declaration_specifiers] = STATE(992),
    [sym_compound_statement] = STATE(1080),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(1080),
    [sym_expression_statement] = STATE(1080),
    [sym_if_statement] = STATE(1080),
    [sym_switch_statement] = STATE(1080),
    [sym_case_statement] = STATE(1080),
    [sym_while_statement] = STATE(1080),
    [sym_do_statement] = STATE(1080),
    [sym_for_statement] = STATE(1080),
    [sym_return_statement] = STATE(1080),
    [sym_break_statement] = STATE(1080),
    [sym_continue_statement] = STATE(1080),
    [sym_goto_statement] = STATE(1080),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_typedef] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(3139),
    [sym_comment] = ACTIONS(41),
  },
  [1132] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(3000),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [1133] = {
    [sym__expression] = STATE(1180),
    [sym_conditional_expression] = STATE(1180),
    [sym_assignment_expression] = STATE(1180),
    [sym_pointer_expression] = STATE(1180),
    [sym_logical_expression] = STATE(1180),
    [sym_bitwise_expression] = STATE(1180),
    [sym_equality_expression] = STATE(1180),
    [sym_relational_expression] = STATE(1180),
    [sym_shift_expression] = STATE(1180),
    [sym_math_expression] = STATE(1180),
    [sym_cast_expression] = STATE(1180),
    [sym_sizeof_expression] = STATE(1180),
    [sym_subscript_expression] = STATE(1180),
    [sym_call_expression] = STATE(1180),
    [sym_field_expression] = STATE(1180),
    [sym_compound_literal_expression] = STATE(1180),
    [sym_parenthesized_expression] = STATE(1180),
    [sym_char_literal] = STATE(1180),
    [sym_concatenated_string] = STATE(1180),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3253),
    [sym_false] = ACTIONS(3253),
    [sym_null] = ACTIONS(3253),
    [sym_identifier] = ACTIONS(3253),
    [sym_comment] = ACTIONS(41),
  },
  [1134] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1135] = {
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_auto] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [sym_null] = ACTIONS(3034),
    [sym_identifier] = ACTIONS(3034),
    [sym_comment] = ACTIONS(41),
  },
  [1136] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1137] = {
    [anon_sym_RPAREN] = ACTIONS(3257),
    [sym_comment] = ACTIONS(41),
  },
  [1138] = {
    [sym_compound_statement] = STATE(1183),
    [sym_labeled_statement] = STATE(1183),
    [sym_expression_statement] = STATE(1183),
    [sym_if_statement] = STATE(1183),
    [sym_switch_statement] = STATE(1183),
    [sym_case_statement] = STATE(1183),
    [sym_while_statement] = STATE(1183),
    [sym_do_statement] = STATE(1183),
    [sym_for_statement] = STATE(1183),
    [sym_return_statement] = STATE(1183),
    [sym_break_statement] = STATE(1183),
    [sym_continue_statement] = STATE(1183),
    [sym_goto_statement] = STATE(1183),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2633),
    [sym_comment] = ACTIONS(41),
  },
  [1139] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1185),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3259),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1140] = {
    [sym__expression] = STATE(1186),
    [sym_conditional_expression] = STATE(1186),
    [sym_assignment_expression] = STATE(1186),
    [sym_pointer_expression] = STATE(1186),
    [sym_logical_expression] = STATE(1186),
    [sym_bitwise_expression] = STATE(1186),
    [sym_equality_expression] = STATE(1186),
    [sym_relational_expression] = STATE(1186),
    [sym_shift_expression] = STATE(1186),
    [sym_math_expression] = STATE(1186),
    [sym_cast_expression] = STATE(1186),
    [sym_sizeof_expression] = STATE(1186),
    [sym_subscript_expression] = STATE(1186),
    [sym_call_expression] = STATE(1186),
    [sym_field_expression] = STATE(1186),
    [sym_compound_literal_expression] = STATE(1186),
    [sym_parenthesized_expression] = STATE(1186),
    [sym_char_literal] = STATE(1186),
    [sym_concatenated_string] = STATE(1186),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3261),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3263),
    [sym_false] = ACTIONS(3263),
    [sym_null] = ACTIONS(3263),
    [sym_identifier] = ACTIONS(3263),
    [sym_comment] = ACTIONS(41),
  },
  [1141] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3265),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1142] = {
    [sym_compound_statement] = STATE(1100),
    [sym_labeled_statement] = STATE(1100),
    [sym_expression_statement] = STATE(1100),
    [sym_if_statement] = STATE(1100),
    [sym_switch_statement] = STATE(1100),
    [sym_case_statement] = STATE(1100),
    [sym_while_statement] = STATE(1100),
    [sym_do_statement] = STATE(1100),
    [sym_for_statement] = STATE(1100),
    [sym_return_statement] = STATE(1100),
    [sym_break_statement] = STATE(1100),
    [sym_continue_statement] = STATE(1100),
    [sym_goto_statement] = STATE(1100),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [1143] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1189),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3267),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1144] = {
    [sym__expression] = STATE(1190),
    [sym_conditional_expression] = STATE(1190),
    [sym_assignment_expression] = STATE(1190),
    [sym_pointer_expression] = STATE(1190),
    [sym_logical_expression] = STATE(1190),
    [sym_bitwise_expression] = STATE(1190),
    [sym_equality_expression] = STATE(1190),
    [sym_relational_expression] = STATE(1190),
    [sym_shift_expression] = STATE(1190),
    [sym_math_expression] = STATE(1190),
    [sym_cast_expression] = STATE(1190),
    [sym_sizeof_expression] = STATE(1190),
    [sym_subscript_expression] = STATE(1190),
    [sym_call_expression] = STATE(1190),
    [sym_field_expression] = STATE(1190),
    [sym_compound_literal_expression] = STATE(1190),
    [sym_parenthesized_expression] = STATE(1190),
    [sym_char_literal] = STATE(1190),
    [sym_concatenated_string] = STATE(1190),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3267),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3269),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3271),
    [sym_false] = ACTIONS(3271),
    [sym_null] = ACTIONS(3271),
    [sym_identifier] = ACTIONS(3271),
    [sym_comment] = ACTIONS(41),
  },
  [1145] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1146] = {
    [sym_compound_statement] = STATE(1007),
    [sym_labeled_statement] = STATE(1007),
    [sym_expression_statement] = STATE(1007),
    [sym_if_statement] = STATE(1007),
    [sym_switch_statement] = STATE(1007),
    [sym_case_statement] = STATE(1007),
    [sym_while_statement] = STATE(1007),
    [sym_do_statement] = STATE(1007),
    [sym_for_statement] = STATE(1007),
    [sym_return_statement] = STATE(1007),
    [sym_break_statement] = STATE(1007),
    [sym_continue_statement] = STATE(1007),
    [sym_goto_statement] = STATE(1007),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [1147] = {
    [sym__expression] = STATE(1193),
    [sym_conditional_expression] = STATE(1193),
    [sym_assignment_expression] = STATE(1193),
    [sym_pointer_expression] = STATE(1193),
    [sym_logical_expression] = STATE(1193),
    [sym_bitwise_expression] = STATE(1193),
    [sym_equality_expression] = STATE(1193),
    [sym_relational_expression] = STATE(1193),
    [sym_shift_expression] = STATE(1193),
    [sym_math_expression] = STATE(1193),
    [sym_cast_expression] = STATE(1193),
    [sym_sizeof_expression] = STATE(1193),
    [sym_subscript_expression] = STATE(1193),
    [sym_call_expression] = STATE(1193),
    [sym_field_expression] = STATE(1193),
    [sym_compound_literal_expression] = STATE(1193),
    [sym_parenthesized_expression] = STATE(1193),
    [sym_char_literal] = STATE(1193),
    [sym_concatenated_string] = STATE(1193),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3275),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3279),
    [sym_false] = ACTIONS(3279),
    [sym_null] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_comment] = ACTIONS(41),
  },
  [1148] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1149] = {
    [sym__expression] = STATE(1195),
    [sym_conditional_expression] = STATE(1195),
    [sym_assignment_expression] = STATE(1195),
    [sym_pointer_expression] = STATE(1195),
    [sym_logical_expression] = STATE(1195),
    [sym_bitwise_expression] = STATE(1195),
    [sym_equality_expression] = STATE(1195),
    [sym_relational_expression] = STATE(1195),
    [sym_shift_expression] = STATE(1195),
    [sym_math_expression] = STATE(1195),
    [sym_cast_expression] = STATE(1195),
    [sym_sizeof_expression] = STATE(1195),
    [sym_subscript_expression] = STATE(1195),
    [sym_call_expression] = STATE(1195),
    [sym_field_expression] = STATE(1195),
    [sym_compound_literal_expression] = STATE(1195),
    [sym_parenthesized_expression] = STATE(1195),
    [sym_char_literal] = STATE(1195),
    [sym_concatenated_string] = STATE(1195),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_identifier] = ACTIONS(3285),
    [sym_comment] = ACTIONS(41),
  },
  [1150] = {
    [sym_compound_statement] = STATE(1154),
    [sym_labeled_statement] = STATE(1154),
    [sym_expression_statement] = STATE(1154),
    [sym_if_statement] = STATE(1154),
    [sym_switch_statement] = STATE(1154),
    [sym_case_statement] = STATE(1154),
    [sym_while_statement] = STATE(1154),
    [sym_do_statement] = STATE(1154),
    [sym_for_statement] = STATE(1154),
    [sym_return_statement] = STATE(1154),
    [sym_break_statement] = STATE(1154),
    [sym_continue_statement] = STATE(1154),
    [sym_goto_statement] = STATE(1154),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [1151] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3287),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1152] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1197),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3287),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1153] = {
    [sym__expression] = STATE(1198),
    [sym_conditional_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1198),
    [sym_pointer_expression] = STATE(1198),
    [sym_logical_expression] = STATE(1198),
    [sym_bitwise_expression] = STATE(1198),
    [sym_equality_expression] = STATE(1198),
    [sym_relational_expression] = STATE(1198),
    [sym_shift_expression] = STATE(1198),
    [sym_math_expression] = STATE(1198),
    [sym_cast_expression] = STATE(1198),
    [sym_sizeof_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_call_expression] = STATE(1198),
    [sym_field_expression] = STATE(1198),
    [sym_compound_literal_expression] = STATE(1198),
    [sym_parenthesized_expression] = STATE(1198),
    [sym_char_literal] = STATE(1198),
    [sym_concatenated_string] = STATE(1198),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3291),
    [sym_false] = ACTIONS(3291),
    [sym_null] = ACTIONS(3291),
    [sym_identifier] = ACTIONS(3291),
    [sym_comment] = ACTIONS(41),
  },
  [1154] = {
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3295),
    [sym_preproc_directive] = ACTIONS(3295),
    [anon_sym_typedef] = ACTIONS(3295),
    [anon_sym_extern] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_auto] = ACTIONS(3295),
    [anon_sym_register] = ACTIONS(3295),
    [anon_sym_inline] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_restrict] = ACTIONS(3295),
    [anon_sym_volatile] = ACTIONS(3295),
    [anon_sym__Atomic] = ACTIONS(3295),
    [anon_sym_unsigned] = ACTIONS(3295),
    [anon_sym_long] = ACTIONS(3295),
    [anon_sym_short] = ACTIONS(3295),
    [sym_primitive_type] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [anon_sym_struct] = ACTIONS(3295),
    [anon_sym_union] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_case] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_goto] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_sizeof] = ACTIONS(3295),
    [sym_number_literal] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [sym_true] = ACTIONS(3295),
    [sym_false] = ACTIONS(3295),
    [sym_null] = ACTIONS(3295),
    [sym_identifier] = ACTIONS(3295),
    [sym_comment] = ACTIONS(41),
  },
  [1155] = {
    [sym_compound_statement] = STATE(1199),
    [sym_labeled_statement] = STATE(1199),
    [sym_expression_statement] = STATE(1199),
    [sym_if_statement] = STATE(1199),
    [sym_switch_statement] = STATE(1199),
    [sym_case_statement] = STATE(1199),
    [sym_while_statement] = STATE(1199),
    [sym_do_statement] = STATE(1199),
    [sym_for_statement] = STATE(1199),
    [sym_return_statement] = STATE(1199),
    [sym_break_statement] = STATE(1199),
    [sym_continue_statement] = STATE(1199),
    [sym_goto_statement] = STATE(1199),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1572),
    [sym_comment] = ACTIONS(41),
  },
  [1156] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3297),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1157] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1201),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3297),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1158] = {
    [sym_ta_integer_list] = STATE(1202),
    [sym_number_literal] = ACTIONS(3093),
    [sym_comment] = ACTIONS(41),
  },
  [1159] = {
    [anon_sym_RPAREN] = ACTIONS(3299),
    [sym_comment] = ACTIONS(41),
  },
  [1160] = {
    [anon_sym_tensor] = ACTIONS(3091),
    [anon_sym_indexvars] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3091),
    [sym_preproc_directive] = ACTIONS(3091),
    [anon_sym_typedef] = ACTIONS(3091),
    [anon_sym_extern] = ACTIONS(3091),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_auto] = ACTIONS(3091),
    [anon_sym_register] = ACTIONS(3091),
    [anon_sym_inline] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3091),
    [anon_sym_restrict] = ACTIONS(3091),
    [anon_sym_volatile] = ACTIONS(3091),
    [anon_sym__Atomic] = ACTIONS(3091),
    [anon_sym_unsigned] = ACTIONS(3091),
    [anon_sym_long] = ACTIONS(3091),
    [anon_sym_short] = ACTIONS(3091),
    [sym_primitive_type] = ACTIONS(3091),
    [anon_sym_enum] = ACTIONS(3091),
    [anon_sym_struct] = ACTIONS(3091),
    [anon_sym_union] = ACTIONS(3091),
    [sym_identifier] = ACTIONS(3091),
    [sym_comment] = ACTIONS(41),
  },
  [1161] = {
    [sym_ta_integer_list] = STATE(1204),
    [sym_number_literal] = ACTIONS(3093),
    [sym_comment] = ACTIONS(41),
  },
  [1162] = {
    [anon_sym_SEMI] = ACTIONS(3301),
    [sym_comment] = ACTIONS(41),
  },
  [1163] = {
    [anon_sym_LBRACE] = ACTIONS(3303),
    [sym_comment] = ACTIONS(41),
  },
  [1164] = {
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3014),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3016),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3016),
    [sym_preproc_directive] = ACTIONS(3016),
    [anon_sym_typedef] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_auto] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [sym_primitive_type] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_goto] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_sizeof] = ACTIONS(3016),
    [sym_number_literal] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [sym_null] = ACTIONS(3016),
    [sym_identifier] = ACTIONS(3016),
    [sym_comment] = ACTIONS(41),
  },
  [1165] = {
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3018),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3020),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_auto] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [sym_primitive_type] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_sizeof] = ACTIONS(3020),
    [sym_number_literal] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [sym_null] = ACTIONS(3020),
    [sym_identifier] = ACTIONS(3020),
    [sym_comment] = ACTIONS(41),
  },
  [1166] = {
    [anon_sym_LPAREN] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2316),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2318),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2318),
    [sym_preproc_directive] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_auto] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(3305),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2318),
    [sym_comment] = ACTIONS(41),
  },
  [1167] = {
    [sym_declaration] = STATE(1124),
    [sym_type_definition] = STATE(1124),
    [sym__declaration_specifiers] = STATE(1063),
    [sym_compound_statement] = STATE(1124),
    [sym_storage_class_specifier] = STATE(97),
    [sym_type_qualifier] = STATE(97),
    [sym__type_specifier] = STATE(96),
    [sym_sized_type_specifier] = STATE(96),
    [sym_enum_specifier] = STATE(96),
    [sym_struct_specifier] = STATE(96),
    [sym_union_specifier] = STATE(96),
    [sym_labeled_statement] = STATE(1124),
    [sym_expression_statement] = STATE(1124),
    [sym_if_statement] = STATE(1124),
    [sym_switch_statement] = STATE(1124),
    [sym_case_statement] = STATE(1124),
    [sym_while_statement] = STATE(1124),
    [sym_do_statement] = STATE(1124),
    [sym_for_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_goto_statement] = STATE(1124),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [sym_macro_type_specifier] = STATE(96),
    [aux_sym__declaration_specifiers_repeat1] = STATE(97),
    [aux_sym_sized_type_specifier_repeat1] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_typedef] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_auto] = ACTIONS(25),
    [anon_sym_register] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_restrict] = ACTIONS(27),
    [anon_sym_volatile] = ACTIONS(27),
    [anon_sym__Atomic] = ACTIONS(27),
    [anon_sym_unsigned] = ACTIONS(187),
    [anon_sym_long] = ACTIONS(187),
    [anon_sym_short] = ACTIONS(187),
    [sym_primitive_type] = ACTIONS(189),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_union] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(3223),
    [sym_comment] = ACTIONS(41),
  },
  [1168] = {
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(90),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(90),
    [anon_sym_auto] = ACTIONS(90),
    [anon_sym_register] = ACTIONS(90),
    [anon_sym_inline] = ACTIONS(90),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_restrict] = ACTIONS(90),
    [anon_sym_volatile] = ACTIONS(90),
    [anon_sym__Atomic] = ACTIONS(90),
    [anon_sym_COLON] = ACTIONS(3121),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_STAR_EQ] = ACTIONS(1067),
    [anon_sym_SLASH_EQ] = ACTIONS(1067),
    [anon_sym_PERCENT_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_GT_EQ] = ACTIONS(1067),
    [anon_sym_AMP_EQ] = ACTIONS(1067),
    [anon_sym_CARET_EQ] = ACTIONS(1067),
    [anon_sym_PIPE_EQ] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_DASH_GT] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(90),
    [sym_comment] = ACTIONS(41),
  },
  [1169] = {
    [sym__expression] = STATE(1209),
    [sym_conditional_expression] = STATE(1209),
    [sym_assignment_expression] = STATE(1209),
    [sym_pointer_expression] = STATE(1209),
    [sym_logical_expression] = STATE(1209),
    [sym_bitwise_expression] = STATE(1209),
    [sym_equality_expression] = STATE(1209),
    [sym_relational_expression] = STATE(1209),
    [sym_shift_expression] = STATE(1209),
    [sym_math_expression] = STATE(1209),
    [sym_cast_expression] = STATE(1209),
    [sym_sizeof_expression] = STATE(1209),
    [sym_subscript_expression] = STATE(1209),
    [sym_call_expression] = STATE(1209),
    [sym_field_expression] = STATE(1209),
    [sym_compound_literal_expression] = STATE(1209),
    [sym_parenthesized_expression] = STATE(1209),
    [sym_char_literal] = STATE(1209),
    [sym_concatenated_string] = STATE(1209),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3307),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3309),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3311),
    [sym_false] = ACTIONS(3311),
    [sym_null] = ACTIONS(3311),
    [sym_identifier] = ACTIONS(3311),
    [sym_comment] = ACTIONS(41),
  },
  [1170] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3313),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1171] = {
    [anon_sym_LPAREN] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3034),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_auto] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [sym_null] = ACTIONS(3034),
    [sym_identifier] = ACTIONS(3034),
    [sym_comment] = ACTIONS(41),
  },
  [1172] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3315),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1173] = {
    [anon_sym_RPAREN] = ACTIONS(3315),
    [sym_comment] = ACTIONS(41),
  },
  [1174] = {
    [sym_compound_statement] = STATE(1212),
    [sym_labeled_statement] = STATE(1212),
    [sym_expression_statement] = STATE(1212),
    [sym_if_statement] = STATE(1212),
    [sym_switch_statement] = STATE(1212),
    [sym_case_statement] = STATE(1212),
    [sym_while_statement] = STATE(1212),
    [sym_do_statement] = STATE(1212),
    [sym_for_statement] = STATE(1212),
    [sym_return_statement] = STATE(1212),
    [sym_break_statement] = STATE(1212),
    [sym_continue_statement] = STATE(1212),
    [sym_goto_statement] = STATE(1212),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2904),
    [sym_comment] = ACTIONS(41),
  },
  [1175] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3317),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1176] = {
    [sym__expression] = STATE(1215),
    [sym_conditional_expression] = STATE(1215),
    [sym_assignment_expression] = STATE(1215),
    [sym_pointer_expression] = STATE(1215),
    [sym_logical_expression] = STATE(1215),
    [sym_bitwise_expression] = STATE(1215),
    [sym_equality_expression] = STATE(1215),
    [sym_relational_expression] = STATE(1215),
    [sym_shift_expression] = STATE(1215),
    [sym_math_expression] = STATE(1215),
    [sym_cast_expression] = STATE(1215),
    [sym_sizeof_expression] = STATE(1215),
    [sym_subscript_expression] = STATE(1215),
    [sym_call_expression] = STATE(1215),
    [sym_field_expression] = STATE(1215),
    [sym_compound_literal_expression] = STATE(1215),
    [sym_parenthesized_expression] = STATE(1215),
    [sym_char_literal] = STATE(1215),
    [sym_concatenated_string] = STATE(1215),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3321),
    [sym_false] = ACTIONS(3321),
    [sym_null] = ACTIONS(3321),
    [sym_identifier] = ACTIONS(3321),
    [sym_comment] = ACTIONS(41),
  },
  [1177] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1178] = {
    [sym_compound_statement] = STATE(1135),
    [sym_labeled_statement] = STATE(1135),
    [sym_expression_statement] = STATE(1135),
    [sym_if_statement] = STATE(1135),
    [sym_switch_statement] = STATE(1135),
    [sym_case_statement] = STATE(1135),
    [sym_while_statement] = STATE(1135),
    [sym_do_statement] = STATE(1135),
    [sym_for_statement] = STATE(1135),
    [sym_return_statement] = STATE(1135),
    [sym_break_statement] = STATE(1135),
    [sym_continue_statement] = STATE(1135),
    [sym_goto_statement] = STATE(1135),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [1179] = {
    [sym__expression] = STATE(1218),
    [sym_conditional_expression] = STATE(1218),
    [sym_assignment_expression] = STATE(1218),
    [sym_pointer_expression] = STATE(1218),
    [sym_logical_expression] = STATE(1218),
    [sym_bitwise_expression] = STATE(1218),
    [sym_equality_expression] = STATE(1218),
    [sym_relational_expression] = STATE(1218),
    [sym_shift_expression] = STATE(1218),
    [sym_math_expression] = STATE(1218),
    [sym_cast_expression] = STATE(1218),
    [sym_sizeof_expression] = STATE(1218),
    [sym_subscript_expression] = STATE(1218),
    [sym_call_expression] = STATE(1218),
    [sym_field_expression] = STATE(1218),
    [sym_compound_literal_expression] = STATE(1218),
    [sym_parenthesized_expression] = STATE(1218),
    [sym_char_literal] = STATE(1218),
    [sym_concatenated_string] = STATE(1218),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3329),
    [sym_false] = ACTIONS(3329),
    [sym_null] = ACTIONS(3329),
    [sym_identifier] = ACTIONS(3329),
    [sym_comment] = ACTIONS(41),
  },
  [1180] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1181] = {
    [sym__expression] = STATE(1220),
    [sym_conditional_expression] = STATE(1220),
    [sym_assignment_expression] = STATE(1220),
    [sym_pointer_expression] = STATE(1220),
    [sym_logical_expression] = STATE(1220),
    [sym_bitwise_expression] = STATE(1220),
    [sym_equality_expression] = STATE(1220),
    [sym_relational_expression] = STATE(1220),
    [sym_shift_expression] = STATE(1220),
    [sym_math_expression] = STATE(1220),
    [sym_cast_expression] = STATE(1220),
    [sym_sizeof_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_field_expression] = STATE(1220),
    [sym_compound_literal_expression] = STATE(1220),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_char_literal] = STATE(1220),
    [sym_concatenated_string] = STATE(1220),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3333),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3335),
    [sym_false] = ACTIONS(3335),
    [sym_null] = ACTIONS(3335),
    [sym_identifier] = ACTIONS(3335),
    [sym_comment] = ACTIONS(41),
  },
  [1182] = {
    [anon_sym_LPAREN] = ACTIONS(2162),
    [anon_sym_LBRACE] = ACTIONS(2162),
    [anon_sym_SEMI] = ACTIONS(2162),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2164),
    [sym_preproc_directive] = ACTIONS(2164),
    [anon_sym_typedef] = ACTIONS(2164),
    [anon_sym_extern] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_auto] = ACTIONS(2164),
    [anon_sym_register] = ACTIONS(2164),
    [anon_sym_inline] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_restrict] = ACTIONS(2164),
    [anon_sym_volatile] = ACTIONS(2164),
    [anon_sym__Atomic] = ACTIONS(2164),
    [anon_sym_unsigned] = ACTIONS(2164),
    [anon_sym_long] = ACTIONS(2164),
    [anon_sym_short] = ACTIONS(2164),
    [sym_primitive_type] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_else] = ACTIONS(2164),
    [anon_sym_switch] = ACTIONS(2164),
    [anon_sym_case] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [anon_sym_do] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_goto] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_PLUS] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2164),
    [anon_sym_DASH_DASH] = ACTIONS(2162),
    [anon_sym_PLUS_PLUS] = ACTIONS(2162),
    [anon_sym_sizeof] = ACTIONS(2164),
    [sym_number_literal] = ACTIONS(2162),
    [anon_sym_SQUOTE] = ACTIONS(2162),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [sym_true] = ACTIONS(2164),
    [sym_false] = ACTIONS(2164),
    [sym_null] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2164),
    [sym_comment] = ACTIONS(41),
  },
  [1183] = {
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3193),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3195),
    [sym_preproc_directive] = ACTIONS(3195),
    [anon_sym_typedef] = ACTIONS(3195),
    [anon_sym_extern] = ACTIONS(3195),
    [anon_sym_STAR] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3195),
    [anon_sym_auto] = ACTIONS(3195),
    [anon_sym_register] = ACTIONS(3195),
    [anon_sym_inline] = ACTIONS(3195),
    [anon_sym_const] = ACTIONS(3195),
    [anon_sym_restrict] = ACTIONS(3195),
    [anon_sym_volatile] = ACTIONS(3195),
    [anon_sym__Atomic] = ACTIONS(3195),
    [anon_sym_unsigned] = ACTIONS(3195),
    [anon_sym_long] = ACTIONS(3195),
    [anon_sym_short] = ACTIONS(3195),
    [sym_primitive_type] = ACTIONS(3195),
    [anon_sym_enum] = ACTIONS(3195),
    [anon_sym_struct] = ACTIONS(3195),
    [anon_sym_union] = ACTIONS(3195),
    [anon_sym_if] = ACTIONS(3195),
    [anon_sym_else] = ACTIONS(3195),
    [anon_sym_switch] = ACTIONS(3195),
    [anon_sym_case] = ACTIONS(3195),
    [anon_sym_default] = ACTIONS(3195),
    [anon_sym_while] = ACTIONS(3195),
    [anon_sym_do] = ACTIONS(3195),
    [anon_sym_for] = ACTIONS(3195),
    [anon_sym_return] = ACTIONS(3195),
    [anon_sym_break] = ACTIONS(3195),
    [anon_sym_continue] = ACTIONS(3195),
    [anon_sym_goto] = ACTIONS(3195),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_DASH_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_PLUS] = ACTIONS(3193),
    [anon_sym_sizeof] = ACTIONS(3195),
    [sym_number_literal] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [sym_true] = ACTIONS(3195),
    [sym_false] = ACTIONS(3195),
    [sym_null] = ACTIONS(3195),
    [sym_identifier] = ACTIONS(3195),
    [sym_comment] = ACTIONS(41),
  },
  [1184] = {
    [sym_compound_statement] = STATE(1221),
    [sym_labeled_statement] = STATE(1221),
    [sym_expression_statement] = STATE(1221),
    [sym_if_statement] = STATE(1221),
    [sym_switch_statement] = STATE(1221),
    [sym_case_statement] = STATE(1221),
    [sym_while_statement] = STATE(1221),
    [sym_do_statement] = STATE(1221),
    [sym_for_statement] = STATE(1221),
    [sym_return_statement] = STATE(1221),
    [sym_break_statement] = STATE(1221),
    [sym_continue_statement] = STATE(1221),
    [sym_goto_statement] = STATE(1221),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2633),
    [sym_comment] = ACTIONS(41),
  },
  [1185] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3337),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1186] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1223),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3337),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1187] = {
    [sym__expression] = STATE(1224),
    [sym_conditional_expression] = STATE(1224),
    [sym_assignment_expression] = STATE(1224),
    [sym_pointer_expression] = STATE(1224),
    [sym_logical_expression] = STATE(1224),
    [sym_bitwise_expression] = STATE(1224),
    [sym_equality_expression] = STATE(1224),
    [sym_relational_expression] = STATE(1224),
    [sym_shift_expression] = STATE(1224),
    [sym_math_expression] = STATE(1224),
    [sym_cast_expression] = STATE(1224),
    [sym_sizeof_expression] = STATE(1224),
    [sym_subscript_expression] = STATE(1224),
    [sym_call_expression] = STATE(1224),
    [sym_field_expression] = STATE(1224),
    [sym_compound_literal_expression] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1224),
    [sym_char_literal] = STATE(1224),
    [sym_concatenated_string] = STATE(1224),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3337),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3339),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3341),
    [sym_false] = ACTIONS(3341),
    [sym_null] = ACTIONS(3341),
    [sym_identifier] = ACTIONS(3341),
    [sym_comment] = ACTIONS(41),
  },
  [1188] = {
    [sym_compound_statement] = STATE(1154),
    [sym_labeled_statement] = STATE(1154),
    [sym_expression_statement] = STATE(1154),
    [sym_if_statement] = STATE(1154),
    [sym_switch_statement] = STATE(1154),
    [sym_case_statement] = STATE(1154),
    [sym_while_statement] = STATE(1154),
    [sym_do_statement] = STATE(1154),
    [sym_for_statement] = STATE(1154),
    [sym_return_statement] = STATE(1154),
    [sym_break_statement] = STATE(1154),
    [sym_continue_statement] = STATE(1154),
    [sym_goto_statement] = STATE(1154),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [1189] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3343),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1190] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1226),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3343),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1191] = {
    [sym__expression] = STATE(1227),
    [sym_conditional_expression] = STATE(1227),
    [sym_assignment_expression] = STATE(1227),
    [sym_pointer_expression] = STATE(1227),
    [sym_logical_expression] = STATE(1227),
    [sym_bitwise_expression] = STATE(1227),
    [sym_equality_expression] = STATE(1227),
    [sym_relational_expression] = STATE(1227),
    [sym_shift_expression] = STATE(1227),
    [sym_math_expression] = STATE(1227),
    [sym_cast_expression] = STATE(1227),
    [sym_sizeof_expression] = STATE(1227),
    [sym_subscript_expression] = STATE(1227),
    [sym_call_expression] = STATE(1227),
    [sym_field_expression] = STATE(1227),
    [sym_compound_literal_expression] = STATE(1227),
    [sym_parenthesized_expression] = STATE(1227),
    [sym_char_literal] = STATE(1227),
    [sym_concatenated_string] = STATE(1227),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3343),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3345),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3347),
    [sym_false] = ACTIONS(3347),
    [sym_null] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3347),
    [sym_comment] = ACTIONS(41),
  },
  [1192] = {
    [sym_compound_statement] = STATE(1100),
    [sym_labeled_statement] = STATE(1100),
    [sym_expression_statement] = STATE(1100),
    [sym_if_statement] = STATE(1100),
    [sym_switch_statement] = STATE(1100),
    [sym_case_statement] = STATE(1100),
    [sym_while_statement] = STATE(1100),
    [sym_do_statement] = STATE(1100),
    [sym_for_statement] = STATE(1100),
    [sym_return_statement] = STATE(1100),
    [sym_break_statement] = STATE(1100),
    [sym_continue_statement] = STATE(1100),
    [sym_goto_statement] = STATE(1100),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [1193] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1229),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3349),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1194] = {
    [sym__expression] = STATE(1230),
    [sym_conditional_expression] = STATE(1230),
    [sym_assignment_expression] = STATE(1230),
    [sym_pointer_expression] = STATE(1230),
    [sym_logical_expression] = STATE(1230),
    [sym_bitwise_expression] = STATE(1230),
    [sym_equality_expression] = STATE(1230),
    [sym_relational_expression] = STATE(1230),
    [sym_shift_expression] = STATE(1230),
    [sym_math_expression] = STATE(1230),
    [sym_cast_expression] = STATE(1230),
    [sym_sizeof_expression] = STATE(1230),
    [sym_subscript_expression] = STATE(1230),
    [sym_call_expression] = STATE(1230),
    [sym_field_expression] = STATE(1230),
    [sym_compound_literal_expression] = STATE(1230),
    [sym_parenthesized_expression] = STATE(1230),
    [sym_char_literal] = STATE(1230),
    [sym_concatenated_string] = STATE(1230),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [sym_null] = ACTIONS(3353),
    [sym_identifier] = ACTIONS(3353),
    [sym_comment] = ACTIONS(41),
  },
  [1195] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1196] = {
    [sym_compound_statement] = STATE(1199),
    [sym_labeled_statement] = STATE(1199),
    [sym_expression_statement] = STATE(1199),
    [sym_if_statement] = STATE(1199),
    [sym_switch_statement] = STATE(1199),
    [sym_case_statement] = STATE(1199),
    [sym_while_statement] = STATE(1199),
    [sym_do_statement] = STATE(1199),
    [sym_for_statement] = STATE(1199),
    [sym_return_statement] = STATE(1199),
    [sym_break_statement] = STATE(1199),
    [sym_continue_statement] = STATE(1199),
    [sym_goto_statement] = STATE(1199),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [1197] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3357),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1198] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1233),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3357),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1199] = {
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3361),
    [sym_preproc_directive] = ACTIONS(3361),
    [anon_sym_typedef] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_auto] = ACTIONS(3361),
    [anon_sym_register] = ACTIONS(3361),
    [anon_sym_inline] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_restrict] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym__Atomic] = ACTIONS(3361),
    [anon_sym_unsigned] = ACTIONS(3361),
    [anon_sym_long] = ACTIONS(3361),
    [anon_sym_short] = ACTIONS(3361),
    [sym_primitive_type] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_union] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3361),
    [sym_number_literal] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [sym_null] = ACTIONS(3361),
    [sym_identifier] = ACTIONS(3361),
    [sym_comment] = ACTIONS(41),
  },
  [1200] = {
    [sym_compound_statement] = STATE(1234),
    [sym_labeled_statement] = STATE(1234),
    [sym_expression_statement] = STATE(1234),
    [sym_if_statement] = STATE(1234),
    [sym_switch_statement] = STATE(1234),
    [sym_case_statement] = STATE(1234),
    [sym_while_statement] = STATE(1234),
    [sym_do_statement] = STATE(1234),
    [sym_for_statement] = STATE(1234),
    [sym_return_statement] = STATE(1234),
    [sym_break_statement] = STATE(1234),
    [sym_continue_statement] = STATE(1234),
    [sym_goto_statement] = STATE(1234),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1572),
    [sym_comment] = ACTIONS(41),
  },
  [1201] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1202] = {
    [anon_sym_RBRACE] = ACTIONS(3365),
    [sym_comment] = ACTIONS(41),
  },
  [1203] = {
    [anon_sym_SEMI] = ACTIONS(3367),
    [sym_comment] = ACTIONS(41),
  },
  [1204] = {
    [anon_sym_RBRACE] = ACTIONS(3369),
    [sym_comment] = ACTIONS(41),
  },
  [1205] = {
    [anon_sym_tensor] = ACTIONS(3091),
    [anon_sym_indexvars] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3091),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3091),
    [sym_preproc_directive] = ACTIONS(3091),
    [anon_sym_typedef] = ACTIONS(3091),
    [anon_sym_extern] = ACTIONS(3091),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_auto] = ACTIONS(3091),
    [anon_sym_register] = ACTIONS(3091),
    [anon_sym_inline] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3091),
    [anon_sym_restrict] = ACTIONS(3091),
    [anon_sym_volatile] = ACTIONS(3091),
    [anon_sym__Atomic] = ACTIONS(3091),
    [anon_sym_unsigned] = ACTIONS(3091),
    [anon_sym_long] = ACTIONS(3091),
    [anon_sym_short] = ACTIONS(3091),
    [sym_primitive_type] = ACTIONS(3091),
    [anon_sym_enum] = ACTIONS(3091),
    [anon_sym_struct] = ACTIONS(3091),
    [anon_sym_union] = ACTIONS(3091),
    [sym_identifier] = ACTIONS(3091),
    [sym_comment] = ACTIONS(41),
  },
  [1206] = {
    [sym_ta_integer_list] = STATE(1238),
    [sym_number_literal] = ACTIONS(3093),
    [sym_comment] = ACTIONS(41),
  },
  [1207] = {
    [sym_compound_statement] = STATE(1171),
    [sym_labeled_statement] = STATE(1171),
    [sym_expression_statement] = STATE(1171),
    [sym_if_statement] = STATE(1171),
    [sym_switch_statement] = STATE(1171),
    [sym_case_statement] = STATE(1171),
    [sym_while_statement] = STATE(1171),
    [sym_do_statement] = STATE(1171),
    [sym_for_statement] = STATE(1171),
    [sym_return_statement] = STATE(1171),
    [sym_break_statement] = STATE(1171),
    [sym_continue_statement] = STATE(1171),
    [sym_goto_statement] = STATE(1171),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
  [1208] = {
    [sym__expression] = STATE(1240),
    [sym_conditional_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1240),
    [sym_pointer_expression] = STATE(1240),
    [sym_logical_expression] = STATE(1240),
    [sym_bitwise_expression] = STATE(1240),
    [sym_equality_expression] = STATE(1240),
    [sym_relational_expression] = STATE(1240),
    [sym_shift_expression] = STATE(1240),
    [sym_math_expression] = STATE(1240),
    [sym_cast_expression] = STATE(1240),
    [sym_sizeof_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_call_expression] = STATE(1240),
    [sym_field_expression] = STATE(1240),
    [sym_compound_literal_expression] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1240),
    [sym_char_literal] = STATE(1240),
    [sym_concatenated_string] = STATE(1240),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [sym_null] = ACTIONS(3375),
    [sym_identifier] = ACTIONS(3375),
    [sym_comment] = ACTIONS(41),
  },
  [1209] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1210] = {
    [sym__expression] = STATE(1242),
    [sym_conditional_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1242),
    [sym_pointer_expression] = STATE(1242),
    [sym_logical_expression] = STATE(1242),
    [sym_bitwise_expression] = STATE(1242),
    [sym_equality_expression] = STATE(1242),
    [sym_relational_expression] = STATE(1242),
    [sym_shift_expression] = STATE(1242),
    [sym_math_expression] = STATE(1242),
    [sym_cast_expression] = STATE(1242),
    [sym_sizeof_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_call_expression] = STATE(1242),
    [sym_field_expression] = STATE(1242),
    [sym_compound_literal_expression] = STATE(1242),
    [sym_parenthesized_expression] = STATE(1242),
    [sym_char_literal] = STATE(1242),
    [sym_concatenated_string] = STATE(1242),
    [sym_string_literal] = STATE(363),
    [anon_sym_LPAREN] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_sizeof] = ACTIONS(846),
    [sym_number_literal] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3381),
    [sym_false] = ACTIONS(3381),
    [sym_null] = ACTIONS(3381),
    [sym_identifier] = ACTIONS(3381),
    [sym_comment] = ACTIONS(41),
  },
  [1211] = {
    [anon_sym_LPAREN] = ACTIONS(2162),
    [anon_sym_LBRACE] = ACTIONS(2162),
    [anon_sym_SEMI] = ACTIONS(2162),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2164),
    [sym_preproc_directive] = ACTIONS(2164),
    [anon_sym_typedef] = ACTIONS(2164),
    [anon_sym_extern] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_auto] = ACTIONS(2164),
    [anon_sym_register] = ACTIONS(2164),
    [anon_sym_inline] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_restrict] = ACTIONS(2164),
    [anon_sym_volatile] = ACTIONS(2164),
    [anon_sym__Atomic] = ACTIONS(2164),
    [anon_sym_unsigned] = ACTIONS(2164),
    [anon_sym_long] = ACTIONS(2164),
    [anon_sym_short] = ACTIONS(2164),
    [sym_primitive_type] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_else] = ACTIONS(2164),
    [anon_sym_switch] = ACTIONS(2164),
    [anon_sym_case] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [anon_sym_do] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_goto] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_PLUS] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2164),
    [anon_sym_DASH_DASH] = ACTIONS(2162),
    [anon_sym_PLUS_PLUS] = ACTIONS(2162),
    [anon_sym_sizeof] = ACTIONS(2164),
    [sym_number_literal] = ACTIONS(2162),
    [anon_sym_SQUOTE] = ACTIONS(2162),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [sym_true] = ACTIONS(2164),
    [sym_false] = ACTIONS(2164),
    [sym_null] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2164),
    [sym_comment] = ACTIONS(41),
  },
  [1212] = {
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3193),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3195),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3195),
    [sym_preproc_directive] = ACTIONS(3195),
    [anon_sym_typedef] = ACTIONS(3195),
    [anon_sym_extern] = ACTIONS(3195),
    [anon_sym_STAR] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3195),
    [anon_sym_auto] = ACTIONS(3195),
    [anon_sym_register] = ACTIONS(3195),
    [anon_sym_inline] = ACTIONS(3195),
    [anon_sym_const] = ACTIONS(3195),
    [anon_sym_restrict] = ACTIONS(3195),
    [anon_sym_volatile] = ACTIONS(3195),
    [anon_sym__Atomic] = ACTIONS(3195),
    [anon_sym_unsigned] = ACTIONS(3195),
    [anon_sym_long] = ACTIONS(3195),
    [anon_sym_short] = ACTIONS(3195),
    [sym_primitive_type] = ACTIONS(3195),
    [anon_sym_enum] = ACTIONS(3195),
    [anon_sym_struct] = ACTIONS(3195),
    [anon_sym_union] = ACTIONS(3195),
    [anon_sym_if] = ACTIONS(3195),
    [anon_sym_else] = ACTIONS(3195),
    [anon_sym_switch] = ACTIONS(3195),
    [anon_sym_case] = ACTIONS(3195),
    [anon_sym_default] = ACTIONS(3195),
    [anon_sym_while] = ACTIONS(3195),
    [anon_sym_do] = ACTIONS(3195),
    [anon_sym_for] = ACTIONS(3195),
    [anon_sym_return] = ACTIONS(3195),
    [anon_sym_break] = ACTIONS(3195),
    [anon_sym_continue] = ACTIONS(3195),
    [anon_sym_goto] = ACTIONS(3195),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_DASH_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_PLUS] = ACTIONS(3193),
    [anon_sym_sizeof] = ACTIONS(3195),
    [sym_number_literal] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [sym_true] = ACTIONS(3195),
    [sym_false] = ACTIONS(3195),
    [sym_null] = ACTIONS(3195),
    [sym_identifier] = ACTIONS(3195),
    [sym_comment] = ACTIONS(41),
  },
  [1213] = {
    [sym_compound_statement] = STATE(1243),
    [sym_labeled_statement] = STATE(1243),
    [sym_expression_statement] = STATE(1243),
    [sym_if_statement] = STATE(1243),
    [sym_switch_statement] = STATE(1243),
    [sym_case_statement] = STATE(1243),
    [sym_while_statement] = STATE(1243),
    [sym_do_statement] = STATE(1243),
    [sym_for_statement] = STATE(1243),
    [sym_return_statement] = STATE(1243),
    [sym_break_statement] = STATE(1243),
    [sym_continue_statement] = STATE(1243),
    [sym_goto_statement] = STATE(1243),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2904),
    [sym_comment] = ACTIONS(41),
  },
  [1214] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3383),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1215] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1245),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3383),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1216] = {
    [sym__expression] = STATE(1246),
    [sym_conditional_expression] = STATE(1246),
    [sym_assignment_expression] = STATE(1246),
    [sym_pointer_expression] = STATE(1246),
    [sym_logical_expression] = STATE(1246),
    [sym_bitwise_expression] = STATE(1246),
    [sym_equality_expression] = STATE(1246),
    [sym_relational_expression] = STATE(1246),
    [sym_shift_expression] = STATE(1246),
    [sym_math_expression] = STATE(1246),
    [sym_cast_expression] = STATE(1246),
    [sym_sizeof_expression] = STATE(1246),
    [sym_subscript_expression] = STATE(1246),
    [sym_call_expression] = STATE(1246),
    [sym_field_expression] = STATE(1246),
    [sym_compound_literal_expression] = STATE(1246),
    [sym_parenthesized_expression] = STATE(1246),
    [sym_char_literal] = STATE(1246),
    [sym_concatenated_string] = STATE(1246),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [sym_null] = ACTIONS(3387),
    [sym_identifier] = ACTIONS(3387),
    [sym_comment] = ACTIONS(41),
  },
  [1217] = {
    [sym_compound_statement] = STATE(1183),
    [sym_labeled_statement] = STATE(1183),
    [sym_expression_statement] = STATE(1183),
    [sym_if_statement] = STATE(1183),
    [sym_switch_statement] = STATE(1183),
    [sym_case_statement] = STATE(1183),
    [sym_while_statement] = STATE(1183),
    [sym_do_statement] = STATE(1183),
    [sym_for_statement] = STATE(1183),
    [sym_return_statement] = STATE(1183),
    [sym_break_statement] = STATE(1183),
    [sym_continue_statement] = STATE(1183),
    [sym_goto_statement] = STATE(1183),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [1218] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1248),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3389),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1219] = {
    [sym__expression] = STATE(1249),
    [sym_conditional_expression] = STATE(1249),
    [sym_assignment_expression] = STATE(1249),
    [sym_pointer_expression] = STATE(1249),
    [sym_logical_expression] = STATE(1249),
    [sym_bitwise_expression] = STATE(1249),
    [sym_equality_expression] = STATE(1249),
    [sym_relational_expression] = STATE(1249),
    [sym_shift_expression] = STATE(1249),
    [sym_math_expression] = STATE(1249),
    [sym_cast_expression] = STATE(1249),
    [sym_sizeof_expression] = STATE(1249),
    [sym_subscript_expression] = STATE(1249),
    [sym_call_expression] = STATE(1249),
    [sym_field_expression] = STATE(1249),
    [sym_compound_literal_expression] = STATE(1249),
    [sym_parenthesized_expression] = STATE(1249),
    [sym_char_literal] = STATE(1249),
    [sym_concatenated_string] = STATE(1249),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3393),
    [sym_false] = ACTIONS(3393),
    [sym_null] = ACTIONS(3393),
    [sym_identifier] = ACTIONS(3393),
    [sym_comment] = ACTIONS(41),
  },
  [1220] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1221] = {
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3295),
    [sym_preproc_directive] = ACTIONS(3295),
    [anon_sym_typedef] = ACTIONS(3295),
    [anon_sym_extern] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_auto] = ACTIONS(3295),
    [anon_sym_register] = ACTIONS(3295),
    [anon_sym_inline] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_restrict] = ACTIONS(3295),
    [anon_sym_volatile] = ACTIONS(3295),
    [anon_sym__Atomic] = ACTIONS(3295),
    [anon_sym_unsigned] = ACTIONS(3295),
    [anon_sym_long] = ACTIONS(3295),
    [anon_sym_short] = ACTIONS(3295),
    [sym_primitive_type] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [anon_sym_struct] = ACTIONS(3295),
    [anon_sym_union] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_case] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_goto] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_sizeof] = ACTIONS(3295),
    [sym_number_literal] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [sym_true] = ACTIONS(3295),
    [sym_false] = ACTIONS(3295),
    [sym_null] = ACTIONS(3295),
    [sym_identifier] = ACTIONS(3295),
    [sym_comment] = ACTIONS(41),
  },
  [1222] = {
    [sym_compound_statement] = STATE(1251),
    [sym_labeled_statement] = STATE(1251),
    [sym_expression_statement] = STATE(1251),
    [sym_if_statement] = STATE(1251),
    [sym_switch_statement] = STATE(1251),
    [sym_case_statement] = STATE(1251),
    [sym_while_statement] = STATE(1251),
    [sym_do_statement] = STATE(1251),
    [sym_for_statement] = STATE(1251),
    [sym_return_statement] = STATE(1251),
    [sym_break_statement] = STATE(1251),
    [sym_continue_statement] = STATE(1251),
    [sym_goto_statement] = STATE(1251),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2633),
    [sym_comment] = ACTIONS(41),
  },
  [1223] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3397),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1224] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1253),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3397),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1225] = {
    [sym_compound_statement] = STATE(1199),
    [sym_labeled_statement] = STATE(1199),
    [sym_expression_statement] = STATE(1199),
    [sym_if_statement] = STATE(1199),
    [sym_switch_statement] = STATE(1199),
    [sym_case_statement] = STATE(1199),
    [sym_while_statement] = STATE(1199),
    [sym_do_statement] = STATE(1199),
    [sym_for_statement] = STATE(1199),
    [sym_return_statement] = STATE(1199),
    [sym_break_statement] = STATE(1199),
    [sym_continue_statement] = STATE(1199),
    [sym_goto_statement] = STATE(1199),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [1226] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3399),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1227] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1255),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3399),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1228] = {
    [sym_compound_statement] = STATE(1154),
    [sym_labeled_statement] = STATE(1154),
    [sym_expression_statement] = STATE(1154),
    [sym_if_statement] = STATE(1154),
    [sym_switch_statement] = STATE(1154),
    [sym_case_statement] = STATE(1154),
    [sym_while_statement] = STATE(1154),
    [sym_do_statement] = STATE(1154),
    [sym_for_statement] = STATE(1154),
    [sym_return_statement] = STATE(1154),
    [sym_break_statement] = STATE(1154),
    [sym_continue_statement] = STATE(1154),
    [sym_goto_statement] = STATE(1154),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [1229] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3401),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1230] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1257),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3401),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1231] = {
    [sym__expression] = STATE(1258),
    [sym_conditional_expression] = STATE(1258),
    [sym_assignment_expression] = STATE(1258),
    [sym_pointer_expression] = STATE(1258),
    [sym_logical_expression] = STATE(1258),
    [sym_bitwise_expression] = STATE(1258),
    [sym_equality_expression] = STATE(1258),
    [sym_relational_expression] = STATE(1258),
    [sym_shift_expression] = STATE(1258),
    [sym_math_expression] = STATE(1258),
    [sym_cast_expression] = STATE(1258),
    [sym_sizeof_expression] = STATE(1258),
    [sym_subscript_expression] = STATE(1258),
    [sym_call_expression] = STATE(1258),
    [sym_field_expression] = STATE(1258),
    [sym_compound_literal_expression] = STATE(1258),
    [sym_parenthesized_expression] = STATE(1258),
    [sym_char_literal] = STATE(1258),
    [sym_concatenated_string] = STATE(1258),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3405),
    [sym_false] = ACTIONS(3405),
    [sym_null] = ACTIONS(3405),
    [sym_identifier] = ACTIONS(3405),
    [sym_comment] = ACTIONS(41),
  },
  [1232] = {
    [sym_compound_statement] = STATE(1234),
    [sym_labeled_statement] = STATE(1234),
    [sym_expression_statement] = STATE(1234),
    [sym_if_statement] = STATE(1234),
    [sym_switch_statement] = STATE(1234),
    [sym_case_statement] = STATE(1234),
    [sym_while_statement] = STATE(1234),
    [sym_do_statement] = STATE(1234),
    [sym_for_statement] = STATE(1234),
    [sym_return_statement] = STATE(1234),
    [sym_break_statement] = STATE(1234),
    [sym_continue_statement] = STATE(1234),
    [sym_goto_statement] = STATE(1234),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [1233] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1234] = {
    [anon_sym_LPAREN] = ACTIONS(3409),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_RBRACE] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(3409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_auto] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [sym_primitive_type] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_else] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3411),
    [sym_number_literal] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [sym_null] = ACTIONS(3411),
    [sym_identifier] = ACTIONS(3411),
    [sym_comment] = ACTIONS(41),
  },
  [1235] = {
    [sym_compound_statement] = STATE(1260),
    [sym_labeled_statement] = STATE(1260),
    [sym_expression_statement] = STATE(1260),
    [sym_if_statement] = STATE(1260),
    [sym_switch_statement] = STATE(1260),
    [sym_case_statement] = STATE(1260),
    [sym_while_statement] = STATE(1260),
    [sym_do_statement] = STATE(1260),
    [sym_for_statement] = STATE(1260),
    [sym_return_statement] = STATE(1260),
    [sym_break_statement] = STATE(1260),
    [sym_continue_statement] = STATE(1260),
    [sym_goto_statement] = STATE(1260),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(549),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_case] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(557),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1572),
    [sym_comment] = ACTIONS(41),
  },
  [1236] = {
    [ts_builtin_sym_end] = ACTIONS(3413),
    [anon_sym_tensor] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_indexvars] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_auto] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [sym_primitive_type] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [sym_identifier] = ACTIONS(3415),
    [sym_comment] = ACTIONS(41),
  },
  [1237] = {
    [anon_sym_RPAREN] = ACTIONS(3417),
    [sym_comment] = ACTIONS(41),
  },
  [1238] = {
    [anon_sym_RBRACE] = ACTIONS(3419),
    [sym_comment] = ACTIONS(41),
  },
  [1239] = {
    [sym_compound_statement] = STATE(1212),
    [sym_labeled_statement] = STATE(1212),
    [sym_expression_statement] = STATE(1212),
    [sym_if_statement] = STATE(1212),
    [sym_switch_statement] = STATE(1212),
    [sym_case_statement] = STATE(1212),
    [sym_while_statement] = STATE(1212),
    [sym_do_statement] = STATE(1212),
    [sym_for_statement] = STATE(1212),
    [sym_return_statement] = STATE(1212),
    [sym_break_statement] = STATE(1212),
    [sym_continue_statement] = STATE(1212),
    [sym_goto_statement] = STATE(1212),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
  [1240] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1264),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1241] = {
    [sym__expression] = STATE(1265),
    [sym_conditional_expression] = STATE(1265),
    [sym_assignment_expression] = STATE(1265),
    [sym_pointer_expression] = STATE(1265),
    [sym_logical_expression] = STATE(1265),
    [sym_bitwise_expression] = STATE(1265),
    [sym_equality_expression] = STATE(1265),
    [sym_relational_expression] = STATE(1265),
    [sym_shift_expression] = STATE(1265),
    [sym_math_expression] = STATE(1265),
    [sym_cast_expression] = STATE(1265),
    [sym_sizeof_expression] = STATE(1265),
    [sym_subscript_expression] = STATE(1265),
    [sym_call_expression] = STATE(1265),
    [sym_field_expression] = STATE(1265),
    [sym_compound_literal_expression] = STATE(1265),
    [sym_parenthesized_expression] = STATE(1265),
    [sym_char_literal] = STATE(1265),
    [sym_concatenated_string] = STATE(1265),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3425),
    [sym_false] = ACTIONS(3425),
    [sym_null] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(3425),
    [sym_comment] = ACTIONS(41),
  },
  [1242] = {
    [sym_argument_list] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1391),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1243] = {
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3295),
    [sym_preproc_directive] = ACTIONS(3295),
    [anon_sym_typedef] = ACTIONS(3295),
    [anon_sym_extern] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_auto] = ACTIONS(3295),
    [anon_sym_register] = ACTIONS(3295),
    [anon_sym_inline] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_restrict] = ACTIONS(3295),
    [anon_sym_volatile] = ACTIONS(3295),
    [anon_sym__Atomic] = ACTIONS(3295),
    [anon_sym_unsigned] = ACTIONS(3295),
    [anon_sym_long] = ACTIONS(3295),
    [anon_sym_short] = ACTIONS(3295),
    [sym_primitive_type] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [anon_sym_struct] = ACTIONS(3295),
    [anon_sym_union] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_case] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_goto] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_sizeof] = ACTIONS(3295),
    [sym_number_literal] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [sym_true] = ACTIONS(3295),
    [sym_false] = ACTIONS(3295),
    [sym_null] = ACTIONS(3295),
    [sym_identifier] = ACTIONS(3295),
    [sym_comment] = ACTIONS(41),
  },
  [1244] = {
    [sym_compound_statement] = STATE(1267),
    [sym_labeled_statement] = STATE(1267),
    [sym_expression_statement] = STATE(1267),
    [sym_if_statement] = STATE(1267),
    [sym_switch_statement] = STATE(1267),
    [sym_case_statement] = STATE(1267),
    [sym_while_statement] = STATE(1267),
    [sym_do_statement] = STATE(1267),
    [sym_for_statement] = STATE(1267),
    [sym_return_statement] = STATE(1267),
    [sym_break_statement] = STATE(1267),
    [sym_continue_statement] = STATE(1267),
    [sym_goto_statement] = STATE(1267),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2904),
    [sym_comment] = ACTIONS(41),
  },
  [1245] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3429),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1246] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1269),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3429),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1247] = {
    [sym_compound_statement] = STATE(1221),
    [sym_labeled_statement] = STATE(1221),
    [sym_expression_statement] = STATE(1221),
    [sym_if_statement] = STATE(1221),
    [sym_switch_statement] = STATE(1221),
    [sym_case_statement] = STATE(1221),
    [sym_while_statement] = STATE(1221),
    [sym_do_statement] = STATE(1221),
    [sym_for_statement] = STATE(1221),
    [sym_return_statement] = STATE(1221),
    [sym_break_statement] = STATE(1221),
    [sym_continue_statement] = STATE(1221),
    [sym_goto_statement] = STATE(1221),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [1248] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1249] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1271),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1250] = {
    [sym__expression] = STATE(1272),
    [sym_conditional_expression] = STATE(1272),
    [sym_assignment_expression] = STATE(1272),
    [sym_pointer_expression] = STATE(1272),
    [sym_logical_expression] = STATE(1272),
    [sym_bitwise_expression] = STATE(1272),
    [sym_equality_expression] = STATE(1272),
    [sym_relational_expression] = STATE(1272),
    [sym_shift_expression] = STATE(1272),
    [sym_math_expression] = STATE(1272),
    [sym_cast_expression] = STATE(1272),
    [sym_sizeof_expression] = STATE(1272),
    [sym_subscript_expression] = STATE(1272),
    [sym_call_expression] = STATE(1272),
    [sym_field_expression] = STATE(1272),
    [sym_compound_literal_expression] = STATE(1272),
    [sym_parenthesized_expression] = STATE(1272),
    [sym_char_literal] = STATE(1272),
    [sym_concatenated_string] = STATE(1272),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [sym_null] = ACTIONS(3435),
    [sym_identifier] = ACTIONS(3435),
    [sym_comment] = ACTIONS(41),
  },
  [1251] = {
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3361),
    [sym_preproc_directive] = ACTIONS(3361),
    [anon_sym_typedef] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_auto] = ACTIONS(3361),
    [anon_sym_register] = ACTIONS(3361),
    [anon_sym_inline] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_restrict] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym__Atomic] = ACTIONS(3361),
    [anon_sym_unsigned] = ACTIONS(3361),
    [anon_sym_long] = ACTIONS(3361),
    [anon_sym_short] = ACTIONS(3361),
    [sym_primitive_type] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_union] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3361),
    [sym_number_literal] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [sym_null] = ACTIONS(3361),
    [sym_identifier] = ACTIONS(3361),
    [sym_comment] = ACTIONS(41),
  },
  [1252] = {
    [sym_compound_statement] = STATE(1273),
    [sym_labeled_statement] = STATE(1273),
    [sym_expression_statement] = STATE(1273),
    [sym_if_statement] = STATE(1273),
    [sym_switch_statement] = STATE(1273),
    [sym_case_statement] = STATE(1273),
    [sym_while_statement] = STATE(1273),
    [sym_do_statement] = STATE(1273),
    [sym_for_statement] = STATE(1273),
    [sym_return_statement] = STATE(1273),
    [sym_break_statement] = STATE(1273),
    [sym_continue_statement] = STATE(1273),
    [sym_goto_statement] = STATE(1273),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2633),
    [sym_comment] = ACTIONS(41),
  },
  [1253] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3437),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1254] = {
    [sym_compound_statement] = STATE(1234),
    [sym_labeled_statement] = STATE(1234),
    [sym_expression_statement] = STATE(1234),
    [sym_if_statement] = STATE(1234),
    [sym_switch_statement] = STATE(1234),
    [sym_case_statement] = STATE(1234),
    [sym_while_statement] = STATE(1234),
    [sym_do_statement] = STATE(1234),
    [sym_for_statement] = STATE(1234),
    [sym_return_statement] = STATE(1234),
    [sym_break_statement] = STATE(1234),
    [sym_continue_statement] = STATE(1234),
    [sym_goto_statement] = STATE(1234),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [1255] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3439),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1256] = {
    [sym_compound_statement] = STATE(1199),
    [sym_labeled_statement] = STATE(1199),
    [sym_expression_statement] = STATE(1199),
    [sym_if_statement] = STATE(1199),
    [sym_switch_statement] = STATE(1199),
    [sym_case_statement] = STATE(1199),
    [sym_while_statement] = STATE(1199),
    [sym_do_statement] = STATE(1199),
    [sym_for_statement] = STATE(1199),
    [sym_return_statement] = STATE(1199),
    [sym_break_statement] = STATE(1199),
    [sym_continue_statement] = STATE(1199),
    [sym_goto_statement] = STATE(1199),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [1257] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3441),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1258] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1277),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3441),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1259] = {
    [sym_compound_statement] = STATE(1260),
    [sym_labeled_statement] = STATE(1260),
    [sym_expression_statement] = STATE(1260),
    [sym_if_statement] = STATE(1260),
    [sym_switch_statement] = STATE(1260),
    [sym_case_statement] = STATE(1260),
    [sym_while_statement] = STATE(1260),
    [sym_do_statement] = STATE(1260),
    [sym_for_statement] = STATE(1260),
    [sym_return_statement] = STATE(1260),
    [sym_break_statement] = STATE(1260),
    [sym_continue_statement] = STATE(1260),
    [sym_goto_statement] = STATE(1260),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1022),
    [sym_comment] = ACTIONS(41),
  },
  [1260] = {
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3445),
    [sym_preproc_directive] = ACTIONS(3445),
    [anon_sym_typedef] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_auto] = ACTIONS(3445),
    [anon_sym_register] = ACTIONS(3445),
    [anon_sym_inline] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_restrict] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym__Atomic] = ACTIONS(3445),
    [anon_sym_unsigned] = ACTIONS(3445),
    [anon_sym_long] = ACTIONS(3445),
    [anon_sym_short] = ACTIONS(3445),
    [sym_primitive_type] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_union] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_else] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_case] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_goto] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3445),
    [sym_number_literal] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [sym_null] = ACTIONS(3445),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(41),
  },
  [1261] = {
    [anon_sym_SEMI] = ACTIONS(3447),
    [sym_comment] = ACTIONS(41),
  },
  [1262] = {
    [anon_sym_RPAREN] = ACTIONS(3449),
    [sym_comment] = ACTIONS(41),
  },
  [1263] = {
    [sym_compound_statement] = STATE(1243),
    [sym_labeled_statement] = STATE(1243),
    [sym_expression_statement] = STATE(1243),
    [sym_if_statement] = STATE(1243),
    [sym_switch_statement] = STATE(1243),
    [sym_case_statement] = STATE(1243),
    [sym_while_statement] = STATE(1243),
    [sym_do_statement] = STATE(1243),
    [sym_for_statement] = STATE(1243),
    [sym_return_statement] = STATE(1243),
    [sym_break_statement] = STATE(1243),
    [sym_continue_statement] = STATE(1243),
    [sym_goto_statement] = STATE(1243),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
  [1264] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1265] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1281),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1266] = {
    [sym__expression] = STATE(1282),
    [sym_conditional_expression] = STATE(1282),
    [sym_assignment_expression] = STATE(1282),
    [sym_pointer_expression] = STATE(1282),
    [sym_logical_expression] = STATE(1282),
    [sym_bitwise_expression] = STATE(1282),
    [sym_equality_expression] = STATE(1282),
    [sym_relational_expression] = STATE(1282),
    [sym_shift_expression] = STATE(1282),
    [sym_math_expression] = STATE(1282),
    [sym_cast_expression] = STATE(1282),
    [sym_sizeof_expression] = STATE(1282),
    [sym_subscript_expression] = STATE(1282),
    [sym_call_expression] = STATE(1282),
    [sym_field_expression] = STATE(1282),
    [sym_compound_literal_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_char_literal] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string_literal] = STATE(401),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [sym_null] = ACTIONS(3455),
    [sym_identifier] = ACTIONS(3455),
    [sym_comment] = ACTIONS(41),
  },
  [1267] = {
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3361),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3361),
    [sym_preproc_directive] = ACTIONS(3361),
    [anon_sym_typedef] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_auto] = ACTIONS(3361),
    [anon_sym_register] = ACTIONS(3361),
    [anon_sym_inline] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_restrict] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym__Atomic] = ACTIONS(3361),
    [anon_sym_unsigned] = ACTIONS(3361),
    [anon_sym_long] = ACTIONS(3361),
    [anon_sym_short] = ACTIONS(3361),
    [sym_primitive_type] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_union] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym_AMP] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_sizeof] = ACTIONS(3361),
    [sym_number_literal] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [sym_null] = ACTIONS(3361),
    [sym_identifier] = ACTIONS(3361),
    [sym_comment] = ACTIONS(41),
  },
  [1268] = {
    [sym_compound_statement] = STATE(1283),
    [sym_labeled_statement] = STATE(1283),
    [sym_expression_statement] = STATE(1283),
    [sym_if_statement] = STATE(1283),
    [sym_switch_statement] = STATE(1283),
    [sym_case_statement] = STATE(1283),
    [sym_while_statement] = STATE(1283),
    [sym_do_statement] = STATE(1283),
    [sym_for_statement] = STATE(1283),
    [sym_return_statement] = STATE(1283),
    [sym_break_statement] = STATE(1283),
    [sym_continue_statement] = STATE(1283),
    [sym_goto_statement] = STATE(1283),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2904),
    [sym_comment] = ACTIONS(41),
  },
  [1269] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1270] = {
    [sym_compound_statement] = STATE(1251),
    [sym_labeled_statement] = STATE(1251),
    [sym_expression_statement] = STATE(1251),
    [sym_if_statement] = STATE(1251),
    [sym_switch_statement] = STATE(1251),
    [sym_case_statement] = STATE(1251),
    [sym_while_statement] = STATE(1251),
    [sym_do_statement] = STATE(1251),
    [sym_for_statement] = STATE(1251),
    [sym_return_statement] = STATE(1251),
    [sym_break_statement] = STATE(1251),
    [sym_continue_statement] = STATE(1251),
    [sym_goto_statement] = STATE(1251),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [1271] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1272] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1286),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1273] = {
    [anon_sym_LPAREN] = ACTIONS(3409),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(3409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_auto] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [sym_primitive_type] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_else] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3411),
    [sym_number_literal] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [sym_null] = ACTIONS(3411),
    [sym_identifier] = ACTIONS(3411),
    [sym_comment] = ACTIONS(41),
  },
  [1274] = {
    [sym_compound_statement] = STATE(1287),
    [sym_labeled_statement] = STATE(1287),
    [sym_expression_statement] = STATE(1287),
    [sym_if_statement] = STATE(1287),
    [sym_switch_statement] = STATE(1287),
    [sym_case_statement] = STATE(1287),
    [sym_while_statement] = STATE(1287),
    [sym_do_statement] = STATE(1287),
    [sym_for_statement] = STATE(1287),
    [sym_return_statement] = STATE(1287),
    [sym_break_statement] = STATE(1287),
    [sym_continue_statement] = STATE(1287),
    [sym_goto_statement] = STATE(1287),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2633),
    [sym_comment] = ACTIONS(41),
  },
  [1275] = {
    [sym_compound_statement] = STATE(1260),
    [sym_labeled_statement] = STATE(1260),
    [sym_expression_statement] = STATE(1260),
    [sym_if_statement] = STATE(1260),
    [sym_switch_statement] = STATE(1260),
    [sym_case_statement] = STATE(1260),
    [sym_while_statement] = STATE(1260),
    [sym_do_statement] = STATE(1260),
    [sym_for_statement] = STATE(1260),
    [sym_return_statement] = STATE(1260),
    [sym_break_statement] = STATE(1260),
    [sym_continue_statement] = STATE(1260),
    [sym_goto_statement] = STATE(1260),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1566),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(41),
  },
  [1276] = {
    [sym_compound_statement] = STATE(1234),
    [sym_labeled_statement] = STATE(1234),
    [sym_expression_statement] = STATE(1234),
    [sym_if_statement] = STATE(1234),
    [sym_switch_statement] = STATE(1234),
    [sym_case_statement] = STATE(1234),
    [sym_while_statement] = STATE(1234),
    [sym_do_statement] = STATE(1234),
    [sym_for_statement] = STATE(1234),
    [sym_return_statement] = STATE(1234),
    [sym_break_statement] = STATE(1234),
    [sym_continue_statement] = STATE(1234),
    [sym_goto_statement] = STATE(1234),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [1277] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1278] = {
    [anon_sym_tensor] = ACTIONS(3415),
    [anon_sym_indexvars] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_auto] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [sym_primitive_type] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [sym_identifier] = ACTIONS(3415),
    [sym_comment] = ACTIONS(41),
  },
  [1279] = {
    [anon_sym_SEMI] = ACTIONS(3463),
    [sym_comment] = ACTIONS(41),
  },
  [1280] = {
    [sym_compound_statement] = STATE(1267),
    [sym_labeled_statement] = STATE(1267),
    [sym_expression_statement] = STATE(1267),
    [sym_if_statement] = STATE(1267),
    [sym_switch_statement] = STATE(1267),
    [sym_case_statement] = STATE(1267),
    [sym_while_statement] = STATE(1267),
    [sym_do_statement] = STATE(1267),
    [sym_for_statement] = STATE(1267),
    [sym_return_statement] = STATE(1267),
    [sym_break_statement] = STATE(1267),
    [sym_continue_statement] = STATE(1267),
    [sym_goto_statement] = STATE(1267),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
  [1281] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3465),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1282] = {
    [sym_argument_list] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(1291),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(3465),
    [anon_sym_COMMA] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_DASH_GT] = ACTIONS(1116),
    [sym_comment] = ACTIONS(41),
  },
  [1283] = {
    [anon_sym_LPAREN] = ACTIONS(3409),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(3409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_auto] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [sym_primitive_type] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_else] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3411),
    [sym_number_literal] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [sym_null] = ACTIONS(3411),
    [sym_identifier] = ACTIONS(3411),
    [sym_comment] = ACTIONS(41),
  },
  [1284] = {
    [sym_compound_statement] = STATE(1292),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2904),
    [sym_comment] = ACTIONS(41),
  },
  [1285] = {
    [sym_compound_statement] = STATE(1273),
    [sym_labeled_statement] = STATE(1273),
    [sym_expression_statement] = STATE(1273),
    [sym_if_statement] = STATE(1273),
    [sym_switch_statement] = STATE(1273),
    [sym_case_statement] = STATE(1273),
    [sym_while_statement] = STATE(1273),
    [sym_do_statement] = STATE(1273),
    [sym_for_statement] = STATE(1273),
    [sym_return_statement] = STATE(1273),
    [sym_break_statement] = STATE(1273),
    [sym_continue_statement] = STATE(1273),
    [sym_goto_statement] = STATE(1273),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [1286] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3467),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1287] = {
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3445),
    [sym_preproc_directive] = ACTIONS(3445),
    [anon_sym_typedef] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_auto] = ACTIONS(3445),
    [anon_sym_register] = ACTIONS(3445),
    [anon_sym_inline] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_restrict] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym__Atomic] = ACTIONS(3445),
    [anon_sym_unsigned] = ACTIONS(3445),
    [anon_sym_long] = ACTIONS(3445),
    [anon_sym_short] = ACTIONS(3445),
    [sym_primitive_type] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_union] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_else] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_case] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_goto] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3445),
    [sym_number_literal] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [sym_null] = ACTIONS(3445),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(41),
  },
  [1288] = {
    [sym_compound_statement] = STATE(1260),
    [sym_labeled_statement] = STATE(1260),
    [sym_expression_statement] = STATE(1260),
    [sym_if_statement] = STATE(1260),
    [sym_switch_statement] = STATE(1260),
    [sym_case_statement] = STATE(1260),
    [sym_while_statement] = STATE(1260),
    [sym_do_statement] = STATE(1260),
    [sym_for_statement] = STATE(1260),
    [sym_return_statement] = STATE(1260),
    [sym_break_statement] = STATE(1260),
    [sym_continue_statement] = STATE(1260),
    [sym_goto_statement] = STATE(1260),
    [sym__expression] = STATE(247),
    [sym_comma_expression] = STATE(248),
    [sym_conditional_expression] = STATE(247),
    [sym_assignment_expression] = STATE(247),
    [sym_pointer_expression] = STATE(247),
    [sym_logical_expression] = STATE(247),
    [sym_bitwise_expression] = STATE(247),
    [sym_equality_expression] = STATE(247),
    [sym_relational_expression] = STATE(247),
    [sym_shift_expression] = STATE(247),
    [sym_math_expression] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_sizeof_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_call_expression] = STATE(247),
    [sym_field_expression] = STATE(247),
    [sym_compound_literal_expression] = STATE(247),
    [sym_parenthesized_expression] = STATE(247),
    [sym_char_literal] = STATE(247),
    [sym_concatenated_string] = STATE(247),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(565),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_identifier] = ACTIONS(2392),
    [sym_comment] = ACTIONS(41),
  },
  [1289] = {
    [anon_sym_tensor] = ACTIONS(3415),
    [anon_sym_indexvars] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3415),
    [sym_preproc_directive] = ACTIONS(3415),
    [anon_sym_typedef] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_auto] = ACTIONS(3415),
    [anon_sym_register] = ACTIONS(3415),
    [anon_sym_inline] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_restrict] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym__Atomic] = ACTIONS(3415),
    [anon_sym_unsigned] = ACTIONS(3415),
    [anon_sym_long] = ACTIONS(3415),
    [anon_sym_short] = ACTIONS(3415),
    [sym_primitive_type] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_union] = ACTIONS(3415),
    [sym_identifier] = ACTIONS(3415),
    [sym_comment] = ACTIONS(41),
  },
  [1290] = {
    [sym_compound_statement] = STATE(1283),
    [sym_labeled_statement] = STATE(1283),
    [sym_expression_statement] = STATE(1283),
    [sym_if_statement] = STATE(1283),
    [sym_switch_statement] = STATE(1283),
    [sym_case_statement] = STATE(1283),
    [sym_while_statement] = STATE(1283),
    [sym_do_statement] = STATE(1283),
    [sym_for_statement] = STATE(1283),
    [sym_return_statement] = STATE(1283),
    [sym_break_statement] = STATE(1283),
    [sym_continue_statement] = STATE(1283),
    [sym_goto_statement] = STATE(1283),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
  [1291] = {
    [aux_sym_for_statement_repeat1] = STATE(1028),
    [anon_sym_RPAREN] = ACTIONS(3469),
    [anon_sym_COMMA] = ACTIONS(2438),
    [sym_comment] = ACTIONS(41),
  },
  [1292] = {
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3443),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3445),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3445),
    [sym_preproc_directive] = ACTIONS(3445),
    [anon_sym_typedef] = ACTIONS(3445),
    [anon_sym_extern] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_auto] = ACTIONS(3445),
    [anon_sym_register] = ACTIONS(3445),
    [anon_sym_inline] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_restrict] = ACTIONS(3445),
    [anon_sym_volatile] = ACTIONS(3445),
    [anon_sym__Atomic] = ACTIONS(3445),
    [anon_sym_unsigned] = ACTIONS(3445),
    [anon_sym_long] = ACTIONS(3445),
    [anon_sym_short] = ACTIONS(3445),
    [sym_primitive_type] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [anon_sym_struct] = ACTIONS(3445),
    [anon_sym_union] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_else] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_case] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_goto] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3445),
    [sym_number_literal] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [sym_null] = ACTIONS(3445),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(41),
  },
  [1293] = {
    [sym_compound_statement] = STATE(1287),
    [sym_labeled_statement] = STATE(1287),
    [sym_expression_statement] = STATE(1287),
    [sym_if_statement] = STATE(1287),
    [sym_switch_statement] = STATE(1287),
    [sym_case_statement] = STATE(1287),
    [sym_while_statement] = STATE(1287),
    [sym_do_statement] = STATE(1287),
    [sym_for_statement] = STATE(1287),
    [sym_return_statement] = STATE(1287),
    [sym_break_statement] = STATE(1287),
    [sym_continue_statement] = STATE(1287),
    [sym_goto_statement] = STATE(1287),
    [sym__expression] = STATE(648),
    [sym_comma_expression] = STATE(649),
    [sym_conditional_expression] = STATE(648),
    [sym_assignment_expression] = STATE(648),
    [sym_pointer_expression] = STATE(648),
    [sym_logical_expression] = STATE(648),
    [sym_bitwise_expression] = STATE(648),
    [sym_equality_expression] = STATE(648),
    [sym_relational_expression] = STATE(648),
    [sym_shift_expression] = STATE(648),
    [sym_math_expression] = STATE(648),
    [sym_cast_expression] = STATE(648),
    [sym_sizeof_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_field_expression] = STATE(648),
    [sym_compound_literal_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_char_literal] = STATE(648),
    [sym_concatenated_string] = STATE(648),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_goto] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(2631),
    [sym_comment] = ACTIONS(41),
  },
  [1294] = {
    [sym_compound_statement] = STATE(1292),
    [sym_labeled_statement] = STATE(1292),
    [sym_expression_statement] = STATE(1292),
    [sym_if_statement] = STATE(1292),
    [sym_switch_statement] = STATE(1292),
    [sym_case_statement] = STATE(1292),
    [sym_while_statement] = STATE(1292),
    [sym_do_statement] = STATE(1292),
    [sym_for_statement] = STATE(1292),
    [sym_return_statement] = STATE(1292),
    [sym_break_statement] = STATE(1292),
    [sym_continue_statement] = STATE(1292),
    [sym_goto_statement] = STATE(1292),
    [sym__expression] = STATE(850),
    [sym_comma_expression] = STATE(851),
    [sym_conditional_expression] = STATE(850),
    [sym_assignment_expression] = STATE(850),
    [sym_pointer_expression] = STATE(850),
    [sym_logical_expression] = STATE(850),
    [sym_bitwise_expression] = STATE(850),
    [sym_equality_expression] = STATE(850),
    [sym_relational_expression] = STATE(850),
    [sym_shift_expression] = STATE(850),
    [sym_math_expression] = STATE(850),
    [sym_cast_expression] = STATE(850),
    [sym_sizeof_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_call_expression] = STATE(850),
    [sym_field_expression] = STATE(850),
    [sym_compound_literal_expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_char_literal] = STATE(850),
    [sym_concatenated_string] = STATE(850),
    [sym_string_literal] = STATE(249),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_sizeof] = ACTIONS(579),
    [sym_number_literal] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(47),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2902),
    [sym_comment] = ACTIONS(41),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_translation_unit, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(2),
  [9] = {.count = 1, .reusable = false}, SHIFT(3),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = false}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = false}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = false}, SHIFT(11),
  [27] = {.count = 1, .reusable = false}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(22),
  [31] = {.count = 1, .reusable = false}, SHIFT(19),
  [33] = {.count = 1, .reusable = false}, SHIFT(13),
  [35] = {.count = 1, .reusable = false}, SHIFT(14),
  [37] = {.count = 1, .reusable = false}, SHIFT(15),
  [39] = {.count = 1, .reusable = false}, SHIFT(16),
  [41] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [43] = {.count = 1, .reusable = true}, SHIFT(23),
  [45] = {.count = 1, .reusable = true}, SHIFT(24),
  [47] = {.count = 1, .reusable = true}, SHIFT(26),
  [49] = {.count = 1, .reusable = true}, SHIFT(27),
  [51] = {.count = 1, .reusable = true}, SHIFT(28),
  [53] = {.count = 1, .reusable = false}, SHIFT(29),
  [55] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [57] = {.count = 1, .reusable = true}, SHIFT(30),
  [59] = {.count = 1, .reusable = false}, SHIFT(31),
  [61] = {.count = 1, .reusable = false}, SHIFT(32),
  [63] = {.count = 1, .reusable = false}, SHIFT(35),
  [65] = {.count = 1, .reusable = false}, SHIFT(33),
  [67] = {.count = 1, .reusable = false}, REDUCE(sym_storage_class_specifier, 1),
  [69] = {.count = 1, .reusable = true}, REDUCE(sym_storage_class_specifier, 1),
  [71] = {.count = 1, .reusable = true}, REDUCE(sym_type_qualifier, 1),
  [73] = {.count = 1, .reusable = false}, REDUCE(sym_type_qualifier, 1),
  [75] = {.count = 1, .reusable = true}, SHIFT(37),
  [77] = {.count = 1, .reusable = true}, SHIFT(38),
  [79] = {.count = 1, .reusable = true}, SHIFT(40),
  [81] = {.count = 1, .reusable = true}, SHIFT(41),
  [83] = {.count = 1, .reusable = true}, SHIFT(43),
  [85] = {.count = 2, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), SHIFT(45),
  [88] = {.count = 1, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [90] = {.count = 1, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [92] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [94] = {.count = 1, .reusable = true}, SHIFT(46),
  [96] = {.count = 1, .reusable = true}, SHIFT(47),
  [98] = {.count = 1, .reusable = true}, SHIFT(48),
  [100] = {.count = 1, .reusable = true}, SHIFT(49),
  [102] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 1),
  [104] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 1),
  [106] = {.count = 1, .reusable = true}, REDUCE(sym_translation_unit, 1),
  [108] = {.count = 1, .reusable = false}, SHIFT(53),
  [110] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 1),
  [112] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 1),
  [114] = {.count = 1, .reusable = false}, SHIFT(57),
  [116] = {.count = 1, .reusable = false}, SHIFT(55),
  [118] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(56),
  [121] = {.count = 1, .reusable = true}, SHIFT(58),
  [123] = {.count = 1, .reusable = true}, REDUCE(sym_ta_name_list, 1),
  [125] = {.count = 1, .reusable = true}, SHIFT(59),
  [127] = {.count = 1, .reusable = true}, SHIFT(60),
  [129] = {.count = 1, .reusable = false}, SHIFT(61),
  [131] = {.count = 1, .reusable = true}, SHIFT(62),
  [133] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_include, 2),
  [135] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_include, 2),
  [137] = {.count = 1, .reusable = false}, SHIFT(63),
  [139] = {.count = 1, .reusable = true}, SHIFT(64),
  [141] = {.count = 1, .reusable = false}, SHIFT(65),
  [143] = {.count = 1, .reusable = false}, SHIFT(67),
  [145] = {.count = 1, .reusable = false}, SHIFT(68),
  [147] = {.count = 1, .reusable = false}, SHIFT(69),
  [149] = {.count = 1, .reusable = false}, SHIFT(70),
  [151] = {.count = 1, .reusable = false}, SHIFT(71),
  [153] = {.count = 1, .reusable = false}, SHIFT(72),
  [155] = {.count = 1, .reusable = false}, SHIFT(73),
  [157] = {.count = 1, .reusable = false}, SHIFT(74),
  [159] = {.count = 1, .reusable = false}, SHIFT(75),
  [161] = {.count = 1, .reusable = false}, SHIFT(76),
  [163] = {.count = 1, .reusable = false}, SHIFT(77),
  [165] = {.count = 1, .reusable = false}, SHIFT(78),
  [167] = {.count = 1, .reusable = false}, SHIFT(82),
  [169] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_call, 2),
  [171] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_call, 2),
  [173] = {.count = 1, .reusable = true}, SHIFT(85),
  [175] = {.count = 1, .reusable = true}, SHIFT(86),
  [177] = {.count = 1, .reusable = true}, SHIFT(87),
  [179] = {.count = 1, .reusable = true}, SHIFT(88),
  [181] = {.count = 1, .reusable = false}, SHIFT(90),
  [183] = {.count = 1, .reusable = false}, SHIFT(92),
  [185] = {.count = 1, .reusable = true}, SHIFT(93),
  [187] = {.count = 1, .reusable = false}, SHIFT(98),
  [189] = {.count = 1, .reusable = false}, SHIFT(96),
  [191] = {.count = 1, .reusable = true}, SHIFT(99),
  [193] = {.count = 1, .reusable = true}, SHIFT(100),
  [195] = {.count = 1, .reusable = true}, SHIFT(101),
  [197] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 2, .alias_sequence_id = 2),
  [199] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 2, .alias_sequence_id = 2),
  [201] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 2),
  [203] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 2),
  [205] = {.count = 1, .reusable = true}, SHIFT(104),
  [207] = {.count = 1, .reusable = false}, SHIFT(105),
  [209] = {.count = 1, .reusable = true}, SHIFT(106),
  [211] = {.count = 1, .reusable = false}, SHIFT(111),
  [213] = {.count = 1, .reusable = false}, SHIFT(108),
  [215] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 2, .alias_sequence_id = 2),
  [217] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 2, .alias_sequence_id = 2),
  [219] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 2),
  [221] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 2),
  [223] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 2, .alias_sequence_id = 2),
  [225] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 2, .alias_sequence_id = 2),
  [227] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 2),
  [229] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 2),
  [231] = {.count = 1, .reusable = false}, SHIFT(117),
  [233] = {.count = 1, .reusable = false}, SHIFT(114),
  [235] = {.count = 1, .reusable = true}, SHIFT(118),
  [237] = {.count = 1, .reusable = true}, SHIFT(119),
  [239] = {.count = 1, .reusable = true}, REDUCE(sym__empty_declaration, 2),
  [241] = {.count = 1, .reusable = false}, REDUCE(sym__empty_declaration, 2),
  [243] = {.count = 1, .reusable = false}, SHIFT(120),
  [245] = {.count = 1, .reusable = true}, SHIFT(122),
  [247] = {.count = 1, .reusable = true}, SHIFT(123),
  [249] = {.count = 1, .reusable = true}, SHIFT(124),
  [251] = {.count = 1, .reusable = true}, SHIFT(125),
  [253] = {.count = 1, .reusable = true}, SHIFT(126),
  [255] = {.count = 1, .reusable = true}, SHIFT(127),
  [257] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 2),
  [259] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 2),
  [261] = {.count = 1, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [263] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2),
  [266] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3),
  [269] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(4),
  [272] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5),
  [275] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(6),
  [278] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7),
  [281] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8),
  [284] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9),
  [287] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(10),
  [290] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(11),
  [293] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(12),
  [296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(22),
  [299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(19),
  [302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(13),
  [305] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(14),
  [308] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(15),
  [311] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(16),
  [314] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(11),
  [317] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(12),
  [320] = {.count = 1, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [322] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 2),
  [324] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 2),
  [326] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .alias_sequence_id = 2),
  [328] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .alias_sequence_id = 2),
  [330] = {.count = 1, .reusable = true}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [332] = {.count = 1, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(57),
  [337] = {.count = 1, .reusable = true}, SHIFT(133),
  [339] = {.count = 1, .reusable = true}, REDUCE(sym_ta_top_level, 3),
  [341] = {.count = 1, .reusable = false}, REDUCE(sym_ta_top_level, 3),
  [343] = {.count = 1, .reusable = true}, REDUCE(sym_string_literal, 2),
  [345] = {.count = 1, .reusable = false}, REDUCE(sym_string_literal, 2),
  [347] = {.count = 1, .reusable = false}, SHIFT(135),
  [349] = {.count = 1, .reusable = true}, SHIFT(136),
  [351] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_def, 3),
  [353] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_def, 3),
  [355] = {.count = 1, .reusable = true}, SHIFT(137),
  [357] = {.count = 1, .reusable = true}, SHIFT(138),
  [359] = {.count = 1, .reusable = true}, SHIFT(139),
  [361] = {.count = 1, .reusable = false}, SHIFT(140),
  [363] = {.count = 1, .reusable = false}, SHIFT(141),
  [365] = {.count = 1, .reusable = true}, SHIFT(142),
  [367] = {.count = 1, .reusable = true}, SHIFT(144),
  [369] = {.count = 1, .reusable = true}, SHIFT(145),
  [371] = {.count = 1, .reusable = true}, SHIFT(146),
  [373] = {.count = 1, .reusable = false}, SHIFT(147),
  [375] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 3),
  [377] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 3),
  [379] = {.count = 1, .reusable = true}, SHIFT(148),
  [381] = {.count = 1, .reusable = false}, SHIFT(149),
  [383] = {.count = 1, .reusable = false}, SHIFT(150),
  [385] = {.count = 1, .reusable = false}, SHIFT(151),
  [387] = {.count = 1, .reusable = false}, SHIFT(152),
  [389] = {.count = 1, .reusable = false}, SHIFT(153),
  [391] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else, 1),
  [393] = {.count = 1, .reusable = false}, SHIFT(154),
  [395] = {.count = 1, .reusable = false}, SHIFT(155),
  [397] = {.count = 1, .reusable = false}, SHIFT(156),
  [399] = {.count = 1, .reusable = false}, SHIFT(157),
  [401] = {.count = 1, .reusable = false}, SHIFT(160),
  [403] = {.count = 1, .reusable = false}, SHIFT(161),
  [405] = {.count = 1, .reusable = false}, SHIFT(162),
  [407] = {.count = 1, .reusable = false}, SHIFT(163),
  [409] = {.count = 1, .reusable = true}, SHIFT(166),
  [411] = {.count = 1, .reusable = true}, SHIFT(167),
  [413] = {.count = 1, .reusable = true}, SHIFT(168),
  [415] = {.count = 1, .reusable = false}, SHIFT(166),
  [417] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 3),
  [419] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 3),
  [421] = {.count = 1, .reusable = true}, SHIFT(172),
  [423] = {.count = 1, .reusable = false}, SHIFT(172),
  [425] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_call, 3),
  [427] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_call, 3),
  [429] = {.count = 1, .reusable = true}, SHIFT(174),
  [431] = {.count = 1, .reusable = false}, SHIFT(88),
  [433] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 1),
  [435] = {.count = 1, .reusable = true}, SHIFT(178),
  [437] = {.count = 1, .reusable = true}, SHIFT(179),
  [439] = {.count = 2, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(12),
  [442] = {.count = 1, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [444] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(92),
  [447] = {.count = 1, .reusable = true}, SHIFT(182),
  [449] = {.count = 1, .reusable = true}, REDUCE(sym_linkage_specification, 3),
  [451] = {.count = 1, .reusable = false}, REDUCE(sym_linkage_specification, 3),
  [453] = {.count = 1, .reusable = false}, SHIFT(185),
  [455] = {.count = 1, .reusable = false}, SHIFT(186),
  [457] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 2),
  [459] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 2),
  [461] = {.count = 1, .reusable = true}, SHIFT(187),
  [463] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator, 1),
  [465] = {.count = 1, .reusable = true}, SHIFT(188),
  [467] = {.count = 1, .reusable = true}, SHIFT(189),
  [469] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 3, .alias_sequence_id = 2),
  [471] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 3, .alias_sequence_id = 2),
  [473] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 2),
  [475] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 2),
  [477] = {.count = 1, .reusable = false}, SHIFT(191),
  [479] = {.count = 1, .reusable = true}, SHIFT(192),
  [481] = {.count = 1, .reusable = true}, SHIFT(193),
  [483] = {.count = 1, .reusable = true}, SHIFT(194),
  [485] = {.count = 1, .reusable = true}, SHIFT(195),
  [487] = {.count = 1, .reusable = true}, SHIFT(196),
  [489] = {.count = 1, .reusable = true}, SHIFT(197),
  [491] = {.count = 1, .reusable = true}, SHIFT(200),
  [493] = {.count = 1, .reusable = false}, SHIFT(202),
  [495] = {.count = 1, .reusable = false}, SHIFT(203),
  [497] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 3, .alias_sequence_id = 2),
  [499] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 3, .alias_sequence_id = 2),
  [501] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 3, .alias_sequence_id = 2),
  [503] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 3, .alias_sequence_id = 2),
  [505] = {.count = 1, .reusable = true}, SHIFT(204),
  [507] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 1),
  [509] = {.count = 1, .reusable = true}, SHIFT(205),
  [511] = {.count = 1, .reusable = true}, SHIFT(206),
  [513] = {.count = 1, .reusable = true}, SHIFT(209),
  [515] = {.count = 1, .reusable = false}, SHIFT(210),
  [517] = {.count = 1, .reusable = false}, SHIFT(211),
  [519] = {.count = 1, .reusable = false}, SHIFT(56),
  [521] = {.count = 1, .reusable = true}, SHIFT(213),
  [523] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_declarator, 2, .dynamic_precedence = 1),
  [525] = {.count = 1, .reusable = false}, SHIFT(214),
  [527] = {.count = 1, .reusable = true}, SHIFT(216),
  [529] = {.count = 1, .reusable = true}, SHIFT(217),
  [531] = {.count = 1, .reusable = false}, SHIFT(221),
  [533] = {.count = 1, .reusable = false}, SHIFT(219),
  [535] = {.count = 1, .reusable = true}, SHIFT(222),
  [537] = {.count = 1, .reusable = true}, SHIFT(223),
  [539] = {.count = 1, .reusable = true}, SHIFT(224),
  [541] = {.count = 1, .reusable = false}, SHIFT(225),
  [543] = {.count = 1, .reusable = false}, SHIFT(226),
  [545] = {.count = 1, .reusable = false}, SHIFT(227),
  [547] = {.count = 1, .reusable = true}, SHIFT(228),
  [549] = {.count = 1, .reusable = false}, SHIFT(229),
  [551] = {.count = 1, .reusable = false}, SHIFT(230),
  [553] = {.count = 1, .reusable = false}, SHIFT(231),
  [555] = {.count = 1, .reusable = false}, SHIFT(232),
  [557] = {.count = 1, .reusable = false}, SHIFT(233),
  [559] = {.count = 1, .reusable = false}, SHIFT(234),
  [561] = {.count = 1, .reusable = false}, SHIFT(235),
  [563] = {.count = 1, .reusable = false}, SHIFT(236),
  [565] = {.count = 1, .reusable = false}, SHIFT(237),
  [567] = {.count = 1, .reusable = false}, SHIFT(238),
  [569] = {.count = 1, .reusable = false}, SHIFT(239),
  [571] = {.count = 1, .reusable = true}, SHIFT(240),
  [573] = {.count = 1, .reusable = true}, SHIFT(241),
  [575] = {.count = 1, .reusable = false}, SHIFT(242),
  [577] = {.count = 1, .reusable = true}, SHIFT(242),
  [579] = {.count = 1, .reusable = false}, SHIFT(243),
  [581] = {.count = 1, .reusable = true}, SHIFT(247),
  [583] = {.count = 1, .reusable = true}, SHIFT(244),
  [585] = {.count = 1, .reusable = false}, SHIFT(247),
  [587] = {.count = 1, .reusable = false}, SHIFT(245),
  [589] = {.count = 1, .reusable = true}, REDUCE(sym_declaration, 3),
  [591] = {.count = 1, .reusable = false}, REDUCE(sym_declaration, 3),
  [593] = {.count = 1, .reusable = true}, SHIFT(251),
  [595] = {.count = 1, .reusable = true}, SHIFT(252),
  [597] = {.count = 1, .reusable = true}, SHIFT(254),
  [599] = {.count = 1, .reusable = true}, SHIFT(255),
  [601] = {.count = 1, .reusable = true}, SHIFT(256),
  [603] = {.count = 1, .reusable = false}, SHIFT(267),
  [605] = {.count = 1, .reusable = false}, SHIFT(263),
  [607] = {.count = 1, .reusable = true}, SHIFT(257),
  [609] = {.count = 1, .reusable = true}, SHIFT(258),
  [611] = {.count = 1, .reusable = false}, SHIFT(259),
  [613] = {.count = 1, .reusable = true}, SHIFT(259),
  [615] = {.count = 1, .reusable = false}, SHIFT(260),
  [617] = {.count = 1, .reusable = true}, SHIFT(264),
  [619] = {.count = 1, .reusable = false}, SHIFT(264),
  [621] = {.count = 1, .reusable = false}, SHIFT(261),
  [623] = {.count = 1, .reusable = true}, SHIFT(268),
  [625] = {.count = 1, .reusable = true}, SHIFT(269),
  [627] = {.count = 1, .reusable = false}, SHIFT(269),
  [629] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [631] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [633] = {.count = 1, .reusable = true}, REDUCE(sym_function_declarator, 2),
  [635] = {.count = 1, .reusable = true}, SHIFT(271),
  [637] = {.count = 1, .reusable = true}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [639] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 3),
  [641] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 3),
  [643] = {.count = 1, .reusable = true}, SHIFT(273),
  [645] = {.count = 1, .reusable = true}, REDUCE(sym_ta_name_list, 3),
  [647] = {.count = 1, .reusable = true}, REDUCE(sym_string_literal, 3),
  [649] = {.count = 1, .reusable = false}, REDUCE(sym_string_literal, 3),
  [651] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [653] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(136),
  [656] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 2),
  [658] = {.count = 1, .reusable = true}, SHIFT(274),
  [660] = {.count = 1, .reusable = true}, SHIFT(275),
  [662] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_def, 4),
  [664] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_def, 4),
  [666] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_function_def, 4),
  [668] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_function_def, 4),
  [670] = {.count = 1, .reusable = true}, SHIFT(277),
  [672] = {.count = 1, .reusable = true}, SHIFT(278),
  [674] = {.count = 1, .reusable = true}, SHIFT(279),
  [676] = {.count = 1, .reusable = false}, SHIFT(280),
  [678] = {.count = 1, .reusable = true}, SHIFT(281),
  [680] = {.count = 1, .reusable = false}, SHIFT(282),
  [682] = {.count = 1, .reusable = false}, SHIFT(283),
  [684] = {.count = 1, .reusable = false}, SHIFT(285),
  [686] = {.count = 1, .reusable = false}, SHIFT(288),
  [688] = {.count = 1, .reusable = true}, SHIFT(291),
  [690] = {.count = 1, .reusable = true}, SHIFT(293),
  [692] = {.count = 1, .reusable = true}, SHIFT(294),
  [694] = {.count = 1, .reusable = true}, SHIFT(295),
  [696] = {.count = 1, .reusable = false}, SHIFT(296),
  [698] = {.count = 1, .reusable = true}, SHIFT(297),
  [700] = {.count = 1, .reusable = false}, SHIFT(298),
  [702] = {.count = 1, .reusable = false}, SHIFT(299),
  [704] = {.count = 1, .reusable = false}, SHIFT(300),
  [706] = {.count = 1, .reusable = true}, SHIFT(303),
  [708] = {.count = 1, .reusable = true}, SHIFT(304),
  [710] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else, 2),
  [712] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif, 2),
  [714] = {.count = 1, .reusable = true}, SHIFT(309),
  [716] = {.count = 1, .reusable = false}, SHIFT(311),
  [718] = {.count = 1, .reusable = true}, SHIFT(312),
  [720] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 4),
  [722] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 4),
  [724] = {.count = 1, .reusable = true}, SHIFT(315),
  [726] = {.count = 1, .reusable = true}, SHIFT(316),
  [728] = {.count = 1, .reusable = true}, SHIFT(319),
  [730] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(67),
  [733] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(68),
  [736] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(69),
  [739] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(70),
  [742] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(71),
  [745] = {.count = 1, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [747] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(73),
  [750] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(76),
  [753] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(77),
  [756] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(78),
  [759] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 4),
  [761] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 4),
  [763] = {.count = 1, .reusable = true}, SHIFT(320),
  [765] = {.count = 1, .reusable = true}, SHIFT(322),
  [767] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_type_declarator, 2, .dynamic_precedence = 1),
  [769] = {.count = 1, .reusable = true}, REDUCE(sym_type_definition, 4),
  [771] = {.count = 1, .reusable = false}, REDUCE(sym_type_definition, 4),
  [773] = {.count = 1, .reusable = true}, SHIFT(324),
  [775] = {.count = 1, .reusable = true}, SHIFT(326),
  [777] = {.count = 1, .reusable = false}, SHIFT(326),
  [779] = {.count = 1, .reusable = true}, REDUCE(sym_function_type_declarator, 2),
  [781] = {.count = 1, .reusable = true}, SHIFT(327),
  [783] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 2),
  [785] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 2),
  [787] = {.count = 1, .reusable = true}, SHIFT(328),
  [789] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(186),
  [792] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 3),
  [794] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 3),
  [796] = {.count = 1, .reusable = true}, SHIFT(332),
  [798] = {.count = 1, .reusable = true}, SHIFT(333),
  [800] = {.count = 1, .reusable = true}, SHIFT(334),
  [802] = {.count = 1, .reusable = true}, SHIFT(335),
  [804] = {.count = 1, .reusable = false}, SHIFT(336),
  [806] = {.count = 1, .reusable = true}, SHIFT(336),
  [808] = {.count = 1, .reusable = false}, SHIFT(337),
  [810] = {.count = 1, .reusable = true}, SHIFT(338),
  [812] = {.count = 1, .reusable = false}, SHIFT(338),
  [814] = {.count = 1, .reusable = true}, SHIFT(340),
  [816] = {.count = 1, .reusable = true}, SHIFT(342),
  [818] = {.count = 1, .reusable = true}, SHIFT(344),
  [820] = {.count = 1, .reusable = true}, SHIFT(345),
  [822] = {.count = 1, .reusable = true}, SHIFT(346),
  [824] = {.count = 1, .reusable = true}, SHIFT(349),
  [826] = {.count = 1, .reusable = true}, SHIFT(352),
  [828] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 2),
  [830] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 2),
  [832] = {.count = 1, .reusable = false}, SHIFT(197),
  [834] = {.count = 1, .reusable = true}, SHIFT(356),
  [836] = {.count = 1, .reusable = true}, SHIFT(357),
  [838] = {.count = 1, .reusable = true}, SHIFT(358),
  [840] = {.count = 1, .reusable = true}, SHIFT(359),
  [842] = {.count = 1, .reusable = false}, SHIFT(360),
  [844] = {.count = 1, .reusable = true}, SHIFT(360),
  [846] = {.count = 1, .reusable = false}, SHIFT(361),
  [848] = {.count = 1, .reusable = true}, SHIFT(362),
  [850] = {.count = 1, .reusable = false}, SHIFT(362),
  [852] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 3),
  [854] = {.count = 1, .reusable = true}, SHIFT(364),
  [856] = {.count = 1, .reusable = true}, SHIFT(365),
  [858] = {.count = 1, .reusable = true}, SHIFT(366),
  [860] = {.count = 1, .reusable = true}, SHIFT(367),
  [862] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 3),
  [864] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 3),
  [866] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [868] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(105),
  [871] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(106),
  [874] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(11),
  [877] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(12),
  [880] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(111),
  [883] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(108),
  [886] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(13),
  [889] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(14),
  [892] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(15),
  [895] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(16),
  [898] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(203),
  [901] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 1, .dynamic_precedence = 1),
  [903] = {.count = 1, .reusable = true}, SHIFT(12),
  [905] = {.count = 1, .reusable = true}, SHIFT(375),
  [907] = {.count = 1, .reusable = true}, SHIFT(377),
  [909] = {.count = 1, .reusable = false}, SHIFT(377),
  [911] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 2),
  [913] = {.count = 1, .reusable = true}, SHIFT(378),
  [915] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 1),
  [917] = {.count = 1, .reusable = true}, REDUCE(sym_macro_type_specifier, 4, .dynamic_precedence = -1),
  [919] = {.count = 1, .reusable = false}, REDUCE(sym_macro_type_specifier, 4, .dynamic_precedence = -1),
  [921] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(211),
  [924] = {.count = 1, .reusable = true}, REDUCE(sym__declarator, 3, .dynamic_precedence = -10),
  [926] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_declarator, 3, .dynamic_precedence = 1),
  [928] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [930] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 2),
  [932] = {.count = 1, .reusable = true}, SHIFT(381),
  [934] = {.count = 1, .reusable = true}, SHIFT(382),
  [936] = {.count = 1, .reusable = true}, SHIFT(384),
  [938] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_declaration, 1),
  [940] = {.count = 1, .reusable = true}, SHIFT(385),
  [942] = {.count = 1, .reusable = true}, SHIFT(386),
  [944] = {.count = 1, .reusable = false}, SHIFT(389),
  [946] = {.count = 1, .reusable = false}, SHIFT(390),
  [948] = {.count = 1, .reusable = true}, SHIFT(391),
  [950] = {.count = 1, .reusable = true}, SHIFT(392),
  [952] = {.count = 1, .reusable = true}, SHIFT(393),
  [954] = {.count = 1, .reusable = true}, SHIFT(394),
  [956] = {.count = 1, .reusable = false}, SHIFT(395),
  [958] = {.count = 1, .reusable = true}, SHIFT(395),
  [960] = {.count = 1, .reusable = false}, SHIFT(396),
  [962] = {.count = 1, .reusable = true}, SHIFT(398),
  [964] = {.count = 1, .reusable = false}, SHIFT(398),
  [966] = {.count = 1, .reusable = false}, SHIFT(397),
  [968] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [970] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [972] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 1),
  [974] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 1),
  [976] = {.count = 1, .reusable = true}, SHIFT(402),
  [978] = {.count = 1, .reusable = false}, SHIFT(403),
  [980] = {.count = 1, .reusable = true}, SHIFT(404),
  [982] = {.count = 1, .reusable = true}, SHIFT(405),
  [984] = {.count = 1, .reusable = false}, SHIFT(405),
  [986] = {.count = 1, .reusable = true}, SHIFT(406),
  [988] = {.count = 1, .reusable = true}, SHIFT(409),
  [990] = {.count = 1, .reusable = true}, SHIFT(410),
  [992] = {.count = 1, .reusable = true}, SHIFT(411),
  [994] = {.count = 1, .reusable = true}, SHIFT(412),
  [996] = {.count = 1, .reusable = false}, SHIFT(413),
  [998] = {.count = 1, .reusable = true}, SHIFT(413),
  [1000] = {.count = 1, .reusable = false}, SHIFT(414),
  [1002] = {.count = 1, .reusable = true}, SHIFT(415),
  [1004] = {.count = 1, .reusable = false}, SHIFT(415),
  [1006] = {.count = 1, .reusable = true}, SHIFT(417),
  [1008] = {.count = 1, .reusable = false}, SHIFT(419),
  [1010] = {.count = 1, .reusable = false}, SHIFT(420),
  [1012] = {.count = 1, .reusable = false}, SHIFT(421),
  [1014] = {.count = 1, .reusable = false}, SHIFT(422),
  [1016] = {.count = 1, .reusable = false}, SHIFT(423),
  [1018] = {.count = 1, .reusable = false}, SHIFT(424),
  [1020] = {.count = 1, .reusable = false}, SHIFT(425),
  [1022] = {.count = 1, .reusable = false}, SHIFT(426),
  [1024] = {.count = 1, .reusable = true}, SHIFT(428),
  [1026] = {.count = 1, .reusable = true}, SHIFT(429),
  [1028] = {.count = 1, .reusable = true}, SHIFT(430),
  [1030] = {.count = 1, .reusable = false}, SHIFT(430),
  [1032] = {.count = 1, .reusable = true}, SHIFT(431),
  [1034] = {.count = 1, .reusable = true}, SHIFT(432),
  [1036] = {.count = 1, .reusable = true}, SHIFT(433),
  [1038] = {.count = 1, .reusable = true}, SHIFT(434),
  [1040] = {.count = 1, .reusable = false}, SHIFT(434),
  [1042] = {.count = 1, .reusable = true}, SHIFT(435),
  [1044] = {.count = 1, .reusable = false}, SHIFT(435),
  [1046] = {.count = 1, .reusable = true}, SHIFT(436),
  [1048] = {.count = 1, .reusable = false}, SHIFT(436),
  [1050] = {.count = 1, .reusable = true}, SHIFT(437),
  [1052] = {.count = 1, .reusable = true}, SHIFT(438),
  [1054] = {.count = 1, .reusable = false}, SHIFT(438),
  [1056] = {.count = 1, .reusable = false}, SHIFT(439),
  [1058] = {.count = 1, .reusable = true}, SHIFT(439),
  [1060] = {.count = 3, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1), SHIFT(45),
  [1064] = {.count = 2, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [1067] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1069] = {.count = 2, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [1072] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1074] = {.count = 1, .reusable = true}, SHIFT(440),
  [1076] = {.count = 1, .reusable = true}, SHIFT(441),
  [1078] = {.count = 1, .reusable = true}, SHIFT(442),
  [1080] = {.count = 1, .reusable = true}, SHIFT(443),
  [1082] = {.count = 1, .reusable = true}, SHIFT(444),
  [1084] = {.count = 1, .reusable = false}, SHIFT(445),
  [1086] = {.count = 1, .reusable = true}, SHIFT(446),
  [1088] = {.count = 1, .reusable = false}, SHIFT(447),
  [1090] = {.count = 1, .reusable = true}, SHIFT(448),
  [1092] = {.count = 1, .reusable = true}, SHIFT(447),
  [1094] = {.count = 1, .reusable = false}, SHIFT(449),
  [1096] = {.count = 1, .reusable = true}, SHIFT(450),
  [1098] = {.count = 1, .reusable = true}, SHIFT(451),
  [1100] = {.count = 1, .reusable = false}, SHIFT(452),
  [1102] = {.count = 1, .reusable = false}, SHIFT(453),
  [1104] = {.count = 1, .reusable = true}, SHIFT(454),
  [1106] = {.count = 1, .reusable = false}, SHIFT(455),
  [1108] = {.count = 1, .reusable = true}, SHIFT(455),
  [1110] = {.count = 1, .reusable = false}, SHIFT(456),
  [1112] = {.count = 1, .reusable = false}, SHIFT(457),
  [1114] = {.count = 1, .reusable = true}, SHIFT(458),
  [1116] = {.count = 1, .reusable = true}, SHIFT(459),
  [1118] = {.count = 1, .reusable = true}, SHIFT(462),
  [1120] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_repeat1, 2),
  [1122] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 3),
  [1124] = {.count = 1, .reusable = true}, SHIFT(466),
  [1126] = {.count = 1, .reusable = true}, SHIFT(467),
  [1128] = {.count = 1, .reusable = false}, SHIFT(467),
  [1130] = {.count = 1, .reusable = true}, SHIFT(468),
  [1132] = {.count = 1, .reusable = true}, SHIFT(469),
  [1134] = {.count = 1, .reusable = false}, SHIFT(469),
  [1136] = {.count = 1, .reusable = false}, SHIFT(471),
  [1138] = {.count = 1, .reusable = false}, SHIFT(472),
  [1140] = {.count = 1, .reusable = true}, SHIFT(473),
  [1142] = {.count = 1, .reusable = true}, SHIFT(472),
  [1144] = {.count = 1, .reusable = false}, SHIFT(474),
  [1146] = {.count = 1, .reusable = true}, SHIFT(475),
  [1148] = {.count = 1, .reusable = true}, SHIFT(476),
  [1150] = {.count = 1, .reusable = false}, SHIFT(477),
  [1152] = {.count = 1, .reusable = false}, SHIFT(478),
  [1154] = {.count = 1, .reusable = true}, SHIFT(479),
  [1156] = {.count = 1, .reusable = false}, SHIFT(480),
  [1158] = {.count = 1, .reusable = true}, SHIFT(480),
  [1160] = {.count = 1, .reusable = false}, SHIFT(481),
  [1162] = {.count = 1, .reusable = false}, SHIFT(482),
  [1164] = {.count = 1, .reusable = false}, SHIFT(484),
  [1166] = {.count = 1, .reusable = false}, SHIFT(485),
  [1168] = {.count = 1, .reusable = true}, SHIFT(486),
  [1170] = {.count = 1, .reusable = true}, SHIFT(487),
  [1172] = {.count = 1, .reusable = true}, SHIFT(488),
  [1174] = {.count = 1, .reusable = true}, SHIFT(489),
  [1176] = {.count = 1, .reusable = true}, SHIFT(490),
  [1178] = {.count = 1, .reusable = false}, SHIFT(490),
  [1180] = {.count = 1, .reusable = true}, REDUCE(sym_init_declarator, 3),
  [1182] = {.count = 1, .reusable = true}, REDUCE(sym_declaration, 4),
  [1184] = {.count = 1, .reusable = false}, REDUCE(sym_declaration, 4),
  [1186] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_repeat1, 2), SHIFT_REPEAT(125),
  [1189] = {.count = 1, .reusable = true}, SHIFT(493),
  [1191] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 3),
  [1193] = {.count = 1, .reusable = true}, SHIFT(496),
  [1195] = {.count = 1, .reusable = true}, SHIFT(497),
  [1197] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_function_def, 5),
  [1199] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_function_def, 5),
  [1201] = {.count = 1, .reusable = true}, SHIFT(499),
  [1203] = {.count = 1, .reusable = false}, SHIFT(500),
  [1205] = {.count = 1, .reusable = true}, SHIFT(501),
  [1207] = {.count = 1, .reusable = false}, SHIFT(502),
  [1209] = {.count = 1, .reusable = false}, SHIFT(503),
  [1211] = {.count = 1, .reusable = true}, SHIFT(504),
  [1213] = {.count = 1, .reusable = false}, SHIFT(504),
  [1215] = {.count = 1, .reusable = true}, SHIFT(506),
  [1217] = {.count = 1, .reusable = false}, SHIFT(506),
  [1219] = {.count = 1, .reusable = true}, SHIFT(508),
  [1221] = {.count = 1, .reusable = true}, SHIFT(509),
  [1223] = {.count = 1, .reusable = false}, SHIFT(510),
  [1225] = {.count = 1, .reusable = true}, SHIFT(511),
  [1227] = {.count = 1, .reusable = false}, SHIFT(512),
  [1229] = {.count = 1, .reusable = false}, SHIFT(513),
  [1231] = {.count = 1, .reusable = false}, SHIFT(515),
  [1233] = {.count = 1, .reusable = false}, SHIFT(518),
  [1235] = {.count = 1, .reusable = true}, SHIFT(521),
  [1237] = {.count = 1, .reusable = false}, SHIFT(523),
  [1239] = {.count = 1, .reusable = true}, SHIFT(524),
  [1241] = {.count = 1, .reusable = true}, SHIFT(527),
  [1243] = {.count = 1, .reusable = true}, SHIFT(528),
  [1245] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(149),
  [1248] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(150),
  [1251] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(151),
  [1254] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(152),
  [1257] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(153),
  [1260] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(154),
  [1263] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(155),
  [1266] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(156),
  [1269] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(157),
  [1272] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif, 3),
  [1274] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif, 3),
  [1276] = {.count = 1, .reusable = true}, SHIFT(532),
  [1278] = {.count = 1, .reusable = true}, SHIFT(534),
  [1280] = {.count = 1, .reusable = true}, SHIFT(536),
  [1282] = {.count = 1, .reusable = true}, SHIFT(538),
  [1284] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 5),
  [1286] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 5),
  [1288] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 5),
  [1290] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 5),
  [1292] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 3, .dynamic_precedence = -10),
  [1294] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_type_declarator, 3, .dynamic_precedence = 1),
  [1296] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 3),
  [1298] = {.count = 1, .reusable = true}, SHIFT(539),
  [1300] = {.count = 1, .reusable = true}, SHIFT(540),
  [1302] = {.count = 1, .reusable = false}, SHIFT(540),
  [1304] = {.count = 1, .reusable = true}, REDUCE(sym_type_definition, 5),
  [1306] = {.count = 1, .reusable = false}, REDUCE(sym_type_definition, 5),
  [1308] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 3),
  [1310] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 3),
  [1312] = {.count = 1, .reusable = true}, SHIFT(542),
  [1314] = {.count = 1, .reusable = true}, SHIFT(543),
  [1316] = {.count = 1, .reusable = false}, SHIFT(543),
  [1318] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator, 3),
  [1320] = {.count = 1, .reusable = false}, SHIFT(544),
  [1322] = {.count = 1, .reusable = false}, SHIFT(545),
  [1324] = {.count = 1, .reusable = true}, SHIFT(546),
  [1326] = {.count = 1, .reusable = true}, SHIFT(545),
  [1328] = {.count = 1, .reusable = false}, SHIFT(547),
  [1330] = {.count = 1, .reusable = true}, SHIFT(548),
  [1332] = {.count = 1, .reusable = true}, SHIFT(549),
  [1334] = {.count = 1, .reusable = false}, SHIFT(550),
  [1336] = {.count = 1, .reusable = false}, SHIFT(551),
  [1338] = {.count = 1, .reusable = true}, SHIFT(552),
  [1340] = {.count = 1, .reusable = false}, SHIFT(553),
  [1342] = {.count = 1, .reusable = true}, SHIFT(553),
  [1344] = {.count = 1, .reusable = false}, SHIFT(554),
  [1346] = {.count = 1, .reusable = false}, SHIFT(555),
  [1348] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 4),
  [1350] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 4),
  [1352] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [1354] = {.count = 1, .reusable = true}, SHIFT(557),
  [1356] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(558),
  [1359] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 3),
  [1361] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 3),
  [1363] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_else_in_field_declaration_list, 1),
  [1365] = {.count = 1, .reusable = false}, SHIFT(560),
  [1367] = {.count = 1, .reusable = true}, SHIFT(561),
  [1369] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3),
  [1371] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3),
  [1373] = {.count = 1, .reusable = true}, SHIFT(564),
  [1375] = {.count = 1, .reusable = true}, SHIFT(567),
  [1377] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_field_declarator, 2, .dynamic_precedence = 1),
  [1379] = {.count = 1, .reusable = true}, SHIFT(570),
  [1381] = {.count = 1, .reusable = true}, SHIFT(571),
  [1383] = {.count = 1, .reusable = false}, SHIFT(571),
  [1385] = {.count = 1, .reusable = true}, SHIFT(572),
  [1387] = {.count = 1, .reusable = false}, SHIFT(573),
  [1389] = {.count = 1, .reusable = false}, SHIFT(574),
  [1391] = {.count = 1, .reusable = true}, SHIFT(575),
  [1393] = {.count = 1, .reusable = true}, SHIFT(574),
  [1395] = {.count = 1, .reusable = false}, SHIFT(576),
  [1397] = {.count = 1, .reusable = true}, SHIFT(577),
  [1399] = {.count = 1, .reusable = true}, SHIFT(578),
  [1401] = {.count = 1, .reusable = false}, SHIFT(579),
  [1403] = {.count = 1, .reusable = false}, SHIFT(580),
  [1405] = {.count = 1, .reusable = true}, SHIFT(581),
  [1407] = {.count = 1, .reusable = false}, SHIFT(582),
  [1409] = {.count = 1, .reusable = true}, SHIFT(582),
  [1411] = {.count = 1, .reusable = false}, SHIFT(583),
  [1413] = {.count = 1, .reusable = false}, SHIFT(584),
  [1415] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 3),
  [1417] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 3),
  [1419] = {.count = 1, .reusable = true}, SHIFT(587),
  [1421] = {.count = 1, .reusable = true}, SHIFT(589),
  [1423] = {.count = 1, .reusable = false}, SHIFT(589),
  [1425] = {.count = 1, .reusable = true}, SHIFT(590),
  [1427] = {.count = 1, .reusable = false}, SHIFT(590),
  [1429] = {.count = 1, .reusable = true}, REDUCE(sym_function_field_declarator, 2),
  [1431] = {.count = 1, .reusable = true}, SHIFT(591),
  [1433] = {.count = 1, .reusable = true}, SHIFT(593),
  [1435] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1),
  [1437] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 2),
  [1439] = {.count = 1, .reusable = true}, SHIFT(596),
  [1441] = {.count = 1, .reusable = true}, SHIFT(597),
  [1443] = {.count = 1, .reusable = false}, SHIFT(597),
  [1445] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 2),
  [1447] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 3),
  [1449] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 3),
  [1451] = {.count = 1, .reusable = true}, SHIFT(599),
  [1453] = {.count = 1, .reusable = true}, SHIFT(600),
  [1455] = {.count = 1, .reusable = true}, SHIFT(602),
  [1457] = {.count = 1, .reusable = false}, SHIFT(603),
  [1459] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_declaration, 2),
  [1461] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(390),
  [1464] = {.count = 1, .reusable = true}, SHIFT(608),
  [1466] = {.count = 1, .reusable = true}, SHIFT(609),
  [1468] = {.count = 1, .reusable = false}, SHIFT(609),
  [1470] = {.count = 1, .reusable = true}, SHIFT(610),
  [1472] = {.count = 1, .reusable = true}, SHIFT(611),
  [1474] = {.count = 1, .reusable = false}, SHIFT(612),
  [1476] = {.count = 1, .reusable = false}, SHIFT(613),
  [1478] = {.count = 1, .reusable = true}, SHIFT(614),
  [1480] = {.count = 1, .reusable = true}, SHIFT(613),
  [1482] = {.count = 1, .reusable = false}, SHIFT(615),
  [1484] = {.count = 1, .reusable = true}, SHIFT(616),
  [1486] = {.count = 1, .reusable = true}, SHIFT(617),
  [1488] = {.count = 1, .reusable = false}, SHIFT(618),
  [1490] = {.count = 1, .reusable = false}, SHIFT(619),
  [1492] = {.count = 1, .reusable = true}, SHIFT(620),
  [1494] = {.count = 1, .reusable = false}, SHIFT(621),
  [1496] = {.count = 1, .reusable = true}, SHIFT(621),
  [1498] = {.count = 1, .reusable = false}, SHIFT(622),
  [1500] = {.count = 1, .reusable = false}, SHIFT(623),
  [1502] = {.count = 1, .reusable = true}, SHIFT(624),
  [1504] = {.count = 1, .reusable = false}, SHIFT(626),
  [1506] = {.count = 1, .reusable = true}, SHIFT(627),
  [1508] = {.count = 1, .reusable = true}, SHIFT(628),
  [1510] = {.count = 1, .reusable = false}, SHIFT(629),
  [1512] = {.count = 1, .reusable = false}, SHIFT(630),
  [1514] = {.count = 1, .reusable = false}, SHIFT(631),
  [1516] = {.count = 1, .reusable = false}, SHIFT(632),
  [1518] = {.count = 1, .reusable = false}, SHIFT(633),
  [1520] = {.count = 1, .reusable = false}, SHIFT(634),
  [1522] = {.count = 1, .reusable = false}, SHIFT(635),
  [1524] = {.count = 1, .reusable = false}, SHIFT(636),
  [1526] = {.count = 1, .reusable = false}, SHIFT(637),
  [1528] = {.count = 1, .reusable = false}, SHIFT(638),
  [1530] = {.count = 1, .reusable = false}, SHIFT(639),
  [1532] = {.count = 1, .reusable = false}, SHIFT(640),
  [1534] = {.count = 1, .reusable = false}, SHIFT(641),
  [1536] = {.count = 1, .reusable = false}, SHIFT(642),
  [1538] = {.count = 1, .reusable = false}, SHIFT(643),
  [1540] = {.count = 1, .reusable = false}, SHIFT(644),
  [1542] = {.count = 1, .reusable = true}, SHIFT(648),
  [1544] = {.count = 1, .reusable = false}, SHIFT(648),
  [1546] = {.count = 1, .reusable = false}, SHIFT(645),
  [1548] = {.count = 1, .reusable = false}, SHIFT(651),
  [1550] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_expression, 2),
  [1552] = {.count = 1, .reusable = false}, REDUCE(sym_pointer_expression, 2),
  [1554] = {.count = 1, .reusable = true}, SHIFT(654),
  [1556] = {.count = 1, .reusable = false}, SHIFT(654),
  [1558] = {.count = 1, .reusable = false}, SHIFT(656),
  [1560] = {.count = 1, .reusable = false}, SHIFT(657),
  [1562] = {.count = 1, .reusable = false}, SHIFT(658),
  [1564] = {.count = 1, .reusable = false}, SHIFT(659),
  [1566] = {.count = 1, .reusable = false}, SHIFT(660),
  [1568] = {.count = 1, .reusable = false}, SHIFT(661),
  [1570] = {.count = 1, .reusable = false}, SHIFT(662),
  [1572] = {.count = 1, .reusable = false}, SHIFT(664),
  [1574] = {.count = 1, .reusable = true}, SHIFT(667),
  [1576] = {.count = 1, .reusable = true}, SHIFT(668),
  [1578] = {.count = 1, .reusable = false}, SHIFT(668),
  [1580] = {.count = 1, .reusable = false}, SHIFT(669),
  [1582] = {.count = 1, .reusable = false}, SHIFT(670),
  [1584] = {.count = 1, .reusable = true}, SHIFT(671),
  [1586] = {.count = 1, .reusable = true}, SHIFT(672),
  [1588] = {.count = 1, .reusable = true}, SHIFT(670),
  [1590] = {.count = 1, .reusable = false}, SHIFT(673),
  [1592] = {.count = 1, .reusable = true}, SHIFT(674),
  [1594] = {.count = 1, .reusable = true}, SHIFT(675),
  [1596] = {.count = 1, .reusable = false}, SHIFT(676),
  [1598] = {.count = 1, .reusable = false}, SHIFT(677),
  [1600] = {.count = 1, .reusable = true}, SHIFT(678),
  [1602] = {.count = 1, .reusable = false}, SHIFT(679),
  [1604] = {.count = 1, .reusable = true}, SHIFT(679),
  [1606] = {.count = 1, .reusable = false}, SHIFT(680),
  [1608] = {.count = 1, .reusable = false}, SHIFT(681),
  [1610] = {.count = 1, .reusable = false}, SHIFT(683),
  [1612] = {.count = 1, .reusable = true}, SHIFT(689),
  [1614] = {.count = 1, .reusable = false}, SHIFT(689),
  [1616] = {.count = 1, .reusable = true}, SHIFT(690),
  [1618] = {.count = 1, .reusable = true}, SHIFT(693),
  [1620] = {.count = 1, .reusable = true}, SHIFT(694),
  [1622] = {.count = 1, .reusable = true}, SHIFT(695),
  [1624] = {.count = 1, .reusable = true}, SHIFT(696),
  [1626] = {.count = 1, .reusable = true}, SHIFT(698),
  [1628] = {.count = 1, .reusable = false}, SHIFT(698),
  [1630] = {.count = 1, .reusable = false}, SHIFT(697),
  [1632] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [1634] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [1636] = {.count = 1, .reusable = true}, SHIFT(699),
  [1638] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [1640] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [1642] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [1644] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [1646] = {.count = 1, .reusable = true}, SHIFT(700),
  [1648] = {.count = 1, .reusable = true}, REDUCE(sym_logical_expression, 2),
  [1650] = {.count = 1, .reusable = false}, REDUCE(sym_logical_expression, 2),
  [1652] = {.count = 1, .reusable = true}, REDUCE(sym_bitwise_expression, 2),
  [1654] = {.count = 1, .reusable = false}, REDUCE(sym_bitwise_expression, 2),
  [1656] = {.count = 1, .reusable = true}, REDUCE(sym_math_expression, 2),
  [1658] = {.count = 1, .reusable = false}, REDUCE(sym_math_expression, 2),
  [1660] = {.count = 1, .reusable = true}, REDUCE(sym_sizeof_expression, 2),
  [1662] = {.count = 1, .reusable = false}, REDUCE(sym_sizeof_expression, 2),
  [1664] = {.count = 1, .reusable = true}, SHIFT(702),
  [1666] = {.count = 1, .reusable = true}, SHIFT(704),
  [1668] = {.count = 1, .reusable = true}, SHIFT(705),
  [1670] = {.count = 1, .reusable = false}, SHIFT(705),
  [1672] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [1674] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [1676] = {.count = 1, .reusable = true}, SHIFT(706),
  [1678] = {.count = 1, .reusable = false}, SHIFT(706),
  [1680] = {.count = 1, .reusable = true}, SHIFT(708),
  [1682] = {.count = 1, .reusable = false}, SHIFT(708),
  [1684] = {.count = 1, .reusable = true}, SHIFT(709),
  [1686] = {.count = 1, .reusable = false}, SHIFT(709),
  [1688] = {.count = 1, .reusable = true}, SHIFT(710),
  [1690] = {.count = 1, .reusable = false}, SHIFT(710),
  [1692] = {.count = 1, .reusable = true}, SHIFT(711),
  [1694] = {.count = 1, .reusable = false}, SHIFT(711),
  [1696] = {.count = 1, .reusable = true}, SHIFT(712),
  [1698] = {.count = 1, .reusable = false}, SHIFT(712),
  [1700] = {.count = 1, .reusable = true}, SHIFT(713),
  [1702] = {.count = 1, .reusable = false}, SHIFT(713),
  [1704] = {.count = 1, .reusable = true}, SHIFT(714),
  [1706] = {.count = 1, .reusable = false}, SHIFT(714),
  [1708] = {.count = 1, .reusable = true}, SHIFT(715),
  [1710] = {.count = 1, .reusable = false}, SHIFT(715),
  [1712] = {.count = 1, .reusable = true}, SHIFT(716),
  [1714] = {.count = 1, .reusable = false}, SHIFT(716),
  [1716] = {.count = 1, .reusable = true}, SHIFT(717),
  [1718] = {.count = 1, .reusable = false}, SHIFT(717),
  [1720] = {.count = 1, .reusable = true}, SHIFT(718),
  [1722] = {.count = 1, .reusable = false}, SHIFT(718),
  [1724] = {.count = 1, .reusable = true}, SHIFT(719),
  [1726] = {.count = 1, .reusable = false}, SHIFT(719),
  [1728] = {.count = 1, .reusable = true}, SHIFT(720),
  [1730] = {.count = 1, .reusable = false}, SHIFT(720),
  [1732] = {.count = 1, .reusable = true}, SHIFT(721),
  [1734] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2),
  [1736] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2),
  [1738] = {.count = 1, .reusable = true}, REDUCE(sym_concatenated_string, 2),
  [1740] = {.count = 1, .reusable = false}, REDUCE(sym_concatenated_string, 2),
  [1742] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [1744] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [1746] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(222),
  [1749] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(123),
  [1752] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2),
  [1754] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(224),
  [1757] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(225),
  [1760] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(5),
  [1763] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(226),
  [1766] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(227),
  [1769] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(8),
  [1772] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(9),
  [1775] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(11),
  [1778] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(228),
  [1781] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(12),
  [1784] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(22),
  [1787] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(19),
  [1790] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(13),
  [1793] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(14),
  [1796] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(15),
  [1799] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(229),
  [1802] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(230),
  [1805] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(231),
  [1808] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(232),
  [1811] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(233),
  [1814] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(234),
  [1817] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(235),
  [1820] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(236),
  [1823] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(237),
  [1826] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(238),
  [1829] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(239),
  [1832] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(240),
  [1835] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(241),
  [1838] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(242),
  [1841] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(242),
  [1844] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(243),
  [1847] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(247),
  [1850] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(244),
  [1853] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(26),
  [1856] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(247),
  [1859] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(245),
  [1862] = {.count = 1, .reusable = true}, SHIFT(723),
  [1864] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 4),
  [1866] = {.count = 1, .reusable = true}, SHIFT(725),
  [1868] = {.count = 1, .reusable = true}, SHIFT(727),
  [1870] = {.count = 1, .reusable = false}, SHIFT(727),
  [1872] = {.count = 1, .reusable = true}, SHIFT(728),
  [1874] = {.count = 1, .reusable = false}, SHIFT(728),
  [1876] = {.count = 1, .reusable = true}, SHIFT(729),
  [1878] = {.count = 1, .reusable = false}, SHIFT(729),
  [1880] = {.count = 1, .reusable = true}, SHIFT(730),
  [1882] = {.count = 1, .reusable = false}, SHIFT(730),
  [1884] = {.count = 1, .reusable = true}, SHIFT(731),
  [1886] = {.count = 1, .reusable = false}, SHIFT(731),
  [1888] = {.count = 1, .reusable = true}, SHIFT(732),
  [1890] = {.count = 1, .reusable = false}, SHIFT(732),
  [1892] = {.count = 1, .reusable = true}, SHIFT(733),
  [1894] = {.count = 1, .reusable = false}, SHIFT(733),
  [1896] = {.count = 1, .reusable = true}, SHIFT(734),
  [1898] = {.count = 1, .reusable = false}, SHIFT(734),
  [1900] = {.count = 1, .reusable = true}, SHIFT(735),
  [1902] = {.count = 1, .reusable = false}, SHIFT(735),
  [1904] = {.count = 1, .reusable = true}, SHIFT(736),
  [1906] = {.count = 1, .reusable = false}, SHIFT(736),
  [1908] = {.count = 1, .reusable = true}, SHIFT(737),
  [1910] = {.count = 1, .reusable = false}, SHIFT(737),
  [1912] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(485),
  [1915] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 2),
  [1917] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 2),
  [1919] = {.count = 1, .reusable = true}, SHIFT(740),
  [1921] = {.count = 1, .reusable = true}, SHIFT(741),
  [1923] = {.count = 1, .reusable = false}, SHIFT(741),
  [1925] = {.count = 1, .reusable = true}, SHIFT(742),
  [1927] = {.count = 1, .reusable = true}, SHIFT(743),
  [1929] = {.count = 1, .reusable = true}, SHIFT(745),
  [1931] = {.count = 1, .reusable = true}, REDUCE(sym_ta_specifier_list_specifier, 1),
  [1933] = {.count = 1, .reusable = true}, SHIFT(747),
  [1935] = {.count = 1, .reusable = true}, REDUCE(sym_ta_specifier_list, 1),
  [1937] = {.count = 1, .reusable = true}, SHIFT(748),
  [1939] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_params_repeat1, 2),
  [1941] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 4),
  [1943] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_params_repeat1, 2), SHIFT_REPEAT(275),
  [1946] = {.count = 1, .reusable = true}, SHIFT(749),
  [1948] = {.count = 1, .reusable = true}, SHIFT(750),
  [1950] = {.count = 1, .reusable = true}, SHIFT(751),
  [1952] = {.count = 1, .reusable = true}, SHIFT(752),
  [1954] = {.count = 1, .reusable = true}, SHIFT(753),
  [1956] = {.count = 1, .reusable = false}, SHIFT(754),
  [1958] = {.count = 1, .reusable = true}, SHIFT(755),
  [1960] = {.count = 1, .reusable = false}, SHIFT(756),
  [1962] = {.count = 1, .reusable = false}, SHIFT(757),
  [1964] = {.count = 1, .reusable = true}, SHIFT(758),
  [1966] = {.count = 1, .reusable = false}, SHIFT(758),
  [1968] = {.count = 1, .reusable = true}, SHIFT(760),
  [1970] = {.count = 1, .reusable = false}, SHIFT(760),
  [1972] = {.count = 1, .reusable = true}, SHIFT(762),
  [1974] = {.count = 1, .reusable = true}, SHIFT(764),
  [1976] = {.count = 1, .reusable = true}, SHIFT(766),
  [1978] = {.count = 1, .reusable = true}, SHIFT(768),
  [1980] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif, 4),
  [1982] = {.count = 1, .reusable = true}, SHIFT(769),
  [1984] = {.count = 1, .reusable = true}, SHIFT(770),
  [1986] = {.count = 1, .reusable = true}, SHIFT(771),
  [1988] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 4),
  [1990] = {.count = 1, .reusable = true}, SHIFT(772),
  [1992] = {.count = 1, .reusable = true}, SHIFT(773),
  [1994] = {.count = 1, .reusable = true}, SHIFT(775),
  [1996] = {.count = 1, .reusable = false}, SHIFT(775),
  [1998] = {.count = 1, .reusable = true}, SHIFT(776),
  [2000] = {.count = 1, .reusable = false}, SHIFT(776),
  [2002] = {.count = 1, .reusable = true}, SHIFT(777),
  [2004] = {.count = 1, .reusable = false}, SHIFT(777),
  [2006] = {.count = 1, .reusable = true}, SHIFT(778),
  [2008] = {.count = 1, .reusable = false}, SHIFT(778),
  [2010] = {.count = 1, .reusable = true}, SHIFT(779),
  [2012] = {.count = 1, .reusable = false}, SHIFT(779),
  [2014] = {.count = 1, .reusable = true}, SHIFT(780),
  [2016] = {.count = 1, .reusable = false}, SHIFT(780),
  [2018] = {.count = 1, .reusable = true}, SHIFT(781),
  [2020] = {.count = 1, .reusable = false}, SHIFT(781),
  [2022] = {.count = 1, .reusable = true}, SHIFT(782),
  [2024] = {.count = 1, .reusable = false}, SHIFT(782),
  [2026] = {.count = 1, .reusable = true}, SHIFT(783),
  [2028] = {.count = 1, .reusable = false}, SHIFT(783),
  [2030] = {.count = 1, .reusable = true}, SHIFT(784),
  [2032] = {.count = 1, .reusable = false}, SHIFT(784),
  [2034] = {.count = 1, .reusable = true}, SHIFT(785),
  [2036] = {.count = 1, .reusable = false}, SHIFT(785),
  [2038] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 5),
  [2040] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 5),
  [2042] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_else_in_field_declaration_list, 2),
  [2044] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 2),
  [2046] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4),
  [2048] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4),
  [2050] = {.count = 1, .reusable = true}, SHIFT(790),
  [2052] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4),
  [2054] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4),
  [2056] = {.count = 1, .reusable = true}, SHIFT(791),
  [2058] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 3, .dynamic_precedence = -10),
  [2060] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_field_declarator, 3, .dynamic_precedence = 1),
  [2062] = {.count = 1, .reusable = true}, SHIFT(792),
  [2064] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 4),
  [2066] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 4),
  [2068] = {.count = 1, .reusable = true}, SHIFT(794),
  [2070] = {.count = 1, .reusable = false}, SHIFT(794),
  [2072] = {.count = 1, .reusable = true}, SHIFT(795),
  [2074] = {.count = 1, .reusable = false}, SHIFT(795),
  [2076] = {.count = 1, .reusable = true}, SHIFT(796),
  [2078] = {.count = 1, .reusable = false}, SHIFT(796),
  [2080] = {.count = 1, .reusable = true}, SHIFT(797),
  [2082] = {.count = 1, .reusable = false}, SHIFT(797),
  [2084] = {.count = 1, .reusable = true}, SHIFT(798),
  [2086] = {.count = 1, .reusable = false}, SHIFT(798),
  [2088] = {.count = 1, .reusable = true}, SHIFT(799),
  [2090] = {.count = 1, .reusable = false}, SHIFT(799),
  [2092] = {.count = 1, .reusable = true}, SHIFT(800),
  [2094] = {.count = 1, .reusable = false}, SHIFT(800),
  [2096] = {.count = 1, .reusable = true}, SHIFT(801),
  [2098] = {.count = 1, .reusable = false}, SHIFT(801),
  [2100] = {.count = 1, .reusable = true}, SHIFT(802),
  [2102] = {.count = 1, .reusable = false}, SHIFT(802),
  [2104] = {.count = 1, .reusable = true}, SHIFT(803),
  [2106] = {.count = 1, .reusable = false}, SHIFT(803),
  [2108] = {.count = 1, .reusable = true}, SHIFT(804),
  [2110] = {.count = 1, .reusable = false}, SHIFT(804),
  [2112] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_declaration_repeat1, 2),
  [2114] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 3),
  [2116] = {.count = 1, .reusable = true}, SHIFT(806),
  [2118] = {.count = 1, .reusable = true}, SHIFT(807),
  [2120] = {.count = 1, .reusable = false}, SHIFT(807),
  [2122] = {.count = 1, .reusable = true}, SHIFT(808),
  [2124] = {.count = 1, .reusable = true}, SHIFT(809),
  [2126] = {.count = 1, .reusable = false}, SHIFT(809),
  [2128] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_declaration_repeat1, 2), SHIFT_REPEAT(365),
  [2131] = {.count = 1, .reusable = true}, REDUCE(sym__abstract_declarator, 3),
  [2133] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 3, .dynamic_precedence = 1),
  [2135] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(12),
  [2138] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 3),
  [2140] = {.count = 1, .reusable = true}, SHIFT(810),
  [2142] = {.count = 1, .reusable = true}, SHIFT(811),
  [2144] = {.count = 1, .reusable = false}, SHIFT(811),
  [2146] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [2148] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 4),
  [2150] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(382),
  [2153] = {.count = 3, .reusable = true}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), SHIFT(45),
  [2157] = {.count = 2, .reusable = true}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [2160] = {.count = 1, .reusable = true}, SHIFT(814),
  [2162] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2164] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2166] = {.count = 1, .reusable = true}, SHIFT(816),
  [2168] = {.count = 1, .reusable = false}, SHIFT(816),
  [2170] = {.count = 1, .reusable = true}, SHIFT(817),
  [2172] = {.count = 1, .reusable = false}, SHIFT(817),
  [2174] = {.count = 1, .reusable = true}, SHIFT(818),
  [2176] = {.count = 1, .reusable = false}, SHIFT(818),
  [2178] = {.count = 1, .reusable = true}, SHIFT(819),
  [2180] = {.count = 1, .reusable = false}, SHIFT(819),
  [2182] = {.count = 1, .reusable = true}, SHIFT(820),
  [2184] = {.count = 1, .reusable = false}, SHIFT(820),
  [2186] = {.count = 1, .reusable = true}, SHIFT(821),
  [2188] = {.count = 1, .reusable = false}, SHIFT(821),
  [2190] = {.count = 1, .reusable = true}, SHIFT(822),
  [2192] = {.count = 1, .reusable = false}, SHIFT(822),
  [2194] = {.count = 1, .reusable = true}, SHIFT(823),
  [2196] = {.count = 1, .reusable = false}, SHIFT(823),
  [2198] = {.count = 1, .reusable = true}, SHIFT(824),
  [2200] = {.count = 1, .reusable = false}, SHIFT(824),
  [2202] = {.count = 1, .reusable = true}, SHIFT(825),
  [2204] = {.count = 1, .reusable = false}, SHIFT(825),
  [2206] = {.count = 1, .reusable = true}, SHIFT(826),
  [2208] = {.count = 1, .reusable = false}, SHIFT(826),
  [2210] = {.count = 1, .reusable = true}, SHIFT(827),
  [2212] = {.count = 1, .reusable = false}, SHIFT(827),
  [2214] = {.count = 1, .reusable = true}, SHIFT(828),
  [2216] = {.count = 1, .reusable = false}, SHIFT(828),
  [2218] = {.count = 1, .reusable = false}, SHIFT(831),
  [2220] = {.count = 1, .reusable = false}, SHIFT(832),
  [2222] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 3),
  [2224] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 3),
  [2226] = {.count = 1, .reusable = true}, SHIFT(833),
  [2228] = {.count = 1, .reusable = true}, SHIFT(834),
  [2230] = {.count = 1, .reusable = false}, SHIFT(835),
  [2232] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else_in_compound_statement, 1),
  [2234] = {.count = 1, .reusable = false}, SHIFT(836),
  [2236] = {.count = 1, .reusable = false}, SHIFT(837),
  [2238] = {.count = 1, .reusable = false}, SHIFT(838),
  [2240] = {.count = 1, .reusable = false}, SHIFT(839),
  [2242] = {.count = 1, .reusable = false}, SHIFT(840),
  [2244] = {.count = 1, .reusable = false}, SHIFT(841),
  [2246] = {.count = 1, .reusable = false}, SHIFT(842),
  [2248] = {.count = 1, .reusable = false}, SHIFT(843),
  [2250] = {.count = 1, .reusable = false}, SHIFT(844),
  [2252] = {.count = 1, .reusable = false}, SHIFT(845),
  [2254] = {.count = 1, .reusable = false}, SHIFT(846),
  [2256] = {.count = 1, .reusable = false}, SHIFT(847),
  [2258] = {.count = 1, .reusable = true}, SHIFT(850),
  [2260] = {.count = 1, .reusable = false}, SHIFT(850),
  [2262] = {.count = 1, .reusable = false}, SHIFT(848),
  [2264] = {.count = 1, .reusable = false}, SHIFT(853),
  [2266] = {.count = 1, .reusable = true}, SHIFT(856),
  [2268] = {.count = 1, .reusable = false}, SHIFT(856),
  [2270] = {.count = 1, .reusable = true}, SHIFT(857),
  [2272] = {.count = 1, .reusable = true}, SHIFT(860),
  [2274] = {.count = 1, .reusable = true}, SHIFT(861),
  [2276] = {.count = 1, .reusable = true}, SHIFT(862),
  [2278] = {.count = 1, .reusable = false}, SHIFT(862),
  [2280] = {.count = 1, .reusable = true}, SHIFT(863),
  [2282] = {.count = 1, .reusable = true}, SHIFT(864),
  [2284] = {.count = 1, .reusable = true}, SHIFT(865),
  [2286] = {.count = 1, .reusable = true}, SHIFT(866),
  [2288] = {.count = 1, .reusable = true}, SHIFT(867),
  [2290] = {.count = 1, .reusable = true}, SHIFT(868),
  [2292] = {.count = 1, .reusable = true}, SHIFT(869),
  [2294] = {.count = 1, .reusable = false}, SHIFT(867),
  [2296] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3),
  [2298] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3),
  [2300] = {.count = 1, .reusable = true}, SHIFT(872),
  [2302] = {.count = 1, .reusable = false}, SHIFT(872),
  [2304] = {.count = 1, .reusable = true}, SHIFT(874),
  [2306] = {.count = 1, .reusable = true}, SHIFT(877),
  [2308] = {.count = 1, .reusable = false}, SHIFT(877),
  [2310] = {.count = 1, .reusable = true}, SHIFT(878),
  [2312] = {.count = 1, .reusable = true}, SHIFT(880),
  [2314] = {.count = 1, .reusable = true}, SHIFT(881),
  [2316] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3),
  [2318] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3),
  [2320] = {.count = 1, .reusable = false}, SHIFT(882),
  [2322] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3),
  [2324] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3),
  [2326] = {.count = 1, .reusable = true}, SHIFT(883),
  [2328] = {.count = 1, .reusable = true}, SHIFT(885),
  [2330] = {.count = 1, .reusable = false}, SHIFT(885),
  [2332] = {.count = 1, .reusable = true}, SHIFT(887),
  [2334] = {.count = 1, .reusable = false}, SHIFT(887),
  [2336] = {.count = 1, .reusable = true}, SHIFT(888),
  [2338] = {.count = 1, .reusable = false}, SHIFT(888),
  [2340] = {.count = 1, .reusable = true}, SHIFT(889),
  [2342] = {.count = 1, .reusable = false}, SHIFT(889),
  [2344] = {.count = 1, .reusable = true}, SHIFT(890),
  [2346] = {.count = 1, .reusable = false}, SHIFT(890),
  [2348] = {.count = 1, .reusable = true}, SHIFT(891),
  [2350] = {.count = 1, .reusable = false}, SHIFT(891),
  [2352] = {.count = 1, .reusable = true}, SHIFT(892),
  [2354] = {.count = 1, .reusable = false}, SHIFT(892),
  [2356] = {.count = 1, .reusable = true}, SHIFT(893),
  [2358] = {.count = 1, .reusable = false}, SHIFT(893),
  [2360] = {.count = 1, .reusable = true}, SHIFT(894),
  [2362] = {.count = 1, .reusable = false}, SHIFT(894),
  [2364] = {.count = 1, .reusable = true}, SHIFT(895),
  [2366] = {.count = 1, .reusable = false}, SHIFT(895),
  [2368] = {.count = 1, .reusable = true}, SHIFT(896),
  [2370] = {.count = 1, .reusable = false}, SHIFT(896),
  [2372] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 3),
  [2374] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 3),
  [2376] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [2378] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [2380] = {.count = 1, .reusable = false}, SHIFT(898),
  [2382] = {.count = 1, .reusable = false}, SHIFT(899),
  [2384] = {.count = 1, .reusable = false}, SHIFT(900),
  [2386] = {.count = 1, .reusable = false}, SHIFT(901),
  [2388] = {.count = 1, .reusable = false}, SHIFT(902),
  [2390] = {.count = 1, .reusable = false}, SHIFT(903),
  [2392] = {.count = 1, .reusable = false}, SHIFT(904),
  [2394] = {.count = 1, .reusable = true}, SHIFT(906),
  [2396] = {.count = 1, .reusable = false}, SHIFT(907),
  [2398] = {.count = 1, .reusable = true}, SHIFT(908),
  [2400] = {.count = 1, .reusable = true}, SHIFT(909),
  [2402] = {.count = 1, .reusable = true}, SHIFT(910),
  [2404] = {.count = 1, .reusable = false}, SHIFT(910),
  [2406] = {.count = 1, .reusable = true}, SHIFT(912),
  [2408] = {.count = 1, .reusable = true}, SHIFT(913),
  [2410] = {.count = 1, .reusable = false}, SHIFT(913),
  [2412] = {.count = 1, .reusable = true}, SHIFT(914),
  [2414] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2416] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2418] = {.count = 1, .reusable = true}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 4),
  [2420] = {.count = 1, .reusable = false}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 4),
  [2422] = {.count = 1, .reusable = true}, SHIFT(915),
  [2424] = {.count = 1, .reusable = true}, REDUCE(sym_char_literal, 3),
  [2426] = {.count = 1, .reusable = false}, REDUCE(sym_char_literal, 3),
  [2428] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .alias_sequence_id = 5),
  [2430] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .alias_sequence_id = 5),
  [2432] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [2434] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [2436] = {.count = 1, .reusable = true}, SHIFT(916),
  [2438] = {.count = 1, .reusable = true}, SHIFT(917),
  [2440] = {.count = 1, .reusable = true}, REDUCE(sym_comma_expression, 3),
  [2442] = {.count = 1, .reusable = true}, REDUCE(sym_math_expression, 3),
  [2444] = {.count = 1, .reusable = false}, REDUCE(sym_math_expression, 3),
  [2446] = {.count = 1, .reusable = true}, SHIFT(919),
  [2448] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3),
  [2450] = {.count = 1, .reusable = true}, SHIFT(920),
  [2452] = {.count = 1, .reusable = true}, REDUCE(sym_bitwise_expression, 3),
  [2454] = {.count = 1, .reusable = false}, REDUCE(sym_bitwise_expression, 3),
  [2456] = {.count = 1, .reusable = true}, REDUCE(sym_logical_expression, 3),
  [2458] = {.count = 1, .reusable = false}, REDUCE(sym_logical_expression, 3),
  [2460] = {.count = 1, .reusable = true}, REDUCE(sym_equality_expression, 3),
  [2462] = {.count = 1, .reusable = false}, REDUCE(sym_equality_expression, 3),
  [2464] = {.count = 1, .reusable = true}, REDUCE(sym_relational_expression, 3),
  [2466] = {.count = 1, .reusable = false}, REDUCE(sym_relational_expression, 3),
  [2468] = {.count = 1, .reusable = true}, REDUCE(sym_shift_expression, 3),
  [2470] = {.count = 1, .reusable = false}, REDUCE(sym_shift_expression, 3),
  [2472] = {.count = 1, .reusable = true}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 6),
  [2474] = {.count = 1, .reusable = false}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 6),
  [2476] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2478] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2480] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(26),
  [2483] = {.count = 1, .reusable = true}, SHIFT(921),
  [2485] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 5),
  [2487] = {.count = 1, .reusable = true}, SHIFT(922),
  [2489] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 3),
  [2491] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 3),
  [2493] = {.count = 1, .reusable = true}, SHIFT(923),
  [2495] = {.count = 1, .reusable = true}, REDUCE(sym_field_designator, 2, .alias_sequence_id = 7),
  [2497] = {.count = 1, .reusable = true}, SHIFT(924),
  [2499] = {.count = 1, .reusable = true}, SHIFT(925),
  [2501] = {.count = 1, .reusable = false}, SHIFT(925),
  [2503] = {.count = 1, .reusable = true}, SHIFT(927),
  [2505] = {.count = 1, .reusable = true}, SHIFT(929),
  [2507] = {.count = 1, .reusable = false}, SHIFT(929),
  [2509] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(488),
  [2512] = {.count = 1, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2),
  [2514] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(489),
  [2517] = {.count = 1, .reusable = true}, SHIFT(931),
  [2519] = {.count = 1, .reusable = true}, SHIFT(932),
  [2521] = {.count = 1, .reusable = true}, SHIFT(935),
  [2523] = {.count = 1, .reusable = true}, SHIFT(936),
  [2525] = {.count = 1, .reusable = true}, SHIFT(937),
  [2527] = {.count = 1, .reusable = true}, SHIFT(938),
  [2529] = {.count = 1, .reusable = true}, SHIFT(939),
  [2531] = {.count = 1, .reusable = true}, SHIFT(940),
  [2533] = {.count = 1, .reusable = true}, SHIFT(941),
  [2535] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 5),
  [2537] = {.count = 1, .reusable = true}, SHIFT(942),
  [2539] = {.count = 1, .reusable = true}, SHIFT(943),
  [2541] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3),
  [2543] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 5),
  [2545] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 5),
  [2547] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5),
  [2549] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5),
  [2551] = {.count = 1, .reusable = true}, SHIFT(945),
  [2553] = {.count = 1, .reusable = true}, SHIFT(946),
  [2555] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 4),
  [2557] = {.count = 1, .reusable = true}, SHIFT(947),
  [2559] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 5),
  [2561] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 5),
  [2563] = {.count = 1, .reusable = true}, SHIFT(948),
  [2565] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 4),
  [2567] = {.count = 1, .reusable = true}, SHIFT(949),
  [2569] = {.count = 1, .reusable = true}, SHIFT(951),
  [2571] = {.count = 1, .reusable = true}, SHIFT(952),
  [2573] = {.count = 1, .reusable = true}, REDUCE(sym_cast_expression, 4),
  [2575] = {.count = 1, .reusable = false}, REDUCE(sym_cast_expression, 4),
  [2577] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 4),
  [2579] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 4),
  [2581] = {.count = 1, .reusable = false}, SHIFT(953),
  [2583] = {.count = 1, .reusable = false}, SHIFT(956),
  [2585] = {.count = 1, .reusable = false}, SHIFT(959),
  [2587] = {.count = 1, .reusable = true}, SHIFT(960),
  [2589] = {.count = 1, .reusable = true}, SHIFT(963),
  [2591] = {.count = 1, .reusable = false}, SHIFT(963),
  [2593] = {.count = 1, .reusable = true}, SHIFT(964),
  [2595] = {.count = 1, .reusable = true}, SHIFT(967),
  [2597] = {.count = 1, .reusable = true}, SHIFT(968),
  [2599] = {.count = 1, .reusable = true}, SHIFT(969),
  [2601] = {.count = 1, .reusable = false}, SHIFT(969),
  [2603] = {.count = 1, .reusable = true}, SHIFT(970),
  [2605] = {.count = 1, .reusable = true}, SHIFT(971),
  [2607] = {.count = 1, .reusable = true}, SHIFT(972),
  [2609] = {.count = 1, .reusable = true}, SHIFT(973),
  [2611] = {.count = 1, .reusable = true}, SHIFT(974),
  [2613] = {.count = 1, .reusable = true}, SHIFT(975),
  [2615] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else_in_compound_statement, 2),
  [2617] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif_in_compound_statement, 2),
  [2619] = {.count = 1, .reusable = false}, SHIFT(979),
  [2621] = {.count = 1, .reusable = false}, SHIFT(980),
  [2623] = {.count = 1, .reusable = false}, SHIFT(981),
  [2625] = {.count = 1, .reusable = false}, SHIFT(982),
  [2627] = {.count = 1, .reusable = false}, SHIFT(983),
  [2629] = {.count = 1, .reusable = false}, SHIFT(984),
  [2631] = {.count = 1, .reusable = false}, SHIFT(985),
  [2633] = {.count = 1, .reusable = false}, SHIFT(987),
  [2635] = {.count = 1, .reusable = true}, SHIFT(989),
  [2637] = {.count = 1, .reusable = false}, SHIFT(990),
  [2639] = {.count = 1, .reusable = true}, SHIFT(994),
  [2641] = {.count = 1, .reusable = true}, SHIFT(995),
  [2643] = {.count = 1, .reusable = true}, SHIFT(996),
  [2645] = {.count = 1, .reusable = false}, SHIFT(996),
  [2647] = {.count = 1, .reusable = true}, SHIFT(997),
  [2649] = {.count = 1, .reusable = true}, SHIFT(998),
  [2651] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4),
  [2653] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2657] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(315),
  [2660] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(628),
  [2663] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(69),
  [2666] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(70),
  [2669] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(629),
  [2672] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2),
  [2674] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(631),
  [2677] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(76),
  [2680] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(77),
  [2683] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(634),
  [2686] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(635),
  [2689] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(636),
  [2692] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(637),
  [2695] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(638),
  [2698] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(639),
  [2701] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(640),
  [2704] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(641),
  [2707] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(642),
  [2710] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(643),
  [2713] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(644),
  [2716] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(648),
  [2719] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(648),
  [2722] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(645),
  [2725] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4),
  [2727] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4),
  [2729] = {.count = 1, .reusable = true}, SHIFT(1001),
  [2731] = {.count = 1, .reusable = true}, SHIFT(1003),
  [2733] = {.count = 1, .reusable = false}, SHIFT(1004),
  [2735] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2737] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2739] = {.count = 1, .reusable = false}, SHIFT(1006),
  [2741] = {.count = 1, .reusable = true}, SHIFT(1008),
  [2743] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 4),
  [2745] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 4),
  [2747] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2749] = {.count = 1, .reusable = true}, SHIFT(1012),
  [2751] = {.count = 1, .reusable = false}, SHIFT(1012),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2755] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2757] = {.count = 1, .reusable = true}, SHIFT(1016),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2761] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2763] = {.count = 1, .reusable = true}, SHIFT(1019),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1020),
  [2767] = {.count = 1, .reusable = false}, SHIFT(1020),
  [2769] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2771] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 4),
  [2773] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 4),
  [2775] = {.count = 1, .reusable = true}, SHIFT(1022),
  [2777] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2779] = {.count = 1, .reusable = false}, SHIFT(1023),
  [2781] = {.count = 1, .reusable = true}, SHIFT(1024),
  [2783] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2785] = {.count = 1, .reusable = false}, SHIFT(1025),
  [2787] = {.count = 1, .reusable = true}, REDUCE(sym_sizeof_expression, 4),
  [2789] = {.count = 1, .reusable = false}, SHIFT(228),
  [2791] = {.count = 1, .reusable = false}, REDUCE(sym_sizeof_expression, 4),
  [2793] = {.count = 1, .reusable = false}, SHIFT(240),
  [2795] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [2797] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [2799] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2801] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2803] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2805] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4),
  [2807] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2811] = {.count = 1, .reusable = false}, SHIFT(1029),
  [2813] = {.count = 1, .reusable = false}, SHIFT(255),
  [2815] = {.count = 1, .reusable = false}, SHIFT(257),
  [2817] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2819] = {.count = 1, .reusable = false}, SHIFT(1030),
  [2821] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_designator, 3),
  [2823] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 4),
  [2825] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 4),
  [2827] = {.count = 1, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2),
  [2829] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2831] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT_REPEAT(1032),
  [2834] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_pair, 3),
  [2836] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2838] = {.count = 1, .reusable = true}, SHIFT(1034),
  [2840] = {.count = 1, .reusable = true}, REDUCE(sym_ta_specifier_list, 3),
  [2842] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2844] = {.count = 1, .reusable = false}, SHIFT(333),
  [2846] = {.count = 1, .reusable = false}, SHIFT(334),
  [2848] = {.count = 1, .reusable = true}, SHIFT(1037),
  [2850] = {.count = 1, .reusable = false}, SHIFT(1037),
  [2852] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4),
  [2854] = {.count = 1, .reusable = false}, SHIFT(357),
  [2856] = {.count = 1, .reusable = false}, SHIFT(358),
  [2858] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2860] = {.count = 1, .reusable = false}, SHIFT(1038),
  [2862] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 5),
  [2864] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 6),
  [2866] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 6),
  [2868] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 5),
  [2870] = {.count = 1, .reusable = false}, SHIFT(392),
  [2872] = {.count = 1, .reusable = false}, SHIFT(393),
  [2874] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2876] = {.count = 1, .reusable = false}, SHIFT(1039),
  [2878] = {.count = 1, .reusable = true}, SHIFT(1040),
  [2880] = {.count = 1, .reusable = false}, SHIFT(1040),
  [2882] = {.count = 1, .reusable = true}, SHIFT(1042),
  [2884] = {.count = 1, .reusable = false}, SHIFT(1042),
  [2886] = {.count = 1, .reusable = false}, SHIFT(1044),
  [2888] = {.count = 1, .reusable = false}, SHIFT(1047),
  [2890] = {.count = 1, .reusable = false}, SHIFT(1050),
  [2892] = {.count = 1, .reusable = false}, SHIFT(1051),
  [2894] = {.count = 1, .reusable = false}, SHIFT(1052),
  [2896] = {.count = 1, .reusable = false}, SHIFT(1053),
  [2898] = {.count = 1, .reusable = false}, SHIFT(1054),
  [2900] = {.count = 1, .reusable = false}, SHIFT(1055),
  [2902] = {.count = 1, .reusable = false}, SHIFT(1056),
  [2904] = {.count = 1, .reusable = false}, SHIFT(1058),
  [2906] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2908] = {.count = 1, .reusable = false}, SHIFT(1061),
  [2910] = {.count = 1, .reusable = true}, SHIFT(1065),
  [2912] = {.count = 1, .reusable = true}, SHIFT(1066),
  [2914] = {.count = 1, .reusable = true}, SHIFT(1067),
  [2916] = {.count = 1, .reusable = false}, SHIFT(1067),
  [2918] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2920] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2922] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(527),
  [2925] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(834),
  [2928] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(151),
  [2931] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(152),
  [2934] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(835),
  [2937] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(836),
  [2940] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(155),
  [2943] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(156),
  [2946] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(837),
  [2949] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(838),
  [2952] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(839),
  [2955] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(840),
  [2958] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(841),
  [2961] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(842),
  [2964] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(843),
  [2967] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(844),
  [2970] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(845),
  [2973] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(846),
  [2976] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(847),
  [2979] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(850),
  [2982] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(850),
  [2985] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(848),
  [2988] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 3),
  [2990] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif_in_compound_statement, 3),
  [2992] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2994] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2996] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2998] = {.count = 1, .reusable = true}, SHIFT(1077),
  [3000] = {.count = 1, .reusable = true}, SHIFT(1078),
  [3002] = {.count = 1, .reusable = false}, SHIFT(1079),
  [3004] = {.count = 1, .reusable = true}, SHIFT(1081),
  [3006] = {.count = 1, .reusable = true}, SHIFT(1083),
  [3008] = {.count = 1, .reusable = true}, SHIFT(1084),
  [3010] = {.count = 1, .reusable = false}, SHIFT(1084),
  [3012] = {.count = 1, .reusable = true}, SHIFT(1085),
  [3014] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 5),
  [3016] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 5),
  [3018] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5),
  [3020] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5),
  [3022] = {.count = 1, .reusable = false}, SHIFT(1086),
  [3024] = {.count = 1, .reusable = true}, SHIFT(1087),
  [3026] = {.count = 1, .reusable = true}, SHIFT(1088),
  [3028] = {.count = 1, .reusable = false}, SHIFT(1088),
  [3030] = {.count = 1, .reusable = true}, SHIFT(1089),
  [3032] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3034] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3036] = {.count = 1, .reusable = false}, SHIFT(410),
  [3038] = {.count = 1, .reusable = false}, SHIFT(411),
  [3040] = {.count = 1, .reusable = true}, SHIFT(1090),
  [3042] = {.count = 1, .reusable = false}, SHIFT(1090),
  [3044] = {.count = 1, .reusable = true}, SHIFT(1092),
  [3046] = {.count = 1, .reusable = false}, SHIFT(1093),
  [3048] = {.count = 1, .reusable = true}, SHIFT(1094),
  [3050] = {.count = 1, .reusable = true}, SHIFT(1095),
  [3052] = {.count = 1, .reusable = false}, SHIFT(1095),
  [3054] = {.count = 1, .reusable = true}, SHIFT(1096),
  [3056] = {.count = 1, .reusable = true}, SHIFT(1097),
  [3058] = {.count = 1, .reusable = false}, SHIFT(1097),
  [3060] = {.count = 1, .reusable = true}, SHIFT(1098),
  [3062] = {.count = 1, .reusable = true}, SHIFT(1099),
  [3064] = {.count = 1, .reusable = false}, SHIFT(1099),
  [3066] = {.count = 1, .reusable = true}, SHIFT(1101),
  [3068] = {.count = 1, .reusable = true}, SHIFT(1103),
  [3070] = {.count = 1, .reusable = false}, SHIFT(1103),
  [3072] = {.count = 1, .reusable = true}, SHIFT(1104),
  [3074] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3076] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 4),
  [3078] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 4),
  [3080] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(917),
  [3083] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5),
  [3085] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 5),
  [3087] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 5),
  [3089] = {.count = 1, .reusable = true}, REDUCE(sym_ta_top_level, 9),
  [3091] = {.count = 1, .reusable = false}, REDUCE(sym_ta_top_level, 9),
  [3093] = {.count = 1, .reusable = true}, SHIFT(1105),
  [3095] = {.count = 1, .reusable = true}, SHIFT(1107),
  [3097] = {.count = 1, .reusable = true}, SHIFT(1108),
  [3099] = {.count = 1, .reusable = true}, SHIFT(1109),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1110),
  [3103] = {.count = 1, .reusable = true}, SHIFT(1111),
  [3105] = {.count = 1, .reusable = true}, SHIFT(1112),
  [3107] = {.count = 1, .reusable = false}, SHIFT(1112),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1114),
  [3111] = {.count = 1, .reusable = false}, SHIFT(1114),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1118),
  [3115] = {.count = 1, .reusable = false}, SHIFT(1118),
  [3117] = {.count = 1, .reusable = true}, SHIFT(1119),
  [3119] = {.count = 1, .reusable = true}, SHIFT(1121),
  [3121] = {.count = 1, .reusable = true}, SHIFT(1122),
  [3123] = {.count = 1, .reusable = false}, SHIFT(1123),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1125),
  [3127] = {.count = 1, .reusable = true}, SHIFT(1127),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1128),
  [3131] = {.count = 1, .reusable = false}, SHIFT(1128),
  [3133] = {.count = 1, .reusable = true}, SHIFT(1129),
  [3135] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 4),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1131),
  [3139] = {.count = 1, .reusable = false}, SHIFT(1132),
  [3141] = {.count = 1, .reusable = true}, SHIFT(1133),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1134),
  [3145] = {.count = 1, .reusable = false}, SHIFT(1134),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1136),
  [3149] = {.count = 1, .reusable = false}, SHIFT(1136),
  [3151] = {.count = 1, .reusable = true}, SHIFT(1138),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1139),
  [3155] = {.count = 1, .reusable = false}, SHIFT(1139),
  [3157] = {.count = 1, .reusable = true}, SHIFT(1140),
  [3159] = {.count = 1, .reusable = true}, SHIFT(1141),
  [3161] = {.count = 1, .reusable = false}, SHIFT(1141),
  [3163] = {.count = 1, .reusable = true}, SHIFT(1142),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1143),
  [3167] = {.count = 1, .reusable = false}, SHIFT(1143),
  [3169] = {.count = 1, .reusable = true}, SHIFT(1144),
  [3171] = {.count = 1, .reusable = true}, SHIFT(1145),
  [3173] = {.count = 1, .reusable = false}, SHIFT(1145),
  [3175] = {.count = 1, .reusable = true}, SHIFT(1146),
  [3177] = {.count = 1, .reusable = true}, SHIFT(1147),
  [3179] = {.count = 1, .reusable = true}, SHIFT(1148),
  [3181] = {.count = 1, .reusable = false}, SHIFT(1148),
  [3183] = {.count = 1, .reusable = true}, SHIFT(1149),
  [3185] = {.count = 1, .reusable = true}, SHIFT(1150),
  [3187] = {.count = 1, .reusable = true}, SHIFT(1152),
  [3189] = {.count = 1, .reusable = false}, SHIFT(1152),
  [3191] = {.count = 1, .reusable = true}, SHIFT(1153),
  [3193] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [3195] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [3197] = {.count = 1, .reusable = true}, SHIFT(1155),
  [3199] = {.count = 1, .reusable = true}, SHIFT(1157),
  [3201] = {.count = 1, .reusable = false}, SHIFT(1157),
  [3203] = {.count = 1, .reusable = true}, REDUCE(sym_ta_integer_list, 1),
  [3205] = {.count = 1, .reusable = true}, SHIFT(1158),
  [3207] = {.count = 1, .reusable = true}, SHIFT(1159),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1160),
  [3211] = {.count = 1, .reusable = true}, SHIFT(1161),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1162),
  [3215] = {.count = 1, .reusable = true}, SHIFT(1163),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1164),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1165),
  [3221] = {.count = 1, .reusable = true}, SHIFT(1167),
  [3223] = {.count = 1, .reusable = false}, SHIFT(1168),
  [3225] = {.count = 1, .reusable = true}, SHIFT(1169),
  [3227] = {.count = 1, .reusable = true}, SHIFT(1170),
  [3229] = {.count = 1, .reusable = false}, SHIFT(1170),
  [3231] = {.count = 1, .reusable = true}, SHIFT(1172),
  [3233] = {.count = 1, .reusable = false}, SHIFT(1172),
  [3235] = {.count = 1, .reusable = true}, SHIFT(1174),
  [3237] = {.count = 1, .reusable = true}, SHIFT(1175),
  [3239] = {.count = 1, .reusable = false}, SHIFT(1175),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1176),
  [3243] = {.count = 1, .reusable = true}, SHIFT(1177),
  [3245] = {.count = 1, .reusable = false}, SHIFT(1177),
  [3247] = {.count = 1, .reusable = false}, SHIFT(1178),
  [3249] = {.count = 1, .reusable = true}, SHIFT(1179),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1180),
  [3253] = {.count = 1, .reusable = false}, SHIFT(1180),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1181),
  [3257] = {.count = 1, .reusable = true}, SHIFT(1182),
  [3259] = {.count = 1, .reusable = true}, SHIFT(1184),
  [3261] = {.count = 1, .reusable = true}, SHIFT(1186),
  [3263] = {.count = 1, .reusable = false}, SHIFT(1186),
  [3265] = {.count = 1, .reusable = true}, SHIFT(1187),
  [3267] = {.count = 1, .reusable = true}, SHIFT(1188),
  [3269] = {.count = 1, .reusable = true}, SHIFT(1190),
  [3271] = {.count = 1, .reusable = false}, SHIFT(1190),
  [3273] = {.count = 1, .reusable = true}, SHIFT(1191),
  [3275] = {.count = 1, .reusable = true}, SHIFT(1192),
  [3277] = {.count = 1, .reusable = true}, SHIFT(1193),
  [3279] = {.count = 1, .reusable = false}, SHIFT(1193),
  [3281] = {.count = 1, .reusable = true}, SHIFT(1194),
  [3283] = {.count = 1, .reusable = true}, SHIFT(1195),
  [3285] = {.count = 1, .reusable = false}, SHIFT(1195),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1196),
  [3289] = {.count = 1, .reusable = true}, SHIFT(1198),
  [3291] = {.count = 1, .reusable = false}, SHIFT(1198),
  [3293] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [3295] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [3297] = {.count = 1, .reusable = true}, SHIFT(1200),
  [3299] = {.count = 1, .reusable = true}, SHIFT(1203),
  [3301] = {.count = 1, .reusable = true}, SHIFT(1205),
  [3303] = {.count = 1, .reusable = true}, SHIFT(1206),
  [3305] = {.count = 1, .reusable = false}, SHIFT(1207),
  [3307] = {.count = 1, .reusable = true}, SHIFT(1208),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1209),
  [3311] = {.count = 1, .reusable = false}, SHIFT(1209),
  [3313] = {.count = 1, .reusable = true}, SHIFT(1210),
  [3315] = {.count = 1, .reusable = true}, SHIFT(1211),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1213),
  [3319] = {.count = 1, .reusable = true}, SHIFT(1215),
  [3321] = {.count = 1, .reusable = false}, SHIFT(1215),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1216),
  [3325] = {.count = 1, .reusable = true}, SHIFT(1217),
  [3327] = {.count = 1, .reusable = true}, SHIFT(1218),
  [3329] = {.count = 1, .reusable = false}, SHIFT(1218),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1219),
  [3333] = {.count = 1, .reusable = true}, SHIFT(1220),
  [3335] = {.count = 1, .reusable = false}, SHIFT(1220),
  [3337] = {.count = 1, .reusable = true}, SHIFT(1222),
  [3339] = {.count = 1, .reusable = true}, SHIFT(1224),
  [3341] = {.count = 1, .reusable = false}, SHIFT(1224),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1225),
  [3345] = {.count = 1, .reusable = true}, SHIFT(1227),
  [3347] = {.count = 1, .reusable = false}, SHIFT(1227),
  [3349] = {.count = 1, .reusable = true}, SHIFT(1228),
  [3351] = {.count = 1, .reusable = true}, SHIFT(1230),
  [3353] = {.count = 1, .reusable = false}, SHIFT(1230),
  [3355] = {.count = 1, .reusable = true}, SHIFT(1231),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1232),
  [3359] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8),
  [3361] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8),
  [3363] = {.count = 1, .reusable = true}, SHIFT(1235),
  [3365] = {.count = 1, .reusable = true}, REDUCE(sym_ta_integer_list, 3),
  [3367] = {.count = 1, .reusable = true}, SHIFT(1236),
  [3369] = {.count = 1, .reusable = true}, SHIFT(1237),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1239),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1240),
  [3375] = {.count = 1, .reusable = false}, SHIFT(1240),
  [3377] = {.count = 1, .reusable = true}, SHIFT(1241),
  [3379] = {.count = 1, .reusable = true}, SHIFT(1242),
  [3381] = {.count = 1, .reusable = false}, SHIFT(1242),
  [3383] = {.count = 1, .reusable = true}, SHIFT(1244),
  [3385] = {.count = 1, .reusable = true}, SHIFT(1246),
  [3387] = {.count = 1, .reusable = false}, SHIFT(1246),
  [3389] = {.count = 1, .reusable = true}, SHIFT(1247),
  [3391] = {.count = 1, .reusable = true}, SHIFT(1249),
  [3393] = {.count = 1, .reusable = false}, SHIFT(1249),
  [3395] = {.count = 1, .reusable = true}, SHIFT(1250),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1252),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1254),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1256),
  [3403] = {.count = 1, .reusable = true}, SHIFT(1258),
  [3405] = {.count = 1, .reusable = false}, SHIFT(1258),
  [3407] = {.count = 1, .reusable = true}, SHIFT(1259),
  [3409] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 9),
  [3411] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 9),
  [3413] = {.count = 1, .reusable = true}, REDUCE(sym_ta_top_level, 13),
  [3415] = {.count = 1, .reusable = false}, REDUCE(sym_ta_top_level, 13),
  [3417] = {.count = 1, .reusable = true}, SHIFT(1261),
  [3419] = {.count = 1, .reusable = true}, SHIFT(1262),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1263),
  [3423] = {.count = 1, .reusable = true}, SHIFT(1265),
  [3425] = {.count = 1, .reusable = false}, SHIFT(1265),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1266),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1268),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1270),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1272),
  [3435] = {.count = 1, .reusable = false}, SHIFT(1272),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1274),
  [3439] = {.count = 1, .reusable = true}, SHIFT(1275),
  [3441] = {.count = 1, .reusable = true}, SHIFT(1276),
  [3443] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 10),
  [3445] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 10),
  [3447] = {.count = 1, .reusable = true}, SHIFT(1278),
  [3449] = {.count = 1, .reusable = true}, SHIFT(1279),
  [3451] = {.count = 1, .reusable = true}, SHIFT(1280),
  [3453] = {.count = 1, .reusable = true}, SHIFT(1282),
  [3455] = {.count = 1, .reusable = false}, SHIFT(1282),
  [3457] = {.count = 1, .reusable = true}, SHIFT(1284),
  [3459] = {.count = 1, .reusable = true}, SHIFT(1285),
  [3461] = {.count = 1, .reusable = true}, SHIFT(1288),
  [3463] = {.count = 1, .reusable = true}, SHIFT(1289),
  [3465] = {.count = 1, .reusable = true}, SHIFT(1290),
  [3467] = {.count = 1, .reusable = true}, SHIFT(1293),
  [3469] = {.count = 1, .reusable = true}, SHIFT(1294),
};

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ableCTensorAlgebra() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
  };
  return &language;
}
